%-------------------------------------------------------------------------------
% File     : essai8.p
% Domain   : PointsTo analysis
% Problem  : Performs pointer analysis
% Version  : 
% English  :     
%-------------------------------------------------------------------------------


% Function = foo
% Params :
%   x : int 
%   y : int 
% Return = int
% Je renomme x par foo_1
% Je renomme y par foo_2

input_clause(clauses_1, axiom,
          [
          --fun_foo( nil ) ,
          --values( foo_1 , Z ),
          ++values( foo_return , Z )
          ]).


% Function = bar
% Params :
%   x : int 
%   y : int 
% Return = int
% Je renomme x par bar_1
% Je renomme y par bar_2
% Je renomme x1 par bar_3

input_clause(clauses_2, axiom,
          [
          --fun_bar( nil ),
          ++values( bar_3 , opp( bar_2 ) )
          ]).

input_clause(clauses_3, axiom,
          [
          --fun_bar( nil ),
          ++values( bar_return , plus( bar_1 , bar_3 ) )
          ]).


% Function = main
% Params :
%   argc : int 
%   argv : char **const 
% Return = int

input_clause(clauses_4, axiom,
          [
          --fun_main( nil ),
          ++values( x , 1 )
          ]).

input_clause(clauses_5, axiom,
          [
          --fun_main( nil ) ,
          --values( x , Z ),
          ++values( x2 , Z )
          ]).

input_clause(clauses_6, axiom,
          [
          --fun_main( nil ),
          ++values( y , 2 )
          ]).

input_clause(clauses_7, axiom,
          [
          --fun_main( nil ) ,
          --values( y , Z ),
          ++values( x3 , Z )
          ]).

input_clause(clauses_8, axiom,
          [
          --fun_main( nil ),
          ++values( foo_1 , x )
          ]).

input_clause(clauses_9, axiom,
          [
          --fun_main( nil ),
          ++values( foo_2 , y )
          ]).

input_clause(clauses_10, axiom,
          [
          --fun_main( nil ),
          ++fun_foo( nil )
          ]).

input_clause(clauses_11, axiom,
          [
          --fun_main( nil ) ,
          --values( foo_return , Z ),
          ++values( r1 , Z )
          ]).

input_clause(clauses_12, axiom,
          [
          --fun_main( nil ) ,
          --values( r1 , Z ),
          ++values( x4 , Z )
          ]).

input_clause(clauses_13, axiom,
          [
          --fun_main( nil ),
          ++values( x6 , 6 )
          ]).

input_clause(clauses_14, axiom,
          [
          --fun_main( nil ),
          ++values( bar_1 , x6 )
          ]).

input_clause(clauses_15, axiom,
          [
          --fun_main( nil ),
          ++values( bar_2 , y )
          ]).

input_clause(clauses_16, axiom,
          [
          --fun_main( nil ),
          ++fun_bar( nil )
          ]).

input_clause(clauses_17, axiom,
          [
          --fun_main( nil ) ,
          --values( bar_return , Z ),
          ++values( r1 , Z )
          ]).

input_clause(clauses_18, axiom,
          [
          --fun_main( nil ) ,
          --values( r1 , Z ),
          ++values( x5 , Z )
          ]).

input_clause(clauses_19, axiom,
          [
          --fun_main( nil ),
          ++values( main_return , 0 )
          ]).




%
% Ajout des clauses du prototole
%
%

input_clause(protocol_1, axiom,
          [
          ++fun_main( nil )
          ]).

input_clause(protocol_2, axiom,
          [
          --values( field( X , N ) , V ) ,
          --values( X , address( Y ) ),
          ++values( field( Y , N ) , V )
          ]).

input_clause(protocol_3, axiom,
          [
          --values( field( X , N ) , V ) ,
          --values( X , address( Z ) ) ,
          --values( Y , address( Z ) ),
          ++values( field( Y , N ) , V )
          ]).

input_clause(protocol_4, axiom,
          [
          --values( K , address( field( X , Y ) ) ) ,
          --values( J , address( field( K , Z ) ) ),
          ++values( J , address( field( field( X , Y ) , Z ) ) )
          ]).

input_clause(protocol_5, axiom,
          [
          --values( offset( X , N ) , V ) ,
          --values( X , address( Y ) ),
          ++values( offset( Y , N ) , V )
          ]).

input_clause(protocol_6, axiom,
          [
          --values( offset( X , N ) , V ) ,
          --values( X , address( Z ) ) ,
          --values( Y , address( Z ) ),
          ++values( offset( Y , N ) , V )
          ]).

input_clause(protocol_7, axiom,
          [
          --values( offset( X , Z ) , V ) ,
          --values( Z , Y ),
          ++values( offset( X , Y ) , V )
          ]).

input_clause(protocol_8, axiom,
          [
          --values( field( field( X2 , Y ) , Z ) , V ) ,
          --values( X2 , address( X1 ) ),
          ++values( field( field( X1 , Y ) , Z ) , V )
          ]).

input_clause(protocol_9, axiom,
          [
          --values( field( field( X2 , Y ) , Z ) , V ) ,
          --values( X1 , address( K ) ) ,
          --values( X2 , address( K ) ),
          ++values( field( field( X1 , Y ) , Z ) , V )
          ]).

input_clause(protocol_10, axiom,
          [
          --values( field( field( field( X2 , Y ) , Z ) , K ) , V ) ,
          --values( X2 , address( X1 ) ),
          ++values( field( field( field( X1 , Y ) , Z ) , K ) , V )
          ]).

input_clause(protocol_11, axiom,
          [
          --values( field( field( field( X2 , Y ) , Z ) , K ) , V ) ,
          --values( X1 , address( K ) ) ,
          --values( X2 , address( K ) ),
          ++values( field( field( field( X1 , Y ) , Z ) , K ) , V )
          ]).

input_clause(protocol_12, axiom,
          [
          --values( X , Z ) ,
          --values( Z , Y ),
          ++values( X , Y )
          ]).


input_clause(clause_conj, conjecture, 
 [
   --values( r1 , 1 )
  ]).

