(* Coq printing functions for resolution proofs, headers.
   Copyright (C) 2003 Jean Goubault-Larrecq and LSV, CNRS UMR 8643 & ENS Cachan.

   This file is part of h1.

   h1 is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   h1 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with h1; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*)

open "clause_h";

extern val coq_print_proof : ('a outstream * string *
			      string * string * string * string) ->
	   clause -> string;
(* coq_print_proof (f, rem_name, bot_prefix, prefix, term_type, xname) c
 prints a series of 'Remark's, with names starting with rem_name,
 where the last one derives c; returns the name of this last Remark.
 The type of terms is term_type, and all needed variables will be
 of name xname, possibly with a number suffix.
 prefix is a prefix added in front of every predicate name.
 bot_prefix is added in front of every botname.
 *)
