% h1 example: the Denning-Sacco key distribution protocol, fixed.
%   Copyright (C) 2008 Jean Goubault-Larrecq and LSV, CNRS UMR 8643 & ENS Cachan.
%
%   This file is part of h1.
%
%   h1 is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2, or (at your option)
%   any later version.
%
%   h1 is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with h1; see the file COPYING.  If not, write to
%   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

% run 'cpp -P dsfixed.timed.p >dsfixed.p'

cnf(alice_agent,axiom,
    (agent(alice))).
cnf(bob_agent,axiom,
    (agent(bob))).
cnf(server_agent,axiom,
    (agent(server))).
cnf(intruder_agent,axiom,
    (agent(i))).

#define PHASE(s) s##_old
#include "dsfixed.phase.p"
#undef PHASE

cnf(intruder_remembers,axiom,
   (~knows_old(M) | knows_current(M))).

cnf(intruder_knows_all_previous_session_keys,axiom,
  (knows_current(key(sym,session_old(A,B))))).

cnf(intruder_knows_all_previous_data,axiom,
  (knows_current(data_old(A,B)))).
   
#define PHASE(s) s##_current
#include "dsfixed.phase.p"
#undef PHASE

cnf(intruder_knows_data_generated_by_bob,axiom,
  (~knows_current(D) | ~bob_msg_current(bob,D))).
cnf(intruder_knows_data_as_seen_by_alice,axiom,
  (~knows_current(D) | ~alice_msg_current(alice,D))).
