(* Heaps (as in heapsort), headers.
   Copyright (C) 2003 Jean Goubault-Larrecq and LSV, CNRS UMR 8643 & ENS Cachan.

   This file is part of h1.

   h1 is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   h1 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with h1; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*)

exception MHeapEmptyEvt;

extern val mheap : (''_a * ''_a -> bool) ->
	   |[ insert : ''_a * ''_b -> unit,
	      inserts : ''_a * (''_b -m> '_c) -> unit,
	      findmin : unit -> ''_a * ''_b,
	      popmin : unit -> ''_a * ''_b,
	      popmins : unit -> ''_a * (''_b -m> '_c),
	      empty : unit -> bool,
	      cvt_to_revlist : unit -> (''_a * ''_b) list,
	      dump_list : unit -> ''_b list
	      ]|;
