% h1 example: tree automaton recognizing lists of even natural numbers.
%   Copyright (C) 2004 Jean Goubault-Larrecq and LSV, CNRS UMR 8643 & ENS Cachan.
%
%   This file is part of h1.
%
%   h1 is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2, or (at your option)
%   any later version.
%
%   h1 is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with h1; see the file COPYING.  If not, write to
%   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

input_clause(o_even, axiom,
	     [++even(o)]).

input_clause(suc_even_odd, axiom,
	     [--even(X), ++odd(s(X))]).

input_clause(suc_odd_even, axiom,
	     [--odd(X), ++even(s(X))]).

input_clause(nil_even_list, axiom,
	     [++list_even(nil)]).

input_clause(cons_even_list, axiom,
	     [--even(X), --list_even(Y),
	      ++list_even(cons(X,Y))]).
   
