(* Applying morphisms to gclauses, headers.
   Copyright (C) 2003 Jean Goubault-Larrecq and LSV, CNRS UMR 8643 & ENS Cachan.

   This file is part of h1.

   h1 is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   h1 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with h1; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*)

open "gclause_h";

type ''var morphism = string -m> ''var list * ''var term;
    (* maps functions f to functions lambda xl.t
     where xl is a list of pairwise distinct variables,
     and t is a term whose free variables are all among xl.
     *)

exception MorphismBadArityEvt of string * int * int;
(* function, arity of pattern, actual arity of function. *)

extern val apply_morphism_term : ''var morphism -> ''var term -> ''var term;

extern val apply_morphism_gclause : ''var morphism -> ''var gclause
	   -> ''var gclause;
