% h1 example: the Needham-Schroeder-Lowe asymmetric key protocol.
%   Copyright (C) 2008 Jean Goubault-Larrecq and LSV, CNRS UMR 8643 & ENS Cachan.
%
%   This file is part of h1.
%
%   h1 is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2, or (at your option)
%   any later version.
%
%   h1 is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with h1; see the file COPYING.  If not, write to
%   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

% run 'cpp -P nsl7bis.timed.p >nsl7bis.p'

cnf(alice_agent,axiom,
    (agent(alice))).
cnf(bob_agent,axiom,
    (agent(bob))).
cnf(server_agent,axiom,
    (agent(server))).
cnf(intruder_agent,axiom,
    (agent(i))).

cnf(alice_has_pub_key,axiom,
    (has_pub_key(alice,cons(key(pub,alice),cons(alice,nil))))).
cnf(bob_has_pub_key,axiom,
    (has_pub_key(bob,cons(key(pub,bob),cons(bob,nil))))).
cnf(server_has_pub_key,axiom,
    (has_pub_key(server,cons(key(pub,server),cons(server,nil))))).
cnf(i_has_pub_key,axiom,
    (has_pub_key(i,cons(key(pub,i),cons(i,nil))))).

#define PHASE(s) s##_old
#include "nsl7bis.phase.p"
#undef PHASE

cnf(intruder_remembers,axiom,
   (~knows_old(M) | knows_current(M))).

cnf(intruder_knows_all_previous_session_keys,axiom,
  (knows_current(key(sym,session_old(A,B,Na))))).
cnf(intruder_knows_all_previous_noncea,axiom,
    (knows_current(noncea_old(A,B,KPb)))).
cnf(intruder_knows_all_previous_nonceb,axiom,
    (knows_current(nonceb_old(A,B,KPa,Na)))).
   
#define PHASE(s) s##_current
#include "nsl7bis.phase.p"
#undef PHASE

cnf(intruder_knows_alice_msg,axiom,
    (~knows_current(noncea_current(alice,bob,KPb)))).
cnf(intruder_knows_bob_msg,axiom,
    (~knows_current(nonceb_current(alice,bob,KPa,Na)))).
