
% Symbols type declarations


input_clause(clause_1, axiom,
[++t_principal(I)]).

input_clause(clause_2, axiom,
[++t_principal(v_s)]).

input_clause(clause_3, axiom,
[++t_principal(v_b)]).

input_clause(clause_4, axiom,
[++t_principal(v_a)]).

input_clause(clause_5, axiom,
[++t_number(v_k2)]).

input_clause(clause_6, axiom,
[++t_number(v_k1)]).

input_clause(clause_7, axiom,
[++t_number(v_nb2)]).

input_clause(clause_8, axiom,
[++t_number(v_nb1)]).

input_clause(clause_9, axiom,
[++t_number(v_na2)]).

input_clause(clause_10, axiom,
[++t_number(v_na1)]).

input_clause(clause_11, axiom,
[++t_number(v_n2)]).

input_clause(clause_12, axiom,
[++t_number(v_n1)]).

input_clause(clause_13, axiom,
[++t_number(v__e)]).

input_clause(clause_14, axiom,
[--t_number(Q_Z1), --t_number(Q_Z2), ++t_number(c(Q_Z1, c(Q_Z2, v__e)))]).

input_clause(clause_15, axiom,
[--t_number(Q_Z), ++t_number(app1(c_shr, Q_Z))]).

input_clause(clause_16, axiom,
[++t_symalgo(vanilla)]).

input_clause(clause_17, axiom,
[++t_asymalgo(vanilla)]).

input_clause(clause_18, axiom,
[--t_symalgo(Q_Zs), ++t_algo(Q_Zs)]).

input_clause(clause_19, axiom,
[--t_asymalgo(Q_Za), ++t_algo(Q_Za)]).

input_clause(clause_20, axiom,
[--t_algo(Q_Za), --t_number(Q_Zk), --t_number(Q_Zt),
  ++t_number(crypt(Q_Za, Q_Zk, Q_Zt))]).

input_clause(clause_21, axiom,
[--t_principal(Q_Z), ++t_number(r_p(Q_Z))]).

input_clause(clause_22, axiom,
[--t_algo(Q_Z), ++t_number(r_a(Q_Z))]).

input_clause(clause_23, axiom,
[--t_symalgo(Q_Z), ++t_algo(r_sa(Q_Z))]).

input_clause(clause_24, axiom,
[--t_asymalgo(Q_Z), ++t_algo(r_aa(Q_Z))]).


% Initial state of principals


input_clause(clause_26, axiom,
[++state_A_1(v_a, v_b, app2(c_shr, c(r_p(v_a), c(r_p(v_s), v__e))), v_n1,
             v_na1)]).

input_clause(clause_27, axiom,
[++state_B_1(v_s, app2(c_shr, c(r_p(v_b), c(r_p(v_s), v__e))), v_nb1)]).

input_clause(clause_28, axiom,
[++state_S_2(v_s, c_shr, v_k1)]).

input_clause(clause_29, axiom,
[++state_A_1(v_b, v_a, app2(c_shr, c(r_p(v_b), c(r_p(v_s), v__e))), v_n2,
             v_na2)]).

input_clause(clause_30, axiom,
[++state_B_1(v_s, app2(c_shr, c(r_p(v_a), c(r_p(v_s), v__e))), v_nb2)]).

input_clause(clause_31, axiom,
[++state_S_2(v_s, c_shr, v_k2)]).


% Transitions


input_clause(clause_33, axiom,
[--state_A_1(P_A, P_B, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))), P_N, P_Na),
  ++state_A_4(P_A, P_B, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))), 
              P_N, P_Na)]).

input_clause(clause_34, axiom,
[--state_A_4(P_A, P_B, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))), P_N, P_Na),
  ++knows(c(P_N, c(r_p(P_A), c(r_p(P_B),
            c(crypt(vanilla, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))),
                c(P_Na, c(P_N, c(r_p(P_A), c(r_p(P_B), v__e))))),
            v__e)))))]).

input_clause(clause_35, axiom,
[--state_A_4(P_A, P_B, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))), P_N, P_Na),
 --knows(c(P_N,
           c(crypt(vanilla, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))),
               c(P_Na, c(P_Kab, v__e))),
           v__e))),
  ++state_A_end(P_A, P_B, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))), 
                P_N, P_Na, P_S, P_Kab)]).

input_clause(clause_36, axiom,
[--state_B_1(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb),
 --knows(c(P_N, c(r_p(P_A), c(r_p(P_B), c(V__XB1, v__e))))),
  ++state_B_2(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
              P_N, P_A, P_B, V__XB1)]).

input_clause(clause_37, axiom,
[--state_B_2(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
             P_N, P_A, P_B, V__XB1),
  ++state_B_3(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
              P_N, P_A, P_B, V__XB1)]).

input_clause(clause_38, axiom,
[--state_B_3(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
             P_N, P_A, P_B, V__XB1),
  ++knows(c(P_N, c(r_p(P_A), c(r_p(P_B), c(V__XB1,
            c(crypt(vanilla, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))),
                c(P_Nb, c(P_N, c(r_p(P_A), c(r_p(P_B), v__e))))),
            v__e))))))]).

input_clause(clause_39, axiom,
[--state_B_3(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
             P_N, P_A, P_B, V__XB1),
 --knows(c(P_N, c(V__XB2,
           c(crypt(vanilla, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))),
               c(P_Nb, c(P_Kab, v__e))),
           v__e)))),
  ++state_B_4(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
              P_N, P_A, P_B, V__XB1, V__XB2, P_Kab)]).

input_clause(clause_40, axiom,
[--state_B_4(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
             P_N, P_A, P_B, V__XB1, V__XB2, P_Kab),
  ++state_B_end(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
                P_N, P_A, P_B, V__XB1, V__XB2, P_Kab)]).

input_clause(clause_41, axiom,
[--state_B_end(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
               P_N, P_A, P_B, V__XB1, V__XB2, P_Kab),
  ++knows(c(P_N, c(V__XB2, v__e)))]).

input_clause(clause_42, axiom,
[--state_S_2(P_S, c_shr, P_Kab),
 --knows(c(P_N, c(r_p(P_A), c(r_p(P_B),
           c(crypt(vanilla, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))),
               c(P_Na, c(P_N, c(r_p(P_A), c(r_p(P_B), v__e))))),
           c(crypt(vanilla, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))),
               c(P_Nb, c(P_N, c(r_p(P_A), c(r_p(P_B), v__e))))),
           v__e)))))),
  ++state_S_3(P_S, c_shr, P_Kab, P_N, P_A, P_B, P_Na, P_Nb)]).

input_clause(clause_43, axiom,
[--state_S_3(P_S, c_shr, P_Kab, P_N, P_A, P_B, P_Na, P_Nb),
  ++state_S_end(P_S, c_shr, P_Kab, P_N, P_A, P_B, P_Na, P_Nb)]).

input_clause(clause_44, axiom,
[--state_S_end(P_S, c_shr, P_Kab, P_N, P_A, P_B, P_Na, P_Nb),
  ++knows(c(P_N,
            c(crypt(vanilla, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))),
                c(P_Na, c(P_Kab, v__e))),
            c(crypt(vanilla, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))),
                c(P_Nb, c(P_Kab, v__e))),
            v__e))))]).


% Initial state of intruder


input_clause(clause_46, axiom,
[++honest(r_p(v_a))]).

input_clause(clause_47, axiom,
[++honest(r_p(v_b))]).

input_clause(clause_48, axiom,
[++honest(r_p(v_s))]).

input_clause(clause_49, axiom,
[--knows(app2(c_shr, c(r_p(Q_X), c(r_p(Q_Y), v__e)))), --honest(r_p(Q_Y)),
 --honest(r_p(Q_X)), --t_principal(Q_X), --t_principal(Q_Y)]).

input_clause(clause_50, axiom,
[++knows(r_p(v_I))]).


% Intruders theory


input_clause(clause_52, axiom,
[++knows(v__e)]).

input_clause(clause_53, axiom,
[--knows(Q_Z1), --knows(Q_Z2), ++knows(c(Q_Z1, c(Q_Z2, v__e)))]).

input_clause(clause_54, axiom,
[--knows(c(Q_Z1, c(Q_Z2, v__e))), ++knows(Q_Z1)]).

input_clause(clause_55, axiom,
[--knows(c(Q_Z1, c(Q_Z2, v__e))), ++knows(Q_Z2)]).

input_clause(clause_56, axiom,
[--t_number(Q_Z), --knows(c_shr), --knows(Q_Z), ++knows(app1(c_shr, Q_Z))]).

input_clause(clause_57, axiom,
[--t_number(Q_Z), --knows(c_shr), --knows(app1(c_shr, Q_Z)), ++knows(Q_Z)]).

input_clause(clause_58, axiom,
[--t_algo(Q_Za), --t_number(Q_Zk), --t_number(Q_Zm), --knows(Q_Zk),
 --knows(Q_Zm), ++knows(crypt(Q_Za, Q_Zk, Q_Zm))]).

input_clause(clause_59, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, r_p(I), Q_Zm)),
 --knows(I), ++knows(Q_Zm)]).

input_clause(clause_60, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, r_p(v_s), Q_Zm)),
 --knows(v_s), ++knows(Q_Zm)]).

input_clause(clause_61, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, r_p(v_b), Q_Zm)),
 --knows(v_b), ++knows(Q_Zm)]).

input_clause(clause_62, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, r_p(v_a), Q_Zm)),
 --knows(v_a), ++knows(Q_Zm)]).

input_clause(clause_63, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_k2, Q_Zm)),
 --knows(v_k2), ++knows(Q_Zm)]).

input_clause(clause_64, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_k1, Q_Zm)),
 --knows(v_k1), ++knows(Q_Zm)]).

input_clause(clause_65, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_nb2, Q_Zm)),
 --knows(v_nb2), ++knows(Q_Zm)]).

input_clause(clause_66, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_nb1, Q_Zm)),
 --knows(v_nb1), ++knows(Q_Zm)]).

input_clause(clause_67, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_na2, Q_Zm)),
 --knows(v_na2), ++knows(Q_Zm)]).

input_clause(clause_68, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_na1, Q_Zm)),
 --knows(v_na1), ++knows(Q_Zm)]).

input_clause(clause_69, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_n2, Q_Zm)),
 --knows(v_n2), ++knows(Q_Zm)]).

input_clause(clause_70, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, v_n1, Q_Zm)),
 --knows(v_n1), ++knows(Q_Zm)]).

input_clause(clause_71, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Zm), --knows(crypt(Q_Za, r_p(v_I), Q_Zm)),
 --knows(v_I), ++knows(Q_Zm)]).

input_clause(clause_72, axiom,
[--t_symalgo(Q_Za), --t_number(Q_Z1), --t_number(Q_Z2),
 --knows(crypt(Q_Za, c(Q_Z1, c(Q_Z2, v__e)), Q_Zm)),
 --knows(c(Q_Z1, c(Q_Z2, v__e))), ++knows(Q_Zm)]).

input_clause(clause_73, axiom,
[--t_number(Q_Y2), --t_number(Q_Y1), --t_symalgo(Q_Za), --t_number(Q_Zm),
 --knows(crypt(Q_Za, app2(c_shr, c(Q_Y2, c(Q_Y1, v__e))), Q_Zm)),
 --knows(app2(c_shr, c(Q_Y2, c(Q_Y1, v__e)))), ++knows(Q_Zm)]).

input_clause(clause_74, axiom,
[--t_symalgo(Q_Za1), --t_algo(Q_Za2), --t_number(Q_Zk), --t_number(Q_Zm1),
 --t_number(Q_Zm2), --knows(crypt(Q_Za1, crypt(Q_Za2, Q_Zk, Q_Zm2), Q_Zm1)),
 --knows(crypt(Q_Za2, Q_Zk, Q_Zm2)), ++knows(Q_Zm1)]).

input_clause(clause_75, axiom,
[--t_principal(Q_Z), --knows(Q_Z), ++knows(r_p(Q_Z))]).

input_clause(clause_76, axiom,
[--t_algo(Q_Z), --knows(Q_Z), ++knows(r_a(Q_Z))]).

input_clause(clause_77, axiom,
[--t_symalgo(Q_Z), --knows(Q_Z), ++knows(r_sa(Q_Z))]).

input_clause(clause_78, axiom,
[--t_asymalgo(Q_Z), --knows(Q_Z), ++knows(r_aa(Q_Z))]).

input_clause(clause_79, axiom,
[--t_principal(Q_Z), --knows(r_p(Q_Z)), ++knows(Q_Z)]).

input_clause(clause_80, axiom,
[--t_algo(Q_Z), --knows(r_a(Q_Z)), ++knows(Q_Z)]).

input_clause(clause_81, axiom,
[--t_symalgo(Q_Z), --knows(r_sa(Q_Z)), ++knows(Q_Z)]).

input_clause(clause_82, axiom,
[--t_asymalgo(Q_Z), --knows(r_aa(Q_Z)), ++knows(Q_Z)]).


% Conjectures


input_clause(conj_84, conjecture,
[--state_A_end(P_A, P_B, app2(c_shr, c(r_p(P_A), c(r_p(P_S), v__e))), 
               P_N, P_Na, P_S, P_Kab),
 --honest(r_p(P_B)), --honest(r_p(P_A)), --knows(P_Kab)]).

input_clause(conj_85, conjecture,
[--state_B_4(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
             P_N, P_A, P_B, V__XB1, V__XB2, P_Kab),
 --honest(r_p(P_B)), --honest(r_p(P_A)), --knows(P_Kab)]).

input_clause(conj_86, conjecture,
[--state_B_end(P_S, app2(c_shr, c(r_p(P_B), c(r_p(P_S), v__e))), P_Nb, 
               P_N, P_A, P_B, V__XB1, V__XB2, P_Kab),
 --honest(r_p(P_B)), --honest(r_p(P_A)), --knows(P_Kab)]).

