% h1 example: tree automaton recognizing trees with 3n+2 or nil as leaves.
%   Copyright (C) 2004 Jean Goubault-Larrecq and LSV, CNRS UMR 8643 & ENS Cachan.
%
%   This file is part of h1.
%
%   h1 is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2, or (at your option)
%   any later version.
%
%   h1 is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with h1; see the file COPYING.  If not, write to
%   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

input_clause(o_zero_mod_3, axiom,
	     [++zero_mod_3(o)]).

input_clause(suc_zero_one_mod_3, axiom,
	     [--zero_mod_3(X), ++one_mod_3(s(X))]).

input_clause(suc_one_two_mod_3, axiom,
	     [--one_mod_3(X), ++two_mod_3(s(X))]).

input_clause(suc_two_zero_mod_3, axiom,
	     [--two_mod_3(X), ++zero_mod_3(s(X))]).

input_clause(nil_3n_plus_2_tree, axiom,
	     [++tree_3n_plus_2(nil)]).

input_clause(two_mod_3_3n_plus_2_tree, axiom,
	     [--two_mod_3(X), ++tree_3n_plus_2(X)]).

input_clause(cons_3n_plus_2_tree, axiom,
	     [--tree_3n_plus_2(X), --tree_3n_plus_2(Y),
	      ++tree_3n_plus_2(cons(X,Y))]).

