
Inductive val : Set :=
	v1 : val | v2 : val | v3 : val | v4 : val | v5 : val | v6 : val.

Definition auto_agent (x1 : val) : Prop :=
  match x1 with
    v1 => True
  | _ => False
  end.

Definition alice : val := v1.
Definition auto_alice_key_current (x1 x2 : val) : Prop :=
  match x1,x2 with
    v1,v3 => True
  | v1,v5 => True
  | v3,v1 => True
  | v3,v2 => True
  | v3,v3 => True
  | v3,v4 => True
  | v3,v5 => True
  | v3,v6 => True
  | _,_ => False
  end.

Definition auto_alice_key_old (x1 x2 : val) : Prop :=
  match x1,x2 with
    _,_ => True
  end.

Definition bob : val := v1.
Definition auto_bob_key_current (x1 x2 : val) : Prop :=
  match x1,x2 with
  | v1,v3 => True
  | v1,v5 => True
  | v2,v1 => True
  | v2,v2 => True
  | v2,v3 => True
  | v2,v4 => True
  | v2,v5 => True
  | v2,v6 => True
  | v3,v1 => True
  | v3,v2 => True
  | v3,v3 => True
  | v3,v4 => True
  | v3,v5 => True
  | v3,v6 => True
  | v4,v1 => True
  | v4,v2 => True
  | v4,v3 => True
  | v4,v4 => True
  | v4,v5 => True
  | v4,v6 => True
  | v5,v1 => True
  | v5,v2 => True
  | v5,v3 => True
  | v5,v4 => True
  | v5,v5 => True
  | v5,v6 => True
  | v6,v1 => True
  | v6,v2 => True
  | v6,v3 => True
  | v6,v4 => True
  | v6,v5 => True
  | v6,v6 => True
  | _,_ => False
  end.

Definition auto_bob_key_old (x1 x2 : val) : Prop :=
  match x1,x2 with
    _,_ => True
  end.

Definition cons (x1 x2 : val) : val :=
  match x1,x2 with
    v1,v1 => v1
  | v1,v2 => v4
  | v1,v3 => v3
  | v1,v4 => v6
  | v1,v5 => v5
  | v1,v6 => v6
  | v2,v1 => v2
  | v2,v2 => v4
  | v2,v3 => v3
  | v2,v4 => v6
  | v2,v5 => v5
  | v2,v6 => v6
  | v3,v1 => v3
  | v3,v2 => v3
  | v3,v3 => v3
  | v3,v4 => v3
  | v3,v5 => v3
  | v3,v6 => v3
  | v4,v1 => v2
  | v4,v2 => v4
  | v4,v3 => v3
  | v4,v4 => v6
  | v4,v5 => v5
  | v4,v6 => v6
  | v5,v1 => v5
  | v5,v2 => v5
  | v5,v3 => v3
  | v5,v4 => v3
  | v5,v5 => v5
  | v5,v6 => v3
  | v6,v1 => v2
  | v6,v2 => v4
  | v6,v3 => v3
  | v6,v4 => v6
  | v6,v5 => v5
  | v6,v6 => v6
  end.
Definition crypt (x1 x2 : val) : val :=
  match x1,x2 with
    v1,v1 => v1
  | v1,v2 => v1
  | v1,v3 => v1
  | v1,v4 => v1
  | v1,v5 => v1
  | v1,v6 => v1
  | v2,v1 => v2
  | v2,v2 => v1
  | v2,v3 => v1
  | v2,v4 => v1
  | v2,v5 => v1
  | v2,v6 => v6
  | v3,v1 => v5
  | v3,v2 => v6
  | v3,v3 => v3
  | v3,v4 => v3
  | v3,v5 => v3
  | v3,v6 => v3
  | v4,v1 => v2
  | v4,v2 => v4
  | v4,v3 => v2
  | v4,v4 => v2
  | v4,v5 => v6
  | v4,v6 => v1
  | v5,v1 => v5
  | v5,v2 => v5
  | v5,v3 => v1
  | v5,v4 => v3
  | v5,v5 => v1
  | v5,v6 => v5
  | v6,v1 => v2
  | v6,v2 => v2
  | v6,v3 => v3
  | v6,v4 => v6
  | v6,v5 => v1
  | v6,v6 => v6
  end.

Definition i : val := v1.
Definition key (x1 x2 : val) : val :=
  match x1,x2 with
  | v1,v1 => v1
  | v1,v2 => v1
  | v1,v3 => v1
  | v1,v4 => v1
  | v1,v5 => v1
  | v1,v6 => v1
  | v2,v1 => v3
  | v2,v2 => v5
  | v2,v3 => v4
  | v2,v4 => v5
  | v2,v5 => v5
  | v2,v6 => v1
  | v3,v1 => v1
  | v3,v2 => v5
  | v3,v3 => v2
  | v3,v4 => v6
  | v3,v5 => v6
  | v3,v6 => v1
  | v4,v1 => v1
  | v4,v2 => v5
  | v4,v3 => v2
  | v4,v4 => v6
  | v4,v5 => v6
  | v4,v6 => v1
  | v5,v1 => v1
  | v5,v2 => v5
  | v5,v3 => v2
  | v5,v4 => v6
  | v5,v5 => v6
  | v5,v6 => v1
  | v6,v1 => v1
  | v6,v2 => v5
  | v6,v3 => v2
  | v6,v4 => v6
  | v6,v5 => v6
  | v6,v6 => v1
  end.

Definition auto_knows_current (x1 : val) : Prop :=
  match x1 with
    v1 => True
  | v2 => True
  | v4 => True
  | v6 => True
  | _ => False
  end.

Definition auto_knows_old (x1 : val) : Prop :=
  match x1 with
    v1 => True
  | _ => False
  end.

Definition nil : val := v1.
Definition noncea_current (x1 : val) : val :=
  match x1 with
  | v1 => v2
  | v2 => v3
  | v3 => v2
  | v4 => v3
  | v5 => v3
  | v6 => v3
  end.
Definition noncea_old (x1 : val) : val :=
  match x1 with
  | v1 => v1
  | v2 => v6
  | v3 => v1
  | v4 => v2
  | v5 => v2
  | v6 => v1
  end.
Definition nonceb_current (x1 x2 x3 : val) : val :=
  match x1,x2,x3 with
    v1,v1,v1 => v2
  | v1,v1,v2 => v6
  | v1,v1,v3 => v5
  | v1,v1,v4 => v6
  | v1,v1,v5 => v6
  | v1,v1,v6 => v4
  | v1,v2,v1 => v4
  | v1,v2,v2 => v5
  | v1,v2,v3 => v4
  | v1,v2,v4 => v5
  | v1,v2,v5 => v5
  | v1,v2,v6 => v5
  | v1,v3,v1 => v2
  | v1,v3,v2 => v6
  | v1,v3,v3 => v5
  | v1,v3,v4 => v6
  | v1,v3,v5 => v4
  | v1,v3,v6 => v6
  | v1,v4,v1 => v5
  | v1,v4,v2 => v6
  | v1,v4,v3 => v5
  | v1,v4,v4 => v6
  | v1,v4,v5 => v2
  | v1,v4,v6 => v6
  | v1,v5,v1 => v5
  | v1,v5,v2 => v6
  | v1,v5,v3 => v5
  | v1,v5,v4 => v6
  | v1,v5,v5 => v1
  | v1,v5,v6 => v5
  | v1,v6,v1 => v6
  | v1,v6,v2 => v5
  | v1,v6,v3 => v4
  | v1,v6,v4 => v2
  | v1,v6,v5 => v6
  | v1,v6,v6 => v5
  | v2,v1,v1 => v2
  | v2,v1,v2 => v4
  | v2,v1,v3 => v5
  | v2,v1,v4 => v6
  | v2,v1,v5 => v6
  | v2,v1,v6 => v6
  | v2,v2,v1 => v5
  | v2,v2,v2 => v5
  | v2,v2,v3 => v5
  | v2,v2,v4 => v5
  | v2,v2,v5 => v5
  | v2,v2,v6 => v5
  | v2,v3,v1 => v5
  | v2,v3,v2 => v6
  | v2,v3,v3 => v5
  | v2,v3,v4 => v5
  | v2,v3,v5 => v4
  | v2,v3,v6 => v5
  | v2,v4,v1 => v1
  | v2,v4,v2 => v6
  | v2,v4,v3 => v5
  | v2,v4,v4 => v6
  | v2,v4,v5 => v6
  | v2,v4,v6 => v6
  | v2,v5,v1 => v5
  | v2,v5,v2 => v5
  | v2,v5,v3 => v5
  | v2,v5,v4 => v6
  | v2,v5,v5 => v1
  | v2,v5,v6 => v5
  | v2,v6,v1 => v6
  | v2,v6,v2 => v2
  | v2,v6,v3 => v4
  | v2,v6,v4 => v5
  | v2,v6,v5 => v1
  | v2,v6,v6 => v5
  | v3,v1,v1 => v5
  | v3,v1,v2 => v5
  | v3,v1,v3 => v5
  | v3,v1,v4 => v5
  | v3,v1,v5 => v5
  | v3,v1,v6 => v5
  | v3,v2,v1 => v4
  | v3,v2,v2 => v5
  | v3,v2,v3 => v5
  | v3,v2,v4 => v4
  | v3,v2,v5 => v4
  | v3,v2,v6 => v5
  | v3,v3,v1 => v5
  | v3,v3,v2 => v5
  | v3,v3,v3 => v5
  | v3,v3,v4 => v5
  | v3,v3,v5 => v5
  | v3,v3,v6 => v5
  | v3,v4,v1 => v5
  | v3,v4,v2 => v5
  | v3,v4,v3 => v5
  | v3,v4,v4 => v5
  | v3,v4,v5 => v5
  | v3,v4,v6 => v5
  | v3,v5,v1 => v5
  | v3,v5,v2 => v5
  | v3,v5,v3 => v5
  | v3,v5,v4 => v5
  | v3,v5,v5 => v5
  | v3,v5,v6 => v5
  | v3,v6,v1 => v4
  | v3,v6,v2 => v4
  | v3,v6,v3 => v4
  | v3,v6,v4 => v4
  | v3,v6,v5 => v4
  | v3,v6,v6 => v4
  | v4,v1,v1 => v2
  | v4,v1,v2 => v2
  | v4,v1,v3 => v5
  | v4,v1,v4 => v2
  | v4,v1,v5 => v6
  | v4,v1,v6 => v6
  | v4,v2,v1 => v5
  | v4,v2,v2 => v5
  | v4,v2,v3 => v4
  | v4,v2,v4 => v5
  | v4,v2,v5 => v5
  | v4,v2,v6 => v5
  | v4,v3,v1 => v5
  | v4,v3,v2 => v5
  | v4,v3,v3 => v5
  | v4,v3,v4 => v5
  | v4,v3,v5 => v4
  | v4,v3,v6 => v6
  | v4,v4,v1 => v1
  | v4,v4,v2 => v6
  | v4,v4,v3 => v5
  | v4,v4,v4 => v6
  | v4,v4,v5 => v5
  | v4,v4,v6 => v6
  | v4,v5,v1 => v5
  | v4,v5,v2 => v5
  | v4,v5,v3 => v5
  | v4,v5,v4 => v5
  | v4,v5,v5 => v1
  | v4,v5,v6 => v6
  | v4,v6,v1 => v6
  | v4,v6,v2 => v5
  | v4,v6,v3 => v4
  | v4,v6,v4 => v5
  | v4,v6,v5 => v1
  | v4,v6,v6 => v5
  | v5,v1,v1 => v6
  | v5,v1,v2 => v6
  | v5,v1,v3 => v5
  | v5,v1,v4 => v6
  | v5,v1,v5 => v6
  | v5,v1,v6 => v6
  | v5,v2,v1 => v5
  | v5,v2,v2 => v5
  | v5,v2,v3 => v4
  | v5,v2,v4 => v5
  | v5,v2,v5 => v5
  | v5,v2,v6 => v5
  | v5,v3,v1 => v4
  | v5,v3,v2 => v4
  | v5,v3,v3 => v5
  | v5,v3,v4 => v4
  | v5,v3,v5 => v4
  | v5,v3,v6 => v4
  | v5,v4,v1 => v5
  | v5,v4,v2 => v6
  | v5,v4,v3 => v5
  | v5,v4,v4 => v2
  | v5,v4,v5 => v6
  | v5,v4,v6 => v5
  | v5,v5,v1 => v1
  | v5,v5,v2 => v1
  | v5,v5,v3 => v5
  | v5,v5,v4 => v5
  | v5,v5,v5 => v5
  | v5,v5,v6 => v5
  | v5,v6,v1 => v6
  | v5,v6,v2 => v1
  | v5,v6,v3 => v4
  | v5,v6,v4 => v6
  | v5,v6,v5 => v6
  | v5,v6,v6 => v6
  | v6,v1,v1 => v2
  | v6,v1,v2 => v2
  | v6,v1,v3 => v5
  | v6,v1,v4 => v4
  | v6,v1,v5 => v6
  | v6,v1,v6 => v6
  | v6,v2,v1 => v5
  | v6,v2,v2 => v5
  | v6,v2,v3 => v4
  | v6,v2,v4 => v5
  | v6,v2,v5 => v5
  | v6,v2,v6 => v5
  | v6,v3,v1 => v5
  | v6,v3,v2 => v6
  | v6,v3,v3 => v5
  | v6,v3,v4 => v6
  | v6,v3,v5 => v4
  | v6,v3,v6 => v5
  | v6,v4,v1 => v1
  | v6,v4,v2 => v6
  | v6,v4,v3 => v5
  | v6,v4,v4 => v6
  | v6,v4,v5 => v2
  | v6,v4,v6 => v6
  | v6,v5,v1 => v5
  | v6,v5,v2 => v5
  | v6,v5,v3 => v5
  | v6,v5,v4 => v5
  | v6,v5,v5 => v5
  | v6,v5,v6 => v6
  | v6,v6,v1 => v6
  | v6,v6,v2 => v2
  | v6,v6,v3 => v4
  | v6,v6,v4 => v5
  | v6,v6,v5 => v6
  | v6,v6,v6 => v2
  end.
Definition nonceb_old (x1 x2 x3 : val) : val :=
  match x1,x2,x3 with
  | v1,v1,v1 => v1
  | v1,v1,v2 => v1
  | v1,v1,v3 => v6
  | v1,v1,v4 => v1
  | v1,v1,v5 => v4
  | v1,v1,v6 => v1
  | v1,v2,v1 => v1
  | v1,v2,v2 => v1
  | v1,v2,v3 => v6
  | v1,v2,v4 => v1
  | v1,v2,v5 => v4
  | v1,v2,v6 => v1
  | v1,v3,v1 => v4
  | v1,v3,v2 => v1
  | v1,v3,v3 => v6
  | v1,v3,v4 => v1
  | v1,v3,v5 => v6
  | v1,v3,v6 => v1
  | v1,v4,v1 => v4
  | v1,v4,v2 => v1
  | v1,v4,v3 => v6
  | v1,v4,v4 => v1
  | v1,v4,v5 => v6
  | v1,v4,v6 => v1
  | v1,v5,v1 => v1
  | v1,v5,v2 => v1
  | v1,v5,v3 => v6
  | v1,v5,v4 => v1
  | v1,v5,v5 => v6
  | v1,v5,v6 => v1
  | v1,v6,v1 => v1
  | v1,v6,v2 => v1
  | v1,v6,v3 => v6
  | v1,v6,v4 => v1
  | v1,v6,v5 => v2
  | v1,v6,v6 => v1
  | v2,v1,v1 => v1
  | v2,v1,v2 => v1
  | v2,v1,v3 => v6
  | v2,v1,v4 => v1
  | v2,v1,v5 => v4
  | v2,v1,v6 => v1
  | v2,v2,v1 => v4
  | v2,v2,v2 => v1
  | v2,v2,v3 => v6
  | v2,v2,v4 => v1
  | v2,v2,v5 => v4
  | v2,v2,v6 => v1
  | v2,v3,v1 => v2
  | v2,v3,v2 => v1
  | v2,v3,v3 => v6
  | v2,v3,v4 => v1
  | v2,v3,v5 => v6
  | v2,v3,v6 => v1
  | v2,v4,v1 => v1
  | v2,v4,v2 => v1
  | v2,v4,v3 => v6
  | v2,v4,v4 => v1
  | v2,v4,v5 => v6
  | v2,v4,v6 => v1
  | v2,v5,v1 => v2
  | v2,v5,v2 => v1
  | v2,v5,v3 => v6
  | v2,v5,v4 => v1
  | v2,v5,v5 => v6
  | v2,v5,v6 => v1
  | v2,v6,v1 => v6
  | v2,v6,v2 => v1
  | v2,v6,v3 => v6
  | v2,v6,v4 => v1
  | v2,v6,v5 => v1
  | v2,v6,v6 => v1
  | v3,v1,v1 => v6
  | v3,v1,v2 => v6
  | v3,v1,v3 => v6
  | v3,v1,v4 => v6
  | v3,v1,v5 => v6
  | v3,v1,v6 => v6
  | v3,v2,v1 => v6
  | v3,v2,v2 => v6
  | v3,v2,v3 => v6
  | v3,v2,v4 => v6
  | v3,v2,v5 => v6
  | v3,v2,v6 => v6
  | v3,v3,v1 => v6
  | v3,v3,v2 => v6
  | v3,v3,v3 => v6
  | v3,v3,v4 => v6
  | v3,v3,v5 => v6
  | v3,v3,v6 => v6
  | v3,v4,v1 => v6
  | v3,v4,v2 => v6
  | v3,v4,v3 => v6
  | v3,v4,v4 => v6
  | v3,v4,v5 => v6
  | v3,v4,v6 => v6
  | v3,v5,v1 => v6
  | v3,v5,v2 => v6
  | v3,v5,v3 => v6
  | v3,v5,v4 => v6
  | v3,v5,v5 => v6
  | v3,v5,v6 => v6
  | v3,v6,v1 => v6
  | v3,v6,v2 => v6
  | v3,v6,v3 => v6
  | v3,v6,v4 => v6
  | v3,v6,v5 => v6
  | v3,v6,v6 => v6
  | v4,v1,v1 => v2
  | v4,v1,v2 => v1
  | v4,v1,v3 => v6
  | v4,v1,v4 => v1
  | v4,v1,v5 => v4
  | v4,v1,v6 => v1
  | v4,v2,v1 => v4
  | v4,v2,v2 => v1
  | v4,v2,v3 => v6
  | v4,v2,v4 => v1
  | v4,v2,v5 => v4
  | v4,v2,v6 => v1
  | v4,v3,v1 => v2
  | v4,v3,v2 => v1
  | v4,v3,v3 => v6
  | v4,v3,v4 => v1
  | v4,v3,v5 => v6
  | v4,v3,v6 => v1
  | v4,v4,v1 => v1
  | v4,v4,v2 => v1
  | v4,v4,v3 => v6
  | v4,v4,v4 => v1
  | v4,v4,v5 => v6
  | v4,v4,v6 => v1
  | v4,v5,v1 => v2
  | v4,v5,v2 => v1
  | v4,v5,v3 => v6
  | v4,v5,v4 => v1
  | v4,v5,v5 => v6
  | v4,v5,v6 => v1
  | v4,v6,v1 => v6
  | v4,v6,v2 => v1
  | v4,v6,v3 => v6
  | v4,v6,v4 => v1
  | v4,v6,v5 => v2
  | v4,v6,v6 => v1
  | v5,v1,v1 => v4
  | v5,v1,v2 => v4
  | v5,v1,v3 => v6
  | v5,v1,v4 => v4
  | v5,v1,v5 => v4
  | v5,v1,v6 => v4
  | v5,v2,v1 => v4
  | v5,v2,v2 => v4
  | v5,v2,v3 => v6
  | v5,v2,v4 => v4
  | v5,v2,v5 => v4
  | v5,v2,v6 => v4
  | v5,v3,v1 => v6
  | v5,v3,v2 => v6
  | v5,v3,v3 => v6
  | v5,v3,v4 => v6
  | v5,v3,v5 => v6
  | v5,v3,v6 => v6
  | v5,v4,v1 => v6
  | v5,v4,v2 => v6
  | v5,v4,v3 => v6
  | v5,v4,v4 => v6
  | v5,v4,v5 => v6
  | v5,v4,v6 => v6
  | v5,v5,v1 => v6
  | v5,v5,v2 => v6
  | v5,v5,v3 => v6
  | v5,v5,v4 => v6
  | v5,v5,v5 => v6
  | v5,v5,v6 => v6
  | v5,v6,v1 => v2
  | v5,v6,v2 => v1
  | v5,v6,v3 => v6
  | v5,v6,v4 => v2
  | v5,v6,v5 => v2
  | v5,v6,v6 => v1
  | v6,v1,v1 => v1
  | v6,v1,v2 => v1
  | v6,v1,v3 => v6
  | v6,v1,v4 => v1
  | v6,v1,v5 => v4
  | v6,v1,v6 => v1
  | v6,v2,v1 => v4
  | v6,v2,v2 => v1
  | v6,v2,v3 => v6
  | v6,v2,v4 => v1
  | v6,v2,v5 => v4
  | v6,v2,v6 => v1
  | v6,v3,v1 => v2
  | v6,v3,v2 => v1
  | v6,v3,v3 => v6
  | v6,v3,v4 => v1
  | v6,v3,v5 => v6
  | v6,v3,v6 => v1
  | v6,v4,v1 => v6
  | v6,v4,v2 => v1
  | v6,v4,v3 => v6
  | v6,v4,v4 => v1
  | v6,v4,v5 => v6
  | v6,v4,v6 => v1
  | v6,v5,v1 => v2
  | v6,v5,v2 => v1
  | v6,v5,v3 => v6
  | v6,v5,v4 => v1
  | v6,v5,v5 => v6
  | v6,v5,v6 => v1
  | v6,v6,v1 => v6
  | v6,v6,v2 => v1
  | v6,v6,v3 => v6
  | v6,v6,v4 => v1
  | v6,v6,v5 => v2
  | v6,v6,v6 => v1
  end.

Definition prv : val := v1.
Definition pub : val := v1.
Definition s (x1:val) : val :=
  match x1 with
  | v1 => v1
  | v2 => v2
  | v3 => v3
  | v4 => v4
  | v5 => v3
  | v6 => v2
  end.
Definition server : val := v1.
Definition session_current (x1 x2 x3 x4 : val) : val :=
  match x1,x2,x3,x4 with
    v1,v1,v1,v1 => v5
  | v1,v1,v1,v2 => v5
  | v1,v1,v1,v3 => v5
  | v1,v1,v1,v4 => v4
  | v1,v1,v1,v5 => v5
  | v1,v1,v1,v6 => v4
  | v1,v1,v2,v1 => v4
  | v1,v1,v2,v2 => v4
  | v1,v1,v2,v3 => v5
  | v1,v1,v2,v4 => v5
  | v1,v1,v2,v5 => v5
  | v1,v1,v2,v6 => v4
  | v1,v1,v3,v1 => v5
  | v1,v1,v3,v2 => v4
  | v1,v1,v3,v3 => v4
  | v1,v1,v3,v4 => v5
  | v1,v1,v3,v5 => v1
  | v1,v1,v3,v6 => v4
  | v1,v1,v4,v1 => v5
  | v1,v1,v4,v2 => v5
  | v1,v1,v4,v3 => v4
  | v1,v1,v4,v4 => v5
  | v1,v1,v4,v5 => v5
  | v1,v1,v4,v6 => v4
  | v1,v1,v5,v1 => v5
  | v1,v1,v5,v2 => v4
  | v1,v1,v5,v3 => v4
  | v1,v1,v5,v4 => v5
  | v1,v1,v5,v5 => v4
  | v1,v1,v5,v6 => v4
  | v1,v1,v6,v1 => v5
  | v1,v1,v6,v2 => v5
  | v1,v1,v6,v3 => v4
  | v1,v1,v6,v4 => v4
  | v1,v1,v6,v5 => v4
  | v1,v1,v6,v6 => v4
  | v1,v2,v1,v1 => v5
  | v1,v2,v1,v2 => v4
  | v1,v2,v1,v3 => v1
  | v1,v2,v1,v4 => v5
  | v1,v2,v1,v5 => v1
  | v1,v2,v1,v6 => v5
  | v1,v2,v2,v1 => v5
  | v1,v2,v2,v2 => v5
  | v1,v2,v2,v3 => v5
  | v1,v2,v2,v4 => v5
  | v1,v2,v2,v5 => v5
  | v1,v2,v2,v6 => v5
  | v1,v2,v3,v1 => v5
  | v1,v2,v3,v2 => v5
  | v1,v2,v3,v3 => v5
  | v1,v2,v3,v4 => v5
  | v1,v2,v3,v5 => v1
  | v1,v2,v3,v6 => v4
  | v1,v2,v4,v1 => v4
  | v1,v2,v4,v2 => v5
  | v1,v2,v4,v3 => v5
  | v1,v2,v4,v4 => v4
  | v1,v2,v4,v5 => v4
  | v1,v2,v4,v6 => v4
  | v1,v2,v5,v1 => v4
  | v1,v2,v5,v2 => v4
  | v1,v2,v5,v3 => v5
  | v1,v2,v5,v4 => v4
  | v1,v2,v5,v5 => v5
  | v1,v2,v5,v6 => v5
  | v1,v2,v6,v1 => v4
  | v1,v2,v6,v2 => v5
  | v1,v2,v6,v3 => v5
  | v1,v2,v6,v4 => v5
  | v1,v2,v6,v5 => v5
  | v1,v2,v6,v6 => v4
  | v1,v3,v1,v1 => v4
  | v1,v3,v1,v2 => v5
  | v1,v3,v1,v3 => v1
  | v1,v3,v1,v4 => v5
  | v1,v3,v1,v5 => v5
  | v1,v3,v1,v6 => v4
  | v1,v3,v2,v1 => v5
  | v1,v3,v2,v2 => v4
  | v1,v3,v2,v3 => v5
  | v1,v3,v2,v4 => v5
  | v1,v3,v2,v5 => v5
  | v1,v3,v2,v6 => v5
  | v1,v3,v3,v1 => v5
  | v1,v3,v3,v2 => v5
  | v1,v3,v3,v3 => v1
  | v1,v3,v3,v4 => v5
  | v1,v3,v3,v5 => v5
  | v1,v3,v3,v6 => v5
  | v1,v3,v4,v1 => v5
  | v1,v3,v4,v2 => v5
  | v1,v3,v4,v3 => v5
  | v1,v3,v4,v4 => v5
  | v1,v3,v4,v5 => v4
  | v1,v3,v4,v6 => v5
  | v1,v3,v5,v1 => v5
  | v1,v3,v5,v2 => v4
  | v1,v3,v5,v3 => v4
  | v1,v3,v5,v4 => v4
  | v1,v3,v5,v5 => v5
  | v1,v3,v5,v6 => v5
  | v1,v3,v6,v1 => v4
  | v1,v3,v6,v2 => v5
  | v1,v3,v6,v3 => v4
  | v1,v3,v6,v4 => v4
  | v1,v3,v6,v5 => v5
  | v1,v3,v6,v6 => v4
  | v1,v4,v1,v1 => v4
  | v1,v4,v1,v2 => v5
  | v1,v4,v1,v3 => v5
  | v1,v4,v1,v4 => v4
  | v1,v4,v1,v5 => v1
  | v1,v4,v1,v6 => v5
  | v1,v4,v2,v1 => v4
  | v1,v4,v2,v2 => v5
  | v1,v4,v2,v3 => v5
  | v1,v4,v2,v4 => v5
  | v1,v4,v2,v5 => v4
  | v1,v4,v2,v6 => v5
  | v1,v4,v3,v1 => v1
  | v1,v4,v3,v2 => v5
  | v1,v4,v3,v3 => v1
  | v1,v4,v3,v4 => v4
  | v1,v4,v3,v5 => v1
  | v1,v4,v3,v6 => v4
  | v1,v4,v4,v1 => v4
  | v1,v4,v4,v2 => v4
  | v1,v4,v4,v3 => v4
  | v1,v4,v4,v4 => v4
  | v1,v4,v4,v5 => v5
  | v1,v4,v4,v6 => v5
  | v1,v4,v5,v1 => v5
  | v1,v4,v5,v2 => v4
  | v1,v4,v5,v3 => v4
  | v1,v4,v5,v4 => v5
  | v1,v4,v5,v5 => v5
  | v1,v4,v5,v6 => v4
  | v1,v4,v6,v1 => v4
  | v1,v4,v6,v2 => v5
  | v1,v4,v6,v3 => v5
  | v1,v4,v6,v4 => v5
  | v1,v4,v6,v5 => v5
  | v1,v4,v6,v6 => v5
  | v1,v5,v1,v1 => v5
  | v1,v5,v1,v2 => v5
  | v1,v5,v1,v3 => v5
  | v1,v5,v1,v4 => v5
  | v1,v5,v1,v5 => v4
  | v1,v5,v1,v6 => v4
  | v1,v5,v2,v1 => v5
  | v1,v5,v2,v2 => v4
  | v1,v5,v2,v3 => v4
  | v1,v5,v2,v4 => v4
  | v1,v5,v2,v5 => v5
  | v1,v5,v2,v6 => v4
  | v1,v5,v3,v1 => v5
  | v1,v5,v3,v2 => v4
  | v1,v5,v3,v3 => v4
  | v1,v5,v3,v4 => v4
  | v1,v5,v3,v5 => v4
  | v1,v5,v3,v6 => v4
  | v1,v5,v4,v1 => v4
  | v1,v5,v4,v2 => v4
  | v1,v5,v4,v3 => v4
  | v1,v5,v4,v4 => v5
  | v1,v5,v4,v5 => v4
  | v1,v5,v4,v6 => v4
  | v1,v5,v5,v1 => v5
  | v1,v5,v5,v2 => v5
  | v1,v5,v5,v3 => v5
  | v1,v5,v5,v4 => v5
  | v1,v5,v5,v5 => v5
  | v1,v5,v5,v6 => v4
  | v1,v5,v6,v1 => v5
  | v1,v5,v6,v2 => v5
  | v1,v5,v6,v3 => v5
  | v1,v5,v6,v4 => v5
  | v1,v5,v6,v5 => v5
  | v1,v5,v6,v6 => v4
  | v1,v6,v1,v1 => v4
  | v1,v6,v1,v2 => v5
  | v1,v6,v1,v3 => v1
  | v1,v6,v1,v4 => v4
  | v1,v6,v1,v5 => v1
  | v1,v6,v1,v6 => v5
  | v1,v6,v2,v1 => v5
  | v1,v6,v2,v2 => v4
  | v1,v6,v2,v3 => v4
  | v1,v6,v2,v4 => v4
  | v1,v6,v2,v5 => v4
  | v1,v6,v2,v6 => v5
  | v1,v6,v3,v1 => v1
  | v1,v6,v3,v2 => v5
  | v1,v6,v3,v3 => v1
  | v1,v6,v3,v4 => v4
  | v1,v6,v3,v5 => v4
  | v1,v6,v3,v6 => v5
  | v1,v6,v4,v1 => v5
  | v1,v6,v4,v2 => v4
  | v1,v6,v4,v3 => v4
  | v1,v6,v4,v4 => v4
  | v1,v6,v4,v5 => v4
  | v1,v6,v4,v6 => v5
  | v1,v6,v5,v1 => v4
  | v1,v6,v5,v2 => v5
  | v1,v6,v5,v3 => v4
  | v1,v6,v5,v4 => v4
  | v1,v6,v5,v5 => v4
  | v1,v6,v5,v6 => v4
  | v1,v6,v6,v1 => v4
  | v1,v6,v6,v2 => v5
  | v1,v6,v6,v3 => v5
  | v1,v6,v6,v4 => v5
  | v1,v6,v6,v5 => v5
  | v1,v6,v6,v6 => v5
  | v2,v1,v1,v1 => v4
  | v2,v1,v1,v2 => v5
  | v2,v1,v1,v3 => v1
  | v2,v1,v1,v4 => v5
  | v2,v1,v1,v5 => v1
  | v2,v1,v1,v6 => v5
  | v2,v1,v2,v1 => v4
  | v2,v1,v2,v2 => v4
  | v2,v1,v2,v3 => v5
  | v2,v1,v2,v4 => v5
  | v2,v1,v2,v5 => v4
  | v2,v1,v2,v6 => v5
  | v2,v1,v3,v1 => v1
  | v2,v1,v3,v2 => v4
  | v2,v1,v3,v3 => v1
  | v2,v1,v3,v4 => v5
  | v2,v1,v3,v5 => v5
  | v2,v1,v3,v6 => v5
  | v2,v1,v4,v1 => v4
  | v2,v1,v4,v2 => v5
  | v2,v1,v4,v3 => v5
  | v2,v1,v4,v4 => v5
  | v2,v1,v4,v5 => v5
  | v2,v1,v4,v6 => v5
  | v2,v1,v5,v1 => v5
  | v2,v1,v5,v2 => v5
  | v2,v1,v5,v3 => v4
  | v2,v1,v5,v4 => v4
  | v2,v1,v5,v5 => v5
  | v2,v1,v5,v6 => v5
  | v2,v1,v6,v1 => v4
  | v2,v1,v6,v2 => v5
  | v2,v1,v6,v3 => v4
  | v2,v1,v6,v4 => v5
  | v2,v1,v6,v5 => v4
  | v2,v1,v6,v6 => v4
  | v2,v2,v1,v1 => v5
  | v2,v2,v1,v2 => v5
  | v2,v2,v1,v3 => v1
  | v2,v2,v1,v4 => v5
  | v2,v2,v1,v5 => v5
  | v2,v2,v1,v6 => v5
  | v2,v2,v2,v1 => v5
  | v2,v2,v2,v2 => v5
  | v2,v2,v2,v3 => v4
  | v2,v2,v2,v4 => v4
  | v2,v2,v2,v5 => v5
  | v2,v2,v2,v6 => v5
  | v2,v2,v3,v1 => v1
  | v2,v2,v3,v2 => v5
  | v2,v2,v3,v3 => v1
  | v2,v2,v3,v4 => v4
  | v2,v2,v3,v5 => v4
  | v2,v2,v3,v6 => v5
  | v2,v2,v4,v1 => v4
  | v2,v2,v4,v2 => v5
  | v2,v2,v4,v3 => v5
  | v2,v2,v4,v4 => v5
  | v2,v2,v4,v5 => v5
  | v2,v2,v4,v6 => v4
  | v2,v2,v5,v1 => v5
  | v2,v2,v5,v2 => v4
  | v2,v2,v5,v3 => v5
  | v2,v2,v5,v4 => v5
  | v2,v2,v5,v5 => v4
  | v2,v2,v5,v6 => v5
  | v2,v2,v6,v1 => v5
  | v2,v2,v6,v2 => v4
  | v2,v2,v6,v3 => v4
  | v2,v2,v6,v4 => v4
  | v2,v2,v6,v5 => v4
  | v2,v2,v6,v6 => v5
  | v2,v3,v1,v1 => v5
  | v2,v3,v1,v2 => v5
  | v2,v3,v1,v3 => v1
  | v2,v3,v1,v4 => v5
  | v2,v3,v1,v5 => v5
  | v2,v3,v1,v6 => v5
  | v2,v3,v2,v1 => v5
  | v2,v3,v2,v2 => v4
  | v2,v3,v2,v3 => v5
  | v2,v3,v2,v4 => v5
  | v2,v3,v2,v5 => v4
  | v2,v3,v2,v6 => v4
  | v2,v3,v3,v1 => v1
  | v2,v3,v3,v2 => v5
  | v2,v3,v3,v3 => v1
  | v2,v3,v3,v4 => v5
  | v2,v3,v3,v5 => v1
  | v2,v3,v3,v6 => v5
  | v2,v3,v4,v1 => v5
  | v2,v3,v4,v2 => v4
  | v2,v3,v4,v3 => v5
  | v2,v3,v4,v4 => v5
  | v2,v3,v4,v5 => v5
  | v2,v3,v4,v6 => v5
  | v2,v3,v5,v1 => v5
  | v2,v3,v5,v2 => v5
  | v2,v3,v5,v3 => v4
  | v2,v3,v5,v4 => v5
  | v2,v3,v5,v5 => v4
  | v2,v3,v5,v6 => v5
  | v2,v3,v6,v1 => v5
  | v2,v3,v6,v2 => v5
  | v2,v3,v6,v3 => v4
  | v2,v3,v6,v4 => v5
  | v2,v3,v6,v5 => v5
  | v2,v3,v6,v6 => v4
  | v2,v4,v1,v1 => v5
  | v2,v4,v1,v2 => v5
  | v2,v4,v1,v3 => v5
  | v2,v4,v1,v4 => v5
  | v2,v4,v1,v5 => v1
  | v2,v4,v1,v6 => v5
  | v2,v4,v2,v1 => v5
  | v2,v4,v2,v2 => v5
  | v2,v4,v2,v3 => v5
  | v2,v4,v2,v4 => v4
  | v2,v4,v2,v5 => v4
  | v2,v4,v2,v6 => v5
  | v2,v4,v3,v1 => v1
  | v2,v4,v3,v2 => v5
  | v2,v4,v3,v3 => v4
  | v2,v4,v3,v4 => v5
  | v2,v4,v3,v5 => v4
  | v2,v4,v3,v6 => v4
  | v2,v4,v4,v1 => v5
  | v2,v4,v4,v2 => v5
  | v2,v4,v4,v3 => v4
  | v2,v4,v4,v4 => v4
  | v2,v4,v4,v5 => v4
  | v2,v4,v4,v6 => v5
  | v2,v4,v5,v1 => v5
  | v2,v4,v5,v2 => v5
  | v2,v4,v5,v3 => v5
  | v2,v4,v5,v4 => v5
  | v2,v4,v5,v5 => v5
  | v2,v4,v5,v6 => v4
  | v2,v4,v6,v1 => v4
  | v2,v4,v6,v2 => v5
  | v2,v4,v6,v3 => v5
  | v2,v4,v6,v4 => v4
  | v2,v4,v6,v5 => v5
  | v2,v4,v6,v6 => v5
  | v2,v5,v1,v1 => v1
  | v2,v5,v1,v2 => v5
  | v2,v5,v1,v3 => v4
  | v2,v5,v1,v4 => v4
  | v2,v5,v1,v5 => v1
  | v2,v5,v1,v6 => v5
  | v2,v5,v2,v1 => v4
  | v2,v5,v2,v2 => v5
  | v2,v5,v2,v3 => v4
  | v2,v5,v2,v4 => v4
  | v2,v5,v2,v5 => v4
  | v2,v5,v2,v6 => v5
  | v2,v5,v3,v1 => v1
  | v2,v5,v3,v2 => v4
  | v2,v5,v3,v3 => v1
  | v2,v5,v3,v4 => v4
  | v2,v5,v3,v5 => v1
  | v2,v5,v3,v6 => v5
  | v2,v5,v4,v1 => v4
  | v2,v5,v4,v2 => v5
  | v2,v5,v4,v3 => v5
  | v2,v5,v4,v4 => v5
  | v2,v5,v4,v5 => v4
  | v2,v5,v4,v6 => v5
  | v2,v5,v5,v1 => v4
  | v2,v5,v5,v2 => v4
  | v2,v5,v5,v3 => v4
  | v2,v5,v5,v4 => v5
  | v2,v5,v5,v5 => v5
  | v2,v5,v5,v6 => v5
  | v2,v5,v6,v1 => v5
  | v2,v5,v6,v2 => v5
  | v2,v5,v6,v3 => v5
  | v2,v5,v6,v4 => v4
  | v2,v5,v6,v5 => v4
  | v2,v5,v6,v6 => v5
  | v2,v6,v1,v1 => v4
  | v2,v6,v1,v2 => v5
  | v2,v6,v1,v3 => v1
  | v2,v6,v1,v4 => v4
  | v2,v6,v1,v5 => v1
  | v2,v6,v1,v6 => v4
  | v2,v6,v2,v1 => v5
  | v2,v6,v2,v2 => v5
  | v2,v6,v2,v3 => v5
  | v2,v6,v2,v4 => v4
  | v2,v6,v2,v5 => v5
  | v2,v6,v2,v6 => v5
  | v2,v6,v3,v1 => v1
  | v2,v6,v3,v2 => v4
  | v2,v6,v3,v3 => v1
  | v2,v6,v3,v4 => v5
  | v2,v6,v3,v5 => v5
  | v2,v6,v3,v6 => v4
  | v2,v6,v4,v1 => v5
  | v2,v6,v4,v2 => v4
  | v2,v6,v4,v3 => v5
  | v2,v6,v4,v4 => v5
  | v2,v6,v4,v5 => v5
  | v2,v6,v4,v6 => v4
  | v2,v6,v5,v1 => v4
  | v2,v6,v5,v2 => v5
  | v2,v6,v5,v3 => v5
  | v2,v6,v5,v4 => v5
  | v2,v6,v5,v5 => v5
  | v2,v6,v5,v6 => v4
  | v2,v6,v6,v1 => v5
  | v2,v6,v6,v2 => v4
  | v2,v6,v6,v3 => v5
  | v2,v6,v6,v4 => v5
  | v2,v6,v6,v5 => v5
  | v2,v6,v6,v6 => v5
  | v3,v1,v1,v1 => v1
  | v3,v1,v1,v2 => v5
  | v3,v1,v1,v3 => v1
  | v3,v1,v1,v4 => v4
  | v3,v1,v1,v5 => v1
  | v3,v1,v1,v6 => v4
  | v3,v1,v2,v1 => v4
  | v3,v1,v2,v2 => v5
  | v3,v1,v2,v3 => v4
  | v3,v1,v2,v4 => v4
  | v3,v1,v2,v5 => v5
  | v3,v1,v2,v6 => v5
  | v3,v1,v3,v1 => v5
  | v3,v1,v3,v2 => v5
  | v3,v1,v3,v3 => v5
  | v3,v1,v3,v4 => v4
  | v3,v1,v3,v5 => v5
  | v3,v1,v3,v6 => v5
  | v3,v1,v4,v1 => v4
  | v3,v1,v4,v2 => v5
  | v3,v1,v4,v3 => v4
  | v3,v1,v4,v4 => v4
  | v3,v1,v4,v5 => v5
  | v3,v1,v4,v6 => v5
  | v3,v1,v5,v1 => v4
  | v3,v1,v5,v2 => v4
  | v3,v1,v5,v3 => v5
  | v3,v1,v5,v4 => v5
  | v3,v1,v5,v5 => v4
  | v3,v1,v5,v6 => v4
  | v3,v1,v6,v1 => v4
  | v3,v1,v6,v2 => v4
  | v3,v1,v6,v3 => v5
  | v3,v1,v6,v4 => v5
  | v3,v1,v6,v5 => v5
  | v3,v1,v6,v6 => v5
  | v3,v2,v1,v1 => v5
  | v3,v2,v1,v2 => v4
  | v3,v2,v1,v3 => v1
  | v3,v2,v1,v4 => v5
  | v3,v2,v1,v5 => v1
  | v3,v2,v1,v6 => v4
  | v3,v2,v2,v1 => v5
  | v3,v2,v2,v2 => v4
  | v3,v2,v2,v3 => v4
  | v3,v2,v2,v4 => v5
  | v3,v2,v2,v5 => v4
  | v3,v2,v2,v6 => v5
  | v3,v2,v3,v1 => v5
  | v3,v2,v3,v2 => v4
  | v3,v2,v3,v3 => v1
  | v3,v2,v3,v4 => v4
  | v3,v2,v3,v5 => v5
  | v3,v2,v3,v6 => v5
  | v3,v2,v4,v1 => v5
  | v3,v2,v4,v2 => v4
  | v3,v2,v4,v3 => v5
  | v3,v2,v4,v4 => v5
  | v3,v2,v4,v5 => v4
  | v3,v2,v4,v6 => v4
  | v3,v2,v5,v1 => v4
  | v3,v2,v5,v2 => v5
  | v3,v2,v5,v3 => v5
  | v3,v2,v5,v4 => v4
  | v3,v2,v5,v5 => v5
  | v3,v2,v5,v6 => v5
  | v3,v2,v6,v1 => v5
  | v3,v2,v6,v2 => v5
  | v3,v2,v6,v3 => v5
  | v3,v2,v6,v4 => v5
  | v3,v2,v6,v5 => v4
  | v3,v2,v6,v6 => v5
  | v3,v3,v1,v1 => v1
  | v3,v3,v1,v2 => v5
  | v3,v3,v1,v3 => v5
  | v3,v3,v1,v4 => v5
  | v3,v3,v1,v5 => v4
  | v3,v3,v1,v6 => v4
  | v3,v3,v2,v1 => v4
  | v3,v3,v2,v2 => v4
  | v3,v3,v2,v3 => v5
  | v3,v3,v2,v4 => v5
  | v3,v3,v2,v5 => v5
  | v3,v3,v2,v6 => v4
  | v3,v3,v3,v1 => v5
  | v3,v3,v3,v2 => v5
  | v3,v3,v3,v3 => v5
  | v3,v3,v3,v4 => v5
  | v3,v3,v3,v5 => v5
  | v3,v3,v3,v6 => v5
  | v3,v3,v4,v1 => v4
  | v3,v3,v4,v2 => v5
  | v3,v3,v4,v3 => v4
  | v3,v3,v4,v4 => v5
  | v3,v3,v4,v5 => v4
  | v3,v3,v4,v6 => v5
  | v3,v3,v5,v1 => v4
  | v3,v3,v5,v2 => v5
  | v3,v3,v5,v3 => v5
  | v3,v3,v5,v4 => v4
  | v3,v3,v5,v5 => v4
  | v3,v3,v5,v6 => v4
  | v3,v3,v6,v1 => v5
  | v3,v3,v6,v2 => v5
  | v3,v3,v6,v3 => v4
  | v3,v3,v6,v4 => v5
  | v3,v3,v6,v5 => v5
  | v3,v3,v6,v6 => v5
  | v3,v4,v1,v1 => v5
  | v3,v4,v1,v2 => v5
  | v3,v4,v1,v3 => v1
  | v3,v4,v1,v4 => v5
  | v3,v4,v1,v5 => v1
  | v3,v4,v1,v6 => v4
  | v3,v4,v2,v1 => v5
  | v3,v4,v2,v2 => v5
  | v3,v4,v2,v3 => v4
  | v3,v4,v2,v4 => v5
  | v3,v4,v2,v5 => v5
  | v3,v4,v2,v6 => v4
  | v3,v4,v3,v1 => v5
  | v3,v4,v3,v2 => v5
  | v3,v4,v3,v3 => v5
  | v3,v4,v3,v4 => v5
  | v3,v4,v3,v5 => v1
  | v3,v4,v3,v6 => v4
  | v3,v4,v4,v1 => v5
  | v3,v4,v4,v2 => v5
  | v3,v4,v4,v3 => v4
  | v3,v4,v4,v4 => v5
  | v3,v4,v4,v5 => v5
  | v3,v4,v4,v6 => v5
  | v3,v4,v5,v1 => v4
  | v3,v4,v5,v2 => v4
  | v3,v4,v5,v3 => v4
  | v3,v4,v5,v4 => v4
  | v3,v4,v5,v5 => v4
  | v3,v4,v5,v6 => v4
  | v3,v4,v6,v1 => v5
  | v3,v4,v6,v2 => v5
  | v3,v4,v6,v3 => v5
  | v3,v4,v6,v4 => v5
  | v3,v4,v6,v5 => v4
  | v3,v4,v6,v6 => v5
  | v3,v5,v1,v1 => v4
  | v3,v5,v1,v2 => v4
  | v3,v5,v1,v3 => v1
  | v3,v5,v1,v4 => v5
  | v3,v5,v1,v5 => v5
  | v3,v5,v1,v6 => v4
  | v3,v5,v2,v1 => v5
  | v3,v5,v2,v2 => v5
  | v3,v5,v2,v3 => v4
  | v3,v5,v2,v4 => v4
  | v3,v5,v2,v5 => v5
  | v3,v5,v2,v6 => v4
  | v3,v5,v3,v1 => v5
  | v3,v5,v3,v2 => v5
  | v3,v5,v3,v3 => v4
  | v3,v5,v3,v4 => v5
  | v3,v5,v3,v5 => v1
  | v3,v5,v3,v6 => v4
  | v3,v5,v4,v1 => v4
  | v3,v5,v4,v2 => v5
  | v3,v5,v4,v3 => v4
  | v3,v5,v4,v4 => v4
  | v3,v5,v4,v5 => v4
  | v3,v5,v4,v6 => v4
  | v3,v5,v5,v1 => v4
  | v3,v5,v5,v2 => v5
  | v3,v5,v5,v3 => v5
  | v3,v5,v5,v4 => v4
  | v3,v5,v5,v5 => v4
  | v3,v5,v5,v6 => v5
  | v3,v5,v6,v1 => v5
  | v3,v5,v6,v2 => v5
  | v3,v5,v6,v3 => v5
  | v3,v5,v6,v4 => v4
  | v3,v5,v6,v5 => v5
  | v3,v5,v6,v6 => v5
  | v3,v6,v1,v1 => v1
  | v3,v6,v1,v2 => v5
  | v3,v6,v1,v3 => v5
  | v3,v6,v1,v4 => v5
  | v3,v6,v1,v5 => v1
  | v3,v6,v1,v6 => v5
  | v3,v6,v2,v1 => v5
  | v3,v6,v2,v2 => v5
  | v3,v6,v2,v3 => v5
  | v3,v6,v2,v4 => v5
  | v3,v6,v2,v5 => v5
  | v3,v6,v2,v6 => v4
  | v3,v6,v3,v1 => v5
  | v3,v6,v3,v2 => v5
  | v3,v6,v3,v3 => v5
  | v3,v6,v3,v4 => v5
  | v3,v6,v3,v5 => v5
  | v3,v6,v3,v6 => v4
  | v3,v6,v4,v1 => v4
  | v3,v6,v4,v2 => v5
  | v3,v6,v4,v3 => v4
  | v3,v6,v4,v4 => v5
  | v3,v6,v4,v5 => v4
  | v3,v6,v4,v6 => v4
  | v3,v6,v5,v1 => v5
  | v3,v6,v5,v2 => v4
  | v3,v6,v5,v3 => v5
  | v3,v6,v5,v4 => v4
  | v3,v6,v5,v5 => v4
  | v3,v6,v5,v6 => v4
  | v3,v6,v6,v1 => v4
  | v3,v6,v6,v2 => v5
  | v3,v6,v6,v3 => v4
  | v3,v6,v6,v4 => v4
  | v3,v6,v6,v5 => v4
  | v3,v6,v6,v6 => v5
  | v4,v1,v1,v1 => v4
  | v4,v1,v1,v2 => v5
  | v4,v1,v1,v3 => v1
  | v4,v1,v1,v4 => v4
  | v4,v1,v1,v5 => v4
  | v4,v1,v1,v6 => v5
  | v4,v1,v2,v1 => v5
  | v4,v1,v2,v2 => v5
  | v4,v1,v2,v3 => v5
  | v4,v1,v2,v4 => v4
  | v4,v1,v2,v5 => v5
  | v4,v1,v2,v6 => v4
  | v4,v1,v3,v1 => v1
  | v4,v1,v3,v2 => v5
  | v4,v1,v3,v3 => v4
  | v4,v1,v3,v4 => v4
  | v4,v1,v3,v5 => v1
  | v4,v1,v3,v6 => v4
  | v4,v1,v4,v1 => v5
  | v4,v1,v4,v2 => v4
  | v4,v1,v4,v3 => v5
  | v4,v1,v4,v4 => v5
  | v4,v1,v4,v5 => v5
  | v4,v1,v4,v6 => v5
  | v4,v1,v5,v1 => v4
  | v4,v1,v5,v2 => v5
  | v4,v1,v5,v3 => v5
  | v4,v1,v5,v4 => v4
  | v4,v1,v5,v5 => v4
  | v4,v1,v5,v6 => v5
  | v4,v1,v6,v1 => v5
  | v4,v1,v6,v2 => v4
  | v4,v1,v6,v3 => v4
  | v4,v1,v6,v4 => v5
  | v4,v1,v6,v5 => v4
  | v4,v1,v6,v6 => v4
  | v4,v2,v1,v1 => v5
  | v4,v2,v1,v2 => v5
  | v4,v2,v1,v3 => v4
  | v4,v2,v1,v4 => v5
  | v4,v2,v1,v5 => v5
  | v4,v2,v1,v6 => v4
  | v4,v2,v2,v1 => v5
  | v4,v2,v2,v2 => v4
  | v4,v2,v2,v3 => v4
  | v4,v2,v2,v4 => v4
  | v4,v2,v2,v5 => v5
  | v4,v2,v2,v6 => v5
  | v4,v2,v3,v1 => v5
  | v4,v2,v3,v2 => v4
  | v4,v2,v3,v3 => v1
  | v4,v2,v3,v4 => v5
  | v4,v2,v3,v5 => v1
  | v4,v2,v3,v6 => v5
  | v4,v2,v4,v1 => v5
  | v4,v2,v4,v2 => v5
  | v4,v2,v4,v3 => v5
  | v4,v2,v4,v4 => v5
  | v4,v2,v4,v5 => v4
  | v4,v2,v4,v6 => v5
  | v4,v2,v5,v1 => v5
  | v4,v2,v5,v2 => v5
  | v4,v2,v5,v3 => v4
  | v4,v2,v5,v4 => v4
  | v4,v2,v5,v5 => v4
  | v4,v2,v5,v6 => v5
  | v4,v2,v6,v1 => v5
  | v4,v2,v6,v2 => v4
  | v4,v2,v6,v3 => v4
  | v4,v2,v6,v4 => v5
  | v4,v2,v6,v5 => v4
  | v4,v2,v6,v6 => v4
  | v4,v3,v1,v1 => v4
  | v4,v3,v1,v2 => v5
  | v4,v3,v1,v3 => v1
  | v4,v3,v1,v4 => v4
  | v4,v3,v1,v5 => v5
  | v4,v3,v1,v6 => v5
  | v4,v3,v2,v1 => v5
  | v4,v3,v2,v2 => v5
  | v4,v3,v2,v3 => v5
  | v4,v3,v2,v4 => v5
  | v4,v3,v2,v5 => v5
  | v4,v3,v2,v6 => v4
  | v4,v3,v3,v1 => v5
  | v4,v3,v3,v2 => v5
  | v4,v3,v3,v3 => v1
  | v4,v3,v3,v4 => v5
  | v4,v3,v3,v5 => v1
  | v4,v3,v3,v6 => v4
  | v4,v3,v4,v1 => v5
  | v4,v3,v4,v2 => v5
  | v4,v3,v4,v3 => v4
  | v4,v3,v4,v4 => v5
  | v4,v3,v4,v5 => v4
  | v4,v3,v4,v6 => v5
  | v4,v3,v5,v1 => v4
  | v4,v3,v5,v2 => v4
  | v4,v3,v5,v3 => v4
  | v4,v3,v5,v4 => v4
  | v4,v3,v5,v5 => v5
  | v4,v3,v5,v6 => v5
  | v4,v3,v6,v1 => v5
  | v4,v3,v6,v2 => v5
  | v4,v3,v6,v3 => v5
  | v4,v3,v6,v4 => v4
  | v4,v3,v6,v5 => v4
  | v4,v3,v6,v6 => v4
  | v4,v4,v1,v1 => v4
  | v4,v4,v1,v2 => v5
  | v4,v4,v1,v3 => v1
  | v4,v4,v1,v4 => v4
  | v4,v4,v1,v5 => v4
  | v4,v4,v1,v6 => v4
  | v4,v4,v2,v1 => v4
  | v4,v4,v2,v2 => v5
  | v4,v4,v2,v3 => v4
  | v4,v4,v2,v4 => v4
  | v4,v4,v2,v5 => v5
  | v4,v4,v2,v6 => v4
  | v4,v4,v3,v1 => v5
  | v4,v4,v3,v2 => v5
  | v4,v4,v3,v3 => v4
  | v4,v4,v3,v4 => v4
  | v4,v4,v3,v5 => v1
  | v4,v4,v3,v6 => v4
  | v4,v4,v4,v1 => v5
  | v4,v4,v4,v2 => v4
  | v4,v4,v4,v3 => v4
  | v4,v4,v4,v4 => v5
  | v4,v4,v4,v5 => v5
  | v4,v4,v4,v6 => v5
  | v4,v4,v5,v1 => v5
  | v4,v4,v5,v2 => v5
  | v4,v4,v5,v3 => v5
  | v4,v4,v5,v4 => v4
  | v4,v4,v5,v5 => v4
  | v4,v4,v5,v6 => v4
  | v4,v4,v6,v1 => v4
  | v4,v4,v6,v2 => v5
  | v4,v4,v6,v3 => v4
  | v4,v4,v6,v4 => v4
  | v4,v4,v6,v5 => v5
  | v4,v4,v6,v6 => v4
  | v4,v5,v1,v1 => v1
  | v4,v5,v1,v2 => v5
  | v4,v5,v1,v3 => v1
  | v4,v5,v1,v4 => v5
  | v4,v5,v1,v5 => v5
  | v4,v5,v1,v6 => v4
  | v4,v5,v2,v1 => v5
  | v4,v5,v2,v2 => v4
  | v4,v5,v2,v3 => v5
  | v4,v5,v2,v4 => v4
  | v4,v5,v2,v5 => v4
  | v4,v5,v2,v6 => v4
  | v4,v5,v3,v1 => v4
  | v4,v5,v3,v2 => v5
  | v4,v5,v3,v3 => v4
  | v4,v5,v3,v4 => v5
  | v4,v5,v3,v5 => v4
  | v4,v5,v3,v6 => v4
  | v4,v5,v4,v1 => v5
  | v4,v5,v4,v2 => v5
  | v4,v5,v4,v3 => v5
  | v4,v5,v4,v4 => v5
  | v4,v5,v4,v5 => v4
  | v4,v5,v4,v6 => v4
  | v4,v5,v5,v1 => v5
  | v4,v5,v5,v2 => v4
  | v4,v5,v5,v3 => v5
  | v4,v5,v5,v4 => v4
  | v4,v5,v5,v5 => v5
  | v4,v5,v5,v6 => v4
  | v4,v5,v6,v1 => v4
  | v4,v5,v6,v2 => v5
  | v4,v5,v6,v3 => v4
  | v4,v5,v6,v4 => v4
  | v4,v5,v6,v5 => v4
  | v4,v5,v6,v6 => v4
  | v4,v6,v1,v1 => v5
  | v4,v6,v1,v2 => v4
  | v4,v6,v1,v3 => v1
  | v4,v6,v1,v4 => v4
  | v4,v6,v1,v5 => v1
  | v4,v6,v1,v6 => v5
  | v4,v6,v2,v1 => v5
  | v4,v6,v2,v2 => v4
  | v4,v6,v2,v3 => v4
  | v4,v6,v2,v4 => v4
  | v4,v6,v2,v5 => v4
  | v4,v6,v2,v6 => v4
  | v4,v6,v3,v1 => v1
  | v4,v6,v3,v2 => v5
  | v4,v6,v3,v3 => v5
  | v4,v6,v3,v4 => v5
  | v4,v6,v3,v5 => v4
  | v4,v6,v3,v6 => v5
  | v4,v6,v4,v1 => v5
  | v4,v6,v4,v2 => v5
  | v4,v6,v4,v3 => v4
  | v4,v6,v4,v4 => v5
  | v4,v6,v4,v5 => v4
  | v4,v6,v4,v6 => v5
  | v4,v6,v5,v1 => v5
  | v4,v6,v5,v2 => v5
  | v4,v6,v5,v3 => v5
  | v4,v6,v5,v4 => v4
  | v4,v6,v5,v5 => v4
  | v4,v6,v5,v6 => v5
  | v4,v6,v6,v1 => v4
  | v4,v6,v6,v2 => v5
  | v4,v6,v6,v3 => v5
  | v4,v6,v6,v4 => v5
  | v4,v6,v6,v5 => v5
  | v4,v6,v6,v6 => v5
  | v5,v1,v1,v1 => v4
  | v5,v1,v1,v2 => v4
  | v5,v1,v1,v3 => v1
  | v5,v1,v1,v4 => v5
  | v5,v1,v1,v5 => v4
  | v5,v1,v1,v6 => v4
  | v5,v1,v2,v1 => v4
  | v5,v1,v2,v2 => v4
  | v5,v1,v2,v3 => v5
  | v5,v1,v2,v4 => v5
  | v5,v1,v2,v5 => v5
  | v5,v1,v2,v6 => v4
  | v5,v1,v3,v1 => v1
  | v5,v1,v3,v2 => v5
  | v5,v1,v3,v3 => v1
  | v5,v1,v3,v4 => v5
  | v5,v1,v3,v5 => v1
  | v5,v1,v3,v6 => v5
  | v5,v1,v4,v1 => v4
  | v5,v1,v4,v2 => v5
  | v5,v1,v4,v3 => v4
  | v5,v1,v4,v4 => v5
  | v5,v1,v4,v5 => v5
  | v5,v1,v4,v6 => v4
  | v5,v1,v5,v1 => v5
  | v5,v1,v5,v2 => v5
  | v5,v1,v5,v3 => v5
  | v5,v1,v5,v4 => v4
  | v5,v1,v5,v5 => v5
  | v5,v1,v5,v6 => v4
  | v5,v1,v6,v1 => v4
  | v5,v1,v6,v2 => v5
  | v5,v1,v6,v3 => v5
  | v5,v1,v6,v4 => v5
  | v5,v1,v6,v5 => v4
  | v5,v1,v6,v6 => v4
  | v5,v2,v1,v1 => v5
  | v5,v2,v1,v2 => v5
  | v5,v2,v1,v3 => v1
  | v5,v2,v1,v4 => v4
  | v5,v2,v1,v5 => v1
  | v5,v2,v1,v6 => v5
  | v5,v2,v2,v1 => v5
  | v5,v2,v2,v2 => v4
  | v5,v2,v2,v3 => v5
  | v5,v2,v2,v4 => v4
  | v5,v2,v2,v5 => v5
  | v5,v2,v2,v6 => v5
  | v5,v2,v3,v1 => v4
  | v5,v2,v3,v2 => v5
  | v5,v2,v3,v3 => v1
  | v5,v2,v3,v4 => v5
  | v5,v2,v3,v5 => v1
  | v5,v2,v3,v6 => v4
  | v5,v2,v4,v1 => v5
  | v5,v2,v4,v2 => v4
  | v5,v2,v4,v3 => v4
  | v5,v2,v4,v4 => v4
  | v5,v2,v4,v5 => v4
  | v5,v2,v4,v6 => v4
  | v5,v2,v5,v1 => v5
  | v5,v2,v5,v2 => v5
  | v5,v2,v5,v3 => v4
  | v5,v2,v5,v4 => v4
  | v5,v2,v5,v5 => v4
  | v5,v2,v5,v6 => v5
  | v5,v2,v6,v1 => v5
  | v5,v2,v6,v2 => v5
  | v5,v2,v6,v3 => v5
  | v5,v2,v6,v4 => v4
  | v5,v2,v6,v5 => v4
  | v5,v2,v6,v6 => v4
  | v5,v3,v1,v1 => v4
  | v5,v3,v1,v2 => v5
  | v5,v3,v1,v3 => v1
  | v5,v3,v1,v4 => v4
  | v5,v3,v1,v5 => v5
  | v5,v3,v1,v6 => v5
  | v5,v3,v2,v1 => v5
  | v5,v3,v2,v2 => v4
  | v5,v3,v2,v3 => v4
  | v5,v3,v2,v4 => v5
  | v5,v3,v2,v5 => v4
  | v5,v3,v2,v6 => v5
  | v5,v3,v3,v1 => v4
  | v5,v3,v3,v2 => v5
  | v5,v3,v3,v3 => v5
  | v5,v3,v3,v4 => v5
  | v5,v3,v3,v5 => v4
  | v5,v3,v3,v6 => v4
  | v5,v3,v4,v1 => v5
  | v5,v3,v4,v2 => v5
  | v5,v3,v4,v3 => v4
  | v5,v3,v4,v4 => v5
  | v5,v3,v4,v5 => v5
  | v5,v3,v4,v6 => v5
  | v5,v3,v5,v1 => v5
  | v5,v3,v5,v2 => v5
  | v5,v3,v5,v3 => v5
  | v5,v3,v5,v4 => v5
  | v5,v3,v5,v5 => v4
  | v5,v3,v5,v6 => v5
  | v5,v3,v6,v1 => v5
  | v5,v3,v6,v2 => v4
  | v5,v3,v6,v3 => v5
  | v5,v3,v6,v4 => v5
  | v5,v3,v6,v5 => v5
  | v5,v3,v6,v6 => v4
  | v5,v4,v1,v1 => v5
  | v5,v4,v1,v2 => v5
  | v5,v4,v1,v3 => v5
  | v5,v4,v1,v4 => v4
  | v5,v4,v1,v5 => v1
  | v5,v4,v1,v6 => v5
  | v5,v4,v2,v1 => v5
  | v5,v4,v2,v2 => v5
  | v5,v4,v2,v3 => v5
  | v5,v4,v2,v4 => v4
  | v5,v4,v2,v5 => v5
  | v5,v4,v2,v6 => v4
  | v5,v4,v3,v1 => v5
  | v5,v4,v3,v2 => v5
  | v5,v4,v3,v3 => v1
  | v5,v4,v3,v4 => v5
  | v5,v4,v3,v5 => v5
  | v5,v4,v3,v6 => v5
  | v5,v4,v4,v1 => v5
  | v5,v4,v4,v2 => v5
  | v5,v4,v4,v3 => v5
  | v5,v4,v4,v4 => v4
  | v5,v4,v4,v5 => v5
  | v5,v4,v4,v6 => v5
  | v5,v4,v5,v1 => v5
  | v5,v4,v5,v2 => v5
  | v5,v4,v5,v3 => v4
  | v5,v4,v5,v4 => v4
  | v5,v4,v5,v5 => v4
  | v5,v4,v5,v6 => v4
  | v5,v4,v6,v1 => v4
  | v5,v4,v6,v2 => v5
  | v5,v4,v6,v3 => v5
  | v5,v4,v6,v4 => v4
  | v5,v4,v6,v5 => v5
  | v5,v4,v6,v6 => v4
  | v5,v5,v1,v1 => v1
  | v5,v5,v1,v2 => v4
  | v5,v5,v1,v3 => v4
  | v5,v5,v1,v4 => v4
  | v5,v5,v1,v5 => v5
  | v5,v5,v1,v6 => v5
  | v5,v5,v2,v1 => v5
  | v5,v5,v2,v2 => v5
  | v5,v5,v2,v3 => v4
  | v5,v5,v2,v4 => v5
  | v5,v5,v2,v5 => v5
  | v5,v5,v2,v6 => v5
  | v5,v5,v3,v1 => v5
  | v5,v5,v3,v2 => v4
  | v5,v5,v3,v3 => v1
  | v5,v5,v3,v4 => v5
  | v5,v5,v3,v5 => v4
  | v5,v5,v3,v6 => v5
  | v5,v5,v4,v1 => v5
  | v5,v5,v4,v2 => v4
  | v5,v5,v4,v3 => v5
  | v5,v5,v4,v4 => v5
  | v5,v5,v4,v5 => v4
  | v5,v5,v4,v6 => v5
  | v5,v5,v5,v1 => v4
  | v5,v5,v5,v2 => v5
  | v5,v5,v5,v3 => v5
  | v5,v5,v5,v4 => v5
  | v5,v5,v5,v5 => v5
  | v5,v5,v5,v6 => v5
  | v5,v5,v6,v1 => v4
  | v5,v5,v6,v2 => v4
  | v5,v5,v6,v3 => v5
  | v5,v5,v6,v4 => v5
  | v5,v5,v6,v5 => v5
  | v5,v5,v6,v6 => v4
  | v5,v6,v1,v1 => v5
  | v5,v6,v1,v2 => v4
  | v5,v6,v1,v3 => v5
  | v5,v6,v1,v4 => v5
  | v5,v6,v1,v5 => v4
  | v5,v6,v1,v6 => v5
  | v5,v6,v2,v1 => v5
  | v5,v6,v2,v2 => v4
  | v5,v6,v2,v3 => v4
  | v5,v6,v2,v4 => v5
  | v5,v6,v2,v5 => v4
  | v5,v6,v2,v6 => v4
  | v5,v6,v3,v1 => v1
  | v5,v6,v3,v2 => v5
  | v5,v6,v3,v3 => v4
  | v5,v6,v3,v4 => v4
  | v5,v6,v3,v5 => v1
  | v5,v6,v3,v6 => v5
  | v5,v6,v4,v1 => v5
  | v5,v6,v4,v2 => v5
  | v5,v6,v4,v3 => v5
  | v5,v6,v4,v4 => v4
  | v5,v6,v4,v5 => v4
  | v5,v6,v4,v6 => v5
  | v5,v6,v5,v1 => v5
  | v5,v6,v5,v2 => v4
  | v5,v6,v5,v3 => v5
  | v5,v6,v5,v4 => v5
  | v5,v6,v5,v5 => v5
  | v5,v6,v5,v6 => v4
  | v5,v6,v6,v1 => v5
  | v5,v6,v6,v2 => v4
  | v5,v6,v6,v3 => v5
  | v5,v6,v6,v4 => v5
  | v5,v6,v6,v5 => v4
  | v5,v6,v6,v6 => v5
  | v6,v1,v1,v1 => v4
  | v6,v1,v1,v2 => v4
  | v6,v1,v1,v3 => v4
  | v6,v1,v1,v4 => v4
  | v6,v1,v1,v5 => v1
  | v6,v1,v1,v6 => v5
  | v6,v1,v2,v1 => v4
  | v6,v1,v2,v2 => v5
  | v6,v1,v2,v3 => v4
  | v6,v1,v2,v4 => v4
  | v6,v1,v2,v5 => v4
  | v6,v1,v2,v6 => v5
  | v6,v1,v3,v1 => v5
  | v6,v1,v3,v2 => v5
  | v6,v1,v3,v3 => v1
  | v6,v1,v3,v4 => v4
  | v6,v1,v3,v5 => v1
  | v6,v1,v3,v6 => v4
  | v6,v1,v4,v1 => v5
  | v6,v1,v4,v2 => v5
  | v6,v1,v4,v3 => v5
  | v6,v1,v4,v4 => v5
  | v6,v1,v4,v5 => v4
  | v6,v1,v4,v6 => v5
  | v6,v1,v5,v1 => v4
  | v6,v1,v5,v2 => v4
  | v6,v1,v5,v3 => v5
  | v6,v1,v5,v4 => v5
  | v6,v1,v5,v5 => v4
  | v6,v1,v5,v6 => v4
  | v6,v1,v6,v1 => v5
  | v6,v1,v6,v2 => v5
  | v6,v1,v6,v3 => v5
  | v6,v1,v6,v4 => v4
  | v6,v1,v6,v5 => v4
  | v6,v1,v6,v6 => v4
  | v6,v2,v1,v1 => v4
  | v6,v2,v1,v2 => v4
  | v6,v2,v1,v3 => v1
  | v6,v2,v1,v4 => v4
  | v6,v2,v1,v5 => v1
  | v6,v2,v1,v6 => v5
  | v6,v2,v2,v1 => v5
  | v6,v2,v2,v2 => v5
  | v6,v2,v2,v3 => v5
  | v6,v2,v2,v4 => v5
  | v6,v2,v2,v5 => v5
  | v6,v2,v2,v6 => v5
  | v6,v2,v3,v1 => v4
  | v6,v2,v3,v2 => v5
  | v6,v2,v3,v3 => v1
  | v6,v2,v3,v4 => v4
  | v6,v2,v3,v5 => v1
  | v6,v2,v3,v6 => v4
  | v6,v2,v4,v1 => v4
  | v6,v2,v4,v2 => v5
  | v6,v2,v4,v3 => v5
  | v6,v2,v4,v4 => v4
  | v6,v2,v4,v5 => v4
  | v6,v2,v4,v6 => v5
  | v6,v2,v5,v1 => v4
  | v6,v2,v5,v2 => v5
  | v6,v2,v5,v3 => v4
  | v6,v2,v5,v4 => v4
  | v6,v2,v5,v5 => v5
  | v6,v2,v5,v6 => v5
  | v6,v2,v6,v1 => v4
  | v6,v2,v6,v2 => v4
  | v6,v2,v6,v3 => v4
  | v6,v2,v6,v4 => v4
  | v6,v2,v6,v5 => v5
  | v6,v2,v6,v6 => v4
  | v6,v3,v1,v1 => v5
  | v6,v3,v1,v2 => v5
  | v6,v3,v1,v3 => v4
  | v6,v3,v1,v4 => v4
  | v6,v3,v1,v5 => v1
  | v6,v3,v1,v6 => v4
  | v6,v3,v2,v1 => v5
  | v6,v3,v2,v2 => v4
  | v6,v3,v2,v3 => v5
  | v6,v3,v2,v4 => v4
  | v6,v3,v2,v5 => v4
  | v6,v3,v2,v6 => v4
  | v6,v3,v3,v1 => v4
  | v6,v3,v3,v2 => v4
  | v6,v3,v3,v3 => v4
  | v6,v3,v3,v4 => v5
  | v6,v3,v3,v5 => v5
  | v6,v3,v3,v6 => v4
  | v6,v3,v4,v1 => v5
  | v6,v3,v4,v2 => v5
  | v6,v3,v4,v3 => v5
  | v6,v3,v4,v4 => v5
  | v6,v3,v4,v5 => v5
  | v6,v3,v4,v6 => v5
  | v6,v3,v5,v1 => v5
  | v6,v3,v5,v2 => v5
  | v6,v3,v5,v3 => v5
  | v6,v3,v5,v4 => v5
  | v6,v3,v5,v5 => v5
  | v6,v3,v5,v6 => v4
  | v6,v3,v6,v1 => v5
  | v6,v3,v6,v2 => v4
  | v6,v3,v6,v3 => v5
  | v6,v3,v6,v4 => v4
  | v6,v3,v6,v5 => v4
  | v6,v3,v6,v6 => v4
  | v6,v4,v1,v1 => v4
  | v6,v4,v1,v2 => v5
  | v6,v4,v1,v3 => v1
  | v6,v4,v1,v4 => v4
  | v6,v4,v1,v5 => v1
  | v6,v4,v1,v6 => v4
  | v6,v4,v2,v1 => v4
  | v6,v4,v2,v2 => v5
  | v6,v4,v2,v3 => v5
  | v6,v4,v2,v4 => v4
  | v6,v4,v2,v5 => v5
  | v6,v4,v2,v6 => v4
  | v6,v4,v3,v1 => v1
  | v6,v4,v3,v2 => v5
  | v6,v4,v3,v3 => v1
  | v6,v4,v3,v4 => v5
  | v6,v4,v3,v5 => v5
  | v6,v4,v3,v6 => v4
  | v6,v4,v4,v1 => v5
  | v6,v4,v4,v2 => v4
  | v6,v4,v4,v3 => v4
  | v6,v4,v4,v4 => v5
  | v6,v4,v4,v5 => v4
  | v6,v4,v4,v6 => v4
  | v6,v4,v5,v1 => v5
  | v6,v4,v5,v2 => v4
  | v6,v4,v5,v3 => v4
  | v6,v4,v5,v4 => v5
  | v6,v4,v5,v5 => v5
  | v6,v4,v5,v6 => v5
  | v6,v4,v6,v1 => v4
  | v6,v4,v6,v2 => v5
  | v6,v4,v6,v3 => v5
  | v6,v4,v6,v4 => v4
  | v6,v4,v6,v5 => v5
  | v6,v4,v6,v6 => v5
  | v6,v5,v1,v1 => v4
  | v6,v5,v1,v2 => v5
  | v6,v5,v1,v3 => v5
  | v6,v5,v1,v4 => v5
  | v6,v5,v1,v5 => v5
  | v6,v5,v1,v6 => v4
  | v6,v5,v2,v1 => v5
  | v6,v5,v2,v2 => v5
  | v6,v5,v2,v3 => v5
  | v6,v5,v2,v4 => v4
  | v6,v5,v2,v5 => v4
  | v6,v5,v2,v6 => v5
  | v6,v5,v3,v1 => v5
  | v6,v5,v3,v2 => v4
  | v6,v5,v3,v3 => v1
  | v6,v5,v3,v4 => v5
  | v6,v5,v3,v5 => v1
  | v6,v5,v3,v6 => v4
  | v6,v5,v4,v1 => v5
  | v6,v5,v4,v2 => v5
  | v6,v5,v4,v3 => v5
  | v6,v5,v4,v4 => v5
  | v6,v5,v4,v5 => v4
  | v6,v5,v4,v6 => v4
  | v6,v5,v5,v1 => v4
  | v6,v5,v5,v2 => v5
  | v6,v5,v5,v3 => v4
  | v6,v5,v5,v4 => v5
  | v6,v5,v5,v5 => v4
  | v6,v5,v5,v6 => v4
  | v6,v5,v6,v1 => v4
  | v6,v5,v6,v2 => v5
  | v6,v5,v6,v3 => v5
  | v6,v5,v6,v4 => v5
  | v6,v5,v6,v5 => v5
  | v6,v5,v6,v6 => v5
  | v6,v6,v1,v1 => v4
  | v6,v6,v1,v2 => v4
  | v6,v6,v1,v3 => v5
  | v6,v6,v1,v4 => v5
  | v6,v6,v1,v5 => v4
  | v6,v6,v1,v6 => v4
  | v6,v6,v2,v1 => v4
  | v6,v6,v2,v2 => v5
  | v6,v6,v2,v3 => v5
  | v6,v6,v2,v4 => v5
  | v6,v6,v2,v5 => v4
  | v6,v6,v2,v6 => v5
  | v6,v6,v3,v1 => v1
  | v6,v6,v3,v2 => v5
  | v6,v6,v3,v3 => v1
  | v6,v6,v3,v4 => v4
  | v6,v6,v3,v5 => v1
  | v6,v6,v3,v6 => v5
  | v6,v6,v4,v1 => v5
  | v6,v6,v4,v2 => v5
  | v6,v6,v4,v3 => v4
  | v6,v6,v4,v4 => v4
  | v6,v6,v4,v5 => v5
  | v6,v6,v4,v6 => v5
  | v6,v6,v5,v1 => v5
  | v6,v6,v5,v2 => v5
  | v6,v6,v5,v3 => v5
  | v6,v6,v5,v4 => v4
  | v6,v6,v5,v5 => v5
  | v6,v6,v5,v6 => v4
  | v6,v6,v6,v1 => v4
  | v6,v6,v6,v2 => v5
  | v6,v6,v6,v3 => v5
  | v6,v6,v6,v4 => v4
  | v6,v6,v6,v5 => v5
  | v6,v6,v6,v6 => v5
  end.
Definition session_old (x1 x2 x3 x4 : val) : val :=
  match x1,x2,x3,x4 with
    v1,v1,v1,v1 => v6
  | v1,v1,v1,v2 => v6
  | v1,v1,v1,v3 => v6
  | v1,v1,v1,v4 => v6
  | v1,v1,v1,v5 => v6
  | v1,v1,v1,v6 => v6
  | v1,v1,v2,v1 => v3
  | v1,v1,v2,v2 => v6
  | v1,v1,v2,v3 => v3
  | v1,v1,v2,v4 => v6
  | v1,v1,v2,v5 => v6
  | v1,v1,v2,v6 => v3
  | v1,v1,v3,v1 => v6
  | v1,v1,v3,v2 => v6
  | v1,v1,v3,v3 => v3
  | v1,v1,v3,v4 => v3
  | v1,v1,v3,v5 => v6
  | v1,v1,v3,v6 => v6
  | v1,v1,v4,v1 => v3
  | v1,v1,v4,v2 => v3
  | v1,v1,v4,v3 => v6
  | v1,v1,v4,v4 => v6
  | v1,v1,v4,v5 => v6
  | v1,v1,v4,v6 => v6
  | v1,v1,v5,v1 => v6
  | v1,v1,v5,v2 => v3
  | v1,v1,v5,v3 => v6
  | v1,v1,v5,v4 => v3
  | v1,v1,v5,v5 => v6
  | v1,v1,v5,v6 => v6
  | v1,v1,v6,v1 => v3
  | v1,v1,v6,v2 => v3
  | v1,v1,v6,v3 => v6
  | v1,v1,v6,v4 => v6
  | v1,v1,v6,v5 => v3
  | v1,v1,v6,v6 => v3
  | v1,v2,v1,v1 => v6
  | v1,v2,v1,v2 => v6
  | v1,v2,v1,v3 => v6
  | v1,v2,v1,v4 => v6
  | v1,v2,v1,v5 => v6
  | v1,v2,v1,v6 => v6
  | v1,v2,v2,v1 => v6
  | v1,v2,v2,v2 => v6
  | v1,v2,v2,v3 => v6
  | v1,v2,v2,v4 => v3
  | v1,v2,v2,v5 => v3
  | v1,v2,v2,v6 => v3
  | v1,v2,v3,v1 => v3
  | v1,v2,v3,v2 => v6
  | v1,v2,v3,v3 => v6
  | v1,v2,v3,v4 => v3
  | v1,v2,v3,v5 => v3
  | v1,v2,v3,v6 => v3
  | v1,v2,v4,v1 => v3
  | v1,v2,v4,v2 => v6
  | v1,v2,v4,v3 => v3
  | v1,v2,v4,v4 => v3
  | v1,v2,v4,v5 => v3
  | v1,v2,v4,v6 => v3
  | v1,v2,v5,v1 => v6
  | v1,v2,v5,v2 => v6
  | v1,v2,v5,v3 => v6
  | v1,v2,v5,v4 => v3
  | v1,v2,v5,v5 => v6
  | v1,v2,v5,v6 => v6
  | v1,v2,v6,v1 => v6
  | v1,v2,v6,v2 => v6
  | v1,v2,v6,v3 => v6
  | v1,v2,v6,v4 => v6
  | v1,v2,v6,v5 => v6
  | v1,v2,v6,v6 => v3
  | v1,v3,v1,v1 => v6
  | v1,v3,v1,v2 => v6
  | v1,v3,v1,v3 => v3
  | v1,v3,v1,v4 => v3
  | v1,v3,v1,v5 => v6
  | v1,v3,v1,v6 => v6
  | v1,v3,v2,v1 => v6
  | v1,v3,v2,v2 => v6
  | v1,v3,v2,v3 => v6
  | v1,v3,v2,v4 => v3
  | v1,v3,v2,v5 => v6
  | v1,v3,v2,v6 => v6
  | v1,v3,v3,v1 => v3
  | v1,v3,v3,v2 => v3
  | v1,v3,v3,v3 => v6
  | v1,v3,v3,v4 => v6
  | v1,v3,v3,v5 => v6
  | v1,v3,v3,v6 => v6
  | v1,v3,v4,v1 => v3
  | v1,v3,v4,v2 => v6
  | v1,v3,v4,v3 => v3
  | v1,v3,v4,v4 => v6
  | v1,v3,v4,v5 => v3
  | v1,v3,v4,v6 => v3
  | v1,v3,v5,v1 => v3
  | v1,v3,v5,v2 => v3
  | v1,v3,v5,v3 => v6
  | v1,v3,v5,v4 => v3
  | v1,v3,v5,v5 => v6
  | v1,v3,v5,v6 => v6
  | v1,v3,v6,v1 => v3
  | v1,v3,v6,v2 => v3
  | v1,v3,v6,v3 => v6
  | v1,v3,v6,v4 => v3
  | v1,v3,v6,v5 => v3
  | v1,v3,v6,v6 => v3
  | v1,v4,v1,v1 => v6
  | v1,v4,v1,v2 => v3
  | v1,v4,v1,v3 => v6
  | v1,v4,v1,v4 => v3
  | v1,v4,v1,v5 => v3
  | v1,v4,v1,v6 => v6
  | v1,v4,v2,v1 => v6
  | v1,v4,v2,v2 => v6
  | v1,v4,v2,v3 => v6
  | v1,v4,v2,v4 => v3
  | v1,v4,v2,v5 => v6
  | v1,v4,v2,v6 => v6
  | v1,v4,v3,v1 => v3
  | v1,v4,v3,v2 => v6
  | v1,v4,v3,v3 => v6
  | v1,v4,v3,v4 => v6
  | v1,v4,v3,v5 => v3
  | v1,v4,v3,v6 => v6
  | v1,v4,v4,v1 => v6
  | v1,v4,v4,v2 => v6
  | v1,v4,v4,v3 => v6
  | v1,v4,v4,v4 => v6
  | v1,v4,v4,v5 => v6
  | v1,v4,v4,v6 => v3
  | v1,v4,v5,v1 => v6
  | v1,v4,v5,v2 => v3
  | v1,v4,v5,v3 => v3
  | v1,v4,v5,v4 => v6
  | v1,v4,v5,v5 => v3
  | v1,v4,v5,v6 => v6
  | v1,v4,v6,v1 => v6
  | v1,v4,v6,v2 => v3
  | v1,v4,v6,v3 => v3
  | v1,v4,v6,v4 => v6
  | v1,v4,v6,v5 => v3
  | v1,v4,v6,v6 => v6
  | v1,v5,v1,v1 => v6
  | v1,v5,v1,v2 => v6
  | v1,v5,v1,v3 => v6
  | v1,v5,v1,v4 => v6
  | v1,v5,v1,v5 => v6
  | v1,v5,v1,v6 => v3
  | v1,v5,v2,v1 => v6
  | v1,v5,v2,v2 => v6
  | v1,v5,v2,v3 => v3
  | v1,v5,v2,v4 => v6
  | v1,v5,v2,v5 => v3
  | v1,v5,v2,v6 => v6
  | v1,v5,v3,v1 => v3
  | v1,v5,v3,v2 => v6
  | v1,v5,v3,v3 => v3
  | v1,v5,v3,v4 => v3
  | v1,v5,v3,v5 => v6
  | v1,v5,v3,v6 => v6
  | v1,v5,v4,v1 => v6
  | v1,v5,v4,v2 => v6
  | v1,v5,v4,v3 => v6
  | v1,v5,v4,v4 => v3
  | v1,v5,v4,v5 => v6
  | v1,v5,v4,v6 => v6
  | v1,v5,v5,v1 => v6
  | v1,v5,v5,v2 => v6
  | v1,v5,v5,v3 => v3
  | v1,v5,v5,v4 => v6
  | v1,v5,v5,v5 => v6
  | v1,v5,v5,v6 => v3
  | v1,v5,v6,v1 => v6
  | v1,v5,v6,v2 => v3
  | v1,v5,v6,v3 => v6
  | v1,v5,v6,v4 => v6
  | v1,v5,v6,v5 => v3
  | v1,v5,v6,v6 => v3
  | v1,v6,v1,v1 => v3
  | v1,v6,v1,v2 => v6
  | v1,v6,v1,v3 => v3
  | v1,v6,v1,v4 => v3
  | v1,v6,v1,v5 => v3
  | v1,v6,v1,v6 => v6
  | v1,v6,v2,v1 => v3
  | v1,v6,v2,v2 => v3
  | v1,v6,v2,v3 => v6
  | v1,v6,v2,v4 => v6
  | v1,v6,v2,v5 => v6
  | v1,v6,v2,v6 => v6
  | v1,v6,v3,v1 => v3
  | v1,v6,v3,v2 => v3
  | v1,v6,v3,v3 => v3
  | v1,v6,v3,v4 => v6
  | v1,v6,v3,v5 => v6
  | v1,v6,v3,v6 => v3
  | v1,v6,v4,v1 => v3
  | v1,v6,v4,v2 => v6
  | v1,v6,v4,v3 => v3
  | v1,v6,v4,v4 => v6
  | v1,v6,v4,v5 => v3
  | v1,v6,v4,v6 => v6
  | v1,v6,v5,v1 => v3
  | v1,v6,v5,v2 => v3
  | v1,v6,v5,v3 => v6
  | v1,v6,v5,v4 => v6
  | v1,v6,v5,v5 => v6
  | v1,v6,v5,v6 => v3
  | v1,v6,v6,v1 => v3
  | v1,v6,v6,v2 => v6
  | v1,v6,v6,v3 => v3
  | v1,v6,v6,v4 => v3
  | v1,v6,v6,v5 => v6
  | v1,v6,v6,v6 => v3
  | v2,v1,v1,v1 => v6
  | v2,v1,v1,v2 => v6
  | v2,v1,v1,v3 => v6
  | v2,v1,v1,v4 => v6
  | v2,v1,v1,v5 => v3
  | v2,v1,v1,v6 => v6
  | v2,v1,v2,v1 => v3
  | v2,v1,v2,v2 => v6
  | v2,v1,v2,v3 => v3
  | v2,v1,v2,v4 => v3
  | v2,v1,v2,v5 => v3
  | v2,v1,v2,v6 => v6
  | v2,v1,v3,v1 => v3
  | v2,v1,v3,v2 => v3
  | v2,v1,v3,v3 => v3
  | v2,v1,v3,v4 => v3
  | v2,v1,v3,v5 => v6
  | v2,v1,v3,v6 => v3
  | v2,v1,v4,v1 => v3
  | v2,v1,v4,v2 => v6
  | v2,v1,v4,v3 => v3
  | v2,v1,v4,v4 => v3
  | v2,v1,v4,v5 => v6
  | v2,v1,v4,v6 => v3
  | v2,v1,v5,v1 => v6
  | v2,v1,v5,v2 => v3
  | v2,v1,v5,v3 => v6
  | v2,v1,v5,v4 => v3
  | v2,v1,v5,v5 => v3
  | v2,v1,v5,v6 => v6
  | v2,v1,v6,v1 => v3
  | v2,v1,v6,v2 => v6
  | v2,v1,v6,v3 => v6
  | v2,v1,v6,v4 => v6
  | v2,v1,v6,v5 => v3
  | v2,v1,v6,v6 => v6
  | v2,v2,v1,v1 => v3
  | v2,v2,v1,v2 => v3
  | v2,v2,v1,v3 => v3
  | v2,v2,v1,v4 => v3
  | v2,v2,v1,v5 => v3
  | v2,v2,v1,v6 => v6
  | v2,v2,v2,v1 => v6
  | v2,v2,v2,v2 => v3
  | v2,v2,v2,v3 => v3
  | v2,v2,v2,v4 => v3
  | v2,v2,v2,v5 => v6
  | v2,v2,v2,v6 => v6
  | v2,v2,v3,v1 => v3
  | v2,v2,v3,v2 => v6
  | v2,v2,v3,v3 => v6
  | v2,v2,v3,v4 => v3
  | v2,v2,v3,v5 => v6
  | v2,v2,v3,v6 => v6
  | v2,v2,v4,v1 => v6
  | v2,v2,v4,v2 => v3
  | v2,v2,v4,v3 => v3
  | v2,v2,v4,v4 => v3
  | v2,v2,v4,v5 => v6
  | v2,v2,v4,v6 => v6
  | v2,v2,v5,v1 => v6
  | v2,v2,v5,v2 => v3
  | v2,v2,v5,v3 => v3
  | v2,v2,v5,v4 => v6
  | v2,v2,v5,v5 => v3
  | v2,v2,v5,v6 => v6
  | v2,v2,v6,v1 => v3
  | v2,v2,v6,v2 => v3
  | v2,v2,v6,v3 => v3
  | v2,v2,v6,v4 => v6
  | v2,v2,v6,v5 => v6
  | v2,v2,v6,v6 => v3
  | v2,v3,v1,v1 => v3
  | v2,v3,v1,v2 => v3
  | v2,v3,v1,v3 => v3
  | v2,v3,v1,v4 => v6
  | v2,v3,v1,v5 => v6
  | v2,v3,v1,v6 => v6
  | v2,v3,v2,v1 => v3
  | v2,v3,v2,v2 => v3
  | v2,v3,v2,v3 => v6
  | v2,v3,v2,v4 => v3
  | v2,v3,v2,v5 => v6
  | v2,v3,v2,v6 => v6
  | v2,v3,v3,v1 => v6
  | v2,v3,v3,v2 => v3
  | v2,v3,v3,v3 => v6
  | v2,v3,v3,v4 => v6
  | v2,v3,v3,v5 => v3
  | v2,v3,v3,v6 => v3
  | v2,v3,v4,v1 => v6
  | v2,v3,v4,v2 => v3
  | v2,v3,v4,v3 => v6
  | v2,v3,v4,v4 => v3
  | v2,v3,v4,v5 => v3
  | v2,v3,v4,v6 => v3
  | v2,v3,v5,v1 => v6
  | v2,v3,v5,v2 => v3
  | v2,v3,v5,v3 => v6
  | v2,v3,v5,v4 => v6
  | v2,v3,v5,v5 => v6
  | v2,v3,v5,v6 => v6
  | v2,v3,v6,v1 => v6
  | v2,v3,v6,v2 => v6
  | v2,v3,v6,v3 => v6
  | v2,v3,v6,v4 => v6
  | v2,v3,v6,v5 => v3
  | v2,v3,v6,v6 => v3
  | v2,v4,v1,v1 => v6
  | v2,v4,v1,v2 => v3
  | v2,v4,v1,v3 => v3
  | v2,v4,v1,v4 => v3
  | v2,v4,v1,v5 => v6
  | v2,v4,v1,v6 => v3
  | v2,v4,v2,v1 => v3
  | v2,v4,v2,v2 => v3
  | v2,v4,v2,v3 => v3
  | v2,v4,v2,v4 => v3
  | v2,v4,v2,v5 => v3
  | v2,v4,v2,v6 => v6
  | v2,v4,v3,v1 => v3
  | v2,v4,v3,v2 => v3
  | v2,v4,v3,v3 => v3
  | v2,v4,v3,v4 => v6
  | v2,v4,v3,v5 => v3
  | v2,v4,v3,v6 => v3
  | v2,v4,v4,v1 => v6
  | v2,v4,v4,v2 => v6
  | v2,v4,v4,v3 => v3
  | v2,v4,v4,v4 => v3
  | v2,v4,v4,v5 => v6
  | v2,v4,v4,v6 => v6
  | v2,v4,v5,v1 => v3
  | v2,v4,v5,v2 => v6
  | v2,v4,v5,v3 => v3
  | v2,v4,v5,v4 => v6
  | v2,v4,v5,v5 => v3
  | v2,v4,v5,v6 => v3
  | v2,v4,v6,v1 => v3
  | v2,v4,v6,v2 => v6
  | v2,v4,v6,v3 => v6
  | v2,v4,v6,v4 => v6
  | v2,v4,v6,v5 => v6
  | v2,v4,v6,v6 => v3
  | v2,v5,v1,v1 => v3
  | v2,v5,v1,v2 => v3
  | v2,v5,v1,v3 => v3
  | v2,v5,v1,v4 => v6
  | v2,v5,v1,v5 => v6
  | v2,v5,v1,v6 => v3
  | v2,v5,v2,v1 => v6
  | v2,v5,v2,v2 => v6
  | v2,v5,v2,v3 => v6
  | v2,v5,v2,v4 => v6
  | v2,v5,v2,v5 => v3
  | v2,v5,v2,v6 => v6
  | v2,v5,v3,v1 => v6
  | v2,v5,v3,v2 => v6
  | v2,v5,v3,v3 => v3
  | v2,v5,v3,v4 => v3
  | v2,v5,v3,v5 => v3
  | v2,v5,v3,v6 => v3
  | v2,v5,v4,v1 => v6
  | v2,v5,v4,v2 => v6
  | v2,v5,v4,v3 => v6
  | v2,v5,v4,v4 => v3
  | v2,v5,v4,v5 => v6
  | v2,v5,v4,v6 => v6
  | v2,v5,v5,v1 => v3
  | v2,v5,v5,v2 => v3
  | v2,v5,v5,v3 => v6
  | v2,v5,v5,v4 => v3
  | v2,v5,v5,v5 => v6
  | v2,v5,v5,v6 => v6
  | v2,v5,v6,v1 => v6
  | v2,v5,v6,v2 => v3
  | v2,v5,v6,v3 => v3
  | v2,v5,v6,v4 => v3
  | v2,v5,v6,v5 => v6
  | v2,v5,v6,v6 => v6
  | v2,v6,v1,v1 => v3
  | v2,v6,v1,v2 => v6
  | v2,v6,v1,v3 => v3
  | v2,v6,v1,v4 => v6
  | v2,v6,v1,v5 => v3
  | v2,v6,v1,v6 => v6
  | v2,v6,v2,v1 => v3
  | v2,v6,v2,v2 => v6
  | v2,v6,v2,v3 => v6
  | v2,v6,v2,v4 => v6
  | v2,v6,v2,v5 => v6
  | v2,v6,v2,v6 => v6
  | v2,v6,v3,v1 => v3
  | v2,v6,v3,v2 => v3
  | v2,v6,v3,v3 => v6
  | v2,v6,v3,v4 => v6
  | v2,v6,v3,v5 => v6
  | v2,v6,v3,v6 => v6
  | v2,v6,v4,v1 => v3
  | v2,v6,v4,v2 => v3
  | v2,v6,v4,v3 => v6
  | v2,v6,v4,v4 => v3
  | v2,v6,v4,v5 => v6
  | v2,v6,v4,v6 => v3
  | v2,v6,v5,v1 => v3
  | v2,v6,v5,v2 => v3
  | v2,v6,v5,v3 => v6
  | v2,v6,v5,v4 => v3
  | v2,v6,v5,v5 => v3
  | v2,v6,v5,v6 => v3
  | v2,v6,v6,v1 => v3
  | v2,v6,v6,v2 => v6
  | v2,v6,v6,v3 => v3
  | v2,v6,v6,v4 => v6
  | v2,v6,v6,v5 => v3
  | v2,v6,v6,v6 => v6
  | v3,v1,v1,v1 => v6
  | v3,v1,v1,v2 => v6
  | v3,v1,v1,v3 => v6
  | v3,v1,v1,v4 => v6
  | v3,v1,v1,v5 => v6
  | v3,v1,v1,v6 => v6
  | v3,v1,v2,v1 => v6
  | v3,v1,v2,v2 => v6
  | v3,v1,v2,v3 => v6
  | v3,v1,v2,v4 => v6
  | v3,v1,v2,v5 => v6
  | v3,v1,v2,v6 => v6
  | v3,v1,v3,v1 => v3
  | v3,v1,v3,v2 => v6
  | v3,v1,v3,v3 => v6
  | v3,v1,v3,v4 => v6
  | v3,v1,v3,v5 => v6
  | v3,v1,v3,v6 => v6
  | v3,v1,v4,v1 => v6
  | v3,v1,v4,v2 => v3
  | v3,v1,v4,v3 => v3
  | v3,v1,v4,v4 => v6
  | v3,v1,v4,v5 => v3
  | v3,v1,v4,v6 => v3
  | v3,v1,v5,v1 => v6
  | v3,v1,v5,v2 => v6
  | v3,v1,v5,v3 => v6
  | v3,v1,v5,v4 => v3
  | v3,v1,v5,v5 => v3
  | v3,v1,v5,v6 => v3
  | v3,v1,v6,v1 => v6
  | v3,v1,v6,v2 => v6
  | v3,v1,v6,v3 => v3
  | v3,v1,v6,v4 => v6
  | v3,v1,v6,v5 => v3
  | v3,v1,v6,v6 => v3
  | v3,v2,v1,v1 => v6
  | v3,v2,v1,v2 => v6
  | v3,v2,v1,v3 => v6
  | v3,v2,v1,v4 => v6
  | v3,v2,v1,v5 => v6
  | v3,v2,v1,v6 => v6
  | v3,v2,v2,v1 => v6
  | v3,v2,v2,v2 => v3
  | v3,v2,v2,v3 => v3
  | v3,v2,v2,v4 => v6
  | v3,v2,v2,v5 => v3
  | v3,v2,v2,v6 => v6
  | v3,v2,v3,v1 => v6
  | v3,v2,v3,v2 => v3
  | v3,v2,v3,v3 => v3
  | v3,v2,v3,v4 => v6
  | v3,v2,v3,v5 => v6
  | v3,v2,v3,v6 => v6
  | v3,v2,v4,v1 => v6
  | v3,v2,v4,v2 => v3
  | v3,v2,v4,v3 => v3
  | v3,v2,v4,v4 => v6
  | v3,v2,v4,v5 => v6
  | v3,v2,v4,v6 => v3
  | v3,v2,v5,v1 => v3
  | v3,v2,v5,v2 => v6
  | v3,v2,v5,v3 => v6
  | v3,v2,v5,v4 => v6
  | v3,v2,v5,v5 => v3
  | v3,v2,v5,v6 => v3
  | v3,v2,v6,v1 => v3
  | v3,v2,v6,v2 => v6
  | v3,v2,v6,v3 => v3
  | v3,v2,v6,v4 => v6
  | v3,v2,v6,v5 => v3
  | v3,v2,v6,v6 => v6
  | v3,v3,v1,v1 => v6
  | v3,v3,v1,v2 => v6
  | v3,v3,v1,v3 => v6
  | v3,v3,v1,v4 => v3
  | v3,v3,v1,v5 => v6
  | v3,v3,v1,v6 => v6
  | v3,v3,v2,v1 => v6
  | v3,v3,v2,v2 => v6
  | v3,v3,v2,v3 => v3
  | v3,v3,v2,v4 => v6
  | v3,v3,v2,v5 => v3
  | v3,v3,v2,v6 => v3
  | v3,v3,v3,v1 => v6
  | v3,v3,v3,v2 => v6
  | v3,v3,v3,v3 => v3
  | v3,v3,v3,v4 => v3
  | v3,v3,v3,v5 => v3
  | v3,v3,v3,v6 => v6
  | v3,v3,v4,v1 => v3
  | v3,v3,v4,v2 => v6
  | v3,v3,v4,v3 => v3
  | v3,v3,v4,v4 => v3
  | v3,v3,v4,v5 => v6
  | v3,v3,v4,v6 => v6
  | v3,v3,v5,v1 => v6
  | v3,v3,v5,v2 => v3
  | v3,v3,v5,v3 => v6
  | v3,v3,v5,v4 => v6
  | v3,v3,v5,v5 => v6
  | v3,v3,v5,v6 => v3
  | v3,v3,v6,v1 => v6
  | v3,v3,v6,v2 => v3
  | v3,v3,v6,v3 => v3
  | v3,v3,v6,v4 => v6
  | v3,v3,v6,v5 => v3
  | v3,v3,v6,v6 => v6
  | v3,v4,v1,v1 => v6
  | v3,v4,v1,v2 => v6
  | v3,v4,v1,v3 => v6
  | v3,v4,v1,v4 => v6
  | v3,v4,v1,v5 => v6
  | v3,v4,v1,v6 => v6
  | v3,v4,v2,v1 => v3
  | v3,v4,v2,v2 => v3
  | v3,v4,v2,v3 => v3
  | v3,v4,v2,v4 => v6
  | v3,v4,v2,v5 => v6
  | v3,v4,v2,v6 => v6
  | v3,v4,v3,v1 => v6
  | v3,v4,v3,v2 => v3
  | v3,v4,v3,v3 => v3
  | v3,v4,v3,v4 => v6
  | v3,v4,v3,v5 => v6
  | v3,v4,v3,v6 => v6
  | v3,v4,v4,v1 => v6
  | v3,v4,v4,v2 => v6
  | v3,v4,v4,v3 => v3
  | v3,v4,v4,v4 => v3
  | v3,v4,v4,v5 => v3
  | v3,v4,v4,v6 => v3
  | v3,v4,v5,v1 => v6
  | v3,v4,v5,v2 => v6
  | v3,v4,v5,v3 => v6
  | v3,v4,v5,v4 => v6
  | v3,v4,v5,v5 => v3
  | v3,v4,v5,v6 => v3
  | v3,v4,v6,v1 => v3
  | v3,v4,v6,v2 => v6
  | v3,v4,v6,v3 => v3
  | v3,v4,v6,v4 => v6
  | v3,v4,v6,v5 => v6
  | v3,v4,v6,v6 => v3
  | v3,v5,v1,v1 => v6
  | v3,v5,v1,v2 => v3
  | v3,v5,v1,v3 => v6
  | v3,v5,v1,v4 => v6
  | v3,v5,v1,v5 => v6
  | v3,v5,v1,v6 => v3
  | v3,v5,v2,v1 => v6
  | v3,v5,v2,v2 => v6
  | v3,v5,v2,v3 => v6
  | v3,v5,v2,v4 => v3
  | v3,v5,v2,v5 => v3
  | v3,v5,v2,v6 => v6
  | v3,v5,v3,v1 => v6
  | v3,v5,v3,v2 => v6
  | v3,v5,v3,v3 => v6
  | v3,v5,v3,v4 => v6
  | v3,v5,v3,v5 => v3
  | v3,v5,v3,v6 => v6
  | v3,v5,v4,v1 => v6
  | v3,v5,v4,v2 => v6
  | v3,v5,v4,v3 => v6
  | v3,v5,v4,v4 => v6
  | v3,v5,v4,v5 => v6
  | v3,v5,v4,v6 => v6
  | v3,v5,v5,v1 => v6
  | v3,v5,v5,v2 => v3
  | v3,v5,v5,v3 => v6
  | v3,v5,v5,v4 => v3
  | v3,v5,v5,v5 => v6
  | v3,v5,v5,v6 => v6
  | v3,v5,v6,v1 => v6
  | v3,v5,v6,v2 => v6
  | v3,v5,v6,v3 => v3
  | v3,v5,v6,v4 => v3
  | v3,v5,v6,v5 => v6
  | v3,v5,v6,v6 => v6
  | v3,v6,v1,v1 => v6
  | v3,v6,v1,v2 => v6
  | v3,v6,v1,v3 => v6
  | v3,v6,v1,v4 => v6
  | v3,v6,v1,v5 => v6
  | v3,v6,v1,v6 => v6
  | v3,v6,v2,v1 => v6
  | v3,v6,v2,v2 => v3
  | v3,v6,v2,v3 => v6
  | v3,v6,v2,v4 => v6
  | v3,v6,v2,v5 => v6
  | v3,v6,v2,v6 => v6
  | v3,v6,v3,v1 => v6
  | v3,v6,v3,v2 => v3
  | v3,v6,v3,v3 => v6
  | v3,v6,v3,v4 => v6
  | v3,v6,v3,v5 => v3
  | v3,v6,v3,v6 => v6
  | v3,v6,v4,v1 => v3
  | v3,v6,v4,v2 => v3
  | v3,v6,v4,v3 => v3
  | v3,v6,v4,v4 => v3
  | v3,v6,v4,v5 => v6
  | v3,v6,v4,v6 => v6
  | v3,v6,v5,v1 => v6
  | v3,v6,v5,v2 => v6
  | v3,v6,v5,v3 => v6
  | v3,v6,v5,v4 => v6
  | v3,v6,v5,v5 => v6
  | v3,v6,v5,v6 => v3
  | v3,v6,v6,v1 => v3
  | v3,v6,v6,v2 => v6
  | v3,v6,v6,v3 => v6
  | v3,v6,v6,v4 => v6
  | v3,v6,v6,v5 => v3
  | v3,v6,v6,v6 => v3
  | v4,v1,v1,v1 => v6
  | v4,v1,v1,v2 => v3
  | v4,v1,v1,v3 => v6
  | v4,v1,v1,v4 => v3
  | v4,v1,v1,v5 => v6
  | v4,v1,v1,v6 => v3
  | v4,v1,v2,v1 => v3
  | v4,v1,v2,v2 => v6
  | v4,v1,v2,v3 => v6
  | v4,v1,v2,v4 => v6
  | v4,v1,v2,v5 => v6
  | v4,v1,v2,v6 => v3
  | v4,v1,v3,v1 => v6
  | v4,v1,v3,v2 => v3
  | v4,v1,v3,v3 => v3
  | v4,v1,v3,v4 => v6
  | v4,v1,v3,v5 => v3
  | v4,v1,v3,v6 => v6
  | v4,v1,v4,v1 => v6
  | v4,v1,v4,v2 => v3
  | v4,v1,v4,v3 => v6
  | v4,v1,v4,v4 => v6
  | v4,v1,v4,v5 => v6
  | v4,v1,v4,v6 => v6
  | v4,v1,v5,v1 => v6
  | v4,v1,v5,v2 => v3
  | v4,v1,v5,v3 => v6
  | v4,v1,v5,v4 => v6
  | v4,v1,v5,v5 => v6
  | v4,v1,v5,v6 => v3
  | v4,v1,v6,v1 => v3
  | v4,v1,v6,v2 => v3
  | v4,v1,v6,v3 => v3
  | v4,v1,v6,v4 => v3
  | v4,v1,v6,v5 => v6
  | v4,v1,v6,v6 => v6
  | v4,v2,v1,v1 => v6
  | v4,v2,v1,v2 => v6
  | v4,v2,v1,v3 => v6
  | v4,v2,v1,v4 => v3
  | v4,v2,v1,v5 => v3
  | v4,v2,v1,v6 => v6
  | v4,v2,v2,v1 => v3
  | v4,v2,v2,v2 => v3
  | v4,v2,v2,v3 => v6
  | v4,v2,v2,v4 => v3
  | v4,v2,v2,v5 => v6
  | v4,v2,v2,v6 => v6
  | v4,v2,v3,v1 => v3
  | v4,v2,v3,v2 => v3
  | v4,v2,v3,v3 => v6
  | v4,v2,v3,v4 => v3
  | v4,v2,v3,v5 => v3
  | v4,v2,v3,v6 => v3
  | v4,v2,v4,v1 => v3
  | v4,v2,v4,v2 => v6
  | v4,v2,v4,v3 => v6
  | v4,v2,v4,v4 => v6
  | v4,v2,v4,v5 => v3
  | v4,v2,v4,v6 => v3
  | v4,v2,v5,v1 => v3
  | v4,v2,v5,v2 => v6
  | v4,v2,v5,v3 => v3
  | v4,v2,v5,v4 => v6
  | v4,v2,v5,v5 => v6
  | v4,v2,v5,v6 => v6
  | v4,v2,v6,v1 => v6
  | v4,v2,v6,v2 => v6
  | v4,v2,v6,v3 => v6
  | v4,v2,v6,v4 => v6
  | v4,v2,v6,v5 => v3
  | v4,v2,v6,v6 => v3
  | v4,v3,v1,v1 => v6
  | v4,v3,v1,v2 => v6
  | v4,v3,v1,v3 => v6
  | v4,v3,v1,v4 => v6
  | v4,v3,v1,v5 => v6
  | v4,v3,v1,v6 => v3
  | v4,v3,v2,v1 => v3
  | v4,v3,v2,v2 => v3
  | v4,v3,v2,v3 => v6
  | v4,v3,v2,v4 => v3
  | v4,v3,v2,v5 => v3
  | v4,v3,v2,v6 => v6
  | v4,v3,v3,v1 => v3
  | v4,v3,v3,v2 => v6
  | v4,v3,v3,v3 => v3
  | v4,v3,v3,v4 => v6
  | v4,v3,v3,v5 => v6
  | v4,v3,v3,v6 => v3
  | v4,v3,v4,v1 => v6
  | v4,v3,v4,v2 => v6
  | v4,v3,v4,v3 => v6
  | v4,v3,v4,v4 => v6
  | v4,v3,v4,v5 => v6
  | v4,v3,v4,v6 => v6
  | v4,v3,v5,v1 => v3
  | v4,v3,v5,v2 => v6
  | v4,v3,v5,v3 => v6
  | v4,v3,v5,v4 => v3
  | v4,v3,v5,v5 => v3
  | v4,v3,v5,v6 => v3
  | v4,v3,v6,v1 => v3
  | v4,v3,v6,v2 => v6
  | v4,v3,v6,v3 => v3
  | v4,v3,v6,v4 => v3
  | v4,v3,v6,v5 => v6
  | v4,v3,v6,v6 => v3
  | v4,v4,v1,v1 => v3
  | v4,v4,v1,v2 => v6
  | v4,v4,v1,v3 => v6
  | v4,v4,v1,v4 => v3
  | v4,v4,v1,v5 => v6
  | v4,v4,v1,v6 => v3
  | v4,v4,v2,v1 => v3
  | v4,v4,v2,v2 => v6
  | v4,v4,v2,v3 => v6
  | v4,v4,v2,v4 => v6
  | v4,v4,v2,v5 => v6
  | v4,v4,v2,v6 => v6
  | v4,v4,v3,v1 => v6
  | v4,v4,v3,v2 => v6
  | v4,v4,v3,v3 => v6
  | v4,v4,v3,v4 => v6
  | v4,v4,v3,v5 => v3
  | v4,v4,v3,v6 => v6
  | v4,v4,v4,v1 => v3
  | v4,v4,v4,v2 => v6
  | v4,v4,v4,v3 => v6
  | v4,v4,v4,v4 => v3
  | v4,v4,v4,v5 => v6
  | v4,v4,v4,v6 => v6
  | v4,v4,v5,v1 => v3
  | v4,v4,v5,v2 => v6
  | v4,v4,v5,v3 => v3
  | v4,v4,v5,v4 => v3
  | v4,v4,v5,v5 => v6
  | v4,v4,v5,v6 => v3
  | v4,v4,v6,v1 => v6
  | v4,v4,v6,v2 => v3
  | v4,v4,v6,v3 => v3
  | v4,v4,v6,v4 => v3
  | v4,v4,v6,v5 => v6
  | v4,v4,v6,v6 => v3
  | v4,v5,v1,v1 => v6
  | v4,v5,v1,v2 => v6
  | v4,v5,v1,v3 => v6
  | v4,v5,v1,v4 => v3
  | v4,v5,v1,v5 => v3
  | v4,v5,v1,v6 => v3
  | v4,v5,v2,v1 => v3
  | v4,v5,v2,v2 => v3
  | v4,v5,v2,v3 => v3
  | v4,v5,v2,v4 => v6
  | v4,v5,v2,v5 => v6
  | v4,v5,v2,v6 => v3
  | v4,v5,v3,v1 => v3
  | v4,v5,v3,v2 => v3
  | v4,v5,v3,v3 => v3
  | v4,v5,v3,v4 => v3
  | v4,v5,v3,v5 => v6
  | v4,v5,v3,v6 => v6
  | v4,v5,v4,v1 => v3
  | v4,v5,v4,v2 => v6
  | v4,v5,v4,v3 => v3
  | v4,v5,v4,v4 => v6
  | v4,v5,v4,v5 => v6
  | v4,v5,v4,v6 => v6
  | v4,v5,v5,v1 => v6
  | v4,v5,v5,v2 => v3
  | v4,v5,v5,v3 => v6
  | v4,v5,v5,v4 => v3
  | v4,v5,v5,v5 => v6
  | v4,v5,v5,v6 => v3
  | v4,v5,v6,v1 => v6
  | v4,v5,v6,v2 => v6
  | v4,v5,v6,v3 => v6
  | v4,v5,v6,v4 => v3
  | v4,v5,v6,v5 => v6
  | v4,v5,v6,v6 => v6
  | v4,v6,v1,v1 => v3
  | v4,v6,v1,v2 => v6
  | v4,v6,v1,v3 => v3
  | v4,v6,v1,v4 => v6
  | v4,v6,v1,v5 => v6
  | v4,v6,v1,v6 => v3
  | v4,v6,v2,v1 => v3
  | v4,v6,v2,v2 => v3
  | v4,v6,v2,v3 => v3
  | v4,v6,v2,v4 => v6
  | v4,v6,v2,v5 => v6
  | v4,v6,v2,v6 => v6
  | v4,v6,v3,v1 => v3
  | v4,v6,v3,v2 => v6
  | v4,v6,v3,v3 => v3
  | v4,v6,v3,v4 => v6
  | v4,v6,v3,v5 => v3
  | v4,v6,v3,v6 => v6
  | v4,v6,v4,v1 => v3
  | v4,v6,v4,v2 => v3
  | v4,v6,v4,v3 => v3
  | v4,v6,v4,v4 => v3
  | v4,v6,v4,v5 => v3
  | v4,v6,v4,v6 => v3
  | v4,v6,v5,v1 => v3
  | v4,v6,v5,v2 => v6
  | v4,v6,v5,v3 => v3
  | v4,v6,v5,v4 => v3
  | v4,v6,v5,v5 => v3
  | v4,v6,v5,v6 => v3
  | v4,v6,v6,v1 => v3
  | v4,v6,v6,v2 => v3
  | v4,v6,v6,v3 => v3
  | v4,v6,v6,v4 => v6
  | v4,v6,v6,v5 => v3
  | v4,v6,v6,v6 => v3
  | v5,v1,v1,v1 => v6
  | v5,v1,v1,v2 => v6
  | v5,v1,v1,v3 => v6
  | v5,v1,v1,v4 => v6
  | v5,v1,v1,v5 => v6
  | v5,v1,v1,v6 => v6
  | v5,v1,v2,v1 => v6
  | v5,v1,v2,v2 => v3
  | v5,v1,v2,v3 => v6
  | v5,v1,v2,v4 => v3
  | v5,v1,v2,v5 => v3
  | v5,v1,v2,v6 => v6
  | v5,v1,v3,v1 => v6
  | v5,v1,v3,v2 => v3
  | v5,v1,v3,v3 => v3
  | v5,v1,v3,v4 => v3
  | v5,v1,v3,v5 => v6
  | v5,v1,v3,v6 => v6
  | v5,v1,v4,v1 => v6
  | v5,v1,v4,v2 => v3
  | v5,v1,v4,v3 => v3
  | v5,v1,v4,v4 => v6
  | v5,v1,v4,v5 => v6
  | v5,v1,v4,v6 => v3
  | v5,v1,v5,v1 => v6
  | v5,v1,v5,v2 => v6
  | v5,v1,v5,v3 => v3
  | v5,v1,v5,v4 => v6
  | v5,v1,v5,v5 => v3
  | v5,v1,v5,v6 => v6
  | v5,v1,v6,v1 => v6
  | v5,v1,v6,v2 => v3
  | v5,v1,v6,v3 => v3
  | v5,v1,v6,v4 => v6
  | v5,v1,v6,v5 => v6
  | v5,v1,v6,v6 => v3
  | v5,v2,v1,v1 => v6
  | v5,v2,v1,v2 => v6
  | v5,v2,v1,v3 => v6
  | v5,v2,v1,v4 => v6
  | v5,v2,v1,v5 => v6
  | v5,v2,v1,v6 => v6
  | v5,v2,v2,v1 => v6
  | v5,v2,v2,v2 => v6
  | v5,v2,v2,v3 => v3
  | v5,v2,v2,v4 => v6
  | v5,v2,v2,v5 => v3
  | v5,v2,v2,v6 => v6
  | v5,v2,v3,v1 => v3
  | v5,v2,v3,v2 => v3
  | v5,v2,v3,v3 => v3
  | v5,v2,v3,v4 => v3
  | v5,v2,v3,v5 => v3
  | v5,v2,v3,v6 => v3
  | v5,v2,v4,v1 => v3
  | v5,v2,v4,v2 => v6
  | v5,v2,v4,v3 => v6
  | v5,v2,v4,v4 => v3
  | v5,v2,v4,v5 => v3
  | v5,v2,v4,v6 => v6
  | v5,v2,v5,v1 => v6
  | v5,v2,v5,v2 => v6
  | v5,v2,v5,v3 => v6
  | v5,v2,v5,v4 => v3
  | v5,v2,v5,v5 => v3
  | v5,v2,v5,v6 => v6
  | v5,v2,v6,v1 => v6
  | v5,v2,v6,v2 => v6
  | v5,v2,v6,v3 => v6
  | v5,v2,v6,v4 => v6
  | v5,v2,v6,v5 => v6
  | v5,v2,v6,v6 => v3
  | v5,v3,v1,v1 => v3
  | v5,v3,v1,v2 => v6
  | v5,v3,v1,v3 => v6
  | v5,v3,v1,v4 => v3
  | v5,v3,v1,v5 => v6
  | v5,v3,v1,v6 => v6
  | v5,v3,v2,v1 => v3
  | v5,v3,v2,v2 => v3
  | v5,v3,v2,v3 => v6
  | v5,v3,v2,v4 => v3
  | v5,v3,v2,v5 => v3
  | v5,v3,v2,v6 => v6
  | v5,v3,v3,v1 => v6
  | v5,v3,v3,v2 => v6
  | v5,v3,v3,v3 => v6
  | v5,v3,v3,v4 => v6
  | v5,v3,v3,v5 => v6
  | v5,v3,v3,v6 => v3
  | v5,v3,v4,v1 => v6
  | v5,v3,v4,v2 => v6
  | v5,v3,v4,v3 => v6
  | v5,v3,v4,v4 => v3
  | v5,v3,v4,v5 => v6
  | v5,v3,v4,v6 => v6
  | v5,v3,v5,v1 => v3
  | v5,v3,v5,v2 => v3
  | v5,v3,v5,v3 => v3
  | v5,v3,v5,v4 => v6
  | v5,v3,v5,v5 => v6
  | v5,v3,v5,v6 => v6
  | v5,v3,v6,v1 => v3
  | v5,v3,v6,v2 => v3
  | v5,v3,v6,v3 => v6
  | v5,v3,v6,v4 => v6
  | v5,v3,v6,v5 => v6
  | v5,v3,v6,v6 => v6
  | v5,v4,v1,v1 => v6
  | v5,v4,v1,v2 => v6
  | v5,v4,v1,v3 => v6
  | v5,v4,v1,v4 => v6
  | v5,v4,v1,v5 => v6
  | v5,v4,v1,v6 => v6
  | v5,v4,v2,v1 => v3
  | v5,v4,v2,v2 => v3
  | v5,v4,v2,v3 => v3
  | v5,v4,v2,v4 => v6
  | v5,v4,v2,v5 => v3
  | v5,v4,v2,v6 => v6
  | v5,v4,v3,v1 => v3
  | v5,v4,v3,v2 => v6
  | v5,v4,v3,v3 => v6
  | v5,v4,v3,v4 => v6
  | v5,v4,v3,v5 => v6
  | v5,v4,v3,v6 => v6
  | v5,v4,v4,v1 => v3
  | v5,v4,v4,v2 => v6
  | v5,v4,v4,v3 => v3
  | v5,v4,v4,v4 => v3
  | v5,v4,v4,v5 => v3
  | v5,v4,v4,v6 => v6
  | v5,v4,v5,v1 => v3
  | v5,v4,v5,v2 => v3
  | v5,v4,v5,v3 => v6
  | v5,v4,v5,v4 => v3
  | v5,v4,v5,v5 => v6
  | v5,v4,v5,v6 => v3
  | v5,v4,v6,v1 => v6
  | v5,v4,v6,v2 => v3
  | v5,v4,v6,v3 => v3
  | v5,v4,v6,v4 => v3
  | v5,v4,v6,v5 => v3
  | v5,v4,v6,v6 => v3
  | v5,v5,v1,v1 => v6
  | v5,v5,v1,v2 => v6
  | v5,v5,v1,v3 => v6
  | v5,v5,v1,v4 => v6
  | v5,v5,v1,v5 => v6
  | v5,v5,v1,v6 => v3
  | v5,v5,v2,v1 => v3
  | v5,v5,v2,v2 => v3
  | v5,v5,v2,v3 => v6
  | v5,v5,v2,v4 => v6
  | v5,v5,v2,v5 => v3
  | v5,v5,v2,v6 => v6
  | v5,v5,v3,v1 => v3
  | v5,v5,v3,v2 => v6
  | v5,v5,v3,v3 => v3
  | v5,v5,v3,v4 => v3
  | v5,v5,v3,v5 => v3
  | v5,v5,v3,v6 => v6
  | v5,v5,v4,v1 => v3
  | v5,v5,v4,v2 => v6
  | v5,v5,v4,v3 => v3
  | v5,v5,v4,v4 => v6
  | v5,v5,v4,v5 => v6
  | v5,v5,v4,v6 => v6
  | v5,v5,v5,v1 => v6
  | v5,v5,v5,v2 => v6
  | v5,v5,v5,v3 => v6
  | v5,v5,v5,v4 => v3
  | v5,v5,v5,v5 => v3
  | v5,v5,v5,v6 => v3
  | v5,v5,v6,v1 => v6
  | v5,v5,v6,v2 => v3
  | v5,v5,v6,v3 => v6
  | v5,v5,v6,v4 => v6
  | v5,v5,v6,v5 => v6
  | v5,v5,v6,v6 => v3
  | v5,v6,v1,v1 => v6
  | v5,v6,v1,v2 => v6
  | v5,v6,v1,v3 => v6
  | v5,v6,v1,v4 => v6
  | v5,v6,v1,v5 => v6
  | v5,v6,v1,v6 => v6
  | v5,v6,v2,v1 => v3
  | v5,v6,v2,v2 => v3
  | v5,v6,v2,v3 => v6
  | v5,v6,v2,v4 => v6
  | v5,v6,v2,v5 => v6
  | v5,v6,v2,v6 => v6
  | v5,v6,v3,v1 => v3
  | v5,v6,v3,v2 => v3
  | v5,v6,v3,v3 => v6
  | v5,v6,v3,v4 => v6
  | v5,v6,v3,v5 => v3
  | v5,v6,v3,v6 => v6
  | v5,v6,v4,v1 => v3
  | v5,v6,v4,v2 => v6
  | v5,v6,v4,v3 => v6
  | v5,v6,v4,v4 => v6
  | v5,v6,v4,v5 => v3
  | v5,v6,v4,v6 => v6
  | v5,v6,v5,v1 => v6
  | v5,v6,v5,v2 => v6
  | v5,v6,v5,v3 => v6
  | v5,v6,v5,v4 => v3
  | v5,v6,v5,v5 => v3
  | v5,v6,v5,v6 => v6
  | v5,v6,v6,v1 => v6
  | v5,v6,v6,v2 => v6
  | v5,v6,v6,v3 => v6
  | v5,v6,v6,v4 => v6
  | v5,v6,v6,v5 => v6
  | v5,v6,v6,v6 => v6
  | v6,v1,v1,v1 => v6
  | v6,v1,v1,v2 => v6
  | v6,v1,v1,v3 => v3
  | v6,v1,v1,v4 => v6
  | v6,v1,v1,v5 => v3
  | v6,v1,v1,v6 => v6
  | v6,v1,v2,v1 => v6
  | v6,v1,v2,v2 => v3
  | v6,v1,v2,v3 => v6
  | v6,v1,v2,v4 => v3
  | v6,v1,v2,v5 => v6
  | v6,v1,v2,v6 => v6
  | v6,v1,v3,v1 => v3
  | v6,v1,v3,v2 => v6
  | v6,v1,v3,v3 => v6
  | v6,v1,v3,v4 => v3
  | v6,v1,v3,v5 => v6
  | v6,v1,v3,v6 => v6
  | v6,v1,v4,v1 => v3
  | v6,v1,v4,v2 => v6
  | v6,v1,v4,v3 => v3
  | v6,v1,v4,v4 => v6
  | v6,v1,v4,v5 => v3
  | v6,v1,v4,v6 => v6
  | v6,v1,v5,v1 => v6
  | v6,v1,v5,v2 => v3
  | v6,v1,v5,v3 => v3
  | v6,v1,v5,v4 => v6
  | v6,v1,v5,v5 => v6
  | v6,v1,v5,v6 => v6
  | v6,v1,v6,v1 => v3
  | v6,v1,v6,v2 => v3
  | v6,v1,v6,v3 => v3
  | v6,v1,v6,v4 => v6
  | v6,v1,v6,v5 => v6
  | v6,v1,v6,v6 => v6
  | v6,v2,v1,v1 => v3
  | v6,v2,v1,v2 => v3
  | v6,v2,v1,v3 => v3
  | v6,v2,v1,v4 => v3
  | v6,v2,v1,v5 => v6
  | v6,v2,v1,v6 => v6
  | v6,v2,v2,v1 => v3
  | v6,v2,v2,v2 => v3
  | v6,v2,v2,v3 => v6
  | v6,v2,v2,v4 => v6
  | v6,v2,v2,v5 => v6
  | v6,v2,v2,v6 => v3
  | v6,v2,v3,v1 => v3
  | v6,v2,v3,v2 => v6
  | v6,v2,v3,v3 => v6
  | v6,v2,v3,v4 => v6
  | v6,v2,v3,v5 => v6
  | v6,v2,v3,v6 => v3
  | v6,v2,v4,v1 => v3
  | v6,v2,v4,v2 => v3
  | v6,v2,v4,v3 => v3
  | v6,v2,v4,v4 => v6
  | v6,v2,v4,v5 => v3
  | v6,v2,v4,v6 => v3
  | v6,v2,v5,v1 => v6
  | v6,v2,v5,v2 => v3
  | v6,v2,v5,v3 => v6
  | v6,v2,v5,v4 => v3
  | v6,v2,v5,v5 => v6
  | v6,v2,v5,v6 => v6
  | v6,v2,v6,v1 => v6
  | v6,v2,v6,v2 => v6
  | v6,v2,v6,v3 => v6
  | v6,v2,v6,v4 => v6
  | v6,v2,v6,v5 => v3
  | v6,v2,v6,v6 => v6
  | v6,v3,v1,v1 => v6
  | v6,v3,v1,v2 => v3
  | v6,v3,v1,v3 => v3
  | v6,v3,v1,v4 => v3
  | v6,v3,v1,v5 => v6
  | v6,v3,v1,v6 => v6
  | v6,v3,v2,v1 => v3
  | v6,v3,v2,v2 => v3
  | v6,v3,v2,v3 => v3
  | v6,v3,v2,v4 => v6
  | v6,v3,v2,v5 => v3
  | v6,v3,v2,v6 => v3
  | v6,v3,v3,v1 => v6
  | v6,v3,v3,v2 => v3
  | v6,v3,v3,v3 => v3
  | v6,v3,v3,v4 => v3
  | v6,v3,v3,v5 => v3
  | v6,v3,v3,v6 => v6
  | v6,v3,v4,v1 => v6
  | v6,v3,v4,v2 => v6
  | v6,v3,v4,v3 => v3
  | v6,v3,v4,v4 => v3
  | v6,v3,v4,v5 => v3
  | v6,v3,v4,v6 => v3
  | v6,v3,v5,v1 => v3
  | v6,v3,v5,v2 => v3
  | v6,v3,v5,v3 => v6
  | v6,v3,v5,v4 => v3
  | v6,v3,v5,v5 => v6
  | v6,v3,v5,v6 => v3
  | v6,v3,v6,v1 => v3
  | v6,v3,v6,v2 => v3
  | v6,v3,v6,v3 => v3
  | v6,v3,v6,v4 => v6
  | v6,v3,v6,v5 => v3
  | v6,v3,v6,v6 => v3
  | v6,v4,v1,v1 => v6
  | v6,v4,v1,v2 => v6
  | v6,v4,v1,v3 => v6
  | v6,v4,v1,v4 => v6
  | v6,v4,v1,v5 => v3
  | v6,v4,v1,v6 => v6
  | v6,v4,v2,v1 => v6
  | v6,v4,v2,v2 => v3
  | v6,v4,v2,v3 => v6
  | v6,v4,v2,v4 => v3
  | v6,v4,v2,v5 => v6
  | v6,v4,v2,v6 => v6
  | v6,v4,v3,v1 => v6
  | v6,v4,v3,v2 => v6
  | v6,v4,v3,v3 => v6
  | v6,v4,v3,v4 => v3
  | v6,v4,v3,v5 => v3
  | v6,v4,v3,v6 => v3
  | v6,v4,v4,v1 => v6
  | v6,v4,v4,v2 => v6
  | v6,v4,v4,v3 => v6
  | v6,v4,v4,v4 => v6
  | v6,v4,v4,v5 => v6
  | v6,v4,v4,v6 => v3
  | v6,v4,v5,v1 => v3
  | v6,v4,v5,v2 => v3
  | v6,v4,v5,v3 => v3
  | v6,v4,v5,v4 => v6
  | v6,v4,v5,v5 => v3
  | v6,v4,v5,v6 => v6
  | v6,v4,v6,v1 => v6
  | v6,v4,v6,v2 => v6
  | v6,v4,v6,v3 => v6
  | v6,v4,v6,v4 => v6
  | v6,v4,v6,v5 => v3
  | v6,v4,v6,v6 => v3
  | v6,v5,v1,v1 => v3
  | v6,v5,v1,v2 => v6
  | v6,v5,v1,v3 => v6
  | v6,v5,v1,v4 => v6
  | v6,v5,v1,v5 => v3
  | v6,v5,v1,v6 => v3
  | v6,v5,v2,v1 => v3
  | v6,v5,v2,v2 => v6
  | v6,v5,v2,v3 => v6
  | v6,v5,v2,v4 => v6
  | v6,v5,v2,v5 => v3
  | v6,v5,v2,v6 => v3
  | v6,v5,v3,v1 => v6
  | v6,v5,v3,v2 => v6
  | v6,v5,v3,v3 => v3
  | v6,v5,v3,v4 => v3
  | v6,v5,v3,v5 => v3
  | v6,v5,v3,v6 => v6
  | v6,v5,v4,v1 => v6
  | v6,v5,v4,v2 => v3
  | v6,v5,v4,v3 => v3
  | v6,v5,v4,v4 => v6
  | v6,v5,v4,v5 => v3
  | v6,v5,v4,v6 => v3
  | v6,v5,v5,v1 => v3
  | v6,v5,v5,v2 => v3
  | v6,v5,v5,v3 => v3
  | v6,v5,v5,v4 => v3
  | v6,v5,v5,v5 => v6
  | v6,v5,v5,v6 => v6
  | v6,v5,v6,v1 => v6
  | v6,v5,v6,v2 => v3
  | v6,v5,v6,v3 => v6
  | v6,v5,v6,v4 => v6
  | v6,v5,v6,v5 => v6
  | v6,v5,v6,v6 => v6
  | v6,v6,v1,v1 => v3
  | v6,v6,v1,v2 => v3
  | v6,v6,v1,v3 => v6
  | v6,v6,v1,v4 => v6
  | v6,v6,v1,v5 => v6
  | v6,v6,v1,v6 => v3
  | v6,v6,v2,v1 => v3
  | v6,v6,v2,v2 => v6
  | v6,v6,v2,v3 => v3
  | v6,v6,v2,v4 => v3
  | v6,v6,v2,v5 => v3
  | v6,v6,v2,v6 => v3
  | v6,v6,v3,v1 => v3
  | v6,v6,v3,v2 => v3
  | v6,v6,v3,v3 => v3
  | v6,v6,v3,v4 => v6
  | v6,v6,v3,v5 => v6
  | v6,v6,v3,v6 => v3
  | v6,v6,v4,v1 => v3
  | v6,v6,v4,v2 => v3
  | v6,v6,v4,v3 => v3
  | v6,v6,v4,v4 => v6
  | v6,v6,v4,v5 => v3
  | v6,v6,v4,v6 => v6
  | v6,v6,v5,v1 => v3
  | v6,v6,v5,v2 => v6
  | v6,v6,v5,v3 => v3
  | v6,v6,v5,v4 => v3
  | v6,v6,v5,v5 => v3
  | v6,v6,v5,v6 => v6
  | v6,v6,v6,v1 => v3
  | v6,v6,v6,v2 => v3
  | v6,v6,v6,v3 => v6
  | v6,v6,v6,v4 => v6
  | v6,v6,v6,v5 => v6
  | v6,v6,v6,v6 => v3
  end.

Definition sym : val := v2.

Lemma lem_alice_agent : auto_agent alice.
Proof.
  simpl; trivial.
Qed.

Lemma lem_bob_agent : auto_agent bob.
Proof.
  simpl; trivial.
Qed.

Lemma lem_server_agent : auto_agent server.
Proof.
  simpl; trivial.
Qed.

Lemma lem_intruder_agent : auto_agent i.
Proof.
  simpl; trivial.
Qed.

Lemma lem_intruder_knows_nil_old : auto_knows_old nil.
Proof.
  simpl; trivial.
Qed.

Lemma lem_intruder_can_take_first_components_old :
  forall _big_m1 _big_m2:val,
    auto_knows_old (cons _big_m1 _big_m2) -> auto_knows_old _big_m1.
Proof.
  intro _big_m1; case _big_m1; intro _big_m2; case _big_m2; simpl; trivial.
Qed.

Lemma lem_intruder_can_take_second_components_old :
  forall _big_m1 _big_m2:val,
    auto_knows_old (cons _big_m1 _big_m2) -> auto_knows_old _big_m2.
Proof.
  intro _big_m1; case _big_m1; intro _big_m2; case _big_m2; simpl; trivial.
Qed.

Lemma lem_intruder_can_build_pairs_old :
  forall _big_m1 _big_m2:val,
    auto_knows_old _big_m1 -> auto_knows_old _big_m2 -> auto_knows_old (cons _big_m1 _big_m2).
Proof.
  intro _big_m1; case _big_m1; intro _big_m2; case _big_m2; simpl; trivial.
Qed.

Lemma lem_intruder_can_encrypt_old :
  forall _big_k _big_m:val,
    auto_knows_old _big_m -> auto_knows_old _big_k -> auto_knows_old (crypt _big_m _big_k).
Proof.
  intro _big_k; case _big_k; intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_can_decrypt_if_has_private_key_old :
  forall _big_k _big_m:val,
    auto_knows_old (crypt _big_m (key pub _big_k))
     -> auto_knows_old (key prv _big_k)
     -> auto_knows_old _big_m.
Proof.
  intro _big_k; case _big_k; intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_can_decrypt_if_has_public_key_old :
  forall _big_k _big_m:val,
    auto_knows_old (crypt _big_m (key prv _big_k))
    -> auto_knows_old (key pub _big_k)
    -> auto_knows_old _big_m.
Proof.
  intro _big_k; case _big_k; intro _big_m; case _big_m; simpl; try red; trivial.
Qed.

Lemma lem_intruder_can_decrypt_if_has_symmetric_key_old : forall _big_m X:val, auto_knows_old (crypt _big_m (key sym X)) -> auto_knows_old (key sym X) -> auto_knows_old _big_m.
Proof.
  intro _big_m; case _big_m; intro X; case X; simpl; trivial.
Qed.

Lemma lem_intruder_can_compute_successors_old : forall _big_m:val, auto_knows_old _big_m -> auto_knows_old (s _big_m).
Proof.
  intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_can_compute_predecessors_old : forall _big_m:val, auto_knows_old (s _big_m) -> auto_knows_old _big_m.
Proof.
  intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_message1_old : forall _big_a:val, auto_agent _big_a -> auto_knows_old (cons _big_a (cons (noncea_old  _big_a) nil)).
Proof.
  intro _big_a; case _big_a; simpl; try red; trivial.
Qed.

Lemma lem_message2_old : forall _big_a _big_b _big_na:val, auto_agent _big_b -> auto_knows_old (cons _big_a (cons _big_na nil)) -> auto_knows_old (cons _big_b (cons (nonceb_old _big_a _big_b _big_na) (cons (crypt (cons _big_a (cons _big_na nil)) (key sym (cons _big_b (cons server nil)))) nil))).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_na; case _big_na; simpl; try red; trivial.
Qed.

Lemma lem_message3_old : forall _big_a _big_b _big_na _big_nb:val, auto_knows_old (cons _big_b (cons _big_nb (cons (crypt (cons _big_a (cons _big_na nil)) (key sym (cons _big_b (cons server nil)))) nil))) -> auto_knows_old (cons _big_nb (cons (crypt (cons _big_b (cons (key sym (session_old _big_a _big_b _big_na _big_nb)) (cons _big_na nil))) (key sym (cons _big_a (cons server nil)))) (cons (crypt (cons _big_a (cons _big_b (cons (key sym (session_old _big_a _big_b _big_na _big_nb)) (cons _big_nb nil)))) (key sym (cons _big_b (cons server nil)))) nil
))).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_na; case _big_na; intro _big_nb; case _big_nb;
  simpl; try red; trivial.
Qed.

Lemma lem_message4_old : forall _big_a _big_b _big_kab _big_m _big_nb:val, auto_knows_old (cons _big_nb (cons(crypt (cons _big_b (cons _big_kab (cons (noncea_old _big_a) nil))) (key sym (cons _big_a (cons server nil)))) (cons _big_m nil))) -> auto_knows_old (cons _big_m (cons (crypt _big_nb _big_kab) nil)).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_kab; case _big_kab; intro _big_m; case _big_m;
  intro _big_nb; case _big_nb;
  simpl; try red; trivial.
Qed.

Lemma lem_intruder_knows_all_agents_old : forall X:val, auto_agent X -> auto_knows_old X.
Proof.
  intro X; case X; simpl; trivial.
Qed.

Lemma lem_intruder_knows_every_public_key_old : forall X:val, auto_knows_old (key pub X).
Proof.
  intro X; case X; simpl; trivial.
Qed.

Lemma lem_intruder_knows_own_private_key_old : auto_knows_old (key prv i).
Proof.
  simpl; trivial.
Qed.

Lemma lem_define_alice_key_old : forall _big_a _big_b _big_kab _big_m _big_nb:val, auto_knows_old (cons _big_nb (cons (crypt (cons _big_b (cons _big_kab (cons (noncea_old _big_a) nil))) (key sym (cons _big_a (cons server nil)))) (cons _big_m nil))) -> auto_alice_key_old _big_a _big_kab.
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_kab; case _big_kab; intro _big_m; case _big_m;
  intro _big_nb; case _big_nb;
  simpl; try red; trivial.
Qed.

Lemma lem_define_bob_key_old : forall _big_a _big_b _big_kab _big_na:val, auto_knows_old (cons (crypt (cons _big_a (cons _big_b (cons _big_kab (cons (nonceb_old _big_a _big_b _big_na) nil)))) (key sym (cons _big_b (cons server nil)))) (cons (crypt (nonceb_old _big_a _big_b _big_na) _big_kab) nil)) -> auto_bob_key_old _big_b _big_kab.
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_kab; case _big_kab; intro _big_na; case _big_na;
  simpl; try red; trivial.
Qed.

Lemma lem_intruder_remembers : forall _big_m:val, auto_knows_old _big_m -> auto_knows_current _big_m.
Proof.
  intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_knows_all_previous_session_keys : forall _big_a _big_b _big_na _big_nb:val, auto_knows_current (key sym (session_old _big_a _big_b _big_na _big_nb)).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_na; case _big_na; intro _big_nb; case _big_nb; simpl; trivial.
Qed.

Lemma lem_intruder_knows_all_previous_noncea : forall _big_a:val, auto_knows_current (noncea_old _big_a).
Proof.
  intro _big_a; case _big_a; simpl; trivial.
Qed.

Lemma lem_intruder_knows_all_previous_nonceb : forall _big_a _big_b _big_na:val, auto_knows_current (nonceb_old _big_a _big_b _big_na).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_na; case _big_na; simpl; trivial.
Qed.

Lemma lem_intruder_knows_nil_current : auto_knows_current nil.
Proof.
  simpl; trivial.
Qed.

Lemma lem_intruder_can_take_first_components_current :
  forall _big_m1 _big_m2:val,
    auto_knows_current (cons _big_m1 _big_m2) -> auto_knows_current _big_m1.
Proof.
  intro _big_m1; case _big_m1; intro _big_m2; case _big_m2; simpl; trivial.
Qed.

Lemma lem_intruder_can_take_second_components_current :
  forall _big_m1 _big_m2:val,
    auto_knows_current (cons _big_m1 _big_m2) -> auto_knows_current _big_m2.
Proof.
  intro _big_m1; case _big_m1; intro _big_m2; case _big_m2; simpl; trivial.
Qed.

Lemma lem_intruder_can_build_pairs_current :
  forall _big_m1 _big_m2:val,
    auto_knows_current _big_m1 -> auto_knows_current _big_m2 -> auto_knows_current (cons _big_m1 _big_m2).
Proof.
  intro _big_m1; case _big_m1; intro _big_m2; case _big_m2; simpl; trivial.
Qed.

Lemma lem_intruder_can_encrypt_current :
  forall _big_k _big_m:val,
    auto_knows_current _big_m -> auto_knows_current _big_k -> auto_knows_current (crypt _big_m _big_k).
Proof.
  intro _big_k; case _big_k; intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_can_decrypt_if_has_private_key_current :
  forall _big_k _big_m:val,
    auto_knows_current (crypt _big_m (key pub _big_k))
     -> auto_knows_current (key prv _big_k)
     -> auto_knows_current _big_m.
Proof.
  intro _big_k; case _big_k; intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_can_decrypt_if_has_public_key_current :
  forall _big_k _big_m:val,
    auto_knows_current (crypt _big_m (key prv _big_k))
    -> auto_knows_current (key pub _big_k)
    -> auto_knows_current _big_m.
Proof.
  intro _big_k; case _big_k; intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_can_decrypt_if_has_symmetric_key_current : forall _big_m X:val, auto_knows_current (crypt _big_m (key sym X)) -> auto_knows_current (key sym X) -> auto_knows_current _big_m.
Proof.
  intro _big_m; case _big_m; intro X; case X; simpl; trivial.
Qed.

Lemma lem_intruder_can_compute_successors_current : forall _big_m:val, auto_knows_current _big_m -> auto_knows_current (s _big_m).
Proof.
  intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_intruder_can_compute_predecessors_current : forall _big_m:val, auto_knows_current (s _big_m) -> auto_knows_current _big_m.
Proof.
  intro _big_m; case _big_m; simpl; trivial.
Qed.

Lemma lem_message1_current : forall _big_a:val, auto_agent _big_a -> auto_knows_current (cons _big_a (cons (noncea_current  _big_a) nil)).
Proof.
  intro _big_a; case _big_a; simpl; try red; trivial.
Qed.

Lemma lem_message2_current : forall _big_a _big_b _big_na:val, auto_agent _big_b -> auto_knows_current (cons _big_a (cons _big_na nil)) -> auto_knows_current (cons _big_b (cons (nonceb_current _big_a _big_b _big_na) (cons (crypt (cons _big_a (cons _big_na nil)) (key sym (cons _big_b (cons server nil)))) nil))).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_na; case _big_na; simpl; try red; trivial.
Qed.

Lemma lem_message3_current : forall _big_a _big_b _big_na _big_nb:val, auto_knows_current (cons _big_b (cons _big_nb (cons (crypt (cons _big_a (cons _big_na nil)) (key sym (cons _big_b (cons server nil)))) nil))) -> auto_knows_current (cons _big_nb (cons (crypt (cons _big_b (cons (key sym (session_current _big_a _big_b _big_na _big_nb)) (cons _big_na nil))) (key sym (cons _big_a (cons server nil)))) (cons (crypt (cons _big_a (cons _big_b (cons (key sym (session_current _big_a _big_b _big_na _big_nb)) (cons _big_nb nil)))) (key sym (cons _big_b (cons server nil)))) nil
))).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_na; case _big_na; intro _big_nb; case _big_nb;
  simpl; try red; trivial.
Qed.

Lemma lem_message4_current : forall _big_a _big_b _big_kab _big_m _big_nb:val, auto_knows_current (cons _big_nb (cons(crypt (cons _big_b (cons _big_kab (cons (noncea_current _big_a) nil))) (key sym (cons _big_a (cons server nil)))) (cons _big_m nil))) -> auto_knows_current (cons _big_m (cons (crypt _big_nb _big_kab) nil)).
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_kab; case _big_kab; intro _big_m; case _big_m;
  intro _big_nb; case _big_nb;
  simpl; try red; trivial.
Qed.

Lemma lem_intruder_knows_all_agents_current : forall X:val, auto_agent X -> auto_knows_current X.
Proof.
  intro X; case X; simpl; trivial.
Qed.

Lemma lem_intruder_knows_every_public_key_current : forall X:val, auto_knows_current (key pub X).
Proof.
  intro X; case X; simpl; trivial.
Qed.

Lemma lem_intruder_knows_own_private_key_current : auto_knows_current (key prv i).
Proof.
  simpl; trivial.
Qed.

Lemma lem_define_alice_key_current : forall _big_a _big_b _big_kab _big_m _big_nb:val, auto_knows_current (cons _big_nb (cons (crypt (cons _big_b (cons _big_kab (cons (noncea_current _big_a) nil))) (key sym (cons _big_a (cons server nil)))) (cons _big_m nil))) -> auto_alice_key_current _big_a _big_kab.
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_kab; case _big_kab; intro _big_m; case _big_m;
  intro _big_nb; case _big_nb;
  simpl; try red; trivial.
Qed.

Lemma lem_define_bob_key_current : forall _big_a _big_b _big_kab _big_na:val, auto_knows_current (cons (crypt (cons _big_a (cons _big_b (cons _big_kab (cons (nonceb_current _big_a _big_b _big_na) nil)))) (key sym (cons _big_b (cons server nil)))) (cons (crypt (nonceb_current _big_a _big_b _big_na) _big_kab) nil)) -> auto_bob_key_current _big_b _big_kab.
Proof.
  intro _big_a; case _big_a; intro _big_b; case _big_b;
  intro _big_kab; case _big_kab; intro _big_na; case _big_na;
  simpl; try red; trivial.
Qed.

Lemma lem_intruder_knows_session_key_generated_by_server : forall _big_na _big_nb:val, auto_knows_current (key sym (session_current alice bob _big_na _big_nb)) -> False.
Proof.
  intro _big_na; case _big_na; intro _big_nb; case _big_nb;
  simpl; trivial.
Qed.

Lemma lem_intruder_knows_session_key_as_seen_by_alice : forall _big_kab:val, auto_alice_key_current alice _big_kab -> auto_knows_current _big_kab -> False.
Proof.
  intro _big_kab; case _big_kab; simpl; trivial.
Qed.

Lemma lem_intruder_knows_session_key_as_seen_by_B : forall _big_kab:val, auto_bob_key_current bob _big_kab -> auto_knows_current _big_kab -> False.
Proof.
  intro _big_kab; case _big_kab; simpl; trivial.
Qed.
