(* [sigd] Signature definition. *)

Inductive term : Set :=
    alice : term
  | bob : term
  | cons : term -> term -> term
  | crypt : term -> term -> term
  | i : term
  | key : term -> term -> term
  | nil : term
  | noncea_current : term -> term -> term
  | noncea_old : term -> term -> term
  | nonceb_current : term -> term -> term
  | nonceb_old : term -> term -> term
  | prv : term
  | pub : term
  | s : term -> term
  | server : term
  | session_current : term -> term -> term -> term
  | session_old : term -> term -> term -> term
  | sym : term
.

(* [modd] Model definition. *)

Inductive auto___type_10 : term -> Prop :=
    trans___type_10_1 : forall X:term, auto___type_10 X
with auto___def_54 : term -> Prop :=
    trans___def_54_1 : forall X:term, auto___def_54 X
with auto___def_4 : term -> Prop :=
    trans___def_4_1 : forall X:term, auto___def_4 X
with auto___type_5 : term -> Prop :=
    trans___type_5_alice_1 : auto___type_5 alice
  | trans___type_5_bob_1 : auto___type_5 bob
  | trans___type_5_i_1 : auto___type_5 i
  | trans___type_5_server_1 : auto___type_5 server
with auto___def_64 : term -> Prop :=
    trans___def_64_noncea_current_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___def_64 (noncea_current X1 X2)
with auto___type_1 : term -> Prop :=
    trans___type_1_alice_1 : auto___type_1 alice
  | trans___type_1_noncea_old_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_1 (noncea_old X1 X2)
  | trans___type_1_bob_1 : auto___type_1 bob
  | trans___type_1_s_1 : forall X1:term, auto_knows_old X1 -> auto___type_1 (s X1)
  | trans___type_1_nil_1 : auto___type_1 nil
  | trans___type_1_i_1 : auto___type_1 i
  | trans___type_1_cons_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_1 (cons X1 X2)
  | trans___type_1_server_1 : auto___type_1 server
  | trans___type_1_key_1 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_1 (key X1 X2)
  | trans___type_1_key_2 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_1 (key X1 X2)
  | trans___type_1_crypt_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_1 (crypt X1 X2)
  | trans___type_1_crypt_2 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_1 (crypt X1 X2)
  | trans___type_1_crypt_3 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_1 (crypt X1 X2)
  | trans___type_1_crypt_4 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_1 (crypt X1 X2)
  | trans___type_1_crypt_5 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_1 (crypt X1 X2)
  | trans___type_1_crypt_6 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_1 (crypt X1 X2)
with auto___def_33 : term -> Prop :=
    trans___def_33_cons_1 : forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> auto___def_33 (cons X1 X2)
with auto___type_13 : term -> Prop :=
    trans___type_13_alice_1 : auto___type_13 alice
  | trans___type_13_bob_1 : auto___type_13 bob
  | trans___type_13_i_1 : auto___type_13 i
  | trans___type_13_server_1 : auto___type_13 server
with auto___type_15 : term -> Prop :=
    trans___type_15_alice_1 : auto___type_15 alice
  | trans___type_15_bob_1 : auto___type_15 bob
  | trans___type_15_i_1 : auto___type_15 i
  | trans___type_15_server_1 : auto___type_15 server
with auto___def_3 : term -> term -> Prop :=
    trans___def_3_1 : forall X1 X2:term, auto___def_48 X1 -> auto_knows_old X2 -> auto___def_3 X1 X2
with auto___def_84 : term -> Prop :=
    trans___def_84_cons_1 : forall X1 X2:term, auto___type_17 X1 -> auto___def_83 X2 -> auto___def_84 (cons X1 X2)
with auto___def_58 : term -> Prop :=
    trans___def_58_key_1 : forall X1 X2:term, auto___def_12 X1 -> auto___def_13 X2 -> auto___def_58 (key X1 X2)
with auto___def_8 : term -> Prop :=
    trans___def_8_key_1 : forall X1 X2:term, auto___def_12 X1 -> auto___def_13 X2 -> auto___def_8 (key X1 X2)
with auto___def_72 : term -> Prop :=
    trans___def_72_key_1 : forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_72 (key X1 X2)
with auto___def_46 : term -> Prop :=
    trans___def_46_pub_1 : auto___def_46 pub
with auto___def_52 : term -> Prop :=
    trans___def_52_i_1 : auto___def_52 i
with auto___type_11 : term -> Prop :=
    trans___type_11_alice_1 : auto___type_11 alice
  | trans___type_11_noncea_old_1 : forall X1 X2:term, auto___type_11 (noncea_old X1 X2)
  | trans___type_11_bob_1 : auto___type_11 bob
  | trans___type_11_s_1 : forall X1:term, auto_knows_current X1 -> auto___type_11 (s X1)
  | trans___type_11_nil_1 : auto___type_11 nil
  | trans___type_11_i_1 : auto___type_11 i
  | trans___type_11_cons_1 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_11 (cons X1 X2)
  | trans___type_11_server_1 : auto___type_11 server
  | trans___type_11_key_1 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___type_11 (key X1 X2)
  | trans___type_11_key_2 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_11 (key X1 X2)
  | trans___type_11_key_3 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_11 (key X1 X2)
  | trans___type_11_nonceb_old_1 : forall X1 X2:term, auto___type_11 (nonceb_old X1 X2)
  | trans___type_11_noncea_current_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_11 (noncea_current X1 X2)
  | trans___type_11_crypt_1 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_2 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_3 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_4 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_5 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_6 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_7 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_8 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_11 (crypt X1 X2)
  | trans___type_11_crypt_9 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_11 (crypt X1 X2)
with auto___type_16 : term -> Prop :=
    trans___type_16_nonceb_old_1 : forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto___type_16 (nonceb_old X1 X2)
  | trans___type_16_nonceb_current_1 : forall X1 X2:term, auto_knows_current X1 -> auto_agent X2 -> auto___type_16 (nonceb_current X1 X2)
with auto___def_32 : term -> Prop :=
    trans___def_32_nil_1 : auto___def_32 nil
with auto___def_43 : term -> term -> Prop :=
    trans___def_43_1 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_27 X2 -> auto___def_43 X1 X2
  | trans___def_43_2 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_27 X2 -> auto___def_43 X1 X2
  | trans___def_43_3 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___def_27 X2 -> auto___def_43 X1 X2
  | trans___def_43_4 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_27 X2 -> auto___def_43 X1 X2
  | trans___def_43_5 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_27 X2 -> auto___def_43 X1 X2
  | trans___def_43_6 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_27 X2 -> auto___def_43 X1 X2
with auto___type_18 : term -> Prop :=
    trans___type_18_key_1 : forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___type_18 (key X1 X2)
with auto___def_38 : term -> Prop :=
    trans___def_38_cons_1 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_38 (cons X1 X2)
with auto___def_48 : term -> Prop :=
    trans___def_48_i_1 : auto___def_48 i
with auto___def_10 : term -> Prop :=
    trans___def_10_nonceb_old_1 : forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto___def_10 (nonceb_old X1 X2)
with auto_agent : term -> Prop :=
    trans_agent_alice_1 : auto_agent alice
  | trans_agent_bob_1 : auto_agent bob
  | trans_agent_i_1 : auto_agent i
  | trans_agent_server_1 : auto_agent server
with auto___def_28 : term -> Prop :=
    trans___def_28_cons_1 : forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> auto___def_28 (cons X1 X2)
with auto___def_37 : term -> Prop :=
    trans___def_37_cons_1 : forall X1 X2:term, auto___type_5 X1 -> auto___def_38 X2 -> auto___def_37 (cons X1 X2)
with auto___def_77 : term -> Prop :=
    trans___def_77_nil_1 : auto___def_77 nil
with auto___def_85 : term -> term -> term -> term -> Prop :=
    trans___def_85_1 : forall X1 X2 X3 X4:term, auto_agent X1 -> auto___type_17 X1 -> auto___def_76 X2 -> auto___type_15 X3 -> auto_agent X3 -> auto___def_72 X4 -> auto___def_85 X1 X2 X3 X4
with auto___def_90 : term -> term -> term -> Prop :=
    trans___def_90_1 : forall X1 X2 X3:term, auto_knows_current X1 -> auto___type_15 X2 -> auto_agent X2 -> auto___type_19 X3 -> auto___def_90 X1 X2 X3
with auto___def_5 : term -> term -> Prop :=
    trans___def_5_1 : forall X1 X2:term, auto___def_44 X1 -> auto___def_30 X2 -> auto___def_5 X1 X2
  | trans___def_5_2 : forall X1 X2:term, auto___def_33 X1 -> auto___def_37 X2 -> auto___def_5 X1 X2
  | trans___def_5_3 : forall X1 X2:term, auto___def_7 X1 -> auto___def_13 X2 -> auto___def_5 X1 X2
  | trans___def_5_4 : forall X1 X2:term, auto___def_42 X1 -> auto___def_30 X2 -> auto___def_5 X1 X2
  | trans___def_5_5 : forall X1 X2:term, auto___def_23 X1 -> auto___def_39 X2 -> auto___def_5 X1 X2
with auto___def_88 : term -> term -> Prop :=
    trans___def_88_1 : forall X1 X2:term, auto_knows_current X1 -> auto___def_72 X2 -> auto_knows_current X2 -> auto___def_88 X1 X2
  | trans___def_88_2 : forall X1 X2:term, auto___def_68 X1 -> auto___def_72 X2 -> auto___def_69 X2 -> auto___def_88 X1 X2
  | trans___def_88_3 : forall X1 X2:term, auto___def_78 X1 -> auto___def_72 X2 -> auto___def_79 X2 -> auto___def_88 X1 X2
  | trans___def_88_4 : forall X1 X2:term, auto___def_23 X1 -> auto___def_72 X2 -> auto___def_24 X2 -> auto___def_88 X1 X2
  | trans___def_88_5 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_72 X2 -> auto___def_88 X1 X2
  | trans___def_88_6 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_72 X2 -> auto___def_88 X1 X2
  | trans___def_88_7 : forall X1 X2:term, auto___def_89 X1 -> auto___def_72 X2 -> auto___type_19 X2 -> auto___def_88 X1 X2
  | trans___def_88_8 : forall X1 X2:term, auto___def_87 X1 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2
  | trans___def_88_9 : forall X1 X2:term, auto___def_33 X1 -> auto___def_72 X2 -> auto___def_34 X2 -> auto___def_88 X1 X2
with auto___def_47 : term -> Prop :=
    trans___def_47_prv_1 : auto___def_47 prv
with auto___def_16 : term -> Prop :=
    trans___def_16_nil_1 : auto___def_16 nil
with auto___def_51 : term -> term -> Prop :=
    trans___def_51_1 : forall X1 X2:term, auto___type_10 X1 -> auto_knows_current X2 -> auto___def_51 X1 X2
with auto___def_21 : term -> Prop :=
    trans___def_21_nil_1 : auto___def_21 nil
with auto___def_7 : term -> Prop :=
    trans___def_7_cons_1 : forall X1 X2:term, auto___type_1 X1 -> auto___def_9 X2 -> auto___def_7 (cons X1 X2)
with auto___def_62 : term -> Prop :=
    trans___def_62_cons_1 : forall X1 X2:term, auto___type_13 X1 -> auto___def_63 X2 -> auto___def_62 (cons X1 X2)
with auto___def_40 : term -> term -> term -> term -> Prop :=
    trans___def_40_1 : forall X1 X2 X3 X4:term, auto_agent X1 -> auto___type_7 X1 -> auto___def_31 X2 -> auto___type_5 X3 -> auto_agent X3 -> auto___def_27 X4 -> auto___def_40 X1 X2 X3 X4
with auto___def_56 : term -> Prop :=
    trans___def_56_session_old_1 : forall X1 X2 X3:term, auto___def_56 (session_old X1 X2 X3)
with auto___def_23 : term -> Prop :=
    trans___def_23_cons_1 : forall X1 X2:term, auto___type_4 X1 -> auto___def_25 X2 -> auto___def_23 (cons X1 X2)
with auto___def_20 : term -> Prop :=
    trans___def_20_cons_1 : forall X1 X2:term, auto_knows_old X1 -> auto___def_21 X2 -> auto___def_20 (cons X1 X2)
with auto___def_60 : term -> Prop :=
    trans___def_60_nonceb_current_1 : forall X1 X2:term, auto_knows_current X1 -> auto_agent X2 -> auto___def_60 (nonceb_current X1 X2)
with auto___def_78 : term -> Prop :=
    trans___def_78_cons_1 : forall X1 X2:term, auto___def_72 X1 -> auto___def_80 X2 -> auto___def_78 (cons X1 X2)
with auto___def_76 : term -> Prop :=
    trans___def_76_crypt_1 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_76 (crypt X1 X2)
with auto___def_44 : term -> Prop :=
    trans___def_44_s_1 : forall X1:term, auto___def_42 X1 -> auto___def_44 (s X1)
  | trans___def_44_s_2 : forall X1:term, auto___def_44 X1 -> auto___def_44 (s X1)
with auto___def_45 : term -> term -> term -> Prop :=
    trans___def_45_1 : forall X1 X2 X3:term, auto___def_45 X1 X2 X3
with auto___def_81 : term -> Prop :=
    trans___def_81_cons_1 : forall X1 X2:term, auto___type_17 X1 -> auto___def_77 X2 -> auto___def_81 (cons X1 X2)
with auto___def_82 : term -> Prop :=
    trans___def_82_cons_1 : forall X1 X2:term, auto___type_15 X1 -> auto___def_83 X2 -> auto___def_82 (cons X1 X2)
with auto___type_2 : term -> Prop :=
    trans___type_2_alice_1 : auto___type_2 alice
  | trans___type_2_bob_1 : auto___type_2 bob
  | trans___type_2_i_1 : auto___type_2 i
  | trans___type_2_server_1 : auto___type_2 server
with auto___type_19 : term -> Prop :=
    trans___type_19_key_1 : forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___type_19 (key X1 X2)
with auto___def_9 : term -> Prop :=
    trans___def_9_cons_1 : forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> auto___def_9 (cons X1 X2)
with auto___def_73 : term -> Prop :=
    trans___def_73_cons_1 : forall X1 X2:term, auto___def_76 X1 -> auto___def_77 X2 -> auto___def_73 (cons X1 X2)
with auto___def_19 : term -> Prop :=
    trans___def_19_noncea_old_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___def_19 (noncea_old X1 X2)
with auto___def_69 : term -> Prop :=
    trans___def_69_key_1 : forall X1 X2:term, auto___def_74 X1 -> auto___def_84 X2 -> auto___def_69 (key X1 X2)
with auto___type_17 : term -> Prop :=
    trans___type_17_alice_1 : auto___type_17 alice
  | trans___type_17_noncea_old_1 : forall X1 X2:term, auto___type_17 (noncea_old X1 X2)
  | trans___type_17_bob_1 : auto___type_17 bob
  | trans___type_17_s_1 : forall X1:term, auto_knows_current X1 -> auto___type_17 (s X1)
  | trans___type_17_nil_1 : auto___type_17 nil
  | trans___type_17_i_1 : auto___type_17 i
  | trans___type_17_cons_1 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_17 (cons X1 X2)
  | trans___type_17_server_1 : auto___type_17 server
  | trans___type_17_key_1 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___type_17 (key X1 X2)
  | trans___type_17_key_2 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_17 (key X1 X2)
  | trans___type_17_key_3 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_17 (key X1 X2)
  | trans___type_17_nonceb_old_1 : forall X1 X2:term, auto___type_17 (nonceb_old X1 X2)
  | trans___type_17_noncea_current_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_17 (noncea_current X1 X2)
  | trans___type_17_crypt_1 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_2 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_3 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_4 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_5 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_6 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_7 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_8 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_17 (crypt X1 X2)
  | trans___type_17_crypt_9 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_17 (crypt X1 X2)
with auto___def_18 : term -> Prop :=
    trans___def_18_cons_1 : forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> auto___def_18 (cons X1 X2)
with auto___def_89 : term -> Prop :=
    trans___def_89_s_1 : forall X1:term, auto___def_87 X1 -> auto___def_89 (s X1)
  | trans___def_89_s_2 : forall X1:term, auto___def_89 X1 -> auto___def_89 (s X1)
with auto___type_6 : term -> Prop :=
    trans___type_6_nonceb_old_1 : forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto___type_6 (nonceb_old X1 X2)
with auto___def_42 : term -> Prop :=
    trans___def_42_nonceb_old_1 : forall X1 X2:term, auto_knows_old X1 -> auto___type_5 X2 -> auto_agent X2 -> auto___def_42 (nonceb_old X1 X2)
with auto___def_34 : term -> Prop :=
    trans___def_34_key_1 : forall X1 X2:term, auto___def_29 X1 -> auto___def_37 X2 -> auto___def_34 (key X1 X2)
with auto___def_11 : term -> Prop :=
    trans___def_11_nil_1 : auto___def_11 nil
with auto___def_24 : term -> Prop :=
    trans___def_24_key_1 : forall X1 X2:term, auto___def_29 X1 -> auto___def_39 X2 -> auto___def_24 (key X1 X2)
with auto___def_17 : term -> Prop :=
    trans___def_17_cons_1 : forall X1 X2:term, auto___type_3 X1 -> auto___def_18 X2 -> auto___def_17 (cons X1 X2)
with auto___def_79 : term -> Prop :=
    trans___def_79_key_1 : forall X1 X2:term, auto___def_74 X1 -> auto___def_82 X2 -> auto___def_79 (key X1 X2)
with auto___def_68 : term -> Prop :=
    trans___def_68_cons_1 : forall X1 X2:term, auto___type_14 X1 -> auto___def_70 X2 -> auto___def_68 (cons X1 X2)
with auto___def_74 : term -> Prop :=
    trans___def_74_sym_1 : auto___def_74 sym
with auto___def_57 : term -> Prop :=
    trans___def_57_cons_1 : forall X1 X2:term, auto___type_11 X1 -> auto___def_59 X2 -> auto___def_57 (cons X1 X2)
with auto___def_55 : term -> term -> Prop :=
    trans___def_55_1 : forall X1 X2:term, auto___def_33 X1 -> auto___def_37 X2 -> auto___def_55 X1 X2
  | trans___def_55_2 : forall X1 X2:term, auto___def_7 X1 -> auto___def_13 X2 -> auto___def_55 X1 X2
  | trans___def_55_3 : forall X1 X2:term, auto___def_57 X1 -> auto___def_13 X2 -> auto___def_55 X1 X2
  | trans___def_55_4 : forall X1 X2:term, auto___def_87 X1 -> auto___def_75 X2 -> auto___def_55 X1 X2
  | trans___def_55_5 : forall X1 X2:term, auto___def_78 X1 -> auto___def_82 X2 -> auto___def_55 X1 X2
  | trans___def_55_6 : forall X1 X2:term, auto___def_89 X1 -> auto___def_75 X2 -> auto___def_55 X1 X2
  | trans___def_55_7 : forall X1 X2:term, auto_knows_current X1 -> auto___def_50 X2 -> auto___def_55 X1 X2
  | trans___def_55_8 : forall X1 X2:term, auto___def_23 X1 -> auto___def_39 X2 -> auto___def_55 X1 X2
  | trans___def_55_9 : forall X1 X2:term, auto___def_68 X1 -> auto___def_84 X2 -> auto___def_55 X1 X2
with auto___def_1 : term -> term -> Prop :=
    trans___def_1_1 : forall X1 X2:term, auto___type_10 X1 -> auto_knows_old X2 -> auto___def_1 X1 X2
with auto___def_63 : term -> Prop :=
    trans___def_63_cons_1 : forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> auto___def_63 (cons X1 X2)
with auto___def_22 : term -> term -> term -> term -> Prop :=
    trans___def_22_1 : forall X1 X2 X3 X4:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X2 -> auto___def_10 X3 -> auto_knows_old X4 -> auto___def_22 X1 X2 X3 X4
with auto___type_7 : term -> Prop :=
    trans___type_7_alice_1 : auto___type_7 alice
  | trans___type_7_noncea_old_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_7 (noncea_old X1 X2)
  | trans___type_7_bob_1 : auto___type_7 bob
  | trans___type_7_s_1 : forall X1:term, auto_knows_old X1 -> auto___type_7 (s X1)
  | trans___type_7_nil_1 : auto___type_7 nil
  | trans___type_7_i_1 : auto___type_7 i
  | trans___type_7_cons_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_7 (cons X1 X2)
  | trans___type_7_server_1 : auto___type_7 server
  | trans___type_7_key_1 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_7 (key X1 X2)
  | trans___type_7_key_2 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_7 (key X1 X2)
  | trans___type_7_crypt_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_7 (crypt X1 X2)
  | trans___type_7_crypt_2 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_7 (crypt X1 X2)
  | trans___type_7_crypt_3 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_7 (crypt X1 X2)
  | trans___type_7_crypt_4 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_7 (crypt X1 X2)
  | trans___type_7_crypt_5 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_7 (crypt X1 X2)
  | trans___type_7_crypt_6 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_7 (crypt X1 X2)
with auto_alice_key_old : term -> term -> Prop :=
    trans_alice_key_old_1 : forall X1 X2:term, auto_agent X1 -> auto___type_7 X1 -> auto___type_9 X2 -> auto___def_27 X2 -> auto_alice_key_old X1 X2
with auto_knows_old : term -> Prop :=
    trans_knows_old_alice_1 : auto_knows_old alice
  | trans_knows_old_noncea_old_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_old (noncea_old X1 X2)
  | trans_knows_old_bob_1 : auto_knows_old bob
  | trans_knows_old_s_1 : forall X1:term, auto_knows_old X1 -> auto_knows_old (s X1)
  | trans_knows_old_nil_1 : auto_knows_old nil
  | trans_knows_old_i_1 : auto_knows_old i
  | trans_knows_old_cons_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X1 X2)
  | trans_knows_old_server_1 : auto_knows_old server
  | trans_knows_old_key_1 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_old (key X1 X2)
  | trans_knows_old_key_2 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_old (key X1 X2)
  | trans_knows_old_crypt_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt X1 X2)
  | trans_knows_old_crypt_2 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_old (crypt X1 X2)
  | trans_knows_old_crypt_3 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_old (crypt X1 X2)
  | trans_knows_old_crypt_4 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_old (crypt X1 X2)
  | trans_knows_old_crypt_5 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_old (crypt X1 X2)
  | trans_knows_old_crypt_6 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_old (crypt X1 X2)
with auto___def_80 : term -> Prop :=
    trans___def_80_cons_1 : forall X1 X2:term, auto___type_16 X1 -> auto___def_81 X2 -> auto___def_80 (cons X1 X2)
with auto___type_3 : term -> Prop :=
    trans___type_3_alice_1 : auto___type_3 alice
  | trans___type_3_bob_1 : auto___type_3 bob
  | trans___type_3_i_1 : auto___type_3 i
  | trans___type_3_server_1 : auto___type_3 server
with auto___def_29 : term -> Prop :=
    trans___def_29_sym_1 : auto___def_29 sym
with auto___def_50 : term -> Prop :=
    trans___def_50_session_old_1 : forall X1 X2 X3:term, auto___def_50 (session_old X1 X2 X3)
with auto___def_25 : term -> Prop :=
    trans___def_25_cons_1 : forall X1 X2:term, auto___type_5 X1 -> auto___def_26 X2 -> auto___def_25 (cons X1 X2)
with auto___def_31 : term -> Prop :=
    trans___def_31_crypt_1 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_31 (crypt X1 X2)
with auto___def_14 : term -> Prop :=
    trans___def_14_cons_1 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_14 (cons X1 X2)
with auto___def_53 : term -> term -> Prop :=
    trans___def_53_1 : forall X1 X2:term, auto___def_48 X1 -> auto_knows_current X2 -> auto___def_53 X1 X2
with auto___def_2 : term -> Prop :=
    trans___def_2_i_1 : auto___def_2 i
with auto___def_67 : term -> term -> term -> term -> Prop :=
    trans___def_67_1 : forall X1 X2 X3 X4:term, auto___type_1 X1 -> auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto___def_10 X3 -> auto_knows_current X4 -> auto___def_67 X1 X2 X3 X4
  | trans___def_67_2 : forall X1 X2 X3 X4:term, auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto___def_60 X3 -> auto_knows_current X4 -> auto___def_67 X1 X2 X3 X4
with auto___def_83 : term -> Prop :=
    trans___def_83_cons_1 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_83 (cons X1 X2)
with auto___def_35 : term -> Prop :=
    trans___def_35_cons_1 : forall X1 X2:term, auto___type_6 X1 -> auto___def_36 X2 -> auto___def_35 (cons X1 X2)
with auto___def_36 : term -> Prop :=
    trans___def_36_cons_1 : forall X1 X2:term, auto___type_7 X1 -> auto___def_32 X2 -> auto___def_36 (cons X1 X2)
with auto___def_15 : term -> Prop :=
    trans___def_15_server_1 : auto___def_15 server
with auto___type_9 : term -> Prop :=
    trans___type_9_key_1 : forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___type_9 (key X1 X2)
with auto___def_61 : term -> Prop :=
    trans___def_61_nil_1 : auto___def_61 nil
with auto___type_8 : term -> Prop :=
    trans___type_8_key_1 : forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___type_8 (key X1 X2)
with auto___def_70 : term -> Prop :=
    trans___def_70_cons_1 : forall X1 X2:term, auto___type_15 X1 -> auto___def_71 X2 -> auto___def_70 (cons X1 X2)
with auto___def_12 : term -> Prop :=
    trans___def_12_sym_1 : auto___def_12 sym
with auto___def_27 : term -> Prop :=
    trans___def_27_key_1 : forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_27 (key X1 X2)
with auto___def_13 : term -> Prop :=
    trans___def_13_cons_1 : forall X1 X2:term, auto_agent X1 -> auto___def_14 X2 -> auto___def_13 (cons X1 X2)
with auto___def_65 : term -> Prop :=
    trans___def_65_cons_1 : forall X1 X2:term, auto_knows_current X1 -> auto___def_66 X2 -> auto___def_65 (cons X1 X2)
with auto___def_26 : term -> Prop :=
    trans___def_26_cons_1 : forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> auto___def_26 (cons X1 X2)
with auto___def_66 : term -> Prop :=
    trans___def_66_nil_1 : auto___def_66 nil
with auto___type_12 : term -> Prop :=
    trans___type_12_alice_1 : auto___type_12 alice
  | trans___type_12_bob_1 : auto___type_12 bob
  | trans___type_12_i_1 : auto___type_12 i
  | trans___type_12_server_1 : auto___type_12 server
with auto___def_30 : term -> Prop :=
    trans___def_30_session_old_1 : forall X1 X2 X3:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X2 -> auto_knows_old X3 -> auto___def_30 (session_old X1 X2 X3)
with auto___def_49 : term -> Prop :=
    trans___def_49_sym_1 : auto___def_49 sym
with auto___def_86 : term -> term -> term -> Prop :=
    trans___def_86_1 : forall X1 X2 X3:term, auto_knows_current X1 -> auto___type_15 X2 -> auto_agent X2 -> auto___def_72 X3 -> auto___def_86 X1 X2 X3
with auto___def_41 : term -> term -> term -> Prop :=
    trans___def_41_1 : forall X1 X2 X3:term, auto_knows_old X1 -> auto___type_5 X2 -> auto_agent X2 -> auto___def_27 X3 -> auto___def_41 X1 X2 X3
with auto___type_14 : term -> Prop :=
    trans___type_14_alice_1 : auto___type_14 alice
  | trans___type_14_noncea_old_1 : forall X1 X2:term, auto___type_14 (noncea_old X1 X2)
  | trans___type_14_bob_1 : auto___type_14 bob
  | trans___type_14_s_1 : forall X1:term, auto_knows_current X1 -> auto___type_14 (s X1)
  | trans___type_14_nil_1 : auto___type_14 nil
  | trans___type_14_i_1 : auto___type_14 i
  | trans___type_14_cons_1 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_14 (cons X1 X2)
  | trans___type_14_server_1 : auto___type_14 server
  | trans___type_14_key_1 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___type_14 (key X1 X2)
  | trans___type_14_key_2 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_14 (key X1 X2)
  | trans___type_14_key_3 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_14 (key X1 X2)
  | trans___type_14_nonceb_old_1 : forall X1 X2:term, auto___type_14 (nonceb_old X1 X2)
  | trans___type_14_noncea_current_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_14 (noncea_current X1 X2)
  | trans___type_14_crypt_1 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_2 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_3 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_4 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_5 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_6 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_7 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_8 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_14 (crypt X1 X2)
  | trans___type_14_crypt_9 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_14 (crypt X1 X2)
with auto___def_75 : term -> Prop :=
    trans___def_75_session_current_1 : forall X1 X2 X3:term, auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto_knows_current X3 -> auto___def_75 (session_current X1 X2 X3)
with auto___def_39 : term -> Prop :=
    trans___def_39_cons_1 : forall X1 X2:term, auto___type_7 X1 -> auto___def_38 X2 -> auto___def_39 (cons X1 X2)
with auto___def_71 : term -> Prop :=
    trans___def_71_cons_1 : forall X1 X2:term, auto___def_72 X1 -> auto___def_73 X2 -> auto___def_71 (cons X1 X2)
with auto___type_4 : term -> Prop :=
    trans___type_4_alice_1 : auto___type_4 alice
  | trans___type_4_noncea_old_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_4 (noncea_old X1 X2)
  | trans___type_4_bob_1 : auto___type_4 bob
  | trans___type_4_s_1 : forall X1:term, auto_knows_old X1 -> auto___type_4 (s X1)
  | trans___type_4_nil_1 : auto___type_4 nil
  | trans___type_4_i_1 : auto___type_4 i
  | trans___type_4_cons_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_4 (cons X1 X2)
  | trans___type_4_server_1 : auto___type_4 server
  | trans___type_4_key_1 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_4 (key X1 X2)
  | trans___type_4_key_2 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_4 (key X1 X2)
  | trans___type_4_crypt_1 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_4 (crypt X1 X2)
  | trans___type_4_crypt_2 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_4 (crypt X1 X2)
  | trans___type_4_crypt_3 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_4 (crypt X1 X2)
  | trans___type_4_crypt_4 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_4 (crypt X1 X2)
  | trans___type_4_crypt_5 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_4 (crypt X1 X2)
  | trans___type_4_crypt_6 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_4 (crypt X1 X2)
with auto___def_87 : term -> Prop :=
    trans___def_87_nonceb_current_1 : forall X1 X2:term, auto_knows_current X1 -> auto___type_15 X2 -> auto_agent X2 -> auto___def_87 (nonceb_current X1 X2)
with auto___def_59 : term -> Prop :=
    trans___def_59_cons_1 : forall X1 X2:term, auto___def_60 X1 -> auto___def_61 X2 -> auto___def_59 (cons X1 X2)
with auto_bob_key_old : term -> term -> Prop :=
    trans_bob_key_old_1 : forall X1 X2:term, auto_bob_key_old X1 X2
with auto_alice_key_current : term -> term -> Prop :=
    trans_alice_key_current_1 : forall X1 X2:term, auto_agent X1 -> auto___type_17 X1 -> auto___def_72 X2 -> auto___type_18 X2 -> auto_alice_key_current X1 X2
with auto_knows_current : term -> Prop :=
    trans_knows_current_alice_1 : auto_knows_current alice
  | trans_knows_current_noncea_old_1 : forall X1 X2:term, auto_knows_current (noncea_old X1 X2)
  | trans_knows_current_bob_1 : auto_knows_current bob
  | trans_knows_current_s_1 : forall X1:term, auto_knows_current X1 -> auto_knows_current (s X1)
  | trans_knows_current_nil_1 : auto_knows_current nil
  | trans_knows_current_i_1 : auto_knows_current i
  | trans_knows_current_cons_1 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X1 X2)
  | trans_knows_current_server_1 : auto_knows_current server
  | trans_knows_current_key_1 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto_knows_current (key X1 X2)
  | trans_knows_current_key_2 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2)
  | trans_knows_current_key_3 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2)
  | trans_knows_current_nonceb_old_1 : forall X1 X2:term, auto_knows_current (nonceb_old X1 X2)
  | trans_knows_current_noncea_current_1 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_current X1 X2)
  | trans_knows_current_crypt_1 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_2 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_3 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_4 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_5 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_6 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_7 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_8 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2)
  | trans_knows_current_crypt_9 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_current (crypt X1 X2)
with auto_bob_key_current : term -> term -> Prop :=
    trans_bob_key_current_1 : forall X1 X2:term, auto___type_15 X1 -> auto_agent X1 -> auto___def_72 X2 -> auto___type_19 X2 -> auto_bob_key_current X1 X2
with auto___def_6 : term -> Prop :=
with auto___query__intruder_knows_session_key_generated_by_server : Prop :=
with auto___query__intruder_knows_session_key_as_seen_by_B : Prop :=
with auto___query__intruder_knows_session_key_as_seen_by_alice : Prop :=
.

(* [defp] Proofs that all definitions hold. *)


Remark rem_1 : forall X1:term, auto___def_19 X1 -> auto___def_19 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2 : forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> auto___def_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_19 X1 -> auto___def_19 X1). tauto. exact (rem_1 X1).
Qed.

Remark rem_3 : forall X2:term, auto___def_20 X2 -> auto___def_20 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_4 : forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> auto___def_20 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_20 X2 -> auto___def_20 X2). tauto. exact (rem_3 X2).
Qed.

Remark rem_5 : forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> (auto___def_19 X1 /\ auto___def_20 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_19 X1). 2:apply (rem_2 X1 X2);  assumption.
  cut (auto___def_20 X2). 2:apply (rem_4 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_6 : forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> auto___def_18 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_5 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_18_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_7 : forall X1 X2:term, auto___def_20 X2 -> auto___def_19 X1 -> auto___def_18 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_19 X1 -> auto___def_20 X2 -> auto___def_18 (cons X1 X2)). tauto. exact (rem_6 X1 X2).
Qed.

Remark rem_8 : forall X1:term, auto___type_7 X1 -> auto___type_7 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_9 : forall X1 X2:term, auto___def_38 X2 -> auto___type_7 X1 -> auto___type_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_7 X1 -> auto___type_7 X1). tauto. exact (rem_8 X1).
Qed.

Remark rem_10 : forall X2:term, auto___def_38 X2 -> auto___def_38 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_11 : forall X1 X2:term, auto___def_38 X2 -> auto___type_7 X1 -> auto___def_38 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_38 X2 -> auto___def_38 X2). tauto. exact (rem_10 X2).
Qed.

Remark rem_12 : forall X1 X2:term, auto___def_38 X2 -> auto___type_7 X1 -> (auto___type_7 X1 /\ auto___def_38 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_7 X1). 2:apply (rem_9 X1 X2);  assumption.
  cut (auto___def_38 X2). 2:apply (rem_11 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_13 : forall X1 X2:term, auto___def_38 X2 -> auto___type_7 X1 -> auto___def_39 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_12 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_39_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_14 : forall X1:term, auto___type_14 X1 -> auto___type_14 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_15 : forall X1 X2:term, auto___def_70 X2 -> auto___type_14 X1 -> auto___type_14 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_14 X1 -> auto___type_14 X1). tauto. exact (rem_14 X1).
Qed.

Remark rem_16 : forall X2:term, auto___def_70 X2 -> auto___def_70 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_17 : forall X1 X2:term, auto___def_70 X2 -> auto___type_14 X1 -> auto___def_70 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_70 X2 -> auto___def_70 X2). tauto. exact (rem_16 X2).
Qed.

Remark rem_18 : forall X1 X2:term, auto___def_70 X2 -> auto___type_14 X1 -> (auto___type_14 X1 /\ auto___def_70 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_14 X1). 2:apply (rem_15 X1 X2);  assumption.
  cut (auto___def_70 X2). 2:apply (rem_17 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_19 : forall X1 X2:term, auto___def_70 X2 -> auto___type_14 X1 -> auto___def_68 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_18 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_68_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_20 : forall X1:term, auto___def_12 X1 -> auto___def_12 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_21 : forall X1 X2:term, auto___def_12 X1 -> auto___def_13 X2 -> auto___def_12 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_12 X1 -> auto___def_12 X1). tauto. exact (rem_20 X1).
Qed.

Remark rem_22 : forall X2:term, auto___def_13 X2 -> auto___def_13 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_23 : forall X1 X2:term, auto___def_12 X1 -> auto___def_13 X2 -> auto___def_13 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_13 X2). tauto. exact (rem_22 X2).
Qed.

Remark rem_24 : forall X1 X2:term, auto___def_12 X1 -> auto___def_13 X2 -> (auto___def_12 X1 /\ auto___def_13 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_12 X1). 2:apply (rem_21 X1 X2);  assumption.
  cut (auto___def_13 X2). 2:apply (rem_23 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_25 : forall X1 X2:term, auto___def_12 X1 -> auto___def_13 X2 -> auto___def_8 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_24 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_8_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_26 : forall X1 X2:term, auto___def_13 X2 -> auto___def_12 X1 -> auto___def_8 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_12 X1 -> auto___def_13 X2 -> auto___def_8 (key X1 X2)). tauto. exact (rem_25 X1 X2).
Qed.

Inductive or_0 : Prop :=
.

Remark rem_27 : forall X1 X2 X3:term, auto___def_75 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_28 : (forall X:term, auto___def_50 X -> auto___def_75 X -> False)
    -> forall X1 X2 X3:term, auto___def_75 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_50_m__def_75. intros X1 X2 X3. intro H. intros.
  elim (rem_27 X1 X2 X3 H);  intros.
Defined.

Inductive or_1(H1:Prop) : Prop :=
    or_1_intro_1 : H1 -> (or_1 H1)
.

Remark rem_29 : forall X1 X2 X3:term, auto___def_50 (session_old X1 X2 X3) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_30 : (forall X:term, auto___def_50 X -> auto___def_75 X -> False)
    -> forall X1 X2 X3:term, auto___def_50 (session_old X1 X2 X3) -> auto___def_75 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_50_m__def_75. intros X1 X2 X3. intro H. intros.
  elim (rem_29 X1 X2 X3 H);  intros.
  apply (rem_28 epsilon_m__def_50_m__def_75 X1 X2 X3);  tauto.
Defined.

Remark rem_31 : auto___def_50 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_32 : forall X1 X2:term, auto___def_50 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_33 : auto___def_50 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_34 : auto___def_50 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_35 : forall X1:term, auto___def_50 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_36 : auto___def_50 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_37 : auto___def_50 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_38 : auto___def_50 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_39 : forall X1 X2:term, auto___def_50 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_40 : auto___def_50 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_41 : auto___def_50 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_42 : forall X1 X2:term, auto___def_50 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_43 : forall X1 X2:term, auto___def_50 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_44 : forall X1 X2:term, auto___def_50 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_45 : forall X1 X2 X3:term, auto___def_50 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_46 : forall X1 X2:term, auto___def_50 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_47 : forall X1 X2:term, auto___def_50 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_48 : forall X2:term, auto___def_50 X2 -> auto___def_75 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_50_m__def_75 1.
  intro X. case X.
   intro H. elim (rem_31  H).
   intro H. elim (rem_34  H).
  intros X1 X2. intro H. elim (rem_39 X1 X2 H).
  intros X1 X2. intro H. elim (rem_46 X1 X2 H).
   intro H. elim (rem_37  H).
  intros X1 X2. intro H. elim (rem_42 X1 X2 H).
   intro H. elim (rem_36  H).
  intros X1 X2. intro H. elim (rem_44 X1 X2 H).
  intros X1 X2. intro H. elim (rem_32 X1 X2 H).
  intros X1 X2. intro H. elim (rem_47 X1 X2 H).
  intros X1 X2. intro H. elim (rem_43 X1 X2 H).
   intro H. elim (rem_33  H).
   intro H. elim (rem_38  H).
  intros X1. intro H. elim (rem_35 X1 H).
   intro H. elim (rem_40  H).
  intros X1 X2 X3. intro H. elim (rem_45 X1 X2 X3 H).
  intros X1 X2 X3;  exact (rem_30 epsilon_m__def_50_m__def_75 X1 X2 X3).
   intro H. elim (rem_41  H).
Qed.

Remark rem_49 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X2:term, auto___def_50 X2 -> auto___def_75 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_72_mknows_current. exact (rem_48).
Defined.

Remark rem_50 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_74 X1 -> auto___def_50 X2 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_72_mknows_current. intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_75 X2 -> False). clear  epsilon_m__def_72_mknows_current. tauto.
  exact (rem_49 epsilon_m__def_72_mknows_current X2).
Defined.

Remark rem_51 : auto___def_74 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_52 : (forall X:term, auto___def_47 X -> auto___def_74 X -> False)
    -> auto___def_74 prv -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_47_m__def_74. intro H. intros.
  elim (rem_51 H);  intros.
Defined.

Remark rem_53 : auto___def_47 prv -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_54 : (forall X:term, auto___def_47 X -> auto___def_74 X -> False)
    -> auto___def_47 prv -> auto___def_74 prv -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_47_m__def_74. intro H. intros.
  elim (rem_53 H);  intros.
  apply (rem_52 epsilon_m__def_47_m__def_74);  tauto.
Defined.

Remark rem_55 : auto___def_47 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_56 : forall X1 X2:term, auto___def_47 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_57 : auto___def_47 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_58 : forall X1:term, auto___def_47 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_59 : auto___def_47 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_60 : auto___def_47 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_61 : auto___def_47 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_62 : forall X1 X2:term, auto___def_47 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_63 : auto___def_47 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_64 : auto___def_47 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_65 : forall X1 X2:term, auto___def_47 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_66 : forall X1 X2:term, auto___def_47 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_67 : forall X1 X2:term, auto___def_47 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_68 : forall X1 X2 X3:term, auto___def_47 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_69 : forall X1 X2:term, auto___def_47 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_70 : forall X1 X2 X3:term, auto___def_47 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_71 : forall X1 X2:term, auto___def_47 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_72 : forall X1:term, auto___def_47 X1 -> auto___def_74 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_47_m__def_74 1.
  intro X. case X.
   intro H. elim (rem_55  H).
   intro H. elim (rem_57  H).
  intros X1 X2. intro H. elim (rem_62 X1 X2 H).
  intros X1 X2. intro H. elim (rem_69 X1 X2 H).
   intro H. elim (rem_60  H).
  intros X1 X2. intro H. elim (rem_65 X1 X2 H).
   intro H. elim (rem_59  H).
  intros X1 X2. intro H. elim (rem_67 X1 X2 H).
  intros X1 X2. intro H. elim (rem_56 X1 X2 H).
  intros X1 X2. intro H. elim (rem_71 X1 X2 H).
  intros X1 X2. intro H. elim (rem_66 X1 X2 H).
  exact (rem_54 epsilon_m__def_47_m__def_74 ).
   intro H. elim (rem_61  H).
  intros X1. intro H. elim (rem_58 X1 H).
   intro H. elim (rem_63  H).
  intros X1 X2 X3. intro H. elim (rem_68 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_70 X1 X2 X3 H).
   intro H. elim (rem_64  H).
Qed.

Remark rem_73 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X1:term, auto___def_47 X1 -> auto___def_74 X1 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_72_mknows_current. exact (rem_72).
Defined.

Remark rem_74 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_72_mknows_current. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_74 X1 -> False). clear  epsilon_m__def_72_mknows_current. tauto.
  exact (rem_73 epsilon_m__def_72_mknows_current X1).
Defined.

Remark rem_75 : auto___def_74 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_76 : (forall X:term, auto___def_46 X -> auto___def_74 X -> False)
    -> auto___def_74 pub -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_46_m__def_74. intro H. intros.
  elim (rem_75 H);  intros.
Defined.

Remark rem_77 : auto___def_46 pub -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_78 : (forall X:term, auto___def_46 X -> auto___def_74 X -> False)
    -> auto___def_46 pub -> auto___def_74 pub -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_46_m__def_74. intro H. intros.
  elim (rem_77 H);  intros.
  apply (rem_76 epsilon_m__def_46_m__def_74);  tauto.
Defined.

Remark rem_79 : auto___def_46 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_80 : forall X1 X2:term, auto___def_46 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_81 : auto___def_46 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_82 : auto___def_46 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_83 : forall X1:term, auto___def_46 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_84 : auto___def_46 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_85 : auto___def_46 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_86 : forall X1 X2:term, auto___def_46 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_87 : auto___def_46 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_88 : auto___def_46 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_89 : forall X1 X2:term, auto___def_46 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_90 : forall X1 X2:term, auto___def_46 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_91 : forall X1 X2:term, auto___def_46 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_92 : forall X1 X2 X3:term, auto___def_46 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_93 : forall X1 X2:term, auto___def_46 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_94 : forall X1 X2 X3:term, auto___def_46 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_95 : forall X1 X2:term, auto___def_46 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_96 : forall X1:term, auto___def_46 X1 -> auto___def_74 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_46_m__def_74 1.
  intro X. case X.
   intro H. elim (rem_79  H).
   intro H. elim (rem_82  H).
  intros X1 X2. intro H. elim (rem_86 X1 X2 H).
  intros X1 X2. intro H. elim (rem_93 X1 X2 H).
   intro H. elim (rem_85  H).
  intros X1 X2. intro H. elim (rem_89 X1 X2 H).
   intro H. elim (rem_84  H).
  intros X1 X2. intro H. elim (rem_91 X1 X2 H).
  intros X1 X2. intro H. elim (rem_80 X1 X2 H).
  intros X1 X2. intro H. elim (rem_95 X1 X2 H).
  intros X1 X2. intro H. elim (rem_90 X1 X2 H).
   intro H. elim (rem_81  H).
  exact (rem_78 epsilon_m__def_46_m__def_74 ).
  intros X1. intro H. elim (rem_83 X1 H).
   intro H. elim (rem_87  H).
  intros X1 X2 X3. intro H. elim (rem_92 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_94 X1 X2 X3 H).
   intro H. elim (rem_88  H).
Qed.

Remark rem_97 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X1:term, auto___def_46 X1 -> auto___def_74 X1 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_72_mknows_current. exact (rem_96).
Defined.

Remark rem_98 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X1 X2:term, auto___type_10 X2 -> auto___def_46 X1 -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_72_mknows_current. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_74 X1 -> False). clear  epsilon_m__def_72_mknows_current. tauto.
  exact (rem_97 epsilon_m__def_72_mknows_current X1).
Defined.

Inductive or_3(H1 H2 H3:Prop) : Prop :=
    or_3_intro_1 : H1 -> (or_3 H1 H2 H3)
  | or_3_intro_2 : H2 -> (or_3 H1 H2 H3)
  | or_3_intro_3 : H3 -> (or_3 H1 H2 H3)
.

Remark rem_99 : forall X1 X2:term, auto_knows_current (key X1 X2) -> or_3
    (auto___def_49 X1 /\ auto___def_50 X2)
    (auto___def_47 X1 /\ auto___def_48 X2)
    (auto___def_46 X1 /\ auto___type_10 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_3_intro_1; tauto.
  intros. apply or_3_intro_2; tauto.
  intros. apply or_3_intro_3; tauto.
Qed.

Remark rem_100 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X1 X2:term, auto_knows_current (key X1 X2) -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_mknows_current. intros X1 X2. intro H. intros.
  elim (rem_99 X1 X2 H);  intros.
  apply (rem_50 epsilon_m__def_72_mknows_current X1 X2);  tauto.
  apply (rem_74 epsilon_m__def_72_mknows_current X1 X2);  tauto.
  apply (rem_98 epsilon_m__def_72_mknows_current X1 X2);  tauto.
Defined.

Remark rem_101 : forall X1 X2:term, auto___def_72 (key X1 X2) -> or_1
    (auto___def_74 X1 /\ auto___def_75 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_102 : (forall X:term, auto___def_72 X -> auto_knows_current X -> False)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto_knows_current (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_mknows_current. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_100 epsilon_m__def_72_mknows_current X1 X2);  tauto.
Defined.

Remark rem_103 : auto___def_72 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_104 : forall X1 X2:term, auto___def_72 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_105 : auto___def_72 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_106 : auto___def_72 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_107 : forall X1:term, auto___def_72 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_108 : auto___def_72 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_109 : auto___def_72 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_110 : auto___def_72 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_111 : forall X1 X2:term, auto___def_72 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_112 : auto___def_72 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_113 : auto___def_72 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_114 : forall X1 X2:term, auto___def_72 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_115 : forall X1 X2:term, auto___def_72 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_116 : forall X1 X2 X3:term, auto___def_72 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_117 : forall X1 X2:term, auto___def_72 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_118 : forall X1 X2 X3:term, auto___def_72 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_119 : forall X1 X2:term, auto___def_72 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_120 : forall X1:term, auto___def_72 X1 -> auto_knows_current X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_72_mknows_current 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_102 epsilon_m__def_72_mknows_current X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_121 : forall X1 X2:term, auto___def_72 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_89 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_120 X2)). tauto.
Qed.

Remark rem_122 : forall X1 X2:term, auto_knows_current X1 -> auto___def_72 X2 -> auto_knows_current X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_89 (s X1)). tauto. exact (rem_121 X1 X2).
Qed.

Remark rem_123 : forall X1 X2:term, auto___def_75 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_124 : (forall X:term, auto___def_84 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_75 (cons X1 X2) -> auto___type_17 X1 -> auto___def_83 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_84_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_123 X1 X2 H);  intros.
Defined.

Remark rem_125 : forall X1 X2:term, auto___def_84 (cons X1 X2) -> or_1
    (auto___type_17 X1 /\ auto___def_83 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_126 : (forall X:term, auto___def_84 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_84 (cons X1 X2) -> auto___def_75 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_84_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_125 X1 X2 H);  intros.
  apply (rem_124 epsilon_m__def_84_m__def_75 X1 X2);  tauto.
Defined.

Remark rem_127 : auto___def_84 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_128 : forall X1 X2:term, auto___def_84 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_129 : auto___def_84 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_130 : auto___def_84 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_131 : forall X1:term, auto___def_84 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_132 : auto___def_84 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_133 : auto___def_84 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_134 : auto___def_84 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_135 : auto___def_84 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_136 : auto___def_84 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_137 : forall X1 X2:term, auto___def_84 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_138 : forall X1 X2:term, auto___def_84 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_139 : forall X1 X2:term, auto___def_84 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_140 : forall X1 X2 X3:term, auto___def_84 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_141 : forall X1 X2:term, auto___def_84 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_142 : forall X1 X2 X3:term, auto___def_84 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_143 : forall X1 X2:term, auto___def_84 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_144 : forall X2:term, auto___def_84 X2 -> auto___def_75 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_84_m__def_75 1.
  intro X. case X.
   intro H. elim (rem_127  H).
   intro H. elim (rem_130  H).
  intros X1 X2;  exact (rem_126 epsilon_m__def_84_m__def_75 X1 X2).
  intros X1 X2. intro H. elim (rem_141 X1 X2 H).
   intro H. elim (rem_133  H).
  intros X1 X2. intro H. elim (rem_137 X1 X2 H).
   intro H. elim (rem_132  H).
  intros X1 X2. intro H. elim (rem_139 X1 X2 H).
  intros X1 X2. intro H. elim (rem_128 X1 X2 H).
  intros X1 X2. intro H. elim (rem_143 X1 X2 H).
  intros X1 X2. intro H. elim (rem_138 X1 X2 H).
   intro H. elim (rem_129  H).
   intro H. elim (rem_134  H).
  intros X1. intro H. elim (rem_131 X1 H).
   intro H. elim (rem_135  H).
  intros X1 X2 X3. intro H. elim (rem_140 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_142 X1 X2 X3 H).
   intro H. elim (rem_136  H).
Qed.

Remark rem_145 : (forall X:term, auto___def_72 X -> auto___def_69 X -> False)
    -> forall X2:term, auto___def_84 X2 -> auto___def_75 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_72_m__def_69. exact (rem_144).
Defined.

Remark rem_146 : (forall X:term, auto___def_72 X -> auto___def_69 X -> False)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_84 X2 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_72_m__def_69. intros X1 X2.
  cut (auto___def_84 X2 -> auto___def_75 X2 -> False). clear  epsilon_m__def_72_m__def_69. tauto.
  exact (rem_145 epsilon_m__def_72_m__def_69 X2).
Defined.

Remark rem_147 : forall X1 X2:term, auto___def_69 (key X1 X2) -> or_1
    (auto___def_74 X1 /\ auto___def_84 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_148 : (forall X:term, auto___def_72 X -> auto___def_69 X -> False)
    -> forall X1 X2:term, auto___def_69 (key X1 X2) -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_69. intros X1 X2. intro H. intros.
  elim (rem_147 X1 X2 H);  intros.
  apply (rem_146 epsilon_m__def_72_m__def_69 X1 X2);  tauto.
Defined.

Remark rem_149 : (forall X:term, auto___def_72 X -> auto___def_69 X -> False)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___def_69 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_69. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_148 epsilon_m__def_72_m__def_69 X1 X2);  tauto.
Defined.

Remark rem_150 : forall X1:term, auto___def_72 X1 -> auto___def_69 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_72_m__def_69 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_149 epsilon_m__def_72_m__def_69 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_151 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_72 X2 -> auto___def_89 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_150 X2)). tauto.
Qed.

Remark rem_152 : forall X1 X2:term, auto___def_68 X1 -> auto___def_72 X2 -> auto___def_69 X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_69 X2 -> auto___def_72 X2 -> auto___def_89 (s X1)). tauto. exact (rem_151 X1 X2).
Qed.

Remark rem_153 : (forall X:term, auto___def_82 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_75 (cons X1 X2) -> auto___type_15 X1 -> auto___def_83 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_82_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_123 X1 X2 H);  intros.
Defined.

Remark rem_154 : forall X1 X2:term, auto___def_82 (cons X1 X2) -> or_1
    (auto___type_15 X1 /\ auto___def_83 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_155 : (forall X:term, auto___def_82 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_82 (cons X1 X2) -> auto___def_75 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_82_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_154 X1 X2 H);  intros.
  apply (rem_153 epsilon_m__def_82_m__def_75 X1 X2);  tauto.
Defined.

Remark rem_156 : auto___def_82 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_157 : forall X1 X2:term, auto___def_82 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_158 : auto___def_82 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_159 : auto___def_82 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_160 : forall X1:term, auto___def_82 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_161 : auto___def_82 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_162 : auto___def_82 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_163 : auto___def_82 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_164 : auto___def_82 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_165 : auto___def_82 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_166 : forall X1 X2:term, auto___def_82 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_167 : forall X1 X2:term, auto___def_82 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_168 : forall X1 X2:term, auto___def_82 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_169 : forall X1 X2 X3:term, auto___def_82 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_170 : forall X1 X2:term, auto___def_82 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_171 : forall X1 X2 X3:term, auto___def_82 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_172 : forall X1 X2:term, auto___def_82 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_173 : forall X2:term, auto___def_82 X2 -> auto___def_75 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_82_m__def_75 1.
  intro X. case X.
   intro H. elim (rem_156  H).
   intro H. elim (rem_159  H).
  intros X1 X2;  exact (rem_155 epsilon_m__def_82_m__def_75 X1 X2).
  intros X1 X2. intro H. elim (rem_170 X1 X2 H).
   intro H. elim (rem_162  H).
  intros X1 X2. intro H. elim (rem_166 X1 X2 H).
   intro H. elim (rem_161  H).
  intros X1 X2. intro H. elim (rem_168 X1 X2 H).
  intros X1 X2. intro H. elim (rem_157 X1 X2 H).
  intros X1 X2. intro H. elim (rem_172 X1 X2 H).
  intros X1 X2. intro H. elim (rem_167 X1 X2 H).
   intro H. elim (rem_158  H).
   intro H. elim (rem_163  H).
  intros X1. intro H. elim (rem_160 X1 H).
   intro H. elim (rem_164  H).
  intros X1 X2 X3. intro H. elim (rem_169 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_171 X1 X2 X3 H).
   intro H. elim (rem_165  H).
Qed.

Remark rem_174 : (forall X:term, auto___def_72 X -> auto___def_79 X -> False)
    -> forall X2:term, auto___def_82 X2 -> auto___def_75 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_72_m__def_79. exact (rem_173).
Defined.

Remark rem_175 : (forall X:term, auto___def_72 X -> auto___def_79 X -> False)
    -> forall X1 X2:term, auto___def_82 X2 -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_72_m__def_79. intros X1 X2.
  cut (auto___def_82 X2 -> auto___def_75 X2 -> False). clear  epsilon_m__def_72_m__def_79. tauto.
  exact (rem_174 epsilon_m__def_72_m__def_79 X2).
Defined.

Remark rem_176 : forall X1 X2:term, auto___def_79 (key X1 X2) -> or_1
    (auto___def_74 X1 /\ auto___def_82 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_177 : (forall X:term, auto___def_72 X -> auto___def_79 X -> False)
    -> forall X1 X2:term, auto___def_79 (key X1 X2) -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_79. intros X1 X2. intro H. intros.
  elim (rem_176 X1 X2 H);  intros.
  apply (rem_175 epsilon_m__def_72_m__def_79 X1 X2);  tauto.
Defined.

Remark rem_178 : (forall X:term, auto___def_72 X -> auto___def_79 X -> False)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___def_79 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_79. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_177 epsilon_m__def_72_m__def_79 X1 X2);  tauto.
Defined.

Remark rem_179 : forall X1:term, auto___def_72 X1 -> auto___def_79 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_72_m__def_79 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_178 epsilon_m__def_72_m__def_79 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_180 : forall X1 X2:term, auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___def_89 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_179 X2)). tauto.
Qed.

Remark rem_181 : forall X1 X2:term, auto___def_78 X1 -> auto___def_72 X2 -> auto___def_79 X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___def_89 (s X1)). tauto. exact (rem_180 X1 X2).
Qed.

Remark rem_182 : forall X1 X2 X3:term, auto___def_39 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_183 : (forall X:term, auto___def_75 X -> auto___def_39 X -> False)
    -> forall X1 X2 X3:term, auto___def_39 (session_current X1 X2 X3) -> auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto_knows_current X3 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_75_m__def_39. intros X1 X2 X3. intro H. intros.
  elim (rem_182 X1 X2 X3 H);  intros.
Defined.

Remark rem_184 : forall X1 X2 X3:term, auto___def_75 (session_current X1 X2 X3) -> or_1
    (auto_knows_current X1 /\ auto_agent X2 /\ auto_knows_current X2 /\ auto_knows_current X3)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_185 : (forall X:term, auto___def_75 X -> auto___def_39 X -> False)
    -> forall X1 X2 X3:term, auto___def_75 (session_current X1 X2 X3) -> auto___def_39 (session_current X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_75_m__def_39. intros X1 X2 X3. intro H. intros.
  elim (rem_184 X1 X2 X3 H);  intros.
  apply (rem_183 epsilon_m__def_75_m__def_39 X1 X2 X3);  tauto.
Defined.

Remark rem_186 : auto___def_75 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_187 : forall X1 X2:term, auto___def_75 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_188 : auto___def_75 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_189 : auto___def_75 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_190 : forall X1:term, auto___def_75 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_191 : auto___def_75 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_192 : auto___def_75 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_193 : auto___def_75 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_194 : auto___def_75 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_195 : auto___def_75 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_196 : forall X1 X2:term, auto___def_75 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_197 : forall X1 X2:term, auto___def_75 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_198 : forall X1 X2:term, auto___def_75 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_199 : forall X1 X2:term, auto___def_75 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_200 : forall X1 X2:term, auto___def_75 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_201 : forall X2:term, auto___def_75 X2 -> auto___def_39 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_75_m__def_39 1.
  intro X. case X.
   intro H. elim (rem_186  H).
   intro H. elim (rem_189  H).
  intros X1 X2. intro H. elim (rem_123 X1 X2 H).
  intros X1 X2. intro H. elim (rem_199 X1 X2 H).
   intro H. elim (rem_192  H).
  intros X1 X2. intro H. elim (rem_196 X1 X2 H).
   intro H. elim (rem_191  H).
  intros X1 X2. intro H. elim (rem_198 X1 X2 H).
  intros X1 X2. intro H. elim (rem_187 X1 X2 H).
  intros X1 X2. intro H. elim (rem_200 X1 X2 H).
  intros X1 X2. intro H. elim (rem_197 X1 X2 H).
   intro H. elim (rem_188  H).
   intro H. elim (rem_193  H).
  intros X1. intro H. elim (rem_190 X1 H).
   intro H. elim (rem_194  H).
  intros X1 X2 X3;  exact (rem_185 epsilon_m__def_75_m__def_39 X1 X2 X3).
  intros X1 X2 X3. intro H. elim (rem_27 X1 X2 X3 H).
   intro H. elim (rem_195  H).
Qed.

Remark rem_202 : (forall X:term, auto___def_72 X -> auto___def_24 X -> False)
    -> forall X2:term, auto___def_75 X2 -> auto___def_39 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_72_m__def_24. exact (rem_201).
Defined.

Remark rem_203 : (forall X:term, auto___def_72 X -> auto___def_24 X -> False)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_29 X1 -> auto___def_39 X2 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_72_m__def_24. intros X1 X2.
  cut (auto___def_75 X2 -> auto___def_39 X2 -> False). clear  epsilon_m__def_72_m__def_24. tauto.
  exact (rem_202 epsilon_m__def_72_m__def_24 X2).
Defined.

Remark rem_204 : forall X1 X2:term, auto___def_24 (key X1 X2) -> or_1
    (auto___def_29 X1 /\ auto___def_39 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_205 : (forall X:term, auto___def_72 X -> auto___def_24 X -> False)
    -> forall X1 X2:term, auto___def_24 (key X1 X2) -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_24. intros X1 X2. intro H. intros.
  elim (rem_204 X1 X2 H);  intros.
  apply (rem_203 epsilon_m__def_72_m__def_24 X1 X2);  tauto.
Defined.

Remark rem_206 : (forall X:term, auto___def_72 X -> auto___def_24 X -> False)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___def_24 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_24. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_205 epsilon_m__def_72_m__def_24 X1 X2);  tauto.
Defined.

Remark rem_207 : forall X1:term, auto___def_72 X1 -> auto___def_24 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_72_m__def_24 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_206 epsilon_m__def_72_m__def_24 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_208 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_72 X2 -> auto___def_89 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_207 X2)). tauto.
Qed.

Remark rem_209 : forall X1 X2:term, auto___def_23 X1 -> auto___def_72 X2 -> auto___def_24 X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_24 X2 -> auto___def_72 X2 -> auto___def_89 (s X1)). tauto. exact (rem_208 X1 X2).
Qed.

Remark rem_210 : (forall X:term, auto___def_13 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_75 (cons X1 X2) -> auto_agent X1 -> auto___def_14 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_13_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_123 X1 X2 H);  intros.
Defined.

Remark rem_211 : forall X1 X2:term, auto___def_13 (cons X1 X2) -> or_1
    (auto_agent X1 /\ auto___def_14 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_212 : (forall X:term, auto___def_13 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_13 (cons X1 X2) -> auto___def_75 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_13_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_211 X1 X2 H);  intros.
  apply (rem_210 epsilon_m__def_13_m__def_75 X1 X2);  tauto.
Defined.

Remark rem_213 : auto___def_13 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_214 : forall X1 X2:term, auto___def_13 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_215 : auto___def_13 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_216 : auto___def_13 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_217 : forall X1:term, auto___def_13 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_218 : auto___def_13 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_219 : auto___def_13 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_220 : auto___def_13 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_221 : auto___def_13 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_222 : auto___def_13 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_223 : forall X1 X2:term, auto___def_13 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_224 : forall X1 X2:term, auto___def_13 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_225 : forall X1 X2:term, auto___def_13 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_226 : forall X1 X2 X3:term, auto___def_13 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_227 : forall X1 X2:term, auto___def_13 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_228 : forall X1 X2 X3:term, auto___def_13 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_229 : forall X1 X2:term, auto___def_13 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_230 : forall X2:term, auto___def_13 X2 -> auto___def_75 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_13_m__def_75 1.
  intro X. case X.
   intro H. elim (rem_213  H).
   intro H. elim (rem_216  H).
  intros X1 X2;  exact (rem_212 epsilon_m__def_13_m__def_75 X1 X2).
  intros X1 X2. intro H. elim (rem_227 X1 X2 H).
   intro H. elim (rem_219  H).
  intros X1 X2. intro H. elim (rem_223 X1 X2 H).
   intro H. elim (rem_218  H).
  intros X1 X2. intro H. elim (rem_225 X1 X2 H).
  intros X1 X2. intro H. elim (rem_214 X1 X2 H).
  intros X1 X2. intro H. elim (rem_229 X1 X2 H).
  intros X1 X2. intro H. elim (rem_224 X1 X2 H).
   intro H. elim (rem_215  H).
   intro H. elim (rem_220  H).
  intros X1. intro H. elim (rem_217 X1 H).
   intro H. elim (rem_221  H).
  intros X1 X2 X3. intro H. elim (rem_226 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_228 X1 X2 X3 H).
   intro H. elim (rem_222  H).
Qed.

Remark rem_231 : (forall X:term, auto___def_8 X -> auto___def_72 X -> False)
    -> forall X2:term, auto___def_13 X2 -> auto___def_75 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_8_m__def_72. exact (rem_230).
Defined.

Remark rem_232 : (forall X:term, auto___def_8 X -> auto___def_72 X -> False)
    -> forall X1 X2:term, auto___def_13 X2 -> auto___def_74 X1 -> auto___def_12 X1 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_8_m__def_72. intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_75 X2 -> False). clear  epsilon_m__def_8_m__def_72. tauto.
  exact (rem_231 epsilon_m__def_8_m__def_72 X2).
Defined.

Remark rem_233 : (forall X:term, auto___def_8 X -> auto___def_72 X -> False)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___def_12 X1 -> auto___def_13 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_8_m__def_72. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_232 epsilon_m__def_8_m__def_72 X1 X2);  tauto.
Defined.

Remark rem_234 : forall X1 X2:term, auto___def_8 (key X1 X2) -> or_1
    (auto___def_12 X1 /\ auto___def_13 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_235 : (forall X:term, auto___def_8 X -> auto___def_72 X -> False)
    -> forall X1 X2:term, auto___def_8 (key X1 X2) -> auto___def_72 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_8_m__def_72. intros X1 X2. intro H. intros.
  elim (rem_234 X1 X2 H);  intros.
  apply (rem_233 epsilon_m__def_8_m__def_72 X1 X2);  tauto.
Defined.

Remark rem_236 : auto___def_8 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_237 : forall X1 X2:term, auto___def_8 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_238 : auto___def_8 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_239 : auto___def_8 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_240 : forall X1:term, auto___def_8 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_241 : auto___def_8 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_242 : auto___def_8 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_243 : auto___def_8 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_244 : forall X1 X2:term, auto___def_8 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_245 : auto___def_8 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_246 : auto___def_8 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_247 : forall X1 X2:term, auto___def_8 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_248 : forall X1 X2:term, auto___def_8 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_249 : forall X1 X2 X3:term, auto___def_8 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_250 : forall X1 X2:term, auto___def_8 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_251 : forall X1 X2 X3:term, auto___def_8 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_252 : forall X1 X2:term, auto___def_8 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_253 : forall X1:term, auto___def_8 X1 -> auto___def_72 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_8_m__def_72 1.
  intro X. case X.
   intro H. elim (rem_236  H).
   intro H. elim (rem_239  H).
  intros X1 X2. intro H. elim (rem_244 X1 X2 H).
  intros X1 X2. intro H. elim (rem_250 X1 X2 H).
   intro H. elim (rem_242  H).
  intros X1 X2;  exact (rem_235 epsilon_m__def_8_m__def_72 X1 X2).
   intro H. elim (rem_241  H).
  intros X1 X2. intro H. elim (rem_248 X1 X2 H).
  intros X1 X2. intro H. elim (rem_237 X1 X2 H).
  intros X1 X2. intro H. elim (rem_252 X1 X2 H).
  intros X1 X2. intro H. elim (rem_247 X1 X2 H).
   intro H. elim (rem_238  H).
   intro H. elim (rem_243  H).
  intros X1. intro H. elim (rem_240 X1 H).
   intro H. elim (rem_245  H).
  intros X1 X2 X3. intro H. elim (rem_249 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_251 X1 X2 X3 H).
   intro H. elim (rem_246  H).
Qed.

Remark rem_254 : forall X1 X2:term, auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___def_89 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_253 X2)). tauto.
Qed.

Remark rem_255 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_72 X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___def_89 (s X1)). tauto. exact (rem_254 X1 X2).
Qed.

Remark rem_256 : (forall X:term, auto___def_58 X -> auto___def_72 X -> False)
    -> forall X2:term, auto___def_13 X2 -> auto___def_75 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_58_m__def_72. exact (rem_230).
Defined.

Remark rem_257 : (forall X:term, auto___def_58 X -> auto___def_72 X -> False)
    -> forall X1 X2:term, auto___def_13 X2 -> auto___def_74 X1 -> auto___def_12 X1 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_58_m__def_72. intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_75 X2 -> False). clear  epsilon_m__def_58_m__def_72. tauto.
  exact (rem_256 epsilon_m__def_58_m__def_72 X2).
Defined.

Remark rem_258 : (forall X:term, auto___def_58 X -> auto___def_72 X -> False)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___def_12 X1 -> auto___def_13 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_58_m__def_72. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_257 epsilon_m__def_58_m__def_72 X1 X2);  tauto.
Defined.

Remark rem_259 : forall X1 X2:term, auto___def_58 (key X1 X2) -> or_1
    (auto___def_12 X1 /\ auto___def_13 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_260 : (forall X:term, auto___def_58 X -> auto___def_72 X -> False)
    -> forall X1 X2:term, auto___def_58 (key X1 X2) -> auto___def_72 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_58_m__def_72. intros X1 X2. intro H. intros.
  elim (rem_259 X1 X2 H);  intros.
  apply (rem_258 epsilon_m__def_58_m__def_72 X1 X2);  tauto.
Defined.

Remark rem_261 : auto___def_58 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_262 : forall X1 X2:term, auto___def_58 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_263 : auto___def_58 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_264 : auto___def_58 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_265 : forall X1:term, auto___def_58 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_266 : auto___def_58 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_267 : auto___def_58 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_268 : auto___def_58 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_269 : forall X1 X2:term, auto___def_58 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_270 : auto___def_58 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_271 : auto___def_58 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_272 : forall X1 X2:term, auto___def_58 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_273 : forall X1 X2:term, auto___def_58 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_274 : forall X1 X2 X3:term, auto___def_58 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_275 : forall X1 X2:term, auto___def_58 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_276 : forall X1 X2 X3:term, auto___def_58 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_277 : forall X1 X2:term, auto___def_58 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_278 : forall X1:term, auto___def_58 X1 -> auto___def_72 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_58_m__def_72 1.
  intro X. case X.
   intro H. elim (rem_261  H).
   intro H. elim (rem_264  H).
  intros X1 X2. intro H. elim (rem_269 X1 X2 H).
  intros X1 X2. intro H. elim (rem_275 X1 X2 H).
   intro H. elim (rem_267  H).
  intros X1 X2;  exact (rem_260 epsilon_m__def_58_m__def_72 X1 X2).
   intro H. elim (rem_266  H).
  intros X1 X2. intro H. elim (rem_273 X1 X2 H).
  intros X1 X2. intro H. elim (rem_262 X1 X2 H).
  intros X1 X2. intro H. elim (rem_277 X1 X2 H).
  intros X1 X2. intro H. elim (rem_272 X1 X2 H).
   intro H. elim (rem_263  H).
   intro H. elim (rem_268  H).
  intros X1. intro H. elim (rem_265 X1 H).
   intro H. elim (rem_270  H).
  intros X1 X2 X3. intro H. elim (rem_274 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_276 X1 X2 X3 H).
   intro H. elim (rem_271  H).
Qed.

Remark rem_279 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_72 X2 -> auto___def_89 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_278 X2)). tauto.
Qed.

Remark rem_280 : forall X1:term, auto___def_89 X1 -> auto___def_89 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_281 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_280 X1).
Qed.

Remark rem_282 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_89 X1). 2:apply (rem_281 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_283 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 (s X1). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_282 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_89_s_2;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_284 : forall X1 X2:term, auto___def_89 X1 -> auto___def_72 X2 -> auto___type_19 X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 (s X1)). tauto. exact (rem_283 X1 X2).
Qed.

Remark rem_285 : forall X1:term, auto___def_87 X1 -> auto___def_87 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_286 : forall X1 X2:term, auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_285 X1).
Qed.

Remark rem_287 : forall X1 X2:term, auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_87 X1). 2:apply (rem_286 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_288 : forall X1 X2:term, auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___def_89 (s X1). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_287 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_89_s_1;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_289 : forall X1 X2:term, auto___def_87 X1 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___def_89 (s X1)). tauto. exact (rem_288 X1 X2).
Qed.

Remark rem_290 : (forall X:term, auto___def_37 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_75 (cons X1 X2) -> auto___type_5 X1 -> auto___def_38 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_37_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_123 X1 X2 H);  intros.
Defined.

Remark rem_291 : forall X1 X2:term, auto___def_37 (cons X1 X2) -> or_1
    (auto___type_5 X1 /\ auto___def_38 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_292 : (forall X:term, auto___def_37 X -> auto___def_75 X -> False)
    -> forall X1 X2:term, auto___def_37 (cons X1 X2) -> auto___def_75 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_37_m__def_75. intros X1 X2. intro H. intros.
  elim (rem_291 X1 X2 H);  intros.
  apply (rem_290 epsilon_m__def_37_m__def_75 X1 X2);  tauto.
Defined.

Remark rem_293 : auto___def_37 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_294 : forall X1 X2:term, auto___def_37 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_295 : auto___def_37 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_296 : auto___def_37 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_297 : forall X1:term, auto___def_37 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_298 : auto___def_37 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_299 : auto___def_37 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_300 : auto___def_37 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_301 : auto___def_37 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_302 : auto___def_37 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_303 : forall X1 X2:term, auto___def_37 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_304 : forall X1 X2:term, auto___def_37 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_305 : forall X1 X2:term, auto___def_37 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_306 : forall X1 X2 X3:term, auto___def_37 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_307 : forall X1 X2:term, auto___def_37 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_308 : forall X1 X2 X3:term, auto___def_37 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_309 : forall X1 X2:term, auto___def_37 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_310 : forall X2:term, auto___def_37 X2 -> auto___def_75 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_37_m__def_75 1.
  intro X. case X.
   intro H. elim (rem_293  H).
   intro H. elim (rem_296  H).
  intros X1 X2;  exact (rem_292 epsilon_m__def_37_m__def_75 X1 X2).
  intros X1 X2. intro H. elim (rem_307 X1 X2 H).
   intro H. elim (rem_299  H).
  intros X1 X2. intro H. elim (rem_303 X1 X2 H).
   intro H. elim (rem_298  H).
  intros X1 X2. intro H. elim (rem_305 X1 X2 H).
  intros X1 X2. intro H. elim (rem_294 X1 X2 H).
  intros X1 X2. intro H. elim (rem_309 X1 X2 H).
  intros X1 X2. intro H. elim (rem_304 X1 X2 H).
   intro H. elim (rem_295  H).
   intro H. elim (rem_300  H).
  intros X1. intro H. elim (rem_297 X1 H).
   intro H. elim (rem_301  H).
  intros X1 X2 X3. intro H. elim (rem_306 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_308 X1 X2 X3 H).
   intro H. elim (rem_302  H).
Qed.

Remark rem_311 : (forall X:term, auto___def_72 X -> auto___def_34 X -> False)
    -> forall X2:term, auto___def_37 X2 -> auto___def_75 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_72_m__def_34. exact (rem_310).
Defined.

Remark rem_312 : (forall X:term, auto___def_72 X -> auto___def_34 X -> False)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_29 X1 -> auto___def_37 X2 -> auto___def_75 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_72_m__def_34. intros X1 X2.
  cut (auto___def_37 X2 -> auto___def_75 X2 -> False). clear  epsilon_m__def_72_m__def_34. tauto.
  exact (rem_311 epsilon_m__def_72_m__def_34 X2).
Defined.

Remark rem_313 : forall X1 X2:term, auto___def_34 (key X1 X2) -> or_1
    (auto___def_29 X1 /\ auto___def_37 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_314 : (forall X:term, auto___def_72 X -> auto___def_34 X -> False)
    -> forall X1 X2:term, auto___def_34 (key X1 X2) -> auto___def_74 X1 -> auto___def_75 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_34. intros X1 X2. intro H. intros.
  elim (rem_313 X1 X2 H);  intros.
  apply (rem_312 epsilon_m__def_72_m__def_34 X1 X2);  tauto.
Defined.

Remark rem_315 : (forall X:term, auto___def_72 X -> auto___def_34 X -> False)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___def_34 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_m__def_34. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_314 epsilon_m__def_72_m__def_34 X1 X2);  tauto.
Defined.

Remark rem_316 : forall X1:term, auto___def_72 X1 -> auto___def_34 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_72_m__def_34 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_315 epsilon_m__def_72_m__def_34 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_317 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_72 X2 -> auto___def_89 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_316 X2)). tauto.
Qed.

Remark rem_318 : forall X1 X2:term, auto___def_33 X1 -> auto___def_72 X2 -> auto___def_34 X2 -> auto___def_89 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_34 X2 -> auto___def_72 X2 -> auto___def_89 (s X1)). tauto. exact (rem_317 X1 X2).
Qed.

Inductive or_9(H1 H2 H3 H4 H5 H6 H7 H8 H9:Prop) : Prop :=
    or_9_intro_1 : H1 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_2 : H2 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_3 : H3 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_4 : H4 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_5 : H5 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_6 : H6 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_7 : H7 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_8 : H8 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
  | or_9_intro_9 : H9 -> (or_9 H1 H2 H3 H4 H5 H6 H7 H8 H9)
.

Remark rem_319 : forall X1 X2:term, auto___def_88 X1 X2 -> or_9
    (auto_knows_current X1 /\ auto___def_72 X2 /\ auto_knows_current X2)
    (auto___def_68 X1 /\ auto___def_72 X2 /\ auto___def_69 X2)
    (auto___def_78 X1 /\ auto___def_72 X2 /\ auto___def_79 X2)
    (auto___def_23 X1 /\ auto___def_72 X2 /\ auto___def_24 X2)
    (auto___def_7 X1 /\ auto___def_8 X2 /\ auto___def_72 X2)
    (auto___def_57 X1 /\ auto___def_58 X2 /\ auto___def_72 X2)
    (auto___def_89 X1 /\ auto___def_72 X2 /\ auto___type_19 X2)
    (auto___def_87 X1 /\ auto___def_72 X2 /\ auto___type_18 X2)
    (auto___def_33 X1 /\ auto___def_72 X2 /\ auto___def_34 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_9_intro_1; tauto.
  intros. apply or_9_intro_2; tauto.
  intros. apply or_9_intro_3; tauto.
  intros. apply or_9_intro_4; tauto.
  intros. apply or_9_intro_5; tauto.
  intros. apply or_9_intro_6; tauto.
  intros. apply or_9_intro_7; tauto.
  intros. apply or_9_intro_8; tauto.
  intros. apply or_9_intro_9; tauto.
Qed.

Remark rem_320 : forall X1 X2:term, auto___def_88 X1 X2 -> auto___def_89 (s X1). (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_319 X1 X2 H);  intros.
  apply (rem_122 X1 X2);  tauto.
  apply (rem_152 X1 X2);  tauto.
  apply (rem_181 X1 X2);  tauto.
  apply (rem_209 X1 X2);  tauto.
  apply (rem_255 X1 X2);  tauto.
  apply (rem_279 X1 X2);  tauto.
  apply (rem_284 X1 X2);  tauto.
  apply (rem_289 X1 X2);  tauto.
  apply (rem_318 X1 X2);  tauto.
Qed.

Remark rem_321 : forall X1:term, auto___def_48 X1 -> auto___def_48 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_322 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_old X2 -> auto___def_48 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_48 X1 -> auto___def_48 X1). tauto. exact (rem_321 X1).
Qed.

Remark rem_323 : forall X2:term, auto_knows_old X2 -> auto_knows_old X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_324 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_323 X2).
Qed.

Remark rem_325 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_old X2 -> (auto___def_48 X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_48 X1). 2:apply (rem_322 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_324 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_326 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_old X2 -> auto___def_3 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_325 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_3_1;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_327 : auto___def_46 prv -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_81 H);  intros.
Qed.

Remark rem_328 : forall X1 X2:term, auto___def_46 prv -> auto_knows_old X2 -> auto___def_3 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_46 prv -> False). tauto.
  exact (rem_327).
Qed.

Remark rem_329 : forall X1 X2:term, auto___def_46 prv -> auto___type_10 X1 -> auto_knows_old X2 -> auto___def_3 X1 X2. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2. intros. apply (rem_328 X1 X2);  assumption.
Qed.

Inductive or_2(H1 H2:Prop) : Prop :=
    or_2_intro_1 : H1 -> (or_2 H1 H2)
  | or_2_intro_2 : H2 -> (or_2 H1 H2)
.

Remark rem_330 : forall X1 X2:term, auto_knows_old (key X1 X2) -> or_2
    (auto___def_47 X1 /\ auto___def_48 X2)
    (auto___def_46 X1 /\ auto___type_10 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_2_intro_1; tauto.
  intros. apply or_2_intro_2; tauto.
Qed.

Remark rem_331 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old (key prv X1) -> auto___def_3 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_330 prv X1 H);  intros.
  apply (rem_326 X1 X2);  tauto.
  apply (rem_329 X1 X2);  tauto.
Qed.

Remark rem_332 : auto___def_29 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_333 : auto___def_29 prv -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_332 H);  intros.
Qed.

Remark rem_334 : forall X1 X2:term, auto___def_23 X2 -> auto___def_29 prv -> auto___def_39 X1 -> auto___def_3 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 prv -> False). tauto.
  exact (rem_333).
Qed.

Remark rem_335 : forall X1 X2:term, auto___def_29 prv -> auto___def_39 X1 -> auto___def_23 X2 -> auto___def_3 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X2 -> auto___def_29 prv -> auto___def_39 X1 -> auto___def_3 X1 X2). tauto. exact (rem_334 X1 X2).
Qed.

Remark rem_336 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 (key prv X1) -> auto___def_3 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_204 prv X1 H);  intros.
  apply (rem_335 X1 X2);  tauto.
Qed.

Remark rem_337 : forall X1 X2:term, auto___def_29 prv -> auto___def_33 X2 -> auto___def_37 X1 -> auto___def_3 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 prv -> False). tauto.
  exact (rem_333).
Qed.

Remark rem_338 : forall X1 X2:term, auto___def_29 prv -> auto___def_37 X1 -> auto___def_33 X2 -> auto___def_3 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 prv -> auto___def_33 X2 -> auto___def_37 X1 -> auto___def_3 X1 X2). tauto. exact (rem_337 X1 X2).
Qed.

Remark rem_339 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 (key prv X1) -> auto___def_3 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_313 prv X1 H);  intros.
  apply (rem_338 X1 X2);  tauto.
Qed.

Remark rem_340 : forall X1 X2:term, auto___def_29 prv -> auto___def_30 X1 -> auto___def_44 X2 -> auto___def_3 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 prv -> False). tauto.
  exact (rem_333).
Qed.

Remark rem_341 : forall X1 X2:term, auto___type_9 (key X1 X2) -> or_1
    (auto___def_29 X1 /\ auto___def_30 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_342 : forall X1 X2:term, auto___def_44 X2 -> auto___type_9 (key prv X1) -> auto___def_3 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_341 prv X1 H);  intros.
  apply (rem_340 X1 X2);  tauto.
Qed.

Remark rem_343 : forall X1 X2:term, auto___def_29 prv -> auto___def_30 X1 -> auto___def_42 X2 -> auto___def_3 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 prv -> False). tauto.
  exact (rem_333).
Qed.

Remark rem_344 : forall X1 X2:term, auto___type_8 (key X1 X2) -> or_1
    (auto___def_29 X1 /\ auto___def_30 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_345 : forall X1 X2:term, auto___def_42 X2 -> auto___type_8 (key prv X1) -> auto___def_3 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_344 prv X1 H);  intros.
  apply (rem_343 X1 X2);  tauto.
Qed.

Remark rem_346 : auto___def_12 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_347 : auto___def_12 prv -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_346 H);  intros.
Qed.

Remark rem_348 : forall X1 X2:term, auto___def_12 prv -> auto___def_13 X1 -> auto___def_7 X2 -> auto___def_3 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_12 prv -> False). tauto.
  exact (rem_347).
Qed.

Remark rem_349 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 (key prv X1) -> auto___def_3 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_234 prv X1 H);  intros.
  apply (rem_348 X1 X2);  tauto.
Qed.

Inductive or_6(H1 H2 H3 H4 H5 H6:Prop) : Prop :=
    or_6_intro_1 : H1 -> (or_6 H1 H2 H3 H4 H5 H6)
  | or_6_intro_2 : H2 -> (or_6 H1 H2 H3 H4 H5 H6)
  | or_6_intro_3 : H3 -> (or_6 H1 H2 H3 H4 H5 H6)
  | or_6_intro_4 : H4 -> (or_6 H1 H2 H3 H4 H5 H6)
  | or_6_intro_5 : H5 -> (or_6 H1 H2 H3 H4 H5 H6)
  | or_6_intro_6 : H6 -> (or_6 H1 H2 H3 H4 H5 H6)
.

Remark rem_350 : forall X1 X2:term, auto_knows_old (crypt X1 X2) -> or_6
    (auto_knows_old X1 /\ auto_knows_old X2)
    (auto___def_23 X1 /\ auto___def_24 X2)
    (auto___def_33 X1 /\ auto___def_34 X2)
    (auto___def_44 X1 /\ auto___type_9 X2)
    (auto___def_42 X1 /\ auto___type_8 X2)
    (auto___def_7 X1 /\ auto___def_8 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_6_intro_1; tauto.
  intros. apply or_6_intro_2; tauto.
  intros. apply or_6_intro_3; tauto.
  intros. apply or_6_intro_4; tauto.
  intros. apply or_6_intro_5; tauto.
  intros. apply or_6_intro_6; tauto.
Qed.

Remark rem_351 : forall X1 X2:term, auto_knows_old (crypt X2 (key prv X1)) -> auto___def_3 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_350 X2 (key prv X1) H);  intros.
  apply (rem_331 X1 X2);  tauto.
  apply (rem_336 X1 X2);  tauto.
  apply (rem_339 X1 X2);  tauto.
  apply (rem_342 X1 X2);  tauto.
  apply (rem_345 X1 X2);  tauto.
  apply (rem_349 X1 X2);  tauto.
Qed.

Remark rem_352 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7.  tauto.
Defined.

Remark rem_353 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto___type_7 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7.  case (rem_352 epsilon_mknows_old_p__type_7). clear  epsilon_mknows_old_p__type_7. intros. apply trans___type_7_alice_1;  tauto.
 clear  epsilon_mknows_old_p__type_7. tauto.
Defined.

Remark rem_354 : auto_knows_old alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_355 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto_knows_old alice -> auto___type_7 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intro H. intros.
  elim (rem_354 H);  intros.
  apply (rem_353 epsilon_mknows_old_p__type_7);  tauto.
Defined.

Remark rem_356 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_357 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_356 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_358 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_359 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_358 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_360 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_357 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_359 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_361 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_7 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_360 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_noncea_old_1;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_362 : forall X1 X2:term, auto_knows_old (noncea_old X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_363 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old (noncea_old X1 X2) -> auto___type_7 (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intro H. intros.
  elim (rem_362 X1 X2 H);  intros.
  apply (rem_361 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
Defined.

Remark rem_364 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto___type_7 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7.  case (rem_352 epsilon_mknows_old_p__type_7). clear  epsilon_mknows_old_p__type_7. intros. apply trans___type_7_bob_1;  tauto.
 clear  epsilon_mknows_old_p__type_7. tauto.
Defined.

Remark rem_365 : auto_knows_old bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_366 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto_knows_old bob -> auto___type_7 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intro H. intros.
  elim (rem_365 H);  intros.
  apply (rem_364 epsilon_mknows_old_p__type_7);  tauto.
Defined.

Remark rem_367 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_368 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1. intros A1.
  cut (auto_knows_old X1). 2:apply (rem_367 epsilon_mknows_old_p__type_7 X1);  assumption.
  tauto.
Defined.

Remark rem_369 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto_knows_old X1 -> auto___type_7 (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1. intros A1.
  case (rem_368 epsilon_mknows_old_p__type_7 X1 A1). clear  epsilon_mknows_old_p__type_7 A1. intros. apply trans___type_7_s_1;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1. tauto.
Defined.

Remark rem_370 : forall X1:term, auto_knows_old (s X1) -> or_1
    (auto_knows_old X1).
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_371 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto_knows_old (s X1) -> auto___type_7 (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1. intro H. intros.
  elim (rem_370 X1 H);  intros.
  apply (rem_369 epsilon_mknows_old_p__type_7 X1);  tauto.
Defined.

Remark rem_372 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto___type_7 nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7.  case (rem_352 epsilon_mknows_old_p__type_7). clear  epsilon_mknows_old_p__type_7. intros. apply trans___type_7_nil_1;  tauto.
 clear  epsilon_mknows_old_p__type_7. tauto.
Defined.

Remark rem_373 : auto_knows_old nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_374 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto_knows_old nil -> auto___type_7 nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intro H. intros.
  elim (rem_373 H);  intros.
  apply (rem_372 epsilon_mknows_old_p__type_7);  tauto.
Defined.

Remark rem_375 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto___type_7 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7.  case (rem_352 epsilon_mknows_old_p__type_7). clear  epsilon_mknows_old_p__type_7. intros. apply trans___type_7_i_1;  tauto.
 clear  epsilon_mknows_old_p__type_7. tauto.
Defined.

Remark rem_376 : auto_knows_old i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_377 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto_knows_old i -> auto___type_7 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intro H. intros.
  elim (rem_376 H);  intros.
  apply (rem_375 epsilon_mknows_old_p__type_7);  tauto.
Defined.

Remark rem_378 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_367 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_379 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_old X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_380 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_379 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_381 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_378 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_380 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_382 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_7 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_381 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_cons_1;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_383 : forall X1 X2:term, auto_knows_old (cons X1 X2) -> or_1
    (auto_knows_old X1 /\ auto_knows_old X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_384 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old (cons X1 X2) -> auto___type_7 (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intro H. intros.
  elim (rem_383 X1 X2 H);  intros.
  apply (rem_382 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
Defined.

Remark rem_385 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto___type_7 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7.  case (rem_352 epsilon_mknows_old_p__type_7). clear  epsilon_mknows_old_p__type_7. intros. apply trans___type_7_server_1;  tauto.
 clear  epsilon_mknows_old_p__type_7. tauto.
Defined.

Remark rem_386 : auto_knows_old server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_387 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> auto_knows_old server -> auto___type_7 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intro H. intros.
  elim (rem_386 H);  intros.
  apply (rem_385 epsilon_mknows_old_p__type_7);  tauto.
Defined.

Remark rem_388 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_389 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_388 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_390 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_391 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_390 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_392 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_389 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_391 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_393 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_7 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_392 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_key_1;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_394 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_395 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_394 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_396 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_397 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_396 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_398 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_395 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_397 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_399 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_7 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_398 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_key_2;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_400 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old (key X1 X2) -> auto___type_7 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intro H. intros.
  elim (rem_330 X1 X2 H);  intros.
  apply (rem_393 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
  apply (rem_399 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
Defined.

Remark rem_401 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_7 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_381 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_crypt_1;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_402 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_403 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_402 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_404 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_405 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_404 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_406 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_403 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_405 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_407 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_7 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_406 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_crypt_2;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_408 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_409 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_408 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_410 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_411 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_410 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_412 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_409 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_411 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_413 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_7 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_412 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_crypt_3;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_414 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto___def_44 X1 -> auto___def_44 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_415 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_414 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_416 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto___type_9 X2 -> auto___type_9 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_417 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___type_9 X2 -> auto___type_9 X2). tauto. exact (rem_416 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_418 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto___def_44 X1 /\ auto___type_9 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto___def_44 X1). 2:apply (rem_415 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_417 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_419 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_7 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_418 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_crypt_4;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_420 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto___def_42 X1 -> auto___def_42 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_421 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_420 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_422 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto___type_8 X2 -> auto___type_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_423 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___type_8 X2 -> auto___type_8 X2). tauto. exact (rem_422 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_424 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto___def_42 X1 /\ auto___type_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto___def_42 X1). 2:apply (rem_421 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto___type_8 X2). 2:apply (rem_423 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_425 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_7 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_424 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_crypt_5;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_426 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_427 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_426 epsilon_mknows_old_p__type_7 X1).
Defined.

Remark rem_428 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_429 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_428 epsilon_mknows_old_p__type_7 X2).
Defined.

Remark rem_430 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_427 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_429 epsilon_mknows_old_p__type_7 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_431 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_7 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intros A1 A2.
  case (rem_430 epsilon_mknows_old_p__type_7 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_7 A1 A2. intros. apply trans___type_7_crypt_6;  tauto.
 clear  epsilon_mknows_old_p__type_7 A1 A2. tauto.
Defined.

Remark rem_432 : (forall X:term, auto_knows_old X -> auto___type_7 X)
    -> forall X1 X2:term, auto_knows_old (crypt X1 X2) -> auto___type_7 (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_7. intros X1 X2. intro H. intros.
  elim (rem_350 X1 X2 H);  intros.
  apply (rem_401 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
  apply (rem_407 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
  apply (rem_413 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
  apply (rem_419 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
  apply (rem_425 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
  apply (rem_431 epsilon_mknows_old_p__type_7 X1 X2);  tauto.
Defined.

Remark rem_433 : auto_knows_old prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_434 : auto_knows_old pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_435 : auto_knows_old sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_436 : forall X1 X2:term, auto_knows_old (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_437 : forall X1 X2:term, auto_knows_old (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_438 : forall X1 X2 X3:term, auto_knows_old (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_439 : forall X1 X2 X3:term, auto_knows_old (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_440 : forall X1 X2:term, auto_knows_old (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_441 : forall X1:term, auto_knows_old X1 -> auto___type_7 X1. (* Induct. *)
Proof.
  fix epsilon_mknows_old_p__type_7 1.
  intro X. case X.
  exact (rem_355 epsilon_mknows_old_p__type_7 ).
  exact (rem_366 epsilon_mknows_old_p__type_7 ).
  intros X1 X2;  exact (rem_384 epsilon_mknows_old_p__type_7 X1 X2).
  intros X1 X2;  exact (rem_432 epsilon_mknows_old_p__type_7 X1 X2).
  exact (rem_377 epsilon_mknows_old_p__type_7 ).
  intros X1 X2;  exact (rem_400 epsilon_mknows_old_p__type_7 X1 X2).
  exact (rem_374 epsilon_mknows_old_p__type_7 ).
  intros X1 X2. intro H. elim (rem_437 X1 X2 H).
  intros X1 X2;  exact (rem_363 epsilon_mknows_old_p__type_7 X1 X2).
  intros X1 X2. intro H. elim (rem_440 X1 X2 H).
  intros X1 X2. intro H. elim (rem_436 X1 X2 H).
   intro H. elim (rem_433  H).
   intro H. elim (rem_434  H).
  intros X1;  exact (rem_371 epsilon_mknows_old_p__type_7 X1).
  exact (rem_387 epsilon_mknows_old_p__type_7 ).
  intros X1 X2 X3. intro H. elim (rem_438 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_439 X1 X2 X3 H).
   intro H. elim (rem_435  H).
Qed.

Remark rem_442 : forall X1 X2 X3 X4:term, auto___def_10 X2 -> auto_agent X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X3 -> auto___type_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X1 -> auto___type_7 X1). tauto. exact (rem_441 X1).
Qed.

Remark rem_443 : forall X1 X2 X3 X4:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X2 -> auto___def_10 X3 -> auto_knows_old X4 -> auto___type_7 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X3 X2 X4.
  cut (auto___def_10 X2 -> auto_agent X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X3 -> auto___type_7 X1). tauto. exact (rem_442 X1 X2 X3 X4).
Qed.

Remark rem_444 : forall X1 X2 X3 X4:term, auto___def_22 X1 X2 X3 X4 -> or_1
    (auto_knows_old X1 /\ auto_agent X2 /\ auto_knows_old X2 /\ auto___def_10 X3 /\ auto_knows_old X4)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_445 : forall X1 X2 X3 X4:term, auto___def_22 X1 X2 X3 X4 -> auto___type_7 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_444 X1 X2 X3 X4 H);  intros.
  apply (rem_443 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_446 : forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_447 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_448 : forall X2:term, auto___type_15 X2 -> auto___type_15 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_449 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X1 -> auto___type_15 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X2 -> auto___type_15 X2). tauto. exact (rem_448 X2).
Qed.

Remark rem_450 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_15_pagent.  tauto.
Defined.

Remark rem_451 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto_agent alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_15_pagent.  case (rem_450 epsilon_m__type_15_pagent). clear  epsilon_m__type_15_pagent. intros. apply trans_agent_alice_1;  tauto.
 clear  epsilon_m__type_15_pagent. tauto.
Defined.

Remark rem_452 : auto___type_15 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_453 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto___type_15 alice -> auto_agent alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_15_pagent. intro H. intros.
  elim (rem_452 H);  intros.
  apply (rem_451 epsilon_m__type_15_pagent);  tauto.
Defined.

Remark rem_454 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto_agent bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_15_pagent.  case (rem_450 epsilon_m__type_15_pagent). clear  epsilon_m__type_15_pagent. intros. apply trans_agent_bob_1;  tauto.
 clear  epsilon_m__type_15_pagent. tauto.
Defined.

Remark rem_455 : auto___type_15 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_456 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto___type_15 bob -> auto_agent bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_15_pagent. intro H. intros.
  elim (rem_455 H);  intros.
  apply (rem_454 epsilon_m__type_15_pagent);  tauto.
Defined.

Remark rem_457 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto_agent i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_15_pagent.  case (rem_450 epsilon_m__type_15_pagent). clear  epsilon_m__type_15_pagent. intros. apply trans_agent_i_1;  tauto.
 clear  epsilon_m__type_15_pagent. tauto.
Defined.

Remark rem_458 : auto___type_15 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_459 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto___type_15 i -> auto_agent i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_15_pagent. intro H. intros.
  elim (rem_458 H);  intros.
  apply (rem_457 epsilon_m__type_15_pagent);  tauto.
Defined.

Remark rem_460 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto_agent server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_15_pagent.  case (rem_450 epsilon_m__type_15_pagent). clear  epsilon_m__type_15_pagent. intros. apply trans_agent_server_1;  tauto.
 clear  epsilon_m__type_15_pagent. tauto.
Defined.

Remark rem_461 : auto___type_15 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_462 : (forall X:term, auto___type_15 X -> auto_agent X)
    -> auto___type_15 server -> auto_agent server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_15_pagent. intro H. intros.
  elim (rem_461 H);  intros.
  apply (rem_460 epsilon_m__type_15_pagent);  tauto.
Defined.

Remark rem_463 : forall X1 X2:term, auto___type_15 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_464 : auto___type_15 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_465 : forall X1:term, auto___type_15 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_466 : auto___type_15 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_467 : auto___type_15 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_468 : forall X1 X2:term, auto___type_15 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_469 : auto___type_15 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_470 : forall X1 X2:term, auto___type_15 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_471 : forall X1 X2:term, auto___type_15 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_472 : forall X1 X2:term, auto___type_15 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_473 : forall X1 X2 X3:term, auto___type_15 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_474 : forall X1 X2:term, auto___type_15 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_475 : forall X1 X2 X3:term, auto___type_15 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_476 : forall X1 X2:term, auto___type_15 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_477 : forall X2:term, auto___type_15 X2 -> auto_agent X2. (* Induct. *)
Proof.
  fix epsilon_m__type_15_pagent 1.
  intro X. case X.
  exact (rem_453 epsilon_m__type_15_pagent ).
  exact (rem_456 epsilon_m__type_15_pagent ).
  intros X1 X2. intro H. elim (rem_468 X1 X2 H).
  intros X1 X2. intro H. elim (rem_474 X1 X2 H).
  exact (rem_459 epsilon_m__type_15_pagent ).
  intros X1 X2. intro H. elim (rem_470 X1 X2 H).
   intro H. elim (rem_466  H).
  intros X1 X2. intro H. elim (rem_472 X1 X2 H).
  intros X1 X2. intro H. elim (rem_463 X1 X2 H).
  intros X1 X2. intro H. elim (rem_476 X1 X2 H).
  intros X1 X2. intro H. elim (rem_471 X1 X2 H).
   intro H. elim (rem_464  H).
   intro H. elim (rem_467  H).
  intros X1. intro H. elim (rem_465 X1 H).
  exact (rem_462 epsilon_m__type_15_pagent ).
  intros X1 X2 X3. intro H. elim (rem_473 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_475 X1 X2 X3 H).
   intro H. elim (rem_469  H).
Qed.

Remark rem_478 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X1 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X2 -> auto_agent X2). tauto. exact (rem_477 X2).
Qed.

Remark rem_479 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X1 -> (auto_knows_current X1 /\ auto___type_15 X2 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4.
  cut (auto_knows_current X1). 2:apply (rem_447 X1 X2 X3);  assumption.
  cut (auto___type_15 X2). 2:apply (rem_449 X1 X2 X3);  assumption.
  cut (auto_agent X2). 2:apply (rem_478 X1 X2 X3);  assumption.
  tauto.
Qed.

Remark rem_480 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X1 -> auto___def_87 (nonceb_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4.
  case (rem_479 X1 X2 X3 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_87_nonceb_current_1;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_481 : forall X1 X2 X3:term, auto_knows_current X1 -> auto___type_15 X2 -> auto_agent X2 -> auto___def_72 X3 -> auto___def_87 (nonceb_current X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X1 -> auto___def_87 (nonceb_current X1 X2)). tauto. exact (rem_480 X1 X2 X3).
Qed.

Remark rem_482 : forall X1 X2 X3:term, auto___def_86 X1 X2 X3 -> or_1
    (auto_knows_current X1 /\ auto___type_15 X2 /\ auto_agent X2 /\ auto___def_72 X3)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_483 : forall X1 X2 X3:term, auto___def_86 X1 X2 X3 -> auto___def_87 (nonceb_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_482 X1 X2 X3 H);  intros.
  apply (rem_481 X1 X2 X3);  tauto.
Qed.

Remark rem_484 : forall X1 X2:term, auto___def_12 X1 -> auto___def_13 X2 -> auto___def_58 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_24 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_58_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_485 : forall X1 X2:term, auto___def_13 X2 -> auto___def_12 X1 -> auto___def_58 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_12 X1 -> auto___def_13 X2 -> auto___def_58 (key X1 X2)). tauto. exact (rem_484 X1 X2).
Qed.

Remark rem_486 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_p__type_5.  tauto.
Defined.

Remark rem_487 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto___type_5 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_5.  case (rem_486 epsilon_magent_p__type_5). clear  epsilon_magent_p__type_5. intros. apply trans___type_5_alice_1;  tauto.
 clear  epsilon_magent_p__type_5. tauto.
Defined.

Remark rem_488 : auto_agent alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_489 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto_agent alice -> auto___type_5 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_5. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_487 epsilon_magent_p__type_5);  tauto.
Defined.

Remark rem_490 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto___type_5 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_5.  case (rem_486 epsilon_magent_p__type_5). clear  epsilon_magent_p__type_5. intros. apply trans___type_5_bob_1;  tauto.
 clear  epsilon_magent_p__type_5. tauto.
Defined.

Remark rem_491 : auto_agent bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_492 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto_agent bob -> auto___type_5 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_5. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_490 epsilon_magent_p__type_5);  tauto.
Defined.

Remark rem_493 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto___type_5 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_5.  case (rem_486 epsilon_magent_p__type_5). clear  epsilon_magent_p__type_5. intros. apply trans___type_5_i_1;  tauto.
 clear  epsilon_magent_p__type_5. tauto.
Defined.

Remark rem_494 : auto_agent i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_495 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto_agent i -> auto___type_5 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_5. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_493 epsilon_magent_p__type_5);  tauto.
Defined.

Remark rem_496 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto___type_5 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_5.  case (rem_486 epsilon_magent_p__type_5). clear  epsilon_magent_p__type_5. intros. apply trans___type_5_server_1;  tauto.
 clear  epsilon_magent_p__type_5. tauto.
Defined.

Remark rem_497 : auto_agent server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_498 : (forall X:term, auto_agent X -> auto___type_5 X)
    -> auto_agent server -> auto___type_5 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_5. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_496 epsilon_magent_p__type_5);  tauto.
Defined.

Remark rem_499 : forall X1 X2:term, auto_agent (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_500 : auto_agent prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_501 : forall X1:term, auto_agent (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_502 : auto_agent nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_503 : auto_agent pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_504 : forall X1 X2:term, auto_agent (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_505 : auto_agent sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_506 : forall X1 X2:term, auto_agent (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_507 : forall X1 X2:term, auto_agent (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_508 : forall X1 X2:term, auto_agent (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_509 : forall X1 X2 X3:term, auto_agent (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_510 : forall X1 X2:term, auto_agent (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_511 : forall X1 X2 X3:term, auto_agent (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_512 : forall X1 X2:term, auto_agent (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_513 : forall X1:term, auto_agent X1 -> auto___type_5 X1. (* Induct. *)
Proof.
  fix epsilon_magent_p__type_5 1.
  intro X. case X.
  exact (rem_489 epsilon_magent_p__type_5 ).
  exact (rem_492 epsilon_magent_p__type_5 ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_495 epsilon_magent_p__type_5 ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_498 epsilon_magent_p__type_5 ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_514 : forall X1 X2 X3 X4:term, auto___def_10 X2 -> auto_agent X1 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X4 -> auto___type_5 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X1 -> auto___type_5 X1). tauto. exact (rem_513 X1).
Qed.

Remark rem_515 : forall X1 X2 X3 X4:term, auto_knows_old X2 -> auto_agent X1 -> auto_knows_old X1 -> auto___def_10 X3 -> auto_knows_old X4 -> auto___type_5 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X2 X3.
  cut (auto___def_10 X2 -> auto_agent X1 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X4 -> auto___type_5 X1). tauto. exact (rem_514 X1 X2 X3 X4).
Qed.

Remark rem_516 : forall X1 X2 X3 X4:term, auto___def_22 X2 X1 X3 X4 -> auto___type_5 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_444 X2 X1 X3 X4 H);  intros.
  apply (rem_515 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_517 : forall X1:term, auto___def_15 X1 -> auto___def_15 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_518 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_15 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_15 X1 -> auto___def_15 X1). tauto. exact (rem_517 X1).
Qed.

Remark rem_519 : forall X2:term, auto___def_16 X2 -> auto___def_16 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_520 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_16 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_16 X2 -> auto___def_16 X2). tauto. exact (rem_519 X2).
Qed.

Remark rem_521 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> (auto___def_15 X1 /\ auto___def_16 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_15 X1). 2:apply (rem_518 X1 X2);  assumption.
  cut (auto___def_16 X2). 2:apply (rem_520 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_522 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_14 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_521 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_14_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_523 : forall X1 X2:term, auto___def_16 X2 -> auto___def_15 X1 -> auto___def_14 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_15 X1 -> auto___def_16 X2 -> auto___def_14 (cons X1 X2)). tauto. exact (rem_522 X1 X2).
Qed.

Remark rem_524 : True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
   tauto.
Qed.

Remark rem_525 : auto___def_15 server. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_15_server_1;  tauto.
 tauto.
Qed.

Remark rem_526 : (forall X:term, auto___def_72 X -> auto___type_19 X)
    -> forall X1:term, auto___def_74 X1 -> auto___def_74 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_527 : (forall X:term, auto___def_72 X -> auto___type_19 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_74 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_72_p__type_19. intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_74 X1). tauto. exact (rem_526 epsilon_m__def_72_p__type_19 X1).
Defined.

Remark rem_528 : (forall X:term, auto___def_72 X -> auto___type_19 X)
    -> forall X2:term, auto___def_75 X2 -> auto___def_75 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_529 : (forall X:term, auto___def_72 X -> auto___type_19 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_75 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_72_p__type_19. intros X1 X2.
  cut (auto___def_75 X2 -> auto___def_75 X2). tauto. exact (rem_528 epsilon_m__def_72_p__type_19 X2).
Defined.

Remark rem_530 : (forall X:term, auto___def_72 X -> auto___type_19 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> (auto___def_74 X1 /\ auto___def_75 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_72_p__type_19. intros X1 X2. intros A1 A2.
  cut (auto___def_74 X1). 2:apply (rem_527 epsilon_m__def_72_p__type_19 X1 X2);  assumption.
  cut (auto___def_75 X2). 2:apply (rem_529 epsilon_m__def_72_p__type_19 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_531 : (forall X:term, auto___def_72 X -> auto___type_19 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___type_19 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_72_p__type_19. intros X1 X2. intros A1 A2.
  case (rem_530 epsilon_m__def_72_p__type_19 X1 X2 A1 A2). clear  epsilon_m__def_72_p__type_19 A1 A2. intros. apply trans___type_19_key_1;  tauto.
 clear  epsilon_m__def_72_p__type_19 A1 A2. tauto.
Defined.

Remark rem_532 : (forall X:term, auto___def_72 X -> auto___type_19 X)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___type_19 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_p__type_19. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_531 epsilon_m__def_72_p__type_19 X1 X2);  tauto.
Defined.

Remark rem_533 : forall X1:term, auto___def_72 X1 -> auto___type_19 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_72_p__type_19 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_532 epsilon_m__def_72_p__type_19 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_534 : forall X1 X2:term, auto___def_72 X1 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_535 : forall X1 X2:term, auto_knows_current X2 -> auto___def_72 X1 -> auto_knows_current X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X1 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___type_19 X1). tauto. exact (rem_534 X1 X2).
Qed.

Remark rem_536 : forall X1 X2:term, auto___def_68 X2 -> auto___def_69 X1 -> auto___def_72 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_537 : forall X1 X2:term, auto___def_68 X2 -> auto___def_72 X1 -> auto___def_69 X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_68 X2 -> auto___def_69 X1 -> auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_536 X1 X2).
Qed.

Remark rem_538 : forall X1 X2:term, auto___def_72 X1 -> auto___def_78 X2 -> auto___def_79 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_539 : forall X1 X2:term, auto___def_78 X2 -> auto___def_72 X1 -> auto___def_79 X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X1 -> auto___def_78 X2 -> auto___def_79 X1 -> auto___type_19 X1). tauto. exact (rem_538 X1 X2).
Qed.

Remark rem_540 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 X1 -> auto___def_72 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_541 : forall X1 X2:term, auto___def_23 X2 -> auto___def_72 X1 -> auto___def_24 X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X2 -> auto___def_24 X1 -> auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_540 X1 X2).
Qed.

Remark rem_542 : forall X1 X2:term, auto___def_7 X2 -> auto___def_72 X1 -> auto___def_8 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_543 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 X1 -> auto___def_72 X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_7 X2 -> auto___def_72 X1 -> auto___def_8 X1 -> auto___type_19 X1). tauto. exact (rem_542 X1 X2).
Qed.

Remark rem_544 : forall X1 X2:term, auto___def_57 X2 -> auto___def_58 X1 -> auto___def_72 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_545 : forall X1 X2:term, auto___def_72 X1 -> auto___def_89 X2 -> auto___type_19 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_546 : forall X1 X2:term, auto___def_89 X2 -> auto___def_72 X1 -> auto___type_19 X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X1 -> auto___def_89 X2 -> auto___type_19 X1 -> auto___type_19 X1). tauto. exact (rem_545 X1 X2).
Qed.

Remark rem_547 : forall X1 X2:term, auto___def_72 X1 -> auto___def_87 X2 -> auto___type_18 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_548 : forall X1 X2:term, auto___def_87 X2 -> auto___def_72 X1 -> auto___type_18 X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X1 -> auto___def_87 X2 -> auto___type_18 X1 -> auto___type_19 X1). tauto. exact (rem_547 X1 X2).
Qed.

Remark rem_549 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 X1 -> auto___def_72 X1 -> auto___type_19 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_533 X1).
Qed.

Remark rem_550 : forall X1 X2:term, auto___def_33 X2 -> auto___def_72 X1 -> auto___def_34 X1 -> auto___type_19 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_33 X2 -> auto___def_34 X1 -> auto___def_72 X1 -> auto___type_19 X1). tauto. exact (rem_549 X1 X2).
Qed.

Remark rem_551 : forall X1 X2:term, auto___def_88 X2 X1 -> auto___type_19 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_319 X2 X1 H);  intros.
  apply (rem_535 X1 X2);  tauto.
  apply (rem_537 X1 X2);  tauto.
  apply (rem_539 X1 X2);  tauto.
  apply (rem_541 X1 X2);  tauto.
  apply (rem_543 X1 X2);  tauto.
  apply (rem_544 X1 X2);  tauto.
  apply (rem_546 X1 X2);  tauto.
  apply (rem_548 X1 X2);  tauto.
  apply (rem_550 X1 X2);  tauto.
Qed.

Remark rem_552 : forall X1:term, auto___def_31 X1 -> auto___def_31 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_553 : forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> auto___def_31 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_31 X1 -> auto___def_31 X1). tauto. exact (rem_552 X1).
Qed.

Remark rem_554 : forall X2:term, auto___def_32 X2 -> auto___def_32 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_555 : forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> auto___def_32 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_32 X2 -> auto___def_32 X2). tauto. exact (rem_554 X2).
Qed.

Remark rem_556 : forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> (auto___def_31 X1 /\ auto___def_32 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_31 X1). 2:apply (rem_553 X1 X2);  assumption.
  cut (auto___def_32 X2). 2:apply (rem_555 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_557 : forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> auto___def_28 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_556 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_28_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_558 : forall X1 X2:term, auto___def_32 X2 -> auto___def_31 X1 -> auto___def_28 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_31 X1 -> auto___def_32 X2 -> auto___def_28 (cons X1 X2)). tauto. exact (rem_557 X1 X2).
Qed.

Remark rem_559 : forall X1:term, auto_knows_current (key pub X1) -> auto___def_54 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___def_54_1. Qed.

Remark rem_560 : forall X1:term, auto___def_72 X1 -> auto___def_72 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_561 : forall X1 X2:term, auto___def_72 X1 -> auto___def_80 X2 -> auto___def_72 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___def_72 X1). tauto. exact (rem_560 X1).
Qed.

Remark rem_562 : forall X2:term, auto___def_80 X2 -> auto___def_80 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_563 : forall X1 X2:term, auto___def_72 X1 -> auto___def_80 X2 -> auto___def_80 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_80 X2 -> auto___def_80 X2). tauto. exact (rem_562 X2).
Qed.

Remark rem_564 : forall X1 X2:term, auto___def_72 X1 -> auto___def_80 X2 -> (auto___def_72 X1 /\ auto___def_80 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_72 X1). 2:apply (rem_561 X1 X2);  assumption.
  cut (auto___def_80 X2). 2:apply (rem_563 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_565 : forall X1 X2:term, auto___def_72 X1 -> auto___def_80 X2 -> auto___def_78 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_564 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_78_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_566 : forall X1 X2:term, auto___def_80 X2 -> auto___def_72 X1 -> auto___def_78 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X1 -> auto___def_80 X2 -> auto___def_78 (cons X1 X2)). tauto. exact (rem_565 X1 X2).
Qed.

Remark rem_567 : forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_568 : forall X1 X2:term, auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_569 : forall X1 X2:term, auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_323 X2).
Qed.

Remark rem_570 : forall X2:term, auto___def_27 X2 -> auto___def_27 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_571 : forall X1 X2:term, auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_27 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_27 X2). tauto. exact (rem_570 X2).
Qed.

Remark rem_572 : forall X1 X2:term, auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_knows_old X2 /\ auto___def_27 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto_knows_old X1). 2:apply (rem_568 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_569 X1 X2);  assumption.
  cut (auto___def_27 X2). 2:apply (rem_571 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_573 : forall X1 X2:term, auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_43 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_572 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_43_3;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_574 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_43 X1 X2). tauto. exact (rem_573 X1 X2).
Qed.

Remark rem_575 : forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_576 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_575 X1).
Qed.

Remark rem_577 : forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_578 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_577 X2).
Qed.

Remark rem_579 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_27 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_27 X2). tauto. exact (rem_570 X2).
Qed.

Remark rem_580 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> (auto___def_23 X1 /\ auto___def_24 X2 /\ auto___def_27 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_23 X1). 2:apply (rem_576 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_578 X1 X2);  assumption.
  cut (auto___def_27 X2). 2:apply (rem_579 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_581 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_580 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_43_4;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_582 : forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_583 : forall X1 X2:term, auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___type_9 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_582 X1).
Qed.

Remark rem_584 : forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_585 : forall X1 X2:term, auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___type_9 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_584 X2).
Qed.

Remark rem_586 : forall X1 X2:term, auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___type_9 X2 -> auto___def_27 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_27 X2). tauto. exact (rem_570 X2).
Qed.

Remark rem_587 : forall X1 X2:term, auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___type_9 X2 -> (auto___def_33 X1 /\ auto___def_34 X2 /\ auto___def_27 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_33 X1). 2:apply (rem_583 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_585 X1 X2);  assumption.
  cut (auto___def_27 X2). 2:apply (rem_586 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_588 : forall X1 X2:term, auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_587 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_43_6;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_589 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2). tauto. exact (rem_588 X1 X2).
Qed.

Remark rem_590 : forall X1:term, auto___def_44 X1 -> auto___def_44 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_591 : forall X1 X2:term, auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_590 X1).
Qed.

Remark rem_592 : (forall X:term, auto___def_27 X -> auto___type_9 X)
    -> forall X1:term, auto___def_29 X1 -> auto___def_29 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_593 : (forall X:term, auto___def_27 X -> auto___type_9 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_29 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_27_p__type_9. intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_29 X1). tauto. exact (rem_592 epsilon_m__def_27_p__type_9 X1).
Defined.

Remark rem_594 : (forall X:term, auto___def_27 X -> auto___type_9 X)
    -> forall X2:term, auto___def_30 X2 -> auto___def_30 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_595 : (forall X:term, auto___def_27 X -> auto___type_9 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_30 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_27_p__type_9. intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_30 X2). tauto. exact (rem_594 epsilon_m__def_27_p__type_9 X2).
Defined.

Remark rem_596 : (forall X:term, auto___def_27 X -> auto___type_9 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> (auto___def_29 X1 /\ auto___def_30 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_27_p__type_9. intros X1 X2. intros A1 A2.
  cut (auto___def_29 X1). 2:apply (rem_593 epsilon_m__def_27_p__type_9 X1 X2);  assumption.
  cut (auto___def_30 X2). 2:apply (rem_595 epsilon_m__def_27_p__type_9 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_597 : (forall X:term, auto___def_27 X -> auto___type_9 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___type_9 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_27_p__type_9. intros X1 X2. intros A1 A2.
  case (rem_596 epsilon_m__def_27_p__type_9 X1 X2 A1 A2). clear  epsilon_m__def_27_p__type_9 A1 A2. intros. apply trans___type_9_key_1;  tauto.
 clear  epsilon_m__def_27_p__type_9 A1 A2. tauto.
Defined.

Remark rem_598 : forall X1 X2:term, auto___def_27 (key X1 X2) -> or_1
    (auto___def_29 X1 /\ auto___def_30 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_599 : (forall X:term, auto___def_27 X -> auto___type_9 X)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto___type_9 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_27_p__type_9. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_597 epsilon_m__def_27_p__type_9 X1 X2);  tauto.
Defined.

Remark rem_600 : auto___def_27 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_601 : forall X1 X2:term, auto___def_27 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_602 : auto___def_27 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_603 : auto___def_27 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_604 : forall X1:term, auto___def_27 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_605 : auto___def_27 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_606 : auto___def_27 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_607 : auto___def_27 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_608 : forall X1 X2:term, auto___def_27 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_609 : auto___def_27 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_610 : auto___def_27 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_611 : forall X1 X2:term, auto___def_27 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_612 : forall X1 X2:term, auto___def_27 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_613 : forall X1 X2 X3:term, auto___def_27 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_614 : forall X1 X2:term, auto___def_27 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_615 : forall X1 X2 X3:term, auto___def_27 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_616 : forall X1 X2:term, auto___def_27 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_617 : forall X2:term, auto___def_27 X2 -> auto___type_9 X2. (* Induct. *)
Proof.
  fix epsilon_m__def_27_p__type_9 1.
  intro X. case X.
   intro H. elim (rem_600  H).
   intro H. elim (rem_603  H).
  intros X1 X2. intro H. elim (rem_608 X1 X2 H).
  intros X1 X2. intro H. elim (rem_614 X1 X2 H).
   intro H. elim (rem_606  H).
  intros X1 X2;  exact (rem_599 epsilon_m__def_27_p__type_9 X1 X2).
   intro H. elim (rem_605  H).
  intros X1 X2. intro H. elim (rem_612 X1 X2 H).
  intros X1 X2. intro H. elim (rem_601 X1 X2 H).
  intros X1 X2. intro H. elim (rem_616 X1 X2 H).
  intros X1 X2. intro H. elim (rem_611 X1 X2 H).
   intro H. elim (rem_602  H).
   intro H. elim (rem_607  H).
  intros X1. intro H. elim (rem_604 X1 H).
   intro H. elim (rem_609  H).
  intros X1 X2 X3. intro H. elim (rem_613 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_615 X1 X2 X3 H).
   intro H. elim (rem_610  H).
Qed.

Remark rem_618 : forall X1 X2:term, auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___type_9 X2). tauto. exact (rem_617 X2).
Qed.

Remark rem_619 : forall X1 X2:term, auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___def_27 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_27 X2). tauto. exact (rem_570 X2).
Qed.

Remark rem_620 : forall X1 X2:term, auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> (auto___def_44 X1 /\ auto___type_9 X2 /\ auto___def_27 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_44 X1). 2:apply (rem_591 X1 X2);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_618 X1 X2);  assumption.
  cut (auto___def_27 X2). 2:apply (rem_619 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_621 : forall X1 X2:term, auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_620 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_43_2;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_622 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___def_43 X1 X2). tauto. exact (rem_621 X1 X2).
Qed.

Remark rem_623 : forall X1:term, auto___def_42 X1 -> auto___def_42 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_624 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___type_9 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_623 X1).
Qed.

Remark rem_625 : (forall X:term, auto___def_27 X -> auto___type_8 X)
    -> forall X1:term, auto___def_29 X1 -> auto___def_29 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_626 : (forall X:term, auto___def_27 X -> auto___type_8 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_29 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_27_p__type_8. intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_29 X1). tauto. exact (rem_625 epsilon_m__def_27_p__type_8 X1).
Defined.

Remark rem_627 : (forall X:term, auto___def_27 X -> auto___type_8 X)
    -> forall X2:term, auto___def_30 X2 -> auto___def_30 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_628 : (forall X:term, auto___def_27 X -> auto___type_8 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_30 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_27_p__type_8. intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_30 X2). tauto. exact (rem_627 epsilon_m__def_27_p__type_8 X2).
Defined.

Remark rem_629 : (forall X:term, auto___def_27 X -> auto___type_8 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> (auto___def_29 X1 /\ auto___def_30 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_27_p__type_8. intros X1 X2. intros A1 A2.
  cut (auto___def_29 X1). 2:apply (rem_626 epsilon_m__def_27_p__type_8 X1 X2);  assumption.
  cut (auto___def_30 X2). 2:apply (rem_628 epsilon_m__def_27_p__type_8 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_630 : (forall X:term, auto___def_27 X -> auto___type_8 X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___type_8 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_27_p__type_8. intros X1 X2. intros A1 A2.
  case (rem_629 epsilon_m__def_27_p__type_8 X1 X2 A1 A2). clear  epsilon_m__def_27_p__type_8 A1 A2. intros. apply trans___type_8_key_1;  tauto.
 clear  epsilon_m__def_27_p__type_8 A1 A2. tauto.
Defined.

Remark rem_631 : (forall X:term, auto___def_27 X -> auto___type_8 X)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto___type_8 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_27_p__type_8. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_630 epsilon_m__def_27_p__type_8 X1 X2);  tauto.
Defined.

Remark rem_632 : forall X2:term, auto___def_27 X2 -> auto___type_8 X2. (* Induct. *)
Proof.
  fix epsilon_m__def_27_p__type_8 1.
  intro X. case X.
   intro H. elim (rem_600  H).
   intro H. elim (rem_603  H).
  intros X1 X2. intro H. elim (rem_608 X1 X2 H).
  intros X1 X2. intro H. elim (rem_614 X1 X2 H).
   intro H. elim (rem_606  H).
  intros X1 X2;  exact (rem_631 epsilon_m__def_27_p__type_8 X1 X2).
   intro H. elim (rem_605  H).
  intros X1 X2. intro H. elim (rem_612 X1 X2 H).
  intros X1 X2. intro H. elim (rem_601 X1 X2 H).
  intros X1 X2. intro H. elim (rem_616 X1 X2 H).
  intros X1 X2. intro H. elim (rem_611 X1 X2 H).
   intro H. elim (rem_602  H).
   intro H. elim (rem_607  H).
  intros X1. intro H. elim (rem_604 X1 H).
   intro H. elim (rem_609  H).
  intros X1 X2 X3. intro H. elim (rem_613 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_615 X1 X2 X3 H).
   intro H. elim (rem_610  H).
Qed.

Remark rem_633 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___type_9 X2 -> auto___type_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___type_8 X2). tauto. exact (rem_632 X2).
Qed.

Remark rem_634 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___type_9 X2 -> auto___def_27 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_27 X2). tauto. exact (rem_570 X2).
Qed.

Remark rem_635 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___type_9 X2 -> (auto___def_42 X1 /\ auto___type_8 X2 /\ auto___def_27 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_42 X1). 2:apply (rem_624 X1 X2);  assumption.
  cut (auto___type_8 X2). 2:apply (rem_633 X1 X2);  assumption.
  cut (auto___def_27 X2). 2:apply (rem_634 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_636 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_635 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_43_1;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_637 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2). tauto. exact (rem_636 X1 X2).
Qed.

Remark rem_638 : forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_639 : forall X1 X2:term, auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___type_9 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_638 X1).
Qed.

Remark rem_640 : forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_641 : forall X1 X2:term, auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___type_9 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_640 X2).
Qed.

Remark rem_642 : forall X1 X2:term, auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___type_9 X2 -> auto___def_27 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_27 X2). tauto. exact (rem_570 X2).
Qed.

Remark rem_643 : forall X1 X2:term, auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___type_9 X2 -> (auto___def_7 X1 /\ auto___def_8 X2 /\ auto___def_27 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_7 X1). 2:apply (rem_639 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_641 X1 X2);  assumption.
  cut (auto___def_27 X2). 2:apply (rem_642 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_644 : forall X1 X2:term, auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_643 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_43_5;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_645 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_27 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___type_9 X2 -> auto___def_43 X1 X2). tauto. exact (rem_644 X1 X2).
Qed.

Remark rem_646 : forall X1 X2:term, auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old (crypt X1 X2) -> auto___def_43 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1 H2. intro H. intros.
  elim (rem_350 X1 X2 H);  intros.
  apply (rem_574 X1 X2);  tauto.
  apply (rem_581 X1 X2);  tauto.
  apply (rem_589 X1 X2);  tauto.
  apply (rem_622 X1 X2);  tauto.
  apply (rem_637 X1 X2);  tauto.
  apply (rem_645 X1 X2);  tauto.
Qed.

Remark rem_647 : forall X1 X2 X3:term, auto___def_27 X2 -> auto___type_7 X3 -> auto___type_9 X2 -> auto_agent X3 -> auto_knows_old (crypt X1 X2) -> auto___def_43 X1 X2. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X2 -> auto___type_9 X2 -> auto_knows_old (crypt X1 X2) -> auto___def_43 X1 X2). tauto.
  exact (rem_646 X1 X2).
Qed.

Remark rem_648 : forall X1 X2 X3:term, auto_agent X3 -> auto___type_7 X3 -> auto___type_9 X2 -> auto___def_27 X2 -> auto_knows_old (crypt X1 X2) -> auto___def_43 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X2 -> auto___type_7 X3 -> auto___type_9 X2 -> auto_agent X3 -> auto_knows_old (crypt X1 X2) -> auto___def_43 X1 X2). tauto. exact (rem_647 X1 X2 X3).
Qed.

Remark rem_649 : forall X1 X2:term, auto_alice_key_old X1 X2 -> or_1
    (auto_agent X1 /\ auto___type_7 X1 /\ auto___type_9 X2 /\ auto___def_27 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_650 : forall X1 X2 X3:term, auto_alice_key_old X3 X2 -> auto_knows_old (crypt X1 X2) -> auto___def_43 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_649 X3 X2 H);  intros.
  apply (rem_648 X1 X2 X3);  tauto.
Qed.

Remark rem_651 : forall X1 X2 X3:term, auto_knows_old (crypt X1 X2) -> auto_alice_key_old X3 X2 -> auto___def_43 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_alice_key_old X3 X2 -> auto_knows_old (crypt X1 X2) -> auto___def_43 X1 X2). tauto. exact (rem_650 X1 X2 X3).
Qed.

Remark rem_652 : forall X1:term, auto___type_5 X1 -> auto___type_5 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_653 : forall X1 X2:term, auto___def_26 X2 -> auto___type_5 X1 -> auto___type_5 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_5 X1 -> auto___type_5 X1). tauto. exact (rem_652 X1).
Qed.

Remark rem_654 : forall X2:term, auto___def_26 X2 -> auto___def_26 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_655 : forall X1 X2:term, auto___def_26 X2 -> auto___type_5 X1 -> auto___def_26 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_26 X2 -> auto___def_26 X2). tauto. exact (rem_654 X2).
Qed.

Remark rem_656 : forall X1 X2:term, auto___def_26 X2 -> auto___type_5 X1 -> (auto___type_5 X1 /\ auto___def_26 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_5 X1). 2:apply (rem_653 X1 X2);  assumption.
  cut (auto___def_26 X2). 2:apply (rem_655 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_657 : forall X1 X2:term, auto___def_26 X2 -> auto___type_5 X1 -> auto___def_25 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_656 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_25_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_658 : forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_659 : forall X1 X2:term, auto___def_14 X2 -> auto_agent X1 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_658 X1).
Qed.

Remark rem_660 : forall X2:term, auto___def_14 X2 -> auto___def_14 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_661 : forall X1 X2:term, auto___def_14 X2 -> auto_agent X1 -> auto___def_14 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_14 X2 -> auto___def_14 X2). tauto. exact (rem_660 X2).
Qed.

Remark rem_662 : forall X1 X2:term, auto___def_14 X2 -> auto_agent X1 -> (auto_agent X1 /\ auto___def_14 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_659 X1 X2);  assumption.
  cut (auto___def_14 X2). 2:apply (rem_661 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_663 : forall X1 X2:term, auto___def_14 X2 -> auto_agent X1 -> auto___def_13 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_662 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_13_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_664 : forall X1:term, auto___def_29 X1 -> auto___def_29 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_665 : forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_29 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_29 X1). tauto. exact (rem_664 X1).
Qed.

Remark rem_666 : forall X2:term, auto___def_30 X2 -> auto___def_30 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_667 : forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_30 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_30 X2). tauto. exact (rem_666 X2).
Qed.

Remark rem_668 : forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> (auto___def_29 X1 /\ auto___def_30 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_29 X1). 2:apply (rem_665 X1 X2);  assumption.
  cut (auto___def_30 X2). 2:apply (rem_667 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_669 : forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_27 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_668 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_27_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_670 : forall X1 X2:term, auto___def_30 X2 -> auto___def_29 X1 -> auto___def_27 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_30 X2 -> auto___def_27 (key X1 X2)). tauto. exact (rem_669 X1 X2).
Qed.

Remark rem_671 : forall X1:term, auto___def_27 X1 -> auto___type_9 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_27_p__type_9 1.
  intro X. case X.
   intro H. elim (rem_600  H).
   intro H. elim (rem_603  H).
  intros X1 X2. intro H. elim (rem_608 X1 X2 H).
  intros X1 X2. intro H. elim (rem_614 X1 X2 H).
   intro H. elim (rem_606  H).
  intros X1 X2;  exact (rem_599 epsilon_m__def_27_p__type_9 X1 X2).
   intro H. elim (rem_605  H).
  intros X1 X2. intro H. elim (rem_612 X1 X2 H).
  intros X1 X2. intro H. elim (rem_601 X1 X2 H).
  intros X1 X2. intro H. elim (rem_616 X1 X2 H).
  intros X1 X2. intro H. elim (rem_611 X1 X2 H).
   intro H. elim (rem_602  H).
   intro H. elim (rem_607  H).
  intros X1. intro H. elim (rem_604 X1 H).
   intro H. elim (rem_609  H).
  intros X1 X2 X3. intro H. elim (rem_613 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_615 X1 X2 X3 H).
   intro H. elim (rem_610  H).
Qed.

Remark rem_672 : forall X1 X2:term, auto___def_27 X1 -> auto___def_42 X2 -> auto___type_8 X1 -> auto___type_9 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___type_9 X1). tauto. exact (rem_671 X1).
Qed.

Remark rem_673 : forall X1 X2:term, auto___def_42 X2 -> auto___type_8 X1 -> auto___def_27 X1 -> auto___type_9 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_42 X2 -> auto___type_8 X1 -> auto___type_9 X1). tauto. exact (rem_672 X1 X2).
Qed.

Remark rem_674 : forall X1 X2:term, auto___def_27 X1 -> auto___def_44 X2 -> auto___type_9 X1 -> auto___type_9 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___type_9 X1). tauto. exact (rem_671 X1).
Qed.

Remark rem_675 : forall X1 X2:term, auto___def_44 X2 -> auto___type_9 X1 -> auto___def_27 X1 -> auto___type_9 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_44 X2 -> auto___type_9 X1 -> auto___type_9 X1). tauto. exact (rem_674 X1 X2).
Qed.

Remark rem_676 : forall X1 X2:term, auto___def_27 X1 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___type_9 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___type_9 X1). tauto. exact (rem_671 X1).
Qed.

Remark rem_677 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old X1 -> auto___def_27 X1 -> auto___type_9 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X1 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___type_9 X1). tauto. exact (rem_676 X1 X2).
Qed.

Remark rem_678 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 X1 -> auto___def_27 X1 -> auto___type_9 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___type_9 X1). tauto. exact (rem_671 X1).
Qed.

Remark rem_679 : forall X1 X2:term, auto___def_27 X1 -> auto___def_7 X2 -> auto___def_8 X1 -> auto___type_9 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___type_9 X1). tauto. exact (rem_671 X1).
Qed.

Remark rem_680 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 X1 -> auto___def_27 X1 -> auto___type_9 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_7 X2 -> auto___def_8 X1 -> auto___type_9 X1). tauto. exact (rem_679 X1 X2).
Qed.

Remark rem_681 : forall X1 X2:term, auto___def_27 X1 -> auto___def_33 X2 -> auto___def_34 X1 -> auto___type_9 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___type_9 X1). tauto. exact (rem_671 X1).
Qed.

Remark rem_682 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 X1 -> auto___def_27 X1 -> auto___type_9 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_33 X2 -> auto___def_34 X1 -> auto___type_9 X1). tauto. exact (rem_681 X1 X2).
Qed.

Remark rem_683 : forall X1 X2:term, auto___def_43 X1 X2 -> or_6
    (auto___def_42 X1 /\ auto___type_8 X2 /\ auto___def_27 X2)
    (auto___def_44 X1 /\ auto___type_9 X2 /\ auto___def_27 X2)
    (auto_knows_old X1 /\ auto_knows_old X2 /\ auto___def_27 X2)
    (auto___def_23 X1 /\ auto___def_24 X2 /\ auto___def_27 X2)
    (auto___def_7 X1 /\ auto___def_8 X2 /\ auto___def_27 X2)
    (auto___def_33 X1 /\ auto___def_34 X2 /\ auto___def_27 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_6_intro_1; tauto.
  intros. apply or_6_intro_2; tauto.
  intros. apply or_6_intro_3; tauto.
  intros. apply or_6_intro_4; tauto.
  intros. apply or_6_intro_5; tauto.
  intros. apply or_6_intro_6; tauto.
Qed.

Remark rem_684 : forall X1 X2:term, auto___def_43 X2 X1 -> auto___type_9 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_683 X2 X1 H);  intros.
  apply (rem_673 X1 X2);  tauto.
  apply (rem_675 X1 X2);  tauto.
  apply (rem_677 X1 X2);  tauto.
  apply (rem_678 X1 X2);  tauto.
  apply (rem_680 X1 X2);  tauto.
  apply (rem_682 X1 X2);  tauto.
Qed.

Remark rem_685 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto_agent X2 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_686 : forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_687 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto_agent X2 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_688 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_pknows_old.  tauto.
Defined.

Remark rem_689 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_knows_old alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_old.  case (rem_688 epsilon_magent_pknows_old). clear  epsilon_magent_pknows_old. intros. apply trans_knows_old_alice_1;  tauto.
 clear  epsilon_magent_pknows_old. tauto.
Defined.

Remark rem_690 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_agent alice -> auto_knows_old alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_old. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_689 epsilon_magent_pknows_old);  tauto.
Defined.

Remark rem_691 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_knows_old bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_old.  case (rem_688 epsilon_magent_pknows_old). clear  epsilon_magent_pknows_old. intros. apply trans_knows_old_bob_1;  tauto.
 clear  epsilon_magent_pknows_old. tauto.
Defined.

Remark rem_692 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_agent bob -> auto_knows_old bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_old. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_691 epsilon_magent_pknows_old);  tauto.
Defined.

Remark rem_693 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_knows_old i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_old.  case (rem_688 epsilon_magent_pknows_old). clear  epsilon_magent_pknows_old. intros. apply trans_knows_old_i_1;  tauto.
 clear  epsilon_magent_pknows_old. tauto.
Defined.

Remark rem_694 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_agent i -> auto_knows_old i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_old. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_693 epsilon_magent_pknows_old);  tauto.
Defined.

Remark rem_695 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_knows_old server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_old.  case (rem_688 epsilon_magent_pknows_old). clear  epsilon_magent_pknows_old. intros. apply trans_knows_old_server_1;  tauto.
 clear  epsilon_magent_pknows_old. tauto.
Defined.

Remark rem_696 : (forall X:term, auto_agent X -> auto_knows_old X)
    -> auto_agent server -> auto_knows_old server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_old. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_695 epsilon_magent_pknows_old);  tauto.
Defined.

Remark rem_697 : forall X2:term, auto_agent X2 -> auto_knows_old X2. (* Induct. *)
Proof.
  fix epsilon_magent_pknows_old 1.
  intro X. case X.
  exact (rem_690 epsilon_magent_pknows_old ).
  exact (rem_692 epsilon_magent_pknows_old ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_694 epsilon_magent_pknows_old ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_696 epsilon_magent_pknows_old ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_698 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto_agent X2 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_knows_old X2). tauto. exact (rem_697 X2).
Qed.

Remark rem_699 : forall X3:term, auto_knows_old X3 -> auto_knows_old X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_700 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto_agent X2 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X3 -> auto_knows_old X3). tauto. exact (rem_699 X3).
Qed.

Remark rem_701 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto_agent X2 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_agent X2 /\ auto_knows_old X2 /\ auto_knows_old X3) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5.
  cut (auto_knows_old X1). 2:apply (rem_685 X1 X2 X3 X4);  assumption.
  cut (auto_agent X2). 2:apply (rem_687 X1 X2 X3 X4);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_698 X1 X2 X3 X4);  assumption.
  cut (auto_knows_old X3). 2:apply (rem_700 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_702 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto_agent X2 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_30 (session_old X1 X2 X3). (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5.
  case (rem_701 X1 X2 X3 X4 A1 A2 A3 A4 A5). clear  A1 A2 A3 A4 A5. intros. apply trans___def_30_session_old_1;  tauto.
 clear  A1 A2 A3 A4 A5. tauto.
Qed.

Remark rem_703 : forall X1 X2 X3 X4:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X2 -> auto___def_10 X4 -> auto_knows_old X3 -> auto___def_30 (session_old X1 X2 X3). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_10 X4 -> auto_agent X2 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_30 (session_old X1 X2 X3)). tauto. exact (rem_702 X1 X2 X3 X4).
Qed.

Remark rem_704 : forall X1 X2 X3 X4:term, auto___def_22 X1 X2 X4 X3 -> auto___def_30 (session_old X1 X2 X3). (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_444 X1 X2 X4 X3 H);  intros.
  apply (rem_703 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_705 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current.  tauto.
Defined.

Remark rem_706 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current.  case (rem_705 epsilon_m__type_1_pknows_current). clear  epsilon_m__type_1_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_1_pknows_current. tauto.
Defined.

Remark rem_707 : auto___type_1 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_708 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto___type_1 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intro H. intros.
  elim (rem_707 H);  intros.
  apply (rem_706 epsilon_m__type_1_pknows_current);  tauto.
Defined.

Remark rem_709 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  tauto.
Defined.

Remark rem_710 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_709 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_noncea_old_1;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_711 : forall X1 X2:term, auto___type_1 (noncea_old X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_712 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 (noncea_old X1 X2) -> auto_knows_current (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_711 X1 X2 H);  intros.
  apply (rem_710 epsilon_m__type_1_pknows_current X1 X2);  tauto.
Defined.

Remark rem_713 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current.  case (rem_705 epsilon_m__type_1_pknows_current). clear  epsilon_m__type_1_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_1_pknows_current. tauto.
Defined.

Remark rem_714 : auto___type_1 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_715 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto___type_1 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intro H. intros.
  elim (rem_714 H);  intros.
  apply (rem_713 epsilon_m__type_1_pknows_current);  tauto.
Defined.

Remark rem_716 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current.  tauto.
Defined.

Remark rem_717 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current.  case (rem_716 epsilon_mknows_old_pknows_current). clear  epsilon_mknows_old_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_mknows_old_pknows_current. tauto.
Defined.

Remark rem_718 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_old alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intro H. intros.
  elim (rem_354 H);  intros.
  apply (rem_717 epsilon_mknows_old_pknows_current);  tauto.
Defined.

Remark rem_719 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  tauto.
Defined.

Remark rem_720 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_719 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_noncea_old_1;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_721 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old (noncea_old X1 X2) -> auto_knows_current (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_362 X1 X2 H);  intros.
  apply (rem_720 epsilon_mknows_old_pknows_current X1 X2);  tauto.
Defined.

Remark rem_722 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current.  case (rem_716 epsilon_mknows_old_pknows_current). clear  epsilon_mknows_old_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_mknows_old_pknows_current. tauto.
Defined.

Remark rem_723 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_old bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intro H. intros.
  elim (rem_365 H);  intros.
  apply (rem_722 epsilon_mknows_old_pknows_current);  tauto.
Defined.

Remark rem_724 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1. (* Use induction hypothesis. *)
Proof.
   intro Hrec. intros X1.
  cut (auto_knows_old X1 -> auto_knows_current X1). tauto. exact (Hrec X1).
Defined.

Remark rem_725 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_724 epsilon_mknows_old_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_726 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1. intros A1.
  case (rem_725 epsilon_mknows_old_pknows_current X1 A1). clear  epsilon_mknows_old_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_mknows_old_pknows_current A1. tauto.
Defined.

Remark rem_727 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old (s X1) -> auto_knows_current (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1. intro H. intros.
  elim (rem_370 X1 H);  intros.
  apply (rem_726 epsilon_mknows_old_pknows_current X1);  tauto.
Defined.

Remark rem_728 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current.  case (rem_716 epsilon_mknows_old_pknows_current). clear  epsilon_mknows_old_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_mknows_old_pknows_current. tauto.
Defined.

Remark rem_729 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_old nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intro H. intros.
  elim (rem_373 H);  intros.
  apply (rem_728 epsilon_mknows_old_pknows_current);  tauto.
Defined.

Remark rem_730 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current.  case (rem_716 epsilon_mknows_old_pknows_current). clear  epsilon_mknows_old_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_mknows_old_pknows_current. tauto.
Defined.

Remark rem_731 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_old i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intro H. intros.
  elim (rem_376 H);  intros.
  apply (rem_730 epsilon_mknows_old_pknows_current);  tauto.
Defined.

Remark rem_732 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_current X1). tauto. exact (rem_724 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_733 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_current X2. (* Use induction hypothesis. *)
Proof.
   intro Hrec. intros X2.
  cut (auto_knows_old X2 -> auto_knows_current X2). tauto. exact (Hrec X2).
Defined.

Remark rem_734 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_current X2). tauto. exact (rem_733 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_735 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_732 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_734 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_736 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_735 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_737 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_383 X1 X2 H);  intros.
  apply (rem_736 epsilon_mknows_old_pknows_current X1 X2);  tauto.
Defined.

Remark rem_738 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current.  case (rem_716 epsilon_mknows_old_pknows_current). clear  epsilon_mknows_old_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_mknows_old_pknows_current. tauto.
Defined.

Remark rem_739 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> auto_knows_old server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intro H. intros.
  elim (rem_386 H);  intros.
  apply (rem_738 epsilon_mknows_old_pknows_current);  tauto.
Defined.

Remark rem_740 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_741 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_740 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_742 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_743 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_742 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_744 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_741 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_743 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_745 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_744 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_key_2;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_746 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_747 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_746 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_748 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_749 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_748 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_750 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_747 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_749 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_751 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_750 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_key_3;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_752 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_330 X1 X2 H);  intros.
  apply (rem_745 epsilon_mknows_old_pknows_current X1 X2);  tauto.
  apply (rem_751 epsilon_mknows_old_pknows_current X1 X2);  tauto.
Defined.

Remark rem_753 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_735 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_754 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_755 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_754 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_756 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_757 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_756 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_758 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_755 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_757 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_759 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_758 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_crypt_1;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_760 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_761 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_760 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_762 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_763 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_762 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_764 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_761 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_763 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_765 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_764 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_crypt_2;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_766 : (forall X:term, auto___def_42 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto___type_5 X2 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_42_pknows_current. intros X1 X2. intros A1 A2 A3.
  tauto.
Defined.

Remark rem_767 : (forall X:term, auto___def_42 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_current (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_42_pknows_current. intros X1 X2. intros A1 A2 A3.
  case (rem_766 epsilon_m__def_42_pknows_current X1 X2 A1 A2 A3). clear  epsilon_m__def_42_pknows_current A1 A2 A3. intros. apply trans_knows_current_nonceb_old_1;  tauto.
 clear  epsilon_m__def_42_pknows_current A1 A2 A3. tauto.
Defined.

Remark rem_768 : forall X1 X2:term, auto___def_42 (nonceb_old X1 X2) -> or_1
    (auto_knows_old X1 /\ auto___type_5 X2 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_769 : (forall X:term, auto___def_42 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 (nonceb_old X1 X2) -> auto_knows_current (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_42_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_768 X1 X2 H);  intros.
  apply (rem_767 epsilon_m__def_42_pknows_current X1 X2);  tauto.
Defined.

Remark rem_770 : auto___def_42 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_771 : forall X1 X2:term, auto___def_42 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_772 : auto___def_42 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_773 : auto___def_42 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_774 : forall X1:term, auto___def_42 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_775 : auto___def_42 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_776 : auto___def_42 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_777 : auto___def_42 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_778 : forall X1 X2:term, auto___def_42 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_779 : auto___def_42 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_780 : auto___def_42 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_781 : forall X1 X2:term, auto___def_42 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_782 : forall X1 X2:term, auto___def_42 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_783 : forall X1 X2 X3:term, auto___def_42 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_784 : forall X1 X2:term, auto___def_42 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_785 : forall X1 X2 X3:term, auto___def_42 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_786 : forall X1 X2:term, auto___def_42 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_787 : forall X1:term, auto___def_42 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_42_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_770  H).
   intro H. elim (rem_773  H).
  intros X1 X2. intro H. elim (rem_778 X1 X2 H).
  intros X1 X2. intro H. elim (rem_784 X1 X2 H).
   intro H. elim (rem_776  H).
  intros X1 X2. intro H. elim (rem_781 X1 X2 H).
   intro H. elim (rem_775  H).
  intros X1 X2. intro H. elim (rem_782 X1 X2 H).
  intros X1 X2. intro H. elim (rem_771 X1 X2 H).
  intros X1 X2. intro H. elim (rem_786 X1 X2 H).
  intros X1 X2;  exact (rem_769 epsilon_m__def_42_pknows_current X1 X2).
   intro H. elim (rem_772  H).
   intro H. elim (rem_777  H).
  intros X1. intro H. elim (rem_774 X1 H).
   intro H. elim (rem_779  H).
  intros X1 X2 X3. intro H. elim (rem_783 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_785 X1 X2 X3 H).
   intro H. elim (rem_780  H).
Qed.

Remark rem_788 : (forall X:term, auto___def_44 X -> auto_knows_current X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_44_pknows_current. exact (rem_787).
Defined.

Remark rem_789 : (forall X:term, auto___def_44 X -> auto_knows_current X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_44_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_788 epsilon_m__def_44_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_790 : (forall X:term, auto___def_44 X -> auto_knows_current X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_44_pknows_current. intros X1. intros A1.
  case (rem_789 epsilon_m__def_44_pknows_current X1 A1). clear  epsilon_m__def_44_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_m__def_44_pknows_current A1. tauto.
Defined.

Remark rem_791 : (forall X:term, auto___def_44 X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current X1. (* Use induction hypothesis. *)
Proof.
   intro Hrec. intros X1.
  cut (auto___def_44 X1 -> auto_knows_current X1). tauto. exact (Hrec X1).
Defined.

Remark rem_792 : (forall X:term, auto___def_44 X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_44_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_791 epsilon_m__def_44_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_793 : (forall X:term, auto___def_44 X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_44_pknows_current. intros X1. intros A1.
  case (rem_792 epsilon_m__def_44_pknows_current X1 A1). clear  epsilon_m__def_44_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_m__def_44_pknows_current A1. tauto.
Defined.

Remark rem_794 : forall X1:term, auto___def_44 (s X1) -> or_2
    (auto___def_42 X1)    (auto___def_44 X1).
Proof.
  intros. inversion H.
  intros. apply or_2_intro_1; tauto.
  intros. apply or_2_intro_2; tauto.
Qed.

Remark rem_795 : (forall X:term, auto___def_44 X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 (s X1) -> auto_knows_current (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_44_pknows_current. intros X1. intro H. intros.
  elim (rem_794 X1 H);  intros.
  apply (rem_790 epsilon_m__def_44_pknows_current X1);  tauto.
  apply (rem_793 epsilon_m__def_44_pknows_current X1);  tauto.
Defined.

Remark rem_796 : auto___def_44 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_797 : forall X1 X2:term, auto___def_44 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_798 : auto___def_44 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_799 : auto___def_44 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_800 : auto___def_44 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_801 : auto___def_44 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_802 : auto___def_44 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_803 : forall X1 X2:term, auto___def_44 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_804 : auto___def_44 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_805 : auto___def_44 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_806 : forall X1 X2:term, auto___def_44 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_807 : forall X1 X2:term, auto___def_44 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_808 : forall X1 X2:term, auto___def_44 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_809 : forall X1 X2 X3:term, auto___def_44 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_810 : forall X1 X2:term, auto___def_44 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_811 : forall X1 X2 X3:term, auto___def_44 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_812 : forall X1 X2:term, auto___def_44 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_813 : forall X1:term, auto___def_44 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_44_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_796  H).
   intro H. elim (rem_799  H).
  intros X1 X2. intro H. elim (rem_803 X1 X2 H).
  intros X1 X2. intro H. elim (rem_810 X1 X2 H).
   intro H. elim (rem_801  H).
  intros X1 X2. intro H. elim (rem_806 X1 X2 H).
   intro H. elim (rem_800  H).
  intros X1 X2. intro H. elim (rem_808 X1 X2 H).
  intros X1 X2. intro H. elim (rem_797 X1 X2 H).
  intros X1 X2. intro H. elim (rem_812 X1 X2 H).
  intros X1 X2. intro H. elim (rem_807 X1 X2 H).
   intro H. elim (rem_798  H).
   intro H. elim (rem_802  H).
  intros X1;  exact (rem_795 epsilon_m__def_44_pknows_current X1).
   intro H. elim (rem_804  H).
  intros X1 X2 X3. intro H. elim (rem_809 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_811 X1 X2 X3 H).
   intro H. elim (rem_805  H).
Qed.

Remark rem_814 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_mknows_old_pknows_current. exact (rem_813).
Defined.

Remark rem_815 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_44 X1 -> auto_knows_current X1). tauto. exact (rem_814 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_816 : (forall X:term, auto___def_29 X -> auto___def_49 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_29_p__def_49.  tauto.
Defined.

Remark rem_817 : (forall X:term, auto___def_29 X -> auto___def_49 X)
    -> auto___def_49 sym. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_29_p__def_49.  case (rem_816 epsilon_m__def_29_p__def_49). clear  epsilon_m__def_29_p__def_49. intros. apply trans___def_49_sym_1;  tauto.
 clear  epsilon_m__def_29_p__def_49. tauto.
Defined.

Remark rem_818 : auto___def_29 sym -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_819 : (forall X:term, auto___def_29 X -> auto___def_49 X)
    -> auto___def_29 sym -> auto___def_49 sym. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_29_p__def_49. intro H. intros.
  elim (rem_818 H);  intros.
  apply (rem_817 epsilon_m__def_29_p__def_49);  tauto.
Defined.

Remark rem_820 : auto___def_29 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_821 : forall X1 X2:term, auto___def_29 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_822 : auto___def_29 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_823 : forall X1:term, auto___def_29 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_824 : auto___def_29 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_825 : auto___def_29 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_826 : auto___def_29 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_827 : forall X1 X2:term, auto___def_29 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_828 : auto___def_29 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_829 : forall X1 X2:term, auto___def_29 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_830 : forall X1 X2:term, auto___def_29 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_831 : forall X1 X2:term, auto___def_29 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_832 : forall X1 X2 X3:term, auto___def_29 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_833 : forall X1 X2:term, auto___def_29 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_834 : forall X1 X2 X3:term, auto___def_29 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_835 : forall X1 X2:term, auto___def_29 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_836 : forall X1:term, auto___def_29 X1 -> auto___def_49 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_29_p__def_49 1.
  intro X. case X.
   intro H. elim (rem_820  H).
   intro H. elim (rem_822  H).
  intros X1 X2. intro H. elim (rem_827 X1 X2 H).
  intros X1 X2. intro H. elim (rem_833 X1 X2 H).
   intro H. elim (rem_825  H).
  intros X1 X2. intro H. elim (rem_829 X1 X2 H).
   intro H. elim (rem_824  H).
  intros X1 X2. intro H. elim (rem_831 X1 X2 H).
  intros X1 X2. intro H. elim (rem_821 X1 X2 H).
  intros X1 X2. intro H. elim (rem_835 X1 X2 H).
  intros X1 X2. intro H. elim (rem_830 X1 X2 H).
   intro H. elim (rem_332  H).
   intro H. elim (rem_826  H).
  intros X1. intro H. elim (rem_823 X1 H).
   intro H. elim (rem_828  H).
  intros X1 X2 X3. intro H. elim (rem_832 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_834 X1 X2 X3 H).
  exact (rem_819 epsilon_m__def_29_p__def_49 ).
Qed.

Remark rem_837 : (forall X:term, auto___type_9 X -> auto_knows_current X)
    -> forall X1:term, auto___def_29 X1 -> auto___def_49 X1. (* Cut history. *)
Proof.  intros epsilon_m__type_9_pknows_current. exact (rem_836).
Defined.

Remark rem_838 : (forall X:term, auto___type_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_9_pknows_current. intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_49 X1). tauto. exact (rem_837 epsilon_m__type_9_pknows_current X1).
Defined.

Remark rem_839 : (forall X:term, auto___def_30 X -> auto___def_50 X)
    -> forall X1 X2 X3:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X2 -> auto_knows_old X3 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_30_p__def_50. intros X1 X2 X3. intros A1 A2 A3 A4.
  tauto.
Defined.

Remark rem_840 : (forall X:term, auto___def_30 X -> auto___def_50 X)
    -> forall X1 X2 X3:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X2 -> auto_knows_old X3 -> auto___def_50 (session_old X1 X2 X3). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_30_p__def_50. intros X1 X2 X3. intros A1 A2 A3 A4.
  case (rem_839 epsilon_m__def_30_p__def_50 X1 X2 X3 A1 A2 A3 A4). clear  epsilon_m__def_30_p__def_50 A1 A2 A3 A4. intros. apply trans___def_50_session_old_1;  tauto.
 clear  epsilon_m__def_30_p__def_50 A1 A2 A3 A4. tauto.
Defined.

Remark rem_841 : forall X1 X2 X3:term, auto___def_30 (session_old X1 X2 X3) -> or_1
    (auto_knows_old X1 /\ auto_agent X2 /\ auto_knows_old X2 /\ auto_knows_old X3)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_842 : (forall X:term, auto___def_30 X -> auto___def_50 X)
    -> forall X1 X2 X3:term, auto___def_30 (session_old X1 X2 X3) -> auto___def_50 (session_old X1 X2 X3). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_30_p__def_50. intros X1 X2 X3. intro H. intros.
  elim (rem_841 X1 X2 X3 H);  intros.
  apply (rem_840 epsilon_m__def_30_p__def_50 X1 X2 X3);  tauto.
Defined.

Remark rem_843 : auto___def_30 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_844 : forall X1 X2:term, auto___def_30 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_845 : auto___def_30 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_846 : auto___def_30 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_847 : forall X1:term, auto___def_30 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_848 : auto___def_30 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_849 : auto___def_30 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_850 : auto___def_30 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_851 : forall X1 X2:term, auto___def_30 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_852 : auto___def_30 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_853 : auto___def_30 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_854 : forall X1 X2:term, auto___def_30 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_855 : forall X1 X2:term, auto___def_30 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_856 : forall X1 X2:term, auto___def_30 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_857 : forall X1 X2 X3:term, auto___def_30 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_858 : forall X1 X2:term, auto___def_30 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_859 : forall X1 X2:term, auto___def_30 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_860 : forall X2:term, auto___def_30 X2 -> auto___def_50 X2. (* Induct. *)
Proof.
  fix epsilon_m__def_30_p__def_50 1.
  intro X. case X.
   intro H. elim (rem_843  H).
   intro H. elim (rem_846  H).
  intros X1 X2. intro H. elim (rem_851 X1 X2 H).
  intros X1 X2. intro H. elim (rem_858 X1 X2 H).
   intro H. elim (rem_849  H).
  intros X1 X2. intro H. elim (rem_854 X1 X2 H).
   intro H. elim (rem_848  H).
  intros X1 X2. intro H. elim (rem_856 X1 X2 H).
  intros X1 X2. intro H. elim (rem_844 X1 X2 H).
  intros X1 X2. intro H. elim (rem_859 X1 X2 H).
  intros X1 X2. intro H. elim (rem_855 X1 X2 H).
   intro H. elim (rem_845  H).
   intro H. elim (rem_850  H).
  intros X1. intro H. elim (rem_847 X1 H).
   intro H. elim (rem_852  H).
  intros X1 X2 X3. intro H. elim (rem_857 X1 X2 X3 H).
  intros X1 X2 X3;  exact (rem_842 epsilon_m__def_30_p__def_50 X1 X2 X3).
   intro H. elim (rem_853  H).
Qed.

Remark rem_861 : (forall X:term, auto___type_9 X -> auto_knows_current X)
    -> forall X2:term, auto___def_30 X2 -> auto___def_50 X2. (* Cut history. *)
Proof.  intros epsilon_m__type_9_pknows_current. exact (rem_860).
Defined.

Remark rem_862 : (forall X:term, auto___type_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_9_pknows_current. intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_50 X2). tauto. exact (rem_861 epsilon_m__type_9_pknows_current X2).
Defined.

Remark rem_863 : (forall X:term, auto___type_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_9_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_838 epsilon_m__type_9_pknows_current X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_862 epsilon_m__type_9_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_864 : (forall X:term, auto___type_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_9_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_863 epsilon_m__type_9_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_9_pknows_current A1 A2. intros. apply trans_knows_current_key_1;  tauto.
 clear  epsilon_m__type_9_pknows_current A1 A2. tauto.
Defined.

Remark rem_865 : (forall X:term, auto___type_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_9 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_9_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_341 X1 X2 H);  intros.
  apply (rem_864 epsilon_m__type_9_pknows_current X1 X2);  tauto.
Defined.

Remark rem_866 : auto___type_9 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_867 : forall X1 X2:term, auto___type_9 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_868 : auto___type_9 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_869 : auto___type_9 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_870 : forall X1:term, auto___type_9 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_871 : auto___type_9 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_872 : auto___type_9 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_873 : auto___type_9 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_874 : forall X1 X2:term, auto___type_9 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_875 : auto___type_9 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_876 : auto___type_9 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_877 : forall X1 X2:term, auto___type_9 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_878 : forall X1 X2:term, auto___type_9 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_879 : forall X1 X2 X3:term, auto___type_9 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_880 : forall X1 X2:term, auto___type_9 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_881 : forall X1 X2 X3:term, auto___type_9 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_882 : forall X1 X2:term, auto___type_9 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_883 : forall X2:term, auto___type_9 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__type_9_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_866  H).
   intro H. elim (rem_869  H).
  intros X1 X2. intro H. elim (rem_874 X1 X2 H).
  intros X1 X2. intro H. elim (rem_880 X1 X2 H).
   intro H. elim (rem_872  H).
  intros X1 X2;  exact (rem_865 epsilon_m__type_9_pknows_current X1 X2).
   intro H. elim (rem_871  H).
  intros X1 X2. intro H. elim (rem_878 X1 X2 H).
  intros X1 X2. intro H. elim (rem_867 X1 X2 H).
  intros X1 X2. intro H. elim (rem_882 X1 X2 H).
  intros X1 X2. intro H. elim (rem_877 X1 X2 H).
   intro H. elim (rem_868  H).
   intro H. elim (rem_873  H).
  intros X1. intro H. elim (rem_870 X1 H).
   intro H. elim (rem_875  H).
  intros X1 X2 X3. intro H. elim (rem_879 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_881 X1 X2 X3 H).
   intro H. elim (rem_876  H).
Qed.

Remark rem_884 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto___type_9 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_mknows_old_pknows_current. exact (rem_883).
Defined.

Remark rem_885 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___type_9 X2 -> auto_knows_current X2). tauto. exact (rem_884 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_886 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_815 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_885 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_887 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_886 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_888 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_mknows_old_pknows_current. exact (rem_787).
Defined.

Remark rem_889 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_42 X1 -> auto_knows_current X1). tauto. exact (rem_888 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_890 : (forall X:term, auto___type_8 X -> auto_knows_current X)
    -> forall X1:term, auto___def_29 X1 -> auto___def_49 X1. (* Cut history. *)
Proof.  intros epsilon_m__type_8_pknows_current. exact (rem_836).
Defined.

Remark rem_891 : (forall X:term, auto___type_8 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_8_pknows_current. intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_49 X1). tauto. exact (rem_890 epsilon_m__type_8_pknows_current X1).
Defined.

Remark rem_892 : (forall X:term, auto___type_8 X -> auto_knows_current X)
    -> forall X2:term, auto___def_30 X2 -> auto___def_50 X2. (* Cut history. *)
Proof.  intros epsilon_m__type_8_pknows_current. exact (rem_860).
Defined.

Remark rem_893 : (forall X:term, auto___type_8 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_8_pknows_current. intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_50 X2). tauto. exact (rem_892 epsilon_m__type_8_pknows_current X2).
Defined.

Remark rem_894 : (forall X:term, auto___type_8 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_8_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_891 epsilon_m__type_8_pknows_current X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_893 epsilon_m__type_8_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_895 : (forall X:term, auto___type_8 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_8_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_894 epsilon_m__type_8_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_8_pknows_current A1 A2. intros. apply trans_knows_current_key_1;  tauto.
 clear  epsilon_m__type_8_pknows_current A1 A2. tauto.
Defined.

Remark rem_896 : (forall X:term, auto___type_8 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_8 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_8_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_344 X1 X2 H);  intros.
  apply (rem_895 epsilon_m__type_8_pknows_current X1 X2);  tauto.
Defined.

Remark rem_897 : auto___type_8 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_898 : forall X1 X2:term, auto___type_8 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_899 : auto___type_8 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_900 : auto___type_8 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_901 : forall X1:term, auto___type_8 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_902 : auto___type_8 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_903 : auto___type_8 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_904 : auto___type_8 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_905 : forall X1 X2:term, auto___type_8 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_906 : auto___type_8 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_907 : auto___type_8 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_908 : forall X1 X2:term, auto___type_8 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_909 : forall X1 X2:term, auto___type_8 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_910 : forall X1 X2 X3:term, auto___type_8 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_911 : forall X1 X2:term, auto___type_8 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_912 : forall X1 X2 X3:term, auto___type_8 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_913 : forall X1 X2:term, auto___type_8 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_914 : forall X2:term, auto___type_8 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__type_8_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_897  H).
   intro H. elim (rem_900  H).
  intros X1 X2. intro H. elim (rem_905 X1 X2 H).
  intros X1 X2. intro H. elim (rem_911 X1 X2 H).
   intro H. elim (rem_903  H).
  intros X1 X2;  exact (rem_896 epsilon_m__type_8_pknows_current X1 X2).
   intro H. elim (rem_902  H).
  intros X1 X2. intro H. elim (rem_909 X1 X2 H).
  intros X1 X2. intro H. elim (rem_898 X1 X2 H).
  intros X1 X2. intro H. elim (rem_913 X1 X2 H).
  intros X1 X2. intro H. elim (rem_908 X1 X2 H).
   intro H. elim (rem_899  H).
   intro H. elim (rem_904  H).
  intros X1. intro H. elim (rem_901 X1 H).
   intro H. elim (rem_906  H).
  intros X1 X2 X3. intro H. elim (rem_910 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_912 X1 X2 X3 H).
   intro H. elim (rem_907  H).
Qed.

Remark rem_915 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto___type_8 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_mknows_old_pknows_current. exact (rem_914).
Defined.

Remark rem_916 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___type_8 X2 -> auto_knows_current X2). tauto. exact (rem_915 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_917 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_889 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_916 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_918 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_917 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_919 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_920 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_919 epsilon_mknows_old_pknows_current X1).
Defined.

Remark rem_921 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_922 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_921 epsilon_mknows_old_pknows_current X2).
Defined.

Remark rem_923 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_920 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_922 epsilon_mknows_old_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_924 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_923 epsilon_mknows_old_pknows_current X1 X2 A1 A2). clear  epsilon_mknows_old_pknows_current A1 A2. intros. apply trans_knows_current_crypt_9;  tauto.
 clear  epsilon_mknows_old_pknows_current A1 A2. tauto.
Defined.

Remark rem_925 : (forall X:term, auto_knows_old X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_350 X1 X2 H);  intros.
  apply (rem_753 epsilon_mknows_old_pknows_current X1 X2);  tauto.
  apply (rem_759 epsilon_mknows_old_pknows_current X1 X2);  tauto.
  apply (rem_765 epsilon_mknows_old_pknows_current X1 X2);  tauto.
  apply (rem_887 epsilon_mknows_old_pknows_current X1 X2);  tauto.
  apply (rem_918 epsilon_mknows_old_pknows_current X1 X2);  tauto.
  apply (rem_924 epsilon_mknows_old_pknows_current X1 X2);  tauto.
Defined.

Remark rem_926 : forall X1:term, auto_knows_old X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_mknows_old_pknows_current 1.
  intro X. case X.
  exact (rem_718 epsilon_mknows_old_pknows_current ).
  exact (rem_723 epsilon_mknows_old_pknows_current ).
  intros X1 X2;  exact (rem_737 epsilon_mknows_old_pknows_current X1 X2).
  intros X1 X2;  exact (rem_925 epsilon_mknows_old_pknows_current X1 X2).
  exact (rem_731 epsilon_mknows_old_pknows_current ).
  intros X1 X2;  exact (rem_752 epsilon_mknows_old_pknows_current X1 X2).
  exact (rem_729 epsilon_mknows_old_pknows_current ).
  intros X1 X2. intro H. elim (rem_437 X1 X2 H).
  intros X1 X2;  exact (rem_721 epsilon_mknows_old_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_440 X1 X2 H).
  intros X1 X2. intro H. elim (rem_436 X1 X2 H).
   intro H. elim (rem_433  H).
   intro H. elim (rem_434  H).
  intros X1;  exact (rem_727 epsilon_mknows_old_pknows_current X1).
  exact (rem_739 epsilon_mknows_old_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_438 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_439 X1 X2 X3 H).
   intro H. elim (rem_435  H).
Qed.

Remark rem_927 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_1_pknows_current. exact (rem_926).
Defined.

Remark rem_928 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_927 epsilon_m__type_1_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_929 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1. intros A1.
  case (rem_928 epsilon_m__type_1_pknows_current X1 A1). clear  epsilon_m__type_1_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_m__type_1_pknows_current A1. tauto.
Defined.

Remark rem_930 : forall X1:term, auto___type_1 (s X1) -> or_1
    (auto_knows_old X1).
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_931 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___type_1 (s X1) -> auto_knows_current (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1. intro H. intros.
  elim (rem_930 X1 H);  intros.
  apply (rem_929 epsilon_m__type_1_pknows_current X1);  tauto.
Defined.

Remark rem_932 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current.  case (rem_705 epsilon_m__type_1_pknows_current). clear  epsilon_m__type_1_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__type_1_pknows_current. tauto.
Defined.

Remark rem_933 : auto___type_1 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_934 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto___type_1 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intro H. intros.
  elim (rem_933 H);  intros.
  apply (rem_932 epsilon_m__type_1_pknows_current);  tauto.
Defined.

Remark rem_935 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current.  case (rem_705 epsilon_m__type_1_pknows_current). clear  epsilon_m__type_1_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_1_pknows_current. tauto.
Defined.

Remark rem_936 : auto___type_1 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_937 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto___type_1 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intro H. intros.
  elim (rem_936 H);  intros.
  apply (rem_935 epsilon_m__type_1_pknows_current);  tauto.
Defined.

Remark rem_938 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_current X1). tauto. exact (rem_927 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_939 : forall X2:term, auto_knows_old X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_mknows_old_pknows_current 1.
  intro X. case X.
  exact (rem_718 epsilon_mknows_old_pknows_current ).
  exact (rem_723 epsilon_mknows_old_pknows_current ).
  intros X1 X2;  exact (rem_737 epsilon_mknows_old_pknows_current X1 X2).
  intros X1 X2;  exact (rem_925 epsilon_mknows_old_pknows_current X1 X2).
  exact (rem_731 epsilon_mknows_old_pknows_current ).
  intros X1 X2;  exact (rem_752 epsilon_mknows_old_pknows_current X1 X2).
  exact (rem_729 epsilon_mknows_old_pknows_current ).
  intros X1 X2. intro H. elim (rem_437 X1 X2 H).
  intros X1 X2;  exact (rem_721 epsilon_mknows_old_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_440 X1 X2 H).
  intros X1 X2. intro H. elim (rem_436 X1 X2 H).
   intro H. elim (rem_433  H).
   intro H. elim (rem_434  H).
  intros X1;  exact (rem_727 epsilon_mknows_old_pknows_current X1).
  exact (rem_739 epsilon_mknows_old_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_438 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_439 X1 X2 X3 H).
   intro H. elim (rem_435  H).
Qed.

Remark rem_940 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_1_pknows_current. exact (rem_939).
Defined.

Remark rem_941 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_current X2). tauto. exact (rem_940 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_942 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_938 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_941 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_943 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_942 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_944 : forall X1 X2:term, auto___type_1 (cons X1 X2) -> or_1
    (auto_knows_old X1 /\ auto_knows_old X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_945 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_944 X1 X2 H);  intros.
  apply (rem_943 epsilon_m__type_1_pknows_current X1 X2);  tauto.
Defined.

Remark rem_946 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current.  case (rem_705 epsilon_m__type_1_pknows_current). clear  epsilon_m__type_1_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_1_pknows_current. tauto.
Defined.

Remark rem_947 : auto___type_1 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_948 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> auto___type_1 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intro H. intros.
  elim (rem_947 H);  intros.
  apply (rem_946 epsilon_m__type_1_pknows_current);  tauto.
Defined.

Remark rem_949 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_950 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_949 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_951 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_952 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_951 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_953 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_950 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_952 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_954 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_953 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_key_2;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_955 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_956 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_955 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_957 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_958 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_957 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_959 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_956 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_958 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_960 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_959 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_key_3;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_961 : forall X1 X2:term, auto___type_1 (key X1 X2) -> or_2
    (auto___def_47 X1 /\ auto___def_48 X2)
    (auto___def_46 X1 /\ auto___type_10 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_2_intro_1; tauto.
  intros. apply or_2_intro_2; tauto.
Qed.

Remark rem_962 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_961 X1 X2 H);  intros.
  apply (rem_954 epsilon_m__type_1_pknows_current X1 X2);  tauto.
  apply (rem_960 epsilon_m__type_1_pknows_current X1 X2);  tauto.
Defined.

Remark rem_963 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_942 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_964 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_965 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_964 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_966 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_967 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_966 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_968 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_965 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_967 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_969 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_968 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_crypt_1;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_970 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_971 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_970 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_972 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_973 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_972 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_974 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_971 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_973 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_975 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_974 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_crypt_2;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_976 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_1_pknows_current. exact (rem_813).
Defined.

Remark rem_977 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_44 X1 -> auto_knows_current X1). tauto. exact (rem_976 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_978 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto___type_9 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_1_pknows_current. exact (rem_883).
Defined.

Remark rem_979 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___type_9 X2 -> auto_knows_current X2). tauto. exact (rem_978 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_980 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_977 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_979 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_981 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_980 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_982 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_1_pknows_current. exact (rem_787).
Defined.

Remark rem_983 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_42 X1 -> auto_knows_current X1). tauto. exact (rem_982 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_984 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto___type_8 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_1_pknows_current. exact (rem_914).
Defined.

Remark rem_985 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___type_8 X2 -> auto_knows_current X2). tauto. exact (rem_984 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_986 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_983 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_985 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_987 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_986 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_988 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_989 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_988 epsilon_m__type_1_pknows_current X1).
Defined.

Remark rem_990 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_991 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_990 epsilon_m__type_1_pknows_current X2).
Defined.

Remark rem_992 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_989 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_991 epsilon_m__type_1_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_993 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_992 epsilon_m__type_1_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_current A1 A2. intros. apply trans_knows_current_crypt_9;  tauto.
 clear  epsilon_m__type_1_pknows_current A1 A2. tauto.
Defined.

Remark rem_994 : forall X1 X2:term, auto___type_1 (crypt X1 X2) -> or_6
    (auto_knows_old X1 /\ auto_knows_old X2)
    (auto___def_23 X1 /\ auto___def_24 X2)
    (auto___def_33 X1 /\ auto___def_34 X2)
    (auto___def_44 X1 /\ auto___type_9 X2)
    (auto___def_42 X1 /\ auto___type_8 X2)
    (auto___def_7 X1 /\ auto___def_8 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_6_intro_1; tauto.
  intros. apply or_6_intro_2; tauto.
  intros. apply or_6_intro_3; tauto.
  intros. apply or_6_intro_4; tauto.
  intros. apply or_6_intro_5; tauto.
  intros. apply or_6_intro_6; tauto.
Qed.

Remark rem_995 : (forall X:term, auto___type_1 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_994 X1 X2 H);  intros.
  apply (rem_963 epsilon_m__type_1_pknows_current X1 X2);  tauto.
  apply (rem_969 epsilon_m__type_1_pknows_current X1 X2);  tauto.
  apply (rem_975 epsilon_m__type_1_pknows_current X1 X2);  tauto.
  apply (rem_981 epsilon_m__type_1_pknows_current X1 X2);  tauto.
  apply (rem_987 epsilon_m__type_1_pknows_current X1 X2);  tauto.
  apply (rem_993 epsilon_m__type_1_pknows_current X1 X2);  tauto.
Defined.

Remark rem_996 : auto___type_1 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_997 : auto___type_1 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_998 : auto___type_1 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_999 : forall X1 X2:term, auto___type_1 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1000 : forall X1 X2:term, auto___type_1 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1001 : forall X1 X2 X3:term, auto___type_1 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1002 : forall X1 X2 X3:term, auto___type_1 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1003 : forall X1 X2:term, auto___type_1 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1004 : forall X1:term, auto___type_1 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_1_pknows_current 1.
  intro X. case X.
  exact (rem_708 epsilon_m__type_1_pknows_current ).
  exact (rem_715 epsilon_m__type_1_pknows_current ).
  intros X1 X2;  exact (rem_945 epsilon_m__type_1_pknows_current X1 X2).
  intros X1 X2;  exact (rem_995 epsilon_m__type_1_pknows_current X1 X2).
  exact (rem_937 epsilon_m__type_1_pknows_current ).
  intros X1 X2;  exact (rem_962 epsilon_m__type_1_pknows_current X1 X2).
  exact (rem_934 epsilon_m__type_1_pknows_current ).
  intros X1 X2. intro H. elim (rem_1000 X1 X2 H).
  intros X1 X2;  exact (rem_712 epsilon_m__type_1_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_1003 X1 X2 H).
  intros X1 X2. intro H. elim (rem_999 X1 X2 H).
   intro H. elim (rem_996  H).
   intro H. elim (rem_997  H).
  intros X1;  exact (rem_931 epsilon_m__type_1_pknows_current X1).
  exact (rem_948 epsilon_m__type_1_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_1001 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1002 X1 X2 X3 H).
   intro H. elim (rem_998  H).
Qed.

Remark rem_1005 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_1 X1 -> auto_knows_current X1). tauto. exact (rem_1004 X1).
Qed.

Remark rem_1006 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_1007 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_pknows_current.  tauto.
Defined.

Remark rem_1008 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_current.  case (rem_1007 epsilon_magent_pknows_current). clear  epsilon_magent_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_magent_pknows_current. tauto.
Defined.

Remark rem_1009 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_agent alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_current. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_1008 epsilon_magent_pknows_current);  tauto.
Defined.

Remark rem_1010 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_current.  case (rem_1007 epsilon_magent_pknows_current). clear  epsilon_magent_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_magent_pknows_current. tauto.
Defined.

Remark rem_1011 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_agent bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_current. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_1010 epsilon_magent_pknows_current);  tauto.
Defined.

Remark rem_1012 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_current.  case (rem_1007 epsilon_magent_pknows_current). clear  epsilon_magent_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_magent_pknows_current. tauto.
Defined.

Remark rem_1013 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_agent i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_current. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_1012 epsilon_magent_pknows_current);  tauto.
Defined.

Remark rem_1014 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_pknows_current.  case (rem_1007 epsilon_magent_pknows_current). clear  epsilon_magent_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_magent_pknows_current. tauto.
Defined.

Remark rem_1015 : (forall X:term, auto_agent X -> auto_knows_current X)
    -> auto_agent server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_pknows_current. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_1014 epsilon_magent_pknows_current);  tauto.
Defined.

Remark rem_1016 : forall X2:term, auto_agent X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_magent_pknows_current 1.
  intro X. case X.
  exact (rem_1009 epsilon_magent_pknows_current ).
  exact (rem_1011 epsilon_magent_pknows_current ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_1013 epsilon_magent_pknows_current ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_1015 epsilon_magent_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_1017 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_knows_current X2). tauto. exact (rem_1016 X2).
Qed.

Remark rem_1018 : forall X3:term, auto_knows_current X3 -> auto_knows_current X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1019 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X3 -> auto_knows_current X3). tauto. exact (rem_1018 X3).
Qed.

Remark rem_1020 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_agent X2 /\ auto_knows_current X2 /\ auto_knows_current X3) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6.
  cut (auto_knows_current X1). 2:apply (rem_1005 X1 X2 X3 X4);  assumption.
  cut (auto_agent X2). 2:apply (rem_1006 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_1017 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X3). 2:apply (rem_1019 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_1021 : forall X1 X2 X3 X4:term, auto___def_10 X4 -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_75 (session_current X1 X2 X3). (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6.
  case (rem_1020 X1 X2 X3 X4 A1 A2 A3 A4 A5 A6). clear  A1 A2 A3 A4 A5 A6. intros. apply trans___def_75_session_current_1;  tauto.
 clear  A1 A2 A3 A4 A5 A6. tauto.
Qed.

Remark rem_1022 : forall X1 X2 X3 X4:term, auto___type_1 X1 -> auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto___def_10 X4 -> auto_knows_current X3 -> auto___def_75 (session_current X1 X2 X3). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_10 X4 -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_75 (session_current X1 X2 X3)). tauto. exact (rem_1021 X1 X2 X3 X4).
Qed.

Remark rem_1023 : forall X1 X2 X3 X4:term, auto___def_60 X4 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_1024 : forall X1 X2 X3 X4:term, auto___def_60 X4 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_1025 : forall X1 X2 X3 X4:term, auto___def_60 X4 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_knows_current X2). tauto. exact (rem_1016 X2).
Qed.

Remark rem_1026 : forall X1 X2 X3 X4:term, auto___def_60 X4 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X3 -> auto_knows_current X3). tauto. exact (rem_1018 X3).
Qed.

Remark rem_1027 : forall X1 X2 X3 X4:term, auto___def_60 X4 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_agent X2 /\ auto_knows_current X2 /\ auto_knows_current X3) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5.
  cut (auto_knows_current X1). 2:apply (rem_1023 X1 X2 X3 X4);  assumption.
  cut (auto_agent X2). 2:apply (rem_1024 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_1025 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X3). 2:apply (rem_1026 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_1028 : forall X1 X2 X3 X4:term, auto___def_60 X4 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_75 (session_current X1 X2 X3). (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5.
  case (rem_1027 X1 X2 X3 X4 A1 A2 A3 A4 A5). clear  A1 A2 A3 A4 A5. intros. apply trans___def_75_session_current_1;  tauto.
 clear  A1 A2 A3 A4 A5. tauto.
Qed.

Remark rem_1029 : forall X1 X2 X3 X4:term, auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto___def_60 X4 -> auto_knows_current X3 -> auto___def_75 (session_current X1 X2 X3). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_60 X4 -> auto_agent X2 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_75 (session_current X1 X2 X3)). tauto. exact (rem_1028 X1 X2 X3 X4).
Qed.

Remark rem_1030 : forall X1 X2 X3 X4:term, auto___def_67 X1 X2 X3 X4 -> or_2
    (auto___type_1 X1 /\ auto_knows_current X1 /\ auto_agent X2 /\ auto_knows_current X2 /\ auto___def_10 X3 /\ auto_knows_current X4)
    (auto_knows_current X1 /\ auto_agent X2 /\ auto_knows_current X2 /\ auto___def_60 X3 /\ auto_knows_current X4)
.
Proof.
  intros. inversion H.
  intros. apply or_2_intro_1; tauto.
  intros. apply or_2_intro_2; tauto.
Qed.

Remark rem_1031 : forall X1 X2 X3 X4:term, auto___def_67 X1 X2 X4 X3 -> auto___def_75 (session_current X1 X2 X3). (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1030 X1 X2 X4 X3 H);  intros.
  apply (rem_1022 X1 X2 X3 X4);  tauto.
  apply (rem_1029 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1032 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_623 X1).
Qed.

Remark rem_1033 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_42 X1). 2:apply (rem_1032 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1034 : forall X1 X2:term, auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___def_44 (s X1). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1033 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_44_s_1;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1035 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_27 X2 -> auto___def_44 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_42 X1 -> auto___type_8 X2 -> auto___def_44 (s X1)). tauto. exact (rem_1034 X1 X2).
Qed.

Remark rem_1036 : forall X1 X2:term, auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_44 X1). 2:apply (rem_591 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1037 : forall X1 X2:term, auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 (s X1). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1036 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_44_s_2;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1038 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_27 X2 -> auto___def_44 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 (s X1)). tauto. exact (rem_1037 X1 X2).
Qed.

Remark rem_1039 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto___def_27 alice -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_600 H);  intros.
Defined.

Remark rem_1040 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto_knows_old alice -> auto___def_27 alice -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_354 H);  intros.
  apply (rem_1039 epsilon_mknows_old_m__def_27);  tauto.
Defined.

Remark rem_1041 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (noncea_old X1 X2) -> auto_agent X1 -> auto_agent X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_601 X1 X2 H);  intros.
Defined.

Remark rem_1042 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto_knows_old (noncea_old X1 X2) -> auto___def_27 (noncea_old X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_362 X1 X2 H);  intros.
  apply (rem_1041 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1043 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto___def_27 bob -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_603 H);  intros.
Defined.

Remark rem_1044 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto_knows_old bob -> auto___def_27 bob -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_365 H);  intros.
  apply (rem_1043 epsilon_mknows_old_m__def_27);  tauto.
Defined.

Remark rem_1045 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1:term, auto___def_27 (s X1) -> auto_knows_old X1 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1. intro H. intros.
  elim (rem_604 X1 H);  intros.
Defined.

Remark rem_1046 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1:term, auto_knows_old (s X1) -> auto___def_27 (s X1) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1. intro H. intros.
  elim (rem_370 X1 H);  intros.
  apply (rem_1045 epsilon_mknows_old_m__def_27 X1);  tauto.
Defined.

Remark rem_1047 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto___def_27 nil -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_605 H);  intros.
Defined.

Remark rem_1048 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto_knows_old nil -> auto___def_27 nil -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_373 H);  intros.
  apply (rem_1047 epsilon_mknows_old_m__def_27);  tauto.
Defined.

Remark rem_1049 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto___def_27 i -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_606 H);  intros.
Defined.

Remark rem_1050 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto_knows_old i -> auto___def_27 i -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_376 H);  intros.
  apply (rem_1049 epsilon_mknows_old_m__def_27);  tauto.
Defined.

Remark rem_1051 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (cons X1 X2) -> auto_knows_old X1 -> auto_knows_old X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_608 X1 X2 H);  intros.
Defined.

Remark rem_1052 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto_knows_old (cons X1 X2) -> auto___def_27 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_383 X1 X2 H);  intros.
  apply (rem_1051 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1053 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto___def_27 server -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_609 H);  intros.
Defined.

Remark rem_1054 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> auto_knows_old server -> auto___def_27 server -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intro H. intros.
  elim (rem_386 H);  intros.
  apply (rem_1053 epsilon_mknows_old_m__def_27);  tauto.
Defined.

Remark rem_1055 : (forall X:term, auto___def_47 X -> auto___def_29 X -> False)
    -> auto___def_29 prv -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_47_m__def_29. intro H. intros.
  elim (rem_332 H);  intros.
Defined.

Remark rem_1056 : (forall X:term, auto___def_47 X -> auto___def_29 X -> False)
    -> auto___def_47 prv -> auto___def_29 prv -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_47_m__def_29. intro H. intros.
  elim (rem_53 H);  intros.
  apply (rem_1055 epsilon_m__def_47_m__def_29);  tauto.
Defined.

Remark rem_1057 : forall X1:term, auto___def_47 X1 -> auto___def_29 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_47_m__def_29 1.
  intro X. case X.
   intro H. elim (rem_55  H).
   intro H. elim (rem_57  H).
  intros X1 X2. intro H. elim (rem_62 X1 X2 H).
  intros X1 X2. intro H. elim (rem_69 X1 X2 H).
   intro H. elim (rem_60  H).
  intros X1 X2. intro H. elim (rem_65 X1 X2 H).
   intro H. elim (rem_59  H).
  intros X1 X2. intro H. elim (rem_67 X1 X2 H).
  intros X1 X2. intro H. elim (rem_56 X1 X2 H).
  intros X1 X2. intro H. elim (rem_71 X1 X2 H).
  intros X1 X2. intro H. elim (rem_66 X1 X2 H).
  exact (rem_1056 epsilon_m__def_47_m__def_29 ).
   intro H. elim (rem_61  H).
  intros X1. intro H. elim (rem_58 X1 H).
   intro H. elim (rem_63  H).
  intros X1 X2 X3. intro H. elim (rem_68 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_70 X1 X2 X3 H).
   intro H. elim (rem_64  H).
Qed.

Remark rem_1058 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1:term, auto___def_47 X1 -> auto___def_29 X1 -> False. (* Cut history. *)
Proof.  intros epsilon_mknows_old_m__def_27. exact (rem_1057).
Defined.

Remark rem_1059 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_30 X2 -> auto___def_29 X1 -> False. (* Split. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_29 X1 -> False). clear  epsilon_mknows_old_m__def_27. tauto.
  exact (rem_1058 epsilon_mknows_old_m__def_27 X1).
Defined.

Remark rem_1060 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto___def_47 X1 -> auto___def_48 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_1059 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1061 : (forall X:term, auto___def_46 X -> auto___def_29 X -> False)
    -> auto___def_29 pub -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_46_m__def_29. intro H. intros.
  elim (rem_826 H);  intros.
Defined.

Remark rem_1062 : (forall X:term, auto___def_46 X -> auto___def_29 X -> False)
    -> auto___def_46 pub -> auto___def_29 pub -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_46_m__def_29. intro H. intros.
  elim (rem_77 H);  intros.
  apply (rem_1061 epsilon_m__def_46_m__def_29);  tauto.
Defined.

Remark rem_1063 : forall X1:term, auto___def_46 X1 -> auto___def_29 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_46_m__def_29 1.
  intro X. case X.
   intro H. elim (rem_79  H).
   intro H. elim (rem_82  H).
  intros X1 X2. intro H. elim (rem_86 X1 X2 H).
  intros X1 X2. intro H. elim (rem_93 X1 X2 H).
   intro H. elim (rem_85  H).
  intros X1 X2. intro H. elim (rem_89 X1 X2 H).
   intro H. elim (rem_84  H).
  intros X1 X2. intro H. elim (rem_91 X1 X2 H).
  intros X1 X2. intro H. elim (rem_80 X1 X2 H).
  intros X1 X2. intro H. elim (rem_95 X1 X2 H).
  intros X1 X2. intro H. elim (rem_90 X1 X2 H).
   intro H. elim (rem_81  H).
  exact (rem_1062 epsilon_m__def_46_m__def_29 ).
  intros X1. intro H. elim (rem_83 X1 H).
   intro H. elim (rem_87  H).
  intros X1 X2 X3. intro H. elim (rem_92 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_94 X1 X2 X3 H).
   intro H. elim (rem_88  H).
Qed.

Remark rem_1064 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1:term, auto___def_46 X1 -> auto___def_29 X1 -> False. (* Cut history. *)
Proof.  intros epsilon_mknows_old_m__def_27. exact (rem_1063).
Defined.

Remark rem_1065 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___type_10 X2 -> auto___def_46 X1 -> auto___def_30 X2 -> auto___def_29 X1 -> False. (* Split. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_29 X1 -> False). clear  epsilon_mknows_old_m__def_27. tauto.
  exact (rem_1064 epsilon_mknows_old_m__def_27 X1).
Defined.

Remark rem_1066 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto___def_46 X1 -> auto___type_10 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_1065 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1067 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto_knows_old (key X1 X2) -> auto___def_27 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_330 X1 X2 H);  intros.
  apply (rem_1060 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
  apply (rem_1066 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1068 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (crypt X1 X2) -> auto_knows_old X1 -> auto_knows_old X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_614 X1 X2 H);  intros.
Defined.

Remark rem_1069 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (crypt X1 X2) -> auto___def_23 X1 -> auto___def_24 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_614 X1 X2 H);  intros.
Defined.

Remark rem_1070 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (crypt X1 X2) -> auto___def_33 X1 -> auto___def_34 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_614 X1 X2 H);  intros.
Defined.

Remark rem_1071 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (crypt X1 X2) -> auto___def_44 X1 -> auto___type_9 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_614 X1 X2 H);  intros.
Defined.

Remark rem_1072 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (crypt X1 X2) -> auto___def_42 X1 -> auto___type_8 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_614 X1 X2 H);  intros.
Defined.

Remark rem_1073 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (crypt X1 X2) -> auto___def_7 X1 -> auto___def_8 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_614 X1 X2 H);  intros.
Defined.

Remark rem_1074 : (forall X:term, auto_knows_old X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto_knows_old (crypt X1 X2) -> auto___def_27 (crypt X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_350 X1 X2 H);  intros.
  apply (rem_1068 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
  apply (rem_1069 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
  apply (rem_1070 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
  apply (rem_1071 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
  apply (rem_1072 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
  apply (rem_1073 epsilon_mknows_old_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1075 : forall X1:term, auto_knows_old X1 -> auto___def_27 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_mknows_old_m__def_27 1.
  intro X. case X.
  exact (rem_1040 epsilon_mknows_old_m__def_27 ).
  exact (rem_1044 epsilon_mknows_old_m__def_27 ).
  intros X1 X2;  exact (rem_1052 epsilon_mknows_old_m__def_27 X1 X2).
  intros X1 X2;  exact (rem_1074 epsilon_mknows_old_m__def_27 X1 X2).
  exact (rem_1050 epsilon_mknows_old_m__def_27 ).
  intros X1 X2;  exact (rem_1067 epsilon_mknows_old_m__def_27 X1 X2).
  exact (rem_1048 epsilon_mknows_old_m__def_27 ).
  intros X1 X2. intro H. elim (rem_437 X1 X2 H).
  intros X1 X2;  exact (rem_1042 epsilon_mknows_old_m__def_27 X1 X2).
  intros X1 X2. intro H. elim (rem_440 X1 X2 H).
  intros X1 X2. intro H. elim (rem_436 X1 X2 H).
   intro H. elim (rem_433  H).
   intro H. elim (rem_434  H).
  intros X1;  exact (rem_1046 epsilon_mknows_old_m__def_27 X1).
  exact (rem_1054 epsilon_mknows_old_m__def_27 ).
  intros X1 X2 X3. intro H. elim (rem_438 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_439 X1 X2 X3 H).
   intro H. elim (rem_435  H).
Qed.

Remark rem_1076 : forall X1 X2:term, auto___def_27 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_44 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_1075 X2)). tauto.
Qed.

Remark rem_1077 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___def_27 X2 -> auto___def_44 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_44 (s X1)). tauto. exact (rem_1076 X1 X2).
Qed.

Remark rem_1078 : forall X1 X2 X3:term, auto___def_39 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1079 : (forall X:term, auto___def_30 X -> auto___def_39 X -> False)
    -> forall X1 X2 X3:term, auto___def_39 (session_old X1 X2 X3) -> auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X2 -> auto_knows_old X3 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_30_m__def_39. intros X1 X2 X3. intro H. intros.
  elim (rem_1078 X1 X2 X3 H);  intros.
Defined.

Remark rem_1080 : (forall X:term, auto___def_30 X -> auto___def_39 X -> False)
    -> forall X1 X2 X3:term, auto___def_30 (session_old X1 X2 X3) -> auto___def_39 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_30_m__def_39. intros X1 X2 X3. intro H. intros.
  elim (rem_841 X1 X2 X3 H);  intros.
  apply (rem_1079 epsilon_m__def_30_m__def_39 X1 X2 X3);  tauto.
Defined.

Remark rem_1081 : forall X2:term, auto___def_30 X2 -> auto___def_39 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_30_m__def_39 1.
  intro X. case X.
   intro H. elim (rem_843  H).
   intro H. elim (rem_846  H).
  intros X1 X2. intro H. elim (rem_851 X1 X2 H).
  intros X1 X2. intro H. elim (rem_858 X1 X2 H).
   intro H. elim (rem_849  H).
  intros X1 X2. intro H. elim (rem_854 X1 X2 H).
   intro H. elim (rem_848  H).
  intros X1 X2. intro H. elim (rem_856 X1 X2 H).
  intros X1 X2. intro H. elim (rem_844 X1 X2 H).
  intros X1 X2. intro H. elim (rem_859 X1 X2 H).
  intros X1 X2. intro H. elim (rem_855 X1 X2 H).
   intro H. elim (rem_845  H).
   intro H. elim (rem_850  H).
  intros X1. intro H. elim (rem_847 X1 H).
   intro H. elim (rem_852  H).
  intros X1 X2 X3. intro H. elim (rem_857 X1 X2 X3 H).
  intros X1 X2 X3;  exact (rem_1080 epsilon_m__def_30_m__def_39 X1 X2 X3).
   intro H. elim (rem_853  H).
Qed.

Remark rem_1082 : (forall X:term, auto___def_24 X -> auto___def_27 X -> False)
    -> forall X2:term, auto___def_30 X2 -> auto___def_39 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_24_m__def_27. exact (rem_1081).
Defined.

Remark rem_1083 : (forall X:term, auto___def_24 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_30 X2 -> auto___def_29 X1 -> auto___def_39 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_24_m__def_27. intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_39 X2 -> False). clear  epsilon_m__def_24_m__def_27. tauto.
  exact (rem_1082 epsilon_m__def_24_m__def_27 X2).
Defined.

Remark rem_1084 : (forall X:term, auto___def_24 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto___def_29 X1 -> auto___def_39 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_24_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_1083 epsilon_m__def_24_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1085 : (forall X:term, auto___def_24 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_24 (key X1 X2) -> auto___def_27 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_24_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_204 X1 X2 H);  intros.
  apply (rem_1084 epsilon_m__def_24_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1086 : auto___def_24 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1087 : forall X1 X2:term, auto___def_24 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1088 : auto___def_24 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1089 : auto___def_24 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1090 : forall X1:term, auto___def_24 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1091 : auto___def_24 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1092 : auto___def_24 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1093 : auto___def_24 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1094 : forall X1 X2:term, auto___def_24 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1095 : auto___def_24 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1096 : auto___def_24 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1097 : forall X1 X2:term, auto___def_24 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1098 : forall X1 X2:term, auto___def_24 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1099 : forall X1 X2 X3:term, auto___def_24 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1100 : forall X1 X2:term, auto___def_24 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1101 : forall X1 X2 X3:term, auto___def_24 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1102 : forall X1 X2:term, auto___def_24 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1103 : forall X1:term, auto___def_24 X1 -> auto___def_27 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_24_m__def_27 1.
  intro X. case X.
   intro H. elim (rem_1086  H).
   intro H. elim (rem_1089  H).
  intros X1 X2. intro H. elim (rem_1094 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1100 X1 X2 H).
   intro H. elim (rem_1092  H).
  intros X1 X2;  exact (rem_1085 epsilon_m__def_24_m__def_27 X1 X2).
   intro H. elim (rem_1091  H).
  intros X1 X2. intro H. elim (rem_1098 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1087 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1102 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1097 X1 X2 H).
   intro H. elim (rem_1088  H).
   intro H. elim (rem_1093  H).
  intros X1. intro H. elim (rem_1090 X1 H).
   intro H. elim (rem_1095  H).
  intros X1 X2 X3. intro H. elim (rem_1099 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1101 X1 X2 X3 H).
   intro H. elim (rem_1096  H).
Qed.

Remark rem_1104 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_27 X2 -> auto___def_44 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_1103 X2)). tauto.
Qed.

Remark rem_1105 : (forall X:term, auto___def_13 X -> auto___def_30 X -> False)
    -> forall X1 X2:term, auto___def_30 (cons X1 X2) -> auto_agent X1 -> auto___def_14 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_13_m__def_30. intros X1 X2. intro H. intros.
  elim (rem_851 X1 X2 H);  intros.
Defined.

Remark rem_1106 : (forall X:term, auto___def_13 X -> auto___def_30 X -> False)
    -> forall X1 X2:term, auto___def_13 (cons X1 X2) -> auto___def_30 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_13_m__def_30. intros X1 X2. intro H. intros.
  elim (rem_211 X1 X2 H);  intros.
  apply (rem_1105 epsilon_m__def_13_m__def_30 X1 X2);  tauto.
Defined.

Remark rem_1107 : forall X2:term, auto___def_13 X2 -> auto___def_30 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_13_m__def_30 1.
  intro X. case X.
   intro H. elim (rem_213  H).
   intro H. elim (rem_216  H).
  intros X1 X2;  exact (rem_1106 epsilon_m__def_13_m__def_30 X1 X2).
  intros X1 X2. intro H. elim (rem_227 X1 X2 H).
   intro H. elim (rem_219  H).
  intros X1 X2. intro H. elim (rem_223 X1 X2 H).
   intro H. elim (rem_218  H).
  intros X1 X2. intro H. elim (rem_225 X1 X2 H).
  intros X1 X2. intro H. elim (rem_214 X1 X2 H).
  intros X1 X2. intro H. elim (rem_229 X1 X2 H).
  intros X1 X2. intro H. elim (rem_224 X1 X2 H).
   intro H. elim (rem_215  H).
   intro H. elim (rem_220  H).
  intros X1. intro H. elim (rem_217 X1 H).
   intro H. elim (rem_221  H).
  intros X1 X2 X3. intro H. elim (rem_226 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_228 X1 X2 X3 H).
   intro H. elim (rem_222  H).
Qed.

Remark rem_1108 : (forall X:term, auto___def_8 X -> auto___def_27 X -> False)
    -> forall X2:term, auto___def_13 X2 -> auto___def_30 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_8_m__def_27. exact (rem_1107).
Defined.

Remark rem_1109 : (forall X:term, auto___def_8 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_13 X2 -> auto___def_30 X2 -> auto___def_12 X1 -> auto___def_29 X1 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_8_m__def_27. intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_30 X2 -> False). clear  epsilon_m__def_8_m__def_27. tauto.
  exact (rem_1108 epsilon_m__def_8_m__def_27 X2).
Defined.

Remark rem_1110 : (forall X:term, auto___def_8 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto___def_12 X1 -> auto___def_13 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_8_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_1109 epsilon_m__def_8_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1111 : (forall X:term, auto___def_8 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_8 (key X1 X2) -> auto___def_27 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_8_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_234 X1 X2 H);  intros.
  apply (rem_1110 epsilon_m__def_8_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1112 : forall X1:term, auto___def_8 X1 -> auto___def_27 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_8_m__def_27 1.
  intro X. case X.
   intro H. elim (rem_236  H).
   intro H. elim (rem_239  H).
  intros X1 X2. intro H. elim (rem_244 X1 X2 H).
  intros X1 X2. intro H. elim (rem_250 X1 X2 H).
   intro H. elim (rem_242  H).
  intros X1 X2;  exact (rem_1111 epsilon_m__def_8_m__def_27 X1 X2).
   intro H. elim (rem_241  H).
  intros X1 X2. intro H. elim (rem_248 X1 X2 H).
  intros X1 X2. intro H. elim (rem_237 X1 X2 H).
  intros X1 X2. intro H. elim (rem_252 X1 X2 H).
  intros X1 X2. intro H. elim (rem_247 X1 X2 H).
   intro H. elim (rem_238  H).
   intro H. elim (rem_243  H).
  intros X1. intro H. elim (rem_240 X1 H).
   intro H. elim (rem_245  H).
  intros X1 X2 X3. intro H. elim (rem_249 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_251 X1 X2 X3 H).
   intro H. elim (rem_246  H).
Qed.

Remark rem_1113 : forall X1 X2:term, auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___def_44 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_1112 X2)). tauto.
Qed.

Remark rem_1114 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_27 X2 -> auto___def_44 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_7 X1 -> auto___def_8 X2 -> auto___def_44 (s X1)). tauto. exact (rem_1113 X1 X2).
Qed.

Remark rem_1115 : (forall X:term, auto___def_37 X -> auto___def_30 X -> False)
    -> forall X1 X2:term, auto___def_30 (cons X1 X2) -> auto___type_5 X1 -> auto___def_38 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_37_m__def_30. intros X1 X2. intro H. intros.
  elim (rem_851 X1 X2 H);  intros.
Defined.

Remark rem_1116 : (forall X:term, auto___def_37 X -> auto___def_30 X -> False)
    -> forall X1 X2:term, auto___def_37 (cons X1 X2) -> auto___def_30 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_37_m__def_30. intros X1 X2. intro H. intros.
  elim (rem_291 X1 X2 H);  intros.
  apply (rem_1115 epsilon_m__def_37_m__def_30 X1 X2);  tauto.
Defined.

Remark rem_1117 : forall X2:term, auto___def_37 X2 -> auto___def_30 X2 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_37_m__def_30 1.
  intro X. case X.
   intro H. elim (rem_293  H).
   intro H. elim (rem_296  H).
  intros X1 X2;  exact (rem_1116 epsilon_m__def_37_m__def_30 X1 X2).
  intros X1 X2. intro H. elim (rem_307 X1 X2 H).
   intro H. elim (rem_299  H).
  intros X1 X2. intro H. elim (rem_303 X1 X2 H).
   intro H. elim (rem_298  H).
  intros X1 X2. intro H. elim (rem_305 X1 X2 H).
  intros X1 X2. intro H. elim (rem_294 X1 X2 H).
  intros X1 X2. intro H. elim (rem_309 X1 X2 H).
  intros X1 X2. intro H. elim (rem_304 X1 X2 H).
   intro H. elim (rem_295  H).
   intro H. elim (rem_300  H).
  intros X1. intro H. elim (rem_297 X1 H).
   intro H. elim (rem_301  H).
  intros X1 X2 X3. intro H. elim (rem_306 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_308 X1 X2 X3 H).
   intro H. elim (rem_302  H).
Qed.

Remark rem_1118 : (forall X:term, auto___def_34 X -> auto___def_27 X -> False)
    -> forall X2:term, auto___def_37 X2 -> auto___def_30 X2 -> False. (* Cut history. *)
Proof.  intros epsilon_m__def_34_m__def_27. exact (rem_1117).
Defined.

Remark rem_1119 : (forall X:term, auto___def_34 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_30 X2 -> auto___def_29 X1 -> auto___def_37 X2 -> False. (* Split. *)
Proof.
  intros epsilon_m__def_34_m__def_27. intros X1 X2.
  cut (auto___def_37 X2 -> auto___def_30 X2 -> False). clear  epsilon_m__def_34_m__def_27. tauto.
  exact (rem_1118 epsilon_m__def_34_m__def_27 X2).
Defined.

Remark rem_1120 : (forall X:term, auto___def_34 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto___def_29 X1 -> auto___def_37 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_34_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_1119 epsilon_m__def_34_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1121 : (forall X:term, auto___def_34 X -> auto___def_27 X -> False)
    -> forall X1 X2:term, auto___def_34 (key X1 X2) -> auto___def_27 (key X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_34_m__def_27. intros X1 X2. intro H. intros.
  elim (rem_313 X1 X2 H);  intros.
  apply (rem_1120 epsilon_m__def_34_m__def_27 X1 X2);  tauto.
Defined.

Remark rem_1122 : auto___def_34 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1123 : forall X1 X2:term, auto___def_34 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1124 : auto___def_34 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1125 : auto___def_34 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1126 : forall X1:term, auto___def_34 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1127 : auto___def_34 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1128 : auto___def_34 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1129 : auto___def_34 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1130 : forall X1 X2:term, auto___def_34 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1131 : auto___def_34 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1132 : auto___def_34 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1133 : forall X1 X2:term, auto___def_34 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1134 : forall X1 X2:term, auto___def_34 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1135 : forall X1 X2 X3:term, auto___def_34 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1136 : forall X1 X2:term, auto___def_34 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1137 : forall X1 X2 X3:term, auto___def_34 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1138 : forall X1 X2:term, auto___def_34 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1139 : forall X1:term, auto___def_34 X1 -> auto___def_27 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_34_m__def_27 1.
  intro X. case X.
   intro H. elim (rem_1122  H).
   intro H. elim (rem_1125  H).
  intros X1 X2. intro H. elim (rem_1130 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1136 X1 X2 H).
   intro H. elim (rem_1128  H).
  intros X1 X2;  exact (rem_1121 epsilon_m__def_34_m__def_27 X1 X2).
   intro H. elim (rem_1127  H).
  intros X1 X2. intro H. elim (rem_1134 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1123 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1138 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1133 X1 X2 H).
   intro H. elim (rem_1124  H).
   intro H. elim (rem_1129  H).
  intros X1. intro H. elim (rem_1126 X1 H).
   intro H. elim (rem_1131  H).
  intros X1 X2 X3. intro H. elim (rem_1135 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1137 X1 X2 X3 H).
   intro H. elim (rem_1132  H).
Qed.

Remark rem_1140 : forall X1 X2:term, auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___def_44 (s X1). (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_1139 X2)). tauto.
Qed.

Remark rem_1141 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_27 X2 -> auto___def_44 (s X1). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X2 -> auto___def_33 X1 -> auto___def_34 X2 -> auto___def_44 (s X1)). tauto. exact (rem_1140 X1 X2).
Qed.

Remark rem_1142 : forall X1 X2:term, auto___def_43 X1 X2 -> auto___def_44 (s X1). (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_683 X1 X2 H);  intros.
  apply (rem_1035 X1 X2);  tauto.
  apply (rem_1038 X1 X2);  tauto.
  apply (rem_1077 X1 X2);  tauto.
  apply (rem_1104 X1 X2);  tauto.
  apply (rem_1114 X1 X2);  tauto.
  apply (rem_1141 X1 X2);  tauto.
Qed.

Remark rem_1143 : auto___def_16 nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_16_nil_1;  tauto.
 tauto.
Qed.

Remark rem_1144 : (forall X:term, auto___def_72 X -> auto___type_18 X)
    -> forall X1:term, auto___def_74 X1 -> auto___def_74 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1145 : (forall X:term, auto___def_72 X -> auto___type_18 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_74 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_72_p__type_18. intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_74 X1). tauto. exact (rem_1144 epsilon_m__def_72_p__type_18 X1).
Defined.

Remark rem_1146 : (forall X:term, auto___def_72 X -> auto___type_18 X)
    -> forall X2:term, auto___def_75 X2 -> auto___def_75 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1147 : (forall X:term, auto___def_72 X -> auto___type_18 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_75 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_72_p__type_18. intros X1 X2.
  cut (auto___def_75 X2 -> auto___def_75 X2). tauto. exact (rem_1146 epsilon_m__def_72_p__type_18 X2).
Defined.

Remark rem_1148 : (forall X:term, auto___def_72 X -> auto___type_18 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> (auto___def_74 X1 /\ auto___def_75 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_72_p__type_18. intros X1 X2. intros A1 A2.
  cut (auto___def_74 X1). 2:apply (rem_1145 epsilon_m__def_72_p__type_18 X1 X2);  assumption.
  cut (auto___def_75 X2). 2:apply (rem_1147 epsilon_m__def_72_p__type_18 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1149 : (forall X:term, auto___def_72 X -> auto___type_18 X)
    -> forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___type_18 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_72_p__type_18. intros X1 X2. intros A1 A2.
  case (rem_1148 epsilon_m__def_72_p__type_18 X1 X2 A1 A2). clear  epsilon_m__def_72_p__type_18 A1 A2. intros. apply trans___type_18_key_1;  tauto.
 clear  epsilon_m__def_72_p__type_18 A1 A2. tauto.
Defined.

Remark rem_1150 : (forall X:term, auto___def_72 X -> auto___type_18 X)
    -> forall X1 X2:term, auto___def_72 (key X1 X2) -> auto___type_18 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_72_p__type_18. intros X1 X2. intro H. intros.
  elim (rem_101 X1 X2 H);  intros.
  apply (rem_1149 epsilon_m__def_72_p__type_18 X1 X2);  tauto.
Defined.

Remark rem_1151 : forall X1:term, auto___def_72 X1 -> auto___type_18 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_72_p__type_18 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_1150 epsilon_m__def_72_p__type_18 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_1152 : forall X1 X2 X3:term, auto___def_72 X1 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X3 -> auto___type_18 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X1 -> auto___type_18 X1). tauto. exact (rem_1151 X1).
Qed.

Remark rem_1153 : forall X1 X2 X3:term, auto_knows_current X2 -> auto___type_15 X3 -> auto_agent X3 -> auto___def_72 X1 -> auto___type_18 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X3 X2.
  cut (auto___def_72 X1 -> auto___type_15 X2 -> auto_agent X2 -> auto_knows_current X3 -> auto___type_18 X1). tauto. exact (rem_1152 X1 X2 X3).
Qed.

Remark rem_1154 : forall X1 X2 X3:term, auto___def_86 X2 X3 X1 -> auto___type_18 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_482 X2 X3 X1 H);  intros.
  apply (rem_1153 X1 X2 X3);  tauto.
Qed.

Remark rem_1155 : auto___def_47 sym -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_64 H);  intros.
Qed.

Remark rem_1156 : forall X1 X2:term, auto___def_47 sym -> auto___def_48 X2 -> auto_knows_old X1 -> auto___def_5 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_47 sym -> False). tauto.
  exact (rem_1155).
Qed.

Remark rem_1157 : auto___def_46 sym -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_88 H);  intros.
Qed.

Remark rem_1158 : forall X1 X2:term, auto___def_46 sym -> auto_knows_old X1 -> auto___def_5 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_1159 : forall X1 X2:term, auto___def_46 sym -> auto___type_10 X2 -> auto_knows_old X1 -> auto___def_5 X1 X2. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2. intros. apply (rem_1158 X1 X2);  assumption.
Qed.

Remark rem_1160 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old (key sym X2) -> auto___def_5 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_330 sym X2 H);  intros.
  apply (rem_1156 X1 X2);  tauto.
  apply (rem_1159 X1 X2);  tauto.
Qed.

Remark rem_1161 : forall X1 X2:term, auto___def_23 X1 -> auto___def_29 sym -> auto___def_39 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_575 X1).
Qed.

Remark rem_1162 : forall X2:term, auto___def_39 X2 -> auto___def_39 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1163 : forall X1 X2:term, auto___def_23 X1 -> auto___def_29 sym -> auto___def_39 X2 -> auto___def_39 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_39 X2 -> auto___def_39 X2). tauto. exact (rem_1162 X2).
Qed.

Remark rem_1164 : forall X1 X2:term, auto___def_23 X1 -> auto___def_29 sym -> auto___def_39 X2 -> (auto___def_23 X1 /\ auto___def_39 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_23 X1). 2:apply (rem_1161 X1 X2);  assumption.
  cut (auto___def_39 X2). 2:apply (rem_1163 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1165 : forall X1 X2:term, auto___def_23 X1 -> auto___def_29 sym -> auto___def_39 X2 -> auto___def_5 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1164 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_5_5;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1166 : forall X1 X2:term, auto___def_29 sym -> auto___def_39 X2 -> auto___def_23 X1 -> auto___def_5 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_29 sym -> auto___def_39 X2 -> auto___def_5 X1 X2). tauto. exact (rem_1165 X1 X2).
Qed.

Remark rem_1167 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 (key sym X2) -> auto___def_5 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_204 sym X2 H);  intros.
  apply (rem_1166 X1 X2);  tauto.
Qed.

Remark rem_1168 : forall X1 X2:term, auto___def_29 sym -> auto___def_33 X1 -> auto___def_37 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_582 X1).
Qed.

Remark rem_1169 : forall X2:term, auto___def_37 X2 -> auto___def_37 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1170 : forall X1 X2:term, auto___def_29 sym -> auto___def_33 X1 -> auto___def_37 X2 -> auto___def_37 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_37 X2 -> auto___def_37 X2). tauto. exact (rem_1169 X2).
Qed.

Remark rem_1171 : forall X1 X2:term, auto___def_29 sym -> auto___def_33 X1 -> auto___def_37 X2 -> (auto___def_33 X1 /\ auto___def_37 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_33 X1). 2:apply (rem_1168 X1 X2);  assumption.
  cut (auto___def_37 X2). 2:apply (rem_1170 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1172 : forall X1 X2:term, auto___def_29 sym -> auto___def_33 X1 -> auto___def_37 X2 -> auto___def_5 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1171 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_5_2;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1173 : forall X1 X2:term, auto___def_29 sym -> auto___def_37 X2 -> auto___def_33 X1 -> auto___def_5 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 sym -> auto___def_33 X1 -> auto___def_37 X2 -> auto___def_5 X1 X2). tauto. exact (rem_1172 X1 X2).
Qed.

Remark rem_1174 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 (key sym X2) -> auto___def_5 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_313 sym X2 H);  intros.
  apply (rem_1173 X1 X2);  tauto.
Qed.

Remark rem_1175 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_44 X1 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_590 X1).
Qed.

Remark rem_1176 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_44 X1 -> auto___def_30 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_30 X2). tauto. exact (rem_666 X2).
Qed.

Remark rem_1177 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_44 X1 -> (auto___def_44 X1 /\ auto___def_30 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_44 X1). 2:apply (rem_1175 X1 X2);  assumption.
  cut (auto___def_30 X2). 2:apply (rem_1176 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1178 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_44 X1 -> auto___def_5 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1177 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_5_1;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1179 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 (key sym X2) -> auto___def_5 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_341 sym X2 H);  intros.
  apply (rem_1178 X1 X2);  tauto.
Qed.

Remark rem_1180 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_42 X1 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_623 X1).
Qed.

Remark rem_1181 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_42 X1 -> auto___def_30 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_30 X2). tauto. exact (rem_666 X2).
Qed.

Remark rem_1182 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_42 X1 -> (auto___def_42 X1 /\ auto___def_30 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_42 X1). 2:apply (rem_1180 X1 X2);  assumption.
  cut (auto___def_30 X2). 2:apply (rem_1181 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1183 : forall X1 X2:term, auto___def_29 sym -> auto___def_30 X2 -> auto___def_42 X1 -> auto___def_5 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1182 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_5_4;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1184 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 (key sym X2) -> auto___def_5 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_344 sym X2 H);  intros.
  apply (rem_1183 X1 X2);  tauto.
Qed.

Remark rem_1185 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_7 X1 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_638 X1).
Qed.

Remark rem_1186 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_7 X1 -> auto___def_13 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_13 X2). tauto. exact (rem_22 X2).
Qed.

Remark rem_1187 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_7 X1 -> (auto___def_7 X1 /\ auto___def_13 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_7 X1). 2:apply (rem_1185 X1 X2);  assumption.
  cut (auto___def_13 X2). 2:apply (rem_1186 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1188 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_7 X1 -> auto___def_5 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1187 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_5_3;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1189 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 (key sym X2) -> auto___def_5 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_234 sym X2 H);  intros.
  apply (rem_1188 X1 X2);  tauto.
Qed.

Remark rem_1190 : forall X1 X2:term, auto_knows_old (crypt X1 (key sym X2)) -> auto___def_5 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_350 X1 (key sym X2) H);  intros.
  apply (rem_1160 X1 X2);  tauto.
  apply (rem_1167 X1 X2);  tauto.
  apply (rem_1174 X1 X2);  tauto.
  apply (rem_1179 X1 X2);  tauto.
  apply (rem_1184 X1 X2);  tauto.
  apply (rem_1189 X1 X2);  tauto.
Qed.

Remark rem_1191 : forall X1:term, auto___def_27 X1 -> auto___def_27 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1192 : forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> auto___def_27 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_27 X1). tauto. exact (rem_1191 X1).
Qed.

Remark rem_1193 : forall X2:term, auto___def_28 X2 -> auto___def_28 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1194 : forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> auto___def_28 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_28 X2 -> auto___def_28 X2). tauto. exact (rem_1193 X2).
Qed.

Remark rem_1195 : forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> (auto___def_27 X1 /\ auto___def_28 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_27 X1). 2:apply (rem_1192 X1 X2);  assumption.
  cut (auto___def_28 X2). 2:apply (rem_1194 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1196 : forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> auto___def_26 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1195 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_26_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1197 : forall X1 X2:term, auto___def_28 X2 -> auto___def_27 X1 -> auto___def_26 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_28 X2 -> auto___def_26 (cons X1 X2)). tauto. exact (rem_1196 X1 X2).
Qed.

Remark rem_1198 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_658 X1).
Qed.

Remark rem_1199 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_1200 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_1198 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_1199 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1201 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___def_19 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1200 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_19_noncea_old_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1202 : forall X1 X2:term, auto_agent X2 -> auto_agent X1 -> auto___def_19 (noncea_old X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_agent X1 -> auto_agent X2 -> auto___def_19 (noncea_old X1 X2)). tauto. exact (rem_1201 X1 X2).
Qed.

Remark rem_1203 : auto___def_49 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1204 : auto___def_49 prv -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_1203 H);  intros.
Qed.

Remark rem_1205 : forall X1:term, auto___def_49 prv -> auto___def_50 X1 -> auto___def_52 X1. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_49 prv -> False). tauto.
  exact (rem_1204).
Qed.

Remark rem_1206 : (forall X:term, auto___def_48 X -> auto___def_52 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_48_p__def_52.  tauto.
Defined.

Remark rem_1207 : (forall X:term, auto___def_48 X -> auto___def_52 X)
    -> auto___def_52 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_48_p__def_52.  case (rem_1206 epsilon_m__def_48_p__def_52). clear  epsilon_m__def_48_p__def_52. intros. apply trans___def_52_i_1;  tauto.
 clear  epsilon_m__def_48_p__def_52. tauto.
Defined.

Remark rem_1208 : auto___def_48 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1209 : (forall X:term, auto___def_48 X -> auto___def_52 X)
    -> auto___def_48 i -> auto___def_52 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_48_p__def_52. intro H. intros.
  elim (rem_1208 H);  intros.
  apply (rem_1207 epsilon_m__def_48_p__def_52);  tauto.
Defined.

Remark rem_1210 : auto___def_48 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1211 : forall X1 X2:term, auto___def_48 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1212 : auto___def_48 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1213 : auto___def_48 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1214 : forall X1:term, auto___def_48 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1215 : auto___def_48 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1216 : auto___def_48 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1217 : forall X1 X2:term, auto___def_48 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1218 : auto___def_48 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1219 : auto___def_48 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1220 : forall X1 X2:term, auto___def_48 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1221 : forall X1 X2:term, auto___def_48 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1222 : forall X1 X2:term, auto___def_48 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1223 : forall X1 X2 X3:term, auto___def_48 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1224 : forall X1 X2:term, auto___def_48 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1225 : forall X1 X2 X3:term, auto___def_48 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1226 : forall X1 X2:term, auto___def_48 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1227 : forall X1:term, auto___def_48 X1 -> auto___def_52 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_48_p__def_52 1.
  intro X. case X.
   intro H. elim (rem_1210  H).
   intro H. elim (rem_1213  H).
  intros X1 X2. intro H. elim (rem_1217 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1224 X1 X2 H).
  exact (rem_1209 epsilon_m__def_48_p__def_52 ).
  intros X1 X2. intro H. elim (rem_1220 X1 X2 H).
   intro H. elim (rem_1215  H).
  intros X1 X2. intro H. elim (rem_1222 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1211 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1226 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1221 X1 X2 H).
   intro H. elim (rem_1212  H).
   intro H. elim (rem_1216  H).
  intros X1. intro H. elim (rem_1214 X1 H).
   intro H. elim (rem_1218  H).
  intros X1 X2 X3. intro H. elim (rem_1223 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1225 X1 X2 X3 H).
   intro H. elim (rem_1219  H).
Qed.

Remark rem_1228 : forall X1:term, auto___def_47 prv -> auto___def_48 X1 -> auto___def_52 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1.
  cut (auto___def_48 X1 -> auto___def_52 X1). tauto. exact (rem_1227 X1).
Qed.

Remark rem_1229 : forall X1:term, auto___def_46 prv -> auto___def_52 X1. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_46 prv -> False). tauto.
  exact (rem_327).
Qed.

Remark rem_1230 : forall X1:term, auto___def_46 prv -> auto___type_10 X1 -> auto___def_52 X1. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1. intros. apply (rem_1229 X1);  assumption.
Qed.

Remark rem_1231 : forall X1:term, auto_knows_current (key prv X1) -> auto___def_52 X1. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_99 prv X1 H);  intros.
  apply (rem_1205 X1);  tauto.
  apply (rem_1228 X1);  tauto.
  apply (rem_1230 X1);  tauto.
Qed.

Remark rem_1232 : (forall X:term, auto___def_48 X -> auto___def_2 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_48_p__def_2.  tauto.
Defined.

Remark rem_1233 : (forall X:term, auto___def_48 X -> auto___def_2 X)
    -> auto___def_2 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_48_p__def_2.  case (rem_1232 epsilon_m__def_48_p__def_2). clear  epsilon_m__def_48_p__def_2. intros. apply trans___def_2_i_1;  tauto.
 clear  epsilon_m__def_48_p__def_2. tauto.
Defined.

Remark rem_1234 : (forall X:term, auto___def_48 X -> auto___def_2 X)
    -> auto___def_48 i -> auto___def_2 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_48_p__def_2. intro H. intros.
  elim (rem_1208 H);  intros.
  apply (rem_1233 epsilon_m__def_48_p__def_2);  tauto.
Defined.

Remark rem_1235 : forall X1:term, auto___def_48 X1 -> auto___def_2 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_48_p__def_2 1.
  intro X. case X.
   intro H. elim (rem_1210  H).
   intro H. elim (rem_1213  H).
  intros X1 X2. intro H. elim (rem_1217 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1224 X1 X2 H).
  exact (rem_1234 epsilon_m__def_48_p__def_2 ).
  intros X1 X2. intro H. elim (rem_1220 X1 X2 H).
   intro H. elim (rem_1215  H).
  intros X1 X2. intro H. elim (rem_1222 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1211 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1226 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1221 X1 X2 H).
   intro H. elim (rem_1212  H).
   intro H. elim (rem_1216  H).
  intros X1. intro H. elim (rem_1214 X1 H).
   intro H. elim (rem_1218  H).
  intros X1 X2 X3. intro H. elim (rem_1223 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1225 X1 X2 X3 H).
   intro H. elim (rem_1219  H).
Qed.

Remark rem_1236 : forall X1:term, auto___def_47 prv -> auto___def_48 X1 -> auto___def_2 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1.
  cut (auto___def_48 X1 -> auto___def_2 X1). tauto. exact (rem_1235 X1).
Qed.

Remark rem_1237 : forall X1:term, auto___def_46 prv -> auto___def_2 X1. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_46 prv -> False). tauto.
  exact (rem_327).
Qed.

Remark rem_1238 : forall X1:term, auto___def_46 prv -> auto___type_10 X1 -> auto___def_2 X1. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1. intros. apply (rem_1237 X1);  assumption.
Qed.

Remark rem_1239 : forall X1:term, auto_knows_old (key prv X1) -> auto___def_2 X1. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_330 prv X1 H);  intros.
  apply (rem_1236 X1);  tauto.
  apply (rem_1238 X1);  tauto.
Qed.

Remark rem_1240 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1.  tauto.
Defined.

Remark rem_1241 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto___type_1 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1.  case (rem_1240 epsilon_mknows_old_p__type_1). clear  epsilon_mknows_old_p__type_1. intros. apply trans___type_1_alice_1;  tauto.
 clear  epsilon_mknows_old_p__type_1. tauto.
Defined.

Remark rem_1242 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto_knows_old alice -> auto___type_1 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intro H. intros.
  elim (rem_354 H);  intros.
  apply (rem_1241 epsilon_mknows_old_p__type_1);  tauto.
Defined.

Remark rem_1243 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1244 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_1243 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1245 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1246 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_1245 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1247 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_1244 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_1246 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1248 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_1 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1247 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_noncea_old_1;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1249 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old (noncea_old X1 X2) -> auto___type_1 (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intro H. intros.
  elim (rem_362 X1 X2 H);  intros.
  apply (rem_1248 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
Defined.

Remark rem_1250 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto___type_1 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1.  case (rem_1240 epsilon_mknows_old_p__type_1). clear  epsilon_mknows_old_p__type_1. intros. apply trans___type_1_bob_1;  tauto.
 clear  epsilon_mknows_old_p__type_1. tauto.
Defined.

Remark rem_1251 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto_knows_old bob -> auto___type_1 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intro H. intros.
  elim (rem_365 H);  intros.
  apply (rem_1250 epsilon_mknows_old_p__type_1);  tauto.
Defined.

Remark rem_1252 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1253 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1. intros A1.
  cut (auto_knows_old X1). 2:apply (rem_1252 epsilon_mknows_old_p__type_1 X1);  assumption.
  tauto.
Defined.

Remark rem_1254 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto_knows_old X1 -> auto___type_1 (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1. intros A1.
  case (rem_1253 epsilon_mknows_old_p__type_1 X1 A1). clear  epsilon_mknows_old_p__type_1 A1. intros. apply trans___type_1_s_1;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1. tauto.
Defined.

Remark rem_1255 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto_knows_old (s X1) -> auto___type_1 (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1. intro H. intros.
  elim (rem_370 X1 H);  intros.
  apply (rem_1254 epsilon_mknows_old_p__type_1 X1);  tauto.
Defined.

Remark rem_1256 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto___type_1 nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1.  case (rem_1240 epsilon_mknows_old_p__type_1). clear  epsilon_mknows_old_p__type_1. intros. apply trans___type_1_nil_1;  tauto.
 clear  epsilon_mknows_old_p__type_1. tauto.
Defined.

Remark rem_1257 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto_knows_old nil -> auto___type_1 nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intro H. intros.
  elim (rem_373 H);  intros.
  apply (rem_1256 epsilon_mknows_old_p__type_1);  tauto.
Defined.

Remark rem_1258 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto___type_1 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1.  case (rem_1240 epsilon_mknows_old_p__type_1). clear  epsilon_mknows_old_p__type_1. intros. apply trans___type_1_i_1;  tauto.
 clear  epsilon_mknows_old_p__type_1. tauto.
Defined.

Remark rem_1259 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto_knows_old i -> auto___type_1 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intro H. intros.
  elim (rem_376 H);  intros.
  apply (rem_1258 epsilon_mknows_old_p__type_1);  tauto.
Defined.

Remark rem_1260 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_1252 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1261 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_old X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1262 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_1261 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1263 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_1260 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_1262 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1264 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_1 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1263 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_cons_1;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1265 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old (cons X1 X2) -> auto___type_1 (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intro H. intros.
  elim (rem_383 X1 X2 H);  intros.
  apply (rem_1264 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
Defined.

Remark rem_1266 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto___type_1 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1.  case (rem_1240 epsilon_mknows_old_p__type_1). clear  epsilon_mknows_old_p__type_1. intros. apply trans___type_1_server_1;  tauto.
 clear  epsilon_mknows_old_p__type_1. tauto.
Defined.

Remark rem_1267 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> auto_knows_old server -> auto___type_1 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intro H. intros.
  elim (rem_386 H);  intros.
  apply (rem_1266 epsilon_mknows_old_p__type_1);  tauto.
Defined.

Remark rem_1268 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1269 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_1268 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1270 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1271 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_1270 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1272 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_1269 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_1271 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1273 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_1 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1272 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_key_1;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1274 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1275 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_1274 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1276 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1277 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_1276 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1278 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_1275 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_1277 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1279 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_1 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1278 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_key_2;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1280 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old (key X1 X2) -> auto___type_1 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intro H. intros.
  elim (rem_330 X1 X2 H);  intros.
  apply (rem_1273 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
  apply (rem_1279 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
Defined.

Remark rem_1281 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_1 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1263 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_crypt_1;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1282 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1283 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_1282 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1284 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1285 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_1284 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1286 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_1283 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_1285 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1287 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_1 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1286 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_crypt_2;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1288 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1289 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_1288 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1290 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1291 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_1290 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1292 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_1289 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_1291 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1293 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_1 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1292 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_crypt_3;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1294 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto___def_44 X1 -> auto___def_44 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1295 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_1294 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1296 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto___type_9 X2 -> auto___type_9 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1297 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___type_9 X2 -> auto___type_9 X2). tauto. exact (rem_1296 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1298 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto___def_44 X1 /\ auto___type_9 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto___def_44 X1). 2:apply (rem_1295 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_1297 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1299 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_1 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1298 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_crypt_4;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1300 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto___def_42 X1 -> auto___def_42 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1301 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_1300 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1302 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto___type_8 X2 -> auto___type_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1303 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___type_8 X2 -> auto___type_8 X2). tauto. exact (rem_1302 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1304 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto___def_42 X1 /\ auto___type_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto___def_42 X1). 2:apply (rem_1301 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto___type_8 X2). 2:apply (rem_1303 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1305 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_1 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1304 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_crypt_5;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1306 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1307 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_1306 epsilon_mknows_old_p__type_1 X1).
Defined.

Remark rem_1308 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1309 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_1308 epsilon_mknows_old_p__type_1 X2).
Defined.

Remark rem_1310 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_1307 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_1309 epsilon_mknows_old_p__type_1 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1311 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_1 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intros A1 A2.
  case (rem_1310 epsilon_mknows_old_p__type_1 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_1 A1 A2. intros. apply trans___type_1_crypt_6;  tauto.
 clear  epsilon_mknows_old_p__type_1 A1 A2. tauto.
Defined.

Remark rem_1312 : (forall X:term, auto_knows_old X -> auto___type_1 X)
    -> forall X1 X2:term, auto_knows_old (crypt X1 X2) -> auto___type_1 (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_1. intros X1 X2. intro H. intros.
  elim (rem_350 X1 X2 H);  intros.
  apply (rem_1281 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
  apply (rem_1287 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
  apply (rem_1293 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
  apply (rem_1299 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
  apply (rem_1305 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
  apply (rem_1311 epsilon_mknows_old_p__type_1 X1 X2);  tauto.
Defined.

Remark rem_1313 : forall X1:term, auto_knows_old X1 -> auto___type_1 X1. (* Induct. *)
Proof.
  fix epsilon_mknows_old_p__type_1 1.
  intro X. case X.
  exact (rem_1242 epsilon_mknows_old_p__type_1 ).
  exact (rem_1251 epsilon_mknows_old_p__type_1 ).
  intros X1 X2;  exact (rem_1265 epsilon_mknows_old_p__type_1 X1 X2).
  intros X1 X2;  exact (rem_1312 epsilon_mknows_old_p__type_1 X1 X2).
  exact (rem_1259 epsilon_mknows_old_p__type_1 ).
  intros X1 X2;  exact (rem_1280 epsilon_mknows_old_p__type_1 X1 X2).
  exact (rem_1257 epsilon_mknows_old_p__type_1 ).
  intros X1 X2. intro H. elim (rem_437 X1 X2 H).
  intros X1 X2;  exact (rem_1249 epsilon_mknows_old_p__type_1 X1 X2).
  intros X1 X2. intro H. elim (rem_440 X1 X2 H).
  intros X1 X2. intro H. elim (rem_436 X1 X2 H).
   intro H. elim (rem_433  H).
   intro H. elim (rem_434  H).
  intros X1;  exact (rem_1255 epsilon_mknows_old_p__type_1 X1).
  exact (rem_1267 epsilon_mknows_old_p__type_1 ).
  intros X1 X2 X3. intro H. elim (rem_438 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_439 X1 X2 X3 H).
   intro H. elim (rem_435  H).
Qed.

Remark rem_1314 : forall X1 X2 X3 X4:term, auto___def_48 (cons X1 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1217 X1 (cons server nil) H);  intros.
Qed.

Remark rem_1315 : forall X1 X2 X3 X4:term, auto___def_47 sym -> auto___def_48 (cons X1 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_48 (cons X1 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto.
  exact (rem_1314 X1 X2 X3 X4).
Qed.

Remark rem_1316 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_1317 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto___type_10 (cons X1 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2 X3 X4. intros. apply (rem_1316 X1 X2 X3 X4);  assumption.
Qed.

Remark rem_1318 : forall X1 X2 X3 X4:term, auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_330 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_1315 X1 X2 X3 X4);  tauto.
  apply (rem_1317 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1319 : forall X1 X2 X3 X4:term, auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old nil -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto.
  exact (rem_1318 X1 X2 X3 X4).
Qed.

Remark rem_1320 : forall X1 X2 X3 X4:term, auto_knows_old X2 -> auto_knows_old nil -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old nil -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1319 X1 X2 X3 X4).
Qed.

Remark rem_1321 : forall X1 X2 X3 X4:term, auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old (cons X2 nil) -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_383 X2 nil H);  intros.
  apply (rem_1320 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1322 : forall X1 X2 X3 X4:term, auto_knows_old X4 -> auto_knows_old (cons X2 nil) -> auto_knows_old X3 -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old (cons X2 nil) -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1321 X1 X2 X3 X4).
Qed.

Remark rem_1323 : forall X1 X2 X3 X4:term, auto_knows_old X3 -> auto_knows_old (cons X4 (cons X2 nil)) -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_383 X4 (cons X2 nil) H);  intros.
  apply (rem_1322 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1324 : forall X1 X2 X3 X4:term, auto_knows_old (cons X3 (cons X4 (cons X2 nil))) -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_383 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_1323 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1325 : forall X1 X2 X3 X4:term, auto_knows_old (noncea_old X1 X3) -> auto_knows_old (cons X3 (cons X4 (cons X2 nil))) -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old (cons X3 (cons X4 (cons X2 nil))) -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto_knows_old (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1324 X1 X2 X3 X4).
Qed.

Remark rem_1326 : forall X1 X2 X3 X4:term, auto_knows_old (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto_knows_old (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_383 (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_1325 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1327 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_658 X1).
Qed.

Remark rem_1328 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto___type_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_7 X1 -> auto___type_7 X1). tauto. exact (rem_8 X1).
Qed.

Remark rem_1329 : forall X2:term, auto___def_31 X2 -> auto___def_31 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1330 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_31 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_31 X2 -> auto___def_31 X2). tauto. exact (rem_1329 X2).
Qed.

Remark rem_1331 : forall X3:term, auto___type_5 X3 -> auto___type_5 X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1332 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto___type_5 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_5 X3 -> auto___type_5 X3). tauto. exact (rem_1331 X3).
Qed.

Remark rem_1333 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_5_pagent.  tauto.
Defined.

Remark rem_1334 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto_agent alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pagent.  case (rem_1333 epsilon_m__type_5_pagent). clear  epsilon_m__type_5_pagent. intros. apply trans_agent_alice_1;  tauto.
 clear  epsilon_m__type_5_pagent. tauto.
Defined.

Remark rem_1335 : auto___type_5 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1336 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto___type_5 alice -> auto_agent alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pagent. intro H. intros.
  elim (rem_1335 H);  intros.
  apply (rem_1334 epsilon_m__type_5_pagent);  tauto.
Defined.

Remark rem_1337 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto_agent bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pagent.  case (rem_1333 epsilon_m__type_5_pagent). clear  epsilon_m__type_5_pagent. intros. apply trans_agent_bob_1;  tauto.
 clear  epsilon_m__type_5_pagent. tauto.
Defined.

Remark rem_1338 : auto___type_5 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1339 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto___type_5 bob -> auto_agent bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pagent. intro H. intros.
  elim (rem_1338 H);  intros.
  apply (rem_1337 epsilon_m__type_5_pagent);  tauto.
Defined.

Remark rem_1340 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto_agent i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pagent.  case (rem_1333 epsilon_m__type_5_pagent). clear  epsilon_m__type_5_pagent. intros. apply trans_agent_i_1;  tauto.
 clear  epsilon_m__type_5_pagent. tauto.
Defined.

Remark rem_1341 : auto___type_5 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1342 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto___type_5 i -> auto_agent i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pagent. intro H. intros.
  elim (rem_1341 H);  intros.
  apply (rem_1340 epsilon_m__type_5_pagent);  tauto.
Defined.

Remark rem_1343 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto_agent server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pagent.  case (rem_1333 epsilon_m__type_5_pagent). clear  epsilon_m__type_5_pagent. intros. apply trans_agent_server_1;  tauto.
 clear  epsilon_m__type_5_pagent. tauto.
Defined.

Remark rem_1344 : auto___type_5 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1345 : (forall X:term, auto___type_5 X -> auto_agent X)
    -> auto___type_5 server -> auto_agent server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pagent. intro H. intros.
  elim (rem_1344 H);  intros.
  apply (rem_1343 epsilon_m__type_5_pagent);  tauto.
Defined.

Remark rem_1346 : forall X1 X2:term, auto___type_5 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1347 : auto___type_5 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1348 : forall X1:term, auto___type_5 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1349 : auto___type_5 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1350 : auto___type_5 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1351 : forall X1 X2:term, auto___type_5 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1352 : auto___type_5 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1353 : forall X1 X2:term, auto___type_5 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1354 : forall X1 X2:term, auto___type_5 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1355 : forall X1 X2:term, auto___type_5 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1356 : forall X1 X2 X3:term, auto___type_5 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1357 : forall X1 X2:term, auto___type_5 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1358 : forall X1 X2 X3:term, auto___type_5 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1359 : forall X1 X2:term, auto___type_5 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1360 : forall X3:term, auto___type_5 X3 -> auto_agent X3. (* Induct. *)
Proof.
  fix epsilon_m__type_5_pagent 1.
  intro X. case X.
  exact (rem_1336 epsilon_m__type_5_pagent ).
  exact (rem_1339 epsilon_m__type_5_pagent ).
  intros X1 X2. intro H. elim (rem_1351 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1357 X1 X2 H).
  exact (rem_1342 epsilon_m__type_5_pagent ).
  intros X1 X2. intro H. elim (rem_1353 X1 X2 H).
   intro H. elim (rem_1349  H).
  intros X1 X2. intro H. elim (rem_1355 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1346 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1359 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1354 X1 X2 H).
   intro H. elim (rem_1347  H).
   intro H. elim (rem_1350  H).
  intros X1. intro H. elim (rem_1348 X1 H).
  exact (rem_1345 epsilon_m__type_5_pagent ).
  intros X1 X2 X3. intro H. elim (rem_1356 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1358 X1 X2 X3 H).
   intro H. elim (rem_1352  H).
Qed.

Remark rem_1361 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto_agent X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_5 X3 -> auto_agent X3). tauto. exact (rem_1360 X3).
Qed.

Remark rem_1362 : forall X4:term, auto___def_27 X4 -> auto___def_27 X4. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1363 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_27 X4. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_27 X4). tauto. exact (rem_1362 X4).
Qed.

Remark rem_1364 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> (auto_agent X1 /\ auto___type_7 X1 /\ auto___def_31 X2 /\ auto___type_5 X3 /\ auto_agent X3 /\ auto___def_27 X4) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6.
  cut (auto_agent X1). 2:apply (rem_1327 X1 X2 X3 X4);  assumption.
  cut (auto___type_7 X1). 2:apply (rem_1328 X1 X2 X3 X4);  assumption.
  cut (auto___def_31 X2). 2:apply (rem_1330 X1 X2 X3 X4);  assumption.
  cut (auto___type_5 X3). 2:apply (rem_1332 X1 X2 X3 X4);  assumption.
  cut (auto_agent X3). 2:apply (rem_1361 X1 X2 X3 X4);  assumption.
  cut (auto___def_27 X4). 2:apply (rem_1363 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_1365 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_40 X1 X2 X3 X4. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6.
  case (rem_1364 X1 X2 X3 X4 A1 A2 A3 A4 A5 A6). clear  A1 A2 A3 A4 A5 A6. intros. apply trans___def_40_1;  tauto.
 clear  A1 A2 A3 A4 A5 A6. tauto.
Qed.

Remark rem_1366 : forall X1 X2 X3 X4:term, auto_agent X1 -> auto_agent X3 -> auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___type_5 X3 -> auto___type_7 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1365 X1 X2 X3 X4).
Qed.

Remark rem_1367 : forall X1 X2:term, auto___type_4 (noncea_old X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1368 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_1367 X1 X3 H);  intros.
  apply (rem_1366 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1369 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___def_38 (cons server nil) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_40 X1 X2 X3 X4). tauto.
  exact (rem_1368 X1 X2 X3 X4).
Qed.

Remark rem_1370 : forall X1 X2 X3 X4:term, auto___type_7 X1 -> auto___def_38 (cons server nil) -> auto___def_27 X4 -> auto___def_31 X2 -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___def_38 (cons server nil) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1369 X1 X2 X3 X4).
Qed.

Remark rem_1371 : forall X1 X2:term, auto___def_39 (cons X1 X2) -> or_1
    (auto___type_7 X1 /\ auto___def_38 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1372 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_1371 X1 (cons server nil) H);  intros.
  apply (rem_1370 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1373 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___def_32 nil -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4). tauto.
  exact (rem_1372 X1 X2 X3 X4).
Qed.

Remark rem_1374 : forall X1 X2 X3 X4:term, auto___def_31 X2 -> auto___def_32 nil -> auto___def_27 X4 -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___def_32 nil -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1373 X1 X2 X3 X4).
Qed.

Remark rem_1375 : forall X1 X2:term, auto___def_28 (cons X1 X2) -> or_1
    (auto___def_31 X1 /\ auto___def_32 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1376 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_28 (cons X2 nil) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_1375 X2 nil H);  intros.
  apply (rem_1374 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1377 : forall X1 X2:term, auto___def_26 (cons X1 X2) -> or_1
    (auto___def_27 X1 /\ auto___def_28 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1378 : forall X1 X2 X3 X4:term, auto___def_26 (cons X4 (cons X2 nil)) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1377 X4 (cons X2 nil) H);  intros.
  apply (rem_1376 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1379 : forall X1 X2 X3 X4:term, auto___type_5 X3 -> auto___def_26 (cons X4 (cons X2 nil)) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_26 (cons X4 (cons X2 nil)) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___type_5 X3 -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1378 X1 X2 X3 X4).
Qed.

Remark rem_1380 : forall X1 X2:term, auto___def_25 (cons X1 X2) -> or_1
    (auto___type_5 X1 /\ auto___def_26 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1381 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1380 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_1379 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1382 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_29 sym -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto.
  exact (rem_1381 X1 X2 X3 X4).
Qed.

Remark rem_1383 : forall X1 X2 X3 X4:term, auto___def_29 sym -> auto___def_39 (cons X1 (cons server nil)) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_29 sym -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1382 X1 X2 X3 X4).
Qed.

Remark rem_1384 : forall X1 X2 X3 X4:term, auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_204 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_1383 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1385 : forall X1 X2 X3 X4:term, auto___type_4 (noncea_old X1 X3) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_4 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1384 X1 X2 X3 X4).
Qed.

Remark rem_1386 : forall X1 X2:term, auto___def_23 (cons X1 X2) -> or_1
    (auto___type_4 X1 /\ auto___def_25 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1387 : forall X1 X2 X3 X4:term, auto___def_23 (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1386 (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_1385 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1388 : forall X1 X2 X3 X4:term, auto___def_27 (noncea_old X1 X3) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_35 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_601 X1 X3 H);  intros.
Qed.

Remark rem_1389 : forall X1 X2 X3 X4:term, auto___def_27 (noncea_old X1 X3) -> auto___def_35 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 (noncea_old X1 X3) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_35 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1388 X1 X2 X3 X4).
Qed.

Remark rem_1390 : forall X1 X2:term, auto___def_33 (cons X1 X2) -> or_1
    (auto___def_27 X1 /\ auto___def_35 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1391 : forall X1 X2 X3 X4:term, auto___def_33 (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1390 (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_1389 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1392 : forall X1 X2 X3 X4:term, auto___def_44 (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___type_9 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_803 (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
Qed.

Remark rem_1393 : forall X1 X2 X3 X4:term, auto___def_42 (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___type_8 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_778 (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
Qed.

Remark rem_1394 : forall X1 X2:term, auto___def_11 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1395 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 (cons X4 (cons X2 nil)) -> auto___type_1 (noncea_old X1 X3) -> auto_agent X1 -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_1394 X4 (cons X2 nil) H);  intros.
Qed.

Remark rem_1396 : forall X1 X2:term, auto___def_9 (cons X1 X2) -> or_1
    (auto___def_10 X1 /\ auto___def_11 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1397 : forall X1 X2 X3 X4:term, auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto_agent X1 -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1396 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_1395 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1398 : forall X1 X2 X3 X4:term, auto___def_14 (cons server nil) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto_agent X1 -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto_agent X1 -> auto___def_40 X1 X2 X3 X4). tauto.
  exact (rem_1397 X1 X2 X3 X4).
Qed.

Remark rem_1399 : forall X1 X2 X3 X4:term, auto_agent X1 -> auto___def_14 (cons server nil) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_14 (cons server nil) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto_agent X1 -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1398 X1 X2 X3 X4).
Qed.

Remark rem_1400 : forall X1 X2 X3 X4:term, auto___def_13 (cons X1 (cons server nil)) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_211 X1 (cons server nil) H);  intros.
  apply (rem_1399 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1401 : forall X1 X2 X3 X4:term, auto___def_12 sym -> auto___def_13 (cons X1 (cons server nil)) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_13 (cons X1 (cons server nil)) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto.
  exact (rem_1400 X1 X2 X3 X4).
Qed.

Remark rem_1402 : forall X1 X2 X3 X4:term, auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_234 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_1401 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1403 : forall X1 X2 X3 X4:term, auto___type_1 (noncea_old X1 X3) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_old X1 X3) -> auto___def_40 X1 X2 X3 X4). tauto. exact (rem_1402 X1 X2 X3 X4).
Qed.

Remark rem_1404 : forall X1 X2:term, auto___def_7 (cons X1 X2) -> or_1
    (auto___type_1 X1 /\ auto___def_9 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1405 : forall X1 X2 X3 X4:term, auto___def_7 (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1404 (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_1403 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1406 : forall X1 X2 X3 X4:term, auto_knows_old (crypt (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) (key sym (cons X1 (cons server nil)))) -> auto___def_40 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_350 (cons (noncea_old X1 X3) (cons X3 (cons X4 (cons X2 nil)))) (key sym (cons X1 (cons server nil))) H);  intros.
  apply (rem_1326 X1 X2 X3 X4);  tauto.
  apply (rem_1387 X1 X2 X3 X4);  tauto.
  apply (rem_1391 X1 X2 X3 X4);  tauto.
  apply (rem_1392 X1 X2 X3 X4);  tauto.
  apply (rem_1393 X1 X2 X3 X4);  tauto.
  apply (rem_1405 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1407 : forall X1:term, auto___type_3 X1 -> auto___type_3 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1408 : forall X1 X2:term, auto___def_18 X2 -> auto___type_3 X1 -> auto___type_3 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_3 X1 -> auto___type_3 X1). tauto. exact (rem_1407 X1).
Qed.

Remark rem_1409 : forall X2:term, auto___def_18 X2 -> auto___def_18 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1410 : forall X1 X2:term, auto___def_18 X2 -> auto___type_3 X1 -> auto___def_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_18 X2 -> auto___def_18 X2). tauto. exact (rem_1409 X2).
Qed.

Remark rem_1411 : forall X1 X2:term, auto___def_18 X2 -> auto___type_3 X1 -> (auto___type_3 X1 /\ auto___def_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_3 X1). 2:apply (rem_1408 X1 X2);  assumption.
  cut (auto___def_18 X2). 2:apply (rem_1410 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1412 : forall X1 X2:term, auto___def_18 X2 -> auto___type_3 X1 -> auto___def_17 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1411 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_17_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1413 : forall X1:term, auto___def_78 X1 -> auto___def_78 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1414 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_1413 X1).
Qed.

Remark rem_1415 : forall X2:term, auto___def_79 X2 -> auto___def_79 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1416 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_1415 X2).
Qed.

Remark rem_1417 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> (auto___def_78 X1 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_78 X1). 2:apply (rem_1414 X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_1416 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1418 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_76 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1417 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_76_crypt_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1419 : forall X1 X2:term, auto___def_79 X2 -> auto___def_78 X1 -> auto___def_76 (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_79 X2 -> auto___def_76 (crypt X1 X2)). tauto. exact (rem_1418 X1 X2).
Qed.

Remark rem_1420 : auto___def_29 sym. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_29_sym_1;  tauto.
 tauto.
Qed.

Remark rem_1421 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_p__type_2.  tauto.
Defined.

Remark rem_1422 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto___type_2 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_2.  case (rem_1421 epsilon_magent_p__type_2). clear  epsilon_magent_p__type_2. intros. apply trans___type_2_alice_1;  tauto.
 clear  epsilon_magent_p__type_2. tauto.
Defined.

Remark rem_1423 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto_agent alice -> auto___type_2 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_2. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_1422 epsilon_magent_p__type_2);  tauto.
Defined.

Remark rem_1424 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto___type_2 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_2.  case (rem_1421 epsilon_magent_p__type_2). clear  epsilon_magent_p__type_2. intros. apply trans___type_2_bob_1;  tauto.
 clear  epsilon_magent_p__type_2. tauto.
Defined.

Remark rem_1425 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto_agent bob -> auto___type_2 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_2. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_1424 epsilon_magent_p__type_2);  tauto.
Defined.

Remark rem_1426 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto___type_2 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_2.  case (rem_1421 epsilon_magent_p__type_2). clear  epsilon_magent_p__type_2. intros. apply trans___type_2_i_1;  tauto.
 clear  epsilon_magent_p__type_2. tauto.
Defined.

Remark rem_1427 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto_agent i -> auto___type_2 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_2. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_1426 epsilon_magent_p__type_2);  tauto.
Defined.

Remark rem_1428 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto___type_2 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_2.  case (rem_1421 epsilon_magent_p__type_2). clear  epsilon_magent_p__type_2. intros. apply trans___type_2_server_1;  tauto.
 clear  epsilon_magent_p__type_2. tauto.
Defined.

Remark rem_1429 : (forall X:term, auto_agent X -> auto___type_2 X)
    -> auto_agent server -> auto___type_2 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_2. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_1428 epsilon_magent_p__type_2);  tauto.
Defined.

Remark rem_1430 : forall X1:term, auto_agent X1 -> auto___type_2 X1. (* Induct. *)
Proof.
  fix epsilon_magent_p__type_2 1.
  intro X. case X.
  exact (rem_1423 epsilon_magent_p__type_2 ).
  exact (rem_1425 epsilon_magent_p__type_2 ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_1427 epsilon_magent_p__type_2 ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_1429 epsilon_magent_p__type_2 ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_1431 : forall X1:term, auto___type_16 X1 -> auto___type_16 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1432 : forall X1 X2:term, auto___def_81 X2 -> auto___type_16 X1 -> auto___type_16 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_16 X1 -> auto___type_16 X1). tauto. exact (rem_1431 X1).
Qed.

Remark rem_1433 : forall X2:term, auto___def_81 X2 -> auto___def_81 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1434 : forall X1 X2:term, auto___def_81 X2 -> auto___type_16 X1 -> auto___def_81 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_81 X2 -> auto___def_81 X2). tauto. exact (rem_1433 X2).
Qed.

Remark rem_1435 : forall X1 X2:term, auto___def_81 X2 -> auto___type_16 X1 -> (auto___type_16 X1 /\ auto___def_81 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_16 X1). 2:apply (rem_1432 X1 X2);  assumption.
  cut (auto___def_81 X2). 2:apply (rem_1434 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1436 : forall X1 X2:term, auto___def_81 X2 -> auto___type_16 X1 -> auto___def_80 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1435 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_80_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1437 : (forall X:term, auto___def_10 X -> auto___type_16 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1438 : (forall X:term, auto___def_10 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_10_p__type_16. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_1437 epsilon_m__def_10_p__type_16 X1).
Defined.

Remark rem_1439 : (forall X:term, auto___def_10 X -> auto___type_16 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1440 : (forall X:term, auto___def_10 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_10_p__type_16. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_1439 epsilon_m__def_10_p__type_16 X2).
Defined.

Remark rem_1441 : (forall X:term, auto___def_10 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> (auto_knows_old X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_10_p__type_16. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_1438 epsilon_m__def_10_p__type_16 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_1440 epsilon_m__def_10_p__type_16 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1442 : (forall X:term, auto___def_10 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto___type_16 (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_10_p__type_16. intros X1 X2. intros A1 A2.
  case (rem_1441 epsilon_m__def_10_p__type_16 X1 X2 A1 A2). clear  epsilon_m__def_10_p__type_16 A1 A2. intros. apply trans___type_16_nonceb_old_1;  tauto.
 clear  epsilon_m__def_10_p__type_16 A1 A2. tauto.
Defined.

Remark rem_1443 : forall X1 X2:term, auto___def_10 (nonceb_old X1 X2) -> or_1
    (auto_knows_old X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1444 : (forall X:term, auto___def_10 X -> auto___type_16 X)
    -> forall X1 X2:term, auto___def_10 (nonceb_old X1 X2) -> auto___type_16 (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_10_p__type_16. intros X1 X2. intro H. intros.
  elim (rem_1443 X1 X2 H);  intros.
  apply (rem_1442 epsilon_m__def_10_p__type_16 X1 X2);  tauto.
Defined.

Remark rem_1445 : auto___def_10 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1446 : forall X1 X2:term, auto___def_10 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1447 : auto___def_10 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1448 : auto___def_10 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1449 : forall X1:term, auto___def_10 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1450 : auto___def_10 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1451 : auto___def_10 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1452 : auto___def_10 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1453 : forall X1 X2:term, auto___def_10 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1454 : auto___def_10 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1455 : auto___def_10 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1456 : forall X1 X2:term, auto___def_10 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1457 : forall X1 X2:term, auto___def_10 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1458 : forall X1 X2 X3:term, auto___def_10 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1459 : forall X1 X2:term, auto___def_10 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1460 : forall X1 X2 X3:term, auto___def_10 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1461 : forall X1 X2:term, auto___def_10 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1462 : forall X1:term, auto___def_10 X1 -> auto___type_16 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_10_p__type_16 1.
  intro X. case X.
   intro H. elim (rem_1445  H).
   intro H. elim (rem_1448  H).
  intros X1 X2. intro H. elim (rem_1453 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1459 X1 X2 H).
   intro H. elim (rem_1451  H).
  intros X1 X2. intro H. elim (rem_1456 X1 X2 H).
   intro H. elim (rem_1450  H).
  intros X1 X2. intro H. elim (rem_1457 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1446 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1461 X1 X2 H).
  intros X1 X2;  exact (rem_1444 epsilon_m__def_10_p__type_16 X1 X2).
   intro H. elim (rem_1447  H).
   intro H. elim (rem_1452  H).
  intros X1. intro H. elim (rem_1449 X1 H).
   intro H. elim (rem_1454  H).
  intros X1 X2 X3. intro H. elim (rem_1458 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1460 X1 X2 X3 H).
   intro H. elim (rem_1455  H).
Qed.

Remark rem_1463 : forall X1 X2 X3 X4:term, auto___def_10 X1 -> auto___type_1 X2 -> auto_agent X3 -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto___type_16 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_10 X1 -> auto___type_16 X1). tauto. exact (rem_1462 X1).
Qed.

Remark rem_1464 : forall X1 X2 X3 X4:term, auto___type_1 X2 -> auto_knows_current X2 -> auto_agent X3 -> auto_knows_current X3 -> auto___def_10 X1 -> auto_knows_current X4 -> auto___type_16 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_10 X1 -> auto___type_1 X2 -> auto_agent X3 -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto___type_16 X1). tauto. exact (rem_1463 X1 X2 X3 X4).
Qed.

Remark rem_1465 : (forall X:term, auto___def_60 X -> auto___type_16 X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1466 : (forall X:term, auto___def_60 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_60_p__type_16. intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_1465 epsilon_m__def_60_p__type_16 X1).
Defined.

Remark rem_1467 : (forall X:term, auto___def_60 X -> auto___type_16 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1468 : (forall X:term, auto___def_60 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_60_p__type_16. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_1467 epsilon_m__def_60_p__type_16 X2).
Defined.

Remark rem_1469 : (forall X:term, auto___def_60 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_agent X2 -> (auto_knows_current X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_60_p__type_16. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_1466 epsilon_m__def_60_p__type_16 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_1468 epsilon_m__def_60_p__type_16 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1470 : (forall X:term, auto___def_60 X -> auto___type_16 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_agent X2 -> auto___type_16 (nonceb_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_60_p__type_16. intros X1 X2. intros A1 A2.
  case (rem_1469 epsilon_m__def_60_p__type_16 X1 X2 A1 A2). clear  epsilon_m__def_60_p__type_16 A1 A2. intros. apply trans___type_16_nonceb_current_1;  tauto.
 clear  epsilon_m__def_60_p__type_16 A1 A2. tauto.
Defined.

Remark rem_1471 : forall X1 X2:term, auto___def_60 (nonceb_current X1 X2) -> or_1
    (auto_knows_current X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1472 : (forall X:term, auto___def_60 X -> auto___type_16 X)
    -> forall X1 X2:term, auto___def_60 (nonceb_current X1 X2) -> auto___type_16 (nonceb_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_60_p__type_16. intros X1 X2. intro H. intros.
  elim (rem_1471 X1 X2 H);  intros.
  apply (rem_1470 epsilon_m__def_60_p__type_16 X1 X2);  tauto.
Defined.

Remark rem_1473 : auto___def_60 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1474 : forall X1 X2:term, auto___def_60 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1475 : auto___def_60 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1476 : auto___def_60 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1477 : forall X1:term, auto___def_60 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1478 : auto___def_60 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1479 : auto___def_60 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1480 : auto___def_60 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1481 : forall X1 X2:term, auto___def_60 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1482 : auto___def_60 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1483 : auto___def_60 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1484 : forall X1 X2:term, auto___def_60 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1485 : forall X1 X2:term, auto___def_60 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1486 : forall X1 X2:term, auto___def_60 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1487 : forall X1 X2 X3:term, auto___def_60 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1488 : forall X1 X2:term, auto___def_60 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1489 : forall X1 X2 X3:term, auto___def_60 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1490 : forall X1:term, auto___def_60 X1 -> auto___type_16 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_60_p__type_16 1.
  intro X. case X.
   intro H. elim (rem_1473  H).
   intro H. elim (rem_1476  H).
  intros X1 X2. intro H. elim (rem_1481 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1488 X1 X2 H).
   intro H. elim (rem_1479  H).
  intros X1 X2. intro H. elim (rem_1484 X1 X2 H).
   intro H. elim (rem_1478  H).
  intros X1 X2. intro H. elim (rem_1486 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1474 X1 X2 H).
  intros X1 X2;  exact (rem_1472 epsilon_m__def_60_p__type_16 X1 X2).
  intros X1 X2. intro H. elim (rem_1485 X1 X2 H).
   intro H. elim (rem_1475  H).
   intro H. elim (rem_1480  H).
  intros X1. intro H. elim (rem_1477 X1 H).
   intro H. elim (rem_1482  H).
  intros X1 X2 X3. intro H. elim (rem_1487 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1489 X1 X2 X3 H).
   intro H. elim (rem_1483  H).
Qed.

Remark rem_1491 : forall X1 X2 X3 X4:term, auto___def_60 X1 -> auto_agent X2 -> auto_knows_current X2 -> auto_knows_current X3 -> auto_knows_current X4 -> auto___type_16 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_60 X1 -> auto___type_16 X1). tauto. exact (rem_1490 X1).
Qed.

Remark rem_1492 : forall X1 X2 X3 X4:term, auto_knows_current X2 -> auto_agent X3 -> auto_knows_current X3 -> auto___def_60 X1 -> auto_knows_current X4 -> auto___type_16 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X2 X3.
  cut (auto___def_60 X1 -> auto_agent X2 -> auto_knows_current X2 -> auto_knows_current X3 -> auto_knows_current X4 -> auto___type_16 X1). tauto. exact (rem_1491 X1 X2 X3 X4).
Qed.

Remark rem_1493 : forall X1 X2 X3 X4:term, auto___def_67 X2 X3 X1 X4 -> auto___type_16 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1030 X2 X3 X1 X4 H);  intros.
  apply (rem_1464 X1 X2 X3 X4);  tauto.
  apply (rem_1492 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1494 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14.  tauto.
Defined.

Remark rem_1495 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto___type_14 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14.  case (rem_1494 epsilon_mknows_current_p__type_14). clear  epsilon_mknows_current_p__type_14. intros. apply trans___type_14_alice_1;  tauto.
 clear  epsilon_mknows_current_p__type_14. tauto.
Defined.

Remark rem_1496 : auto_knows_current alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1497 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto_knows_current alice -> auto___type_14 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intro H. intros.
  elim (rem_1496 H);  intros.
  apply (rem_1495 epsilon_mknows_current_p__type_14);  tauto.
Defined.

Remark rem_1498 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___type_14 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.  case (rem_1494 epsilon_mknows_current_p__type_14). clear  epsilon_mknows_current_p__type_14. intros. apply trans___type_14_noncea_old_1;  tauto.
 clear  epsilon_mknows_current_p__type_14. tauto.
Defined.

Remark rem_1499 : forall X1 X2:term, auto_knows_current (noncea_old X1 X2) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1500 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current (noncea_old X1 X2) -> auto___type_14 (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intro H. intros.
  elim (rem_1499 X1 X2 H);  intros.
  apply (rem_1498 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
Defined.

Remark rem_1501 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto___type_14 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14.  case (rem_1494 epsilon_mknows_current_p__type_14). clear  epsilon_mknows_current_p__type_14. intros. apply trans___type_14_bob_1;  tauto.
 clear  epsilon_mknows_current_p__type_14. tauto.
Defined.

Remark rem_1502 : auto_knows_current bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1503 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto_knows_current bob -> auto___type_14 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intro H. intros.
  elim (rem_1502 H);  intros.
  apply (rem_1501 epsilon_mknows_current_p__type_14);  tauto.
Defined.

Remark rem_1504 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1505 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_1504 epsilon_mknows_current_p__type_14 X1);  assumption.
  tauto.
Defined.

Remark rem_1506 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto_knows_current X1 -> auto___type_14 (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1. intros A1.
  case (rem_1505 epsilon_mknows_current_p__type_14 X1 A1). clear  epsilon_mknows_current_p__type_14 A1. intros. apply trans___type_14_s_1;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1. tauto.
Defined.

Remark rem_1507 : forall X1:term, auto_knows_current (s X1) -> or_1
    (auto_knows_current X1).
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1508 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto_knows_current (s X1) -> auto___type_14 (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1. intro H. intros.
  elim (rem_1507 X1 H);  intros.
  apply (rem_1506 epsilon_mknows_current_p__type_14 X1);  tauto.
Defined.

Remark rem_1509 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto___type_14 nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14.  case (rem_1494 epsilon_mknows_current_p__type_14). clear  epsilon_mknows_current_p__type_14. intros. apply trans___type_14_nil_1;  tauto.
 clear  epsilon_mknows_current_p__type_14. tauto.
Defined.

Remark rem_1510 : auto_knows_current nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1511 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto_knows_current nil -> auto___type_14 nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intro H. intros.
  elim (rem_1510 H);  intros.
  apply (rem_1509 epsilon_mknows_current_p__type_14);  tauto.
Defined.

Remark rem_1512 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto___type_14 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14.  case (rem_1494 epsilon_mknows_current_p__type_14). clear  epsilon_mknows_current_p__type_14. intros. apply trans___type_14_i_1;  tauto.
 clear  epsilon_mknows_current_p__type_14. tauto.
Defined.

Remark rem_1513 : auto_knows_current i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1514 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto_knows_current i -> auto___type_14 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intro H. intros.
  elim (rem_1513 H);  intros.
  apply (rem_1512 epsilon_mknows_current_p__type_14);  tauto.
Defined.

Remark rem_1515 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_1504 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1516 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto_knows_current X2 -> auto_knows_current X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1517 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_1516 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1518 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_1515 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_1517 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1519 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_14 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1518 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_cons_1;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1520 : forall X1 X2:term, auto_knows_current (cons X1 X2) -> or_1
    (auto_knows_current X1 /\ auto_knows_current X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1521 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current (cons X1 X2) -> auto___type_14 (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intro H. intros.
  elim (rem_1520 X1 X2 H);  intros.
  apply (rem_1519 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
Defined.

Remark rem_1522 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto___type_14 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14.  case (rem_1494 epsilon_mknows_current_p__type_14). clear  epsilon_mknows_current_p__type_14. intros. apply trans___type_14_server_1;  tauto.
 clear  epsilon_mknows_current_p__type_14. tauto.
Defined.

Remark rem_1523 : auto_knows_current server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1524 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> auto_knows_current server -> auto___type_14 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intro H. intros.
  elim (rem_1523 H);  intros.
  apply (rem_1522 epsilon_mknows_current_p__type_14);  tauto.
Defined.

Remark rem_1525 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_49 X1 -> auto___def_49 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1526 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_49 X1 -> auto___def_49 X1). tauto. exact (rem_1525 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1527 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_50 X2 -> auto___def_50 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1528 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_50 X2). tauto. exact (rem_1527 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1529 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_1526 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_1528 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1530 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___type_14 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1529 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_key_1;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1531 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1532 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_1531 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1533 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1534 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_1533 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1535 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_1532 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_1534 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1536 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_14 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1535 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_key_2;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1537 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1538 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_1537 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1539 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1540 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_1539 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1541 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_1538 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_1540 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1542 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_14 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1541 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_key_3;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1543 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current (key X1 X2) -> auto___type_14 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intro H. intros.
  elim (rem_99 X1 X2 H);  intros.
  apply (rem_1530 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1536 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1542 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
Defined.

Remark rem_1544 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___type_14 (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.  case (rem_1494 epsilon_mknows_current_p__type_14). clear  epsilon_mknows_current_p__type_14. intros. apply trans___type_14_nonceb_old_1;  tauto.
 clear  epsilon_mknows_current_p__type_14. tauto.
Defined.

Remark rem_1545 : forall X1 X2:term, auto_knows_current (nonceb_old X1 X2) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1546 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current (nonceb_old X1 X2) -> auto___type_14 (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intro H. intros.
  elim (rem_1545 X1 X2 H);  intros.
  apply (rem_1544 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
Defined.

Remark rem_1547 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1548 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_1547 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1549 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1550 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_1549 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1551 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_1548 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_1550 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1552 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_14 (noncea_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1551 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_noncea_current_1;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1553 : forall X1 X2:term, auto_knows_current (noncea_current X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1554 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current (noncea_current X1 X2) -> auto___type_14 (noncea_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intro H. intros.
  elim (rem_1553 X1 X2 H);  intros.
  apply (rem_1552 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
Defined.

Remark rem_1555 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1556 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_1555 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1557 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1558 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_1557 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1559 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_1556 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_1558 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1560 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1559 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_1;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1561 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1562 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_1561 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1563 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1564 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_1563 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1565 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_1562 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_1564 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1566 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1565 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_2;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1567 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_78 X1 -> auto___def_78 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1568 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_1567 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1569 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_79 X2 -> auto___def_79 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1570 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_1569 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1571 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> (auto___def_78 X1 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_78 X1). 2:apply (rem_1568 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_1570 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1572 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1571 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_3;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1573 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_89 X1 -> auto___def_89 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1574 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_1573 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1575 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___type_19 X2 -> auto___type_19 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1576 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___type_19 X2 -> auto___type_19 X2). tauto. exact (rem_1575 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1577 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> (auto___def_89 X1 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_89 X1). 2:apply (rem_1574 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_1576 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1578 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1577 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_4;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1579 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_57 X1 -> auto___def_57 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1580 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_1579 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1581 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_58 X2 -> auto___def_58 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1582 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_58 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_58 X2 -> auto___def_58 X2). tauto. exact (rem_1581 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1583 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> (auto___def_57 X1 /\ auto___def_58 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_57 X1). 2:apply (rem_1580 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_58 X2). 2:apply (rem_1582 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1584 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1583 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_5;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1585 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_68 X1 -> auto___def_68 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1586 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_1585 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1587 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_69 X2 -> auto___def_69 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1588 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_69 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_69 X2 -> auto___def_69 X2). tauto. exact (rem_1587 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1589 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> (auto___def_68 X1 /\ auto___def_69 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_68 X1). 2:apply (rem_1586 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_69 X2). 2:apply (rem_1588 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1590 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1589 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_6;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1591 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1518 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_7;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1592 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_87 X1 -> auto___def_87 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1593 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_1592 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1594 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___type_18 X2 -> auto___type_18 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1595 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___type_18 X2 -> auto___type_18 X2). tauto. exact (rem_1594 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1596 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> (auto___def_87 X1 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_87 X1). 2:apply (rem_1593 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_1595 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1597 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1596 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_8;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1598 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1599 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_1598 epsilon_mknows_current_p__type_14 X1).
Defined.

Remark rem_1600 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1601 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_1600 epsilon_mknows_current_p__type_14 X2).
Defined.

Remark rem_1602 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_1599 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_1601 epsilon_mknows_current_p__type_14 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1603 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_14 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intros A1 A2.
  case (rem_1602 epsilon_mknows_current_p__type_14 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_14 A1 A2. intros. apply trans___type_14_crypt_9;  tauto.
 clear  epsilon_mknows_current_p__type_14 A1 A2. tauto.
Defined.

Remark rem_1604 : forall X1 X2:term, auto_knows_current (crypt X1 X2) -> or_9
    (auto___def_23 X1 /\ auto___def_24 X2)
    (auto___def_33 X1 /\ auto___def_34 X2)
    (auto___def_78 X1 /\ auto___def_79 X2)
    (auto___def_89 X1 /\ auto___type_19 X2)
    (auto___def_57 X1 /\ auto___def_58 X2)
    (auto___def_68 X1 /\ auto___def_69 X2)
    (auto_knows_current X1 /\ auto_knows_current X2)
    (auto___def_87 X1 /\ auto___type_18 X2)
    (auto___def_7 X1 /\ auto___def_8 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_9_intro_1; tauto.
  intros. apply or_9_intro_2; tauto.
  intros. apply or_9_intro_3; tauto.
  intros. apply or_9_intro_4; tauto.
  intros. apply or_9_intro_5; tauto.
  intros. apply or_9_intro_6; tauto.
  intros. apply or_9_intro_7; tauto.
  intros. apply or_9_intro_8; tauto.
  intros. apply or_9_intro_9; tauto.
Qed.

Remark rem_1605 : (forall X:term, auto_knows_current X -> auto___type_14 X)
    -> forall X1 X2:term, auto_knows_current (crypt X1 X2) -> auto___type_14 (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_14. intros X1 X2. intro H. intros.
  elim (rem_1604 X1 X2 H);  intros.
  apply (rem_1560 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1566 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1572 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1578 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1584 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1590 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1591 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1597 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
  apply (rem_1603 epsilon_mknows_current_p__type_14 X1 X2);  tauto.
Defined.

Remark rem_1606 : auto_knows_current prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1607 : auto_knows_current pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1608 : auto_knows_current sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1609 : forall X1 X2 X3:term, auto_knows_current (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1610 : forall X1 X2 X3:term, auto_knows_current (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1611 : forall X1 X2:term, auto_knows_current (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1612 : forall X1:term, auto_knows_current X1 -> auto___type_14 X1. (* Induct. *)
Proof.
  fix epsilon_mknows_current_p__type_14 1.
  intro X. case X.
  exact (rem_1497 epsilon_mknows_current_p__type_14 ).
  exact (rem_1503 epsilon_mknows_current_p__type_14 ).
  intros X1 X2;  exact (rem_1521 epsilon_mknows_current_p__type_14 X1 X2).
  intros X1 X2;  exact (rem_1605 epsilon_mknows_current_p__type_14 X1 X2).
  exact (rem_1514 epsilon_mknows_current_p__type_14 ).
  intros X1 X2;  exact (rem_1543 epsilon_mknows_current_p__type_14 X1 X2).
  exact (rem_1511 epsilon_mknows_current_p__type_14 ).
  intros X1 X2;  exact (rem_1554 epsilon_mknows_current_p__type_14 X1 X2).
  intros X1 X2;  exact (rem_1500 epsilon_mknows_current_p__type_14 X1 X2).
  intros X1 X2. intro H. elim (rem_1611 X1 X2 H).
  intros X1 X2;  exact (rem_1546 epsilon_mknows_current_p__type_14 X1 X2).
   intro H. elim (rem_1606  H).
   intro H. elim (rem_1607  H).
  intros X1;  exact (rem_1508 epsilon_mknows_current_p__type_14 X1).
  exact (rem_1524 epsilon_mknows_current_p__type_14 ).
  intros X1 X2 X3. intro H. elim (rem_1609 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1610 X1 X2 X3 H).
   intro H. elim (rem_1608  H).
Qed.

Remark rem_1613 : forall X1 X2 X3 X4:term, auto___def_10 X2 -> auto___type_1 X3 -> auto_agent X4 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_14 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X1 -> auto___type_14 X1). tauto. exact (rem_1612 X1).
Qed.

Remark rem_1614 : forall X1 X2 X3 X4:term, auto___type_1 X2 -> auto_knows_current X2 -> auto_agent X3 -> auto_knows_current X3 -> auto___def_10 X4 -> auto_knows_current X1 -> auto___type_14 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X3 X4 X2.
  cut (auto___def_10 X2 -> auto___type_1 X3 -> auto_agent X4 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_14 X1). tauto. exact (rem_1613 X1 X2 X3 X4).
Qed.

Remark rem_1615 : forall X1 X2 X3 X4:term, auto___def_60 X2 -> auto_agent X3 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X4 -> auto___type_14 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X1 -> auto___type_14 X1). tauto. exact (rem_1612 X1).
Qed.

Remark rem_1616 : forall X1 X2 X3 X4:term, auto_knows_current X2 -> auto_agent X3 -> auto_knows_current X3 -> auto___def_60 X4 -> auto_knows_current X1 -> auto___type_14 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X3 X2.
  cut (auto___def_60 X2 -> auto_agent X3 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X4 -> auto___type_14 X1). tauto. exact (rem_1615 X1 X2 X3 X4).
Qed.

Remark rem_1617 : forall X1 X2 X3 X4:term, auto___def_67 X2 X3 X4 X1 -> auto___type_14 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1030 X2 X3 X4 X1 H);  intros.
  apply (rem_1614 X1 X2 X3 X4);  tauto.
  apply (rem_1616 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1618 : forall X1:term, auto___def_74 X1 -> auto___def_74 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1619 : forall X1 X2:term, auto___def_74 X1 -> auto___def_82 X2 -> auto___def_74 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_74 X1). tauto. exact (rem_1618 X1).
Qed.

Remark rem_1620 : forall X2:term, auto___def_82 X2 -> auto___def_82 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1621 : forall X1 X2:term, auto___def_74 X1 -> auto___def_82 X2 -> auto___def_82 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_82 X2 -> auto___def_82 X2). tauto. exact (rem_1620 X2).
Qed.

Remark rem_1622 : forall X1 X2:term, auto___def_74 X1 -> auto___def_82 X2 -> (auto___def_74 X1 /\ auto___def_82 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_74 X1). 2:apply (rem_1619 X1 X2);  assumption.
  cut (auto___def_82 X2). 2:apply (rem_1621 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1623 : forall X1 X2:term, auto___def_74 X1 -> auto___def_82 X2 -> auto___def_79 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1622 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_79_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1624 : forall X1 X2:term, auto___def_82 X2 -> auto___def_74 X1 -> auto___def_79 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_82 X2 -> auto___def_79 (key X1 X2)). tauto. exact (rem_1623 X1 X2).
Qed.

Remark rem_1625 : forall X1:term, auto___type_11 X1 -> auto___type_11 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1626 : forall X1 X2:term, auto___def_59 X2 -> auto___type_11 X1 -> auto___type_11 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_11 X1 -> auto___type_11 X1). tauto. exact (rem_1625 X1).
Qed.

Remark rem_1627 : forall X2:term, auto___def_59 X2 -> auto___def_59 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1628 : forall X1 X2:term, auto___def_59 X2 -> auto___type_11 X1 -> auto___def_59 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_59 X2 -> auto___def_59 X2). tauto. exact (rem_1627 X2).
Qed.

Remark rem_1629 : forall X1 X2:term, auto___def_59 X2 -> auto___type_11 X1 -> (auto___type_11 X1 /\ auto___def_59 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_11 X1). 2:apply (rem_1626 X1 X2);  assumption.
  cut (auto___def_59 X2). 2:apply (rem_1628 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1630 : forall X1 X2:term, auto___def_59 X2 -> auto___type_11 X1 -> auto___def_57 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1629 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_57_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1631 : forall X1 X2:term, auto___def_74 X1 -> auto___def_84 X2 -> auto___def_74 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_74 X1). tauto. exact (rem_1618 X1).
Qed.

Remark rem_1632 : forall X2:term, auto___def_84 X2 -> auto___def_84 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1633 : forall X1 X2:term, auto___def_74 X1 -> auto___def_84 X2 -> auto___def_84 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_84 X2 -> auto___def_84 X2). tauto. exact (rem_1632 X2).
Qed.

Remark rem_1634 : forall X1 X2:term, auto___def_74 X1 -> auto___def_84 X2 -> (auto___def_74 X1 /\ auto___def_84 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_74 X1). 2:apply (rem_1631 X1 X2);  assumption.
  cut (auto___def_84 X2). 2:apply (rem_1633 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1635 : forall X1 X2:term, auto___def_74 X1 -> auto___def_84 X2 -> auto___def_69 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1634 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_69_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1636 : forall X1 X2:term, auto___def_84 X2 -> auto___def_74 X1 -> auto___def_69 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_84 X2 -> auto___def_69 (key X1 X2)). tauto. exact (rem_1635 X1 X2).
Qed.

Remark rem_1637 : forall X1:term, auto___def_10 X1 -> auto___def_10 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1638 : forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> auto___def_10 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_10 X1 -> auto___def_10 X1). tauto. exact (rem_1637 X1).
Qed.

Remark rem_1639 : forall X2:term, auto___def_11 X2 -> auto___def_11 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1640 : forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> auto___def_11 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_11 X2 -> auto___def_11 X2). tauto. exact (rem_1639 X2).
Qed.

Remark rem_1641 : forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> (auto___def_10 X1 /\ auto___def_11 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_10 X1). 2:apply (rem_1638 X1 X2);  assumption.
  cut (auto___def_11 X2). 2:apply (rem_1640 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1642 : forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> auto___def_9 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1641 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_9_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1643 : forall X1 X2:term, auto___def_11 X2 -> auto___def_10 X1 -> auto___def_9 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_10 X1 -> auto___def_11 X2 -> auto___def_9 (cons X1 X2)). tauto. exact (rem_1642 X1 X2).
Qed.

Remark rem_1644 : auto___def_26 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1645 : auto___def_26 nil -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_1644 H);  intros.
Qed.

Remark rem_1646 : forall X1 X2 X3 X4:term, auto___def_26 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto___type_5 X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_26 nil -> False). tauto.
  exact (rem_1645).
Qed.

Remark rem_1647 : forall X1 X2 X3 X4:term, auto___type_5 X3 -> auto___def_26 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_26 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto___type_5 X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1646 X1 X2 X3 X4).
Qed.

Remark rem_1648 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1380 X3 nil H);  intros.
  apply (rem_1647 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1649 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 nil) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1648 X1 X2 X3 X4).
Qed.

Remark rem_1650 : forall X1 X2 X3 X4:term, auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___def_25 (cons X3 nil) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 nil) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1649 X1 X2 X3 X4).
Qed.

Remark rem_1651 : forall X1 X2 X3 X4:term, auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons X3 nil) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_204 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_1650 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1652 : forall X1 X2 X3 X4:term, auto___type_4 X1 -> auto___def_25 (cons X3 nil) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons X3 nil) -> auto___type_4 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1651 X1 X2 X3 X4).
Qed.

Remark rem_1653 : forall X1 X2 X3 X4:term, auto___def_23 (cons X1 (cons X3 nil)) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1386 X1 (cons X3 nil) H);  intros.
  apply (rem_1652 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1654 : auto___def_36 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1655 : auto___def_36 nil -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_1654 H);  intros.
Qed.

Remark rem_1656 : forall X1 X2 X3 X4:term, auto___def_27 X1 -> auto___def_36 nil -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_36 nil -> False). tauto.
  exact (rem_1655).
Qed.

Remark rem_1657 : forall X1 X2 X3 X4:term, auto___type_6 X3 -> auto___def_36 nil -> auto___def_27 X1 -> auto___def_37 (cons X2 (cons server nil)) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X1 -> auto___def_36 nil -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1656 X1 X2 X3 X4).
Qed.

Remark rem_1658 : forall X1 X2:term, auto___def_35 (cons X1 X2) -> or_1
    (auto___type_6 X1 /\ auto___def_36 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1659 : forall X1 X2 X3 X4:term, auto___def_27 X1 -> auto___def_35 (cons X3 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_1658 X3 nil H);  intros.
  apply (rem_1657 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1660 : forall X1 X2 X3 X4:term, auto___def_27 X1 -> auto___def_29 sym -> auto___def_35 (cons X3 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_27 X1 -> auto___def_35 (cons X3 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1659 X1 X2 X3 X4).
Qed.

Remark rem_1661 : forall X1 X2 X3 X4:term, auto___def_29 sym -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_27 X1 -> auto___def_35 (cons X3 nil) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X1 -> auto___def_29 sym -> auto___def_35 (cons X3 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1660 X1 X2 X3 X4).
Qed.

Remark rem_1662 : forall X1 X2 X3 X4:term, auto___def_27 X1 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons X3 nil) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_313 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_1661 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1663 : forall X1 X2 X3 X4:term, auto___def_27 X1 -> auto___def_35 (cons X3 nil) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X1 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons X3 nil) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1662 X1 X2 X3 X4).
Qed.

Remark rem_1664 : forall X1 X2 X3 X4:term, auto___def_33 (cons X1 (cons X3 nil)) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1390 X1 (cons X3 nil) H);  intros.
  apply (rem_1663 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1665 : forall X1 X2 X3 X4:term, auto___def_72 X1 -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto___def_80 (cons X3 nil) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2 X3 X4. intros.
  assert (HH:=(rem_120 X1)). tauto.
Qed.

Remark rem_1666 : forall X1 X2 X3 X4:term, auto___def_72 X1 -> auto___def_80 (cons X3 nil) -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_72 X1 -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto___def_80 (cons X3 nil) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1665 X1 X2 X3 X4).
Qed.

Remark rem_1667 : forall X1 X2:term, auto___def_78 (cons X1 X2) -> or_1
    (auto___def_72 X1 /\ auto___def_80 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1668 : forall X1 X2 X3 X4:term, auto___def_78 (cons X1 (cons X3 nil)) -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1667 X1 (cons X3 nil) H);  intros.
  apply (rem_1666 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1669 : forall X1 X2:term, auto___def_89 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1670 : forall X1 X2 X3 X4:term, auto___def_89 (cons X1 (cons X3 nil)) -> auto___type_19 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1669 X1 (cons X3 nil) H);  intros.
Qed.

Remark rem_1671 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current.  tauto.
Defined.

Remark rem_1672 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current.  case (rem_1671 epsilon_m__type_11_pknows_current). clear  epsilon_m__type_11_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_11_pknows_current. tauto.
Defined.

Remark rem_1673 : auto___type_11 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1674 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto___type_11 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intro H. intros.
  elim (rem_1673 H);  intros.
  apply (rem_1672 epsilon_m__type_11_pknows_current);  tauto.
Defined.

Remark rem_1675 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.  case (rem_1671 epsilon_m__type_11_pknows_current). clear  epsilon_m__type_11_pknows_current. intros. apply trans_knows_current_noncea_old_1;  tauto.
 clear  epsilon_m__type_11_pknows_current. tauto.
Defined.

Remark rem_1676 : forall X1 X2:term, auto___type_11 (noncea_old X1 X2) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1677 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_11 (noncea_old X1 X2) -> auto_knows_current (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1676 X1 X2 H);  intros.
  apply (rem_1675 epsilon_m__type_11_pknows_current X1 X2);  tauto.
Defined.

Remark rem_1678 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current.  case (rem_1671 epsilon_m__type_11_pknows_current). clear  epsilon_m__type_11_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_11_pknows_current. tauto.
Defined.

Remark rem_1679 : auto___type_11 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1680 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto___type_11 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intro H. intros.
  elim (rem_1679 H);  intros.
  apply (rem_1678 epsilon_m__type_11_pknows_current);  tauto.
Defined.

Remark rem_1681 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1682 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_1681 epsilon_m__type_11_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_1683 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1. intros A1.
  case (rem_1682 epsilon_m__type_11_pknows_current X1 A1). clear  epsilon_m__type_11_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_m__type_11_pknows_current A1. tauto.
Defined.

Remark rem_1684 : forall X1:term, auto___type_11 (s X1) -> or_1
    (auto_knows_current X1).
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1685 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___type_11 (s X1) -> auto_knows_current (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1. intro H. intros.
  elim (rem_1684 X1 H);  intros.
  apply (rem_1683 epsilon_m__type_11_pknows_current X1);  tauto.
Defined.

Remark rem_1686 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current.  case (rem_1671 epsilon_m__type_11_pknows_current). clear  epsilon_m__type_11_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__type_11_pknows_current. tauto.
Defined.

Remark rem_1687 : auto___type_11 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1688 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto___type_11 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intro H. intros.
  elim (rem_1687 H);  intros.
  apply (rem_1686 epsilon_m__type_11_pknows_current);  tauto.
Defined.

Remark rem_1689 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current.  case (rem_1671 epsilon_m__type_11_pknows_current). clear  epsilon_m__type_11_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_11_pknows_current. tauto.
Defined.

Remark rem_1690 : auto___type_11 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1691 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto___type_11 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intro H. intros.
  elim (rem_1690 H);  intros.
  apply (rem_1689 epsilon_m__type_11_pknows_current);  tauto.
Defined.

Remark rem_1692 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_1681 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1693 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto_knows_current X2 -> auto_knows_current X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1694 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_1693 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1695 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_1692 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_1694 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1696 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1695 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1697 : forall X1 X2:term, auto___type_11 (cons X1 X2) -> or_1
    (auto_knows_current X1 /\ auto_knows_current X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1698 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_11 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1697 X1 X2 H);  intros.
  apply (rem_1696 epsilon_m__type_11_pknows_current X1 X2);  tauto.
Defined.

Remark rem_1699 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current.  case (rem_1671 epsilon_m__type_11_pknows_current). clear  epsilon_m__type_11_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_11_pknows_current. tauto.
Defined.

Remark rem_1700 : auto___type_11 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1701 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> auto___type_11 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intro H. intros.
  elim (rem_1700 H);  intros.
  apply (rem_1699 epsilon_m__type_11_pknows_current);  tauto.
Defined.

Remark rem_1702 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_49 X1 -> auto___def_49 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1703 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_49 X1 -> auto___def_49 X1). tauto. exact (rem_1702 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1704 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_50 X2 -> auto___def_50 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1705 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_50 X2). tauto. exact (rem_1704 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1706 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_1703 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_1705 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1707 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1706 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_key_1;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1708 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1709 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_1708 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1710 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1711 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_1710 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1712 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_1709 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_1711 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1713 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1712 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_key_2;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1714 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1715 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_1714 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1716 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1717 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_1716 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1718 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_1715 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_1717 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1719 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1718 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_key_3;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1720 : forall X1 X2:term, auto___type_11 (key X1 X2) -> or_3
    (auto___def_49 X1 /\ auto___def_50 X2)
    (auto___def_47 X1 /\ auto___def_48 X2)
    (auto___def_46 X1 /\ auto___type_10 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_3_intro_1; tauto.
  intros. apply or_3_intro_2; tauto.
  intros. apply or_3_intro_3; tauto.
Qed.

Remark rem_1721 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_11 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1720 X1 X2 H);  intros.
  apply (rem_1707 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1713 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1719 epsilon_m__type_11_pknows_current X1 X2);  tauto.
Defined.

Remark rem_1722 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.  case (rem_1671 epsilon_m__type_11_pknows_current). clear  epsilon_m__type_11_pknows_current. intros. apply trans_knows_current_nonceb_old_1;  tauto.
 clear  epsilon_m__type_11_pknows_current. tauto.
Defined.

Remark rem_1723 : forall X1 X2:term, auto___type_11 (nonceb_old X1 X2) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1724 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_11 (nonceb_old X1 X2) -> auto_knows_current (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1723 X1 X2 H);  intros.
  apply (rem_1722 epsilon_m__type_11_pknows_current X1 X2);  tauto.
Defined.

Remark rem_1725 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1726 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_1725 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1727 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1728 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_1727 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1729 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_1726 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_1728 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1730 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1729 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_noncea_current_1;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1731 : forall X1 X2:term, auto___type_11 (noncea_current X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1732 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_11 (noncea_current X1 X2) -> auto_knows_current (noncea_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1731 X1 X2 H);  intros.
  apply (rem_1730 epsilon_m__type_11_pknows_current X1 X2);  tauto.
Defined.

Remark rem_1733 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1734 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_1733 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1735 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1736 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_1735 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1737 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_1734 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_1736 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1738 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1737 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_1;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1739 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1740 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_1739 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1741 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1742 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_1741 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1743 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_1740 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_1742 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1744 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1743 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_2;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1745 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_78 X1 -> auto___def_78 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1746 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_1745 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1747 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_79 X2 -> auto___def_79 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1748 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_1747 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1749 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> (auto___def_78 X1 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_78 X1). 2:apply (rem_1746 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_1748 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1750 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1749 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_3;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1751 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_89 X1 -> auto___def_89 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1752 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_1751 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1753 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___type_19 X2 -> auto___type_19 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1754 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___type_19 X2 -> auto___type_19 X2). tauto. exact (rem_1753 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1755 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> (auto___def_89 X1 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_89 X1). 2:apply (rem_1752 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_1754 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1756 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1755 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_4;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1757 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_57 X1 -> auto___def_57 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1758 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_1757 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1759 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_58 X2 -> auto___def_58 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1760 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_58 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_58 X2 -> auto___def_58 X2). tauto. exact (rem_1759 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1761 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> (auto___def_57 X1 /\ auto___def_58 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_57 X1). 2:apply (rem_1758 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_58 X2). 2:apply (rem_1760 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1762 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1761 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_5;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1763 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_68 X1 -> auto___def_68 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1764 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_1763 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1765 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_69 X2 -> auto___def_69 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1766 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_69 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_69 X2 -> auto___def_69 X2). tauto. exact (rem_1765 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1767 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> (auto___def_68 X1 /\ auto___def_69 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_68 X1). 2:apply (rem_1764 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_69 X2). 2:apply (rem_1766 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1768 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1767 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_6;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1769 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1695 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1770 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_87 X1 -> auto___def_87 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1771 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_1770 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1772 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___type_18 X2 -> auto___type_18 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1773 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___type_18 X2 -> auto___type_18 X2). tauto. exact (rem_1772 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1774 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> (auto___def_87 X1 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_87 X1). 2:apply (rem_1771 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_1773 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1775 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1774 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_8;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1776 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1777 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_1776 epsilon_m__type_11_pknows_current X1).
Defined.

Remark rem_1778 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_1779 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_1778 epsilon_m__type_11_pknows_current X2).
Defined.

Remark rem_1780 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_1777 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_1779 epsilon_m__type_11_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_1781 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_1780 epsilon_m__type_11_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_11_pknows_current A1 A2. intros. apply trans_knows_current_crypt_9;  tauto.
 clear  epsilon_m__type_11_pknows_current A1 A2. tauto.
Defined.

Remark rem_1782 : forall X1 X2:term, auto___type_11 (crypt X1 X2) -> or_9
    (auto___def_23 X1 /\ auto___def_24 X2)
    (auto___def_33 X1 /\ auto___def_34 X2)
    (auto___def_78 X1 /\ auto___def_79 X2)
    (auto___def_89 X1 /\ auto___type_19 X2)
    (auto___def_57 X1 /\ auto___def_58 X2)
    (auto___def_68 X1 /\ auto___def_69 X2)
    (auto_knows_current X1 /\ auto_knows_current X2)
    (auto___def_87 X1 /\ auto___type_18 X2)
    (auto___def_7 X1 /\ auto___def_8 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_9_intro_1; tauto.
  intros. apply or_9_intro_2; tauto.
  intros. apply or_9_intro_3; tauto.
  intros. apply or_9_intro_4; tauto.
  intros. apply or_9_intro_5; tauto.
  intros. apply or_9_intro_6; tauto.
  intros. apply or_9_intro_7; tauto.
  intros. apply or_9_intro_8; tauto.
  intros. apply or_9_intro_9; tauto.
Qed.

Remark rem_1783 : (forall X:term, auto___type_11 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_11 (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_11_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1782 X1 X2 H);  intros.
  apply (rem_1738 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1744 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1750 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1756 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1762 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1768 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1769 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1775 epsilon_m__type_11_pknows_current X1 X2);  tauto.
  apply (rem_1781 epsilon_m__type_11_pknows_current X1 X2);  tauto.
Defined.

Remark rem_1784 : auto___type_11 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1785 : auto___type_11 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1786 : auto___type_11 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1787 : forall X1 X2 X3:term, auto___type_11 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1788 : forall X1 X2 X3:term, auto___type_11 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1789 : forall X1 X2:term, auto___type_11 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1790 : forall X1:term, auto___type_11 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_11_pknows_current 1.
  intro X. case X.
  exact (rem_1674 epsilon_m__type_11_pknows_current ).
  exact (rem_1680 epsilon_m__type_11_pknows_current ).
  intros X1 X2;  exact (rem_1698 epsilon_m__type_11_pknows_current X1 X2).
  intros X1 X2;  exact (rem_1783 epsilon_m__type_11_pknows_current X1 X2).
  exact (rem_1691 epsilon_m__type_11_pknows_current ).
  intros X1 X2;  exact (rem_1721 epsilon_m__type_11_pknows_current X1 X2).
  exact (rem_1688 epsilon_m__type_11_pknows_current ).
  intros X1 X2;  exact (rem_1732 epsilon_m__type_11_pknows_current X1 X2).
  intros X1 X2;  exact (rem_1677 epsilon_m__type_11_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_1789 X1 X2 H).
  intros X1 X2;  exact (rem_1724 epsilon_m__type_11_pknows_current X1 X2).
   intro H. elim (rem_1784  H).
   intro H. elim (rem_1785  H).
  intros X1;  exact (rem_1685 epsilon_m__type_11_pknows_current X1).
  exact (rem_1701 epsilon_m__type_11_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_1787 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1788 X1 X2 X3 H).
   intro H. elim (rem_1786  H).
Qed.

Remark rem_1791 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 nil -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_11 X1 -> auto_knows_current X1). tauto. exact (rem_1790 X1).
Qed.

Remark rem_1792 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 nil -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_1793 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 nil -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_knows_current X2). tauto. exact (rem_1016 X2).
Qed.

Remark rem_1794 : forall X3:term, auto___def_60 X3 -> auto___def_60 X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1795 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 nil -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_60 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_60 X3 -> auto___def_60 X3). tauto. exact (rem_1794 X3).
Qed.

Remark rem_1796 : forall X4:term, auto_knows_current X4 -> auto_knows_current X4. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1797 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 nil -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X4. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X4 -> auto_knows_current X4). tauto. exact (rem_1796 X4).
Qed.

Remark rem_1798 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 nil -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_agent X2 /\ auto_knows_current X2 /\ auto___def_60 X3 /\ auto_knows_current X4) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6 A7.
  cut (auto_knows_current X1). 2:apply (rem_1791 X1 X2 X3 X4);  assumption.
  cut (auto_agent X2). 2:apply (rem_1792 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_1793 X1 X2 X3 X4);  assumption.
  cut (auto___def_60 X3). 2:apply (rem_1795 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X4). 2:apply (rem_1797 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_1799 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 nil -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6 A7.
  case (rem_1798 X1 X2 X3 X4 A1 A2 A3 A4 A5 A6 A7). clear  A1 A2 A3 A4 A5 A6 A7. intros. apply trans___def_67_2;  tauto.
 clear  A1 A2 A3 A4 A5 A6 A7. tauto.
Qed.

Remark rem_1800 : forall X1 X2:term, auto___def_59 (cons X1 X2) -> or_1
    (auto___def_60 X1 /\ auto___def_61 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1801 : forall X1 X2 X3 X4:term, auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1800 X3 nil H);  intros.
  apply (rem_1799 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1802 : forall X1 X2 X3 X4:term, auto___def_14 (cons server nil) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1801 X1 X2 X3 X4).
Qed.

Remark rem_1803 : forall X1 X2 X3 X4:term, auto_agent X2 -> auto___def_14 (cons server nil) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_14 (cons server nil) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1802 X1 X2 X3 X4).
Qed.

Remark rem_1804 : forall X1 X2 X3 X4:term, auto___def_13 (cons X2 (cons server nil)) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_211 X2 (cons server nil) H);  intros.
  apply (rem_1803 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1805 : forall X1 X2 X3 X4:term, auto___def_12 sym -> auto___def_13 (cons X2 (cons server nil)) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_13 (cons X2 (cons server nil)) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1804 X1 X2 X3 X4).
Qed.

Remark rem_1806 : forall X1 X2 X3 X4:term, auto___def_58 (key sym (cons X2 (cons server nil))) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_259 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_1805 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1807 : forall X1 X2 X3 X4:term, auto___type_11 X1 -> auto___def_59 (cons X3 nil) -> auto___def_58 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_58 (key sym (cons X2 (cons server nil))) -> auto___def_59 (cons X3 nil) -> auto___type_11 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1806 X1 X2 X3 X4).
Qed.

Remark rem_1808 : forall X1 X2:term, auto___def_57 (cons X1 X2) -> or_1
    (auto___type_11 X1 /\ auto___def_59 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1809 : forall X1 X2 X3 X4:term, auto___def_57 (cons X1 (cons X3 nil)) -> auto___def_58 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1808 X1 (cons X3 nil) H);  intros.
  apply (rem_1807 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1810 : auto___def_71 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1811 : auto___def_71 nil -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_1810 H);  intros.
Qed.

Remark rem_1812 : forall X1 X2 X3 X4:term, auto___def_71 nil -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X1 -> auto___type_15 X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_71 nil -> False). tauto.
  exact (rem_1811).
Qed.

Remark rem_1813 : forall X1 X2 X3 X4:term, auto___type_15 X3 -> auto___def_71 nil -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_71 nil -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X1 -> auto___type_15 X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1812 X1 X2 X3 X4).
Qed.

Remark rem_1814 : forall X1 X2:term, auto___def_70 (cons X1 X2) -> or_1
    (auto___type_15 X1 /\ auto___def_71 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1815 : forall X1 X2 X3 X4:term, auto___def_70 (cons X3 nil) -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1814 X3 nil H);  intros.
  apply (rem_1813 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1816 : forall X1 X2 X3 X4:term, auto___def_70 (cons X3 nil) -> auto___def_74 sym -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_70 (cons X3 nil) -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1815 X1 X2 X3 X4).
Qed.

Remark rem_1817 : forall X1 X2 X3 X4:term, auto___def_74 sym -> auto___def_84 (cons X2 (cons server nil)) -> auto___def_70 (cons X3 nil) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_70 (cons X3 nil) -> auto___def_74 sym -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1816 X1 X2 X3 X4).
Qed.

Remark rem_1818 : forall X1 X2 X3 X4:term, auto___def_69 (key sym (cons X2 (cons server nil))) -> auto___def_70 (cons X3 nil) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_147 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_1817 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1819 : forall X1 X2 X3 X4:term, auto___type_14 X1 -> auto___def_70 (cons X3 nil) -> auto___def_69 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_69 (key sym (cons X2 (cons server nil))) -> auto___def_70 (cons X3 nil) -> auto___type_14 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1818 X1 X2 X3 X4).
Qed.

Remark rem_1820 : forall X1 X2:term, auto___def_68 (cons X1 X2) -> or_1
    (auto___type_14 X1 /\ auto___def_70 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1821 : forall X1 X2 X3 X4:term, auto___def_68 (cons X1 (cons X3 nil)) -> auto___def_69 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1820 X1 (cons X3 nil) H);  intros.
  apply (rem_1819 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1822 : forall X1 X2 X3 X4:term, auto___def_50 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_39 X2 (cons server nil) H);  intros.
Qed.

Remark rem_1823 : forall X1 X2 X3 X4:term, auto___def_49 sym -> auto___def_50 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_50 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1822 X1 X2 X3 X4).
Qed.

Remark rem_1824 : forall X1 X2 X3 X4:term, auto___def_48 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1217 X2 (cons server nil) H);  intros.
Qed.

Remark rem_1825 : forall X1 X2 X3 X4:term, auto___def_47 sym -> auto___def_48 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_48 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1824 X1 X2 X3 X4).
Qed.

Remark rem_1826 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_1827 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto___type_10 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2 X3 X4. intros. apply (rem_1826 X1 X2 X3 X4);  assumption.
Qed.

Remark rem_1828 : forall X1 X2 X3 X4:term, auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3 H4. intro H. intros.
  elim (rem_99 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_1823 X1 X2 X3 X4);  tauto.
  apply (rem_1825 X1 X2 X3 X4);  tauto.
  apply (rem_1827 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1829 : forall X1 X2 X3 X4:term, auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current nil -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1828 X1 X2 X3 X4).
Qed.

Remark rem_1830 : forall X1 X2 X3 X4:term, auto_knows_current X3 -> auto_knows_current nil -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current nil -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1829 X1 X2 X3 X4).
Qed.

Remark rem_1831 : forall X1 X2 X3 X4:term, auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X3 nil) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_1520 X3 nil H);  intros.
  apply (rem_1830 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1832 : forall X1 X2 X3 X4:term, auto_knows_current X1 -> auto_knows_current (cons X3 nil) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X3 nil) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1831 X1 X2 X3 X4).
Qed.

Remark rem_1833 : forall X1 X2 X3 X4:term, auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X1 (cons X3 nil)) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_1520 X1 (cons X3 nil) H);  intros.
  apply (rem_1832 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1834 : forall X1 X2 X3 X4:term, auto_knows_current (cons X1 (cons X3 nil)) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X1 (cons X3 nil)) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1833 X1 X2 X3 X4).
Qed.

Remark rem_1835 : forall X1 X2:term, auto___def_87 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_1836 : forall X1 X2 X3 X4:term, auto___def_87 (cons X1 (cons X3 nil)) -> auto___type_18 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1835 X1 (cons X3 nil) H);  intros.
Qed.

Remark rem_1837 : forall X1:term, auto___type_1 X1 -> auto___type_1 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1838 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___type_1 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_1 X1 -> auto___type_1 X1). tauto. exact (rem_1837 X1).
Qed.

Remark rem_1839 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_1 X1 -> auto_knows_current X1). tauto. exact (rem_1004 X1).
Qed.

Remark rem_1840 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_1841 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_knows_current X2). tauto. exact (rem_1016 X2).
Qed.

Remark rem_1842 : forall X3:term, auto___def_10 X3 -> auto___def_10 X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1843 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_10 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_10 X3 -> auto___def_10 X3). tauto. exact (rem_1842 X3).
Qed.

Remark rem_1844 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X4. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X4 -> auto_knows_current X4). tauto. exact (rem_1796 X4).
Qed.

Remark rem_1845 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> (auto___type_1 X1 /\ auto_knows_current X1 /\ auto_agent X2 /\ auto_knows_current X2 /\ auto___def_10 X3 /\ auto_knows_current X4) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6 A7.
  cut (auto___type_1 X1). 2:apply (rem_1838 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X1). 2:apply (rem_1839 X1 X2 X3 X4);  assumption.
  cut (auto_agent X2). 2:apply (rem_1840 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_1841 X1 X2 X3 X4);  assumption.
  cut (auto___def_10 X3). 2:apply (rem_1843 X1 X2 X3 X4);  assumption.
  cut (auto_knows_current X4). 2:apply (rem_1844 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_1846 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6 A7.
  case (rem_1845 X1 X2 X3 X4 A1 A2 A3 A4 A5 A6 A7). clear  A1 A2 A3 A4 A5 A6 A7. intros. apply trans___def_67_1;  tauto.
 clear  A1 A2 A3 A4 A5 A6 A7. tauto.
Qed.

Remark rem_1847 : forall X1 X2 X3 X4:term, auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1396 X3 nil H);  intros.
  apply (rem_1846 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1848 : forall X1 X2 X3 X4:term, auto___def_14 (cons server nil) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1847 X1 X2 X3 X4).
Qed.

Remark rem_1849 : forall X1 X2 X3 X4:term, auto_agent X2 -> auto___def_14 (cons server nil) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_14 (cons server nil) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1848 X1 X2 X3 X4).
Qed.

Remark rem_1850 : forall X1 X2 X3 X4:term, auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_211 X2 (cons server nil) H);  intros.
  apply (rem_1849 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1851 : forall X1 X2 X3 X4:term, auto___def_12 sym -> auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1850 X1 X2 X3 X4).
Qed.

Remark rem_1852 : forall X1 X2 X3 X4:term, auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_234 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_1851 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1853 : forall X1 X2 X3 X4:term, auto___type_1 X1 -> auto___def_9 (cons X3 nil) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1852 X1 X2 X3 X4).
Qed.

Remark rem_1854 : forall X1 X2 X3 X4:term, auto___def_7 (cons X1 (cons X3 nil)) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1404 X1 (cons X3 nil) H);  intros.
  apply (rem_1853 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1855 : forall X1 X2 X3 X4:term, auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_1604 (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil))) H);  intros.
  apply (rem_1653 X1 X2 X3 X4);  tauto.
  apply (rem_1664 X1 X2 X3 X4);  tauto.
  apply (rem_1668 X1 X2 X3 X4);  tauto.
  apply (rem_1670 X1 X2 X3 X4);  tauto.
  apply (rem_1809 X1 X2 X3 X4);  tauto.
  apply (rem_1821 X1 X2 X3 X4);  tauto.
  apply (rem_1834 X1 X2 X3 X4);  tauto.
  apply (rem_1836 X1 X2 X3 X4);  tauto.
  apply (rem_1854 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1856 : forall X1 X2 X3 X4:term, auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto_knows_current nil -> auto___def_67 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto___def_67 X1 X2 X3 X4). tauto.
  exact (rem_1855 X1 X2 X3 X4).
Qed.

Remark rem_1857 : forall X1 X2 X3 X4:term, auto_knows_current (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto_knows_current nil -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto_knows_current nil -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1856 X1 X2 X3 X4).
Qed.

Remark rem_1858 : forall X1 X2 X3 X4:term, auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_1520 (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil H);  intros.
  apply (rem_1857 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1859 : forall X1 X2 X3 X4:term, auto_knows_current X4 -> auto_knows_current (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1858 X1 X2 X3 X4).
Qed.

Remark rem_1860 : forall X1 X2 X3 X4:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_1520 X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) H);  intros.
  apply (rem_1859 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1861 : forall X1 X2 X3 X4:term, auto_knows_current X2 -> auto_knows_current (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) -> auto_knows_current X1 -> auto___def_67 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) -> auto___def_67 X1 X2 X3 X4). tauto. exact (rem_1860 X1 X2 X3 X4).
Qed.

Remark rem_1862 : forall X1 X2 X3 X4:term, auto_knows_current X1 -> auto_knows_current (cons X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil))) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_1520 X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) H);  intros.
  apply (rem_1861 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1863 : forall X1 X2 X3 X4:term, auto_knows_current (cons X1 (cons X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)))) -> auto___def_67 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1520 X1 (cons X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil))) H);  intros.
  apply (rem_1862 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_1864 : forall X1:term, auto___def_27 X1 -> auto___type_8 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_27_p__type_8 1.
  intro X. case X.
   intro H. elim (rem_600  H).
   intro H. elim (rem_603  H).
  intros X1 X2. intro H. elim (rem_608 X1 X2 H).
  intros X1 X2. intro H. elim (rem_614 X1 X2 H).
   intro H. elim (rem_606  H).
  intros X1 X2;  exact (rem_631 epsilon_m__def_27_p__type_8 X1 X2).
   intro H. elim (rem_605  H).
  intros X1 X2. intro H. elim (rem_612 X1 X2 H).
  intros X1 X2. intro H. elim (rem_601 X1 X2 H).
  intros X1 X2. intro H. elim (rem_616 X1 X2 H).
  intros X1 X2. intro H. elim (rem_611 X1 X2 H).
   intro H. elim (rem_602  H).
   intro H. elim (rem_607  H).
  intros X1. intro H. elim (rem_604 X1 H).
   intro H. elim (rem_609  H).
  intros X1 X2 X3. intro H. elim (rem_613 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_615 X1 X2 X3 H).
   intro H. elim (rem_610  H).
Qed.

Remark rem_1865 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X3 -> auto___type_8 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X1 -> auto___type_8 X1). tauto. exact (rem_1864 X1).
Qed.

Remark rem_1866 : forall X1 X2 X3:term, auto_knows_old X2 -> auto___type_5 X3 -> auto_agent X3 -> auto___def_27 X1 -> auto___type_8 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X3 X2.
  cut (auto___def_27 X1 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X3 -> auto___type_8 X1). tauto. exact (rem_1865 X1 X2 X3).
Qed.

Remark rem_1867 : forall X1 X2 X3:term, auto___def_41 X1 X2 X3 -> or_1
    (auto_knows_old X1 /\ auto___type_5 X2 /\ auto_agent X2 /\ auto___def_27 X3)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1868 : forall X1 X2 X3:term, auto___def_41 X2 X3 X1 -> auto___type_8 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1867 X2 X3 X1 H);  intros.
  apply (rem_1866 X1 X2 X3);  tauto.
Qed.

Remark rem_1869 : (forall X:term, auto___def_50 X -> auto___def_56 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_50_p__def_56.  tauto.
Defined.

Remark rem_1870 : (forall X:term, auto___def_50 X -> auto___def_56 X)
    -> forall X1 X2 X3:term, auto___def_56 (session_old X1 X2 X3). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_50_p__def_56. intros X1 X2 X3.  case (rem_1869 epsilon_m__def_50_p__def_56). clear  epsilon_m__def_50_p__def_56. intros. apply trans___def_56_session_old_1;  tauto.
 clear  epsilon_m__def_50_p__def_56. tauto.
Defined.

Remark rem_1871 : (forall X:term, auto___def_50 X -> auto___def_56 X)
    -> forall X1 X2 X3:term, auto___def_50 (session_old X1 X2 X3) -> auto___def_56 (session_old X1 X2 X3). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_50_p__def_56. intros X1 X2 X3. intro H. intros.
  elim (rem_29 X1 X2 X3 H);  intros.
  apply (rem_1870 epsilon_m__def_50_p__def_56 X1 X2 X3);  tauto.
Defined.

Remark rem_1872 : forall X1:term, auto___def_50 X1 -> auto___def_56 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_50_p__def_56 1.
  intro X. case X.
   intro H. elim (rem_31  H).
   intro H. elim (rem_34  H).
  intros X1 X2. intro H. elim (rem_39 X1 X2 H).
  intros X1 X2. intro H. elim (rem_46 X1 X2 H).
   intro H. elim (rem_37  H).
  intros X1 X2. intro H. elim (rem_42 X1 X2 H).
   intro H. elim (rem_36  H).
  intros X1 X2. intro H. elim (rem_44 X1 X2 H).
  intros X1 X2. intro H. elim (rem_32 X1 X2 H).
  intros X1 X2. intro H. elim (rem_47 X1 X2 H).
  intros X1 X2. intro H. elim (rem_43 X1 X2 H).
   intro H. elim (rem_33  H).
   intro H. elim (rem_38  H).
  intros X1. intro H. elim (rem_35 X1 H).
   intro H. elim (rem_40  H).
  intros X1 X2 X3. intro H. elim (rem_45 X1 X2 X3 H).
  intros X1 X2 X3;  exact (rem_1871 epsilon_m__def_50_p__def_56 X1 X2 X3).
   intro H. elim (rem_41  H).
Qed.

Remark rem_1873 : forall X1:term, auto___def_49 sym -> auto___def_50 X1 -> auto___def_56 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1.
  cut (auto___def_50 X1 -> auto___def_56 X1). tauto. exact (rem_1872 X1).
Qed.

Remark rem_1874 : forall X1:term, auto___def_47 sym -> auto___def_48 X1 -> auto___def_56 X1. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_47 sym -> False). tauto.
  exact (rem_1155).
Qed.

Remark rem_1875 : forall X1:term, auto___def_46 sym -> auto___def_56 X1. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_1876 : forall X1:term, auto___def_46 sym -> auto___type_10 X1 -> auto___def_56 X1. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1. intros. apply (rem_1875 X1);  assumption.
Qed.

Remark rem_1877 : forall X1:term, auto_knows_current (key sym X1) -> auto___def_56 X1. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_99 sym X1 H);  intros.
  apply (rem_1873 X1);  tauto.
  apply (rem_1874 X1);  tauto.
  apply (rem_1876 X1);  tauto.
Qed.

Remark rem_1878 : forall X1:term, auto_knows_old (key pub X1) -> auto___def_4 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___def_4_1. Qed.

Remark rem_1879 : forall X1 X2:term, auto___def_23 X2 -> auto___def_29 prv -> auto___def_39 X1 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 prv -> False). tauto.
  exact (rem_333).
Qed.

Remark rem_1880 : forall X1 X2:term, auto___def_29 prv -> auto___def_39 X1 -> auto___def_23 X2 -> auto___def_53 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X2 -> auto___def_29 prv -> auto___def_39 X1 -> auto___def_53 X1 X2). tauto. exact (rem_1879 X1 X2).
Qed.

Remark rem_1881 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_204 prv X1 H);  intros.
  apply (rem_1880 X1 X2);  tauto.
Qed.

Remark rem_1882 : forall X1 X2:term, auto___def_29 prv -> auto___def_33 X2 -> auto___def_37 X1 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 prv -> False). tauto.
  exact (rem_333).
Qed.

Remark rem_1883 : forall X1 X2:term, auto___def_29 prv -> auto___def_37 X1 -> auto___def_33 X2 -> auto___def_53 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 prv -> auto___def_33 X2 -> auto___def_37 X1 -> auto___def_53 X1 X2). tauto. exact (rem_1882 X1 X2).
Qed.

Remark rem_1884 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_313 prv X1 H);  intros.
  apply (rem_1883 X1 X2);  tauto.
Qed.

Remark rem_1885 : auto___def_74 prv -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_51 H);  intros.
Qed.

Remark rem_1886 : forall X1 X2:term, auto___def_74 prv -> auto___def_78 X2 -> auto___def_82 X1 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 prv -> False). tauto.
  exact (rem_1885).
Qed.

Remark rem_1887 : forall X1 X2:term, auto___def_74 prv -> auto___def_82 X1 -> auto___def_78 X2 -> auto___def_53 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_74 prv -> auto___def_78 X2 -> auto___def_82 X1 -> auto___def_53 X1 X2). tauto. exact (rem_1886 X1 X2).
Qed.

Remark rem_1888 : forall X1 X2:term, auto___def_78 X2 -> auto___def_79 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_176 prv X1 H);  intros.
  apply (rem_1887 X1 X2);  tauto.
Qed.

Remark rem_1889 : forall X1 X2:term, auto___def_74 prv -> auto___def_75 X1 -> auto___def_89 X2 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 prv -> False). tauto.
  exact (rem_1885).
Qed.

Remark rem_1890 : forall X1 X2:term, auto___type_19 (key X1 X2) -> or_1
    (auto___def_74 X1 /\ auto___def_75 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1891 : forall X1 X2:term, auto___def_89 X2 -> auto___type_19 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_1890 prv X1 H);  intros.
  apply (rem_1889 X1 X2);  tauto.
Qed.

Remark rem_1892 : forall X1 X2:term, auto___def_12 prv -> auto___def_13 X1 -> auto___def_57 X2 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_12 prv -> False). tauto.
  exact (rem_347).
Qed.

Remark rem_1893 : forall X1 X2:term, auto___def_57 X2 -> auto___def_58 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_259 prv X1 H);  intros.
  apply (rem_1892 X1 X2);  tauto.
Qed.

Remark rem_1894 : forall X1 X2:term, auto___def_68 X2 -> auto___def_74 prv -> auto___def_84 X1 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 prv -> False). tauto.
  exact (rem_1885).
Qed.

Remark rem_1895 : forall X1 X2:term, auto___def_74 prv -> auto___def_84 X1 -> auto___def_68 X2 -> auto___def_53 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_68 X2 -> auto___def_74 prv -> auto___def_84 X1 -> auto___def_53 X1 X2). tauto. exact (rem_1894 X1 X2).
Qed.

Remark rem_1896 : forall X1 X2:term, auto___def_68 X2 -> auto___def_69 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_147 prv X1 H);  intros.
  apply (rem_1895 X1 X2);  tauto.
Qed.

Remark rem_1897 : forall X1 X2:term, auto___def_49 prv -> auto___def_50 X1 -> auto_knows_current X2 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_49 prv -> False). tauto.
  exact (rem_1204).
Qed.

Remark rem_1898 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_current X2 -> auto___def_48 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_48 X1 -> auto___def_48 X1). tauto. exact (rem_321 X1).
Qed.

Remark rem_1899 : forall X2:term, auto_knows_current X2 -> auto_knows_current X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1900 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_1899 X2).
Qed.

Remark rem_1901 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_current X2 -> (auto___def_48 X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_48 X1). 2:apply (rem_1898 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_1900 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1902 : forall X1 X2:term, auto___def_47 prv -> auto___def_48 X1 -> auto_knows_current X2 -> auto___def_53 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1901 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_53_1;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1903 : forall X1 X2:term, auto___def_46 prv -> auto_knows_current X2 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_46 prv -> False). tauto.
  exact (rem_327).
Qed.

Remark rem_1904 : forall X1 X2:term, auto___def_46 prv -> auto___type_10 X1 -> auto_knows_current X2 -> auto___def_53 X1 X2. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2. intros. apply (rem_1903 X1 X2);  assumption.
Qed.

Remark rem_1905 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_99 prv X1 H);  intros.
  apply (rem_1897 X1 X2);  tauto.
  apply (rem_1902 X1 X2);  tauto.
  apply (rem_1904 X1 X2);  tauto.
Qed.

Remark rem_1906 : forall X1 X2:term, auto___def_74 prv -> auto___def_75 X1 -> auto___def_87 X2 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 prv -> False). tauto.
  exact (rem_1885).
Qed.

Remark rem_1907 : forall X1 X2:term, auto___type_18 (key X1 X2) -> or_1
    (auto___def_74 X1 /\ auto___def_75 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_1908 : forall X1 X2:term, auto___def_87 X2 -> auto___type_18 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_1907 prv X1 H);  intros.
  apply (rem_1906 X1 X2);  tauto.
Qed.

Remark rem_1909 : forall X1 X2:term, auto___def_12 prv -> auto___def_13 X1 -> auto___def_7 X2 -> auto___def_53 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_12 prv -> False). tauto.
  exact (rem_347).
Qed.

Remark rem_1910 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 (key prv X1) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_234 prv X1 H);  intros.
  apply (rem_1909 X1 X2);  tauto.
Qed.

Remark rem_1911 : forall X1 X2:term, auto_knows_current (crypt X2 (key prv X1)) -> auto___def_53 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_1604 X2 (key prv X1) H);  intros.
  apply (rem_1881 X1 X2);  tauto.
  apply (rem_1884 X1 X2);  tauto.
  apply (rem_1888 X1 X2);  tauto.
  apply (rem_1891 X1 X2);  tauto.
  apply (rem_1893 X1 X2);  tauto.
  apply (rem_1896 X1 X2);  tauto.
  apply (rem_1905 X1 X2);  tauto.
  apply (rem_1908 X1 X2);  tauto.
  apply (rem_1910 X1 X2);  tauto.
Qed.

Remark rem_1912 : auto___def_77 nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_77_nil_1;  tauto.
 tauto.
Qed.

Remark rem_1913 : forall X1 X2:term, auto___def_23 X1 -> auto___def_29 sym -> auto___def_39 X2 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1164 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_8;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1914 : forall X1 X2:term, auto___def_29 sym -> auto___def_39 X2 -> auto___def_23 X1 -> auto___def_55 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_29 sym -> auto___def_39 X2 -> auto___def_55 X1 X2). tauto. exact (rem_1913 X1 X2).
Qed.

Remark rem_1915 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_204 sym X2 H);  intros.
  apply (rem_1914 X1 X2);  tauto.
Qed.

Remark rem_1916 : forall X1 X2:term, auto___def_29 sym -> auto___def_33 X1 -> auto___def_37 X2 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1171 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_1;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1917 : forall X1 X2:term, auto___def_29 sym -> auto___def_37 X2 -> auto___def_33 X1 -> auto___def_55 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 sym -> auto___def_33 X1 -> auto___def_37 X2 -> auto___def_55 X1 X2). tauto. exact (rem_1916 X1 X2).
Qed.

Remark rem_1918 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_313 sym X2 H);  intros.
  apply (rem_1917 X1 X2);  tauto.
Qed.

Remark rem_1919 : forall X1 X2:term, auto___def_74 sym -> auto___def_78 X1 -> auto___def_82 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_1413 X1).
Qed.

Remark rem_1920 : forall X1 X2:term, auto___def_74 sym -> auto___def_78 X1 -> auto___def_82 X2 -> auto___def_82 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_82 X2 -> auto___def_82 X2). tauto. exact (rem_1620 X2).
Qed.

Remark rem_1921 : forall X1 X2:term, auto___def_74 sym -> auto___def_78 X1 -> auto___def_82 X2 -> (auto___def_78 X1 /\ auto___def_82 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_78 X1). 2:apply (rem_1919 X1 X2);  assumption.
  cut (auto___def_82 X2). 2:apply (rem_1920 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1922 : forall X1 X2:term, auto___def_74 sym -> auto___def_78 X1 -> auto___def_82 X2 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1921 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_5;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1923 : forall X1 X2:term, auto___def_74 sym -> auto___def_82 X2 -> auto___def_78 X1 -> auto___def_55 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_74 sym -> auto___def_78 X1 -> auto___def_82 X2 -> auto___def_55 X1 X2). tauto. exact (rem_1922 X1 X2).
Qed.

Remark rem_1924 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_176 sym X2 H);  intros.
  apply (rem_1923 X1 X2);  tauto.
Qed.

Remark rem_1925 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_89 X1 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_280 X1).
Qed.

Remark rem_1926 : forall X2:term, auto___def_75 X2 -> auto___def_75 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1927 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_89 X1 -> auto___def_75 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_75 X2 -> auto___def_75 X2). tauto. exact (rem_1926 X2).
Qed.

Remark rem_1928 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_89 X1 -> (auto___def_89 X1 /\ auto___def_75 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_89 X1). 2:apply (rem_1925 X1 X2);  assumption.
  cut (auto___def_75 X2). 2:apply (rem_1927 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1929 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_89 X1 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1928 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_6;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1930 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_1890 sym X2 H);  intros.
  apply (rem_1929 X1 X2);  tauto.
Qed.

Remark rem_1931 : forall X1:term, auto___def_57 X1 -> auto___def_57 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1932 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_57 X1 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_1931 X1).
Qed.

Remark rem_1933 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_57 X1 -> auto___def_13 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_13 X2). tauto. exact (rem_22 X2).
Qed.

Remark rem_1934 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_57 X1 -> (auto___def_57 X1 /\ auto___def_13 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_57 X1). 2:apply (rem_1932 X1 X2);  assumption.
  cut (auto___def_13 X2). 2:apply (rem_1933 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1935 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_57 X1 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1934 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_3;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1936 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_259 sym X2 H);  intros.
  apply (rem_1935 X1 X2);  tauto.
Qed.

Remark rem_1937 : forall X1:term, auto___def_68 X1 -> auto___def_68 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1938 : forall X1 X2:term, auto___def_68 X1 -> auto___def_74 sym -> auto___def_84 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_1937 X1).
Qed.

Remark rem_1939 : forall X1 X2:term, auto___def_68 X1 -> auto___def_74 sym -> auto___def_84 X2 -> auto___def_84 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_84 X2 -> auto___def_84 X2). tauto. exact (rem_1632 X2).
Qed.

Remark rem_1940 : forall X1 X2:term, auto___def_68 X1 -> auto___def_74 sym -> auto___def_84 X2 -> (auto___def_68 X1 /\ auto___def_84 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_68 X1). 2:apply (rem_1938 X1 X2);  assumption.
  cut (auto___def_84 X2). 2:apply (rem_1939 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1941 : forall X1 X2:term, auto___def_68 X1 -> auto___def_74 sym -> auto___def_84 X2 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1940 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_9;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1942 : forall X1 X2:term, auto___def_74 sym -> auto___def_84 X2 -> auto___def_68 X1 -> auto___def_55 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_74 sym -> auto___def_84 X2 -> auto___def_55 X1 X2). tauto. exact (rem_1941 X1 X2).
Qed.

Remark rem_1943 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_147 sym X2 H);  intros.
  apply (rem_1942 X1 X2);  tauto.
Qed.

Remark rem_1944 : forall X1 X2:term, auto___def_49 sym -> auto___def_50 X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_1945 : forall X2:term, auto___def_50 X2 -> auto___def_50 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1946 : forall X1 X2:term, auto___def_49 sym -> auto___def_50 X2 -> auto_knows_current X1 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_50 X2). tauto. exact (rem_1945 X2).
Qed.

Remark rem_1947 : forall X1 X2:term, auto___def_49 sym -> auto___def_50 X2 -> auto_knows_current X1 -> (auto_knows_current X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto_knows_current X1). 2:apply (rem_1944 X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_1946 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1948 : forall X1 X2:term, auto___def_49 sym -> auto___def_50 X2 -> auto_knows_current X1 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1947 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_7;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1949 : forall X1 X2:term, auto___def_47 sym -> auto___def_48 X2 -> auto_knows_current X1 -> auto___def_55 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_47 sym -> False). tauto.
  exact (rem_1155).
Qed.

Remark rem_1950 : forall X1 X2:term, auto___def_46 sym -> auto_knows_current X1 -> auto___def_55 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_1951 : forall X1 X2:term, auto___def_46 sym -> auto___type_10 X2 -> auto_knows_current X1 -> auto___def_55 X1 X2. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2. intros. apply (rem_1950 X1 X2);  assumption.
Qed.

Remark rem_1952 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_99 sym X2 H);  intros.
  apply (rem_1948 X1 X2);  tauto.
  apply (rem_1949 X1 X2);  tauto.
  apply (rem_1951 X1 X2);  tauto.
Qed.

Remark rem_1953 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_87 X1 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_285 X1).
Qed.

Remark rem_1954 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_87 X1 -> auto___def_75 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_75 X2 -> auto___def_75 X2). tauto. exact (rem_1926 X2).
Qed.

Remark rem_1955 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_87 X1 -> (auto___def_87 X1 /\ auto___def_75 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_87 X1). 2:apply (rem_1953 X1 X2);  assumption.
  cut (auto___def_75 X2). 2:apply (rem_1954 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1956 : forall X1 X2:term, auto___def_74 sym -> auto___def_75 X2 -> auto___def_87 X1 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1955 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_4;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1957 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_1907 sym X2 H);  intros.
  apply (rem_1956 X1 X2);  tauto.
Qed.

Remark rem_1958 : forall X1 X2:term, auto___def_12 sym -> auto___def_13 X2 -> auto___def_7 X1 -> auto___def_55 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_1187 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_55_2;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_1959 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 (key sym X2) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_234 sym X2 H);  intros.
  apply (rem_1958 X1 X2);  tauto.
Qed.

Remark rem_1960 : forall X1 X2:term, auto_knows_current (crypt X1 (key sym X2)) -> auto___def_55 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_1604 X1 (key sym X2) H);  intros.
  apply (rem_1915 X1 X2);  tauto.
  apply (rem_1918 X1 X2);  tauto.
  apply (rem_1924 X1 X2);  tauto.
  apply (rem_1930 X1 X2);  tauto.
  apply (rem_1936 X1 X2);  tauto.
  apply (rem_1943 X1 X2);  tauto.
  apply (rem_1952 X1 X2);  tauto.
  apply (rem_1957 X1 X2);  tauto.
  apply (rem_1959 X1 X2);  tauto.
Qed.

Remark rem_1961 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_p__type_3.  tauto.
Defined.

Remark rem_1962 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto___type_3 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_3.  case (rem_1961 epsilon_magent_p__type_3). clear  epsilon_magent_p__type_3. intros. apply trans___type_3_alice_1;  tauto.
 clear  epsilon_magent_p__type_3. tauto.
Defined.

Remark rem_1963 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto_agent alice -> auto___type_3 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_3. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_1962 epsilon_magent_p__type_3);  tauto.
Defined.

Remark rem_1964 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto___type_3 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_3.  case (rem_1961 epsilon_magent_p__type_3). clear  epsilon_magent_p__type_3. intros. apply trans___type_3_bob_1;  tauto.
 clear  epsilon_magent_p__type_3. tauto.
Defined.

Remark rem_1965 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto_agent bob -> auto___type_3 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_3. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_1964 epsilon_magent_p__type_3);  tauto.
Defined.

Remark rem_1966 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto___type_3 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_3.  case (rem_1961 epsilon_magent_p__type_3). clear  epsilon_magent_p__type_3. intros. apply trans___type_3_i_1;  tauto.
 clear  epsilon_magent_p__type_3. tauto.
Defined.

Remark rem_1967 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto_agent i -> auto___type_3 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_3. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_1966 epsilon_magent_p__type_3);  tauto.
Defined.

Remark rem_1968 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto___type_3 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_3.  case (rem_1961 epsilon_magent_p__type_3). clear  epsilon_magent_p__type_3. intros. apply trans___type_3_server_1;  tauto.
 clear  epsilon_magent_p__type_3. tauto.
Defined.

Remark rem_1969 : (forall X:term, auto_agent X -> auto___type_3 X)
    -> auto_agent server -> auto___type_3 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_3. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_1968 epsilon_magent_p__type_3);  tauto.
Defined.

Remark rem_1970 : forall X1:term, auto_agent X1 -> auto___type_3 X1. (* Induct. *)
Proof.
  fix epsilon_magent_p__type_3 1.
  intro X. case X.
  exact (rem_1963 epsilon_magent_p__type_3 ).
  exact (rem_1965 epsilon_magent_p__type_3 ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_1967 epsilon_magent_p__type_3 ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_1969 epsilon_magent_p__type_3 ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_1971 : auto___def_32 nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_32_nil_1;  tauto.
 tauto.
Qed.

Remark rem_1972 : forall X1:term, auto___def_76 X1 -> auto___def_76 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1973 : forall X1 X2:term, auto___def_76 X1 -> auto___def_77 X2 -> auto___def_76 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_76 X1 -> auto___def_76 X1). tauto. exact (rem_1972 X1).
Qed.

Remark rem_1974 : forall X2:term, auto___def_77 X2 -> auto___def_77 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1975 : forall X1 X2:term, auto___def_76 X1 -> auto___def_77 X2 -> auto___def_77 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_77 X2 -> auto___def_77 X2). tauto. exact (rem_1974 X2).
Qed.

Remark rem_1976 : forall X1 X2:term, auto___def_76 X1 -> auto___def_77 X2 -> (auto___def_76 X1 /\ auto___def_77 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_76 X1). 2:apply (rem_1973 X1 X2);  assumption.
  cut (auto___def_77 X2). 2:apply (rem_1975 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1977 : forall X1 X2:term, auto___def_76 X1 -> auto___def_77 X2 -> auto___def_73 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1976 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_73_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1978 : forall X1 X2:term, auto___def_77 X2 -> auto___def_76 X1 -> auto___def_73 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_76 X1 -> auto___def_77 X2 -> auto___def_73 (cons X1 X2)). tauto. exact (rem_1977 X1 X2).
Qed.

Remark rem_1979 : auto___def_48 i. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_48_i_1;  tauto.
 tauto.
Qed.

Remark rem_1980 : forall X1 X2:term, auto___def_72 X1 -> auto___def_73 X2 -> auto___def_72 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X1 -> auto___def_72 X1). tauto. exact (rem_560 X1).
Qed.

Remark rem_1981 : forall X2:term, auto___def_73 X2 -> auto___def_73 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_1982 : forall X1 X2:term, auto___def_72 X1 -> auto___def_73 X2 -> auto___def_73 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_73 X2 -> auto___def_73 X2). tauto. exact (rem_1981 X2).
Qed.

Remark rem_1983 : forall X1 X2:term, auto___def_72 X1 -> auto___def_73 X2 -> (auto___def_72 X1 /\ auto___def_73 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_72 X1). 2:apply (rem_1980 X1 X2);  assumption.
  cut (auto___def_73 X2). 2:apply (rem_1982 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1984 : forall X1 X2:term, auto___def_72 X1 -> auto___def_73 X2 -> auto___def_71 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1983 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_71_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1985 : forall X1 X2:term, auto___def_73 X2 -> auto___def_72 X1 -> auto___def_71 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X1 -> auto___def_73 X2 -> auto___def_71 (cons X1 X2)). tauto. exact (rem_1984 X1 X2).
Qed.

Remark rem_1986 : forall X1 X2:term, auto___def_38 X2 -> auto___type_5 X1 -> auto___type_5 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_5 X1 -> auto___type_5 X1). tauto. exact (rem_652 X1).
Qed.

Remark rem_1987 : forall X1 X2:term, auto___def_38 X2 -> auto___type_5 X1 -> auto___def_38 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_38 X2 -> auto___def_38 X2). tauto. exact (rem_10 X2).
Qed.

Remark rem_1988 : forall X1 X2:term, auto___def_38 X2 -> auto___type_5 X1 -> (auto___type_5 X1 /\ auto___def_38 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_5 X1). 2:apply (rem_1986 X1 X2);  assumption.
  cut (auto___def_38 X2). 2:apply (rem_1987 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1989 : forall X1 X2:term, auto___def_38 X2 -> auto___type_5 X1 -> auto___def_37 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1988 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_37_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1990 : forall X1 X2:term, auto___def_29 X1 -> auto___def_37 X2 -> auto___def_29 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_29 X1). tauto. exact (rem_664 X1).
Qed.

Remark rem_1991 : forall X1 X2:term, auto___def_29 X1 -> auto___def_37 X2 -> auto___def_37 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_37 X2 -> auto___def_37 X2). tauto. exact (rem_1169 X2).
Qed.

Remark rem_1992 : forall X1 X2:term, auto___def_29 X1 -> auto___def_37 X2 -> (auto___def_29 X1 /\ auto___def_37 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_29 X1). 2:apply (rem_1990 X1 X2);  assumption.
  cut (auto___def_37 X2). 2:apply (rem_1991 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_1993 : forall X1 X2:term, auto___def_29 X1 -> auto___def_37 X2 -> auto___def_34 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1992 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_34_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_1994 : forall X1 X2:term, auto___def_37 X2 -> auto___def_29 X1 -> auto___def_34 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_37 X2 -> auto___def_34 (key X1 X2)). tauto. exact (rem_1993 X1 X2).
Qed.

Remark rem_1995 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_p__type_15.  tauto.
Defined.

Remark rem_1996 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto___type_15 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_15.  case (rem_1995 epsilon_magent_p__type_15). clear  epsilon_magent_p__type_15. intros. apply trans___type_15_alice_1;  tauto.
 clear  epsilon_magent_p__type_15. tauto.
Defined.

Remark rem_1997 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto_agent alice -> auto___type_15 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_15. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_1996 epsilon_magent_p__type_15);  tauto.
Defined.

Remark rem_1998 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto___type_15 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_15.  case (rem_1995 epsilon_magent_p__type_15). clear  epsilon_magent_p__type_15. intros. apply trans___type_15_bob_1;  tauto.
 clear  epsilon_magent_p__type_15. tauto.
Defined.

Remark rem_1999 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto_agent bob -> auto___type_15 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_15. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_1998 epsilon_magent_p__type_15);  tauto.
Defined.

Remark rem_2000 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto___type_15 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_15.  case (rem_1995 epsilon_magent_p__type_15). clear  epsilon_magent_p__type_15. intros. apply trans___type_15_i_1;  tauto.
 clear  epsilon_magent_p__type_15. tauto.
Defined.

Remark rem_2001 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto_agent i -> auto___type_15 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_15. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_2000 epsilon_magent_p__type_15);  tauto.
Defined.

Remark rem_2002 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto___type_15 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_15.  case (rem_1995 epsilon_magent_p__type_15). clear  epsilon_magent_p__type_15. intros. apply trans___type_15_server_1;  tauto.
 clear  epsilon_magent_p__type_15. tauto.
Defined.

Remark rem_2003 : (forall X:term, auto_agent X -> auto___type_15 X)
    -> auto_agent server -> auto___type_15 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_15. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_2002 epsilon_magent_p__type_15);  tauto.
Defined.

Remark rem_2004 : forall X1:term, auto_agent X1 -> auto___type_15 X1. (* Induct. *)
Proof.
  fix epsilon_magent_p__type_15 1.
  intro X. case X.
  exact (rem_1997 epsilon_magent_p__type_15 ).
  exact (rem_1999 epsilon_magent_p__type_15 ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_2001 epsilon_magent_p__type_15 ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_2003 epsilon_magent_p__type_15 ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_2005 : forall X1 X2 X3 X4:term, auto___def_10 X2 -> auto___type_1 X3 -> auto_agent X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_15 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X1 -> auto___type_15 X1). tauto. exact (rem_2004 X1).
Qed.

Remark rem_2006 : forall X1 X2 X3 X4:term, auto___type_1 X2 -> auto_knows_current X2 -> auto_agent X1 -> auto_knows_current X1 -> auto___def_10 X3 -> auto_knows_current X4 -> auto___type_15 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X3 X2 X4.
  cut (auto___def_10 X2 -> auto___type_1 X3 -> auto_agent X1 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_15 X1). tauto. exact (rem_2005 X1 X2 X3 X4).
Qed.

Remark rem_2007 : forall X1 X2 X3 X4:term, auto___def_60 X2 -> auto_agent X1 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X4 -> auto___type_15 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X1 -> auto___type_15 X1). tauto. exact (rem_2004 X1).
Qed.

Remark rem_2008 : forall X1 X2 X3 X4:term, auto_knows_current X2 -> auto_agent X1 -> auto_knows_current X1 -> auto___def_60 X3 -> auto_knows_current X4 -> auto___type_15 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X2 X3.
  cut (auto___def_60 X2 -> auto_agent X1 -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current X4 -> auto___type_15 X1). tauto. exact (rem_2007 X1 X2 X3 X4).
Qed.

Remark rem_2009 : forall X1 X2 X3 X4:term, auto___def_67 X2 X1 X3 X4 -> auto___type_15 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1030 X2 X1 X3 X4 H);  intros.
  apply (rem_2006 X1 X2 X3 X4);  tauto.
  apply (rem_2008 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2010 : forall X1:term, auto___def_47 sym -> auto___def_48 X1 -> auto___def_6 X1. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_47 sym -> False). tauto.
  exact (rem_1155).
Qed.

Remark rem_2011 : forall X1:term, auto___def_46 sym -> auto___def_6 X1. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_2012 : forall X1:term, auto___def_46 sym -> auto___type_10 X1 -> auto___def_6 X1. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1. intros. apply (rem_2011 X1);  assumption.
Qed.

Remark rem_2013 : forall X1:term, auto_knows_old (key sym X1) -> auto___def_6 X1. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_330 sym X1 H);  intros.
  apply (rem_2010 X1);  tauto.
  apply (rem_2012 X1);  tauto.
Qed.

Remark rem_2014 : forall X1 X2 X3:term, auto___def_50 (session_old X1 X2 X3). (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3.  case (rem_524). intros. apply trans___def_50_session_old_1;  tauto.
 tauto.
Qed.

Remark rem_2015 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X1 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_2016 : forall X2:term, auto___type_5 X2 -> auto___type_5 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2017 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X1 -> auto___type_5 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_5 X2 -> auto___type_5 X2). tauto. exact (rem_2016 X2).
Qed.

Remark rem_2018 : forall X2:term, auto___type_5 X2 -> auto_agent X2. (* Induct. *)
Proof.
  fix epsilon_m__type_5_pagent 1.
  intro X. case X.
  exact (rem_1336 epsilon_m__type_5_pagent ).
  exact (rem_1339 epsilon_m__type_5_pagent ).
  intros X1 X2. intro H. elim (rem_1351 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1357 X1 X2 H).
  exact (rem_1342 epsilon_m__type_5_pagent ).
  intros X1 X2. intro H. elim (rem_1353 X1 X2 H).
   intro H. elim (rem_1349  H).
  intros X1 X2. intro H. elim (rem_1355 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1346 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1359 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1354 X1 X2 H).
   intro H. elim (rem_1347  H).
   intro H. elim (rem_1350  H).
  intros X1. intro H. elim (rem_1348 X1 H).
  exact (rem_1345 epsilon_m__type_5_pagent ).
  intros X1 X2 X3. intro H. elim (rem_1356 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1358 X1 X2 X3 H).
   intro H. elim (rem_1352  H).
Qed.

Remark rem_2019 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X1 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_5 X2 -> auto_agent X2). tauto. exact (rem_2018 X2).
Qed.

Remark rem_2020 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X1 -> (auto_knows_old X1 /\ auto___type_5 X2 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4.
  cut (auto_knows_old X1). 2:apply (rem_2015 X1 X2 X3);  assumption.
  cut (auto___type_5 X2). 2:apply (rem_2017 X1 X2 X3);  assumption.
  cut (auto_agent X2). 2:apply (rem_2019 X1 X2 X3);  assumption.
  tauto.
Qed.

Remark rem_2021 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X1 -> auto___def_42 (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4.
  case (rem_2020 X1 X2 X3 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_42_nonceb_old_1;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_2022 : forall X1 X2 X3:term, auto_knows_old X1 -> auto___type_5 X2 -> auto_agent X2 -> auto___def_27 X3 -> auto___def_42 (nonceb_old X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___type_5 X2 -> auto_agent X2 -> auto_knows_old X1 -> auto___def_42 (nonceb_old X1 X2)). tauto. exact (rem_2021 X1 X2 X3).
Qed.

Remark rem_2023 : forall X1 X2 X3:term, auto___def_41 X1 X2 X3 -> auto___def_42 (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1867 X1 X2 X3 H);  intros.
  apply (rem_2022 X1 X2 X3);  tauto.
Qed.

Remark rem_2024 : auto___def_46 pub. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_46_pub_1;  tauto.
 tauto.
Qed.

Remark rem_2025 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_p__type_12.  tauto.
Defined.

Remark rem_2026 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto___type_12 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_12.  case (rem_2025 epsilon_magent_p__type_12). clear  epsilon_magent_p__type_12. intros. apply trans___type_12_alice_1;  tauto.
 clear  epsilon_magent_p__type_12. tauto.
Defined.

Remark rem_2027 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto_agent alice -> auto___type_12 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_12. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_2026 epsilon_magent_p__type_12);  tauto.
Defined.

Remark rem_2028 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto___type_12 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_12.  case (rem_2025 epsilon_magent_p__type_12). clear  epsilon_magent_p__type_12. intros. apply trans___type_12_bob_1;  tauto.
 clear  epsilon_magent_p__type_12. tauto.
Defined.

Remark rem_2029 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto_agent bob -> auto___type_12 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_12. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_2028 epsilon_magent_p__type_12);  tauto.
Defined.

Remark rem_2030 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto___type_12 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_12.  case (rem_2025 epsilon_magent_p__type_12). clear  epsilon_magent_p__type_12. intros. apply trans___type_12_i_1;  tauto.
 clear  epsilon_magent_p__type_12. tauto.
Defined.

Remark rem_2031 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto_agent i -> auto___type_12 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_12. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_2030 epsilon_magent_p__type_12);  tauto.
Defined.

Remark rem_2032 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto___type_12 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_12.  case (rem_2025 epsilon_magent_p__type_12). clear  epsilon_magent_p__type_12. intros. apply trans___type_12_server_1;  tauto.
 clear  epsilon_magent_p__type_12. tauto.
Defined.

Remark rem_2033 : (forall X:term, auto_agent X -> auto___type_12 X)
    -> auto_agent server -> auto___type_12 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_12. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_2032 epsilon_magent_p__type_12);  tauto.
Defined.

Remark rem_2034 : forall X1:term, auto_agent X1 -> auto___type_12 X1. (* Induct. *)
Proof.
  fix epsilon_magent_p__type_12 1.
  intro X. case X.
  exact (rem_2027 epsilon_magent_p__type_12 ).
  exact (rem_2029 epsilon_magent_p__type_12 ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_2031 epsilon_magent_p__type_12 ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_2033 epsilon_magent_p__type_12 ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_2035 : forall X1 X2:term, auto___def_32 X2 -> auto___type_7 X1 -> auto___type_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_7 X1 -> auto___type_7 X1). tauto. exact (rem_8 X1).
Qed.

Remark rem_2036 : forall X1 X2:term, auto___def_32 X2 -> auto___type_7 X1 -> auto___def_32 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_32 X2 -> auto___def_32 X2). tauto. exact (rem_554 X2).
Qed.

Remark rem_2037 : forall X1 X2:term, auto___def_32 X2 -> auto___type_7 X1 -> (auto___type_7 X1 /\ auto___def_32 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_7 X1). 2:apply (rem_2035 X1 X2);  assumption.
  cut (auto___def_32 X2). 2:apply (rem_2036 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2038 : forall X1 X2:term, auto___def_32 X2 -> auto___type_7 X1 -> auto___def_36 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2037 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_36_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2039 : forall X1:term, auto___type_15 X1 -> auto___type_15 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2040 : forall X1 X2:term, auto___def_71 X2 -> auto___type_15 X1 -> auto___type_15 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_15 X1 -> auto___type_15 X1). tauto. exact (rem_2039 X1).
Qed.

Remark rem_2041 : forall X2:term, auto___def_71 X2 -> auto___def_71 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2042 : forall X1 X2:term, auto___def_71 X2 -> auto___type_15 X1 -> auto___def_71 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_71 X2 -> auto___def_71 X2). tauto. exact (rem_2041 X2).
Qed.

Remark rem_2043 : forall X1 X2:term, auto___def_71 X2 -> auto___type_15 X1 -> (auto___type_15 X1 /\ auto___def_71 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_15 X1). 2:apply (rem_2040 X1 X2);  assumption.
  cut (auto___def_71 X2). 2:apply (rem_2042 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2044 : forall X1 X2:term, auto___def_71 X2 -> auto___type_15 X1 -> auto___def_70 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2043 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_70_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2045 : forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___def_64 (noncea_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_1200 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_64_noncea_current_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2046 : forall X1 X2:term, auto_agent X2 -> auto_agent X1 -> auto___def_64 (noncea_current X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_agent X1 -> auto_agent X2 -> auto___def_64 (noncea_current X1 X2)). tauto. exact (rem_2045 X1 X2).
Qed.

Remark rem_2047 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 (key pub X1) -> auto___type_10 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___type_10_1. Qed.

Remark rem_2048 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current.  tauto.
Defined.

Remark rem_2049 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current.  case (rem_2048 epsilon_m__type_4_pknows_current). clear  epsilon_m__type_4_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_4_pknows_current. tauto.
Defined.

Remark rem_2050 : auto___type_4 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2051 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto___type_4 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intro H. intros.
  elim (rem_2050 H);  intros.
  apply (rem_2049 epsilon_m__type_4_pknows_current);  tauto.
Defined.

Remark rem_2052 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  tauto.
Defined.

Remark rem_2053 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2052 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_noncea_old_1;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2054 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 (noncea_old X1 X2) -> auto_knows_current (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1367 X1 X2 H);  intros.
  apply (rem_2053 epsilon_m__type_4_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2055 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current.  case (rem_2048 epsilon_m__type_4_pknows_current). clear  epsilon_m__type_4_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_4_pknows_current. tauto.
Defined.

Remark rem_2056 : auto___type_4 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2057 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto___type_4 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intro H. intros.
  elim (rem_2056 H);  intros.
  apply (rem_2055 epsilon_m__type_4_pknows_current);  tauto.
Defined.

Remark rem_2058 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_4_pknows_current. exact (rem_926).
Defined.

Remark rem_2059 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_2058 epsilon_m__type_4_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_2060 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1. intros A1.
  case (rem_2059 epsilon_m__type_4_pknows_current X1 A1). clear  epsilon_m__type_4_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_m__type_4_pknows_current A1. tauto.
Defined.

Remark rem_2061 : forall X1:term, auto___type_4 (s X1) -> or_1
    (auto_knows_old X1).
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2062 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___type_4 (s X1) -> auto_knows_current (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1. intro H. intros.
  elim (rem_2061 X1 H);  intros.
  apply (rem_2060 epsilon_m__type_4_pknows_current X1);  tauto.
Defined.

Remark rem_2063 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current.  case (rem_2048 epsilon_m__type_4_pknows_current). clear  epsilon_m__type_4_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__type_4_pknows_current. tauto.
Defined.

Remark rem_2064 : auto___type_4 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2065 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto___type_4 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intro H. intros.
  elim (rem_2064 H);  intros.
  apply (rem_2063 epsilon_m__type_4_pknows_current);  tauto.
Defined.

Remark rem_2066 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current.  case (rem_2048 epsilon_m__type_4_pknows_current). clear  epsilon_m__type_4_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_4_pknows_current. tauto.
Defined.

Remark rem_2067 : auto___type_4 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2068 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto___type_4 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intro H. intros.
  elim (rem_2067 H);  intros.
  apply (rem_2066 epsilon_m__type_4_pknows_current);  tauto.
Defined.

Remark rem_2069 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_current X1). tauto. exact (rem_2058 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2070 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_4_pknows_current. exact (rem_939).
Defined.

Remark rem_2071 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_current X2). tauto. exact (rem_2070 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2072 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2069 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2071 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2073 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2072 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2074 : forall X1 X2:term, auto___type_4 (cons X1 X2) -> or_1
    (auto_knows_old X1 /\ auto_knows_old X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2075 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2074 X1 X2 H);  intros.
  apply (rem_2073 epsilon_m__type_4_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2076 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current.  case (rem_2048 epsilon_m__type_4_pknows_current). clear  epsilon_m__type_4_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_4_pknows_current. tauto.
Defined.

Remark rem_2077 : auto___type_4 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2078 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> auto___type_4 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intro H. intros.
  elim (rem_2077 H);  intros.
  apply (rem_2076 epsilon_m__type_4_pknows_current);  tauto.
Defined.

Remark rem_2079 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2080 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_2079 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2081 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2082 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_2081 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2083 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_2080 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_2082 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2084 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2083 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_key_2;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2085 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2086 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_2085 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2087 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2088 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_2087 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2089 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_2086 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_2088 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2090 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2089 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_key_3;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2091 : forall X1 X2:term, auto___type_4 (key X1 X2) -> or_2
    (auto___def_47 X1 /\ auto___def_48 X2)
    (auto___def_46 X1 /\ auto___type_10 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_2_intro_1; tauto.
  intros. apply or_2_intro_2; tauto.
Qed.

Remark rem_2092 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2091 X1 X2 H);  intros.
  apply (rem_2084 epsilon_m__type_4_pknows_current X1 X2);  tauto.
  apply (rem_2090 epsilon_m__type_4_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2093 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2072 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2094 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2095 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_2094 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2096 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2097 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_2096 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2098 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_2095 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_2097 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2099 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2098 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_crypt_1;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2100 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2101 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_2100 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2102 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2103 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_2102 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2104 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_2101 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_2103 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2105 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2104 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_crypt_2;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2106 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_4_pknows_current. exact (rem_813).
Defined.

Remark rem_2107 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_44 X1 -> auto_knows_current X1). tauto. exact (rem_2106 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2108 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto___type_9 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_4_pknows_current. exact (rem_883).
Defined.

Remark rem_2109 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___type_9 X2 -> auto_knows_current X2). tauto. exact (rem_2108 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2110 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2107 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2109 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2111 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2110 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2112 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_4_pknows_current. exact (rem_787).
Defined.

Remark rem_2113 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_42 X1 -> auto_knows_current X1). tauto. exact (rem_2112 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2114 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto___type_8 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_4_pknows_current. exact (rem_914).
Defined.

Remark rem_2115 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___type_8 X2 -> auto_knows_current X2). tauto. exact (rem_2114 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2116 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2113 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2115 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2117 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2116 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2118 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2119 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_2118 epsilon_m__type_4_pknows_current X1).
Defined.

Remark rem_2120 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2121 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_2120 epsilon_m__type_4_pknows_current X2).
Defined.

Remark rem_2122 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_2119 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_2121 epsilon_m__type_4_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2123 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2122 epsilon_m__type_4_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_4_pknows_current A1 A2. intros. apply trans_knows_current_crypt_9;  tauto.
 clear  epsilon_m__type_4_pknows_current A1 A2. tauto.
Defined.

Remark rem_2124 : forall X1 X2:term, auto___type_4 (crypt X1 X2) -> or_6
    (auto_knows_old X1 /\ auto_knows_old X2)
    (auto___def_23 X1 /\ auto___def_24 X2)
    (auto___def_33 X1 /\ auto___def_34 X2)
    (auto___def_44 X1 /\ auto___type_9 X2)
    (auto___def_42 X1 /\ auto___type_8 X2)
    (auto___def_7 X1 /\ auto___def_8 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_6_intro_1; tauto.
  intros. apply or_6_intro_2; tauto.
  intros. apply or_6_intro_3; tauto.
  intros. apply or_6_intro_4; tauto.
  intros. apply or_6_intro_5; tauto.
  intros. apply or_6_intro_6; tauto.
Qed.

Remark rem_2125 : (forall X:term, auto___type_4 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_4_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2124 X1 X2 H);  intros.
  apply (rem_2093 epsilon_m__type_4_pknows_current X1 X2);  tauto.
  apply (rem_2099 epsilon_m__type_4_pknows_current X1 X2);  tauto.
  apply (rem_2105 epsilon_m__type_4_pknows_current X1 X2);  tauto.
  apply (rem_2111 epsilon_m__type_4_pknows_current X1 X2);  tauto.
  apply (rem_2117 epsilon_m__type_4_pknows_current X1 X2);  tauto.
  apply (rem_2123 epsilon_m__type_4_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2126 : auto___type_4 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2127 : auto___type_4 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2128 : auto___type_4 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2129 : forall X1 X2:term, auto___type_4 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2130 : forall X1 X2:term, auto___type_4 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2131 : forall X1 X2 X3:term, auto___type_4 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2132 : forall X1 X2 X3:term, auto___type_4 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2133 : forall X1 X2:term, auto___type_4 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2134 : forall X1:term, auto___type_4 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_4_pknows_current 1.
  intro X. case X.
  exact (rem_2051 epsilon_m__type_4_pknows_current ).
  exact (rem_2057 epsilon_m__type_4_pknows_current ).
  intros X1 X2;  exact (rem_2075 epsilon_m__type_4_pknows_current X1 X2).
  intros X1 X2;  exact (rem_2125 epsilon_m__type_4_pknows_current X1 X2).
  exact (rem_2068 epsilon_m__type_4_pknows_current ).
  intros X1 X2;  exact (rem_2092 epsilon_m__type_4_pknows_current X1 X2).
  exact (rem_2065 epsilon_m__type_4_pknows_current ).
  intros X1 X2. intro H. elim (rem_2130 X1 X2 H).
  intros X1 X2;  exact (rem_2054 epsilon_m__type_4_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2133 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2129 X1 X2 H).
   intro H. elim (rem_2126  H).
   intro H. elim (rem_2127  H).
  intros X1;  exact (rem_2062 epsilon_m__type_4_pknows_current X1).
  exact (rem_2078 epsilon_m__type_4_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_2131 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2132 X1 X2 X3 H).
   intro H. elim (rem_2128  H).
Qed.

Remark rem_2135 : (forall X:term, auto___def_23 X -> auto_knows_current X)
    -> forall X1:term, auto___type_4 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_23_pknows_current. exact (rem_2134).
Defined.

Remark rem_2136 : (forall X:term, auto___def_23 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 X1 -> auto___def_25 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_23_pknows_current. intros X1 X2.
  cut (auto___type_4 X1 -> auto_knows_current X1). tauto. exact (rem_2135 epsilon_m__def_23_pknows_current X1).
Defined.

Remark rem_2137 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_5_pknows_current.  tauto.
Defined.

Remark rem_2138 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current.  case (rem_2137 epsilon_m__type_5_pknows_current). clear  epsilon_m__type_5_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_5_pknows_current. tauto.
Defined.

Remark rem_2139 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto___type_5 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current. intro H. intros.
  elim (rem_1335 H);  intros.
  apply (rem_2138 epsilon_m__type_5_pknows_current);  tauto.
Defined.

Remark rem_2140 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current.  case (rem_2137 epsilon_m__type_5_pknows_current). clear  epsilon_m__type_5_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_5_pknows_current. tauto.
Defined.

Remark rem_2141 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto___type_5 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current. intro H. intros.
  elim (rem_1338 H);  intros.
  apply (rem_2140 epsilon_m__type_5_pknows_current);  tauto.
Defined.

Remark rem_2142 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current.  case (rem_2137 epsilon_m__type_5_pknows_current). clear  epsilon_m__type_5_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_5_pknows_current. tauto.
Defined.

Remark rem_2143 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto___type_5 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current. intro H. intros.
  elim (rem_1341 H);  intros.
  apply (rem_2142 epsilon_m__type_5_pknows_current);  tauto.
Defined.

Remark rem_2144 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current.  case (rem_2137 epsilon_m__type_5_pknows_current). clear  epsilon_m__type_5_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_5_pknows_current. tauto.
Defined.

Remark rem_2145 : (forall X:term, auto___type_5 X -> auto_knows_current X)
    -> auto___type_5 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_5_pknows_current. intro H. intros.
  elim (rem_1344 H);  intros.
  apply (rem_2144 epsilon_m__type_5_pknows_current);  tauto.
Defined.

Remark rem_2146 : forall X1:term, auto___type_5 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_5_pknows_current 1.
  intro X. case X.
  exact (rem_2139 epsilon_m__type_5_pknows_current ).
  exact (rem_2141 epsilon_m__type_5_pknows_current ).
  intros X1 X2. intro H. elim (rem_1351 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1357 X1 X2 H).
  exact (rem_2143 epsilon_m__type_5_pknows_current ).
  intros X1 X2. intro H. elim (rem_1353 X1 X2 H).
   intro H. elim (rem_1349  H).
  intros X1 X2. intro H. elim (rem_1355 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1346 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1359 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1354 X1 X2 H).
   intro H. elim (rem_1347  H).
   intro H. elim (rem_1350  H).
  intros X1. intro H. elim (rem_1348 X1 H).
  exact (rem_2145 epsilon_m__type_5_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_1356 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1358 X1 X2 X3 H).
   intro H. elim (rem_1352  H).
Qed.

Remark rem_2147 : (forall X:term, auto___def_25 X -> auto_knows_current X)
    -> forall X1:term, auto___type_5 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_25_pknows_current. exact (rem_2146).
Defined.

Remark rem_2148 : (forall X:term, auto___def_25 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_5 X1 -> auto___def_26 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_25_pknows_current. intros X1 X2.
  cut (auto___type_5 X1 -> auto_knows_current X1). tauto. exact (rem_2147 epsilon_m__def_25_pknows_current X1).
Defined.

Remark rem_2149 : (forall X:term, auto___def_27 X -> auto_knows_current X)
    -> forall X1:term, auto___def_29 X1 -> auto___def_49 X1. (* Cut history. *)
Proof.  intros epsilon_m__def_27_pknows_current. exact (rem_836).
Defined.

Remark rem_2150 : (forall X:term, auto___def_27 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_27_pknows_current. intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_49 X1). tauto. exact (rem_2149 epsilon_m__def_27_pknows_current X1).
Defined.

Remark rem_2151 : (forall X:term, auto___def_27 X -> auto_knows_current X)
    -> forall X2:term, auto___def_30 X2 -> auto___def_50 X2. (* Cut history. *)
Proof.  intros epsilon_m__def_27_pknows_current. exact (rem_860).
Defined.

Remark rem_2152 : (forall X:term, auto___def_27 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_27_pknows_current. intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_50 X2). tauto. exact (rem_2151 epsilon_m__def_27_pknows_current X2).
Defined.

Remark rem_2153 : (forall X:term, auto___def_27 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_27_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_2150 epsilon_m__def_27_pknows_current X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_2152 epsilon_m__def_27_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2154 : (forall X:term, auto___def_27 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_29 X1 -> auto___def_30 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_27_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2153 epsilon_m__def_27_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_27_pknows_current A1 A2. intros. apply trans_knows_current_key_1;  tauto.
 clear  epsilon_m__def_27_pknows_current A1 A2. tauto.
Defined.

Remark rem_2155 : (forall X:term, auto___def_27 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_27_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_598 X1 X2 H);  intros.
  apply (rem_2154 epsilon_m__def_27_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2156 : forall X1:term, auto___def_27 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_27_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_600  H).
   intro H. elim (rem_603  H).
  intros X1 X2. intro H. elim (rem_608 X1 X2 H).
  intros X1 X2. intro H. elim (rem_614 X1 X2 H).
   intro H. elim (rem_606  H).
  intros X1 X2;  exact (rem_2155 epsilon_m__def_27_pknows_current X1 X2).
   intro H. elim (rem_605  H).
  intros X1 X2. intro H. elim (rem_612 X1 X2 H).
  intros X1 X2. intro H. elim (rem_601 X1 X2 H).
  intros X1 X2. intro H. elim (rem_616 X1 X2 H).
  intros X1 X2. intro H. elim (rem_611 X1 X2 H).
   intro H. elim (rem_602  H).
   intro H. elim (rem_607  H).
  intros X1. intro H. elim (rem_604 X1 H).
   intro H. elim (rem_609  H).
  intros X1 X2 X3. intro H. elim (rem_613 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_615 X1 X2 X3 H).
   intro H. elim (rem_610  H).
Qed.

Remark rem_2157 : (forall X:term, auto___def_26 X -> auto_knows_current X)
    -> forall X1:term, auto___def_27 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_26_pknows_current. exact (rem_2156).
Defined.

Remark rem_2158 : (forall X:term, auto___def_26 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_26_pknows_current. intros X1 X2.
  cut (auto___def_27 X1 -> auto_knows_current X1). tauto. exact (rem_2157 epsilon_m__def_26_pknows_current X1).
Defined.

Remark rem_2159 : (forall X:term, auto___def_31 X -> auto_knows_current X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2160 : (forall X:term, auto___def_31 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_31_pknows_current. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_2159 epsilon_m__def_31_pknows_current X1).
Defined.

Remark rem_2161 : (forall X:term, auto___def_31 X -> auto_knows_current X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2162 : (forall X:term, auto___def_31 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_31_pknows_current. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_2161 epsilon_m__def_31_pknows_current X2).
Defined.

Remark rem_2163 : (forall X:term, auto___def_31 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_31_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_2160 epsilon_m__def_31_pknows_current X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_2162 epsilon_m__def_31_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2164 : (forall X:term, auto___def_31 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_31_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2163 epsilon_m__def_31_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_31_pknows_current A1 A2. intros. apply trans_knows_current_crypt_2;  tauto.
 clear  epsilon_m__def_31_pknows_current A1 A2. tauto.
Defined.

Remark rem_2165 : forall X1 X2:term, auto___def_31 (crypt X1 X2) -> or_1
    (auto___def_33 X1 /\ auto___def_34 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2166 : (forall X:term, auto___def_31 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_31 (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_31_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2165 X1 X2 H);  intros.
  apply (rem_2164 epsilon_m__def_31_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2167 : auto___def_31 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2168 : forall X1 X2:term, auto___def_31 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2169 : auto___def_31 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2170 : auto___def_31 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2171 : forall X1:term, auto___def_31 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2172 : auto___def_31 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2173 : auto___def_31 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2174 : auto___def_31 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2175 : forall X1 X2:term, auto___def_31 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2176 : auto___def_31 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2177 : auto___def_31 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2178 : forall X1 X2:term, auto___def_31 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2179 : forall X1 X2:term, auto___def_31 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2180 : forall X1 X2:term, auto___def_31 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2181 : forall X1 X2 X3:term, auto___def_31 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2182 : forall X1 X2 X3:term, auto___def_31 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2183 : forall X1 X2:term, auto___def_31 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2184 : forall X1:term, auto___def_31 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_31_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2167  H).
   intro H. elim (rem_2170  H).
  intros X1 X2. intro H. elim (rem_2175 X1 X2 H).
  intros X1 X2;  exact (rem_2166 epsilon_m__def_31_pknows_current X1 X2).
   intro H. elim (rem_2173  H).
  intros X1 X2. intro H. elim (rem_2178 X1 X2 H).
   intro H. elim (rem_2172  H).
  intros X1 X2. intro H. elim (rem_2180 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2168 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2183 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2179 X1 X2 H).
   intro H. elim (rem_2169  H).
   intro H. elim (rem_2174  H).
  intros X1. intro H. elim (rem_2171 X1 H).
   intro H. elim (rem_2176  H).
  intros X1 X2 X3. intro H. elim (rem_2181 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2182 X1 X2 X3 H).
   intro H. elim (rem_2177  H).
Qed.

Remark rem_2185 : (forall X:term, auto___def_28 X -> auto_knows_current X)
    -> forall X1:term, auto___def_31 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_28_pknows_current. exact (rem_2184).
Defined.

Remark rem_2186 : (forall X:term, auto___def_28 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_28_pknows_current. intros X1 X2.
  cut (auto___def_31 X1 -> auto_knows_current X1). tauto. exact (rem_2185 epsilon_m__def_28_pknows_current X1).
Defined.

Remark rem_2187 : (forall X:term, auto___def_32 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_32_pknows_current.  tauto.
Defined.

Remark rem_2188 : (forall X:term, auto___def_32 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_32_pknows_current.  case (rem_2187 epsilon_m__def_32_pknows_current). clear  epsilon_m__def_32_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__def_32_pknows_current. tauto.
Defined.

Remark rem_2189 : auto___def_32 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2190 : (forall X:term, auto___def_32 X -> auto_knows_current X)
    -> auto___def_32 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_32_pknows_current. intro H. intros.
  elim (rem_2189 H);  intros.
  apply (rem_2188 epsilon_m__def_32_pknows_current);  tauto.
Defined.

Remark rem_2191 : auto___def_32 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2192 : forall X1 X2:term, auto___def_32 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2193 : auto___def_32 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2194 : auto___def_32 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2195 : forall X1:term, auto___def_32 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2196 : auto___def_32 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2197 : auto___def_32 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2198 : forall X1 X2:term, auto___def_32 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2199 : auto___def_32 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2200 : auto___def_32 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2201 : forall X1 X2:term, auto___def_32 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2202 : forall X1 X2:term, auto___def_32 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2203 : forall X1 X2:term, auto___def_32 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2204 : forall X1 X2 X3:term, auto___def_32 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2205 : forall X1 X2:term, auto___def_32 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2206 : forall X1 X2 X3:term, auto___def_32 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2207 : forall X1 X2:term, auto___def_32 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2208 : forall X2:term, auto___def_32 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_32_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2191  H).
   intro H. elim (rem_2194  H).
  intros X1 X2. intro H. elim (rem_2198 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2205 X1 X2 H).
   intro H. elim (rem_2196  H).
  intros X1 X2. intro H. elim (rem_2201 X1 X2 H).
  exact (rem_2190 epsilon_m__def_32_pknows_current ).
  intros X1 X2. intro H. elim (rem_2203 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2192 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2207 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2202 X1 X2 H).
   intro H. elim (rem_2193  H).
   intro H. elim (rem_2197  H).
  intros X1. intro H. elim (rem_2195 X1 H).
   intro H. elim (rem_2199  H).
  intros X1 X2 X3. intro H. elim (rem_2204 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2206 X1 X2 X3 H).
   intro H. elim (rem_2200  H).
Qed.

Remark rem_2209 : (forall X:term, auto___def_28 X -> auto_knows_current X)
    -> forall X2:term, auto___def_32 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_28_pknows_current. exact (rem_2208).
Defined.

Remark rem_2210 : (forall X:term, auto___def_28 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_28_pknows_current. intros X1 X2.
  cut (auto___def_32 X2 -> auto_knows_current X2). tauto. exact (rem_2209 epsilon_m__def_28_pknows_current X2).
Defined.

Remark rem_2211 : (forall X:term, auto___def_28 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_28_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2186 epsilon_m__def_28_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2210 epsilon_m__def_28_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2212 : (forall X:term, auto___def_28 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_31 X1 -> auto___def_32 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_28_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2211 epsilon_m__def_28_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_28_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_28_pknows_current A1 A2. tauto.
Defined.

Remark rem_2213 : (forall X:term, auto___def_28 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_28 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_28_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1375 X1 X2 H);  intros.
  apply (rem_2212 epsilon_m__def_28_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2214 : auto___def_28 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2215 : forall X1 X2:term, auto___def_28 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2216 : auto___def_28 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2217 : auto___def_28 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2218 : forall X1:term, auto___def_28 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2219 : auto___def_28 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2220 : auto___def_28 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2221 : auto___def_28 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2222 : auto___def_28 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2223 : auto___def_28 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2224 : forall X1 X2:term, auto___def_28 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2225 : forall X1 X2:term, auto___def_28 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2226 : forall X1 X2:term, auto___def_28 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2227 : forall X1 X2 X3:term, auto___def_28 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2228 : forall X1 X2:term, auto___def_28 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2229 : forall X1 X2 X3:term, auto___def_28 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2230 : forall X1 X2:term, auto___def_28 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2231 : forall X2:term, auto___def_28 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_28_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2214  H).
   intro H. elim (rem_2217  H).
  intros X1 X2;  exact (rem_2213 epsilon_m__def_28_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2228 X1 X2 H).
   intro H. elim (rem_2220  H).
  intros X1 X2. intro H. elim (rem_2224 X1 X2 H).
   intro H. elim (rem_2219  H).
  intros X1 X2. intro H. elim (rem_2226 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2215 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2230 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2225 X1 X2 H).
   intro H. elim (rem_2216  H).
   intro H. elim (rem_2221  H).
  intros X1. intro H. elim (rem_2218 X1 H).
   intro H. elim (rem_2222  H).
  intros X1 X2 X3. intro H. elim (rem_2227 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2229 X1 X2 X3 H).
   intro H. elim (rem_2223  H).
Qed.

Remark rem_2232 : (forall X:term, auto___def_26 X -> auto_knows_current X)
    -> forall X2:term, auto___def_28 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_26_pknows_current. exact (rem_2231).
Defined.

Remark rem_2233 : (forall X:term, auto___def_26 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_26_pknows_current. intros X1 X2.
  cut (auto___def_28 X2 -> auto_knows_current X2). tauto. exact (rem_2232 epsilon_m__def_26_pknows_current X2).
Defined.

Remark rem_2234 : (forall X:term, auto___def_26 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_26_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2158 epsilon_m__def_26_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2233 epsilon_m__def_26_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2235 : (forall X:term, auto___def_26 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_28 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_26_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2234 epsilon_m__def_26_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_26_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_26_pknows_current A1 A2. tauto.
Defined.

Remark rem_2236 : (forall X:term, auto___def_26 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_26 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_26_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1377 X1 X2 H);  intros.
  apply (rem_2235 epsilon_m__def_26_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2237 : auto___def_26 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2238 : forall X1 X2:term, auto___def_26 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2239 : auto___def_26 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2240 : auto___def_26 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2241 : forall X1:term, auto___def_26 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2242 : auto___def_26 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2243 : auto___def_26 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2244 : auto___def_26 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2245 : auto___def_26 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2246 : forall X1 X2:term, auto___def_26 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2247 : forall X1 X2:term, auto___def_26 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2248 : forall X1 X2:term, auto___def_26 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2249 : forall X1 X2 X3:term, auto___def_26 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2250 : forall X1 X2:term, auto___def_26 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2251 : forall X1 X2 X3:term, auto___def_26 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2252 : forall X1 X2:term, auto___def_26 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2253 : forall X2:term, auto___def_26 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_26_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2237  H).
   intro H. elim (rem_2240  H).
  intros X1 X2;  exact (rem_2236 epsilon_m__def_26_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2250 X1 X2 H).
   intro H. elim (rem_2242  H).
  intros X1 X2. intro H. elim (rem_2246 X1 X2 H).
   intro H. elim (rem_1644  H).
  intros X1 X2. intro H. elim (rem_2248 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2238 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2252 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2247 X1 X2 H).
   intro H. elim (rem_2239  H).
   intro H. elim (rem_2243  H).
  intros X1. intro H. elim (rem_2241 X1 H).
   intro H. elim (rem_2244  H).
  intros X1 X2 X3. intro H. elim (rem_2249 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2251 X1 X2 X3 H).
   intro H. elim (rem_2245  H).
Qed.

Remark rem_2254 : (forall X:term, auto___def_25 X -> auto_knows_current X)
    -> forall X2:term, auto___def_26 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_25_pknows_current. exact (rem_2253).
Defined.

Remark rem_2255 : (forall X:term, auto___def_25 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_5 X1 -> auto___def_26 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_25_pknows_current. intros X1 X2.
  cut (auto___def_26 X2 -> auto_knows_current X2). tauto. exact (rem_2254 epsilon_m__def_25_pknows_current X2).
Defined.

Remark rem_2256 : (forall X:term, auto___def_25 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_5 X1 -> auto___def_26 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_25_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2148 epsilon_m__def_25_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2255 epsilon_m__def_25_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2257 : (forall X:term, auto___def_25 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_5 X1 -> auto___def_26 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_25_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2256 epsilon_m__def_25_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_25_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_25_pknows_current A1 A2. tauto.
Defined.

Remark rem_2258 : (forall X:term, auto___def_25 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_25 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_25_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1380 X1 X2 H);  intros.
  apply (rem_2257 epsilon_m__def_25_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2259 : auto___def_25 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2260 : forall X1 X2:term, auto___def_25 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2261 : auto___def_25 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2262 : auto___def_25 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2263 : forall X1:term, auto___def_25 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2264 : auto___def_25 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2265 : auto___def_25 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2266 : auto___def_25 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2267 : auto___def_25 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2268 : auto___def_25 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2269 : forall X1 X2:term, auto___def_25 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2270 : forall X1 X2:term, auto___def_25 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2271 : forall X1 X2:term, auto___def_25 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2272 : forall X1 X2 X3:term, auto___def_25 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2273 : forall X1 X2:term, auto___def_25 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2274 : forall X1 X2 X3:term, auto___def_25 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2275 : forall X1 X2:term, auto___def_25 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2276 : forall X2:term, auto___def_25 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_25_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2259  H).
   intro H. elim (rem_2262  H).
  intros X1 X2;  exact (rem_2258 epsilon_m__def_25_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2273 X1 X2 H).
   intro H. elim (rem_2265  H).
  intros X1 X2. intro H. elim (rem_2269 X1 X2 H).
   intro H. elim (rem_2264  H).
  intros X1 X2. intro H. elim (rem_2271 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2260 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2275 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2270 X1 X2 H).
   intro H. elim (rem_2261  H).
   intro H. elim (rem_2266  H).
  intros X1. intro H. elim (rem_2263 X1 H).
   intro H. elim (rem_2267  H).
  intros X1 X2 X3. intro H. elim (rem_2272 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2274 X1 X2 X3 H).
   intro H. elim (rem_2268  H).
Qed.

Remark rem_2277 : (forall X:term, auto___def_23 X -> auto_knows_current X)
    -> forall X2:term, auto___def_25 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_23_pknows_current. exact (rem_2276).
Defined.

Remark rem_2278 : (forall X:term, auto___def_23 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 X1 -> auto___def_25 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_23_pknows_current. intros X1 X2.
  cut (auto___def_25 X2 -> auto_knows_current X2). tauto. exact (rem_2277 epsilon_m__def_23_pknows_current X2).
Defined.

Remark rem_2279 : (forall X:term, auto___def_23 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 X1 -> auto___def_25 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_23_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2136 epsilon_m__def_23_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2278 epsilon_m__def_23_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2280 : (forall X:term, auto___def_23 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_4 X1 -> auto___def_25 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_23_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2279 epsilon_m__def_23_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_23_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_23_pknows_current A1 A2. tauto.
Defined.

Remark rem_2281 : (forall X:term, auto___def_23 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_23_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1386 X1 X2 H);  intros.
  apply (rem_2280 epsilon_m__def_23_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2282 : auto___def_23 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2283 : forall X1 X2:term, auto___def_23 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2284 : auto___def_23 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2285 : auto___def_23 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2286 : forall X1:term, auto___def_23 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2287 : auto___def_23 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2288 : auto___def_23 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2289 : auto___def_23 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2290 : auto___def_23 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2291 : auto___def_23 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2292 : forall X1 X2:term, auto___def_23 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2293 : forall X1 X2:term, auto___def_23 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2294 : forall X1 X2:term, auto___def_23 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2295 : forall X1 X2 X3:term, auto___def_23 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2296 : forall X1 X2:term, auto___def_23 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2297 : forall X1 X2 X3:term, auto___def_23 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2298 : forall X1 X2:term, auto___def_23 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2299 : forall X2:term, auto___def_23 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_23_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2282  H).
   intro H. elim (rem_2285  H).
  intros X1 X2;  exact (rem_2281 epsilon_m__def_23_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2296 X1 X2 H).
   intro H. elim (rem_2288  H).
  intros X1 X2. intro H. elim (rem_2292 X1 X2 H).
   intro H. elim (rem_2287  H).
  intros X1 X2. intro H. elim (rem_2294 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2283 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2298 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2293 X1 X2 H).
   intro H. elim (rem_2284  H).
   intro H. elim (rem_2289  H).
  intros X1. intro H. elim (rem_2286 X1 H).
   intro H. elim (rem_2290  H).
  intros X1 X2 X3. intro H. elim (rem_2295 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2297 X1 X2 X3 H).
   intro H. elim (rem_2291  H).
Qed.

Remark rem_2300 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 (key pub X1) -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_23 X2 -> auto_knows_current X2). tauto. exact (rem_2299 X2).
Qed.

Remark rem_2301 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 (key pub X1) -> (auto___type_10 X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_10 X1). 2:apply (rem_2047 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2300 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2302 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 (key pub X1) -> auto___def_51 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2301 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_51_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2303 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 (key pub X1) -> auto___type_10 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___type_10_1. Qed.

Remark rem_2304 : (forall X:term, auto___def_33 X -> auto_knows_current X)
    -> forall X1:term, auto___def_27 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_33_pknows_current. exact (rem_2156).
Defined.

Remark rem_2305 : (forall X:term, auto___def_33 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_33_pknows_current. intros X1 X2.
  cut (auto___def_27 X1 -> auto_knows_current X1). tauto. exact (rem_2304 epsilon_m__def_33_pknows_current X1).
Defined.

Remark rem_2306 : (forall X:term, auto___type_6 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_6_pknows_current. intros X1 X2. intros A1 A2.
  tauto.
Defined.

Remark rem_2307 : (forall X:term, auto___type_6 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_current (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_6_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2306 epsilon_m__type_6_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_6_pknows_current A1 A2. intros. apply trans_knows_current_nonceb_old_1;  tauto.
 clear  epsilon_m__type_6_pknows_current A1 A2. tauto.
Defined.

Remark rem_2308 : forall X1 X2:term, auto___type_6 (nonceb_old X1 X2) -> or_1
    (auto_knows_old X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2309 : (forall X:term, auto___type_6 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_6 (nonceb_old X1 X2) -> auto_knows_current (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_6_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2308 X1 X2 H);  intros.
  apply (rem_2307 epsilon_m__type_6_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2310 : auto___type_6 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2311 : forall X1 X2:term, auto___type_6 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2312 : auto___type_6 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2313 : auto___type_6 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2314 : forall X1:term, auto___type_6 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2315 : auto___type_6 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2316 : auto___type_6 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2317 : auto___type_6 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2318 : forall X1 X2:term, auto___type_6 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2319 : auto___type_6 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2320 : auto___type_6 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2321 : forall X1 X2:term, auto___type_6 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2322 : forall X1 X2:term, auto___type_6 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2323 : forall X1 X2 X3:term, auto___type_6 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2324 : forall X1 X2:term, auto___type_6 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2325 : forall X1 X2 X3:term, auto___type_6 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2326 : forall X1 X2:term, auto___type_6 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2327 : forall X1:term, auto___type_6 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_6_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2310  H).
   intro H. elim (rem_2313  H).
  intros X1 X2. intro H. elim (rem_2318 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2324 X1 X2 H).
   intro H. elim (rem_2316  H).
  intros X1 X2. intro H. elim (rem_2321 X1 X2 H).
   intro H. elim (rem_2315  H).
  intros X1 X2. intro H. elim (rem_2322 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2311 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2326 X1 X2 H).
  intros X1 X2;  exact (rem_2309 epsilon_m__type_6_pknows_current X1 X2).
   intro H. elim (rem_2312  H).
   intro H. elim (rem_2317  H).
  intros X1. intro H. elim (rem_2314 X1 H).
   intro H. elim (rem_2319  H).
  intros X1 X2 X3. intro H. elim (rem_2323 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2325 X1 X2 X3 H).
   intro H. elim (rem_2320  H).
Qed.

Remark rem_2328 : (forall X:term, auto___def_35 X -> auto_knows_current X)
    -> forall X1:term, auto___type_6 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_35_pknows_current. exact (rem_2327).
Defined.

Remark rem_2329 : (forall X:term, auto___def_35 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_6 X1 -> auto___def_36 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_35_pknows_current. intros X1 X2.
  cut (auto___type_6 X1 -> auto_knows_current X1). tauto. exact (rem_2328 epsilon_m__def_35_pknows_current X1).
Defined.

Remark rem_2330 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current.  tauto.
Defined.

Remark rem_2331 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current.  case (rem_2330 epsilon_m__type_7_pknows_current). clear  epsilon_m__type_7_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_7_pknows_current. tauto.
Defined.

Remark rem_2332 : auto___type_7 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2333 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto___type_7 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intro H. intros.
  elim (rem_2332 H);  intros.
  apply (rem_2331 epsilon_m__type_7_pknows_current);  tauto.
Defined.

Remark rem_2334 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  tauto.
Defined.

Remark rem_2335 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2334 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_noncea_old_1;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2336 : forall X1 X2:term, auto___type_7 (noncea_old X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2337 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 (noncea_old X1 X2) -> auto_knows_current (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2336 X1 X2 H);  intros.
  apply (rem_2335 epsilon_m__type_7_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2338 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current.  case (rem_2330 epsilon_m__type_7_pknows_current). clear  epsilon_m__type_7_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_7_pknows_current. tauto.
Defined.

Remark rem_2339 : auto___type_7 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2340 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto___type_7 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intro H. intros.
  elim (rem_2339 H);  intros.
  apply (rem_2338 epsilon_m__type_7_pknows_current);  tauto.
Defined.

Remark rem_2341 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_7_pknows_current. exact (rem_926).
Defined.

Remark rem_2342 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_2341 epsilon_m__type_7_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_2343 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1. intros A1.
  case (rem_2342 epsilon_m__type_7_pknows_current X1 A1). clear  epsilon_m__type_7_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_m__type_7_pknows_current A1. tauto.
Defined.

Remark rem_2344 : forall X1:term, auto___type_7 (s X1) -> or_1
    (auto_knows_old X1).
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2345 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___type_7 (s X1) -> auto_knows_current (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1. intro H. intros.
  elim (rem_2344 X1 H);  intros.
  apply (rem_2343 epsilon_m__type_7_pknows_current X1);  tauto.
Defined.

Remark rem_2346 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current.  case (rem_2330 epsilon_m__type_7_pknows_current). clear  epsilon_m__type_7_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__type_7_pknows_current. tauto.
Defined.

Remark rem_2347 : auto___type_7 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2348 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto___type_7 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intro H. intros.
  elim (rem_2347 H);  intros.
  apply (rem_2346 epsilon_m__type_7_pknows_current);  tauto.
Defined.

Remark rem_2349 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current.  case (rem_2330 epsilon_m__type_7_pknows_current). clear  epsilon_m__type_7_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_7_pknows_current. tauto.
Defined.

Remark rem_2350 : auto___type_7 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2351 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto___type_7 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intro H. intros.
  elim (rem_2350 H);  intros.
  apply (rem_2349 epsilon_m__type_7_pknows_current);  tauto.
Defined.

Remark rem_2352 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_current X1). tauto. exact (rem_2341 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2353 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_7_pknows_current. exact (rem_939).
Defined.

Remark rem_2354 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_current X2). tauto. exact (rem_2353 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2355 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2352 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2354 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2356 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2355 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2357 : forall X1 X2:term, auto___type_7 (cons X1 X2) -> or_1
    (auto_knows_old X1 /\ auto_knows_old X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2358 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2357 X1 X2 H);  intros.
  apply (rem_2356 epsilon_m__type_7_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2359 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current.  case (rem_2330 epsilon_m__type_7_pknows_current). clear  epsilon_m__type_7_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_7_pknows_current. tauto.
Defined.

Remark rem_2360 : auto___type_7 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2361 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> auto___type_7 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intro H. intros.
  elim (rem_2360 H);  intros.
  apply (rem_2359 epsilon_m__type_7_pknows_current);  tauto.
Defined.

Remark rem_2362 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2363 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_2362 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2364 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2365 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_2364 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2366 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_2363 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_2365 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2367 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2366 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_key_2;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2368 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2369 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_2368 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2370 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2371 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_2370 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2372 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_2369 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_2371 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2373 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2372 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_key_3;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2374 : forall X1 X2:term, auto___type_7 (key X1 X2) -> or_2
    (auto___def_47 X1 /\ auto___def_48 X2)
    (auto___def_46 X1 /\ auto___type_10 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_2_intro_1; tauto.
  intros. apply or_2_intro_2; tauto.
Qed.

Remark rem_2375 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2374 X1 X2 H);  intros.
  apply (rem_2367 epsilon_m__type_7_pknows_current X1 X2);  tauto.
  apply (rem_2373 epsilon_m__type_7_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2376 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2355 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2377 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2378 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_2377 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2379 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2380 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_2379 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2381 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_2378 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_2380 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2382 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2381 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_crypt_1;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2383 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2384 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_2383 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2385 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2386 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_2385 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2387 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_2384 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_2386 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2388 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2387 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_crypt_2;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2389 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_7_pknows_current. exact (rem_813).
Defined.

Remark rem_2390 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_44 X1 -> auto_knows_current X1). tauto. exact (rem_2389 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2391 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto___type_9 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_7_pknows_current. exact (rem_883).
Defined.

Remark rem_2392 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___type_9 X2 -> auto_knows_current X2). tauto. exact (rem_2391 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2393 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2390 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2392 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2394 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2393 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2395 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_7_pknows_current. exact (rem_787).
Defined.

Remark rem_2396 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_42 X1 -> auto_knows_current X1). tauto. exact (rem_2395 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2397 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto___type_8 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_7_pknows_current. exact (rem_914).
Defined.

Remark rem_2398 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___type_8 X2 -> auto_knows_current X2). tauto. exact (rem_2397 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2399 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2396 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2398 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2400 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2399 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2401 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2402 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_2401 epsilon_m__type_7_pknows_current X1).
Defined.

Remark rem_2403 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2404 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_2403 epsilon_m__type_7_pknows_current X2).
Defined.

Remark rem_2405 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_2402 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_2404 epsilon_m__type_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2406 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2405 epsilon_m__type_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_current A1 A2. intros. apply trans_knows_current_crypt_9;  tauto.
 clear  epsilon_m__type_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2407 : forall X1 X2:term, auto___type_7 (crypt X1 X2) -> or_6
    (auto_knows_old X1 /\ auto_knows_old X2)
    (auto___def_23 X1 /\ auto___def_24 X2)
    (auto___def_33 X1 /\ auto___def_34 X2)
    (auto___def_44 X1 /\ auto___type_9 X2)
    (auto___def_42 X1 /\ auto___type_8 X2)
    (auto___def_7 X1 /\ auto___def_8 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_6_intro_1; tauto.
  intros. apply or_6_intro_2; tauto.
  intros. apply or_6_intro_3; tauto.
  intros. apply or_6_intro_4; tauto.
  intros. apply or_6_intro_5; tauto.
  intros. apply or_6_intro_6; tauto.
Qed.

Remark rem_2408 : (forall X:term, auto___type_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2407 X1 X2 H);  intros.
  apply (rem_2376 epsilon_m__type_7_pknows_current X1 X2);  tauto.
  apply (rem_2382 epsilon_m__type_7_pknows_current X1 X2);  tauto.
  apply (rem_2388 epsilon_m__type_7_pknows_current X1 X2);  tauto.
  apply (rem_2394 epsilon_m__type_7_pknows_current X1 X2);  tauto.
  apply (rem_2400 epsilon_m__type_7_pknows_current X1 X2);  tauto.
  apply (rem_2406 epsilon_m__type_7_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2409 : auto___type_7 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2410 : auto___type_7 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2411 : auto___type_7 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2412 : forall X1 X2:term, auto___type_7 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2413 : forall X1 X2:term, auto___type_7 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2414 : forall X1 X2 X3:term, auto___type_7 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2415 : forall X1 X2 X3:term, auto___type_7 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2416 : forall X1 X2:term, auto___type_7 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2417 : forall X1:term, auto___type_7 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_7_pknows_current 1.
  intro X. case X.
  exact (rem_2333 epsilon_m__type_7_pknows_current ).
  exact (rem_2340 epsilon_m__type_7_pknows_current ).
  intros X1 X2;  exact (rem_2358 epsilon_m__type_7_pknows_current X1 X2).
  intros X1 X2;  exact (rem_2408 epsilon_m__type_7_pknows_current X1 X2).
  exact (rem_2351 epsilon_m__type_7_pknows_current ).
  intros X1 X2;  exact (rem_2375 epsilon_m__type_7_pknows_current X1 X2).
  exact (rem_2348 epsilon_m__type_7_pknows_current ).
  intros X1 X2. intro H. elim (rem_2413 X1 X2 H).
  intros X1 X2;  exact (rem_2337 epsilon_m__type_7_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2416 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2412 X1 X2 H).
   intro H. elim (rem_2409  H).
   intro H. elim (rem_2410  H).
  intros X1;  exact (rem_2345 epsilon_m__type_7_pknows_current X1).
  exact (rem_2361 epsilon_m__type_7_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_2414 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2415 X1 X2 X3 H).
   intro H. elim (rem_2411  H).
Qed.

Remark rem_2418 : (forall X:term, auto___def_36 X -> auto_knows_current X)
    -> forall X1:term, auto___type_7 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_36_pknows_current. exact (rem_2417).
Defined.

Remark rem_2419 : (forall X:term, auto___def_36 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 X1 -> auto___def_32 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_36_pknows_current. intros X1 X2.
  cut (auto___type_7 X1 -> auto_knows_current X1). tauto. exact (rem_2418 epsilon_m__def_36_pknows_current X1).
Defined.

Remark rem_2420 : (forall X:term, auto___def_36 X -> auto_knows_current X)
    -> forall X2:term, auto___def_32 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_36_pknows_current. exact (rem_2208).
Defined.

Remark rem_2421 : (forall X:term, auto___def_36 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 X1 -> auto___def_32 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_36_pknows_current. intros X1 X2.
  cut (auto___def_32 X2 -> auto_knows_current X2). tauto. exact (rem_2420 epsilon_m__def_36_pknows_current X2).
Defined.

Remark rem_2422 : (forall X:term, auto___def_36 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 X1 -> auto___def_32 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_36_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2419 epsilon_m__def_36_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2421 epsilon_m__def_36_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2423 : (forall X:term, auto___def_36 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_7 X1 -> auto___def_32 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_36_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2422 epsilon_m__def_36_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_36_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_36_pknows_current A1 A2. tauto.
Defined.

Remark rem_2424 : forall X1 X2:term, auto___def_36 (cons X1 X2) -> or_1
    (auto___type_7 X1 /\ auto___def_32 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2425 : (forall X:term, auto___def_36 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_36 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_36_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_2424 X1 X2 H);  intros.
  apply (rem_2423 epsilon_m__def_36_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2426 : auto___def_36 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2427 : forall X1 X2:term, auto___def_36 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2428 : auto___def_36 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2429 : auto___def_36 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2430 : forall X1:term, auto___def_36 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2431 : auto___def_36 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2432 : auto___def_36 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2433 : auto___def_36 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2434 : auto___def_36 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2435 : forall X1 X2:term, auto___def_36 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2436 : forall X1 X2:term, auto___def_36 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2437 : forall X1 X2:term, auto___def_36 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2438 : forall X1 X2 X3:term, auto___def_36 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2439 : forall X1 X2:term, auto___def_36 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2440 : forall X1 X2 X3:term, auto___def_36 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2441 : forall X1 X2:term, auto___def_36 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2442 : forall X2:term, auto___def_36 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_36_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2426  H).
   intro H. elim (rem_2429  H).
  intros X1 X2;  exact (rem_2425 epsilon_m__def_36_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2439 X1 X2 H).
   intro H. elim (rem_2431  H).
  intros X1 X2. intro H. elim (rem_2435 X1 X2 H).
   intro H. elim (rem_1654  H).
  intros X1 X2. intro H. elim (rem_2437 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2427 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2441 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2436 X1 X2 H).
   intro H. elim (rem_2428  H).
   intro H. elim (rem_2432  H).
  intros X1. intro H. elim (rem_2430 X1 H).
   intro H. elim (rem_2433  H).
  intros X1 X2 X3. intro H. elim (rem_2438 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2440 X1 X2 X3 H).
   intro H. elim (rem_2434  H).
Qed.

Remark rem_2443 : (forall X:term, auto___def_35 X -> auto_knows_current X)
    -> forall X2:term, auto___def_36 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_35_pknows_current. exact (rem_2442).
Defined.

Remark rem_2444 : (forall X:term, auto___def_35 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_6 X1 -> auto___def_36 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_35_pknows_current. intros X1 X2.
  cut (auto___def_36 X2 -> auto_knows_current X2). tauto. exact (rem_2443 epsilon_m__def_35_pknows_current X2).
Defined.

Remark rem_2445 : (forall X:term, auto___def_35 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_6 X1 -> auto___def_36 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_35_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2329 epsilon_m__def_35_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2444 epsilon_m__def_35_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2446 : (forall X:term, auto___def_35 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_6 X1 -> auto___def_36 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_35_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2445 epsilon_m__def_35_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_35_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_35_pknows_current A1 A2. tauto.
Defined.

Remark rem_2447 : (forall X:term, auto___def_35 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_35 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_35_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1658 X1 X2 H);  intros.
  apply (rem_2446 epsilon_m__def_35_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2448 : auto___def_35 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2449 : forall X1 X2:term, auto___def_35 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2450 : auto___def_35 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2451 : auto___def_35 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2452 : forall X1:term, auto___def_35 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2453 : auto___def_35 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2454 : auto___def_35 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2455 : auto___def_35 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2456 : auto___def_35 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2457 : auto___def_35 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2458 : forall X1 X2:term, auto___def_35 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2459 : forall X1 X2:term, auto___def_35 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2460 : forall X1 X2:term, auto___def_35 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2461 : forall X1 X2 X3:term, auto___def_35 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2462 : forall X1 X2:term, auto___def_35 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2463 : forall X1 X2 X3:term, auto___def_35 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2464 : forall X1 X2:term, auto___def_35 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2465 : forall X2:term, auto___def_35 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_35_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2448  H).
   intro H. elim (rem_2451  H).
  intros X1 X2;  exact (rem_2447 epsilon_m__def_35_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2462 X1 X2 H).
   intro H. elim (rem_2454  H).
  intros X1 X2. intro H. elim (rem_2458 X1 X2 H).
   intro H. elim (rem_2453  H).
  intros X1 X2. intro H. elim (rem_2460 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2449 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2464 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2459 X1 X2 H).
   intro H. elim (rem_2450  H).
   intro H. elim (rem_2455  H).
  intros X1. intro H. elim (rem_2452 X1 H).
   intro H. elim (rem_2456  H).
  intros X1 X2 X3. intro H. elim (rem_2461 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2463 X1 X2 X3 H).
   intro H. elim (rem_2457  H).
Qed.

Remark rem_2466 : (forall X:term, auto___def_33 X -> auto_knows_current X)
    -> forall X2:term, auto___def_35 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_33_pknows_current. exact (rem_2465).
Defined.

Remark rem_2467 : (forall X:term, auto___def_33 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_33_pknows_current. intros X1 X2.
  cut (auto___def_35 X2 -> auto_knows_current X2). tauto. exact (rem_2466 epsilon_m__def_33_pknows_current X2).
Defined.

Remark rem_2468 : (forall X:term, auto___def_33 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_33_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2305 epsilon_m__def_33_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2467 epsilon_m__def_33_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2469 : (forall X:term, auto___def_33 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_33_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2468 epsilon_m__def_33_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_33_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_33_pknows_current A1 A2. tauto.
Defined.

Remark rem_2470 : (forall X:term, auto___def_33 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_33_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1390 X1 X2 H);  intros.
  apply (rem_2469 epsilon_m__def_33_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2471 : auto___def_33 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2472 : forall X1 X2:term, auto___def_33 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2473 : auto___def_33 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2474 : auto___def_33 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2475 : forall X1:term, auto___def_33 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2476 : auto___def_33 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2477 : auto___def_33 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2478 : auto___def_33 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2479 : auto___def_33 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2480 : auto___def_33 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2481 : forall X1 X2:term, auto___def_33 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2482 : forall X1 X2:term, auto___def_33 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2483 : forall X1 X2:term, auto___def_33 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2484 : forall X1 X2 X3:term, auto___def_33 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2485 : forall X1 X2:term, auto___def_33 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2486 : forall X1 X2 X3:term, auto___def_33 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2487 : forall X1 X2:term, auto___def_33 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2488 : forall X2:term, auto___def_33 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_33_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2471  H).
   intro H. elim (rem_2474  H).
  intros X1 X2;  exact (rem_2470 epsilon_m__def_33_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2485 X1 X2 H).
   intro H. elim (rem_2477  H).
  intros X1 X2. intro H. elim (rem_2481 X1 X2 H).
   intro H. elim (rem_2476  H).
  intros X1 X2. intro H. elim (rem_2483 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2472 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2487 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2482 X1 X2 H).
   intro H. elim (rem_2473  H).
   intro H. elim (rem_2478  H).
  intros X1. intro H. elim (rem_2475 X1 H).
   intro H. elim (rem_2479  H).
  intros X1 X2 X3. intro H. elim (rem_2484 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2486 X1 X2 X3 H).
   intro H. elim (rem_2480  H).
Qed.

Remark rem_2489 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 (key pub X1) -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_33 X2 -> auto_knows_current X2). tauto. exact (rem_2488 X2).
Qed.

Remark rem_2490 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 (key pub X1) -> (auto___type_10 X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_10 X1). 2:apply (rem_2303 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2489 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2491 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 (key pub X1) -> auto___def_51 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2490 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_51_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2492 : auto___def_74 pub -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_75 H);  intros.
Qed.

Remark rem_2493 : forall X1 X2:term, auto___def_74 pub -> auto___def_78 X2 -> auto___def_82 X1 -> auto___def_51 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 pub -> False). tauto.
  exact (rem_2492).
Qed.

Remark rem_2494 : forall X1 X2:term, auto___def_74 pub -> auto___def_82 X1 -> auto___def_78 X2 -> auto___def_51 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_74 pub -> auto___def_78 X2 -> auto___def_82 X1 -> auto___def_51 X1 X2). tauto. exact (rem_2493 X1 X2).
Qed.

Remark rem_2495 : forall X1 X2:term, auto___def_78 X2 -> auto___def_79 (key pub X1) -> auto___def_51 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_176 pub X1 H);  intros.
  apply (rem_2494 X1 X2);  tauto.
Qed.

Remark rem_2496 : forall X1 X2:term, auto___def_74 pub -> auto___def_75 X1 -> auto___def_89 X2 -> auto___def_51 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 pub -> False). tauto.
  exact (rem_2492).
Qed.

Remark rem_2497 : forall X1 X2:term, auto___def_89 X2 -> auto___type_19 (key pub X1) -> auto___def_51 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_1890 pub X1 H);  intros.
  apply (rem_2496 X1 X2);  tauto.
Qed.

Remark rem_2498 : auto___def_12 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2499 : auto___def_12 pub -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_2498 H);  intros.
Qed.

Remark rem_2500 : forall X1 X2:term, auto___def_12 pub -> auto___def_13 X1 -> auto___def_57 X2 -> auto___def_51 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_12 pub -> False). tauto.
  exact (rem_2499).
Qed.

Remark rem_2501 : forall X1 X2:term, auto___def_57 X2 -> auto___def_58 (key pub X1) -> auto___def_51 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_259 pub X1 H);  intros.
  apply (rem_2500 X1 X2);  tauto.
Qed.

Remark rem_2502 : forall X1 X2:term, auto___def_68 X2 -> auto___def_74 pub -> auto___def_84 X1 -> auto___def_51 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 pub -> False). tauto.
  exact (rem_2492).
Qed.

Remark rem_2503 : forall X1 X2:term, auto___def_74 pub -> auto___def_84 X1 -> auto___def_68 X2 -> auto___def_51 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_68 X2 -> auto___def_74 pub -> auto___def_84 X1 -> auto___def_51 X1 X2). tauto. exact (rem_2502 X1 X2).
Qed.

Remark rem_2504 : forall X1 X2:term, auto___def_68 X2 -> auto___def_69 (key pub X1) -> auto___def_51 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_147 pub X1 H);  intros.
  apply (rem_2503 X1 X2);  tauto.
Qed.

Remark rem_2505 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current (key pub X1) -> auto___type_10 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___type_10_1. Qed.

Remark rem_2506 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current (key pub X1) -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_1899 X2).
Qed.

Remark rem_2507 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current (key pub X1) -> (auto___type_10 X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_10 X1). 2:apply (rem_2505 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2506 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2508 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current (key pub X1) -> auto___def_51 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2507 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_51_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2509 : forall X1 X2:term, auto___def_74 pub -> auto___def_75 X1 -> auto___def_87 X2 -> auto___def_51 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 pub -> False). tauto.
  exact (rem_2492).
Qed.

Remark rem_2510 : forall X1 X2:term, auto___def_87 X2 -> auto___type_18 (key pub X1) -> auto___def_51 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_1907 pub X1 H);  intros.
  apply (rem_2509 X1 X2);  tauto.
Qed.

Remark rem_2511 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 (key pub X1) -> auto___type_10 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___type_10_1. Qed.

Remark rem_2512 : (forall X:term, auto___def_7 X -> auto_knows_current X)
    -> forall X1:term, auto___type_1 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_7_pknows_current. exact (rem_1004).
Defined.

Remark rem_2513 : (forall X:term, auto___def_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 X1 -> auto___def_9 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_7_pknows_current. intros X1 X2.
  cut (auto___type_1 X1 -> auto_knows_current X1). tauto. exact (rem_2512 epsilon_m__def_7_pknows_current X1).
Defined.

Remark rem_2514 : (forall X:term, auto___def_10 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_10_pknows_current. intros X1 X2. intros A1 A2.
  tauto.
Defined.

Remark rem_2515 : (forall X:term, auto___def_10 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_current (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_10_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2514 epsilon_m__def_10_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_10_pknows_current A1 A2. intros. apply trans_knows_current_nonceb_old_1;  tauto.
 clear  epsilon_m__def_10_pknows_current A1 A2. tauto.
Defined.

Remark rem_2516 : (forall X:term, auto___def_10 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_10 (nonceb_old X1 X2) -> auto_knows_current (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_10_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1443 X1 X2 H);  intros.
  apply (rem_2515 epsilon_m__def_10_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2517 : forall X1:term, auto___def_10 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_10_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_1445  H).
   intro H. elim (rem_1448  H).
  intros X1 X2. intro H. elim (rem_1453 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1459 X1 X2 H).
   intro H. elim (rem_1451  H).
  intros X1 X2. intro H. elim (rem_1456 X1 X2 H).
   intro H. elim (rem_1450  H).
  intros X1 X2. intro H. elim (rem_1457 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1446 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1461 X1 X2 H).
  intros X1 X2;  exact (rem_2516 epsilon_m__def_10_pknows_current X1 X2).
   intro H. elim (rem_1447  H).
   intro H. elim (rem_1452  H).
  intros X1. intro H. elim (rem_1449 X1 H).
   intro H. elim (rem_1454  H).
  intros X1 X2 X3. intro H. elim (rem_1458 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1460 X1 X2 X3 H).
   intro H. elim (rem_1455  H).
Qed.

Remark rem_2518 : (forall X:term, auto___def_9 X -> auto_knows_current X)
    -> forall X1:term, auto___def_10 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_9_pknows_current. exact (rem_2517).
Defined.

Remark rem_2519 : (forall X:term, auto___def_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_9_pknows_current. intros X1 X2.
  cut (auto___def_10 X1 -> auto_knows_current X1). tauto. exact (rem_2518 epsilon_m__def_9_pknows_current X1).
Defined.

Remark rem_2520 : (forall X:term, auto___def_11 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_11_pknows_current.  tauto.
Defined.

Remark rem_2521 : (forall X:term, auto___def_11 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_11_pknows_current.  case (rem_2520 epsilon_m__def_11_pknows_current). clear  epsilon_m__def_11_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__def_11_pknows_current. tauto.
Defined.

Remark rem_2522 : auto___def_11 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2523 : (forall X:term, auto___def_11 X -> auto_knows_current X)
    -> auto___def_11 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_11_pknows_current. intro H. intros.
  elim (rem_2522 H);  intros.
  apply (rem_2521 epsilon_m__def_11_pknows_current);  tauto.
Defined.

Remark rem_2524 : auto___def_11 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2525 : forall X1 X2:term, auto___def_11 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2526 : auto___def_11 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2527 : auto___def_11 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2528 : forall X1:term, auto___def_11 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2529 : auto___def_11 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2530 : auto___def_11 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2531 : auto___def_11 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2532 : auto___def_11 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2533 : forall X1 X2:term, auto___def_11 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2534 : forall X1 X2:term, auto___def_11 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2535 : forall X1 X2:term, auto___def_11 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2536 : forall X1 X2 X3:term, auto___def_11 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2537 : forall X1 X2:term, auto___def_11 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2538 : forall X1 X2 X3:term, auto___def_11 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2539 : forall X1 X2:term, auto___def_11 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2540 : forall X2:term, auto___def_11 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_11_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2524  H).
   intro H. elim (rem_2527  H).
  intros X1 X2. intro H. elim (rem_1394 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2537 X1 X2 H).
   intro H. elim (rem_2529  H).
  intros X1 X2. intro H. elim (rem_2533 X1 X2 H).
  exact (rem_2523 epsilon_m__def_11_pknows_current ).
  intros X1 X2. intro H. elim (rem_2535 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2525 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2539 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2534 X1 X2 H).
   intro H. elim (rem_2526  H).
   intro H. elim (rem_2530  H).
  intros X1. intro H. elim (rem_2528 X1 H).
   intro H. elim (rem_2531  H).
  intros X1 X2 X3. intro H. elim (rem_2536 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2538 X1 X2 X3 H).
   intro H. elim (rem_2532  H).
Qed.

Remark rem_2541 : (forall X:term, auto___def_9 X -> auto_knows_current X)
    -> forall X2:term, auto___def_11 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_9_pknows_current. exact (rem_2540).
Defined.

Remark rem_2542 : (forall X:term, auto___def_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_9_pknows_current. intros X1 X2.
  cut (auto___def_11 X2 -> auto_knows_current X2). tauto. exact (rem_2541 epsilon_m__def_9_pknows_current X2).
Defined.

Remark rem_2543 : (forall X:term, auto___def_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_9_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2519 epsilon_m__def_9_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2542 epsilon_m__def_9_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2544 : (forall X:term, auto___def_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_10 X1 -> auto___def_11 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_9_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2543 epsilon_m__def_9_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_9_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_9_pknows_current A1 A2. tauto.
Defined.

Remark rem_2545 : (forall X:term, auto___def_9 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_9 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_9_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1396 X1 X2 H);  intros.
  apply (rem_2544 epsilon_m__def_9_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2546 : auto___def_9 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2547 : forall X1 X2:term, auto___def_9 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2548 : auto___def_9 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2549 : auto___def_9 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2550 : forall X1:term, auto___def_9 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2551 : auto___def_9 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2552 : auto___def_9 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2553 : auto___def_9 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2554 : auto___def_9 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2555 : auto___def_9 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2556 : forall X1 X2:term, auto___def_9 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2557 : forall X1 X2:term, auto___def_9 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2558 : forall X1 X2:term, auto___def_9 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2559 : forall X1 X2 X3:term, auto___def_9 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2560 : forall X1 X2:term, auto___def_9 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2561 : forall X1 X2 X3:term, auto___def_9 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2562 : forall X1 X2:term, auto___def_9 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2563 : forall X2:term, auto___def_9 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_9_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2546  H).
   intro H. elim (rem_2549  H).
  intros X1 X2;  exact (rem_2545 epsilon_m__def_9_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2560 X1 X2 H).
   intro H. elim (rem_2552  H).
  intros X1 X2. intro H. elim (rem_2556 X1 X2 H).
   intro H. elim (rem_2551  H).
  intros X1 X2. intro H. elim (rem_2558 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2547 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2562 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2557 X1 X2 H).
   intro H. elim (rem_2548  H).
   intro H. elim (rem_2553  H).
  intros X1. intro H. elim (rem_2550 X1 H).
   intro H. elim (rem_2554  H).
  intros X1 X2 X3. intro H. elim (rem_2559 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2561 X1 X2 X3 H).
   intro H. elim (rem_2555  H).
Qed.

Remark rem_2564 : (forall X:term, auto___def_7 X -> auto_knows_current X)
    -> forall X2:term, auto___def_9 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_7_pknows_current. exact (rem_2563).
Defined.

Remark rem_2565 : (forall X:term, auto___def_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 X1 -> auto___def_9 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_7_pknows_current. intros X1 X2.
  cut (auto___def_9 X2 -> auto_knows_current X2). tauto. exact (rem_2564 epsilon_m__def_7_pknows_current X2).
Defined.

Remark rem_2566 : (forall X:term, auto___def_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 X1 -> auto___def_9 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_7_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2513 epsilon_m__def_7_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2565 epsilon_m__def_7_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2567 : (forall X:term, auto___def_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_1 X1 -> auto___def_9 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_7_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_2566 epsilon_m__def_7_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_7_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_7_pknows_current A1 A2. tauto.
Defined.

Remark rem_2568 : (forall X:term, auto___def_7 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_7_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_1404 X1 X2 H);  intros.
  apply (rem_2567 epsilon_m__def_7_pknows_current X1 X2);  tauto.
Defined.

Remark rem_2569 : auto___def_7 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2570 : forall X1 X2:term, auto___def_7 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2571 : auto___def_7 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2572 : auto___def_7 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2573 : forall X1:term, auto___def_7 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2574 : auto___def_7 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2575 : auto___def_7 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2576 : auto___def_7 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2577 : auto___def_7 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2578 : auto___def_7 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2579 : forall X1 X2:term, auto___def_7 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2580 : forall X1 X2:term, auto___def_7 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2581 : forall X1 X2:term, auto___def_7 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2582 : forall X1 X2 X3:term, auto___def_7 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2583 : forall X1 X2:term, auto___def_7 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2584 : forall X1 X2 X3:term, auto___def_7 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2585 : forall X1 X2:term, auto___def_7 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2586 : forall X2:term, auto___def_7 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_7_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2569  H).
   intro H. elim (rem_2572  H).
  intros X1 X2;  exact (rem_2568 epsilon_m__def_7_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2583 X1 X2 H).
   intro H. elim (rem_2575  H).
  intros X1 X2. intro H. elim (rem_2579 X1 X2 H).
   intro H. elim (rem_2574  H).
  intros X1 X2. intro H. elim (rem_2581 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2570 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2585 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2580 X1 X2 H).
   intro H. elim (rem_2571  H).
   intro H. elim (rem_2576  H).
  intros X1. intro H. elim (rem_2573 X1 H).
   intro H. elim (rem_2577  H).
  intros X1 X2 X3. intro H. elim (rem_2582 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2584 X1 X2 X3 H).
   intro H. elim (rem_2578  H).
Qed.

Remark rem_2587 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 (key pub X1) -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_7 X2 -> auto_knows_current X2). tauto. exact (rem_2586 X2).
Qed.

Remark rem_2588 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 (key pub X1) -> (auto___type_10 X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_10 X1). 2:apply (rem_2511 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2587 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2589 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 (key pub X1) -> auto___def_51 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2588 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_51_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2590 : forall X1 X2:term, auto_knows_current (crypt X2 (key pub X1)) -> auto___def_51 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_1604 X2 (key pub X1) H);  intros.
  apply (rem_2302 X1 X2);  tauto.
  apply (rem_2491 X1 X2);  tauto.
  apply (rem_2495 X1 X2);  tauto.
  apply (rem_2497 X1 X2);  tauto.
  apply (rem_2501 X1 X2);  tauto.
  apply (rem_2504 X1 X2);  tauto.
  apply (rem_2508 X1 X2);  tauto.
  apply (rem_2510 X1 X2);  tauto.
  apply (rem_2589 X1 X2);  tauto.
Qed.

Remark rem_2591 : forall X1 X2 X3:term, auto___def_23 (s (nonceb_current X1 X2)) -> auto___def_24 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2286 (nonceb_current X1 X2) H);  intros.
Qed.

Remark rem_2592 : forall X1 X2 X3:term, auto___def_33 (s (nonceb_current X1 X2)) -> auto___def_34 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2475 (nonceb_current X1 X2) H);  intros.
Qed.

Remark rem_2593 : forall X1:term, auto___def_78 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2594 : forall X1 X2 X3:term, auto___def_78 (s (nonceb_current X1 X2)) -> auto___def_79 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2593 (nonceb_current X1 X2) H);  intros.
Qed.

Remark rem_2595 : forall X1 X2 X3:term, auto___type_15 X2 -> auto___type_19 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_2596 : forall X1 X2 X3:term, auto___type_15 X2 -> auto___type_19 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto___type_15 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X2 -> auto___type_15 X2). tauto. exact (rem_448 X2).
Qed.

Remark rem_2597 : forall X1 X2 X3:term, auto___type_15 X2 -> auto___type_19 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X2 -> auto_agent X2). tauto. exact (rem_477 X2).
Qed.

Remark rem_2598 : forall X3:term, auto___type_19 X3 -> auto___type_19 X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2599 : forall X1 X2 X3:term, auto___type_15 X2 -> auto___type_19 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto___type_19 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_19 X3 -> auto___type_19 X3). tauto. exact (rem_2598 X3).
Qed.

Remark rem_2600 : forall X1 X2 X3:term, auto___type_15 X2 -> auto___type_19 X3 -> auto_agent X2 -> auto_knows_current X1 -> (auto_knows_current X1 /\ auto___type_15 X2 /\ auto_agent X2 /\ auto___type_19 X3) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4.
  cut (auto_knows_current X1). 2:apply (rem_2595 X1 X2 X3);  assumption.
  cut (auto___type_15 X2). 2:apply (rem_2596 X1 X2 X3);  assumption.
  cut (auto_agent X2). 2:apply (rem_2597 X1 X2 X3);  assumption.
  cut (auto___type_19 X3). 2:apply (rem_2599 X1 X2 X3);  assumption.
  tauto.
Qed.

Remark rem_2601 : forall X1 X2 X3:term, auto___type_15 X2 -> auto___type_19 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto___def_90 X1 X2 X3. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4.
  case (rem_2600 X1 X2 X3 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_90_1;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_2602 : forall X1 X2 X3:term, auto_knows_current X1 -> auto___type_15 X2 -> auto_agent X2 -> auto___type_19 X3 -> auto___def_90 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___type_15 X2 -> auto___type_19 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto___def_90 X1 X2 X3). tauto. exact (rem_2601 X1 X2 X3).
Qed.

Remark rem_2603 : forall X1 X2:term, auto___def_87 (nonceb_current X1 X2) -> or_1
    (auto_knows_current X1 /\ auto___type_15 X2 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_2604 : forall X1 X2 X3:term, auto___def_87 (nonceb_current X1 X2) -> auto___type_19 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2603 X1 X2 H);  intros.
  apply (rem_2602 X1 X2 X3);  tauto.
Qed.

Remark rem_2605 : forall X1 X2:term, auto___def_89 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2606 : forall X1 X2 X3:term, auto___def_89 (nonceb_current X1 X2) -> auto___type_19 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2605 X1 X2 H);  intros.
Qed.

Remark rem_2607 : forall X1:term, auto___def_89 (s X1) -> or_2
    (auto___def_87 X1)    (auto___def_89 X1).
Proof.
  intros. inversion H.
  intros. apply or_2_intro_1; tauto.
  intros. apply or_2_intro_2; tauto.
Qed.

Remark rem_2608 : forall X1 X2 X3:term, auto___def_89 (s (nonceb_current X1 X2)) -> auto___type_19 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2607 (nonceb_current X1 X2) H);  intros.
  apply (rem_2604 X1 X2 X3);  tauto.
  apply (rem_2606 X1 X2 X3);  tauto.
Qed.

Remark rem_2609 : forall X1:term, auto___def_57 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2610 : forall X1 X2 X3:term, auto___def_57 (s (nonceb_current X1 X2)) -> auto___def_58 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2609 (nonceb_current X1 X2) H);  intros.
Qed.

Remark rem_2611 : forall X1:term, auto___def_68 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2612 : forall X1 X2 X3:term, auto___def_68 (s (nonceb_current X1 X2)) -> auto___def_69 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2611 (nonceb_current X1 X2) H);  intros.
Qed.

Remark rem_2613 : forall X1 X2 X3:term, auto_knows_current X3 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1611 X1 X2 H);  intros.
Qed.

Remark rem_2614 : forall X1 X2 X3:term, auto_knows_current (nonceb_current X1 X2) -> auto_knows_current X3 -> auto___def_90 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_knows_current X3 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_90 X1 X2 X3). tauto. exact (rem_2613 X1 X2 X3).
Qed.

Remark rem_2615 : forall X1 X2 X3:term, auto_knows_current X3 -> auto_knows_current (s (nonceb_current X1 X2)) -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1507 (nonceb_current X1 X2) H);  intros.
  apply (rem_2614 X1 X2 X3);  tauto.
Qed.

Remark rem_2616 : forall X1 X2 X3:term, auto_knows_current (s (nonceb_current X1 X2)) -> auto_knows_current X3 -> auto___def_90 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_knows_current X3 -> auto_knows_current (s (nonceb_current X1 X2)) -> auto___def_90 X1 X2 X3). tauto. exact (rem_2615 X1 X2 X3).
Qed.

Remark rem_2617 : forall X1:term, auto___def_87 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_2618 : forall X1 X2 X3:term, auto___def_87 (s (nonceb_current X1 X2)) -> auto___type_18 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2617 (nonceb_current X1 X2) H);  intros.
Qed.

Remark rem_2619 : forall X1 X2 X3:term, auto___def_7 (s (nonceb_current X1 X2)) -> auto___def_8 X3 -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_2573 (nonceb_current X1 X2) H);  intros.
Qed.

Remark rem_2620 : forall X1 X2 X3:term, auto_knows_current (crypt (s (nonceb_current X1 X2)) X3) -> auto___def_90 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1604 (s (nonceb_current X1 X2)) X3 H);  intros.
  apply (rem_2591 X1 X2 X3);  tauto.
  apply (rem_2592 X1 X2 X3);  tauto.
  apply (rem_2594 X1 X2 X3);  tauto.
  apply (rem_2608 X1 X2 X3);  tauto.
  apply (rem_2610 X1 X2 X3);  tauto.
  apply (rem_2612 X1 X2 X3);  tauto.
  apply (rem_2616 X1 X2 X3);  tauto.
  apply (rem_2618 X1 X2 X3);  tauto.
  apply (rem_2619 X1 X2 X3);  tauto.
Qed.

Remark rem_2621 : forall X1:term, auto___type_6 X1 -> auto___type_6 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2622 : forall X1 X2:term, auto___def_36 X2 -> auto___type_6 X1 -> auto___type_6 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_6 X1 -> auto___type_6 X1). tauto. exact (rem_2621 X1).
Qed.

Remark rem_2623 : forall X2:term, auto___def_36 X2 -> auto___def_36 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2624 : forall X1 X2:term, auto___def_36 X2 -> auto___type_6 X1 -> auto___def_36 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_36 X2 -> auto___def_36 X2). tauto. exact (rem_2623 X2).
Qed.

Remark rem_2625 : forall X1 X2:term, auto___def_36 X2 -> auto___type_6 X1 -> (auto___type_6 X1 /\ auto___def_36 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_6 X1). 2:apply (rem_2622 X1 X2);  assumption.
  cut (auto___def_36 X2). 2:apply (rem_2624 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2626 : forall X1 X2:term, auto___def_36 X2 -> auto___type_6 X1 -> auto___def_35 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2625 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_35_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2627 : auto___def_47 prv. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_47_prv_1;  tauto.
 tauto.
Qed.

Remark rem_2628 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_magent_p__type_13.  tauto.
Defined.

Remark rem_2629 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto___type_13 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_13.  case (rem_2628 epsilon_magent_p__type_13). clear  epsilon_magent_p__type_13. intros. apply trans___type_13_alice_1;  tauto.
 clear  epsilon_magent_p__type_13. tauto.
Defined.

Remark rem_2630 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto_agent alice -> auto___type_13 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_13. intro H. intros.
  elim (rem_488 H);  intros.
  apply (rem_2629 epsilon_magent_p__type_13);  tauto.
Defined.

Remark rem_2631 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto___type_13 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_13.  case (rem_2628 epsilon_magent_p__type_13). clear  epsilon_magent_p__type_13. intros. apply trans___type_13_bob_1;  tauto.
 clear  epsilon_magent_p__type_13. tauto.
Defined.

Remark rem_2632 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto_agent bob -> auto___type_13 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_13. intro H. intros.
  elim (rem_491 H);  intros.
  apply (rem_2631 epsilon_magent_p__type_13);  tauto.
Defined.

Remark rem_2633 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto___type_13 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_13.  case (rem_2628 epsilon_magent_p__type_13). clear  epsilon_magent_p__type_13. intros. apply trans___type_13_i_1;  tauto.
 clear  epsilon_magent_p__type_13. tauto.
Defined.

Remark rem_2634 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto_agent i -> auto___type_13 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_13. intro H. intros.
  elim (rem_494 H);  intros.
  apply (rem_2633 epsilon_magent_p__type_13);  tauto.
Defined.

Remark rem_2635 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto___type_13 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_magent_p__type_13.  case (rem_2628 epsilon_magent_p__type_13). clear  epsilon_magent_p__type_13. intros. apply trans___type_13_server_1;  tauto.
 clear  epsilon_magent_p__type_13. tauto.
Defined.

Remark rem_2636 : (forall X:term, auto_agent X -> auto___type_13 X)
    -> auto_agent server -> auto___type_13 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_magent_p__type_13. intro H. intros.
  elim (rem_497 H);  intros.
  apply (rem_2635 epsilon_magent_p__type_13);  tauto.
Defined.

Remark rem_2637 : forall X1:term, auto_agent X1 -> auto___type_13 X1. (* Induct. *)
Proof.
  fix epsilon_magent_p__type_13 1.
  intro X. case X.
  exact (rem_2630 epsilon_magent_p__type_13 ).
  exact (rem_2632 epsilon_magent_p__type_13 ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_2634 epsilon_magent_p__type_13 ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_2636 epsilon_magent_p__type_13 ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_2638 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_38 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_521 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_38_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2639 : forall X1 X2:term, auto___def_16 X2 -> auto___def_15 X1 -> auto___def_38 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_15 X1 -> auto___def_16 X2 -> auto___def_38 (cons X1 X2)). tauto. exact (rem_2638 X1 X2).
Qed.

Remark rem_2640 : forall X1 X2:term, auto___def_9 X2 -> auto___type_1 X1 -> auto___type_1 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_1 X1 -> auto___type_1 X1). tauto. exact (rem_1837 X1).
Qed.

Remark rem_2641 : forall X2:term, auto___def_9 X2 -> auto___def_9 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2642 : forall X1 X2:term, auto___def_9 X2 -> auto___type_1 X1 -> auto___def_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_9 X2 -> auto___def_9 X2). tauto. exact (rem_2641 X2).
Qed.

Remark rem_2643 : forall X1 X2:term, auto___def_9 X2 -> auto___type_1 X1 -> (auto___type_1 X1 /\ auto___def_9 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_1 X1). 2:apply (rem_2640 X1 X2);  assumption.
  cut (auto___def_9 X2). 2:apply (rem_2642 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2644 : forall X1 X2:term, auto___def_9 X2 -> auto___type_1 X1 -> auto___def_7 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2643 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_7_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2645 : forall X1:term, auto___type_17 X1 -> auto___type_17 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2646 : forall X1 X2:term, auto___def_83 X2 -> auto___type_17 X1 -> auto___type_17 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_17 X1 -> auto___type_17 X1). tauto. exact (rem_2645 X1).
Qed.

Remark rem_2647 : forall X2:term, auto___def_83 X2 -> auto___def_83 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2648 : forall X1 X2:term, auto___def_83 X2 -> auto___type_17 X1 -> auto___def_83 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_83 X2 -> auto___def_83 X2). tauto. exact (rem_2647 X2).
Qed.

Remark rem_2649 : forall X1 X2:term, auto___def_83 X2 -> auto___type_17 X1 -> (auto___type_17 X1 /\ auto___def_83 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_17 X1). 2:apply (rem_2646 X1 X2);  assumption.
  cut (auto___def_83 X2). 2:apply (rem_2648 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2650 : forall X1 X2:term, auto___def_83 X2 -> auto___type_17 X1 -> auto___def_84 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2649 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_84_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2651 : auto___def_11 nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_11_nil_1;  tauto.
 tauto.
Qed.

Remark rem_2652 : forall X1 X2:term, auto___def_21 X2 -> auto_knows_old X1 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_2653 : forall X2:term, auto___def_21 X2 -> auto___def_21 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2654 : forall X1 X2:term, auto___def_21 X2 -> auto_knows_old X1 -> auto___def_21 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_21 X2 -> auto___def_21 X2). tauto. exact (rem_2653 X2).
Qed.

Remark rem_2655 : forall X1 X2:term, auto___def_21 X2 -> auto_knows_old X1 -> (auto_knows_old X1 /\ auto___def_21 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_2652 X1 X2);  assumption.
  cut (auto___def_21 X2). 2:apply (rem_2654 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2656 : forall X1 X2:term, auto___def_21 X2 -> auto_knows_old X1 -> auto___def_20 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2655 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_20_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2657 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old (key pub X1) -> auto___type_10 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___type_10_1. Qed.

Remark rem_2658 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old (key pub X1) -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_323 X2).
Qed.

Remark rem_2659 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old (key pub X1) -> (auto___type_10 X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_10 X1). 2:apply (rem_2657 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_2658 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2660 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old (key pub X1) -> auto___def_1 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2659 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_1_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2661 : auto___def_29 pub -> False. (* Eliminate negative atom. *)
Proof.
  intro H. intros.
  elim (rem_826 H);  intros.
Qed.

Remark rem_2662 : forall X1 X2:term, auto___def_23 X2 -> auto___def_29 pub -> auto___def_39 X1 -> auto___def_1 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 pub -> False). tauto.
  exact (rem_2661).
Qed.

Remark rem_2663 : forall X1 X2:term, auto___def_29 pub -> auto___def_39 X1 -> auto___def_23 X2 -> auto___def_1 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X2 -> auto___def_29 pub -> auto___def_39 X1 -> auto___def_1 X1 X2). tauto. exact (rem_2662 X1 X2).
Qed.

Remark rem_2664 : forall X1 X2:term, auto___def_23 X2 -> auto___def_24 (key pub X1) -> auto___def_1 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_204 pub X1 H);  intros.
  apply (rem_2663 X1 X2);  tauto.
Qed.

Remark rem_2665 : forall X1 X2:term, auto___def_29 pub -> auto___def_33 X2 -> auto___def_37 X1 -> auto___def_1 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 pub -> False). tauto.
  exact (rem_2661).
Qed.

Remark rem_2666 : forall X1 X2:term, auto___def_29 pub -> auto___def_37 X1 -> auto___def_33 X2 -> auto___def_1 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 pub -> auto___def_33 X2 -> auto___def_37 X1 -> auto___def_1 X1 X2). tauto. exact (rem_2665 X1 X2).
Qed.

Remark rem_2667 : forall X1 X2:term, auto___def_33 X2 -> auto___def_34 (key pub X1) -> auto___def_1 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_313 pub X1 H);  intros.
  apply (rem_2666 X1 X2);  tauto.
Qed.

Remark rem_2668 : forall X1 X2:term, auto___def_29 pub -> auto___def_30 X1 -> auto___def_44 X2 -> auto___def_1 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 pub -> False). tauto.
  exact (rem_2661).
Qed.

Remark rem_2669 : forall X1 X2:term, auto___def_44 X2 -> auto___type_9 (key pub X1) -> auto___def_1 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_341 pub X1 H);  intros.
  apply (rem_2668 X1 X2);  tauto.
Qed.

Remark rem_2670 : forall X1 X2:term, auto___def_29 pub -> auto___def_30 X1 -> auto___def_42 X2 -> auto___def_1 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 pub -> False). tauto.
  exact (rem_2661).
Qed.

Remark rem_2671 : forall X1 X2:term, auto___def_42 X2 -> auto___type_8 (key pub X1) -> auto___def_1 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_344 pub X1 H);  intros.
  apply (rem_2670 X1 X2);  tauto.
Qed.

Remark rem_2672 : forall X1 X2:term, auto___def_12 pub -> auto___def_13 X1 -> auto___def_7 X2 -> auto___def_1 X1 X2. (* Split. *)
Proof.
  intros X1 X2.
  cut (auto___def_12 pub -> False). tauto.
  exact (rem_2499).
Qed.

Remark rem_2673 : forall X1 X2:term, auto___def_7 X2 -> auto___def_8 (key pub X1) -> auto___def_1 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1. intro H. intros.
  elim (rem_234 pub X1 H);  intros.
  apply (rem_2672 X1 X2);  tauto.
Qed.

Remark rem_2674 : forall X1 X2:term, auto_knows_old (crypt X2 (key pub X1)) -> auto___def_1 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_350 X2 (key pub X1) H);  intros.
  apply (rem_2660 X1 X2);  tauto.
  apply (rem_2664 X1 X2);  tauto.
  apply (rem_2667 X1 X2);  tauto.
  apply (rem_2669 X1 X2);  tauto.
  apply (rem_2671 X1 X2);  tauto.
  apply (rem_2673 X1 X2);  tauto.
Qed.

Remark rem_2675 : forall X1 X2 X3:term, auto_knows_old (crypt (s (nonceb_old X1 X2)) X3) -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1.
  tauto.
Qed.

Remark rem_2676 : forall X1 X2 X3:term, auto_knows_old (crypt (s (nonceb_old X1 X2)) X3) -> auto___def_45 X1 X2 X3. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1.
  case (rem_2675 X1 X2 X3 A1). clear  A1. intros. apply trans___def_45_1;  tauto.
 clear  A1. tauto.
Qed.

Remark rem_2677 : auto___def_21 nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_21_nil_1;  tauto.
 tauto.
Qed.

Remark rem_2678 : auto___def_66 nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_66_nil_1;  tauto.
 tauto.
Qed.

Remark rem_2679 : forall X1:term, auto___def_60 X1 -> auto___def_60 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2680 : forall X1 X2:term, auto___def_60 X1 -> auto___def_61 X2 -> auto___def_60 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_60 X1 -> auto___def_60 X1). tauto. exact (rem_2679 X1).
Qed.

Remark rem_2681 : forall X2:term, auto___def_61 X2 -> auto___def_61 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2682 : forall X1 X2:term, auto___def_60 X1 -> auto___def_61 X2 -> auto___def_61 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_61 X2 -> auto___def_61 X2). tauto. exact (rem_2681 X2).
Qed.

Remark rem_2683 : forall X1 X2:term, auto___def_60 X1 -> auto___def_61 X2 -> (auto___def_60 X1 /\ auto___def_61 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_60 X1). 2:apply (rem_2680 X1 X2);  assumption.
  cut (auto___def_61 X2). 2:apply (rem_2682 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2684 : forall X1 X2:term, auto___def_60 X1 -> auto___def_61 X2 -> auto___def_59 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2683 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_59_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2685 : forall X1 X2:term, auto___def_61 X2 -> auto___def_60 X1 -> auto___def_59 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_60 X1 -> auto___def_61 X2 -> auto___def_59 (cons X1 X2)). tauto. exact (rem_2684 X1 X2).
Qed.

Remark rem_2686 : forall X1:term, auto___type_10 X1. (* Subsumed by universal clause. *)
Proof. intros. apply trans___type_10_1. Qed.

Remark rem_2687 : forall X1 X2:term, auto___def_83 X2 -> auto___type_15 X1 -> auto___type_15 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_15 X1 -> auto___type_15 X1). tauto. exact (rem_2039 X1).
Qed.

Remark rem_2688 : forall X1 X2:term, auto___def_83 X2 -> auto___type_15 X1 -> auto___def_83 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_83 X2 -> auto___def_83 X2). tauto. exact (rem_2647 X2).
Qed.

Remark rem_2689 : forall X1 X2:term, auto___def_83 X2 -> auto___type_15 X1 -> (auto___type_15 X1 /\ auto___def_83 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_15 X1). 2:apply (rem_2687 X1 X2);  assumption.
  cut (auto___def_83 X2). 2:apply (rem_2688 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2690 : forall X1 X2:term, auto___def_83 X2 -> auto___type_15 X1 -> auto___def_82 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2689 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_82_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2691 : forall X1 X2:term, auto_agent X2 -> auto_knows_old X1 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_2692 : forall X1 X2:term, auto_agent X2 -> auto_knows_old X1 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_2693 : forall X1 X2:term, auto_agent X2 -> auto_knows_old X1 -> (auto_knows_old X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_2691 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_2692 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2694 : forall X1 X2:term, auto_agent X2 -> auto_knows_old X1 -> auto___def_10 (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2693 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_10_nonceb_old_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2695 : forall X1 X2:term, auto___def_66 X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_2696 : forall X2:term, auto___def_66 X2 -> auto___def_66 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2697 : forall X1 X2:term, auto___def_66 X2 -> auto_knows_current X1 -> auto___def_66 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_66 X2 -> auto___def_66 X2). tauto. exact (rem_2696 X2).
Qed.

Remark rem_2698 : forall X1 X2:term, auto___def_66 X2 -> auto_knows_current X1 -> (auto_knows_current X1 /\ auto___def_66 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2695 X1 X2);  assumption.
  cut (auto___def_66 X2). 2:apply (rem_2697 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2699 : forall X1 X2:term, auto___def_66 X2 -> auto_knows_current X1 -> auto___def_65 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2698 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_65_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2700 : forall X1 X2 X3 X4:term, auto___def_48 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1217 X2 (cons server nil) H);  intros.
Qed.

Remark rem_2701 : forall X1 X2 X3 X4:term, auto___def_47 sym -> auto___def_48 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_48 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto.
  exact (rem_2700 X1 X2 X3 X4).
Qed.

Remark rem_2702 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_2703 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto___type_10 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2 X3 X4. intros. apply (rem_2702 X1 X2 X3 X4);  assumption.
Qed.

Remark rem_2704 : forall X1 X2 X3 X4:term, auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3 H4. intro H. intros.
  elim (rem_330 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_2701 X1 X2 X3 X4);  tauto.
  apply (rem_2703 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2705 : forall X1 X2 X3 X4:term, auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old nil -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4). tauto.
  exact (rem_2704 X1 X2 X3 X4).
Qed.

Remark rem_2706 : forall X1 X2 X3 X4:term, auto_knows_old X3 -> auto_knows_old nil -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old nil -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2705 X1 X2 X3 X4).
Qed.

Remark rem_2707 : forall X1 X2 X3 X4:term, auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X3 nil) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_383 X3 nil H);  intros.
  apply (rem_2706 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2708 : forall X1 X2 X3 X4:term, auto_knows_old X1 -> auto_knows_old (cons X3 nil) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X3 nil) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2707 X1 X2 X3 X4).
Qed.

Remark rem_2709 : forall X1 X2 X3 X4:term, auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X1 (cons X3 nil)) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_383 X1 (cons X3 nil) H);  intros.
  apply (rem_2708 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2710 : forall X1 X2 X3 X4:term, auto_knows_old (cons X1 (cons X3 nil)) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X1 (cons X3 nil)) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2709 X1 X2 X3 X4).
Qed.

Remark rem_2711 : forall X1 X2 X3 X4:term, auto___def_26 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto___type_5 X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_26 nil -> False). tauto.
  exact (rem_1645).
Qed.

Remark rem_2712 : forall X1 X2 X3 X4:term, auto___type_5 X3 -> auto___def_26 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_26 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto___type_5 X3 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2711 X1 X2 X3 X4).
Qed.

Remark rem_2713 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1380 X3 nil H);  intros.
  apply (rem_2712 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2714 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 nil) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto.
  exact (rem_2713 X1 X2 X3 X4).
Qed.

Remark rem_2715 : forall X1 X2 X3 X4:term, auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___def_25 (cons X3 nil) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 nil) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2714 X1 X2 X3 X4).
Qed.

Remark rem_2716 : forall X1 X2 X3 X4:term, auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons X3 nil) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_204 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_2715 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2717 : forall X1 X2 X3 X4:term, auto___type_4 X1 -> auto___def_25 (cons X3 nil) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons X3 nil) -> auto___type_4 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2716 X1 X2 X3 X4).
Qed.

Remark rem_2718 : forall X1 X2 X3 X4:term, auto___def_23 (cons X1 (cons X3 nil)) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1386 X1 (cons X3 nil) H);  intros.
  apply (rem_2717 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2719 : forall X1 X2 X3 X4:term, auto___def_27 X1 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons X3 nil) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2 X3 X4. intros.
  assert (HH:=(rem_1075 X1)). tauto.
Qed.

Remark rem_2720 : forall X1 X2 X3 X4:term, auto___def_27 X1 -> auto___def_35 (cons X3 nil) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X1 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons X3 nil) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2719 X1 X2 X3 X4).
Qed.

Remark rem_2721 : forall X1 X2 X3 X4:term, auto___def_33 (cons X1 (cons X3 nil)) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1390 X1 (cons X3 nil) H);  intros.
  apply (rem_2720 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2722 : forall X1 X2 X3 X4:term, auto___def_44 (cons X1 (cons X3 nil)) -> auto___type_9 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_803 X1 (cons X3 nil) H);  intros.
Qed.

Remark rem_2723 : forall X1 X2 X3 X4:term, auto___def_42 (cons X1 (cons X3 nil)) -> auto___type_8 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_778 X1 (cons X3 nil) H);  intros.
Qed.

Remark rem_2724 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old.  tauto.
Defined.

Remark rem_2725 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto_knows_old alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old.  case (rem_2724 epsilon_m__type_1_pknows_old). clear  epsilon_m__type_1_pknows_old. intros. apply trans_knows_old_alice_1;  tauto.
 clear  epsilon_m__type_1_pknows_old. tauto.
Defined.

Remark rem_2726 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto___type_1 alice -> auto_knows_old alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intro H. intros.
  elim (rem_707 H);  intros.
  apply (rem_2725 epsilon_m__type_1_pknows_old);  tauto.
Defined.

Remark rem_2727 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2728 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_2727 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2729 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2730 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_2729 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2731 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_2728 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_2730 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2732 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_old (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2731 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_noncea_old_1;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2733 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_1 (noncea_old X1 X2) -> auto_knows_old (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_711 X1 X2 H);  intros.
  apply (rem_2732 epsilon_m__type_1_pknows_old X1 X2);  tauto.
Defined.

Remark rem_2734 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto_knows_old bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old.  case (rem_2724 epsilon_m__type_1_pknows_old). clear  epsilon_m__type_1_pknows_old. intros. apply trans_knows_old_bob_1;  tauto.
 clear  epsilon_m__type_1_pknows_old. tauto.
Defined.

Remark rem_2735 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto___type_1 bob -> auto_knows_old bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intro H. intros.
  elim (rem_714 H);  intros.
  apply (rem_2734 epsilon_m__type_1_pknows_old);  tauto.
Defined.

Remark rem_2736 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2737 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1. intros A1.
  cut (auto_knows_old X1). 2:apply (rem_2736 epsilon_m__type_1_pknows_old X1);  assumption.
  tauto.
Defined.

Remark rem_2738 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1. intros A1.
  case (rem_2737 epsilon_m__type_1_pknows_old X1 A1). clear  epsilon_m__type_1_pknows_old A1. intros. apply trans_knows_old_s_1;  tauto.
 clear  epsilon_m__type_1_pknows_old A1. tauto.
Defined.

Remark rem_2739 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___type_1 (s X1) -> auto_knows_old (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1. intro H. intros.
  elim (rem_930 X1 H);  intros.
  apply (rem_2738 epsilon_m__type_1_pknows_old X1);  tauto.
Defined.

Remark rem_2740 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto_knows_old nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old.  case (rem_2724 epsilon_m__type_1_pknows_old). clear  epsilon_m__type_1_pknows_old. intros. apply trans_knows_old_nil_1;  tauto.
 clear  epsilon_m__type_1_pknows_old. tauto.
Defined.

Remark rem_2741 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto___type_1 nil -> auto_knows_old nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intro H. intros.
  elim (rem_933 H);  intros.
  apply (rem_2740 epsilon_m__type_1_pknows_old);  tauto.
Defined.

Remark rem_2742 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto_knows_old i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old.  case (rem_2724 epsilon_m__type_1_pknows_old). clear  epsilon_m__type_1_pknows_old. intros. apply trans_knows_old_i_1;  tauto.
 clear  epsilon_m__type_1_pknows_old. tauto.
Defined.

Remark rem_2743 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto___type_1 i -> auto_knows_old i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intro H. intros.
  elim (rem_936 H);  intros.
  apply (rem_2742 epsilon_m__type_1_pknows_old);  tauto.
Defined.

Remark rem_2744 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_2736 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2745 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_old X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2746 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_2745 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2747 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_2744 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_2746 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2748 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2747 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_cons_1;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2749 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_1 (cons X1 X2) -> auto_knows_old (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_944 X1 X2 H);  intros.
  apply (rem_2748 epsilon_m__type_1_pknows_old X1 X2);  tauto.
Defined.

Remark rem_2750 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto_knows_old server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old.  case (rem_2724 epsilon_m__type_1_pknows_old). clear  epsilon_m__type_1_pknows_old. intros. apply trans_knows_old_server_1;  tauto.
 clear  epsilon_m__type_1_pknows_old. tauto.
Defined.

Remark rem_2751 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> auto___type_1 server -> auto_knows_old server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intro H. intros.
  elim (rem_947 H);  intros.
  apply (rem_2750 epsilon_m__type_1_pknows_old);  tauto.
Defined.

Remark rem_2752 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2753 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_2752 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2754 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2755 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_2754 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2756 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_2753 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_2755 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2757 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_old (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2756 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_key_1;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2758 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2759 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_2758 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2760 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2761 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_2760 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2762 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_2759 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_2761 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2763 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_old (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2762 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_key_2;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2764 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_1 (key X1 X2) -> auto_knows_old (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_961 X1 X2 H);  intros.
  apply (rem_2757 epsilon_m__type_1_pknows_old X1 X2);  tauto.
  apply (rem_2763 epsilon_m__type_1_pknows_old X1 X2);  tauto.
Defined.

Remark rem_2765 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2747 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_crypt_1;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2766 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2767 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_2766 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2768 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2769 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_2768 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2770 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_2767 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_2769 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2771 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2770 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_crypt_2;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2772 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2773 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_2772 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2774 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2775 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_2774 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2776 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_2773 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_2775 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2777 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2776 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_crypt_3;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2778 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___def_44 X1 -> auto___def_44 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2779 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_2778 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2780 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto___type_9 X2 -> auto___type_9 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2781 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___type_9 X2 -> auto___type_9 X2). tauto. exact (rem_2780 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2782 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto___def_44 X1 /\ auto___type_9 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_44 X1). 2:apply (rem_2779 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_2781 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2783 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2782 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_crypt_4;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2784 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___def_42 X1 -> auto___def_42 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2785 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_2784 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2786 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto___type_8 X2 -> auto___type_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2787 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___type_8 X2 -> auto___type_8 X2). tauto. exact (rem_2786 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2788 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto___def_42 X1 /\ auto___type_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_42 X1). 2:apply (rem_2785 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto___type_8 X2). 2:apply (rem_2787 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2789 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2788 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_crypt_5;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2790 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2791 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_2790 epsilon_m__type_1_pknows_old X1).
Defined.

Remark rem_2792 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2793 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_2792 epsilon_m__type_1_pknows_old X2).
Defined.

Remark rem_2794 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_2791 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_2793 epsilon_m__type_1_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2795 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_2794 epsilon_m__type_1_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_1_pknows_old A1 A2. intros. apply trans_knows_old_crypt_6;  tauto.
 clear  epsilon_m__type_1_pknows_old A1 A2. tauto.
Defined.

Remark rem_2796 : (forall X:term, auto___type_1 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_1 (crypt X1 X2) -> auto_knows_old (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_994 X1 X2 H);  intros.
  apply (rem_2765 epsilon_m__type_1_pknows_old X1 X2);  tauto.
  apply (rem_2771 epsilon_m__type_1_pknows_old X1 X2);  tauto.
  apply (rem_2777 epsilon_m__type_1_pknows_old X1 X2);  tauto.
  apply (rem_2783 epsilon_m__type_1_pknows_old X1 X2);  tauto.
  apply (rem_2789 epsilon_m__type_1_pknows_old X1 X2);  tauto.
  apply (rem_2795 epsilon_m__type_1_pknows_old X1 X2);  tauto.
Defined.

Remark rem_2797 : forall X1:term, auto___type_1 X1 -> auto_knows_old X1. (* Induct. *)
Proof.
  fix epsilon_m__type_1_pknows_old 1.
  intro X. case X.
  exact (rem_2726 epsilon_m__type_1_pknows_old ).
  exact (rem_2735 epsilon_m__type_1_pknows_old ).
  intros X1 X2;  exact (rem_2749 epsilon_m__type_1_pknows_old X1 X2).
  intros X1 X2;  exact (rem_2796 epsilon_m__type_1_pknows_old X1 X2).
  exact (rem_2743 epsilon_m__type_1_pknows_old ).
  intros X1 X2;  exact (rem_2764 epsilon_m__type_1_pknows_old X1 X2).
  exact (rem_2741 epsilon_m__type_1_pknows_old ).
  intros X1 X2. intro H. elim (rem_1000 X1 X2 H).
  intros X1 X2;  exact (rem_2733 epsilon_m__type_1_pknows_old X1 X2).
  intros X1 X2. intro H. elim (rem_1003 X1 X2 H).
  intros X1 X2. intro H. elim (rem_999 X1 X2 H).
   intro H. elim (rem_996  H).
   intro H. elim (rem_997  H).
  intros X1;  exact (rem_2739 epsilon_m__type_1_pknows_old X1).
  exact (rem_2751 epsilon_m__type_1_pknows_old ).
  intros X1 X2 X3. intro H. elim (rem_1001 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1002 X1 X2 X3 H).
   intro H. elim (rem_998  H).
Qed.

Remark rem_2798 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_1 X1 -> auto_knows_old X1). tauto. exact (rem_2797 X1).
Qed.

Remark rem_2799 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_2800 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X2 -> auto_knows_old X2). tauto. exact (rem_697 X2).
Qed.

Remark rem_2801 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_10 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_10 X3 -> auto___def_10 X3). tauto. exact (rem_1842 X3).
Qed.

Remark rem_2802 : forall X4:term, auto_knows_old X4 -> auto_knows_old X4. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2803 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X4. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X4 -> auto_knows_old X4). tauto. exact (rem_2802 X4).
Qed.

Remark rem_2804 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_agent X2 /\ auto_knows_old X2 /\ auto___def_10 X3 /\ auto_knows_old X4) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6 A7.
  cut (auto_knows_old X1). 2:apply (rem_2798 X1 X2 X3 X4);  assumption.
  cut (auto_agent X2). 2:apply (rem_2799 X1 X2 X3 X4);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_2800 X1 X2 X3 X4);  assumption.
  cut (auto___def_10 X3). 2:apply (rem_2801 X1 X2 X3 X4);  assumption.
  cut (auto_knows_old X4). 2:apply (rem_2803 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_2805 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 nil -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6 A7.
  case (rem_2804 X1 X2 X3 X4 A1 A2 A3 A4 A5 A6 A7). clear  A1 A2 A3 A4 A5 A6 A7. intros. apply trans___def_22_1;  tauto.
 clear  A1 A2 A3 A4 A5 A6 A7. tauto.
Qed.

Remark rem_2806 : forall X1 X2 X3 X4:term, auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1396 X3 nil H);  intros.
  apply (rem_2805 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2807 : forall X1 X2 X3 X4:term, auto___def_14 (cons server nil) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto.
  exact (rem_2806 X1 X2 X3 X4).
Qed.

Remark rem_2808 : forall X1 X2 X3 X4:term, auto_agent X2 -> auto___def_14 (cons server nil) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_14 (cons server nil) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_agent X2 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2807 X1 X2 X3 X4).
Qed.

Remark rem_2809 : forall X1 X2 X3 X4:term, auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_211 X2 (cons server nil) H);  intros.
  apply (rem_2808 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2810 : forall X1 X2 X3 X4:term, auto___def_12 sym -> auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto.
  exact (rem_2809 X1 X2 X3 X4).
Qed.

Remark rem_2811 : forall X1 X2 X3 X4:term, auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_234 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_2810 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2812 : forall X1 X2 X3 X4:term, auto___type_1 X1 -> auto___def_9 (cons X3 nil) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons X3 nil) -> auto___type_1 X1 -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2811 X1 X2 X3 X4).
Qed.

Remark rem_2813 : forall X1 X2 X3 X4:term, auto___def_7 (cons X1 (cons X3 nil)) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1404 X1 (cons X3 nil) H);  intros.
  apply (rem_2812 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2814 : forall X1 X2 X3 X4:term, auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_350 (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil))) H);  intros.
  apply (rem_2710 X1 X2 X3 X4);  tauto.
  apply (rem_2718 X1 X2 X3 X4);  tauto.
  apply (rem_2721 X1 X2 X3 X4);  tauto.
  apply (rem_2722 X1 X2 X3 X4);  tauto.
  apply (rem_2723 X1 X2 X3 X4);  tauto.
  apply (rem_2813 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2815 : forall X1 X2 X3 X4:term, auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto_knows_old nil -> auto___def_22 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto___def_22 X1 X2 X3 X4). tauto.
  exact (rem_2814 X1 X2 X3 X4).
Qed.

Remark rem_2816 : forall X1 X2 X3 X4:term, auto_knows_old (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto_knows_old nil -> auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) -> auto_knows_old nil -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2815 X1 X2 X3 X4).
Qed.

Remark rem_2817 : forall X1 X2 X3 X4:term, auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_383 (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil H);  intros.
  apply (rem_2816 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2818 : forall X1 X2 X3 X4:term, auto_knows_old X4 -> auto_knows_old (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) -> auto_knows_old X1 -> auto_knows_old X2 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X4 -> auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2817 X1 X2 X3 X4).
Qed.

Remark rem_2819 : forall X1 X2 X3 X4:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_383 X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil) H);  intros.
  apply (rem_2818 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2820 : forall X1 X2 X3 X4:term, auto_knows_old X2 -> auto_knows_old (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) -> auto_knows_old X1 -> auto___def_22 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) -> auto___def_22 X1 X2 X3 X4). tauto. exact (rem_2819 X1 X2 X3 X4).
Qed.

Remark rem_2821 : forall X1 X2 X3 X4:term, auto_knows_old X1 -> auto_knows_old (cons X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil))) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_383 X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)) H);  intros.
  apply (rem_2820 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2822 : forall X1 X2 X3 X4:term, auto_knows_old (cons X1 (cons X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil)))) -> auto___def_22 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_383 X1 (cons X2 (cons X4 (cons (crypt (cons X1 (cons X3 nil)) (key sym (cons X2 (cons server nil)))) nil))) H);  intros.
  apply (rem_2821 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2823 : auto___def_12 sym. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_12_sym_1;  tauto.
 tauto.
Qed.

Remark rem_2824 : (forall X:term, auto___def_10 X -> auto___type_6 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2825 : (forall X:term, auto___def_10 X -> auto___type_6 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_10_p__type_6. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_2824 epsilon_m__def_10_p__type_6 X1).
Defined.

Remark rem_2826 : (forall X:term, auto___def_10 X -> auto___type_6 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2827 : (forall X:term, auto___def_10 X -> auto___type_6 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_10_p__type_6. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_2826 epsilon_m__def_10_p__type_6 X2).
Defined.

Remark rem_2828 : (forall X:term, auto___def_10 X -> auto___type_6 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> (auto_knows_old X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_10_p__type_6. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_2825 epsilon_m__def_10_p__type_6 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_2827 epsilon_m__def_10_p__type_6 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2829 : (forall X:term, auto___def_10 X -> auto___type_6 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_agent X2 -> auto___type_6 (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_10_p__type_6. intros X1 X2. intros A1 A2.
  case (rem_2828 epsilon_m__def_10_p__type_6 X1 X2 A1 A2). clear  epsilon_m__def_10_p__type_6 A1 A2. intros. apply trans___type_6_nonceb_old_1;  tauto.
 clear  epsilon_m__def_10_p__type_6 A1 A2. tauto.
Defined.

Remark rem_2830 : (forall X:term, auto___def_10 X -> auto___type_6 X)
    -> forall X1 X2:term, auto___def_10 (nonceb_old X1 X2) -> auto___type_6 (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_10_p__type_6. intros X1 X2. intro H. intros.
  elim (rem_1443 X1 X2 H);  intros.
  apply (rem_2829 epsilon_m__def_10_p__type_6 X1 X2);  tauto.
Defined.

Remark rem_2831 : forall X1:term, auto___def_10 X1 -> auto___type_6 X1. (* Induct. *)
Proof.
  fix epsilon_m__def_10_p__type_6 1.
  intro X. case X.
   intro H. elim (rem_1445  H).
   intro H. elim (rem_1448  H).
  intros X1 X2. intro H. elim (rem_1453 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1459 X1 X2 H).
   intro H. elim (rem_1451  H).
  intros X1 X2. intro H. elim (rem_1456 X1 X2 H).
   intro H. elim (rem_1450  H).
  intros X1 X2. intro H. elim (rem_1457 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1446 X1 X2 H).
  intros X1 X2. intro H. elim (rem_1461 X1 X2 H).
  intros X1 X2;  exact (rem_2830 epsilon_m__def_10_p__type_6 X1 X2).
   intro H. elim (rem_1447  H).
   intro H. elim (rem_1452  H).
  intros X1. intro H. elim (rem_1449 X1 H).
   intro H. elim (rem_1454  H).
  intros X1 X2 X3. intro H. elim (rem_1458 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1460 X1 X2 X3 H).
   intro H. elim (rem_1455  H).
Qed.

Remark rem_2832 : forall X1 X2 X3 X4:term, auto___def_10 X1 -> auto_agent X2 -> auto_knows_old X2 -> auto_knows_old X3 -> auto_knows_old X4 -> auto___type_6 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_10 X1 -> auto___type_6 X1). tauto. exact (rem_2831 X1).
Qed.

Remark rem_2833 : forall X1 X2 X3 X4:term, auto_knows_old X2 -> auto_agent X3 -> auto_knows_old X3 -> auto___def_10 X1 -> auto_knows_old X4 -> auto___type_6 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X2 X3.
  cut (auto___def_10 X1 -> auto_agent X2 -> auto_knows_old X2 -> auto_knows_old X3 -> auto_knows_old X4 -> auto___type_6 X1). tauto. exact (rem_2832 X1 X2 X3 X4).
Qed.

Remark rem_2834 : forall X1 X2 X3 X4:term, auto___def_22 X2 X3 X1 X4 -> auto___type_6 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_444 X2 X3 X1 X4 H);  intros.
  apply (rem_2833 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_2835 : auto___def_49 sym. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_49_sym_1;  tauto.
 tauto.
Qed.

Remark rem_2836 : forall X1:term, auto___type_13 X1 -> auto___type_13 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2837 : forall X1 X2:term, auto___def_63 X2 -> auto___type_13 X1 -> auto___type_13 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_13 X1 -> auto___type_13 X1). tauto. exact (rem_2836 X1).
Qed.

Remark rem_2838 : forall X2:term, auto___def_63 X2 -> auto___def_63 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2839 : forall X1 X2:term, auto___def_63 X2 -> auto___type_13 X1 -> auto___def_63 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_63 X2 -> auto___def_63 X2). tauto. exact (rem_2838 X2).
Qed.

Remark rem_2840 : forall X1 X2:term, auto___def_63 X2 -> auto___type_13 X1 -> (auto___type_13 X1 /\ auto___def_63 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_13 X1). 2:apply (rem_2837 X1 X2);  assumption.
  cut (auto___def_63 X2). 2:apply (rem_2839 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2841 : forall X1 X2:term, auto___def_63 X2 -> auto___type_13 X1 -> auto___def_62 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2840 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_62_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2842 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11.  tauto.
Defined.

Remark rem_2843 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto___type_11 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11.  case (rem_2842 epsilon_mknows_current_p__type_11). clear  epsilon_mknows_current_p__type_11. intros. apply trans___type_11_alice_1;  tauto.
 clear  epsilon_mknows_current_p__type_11. tauto.
Defined.

Remark rem_2844 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto_knows_current alice -> auto___type_11 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intro H. intros.
  elim (rem_1496 H);  intros.
  apply (rem_2843 epsilon_mknows_current_p__type_11);  tauto.
Defined.

Remark rem_2845 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___type_11 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.  case (rem_2842 epsilon_mknows_current_p__type_11). clear  epsilon_mknows_current_p__type_11. intros. apply trans___type_11_noncea_old_1;  tauto.
 clear  epsilon_mknows_current_p__type_11. tauto.
Defined.

Remark rem_2846 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current (noncea_old X1 X2) -> auto___type_11 (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intro H. intros.
  elim (rem_1499 X1 X2 H);  intros.
  apply (rem_2845 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
Defined.

Remark rem_2847 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto___type_11 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11.  case (rem_2842 epsilon_mknows_current_p__type_11). clear  epsilon_mknows_current_p__type_11. intros. apply trans___type_11_bob_1;  tauto.
 clear  epsilon_mknows_current_p__type_11. tauto.
Defined.

Remark rem_2848 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto_knows_current bob -> auto___type_11 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intro H. intros.
  elim (rem_1502 H);  intros.
  apply (rem_2847 epsilon_mknows_current_p__type_11);  tauto.
Defined.

Remark rem_2849 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2850 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_2849 epsilon_mknows_current_p__type_11 X1);  assumption.
  tauto.
Defined.

Remark rem_2851 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto_knows_current X1 -> auto___type_11 (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1. intros A1.
  case (rem_2850 epsilon_mknows_current_p__type_11 X1 A1). clear  epsilon_mknows_current_p__type_11 A1. intros. apply trans___type_11_s_1;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1. tauto.
Defined.

Remark rem_2852 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto_knows_current (s X1) -> auto___type_11 (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1. intro H. intros.
  elim (rem_1507 X1 H);  intros.
  apply (rem_2851 epsilon_mknows_current_p__type_11 X1);  tauto.
Defined.

Remark rem_2853 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto___type_11 nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11.  case (rem_2842 epsilon_mknows_current_p__type_11). clear  epsilon_mknows_current_p__type_11. intros. apply trans___type_11_nil_1;  tauto.
 clear  epsilon_mknows_current_p__type_11. tauto.
Defined.

Remark rem_2854 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto_knows_current nil -> auto___type_11 nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intro H. intros.
  elim (rem_1510 H);  intros.
  apply (rem_2853 epsilon_mknows_current_p__type_11);  tauto.
Defined.

Remark rem_2855 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto___type_11 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11.  case (rem_2842 epsilon_mknows_current_p__type_11). clear  epsilon_mknows_current_p__type_11. intros. apply trans___type_11_i_1;  tauto.
 clear  epsilon_mknows_current_p__type_11. tauto.
Defined.

Remark rem_2856 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto_knows_current i -> auto___type_11 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intro H. intros.
  elim (rem_1513 H);  intros.
  apply (rem_2855 epsilon_mknows_current_p__type_11);  tauto.
Defined.

Remark rem_2857 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_2849 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2858 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto_knows_current X2 -> auto_knows_current X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2859 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_2858 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2860 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_2857 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_2859 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2861 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_11 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2860 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_cons_1;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2862 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current (cons X1 X2) -> auto___type_11 (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intro H. intros.
  elim (rem_1520 X1 X2 H);  intros.
  apply (rem_2861 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
Defined.

Remark rem_2863 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto___type_11 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11.  case (rem_2842 epsilon_mknows_current_p__type_11). clear  epsilon_mknows_current_p__type_11. intros. apply trans___type_11_server_1;  tauto.
 clear  epsilon_mknows_current_p__type_11. tauto.
Defined.

Remark rem_2864 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> auto_knows_current server -> auto___type_11 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intro H. intros.
  elim (rem_1523 H);  intros.
  apply (rem_2863 epsilon_mknows_current_p__type_11);  tauto.
Defined.

Remark rem_2865 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_49 X1 -> auto___def_49 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2866 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_49 X1 -> auto___def_49 X1). tauto. exact (rem_2865 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2867 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_50 X2 -> auto___def_50 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2868 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_50 X2). tauto. exact (rem_2867 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2869 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_2866 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_2868 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2870 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___type_11 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2869 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_key_1;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2871 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2872 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_2871 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2873 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2874 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_2873 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2875 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_2872 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_2874 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2876 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_11 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2875 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_key_2;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2877 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2878 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_2877 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2879 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2880 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_2879 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2881 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_2878 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_2880 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2882 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_11 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2881 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_key_3;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2883 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current (key X1 X2) -> auto___type_11 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intro H. intros.
  elim (rem_99 X1 X2 H);  intros.
  apply (rem_2870 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2876 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2882 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
Defined.

Remark rem_2884 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___type_11 (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.  case (rem_2842 epsilon_mknows_current_p__type_11). clear  epsilon_mknows_current_p__type_11. intros. apply trans___type_11_nonceb_old_1;  tauto.
 clear  epsilon_mknows_current_p__type_11. tauto.
Defined.

Remark rem_2885 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current (nonceb_old X1 X2) -> auto___type_11 (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intro H. intros.
  elim (rem_1545 X1 X2 H);  intros.
  apply (rem_2884 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
Defined.

Remark rem_2886 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2887 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_2886 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2888 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2889 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_2888 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2890 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_2887 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_2889 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2891 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_11 (noncea_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2890 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_noncea_current_1;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2892 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current (noncea_current X1 X2) -> auto___type_11 (noncea_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intro H. intros.
  elim (rem_1553 X1 X2 H);  intros.
  apply (rem_2891 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
Defined.

Remark rem_2893 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2894 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_2893 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2895 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2896 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_2895 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2897 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_2894 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_2896 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2898 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2897 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_1;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2899 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2900 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_2899 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2901 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2902 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_2901 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2903 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_2900 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_2902 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2904 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2903 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_2;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2905 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_78 X1 -> auto___def_78 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2906 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_2905 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2907 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_79 X2 -> auto___def_79 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2908 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_2907 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2909 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> (auto___def_78 X1 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_78 X1). 2:apply (rem_2906 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_2908 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2910 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2909 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_3;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2911 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_89 X1 -> auto___def_89 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2912 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_2911 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2913 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___type_19 X2 -> auto___type_19 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2914 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___type_19 X2 -> auto___type_19 X2). tauto. exact (rem_2913 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2915 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> (auto___def_89 X1 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_89 X1). 2:apply (rem_2912 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_2914 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2916 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2915 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_4;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2917 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_57 X1 -> auto___def_57 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2918 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_2917 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2919 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_58 X2 -> auto___def_58 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2920 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_58 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_58 X2 -> auto___def_58 X2). tauto. exact (rem_2919 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2921 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> (auto___def_57 X1 /\ auto___def_58 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_57 X1). 2:apply (rem_2918 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_58 X2). 2:apply (rem_2920 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2922 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2921 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_5;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2923 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_68 X1 -> auto___def_68 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2924 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_2923 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2925 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_69 X2 -> auto___def_69 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2926 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_69 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_69 X2 -> auto___def_69 X2). tauto. exact (rem_2925 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2927 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> (auto___def_68 X1 /\ auto___def_69 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_68 X1). 2:apply (rem_2924 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_69 X2). 2:apply (rem_2926 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2928 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2927 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_6;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2929 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2860 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_7;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2930 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_87 X1 -> auto___def_87 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2931 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_2930 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2932 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___type_18 X2 -> auto___type_18 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2933 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___type_18 X2 -> auto___type_18 X2). tauto. exact (rem_2932 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2934 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> (auto___def_87 X1 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_87 X1). 2:apply (rem_2931 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_2933 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2935 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2934 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_8;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2936 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2937 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_2936 epsilon_mknows_current_p__type_11 X1).
Defined.

Remark rem_2938 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_2939 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_2938 epsilon_mknows_current_p__type_11 X2).
Defined.

Remark rem_2940 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_2937 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_2939 epsilon_mknows_current_p__type_11 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_2941 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_11 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intros A1 A2.
  case (rem_2940 epsilon_mknows_current_p__type_11 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_11 A1 A2. intros. apply trans___type_11_crypt_9;  tauto.
 clear  epsilon_mknows_current_p__type_11 A1 A2. tauto.
Defined.

Remark rem_2942 : (forall X:term, auto_knows_current X -> auto___type_11 X)
    -> forall X1 X2:term, auto_knows_current (crypt X1 X2) -> auto___type_11 (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_11. intros X1 X2. intro H. intros.
  elim (rem_1604 X1 X2 H);  intros.
  apply (rem_2898 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2904 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2910 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2916 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2922 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2928 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2929 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2935 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
  apply (rem_2941 epsilon_mknows_current_p__type_11 X1 X2);  tauto.
Defined.

Remark rem_2943 : forall X1:term, auto_knows_current X1 -> auto___type_11 X1. (* Induct. *)
Proof.
  fix epsilon_mknows_current_p__type_11 1.
  intro X. case X.
  exact (rem_2844 epsilon_mknows_current_p__type_11 ).
  exact (rem_2848 epsilon_mknows_current_p__type_11 ).
  intros X1 X2;  exact (rem_2862 epsilon_mknows_current_p__type_11 X1 X2).
  intros X1 X2;  exact (rem_2942 epsilon_mknows_current_p__type_11 X1 X2).
  exact (rem_2856 epsilon_mknows_current_p__type_11 ).
  intros X1 X2;  exact (rem_2883 epsilon_mknows_current_p__type_11 X1 X2).
  exact (rem_2854 epsilon_mknows_current_p__type_11 ).
  intros X1 X2;  exact (rem_2892 epsilon_mknows_current_p__type_11 X1 X2).
  intros X1 X2;  exact (rem_2846 epsilon_mknows_current_p__type_11 X1 X2).
  intros X1 X2. intro H. elim (rem_1611 X1 X2 H).
  intros X1 X2;  exact (rem_2885 epsilon_mknows_current_p__type_11 X1 X2).
   intro H. elim (rem_1606  H).
   intro H. elim (rem_1607  H).
  intros X1;  exact (rem_2852 epsilon_mknows_current_p__type_11 X1).
  exact (rem_2864 epsilon_mknows_current_p__type_11 ).
  intros X1 X2 X3. intro H. elim (rem_1609 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1610 X1 X2 X3 H).
   intro H. elim (rem_1608  H).
Qed.

Remark rem_2944 : auto___def_74 sym. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_74_sym_1;  tauto.
 tauto.
Qed.

Remark rem_2945 : forall X1 X2:term, auto___def_29 X1 -> auto___def_39 X2 -> auto___def_29 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_29 X1). tauto. exact (rem_664 X1).
Qed.

Remark rem_2946 : forall X1 X2:term, auto___def_29 X1 -> auto___def_39 X2 -> auto___def_39 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_39 X2 -> auto___def_39 X2). tauto. exact (rem_1162 X2).
Qed.

Remark rem_2947 : forall X1 X2:term, auto___def_29 X1 -> auto___def_39 X2 -> (auto___def_29 X1 /\ auto___def_39 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_29 X1). 2:apply (rem_2945 X1 X2);  assumption.
  cut (auto___def_39 X2). 2:apply (rem_2946 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2948 : forall X1 X2:term, auto___def_29 X1 -> auto___def_39 X2 -> auto___def_24 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2947 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_24_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2949 : forall X1 X2:term, auto___def_39 X2 -> auto___def_29 X1 -> auto___def_24 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_29 X1 -> auto___def_39 X2 -> auto___def_24 (key X1 X2)). tauto. exact (rem_2948 X1 X2).
Qed.

Remark rem_2950 : forall X1:term, auto___type_4 X1 -> auto___type_4 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2951 : forall X1 X2:term, auto___def_25 X2 -> auto___type_4 X1 -> auto___type_4 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_4 X1 -> auto___type_4 X1). tauto. exact (rem_2950 X1).
Qed.

Remark rem_2952 : forall X2:term, auto___def_25 X2 -> auto___def_25 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2953 : forall X1 X2:term, auto___def_25 X2 -> auto___type_4 X1 -> auto___def_25 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_25 X2 -> auto___def_25 X2). tauto. exact (rem_2952 X2).
Qed.

Remark rem_2954 : forall X1 X2:term, auto___def_25 X2 -> auto___type_4 X1 -> (auto___type_4 X1 /\ auto___def_25 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_4 X1). 2:apply (rem_2951 X1 X2);  assumption.
  cut (auto___def_25 X2). 2:apply (rem_2953 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2955 : forall X1 X2:term, auto___def_25 X2 -> auto___type_4 X1 -> auto___def_23 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2954 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_23_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2956 : forall X1 X2:term, auto___def_77 X2 -> auto___type_17 X1 -> auto___type_17 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_17 X1 -> auto___type_17 X1). tauto. exact (rem_2645 X1).
Qed.

Remark rem_2957 : forall X1 X2:term, auto___def_77 X2 -> auto___type_17 X1 -> auto___def_77 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_77 X2 -> auto___def_77 X2). tauto. exact (rem_1974 X2).
Qed.

Remark rem_2958 : forall X1 X2:term, auto___def_77 X2 -> auto___type_17 X1 -> (auto___type_17 X1 /\ auto___def_77 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___type_17 X1). 2:apply (rem_2956 X1 X2);  assumption.
  cut (auto___def_77 X2). 2:apply (rem_2957 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2959 : forall X1 X2:term, auto___def_77 X2 -> auto___type_17 X1 -> auto___def_81 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2958 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_81_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2960 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_582 X1).
Qed.

Remark rem_2961 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_584 X2).
Qed.

Remark rem_2962 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_2960 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_2961 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2963 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_31 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2962 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_31_crypt_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2964 : forall X1 X2:term, auto___def_34 X2 -> auto___def_33 X1 -> auto___def_31 (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_34 X2 -> auto___def_31 (crypt X1 X2)). tauto. exact (rem_2963 X1 X2).
Qed.

Remark rem_2965 : auto___def_61 nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans___def_61_nil_1;  tauto.
 tauto.
Qed.

Remark rem_2966 : forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> auto___def_27 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_27 X1). tauto. exact (rem_1191 X1).
Qed.

Remark rem_2967 : forall X2:term, auto___def_35 X2 -> auto___def_35 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2968 : forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> auto___def_35 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_35 X2 -> auto___def_35 X2). tauto. exact (rem_2967 X2).
Qed.

Remark rem_2969 : forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> (auto___def_27 X1 /\ auto___def_35 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_27 X1). 2:apply (rem_2966 X1 X2);  assumption.
  cut (auto___def_35 X2). 2:apply (rem_2968 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2970 : forall X1 X2:term, auto___def_27 X1 -> auto___def_35 X2 -> auto___def_33 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2969 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_33_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2971 : forall X1 X2:term, auto___def_35 X2 -> auto___def_27 X1 -> auto___def_33 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_27 X1 -> auto___def_35 X2 -> auto___def_33 (cons X1 X2)). tauto. exact (rem_2970 X1 X2).
Qed.

Remark rem_2972 : forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_74 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_74 X1). tauto. exact (rem_1618 X1).
Qed.

Remark rem_2973 : forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_75 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_75 X2 -> auto___def_75 X2). tauto. exact (rem_1926 X2).
Qed.

Remark rem_2974 : forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> (auto___def_74 X1 /\ auto___def_75 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_74 X1). 2:apply (rem_2972 X1 X2);  assumption.
  cut (auto___def_75 X2). 2:apply (rem_2973 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2975 : forall X1 X2:term, auto___def_74 X1 -> auto___def_75 X2 -> auto___def_72 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_2974 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_72_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2976 : forall X1 X2:term, auto___def_75 X2 -> auto___def_74 X1 -> auto___def_72 (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_74 X1 -> auto___def_75 X2 -> auto___def_72 (key X1 X2)). tauto. exact (rem_2975 X1 X2).
Qed.

Remark rem_2977 : forall X1 X2:term, auto___def_15 X1 -> auto___def_16 X2 -> auto___def_83 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_521 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_83_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_2978 : forall X1 X2:term, auto___def_16 X2 -> auto___def_15 X1 -> auto___def_83 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_15 X1 -> auto___def_16 X2 -> auto___def_83 (cons X1 X2)). tauto. exact (rem_2977 X1 X2).
Qed.

Remark rem_2979 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_575 X1).
Qed.

Remark rem_2980 : forall X2:term, auto___def_72 X2 -> auto___def_72 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_2981 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_2982 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_577 X2).
Qed.

Remark rem_2983 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> (auto___def_23 X1 /\ auto___def_72 X2 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_23 X1). 2:apply (rem_2979 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_2981 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_2982 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2984 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_2983 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_4;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_2985 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_582 X1).
Qed.

Remark rem_2986 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_2987 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_584 X2).
Qed.

Remark rem_2988 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> (auto___def_33 X1 /\ auto___def_72 X2 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_33 X1). 2:apply (rem_2985 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_2986 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_2987 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2989 : forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_2988 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_9;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_2990 : forall X1 X2:term, auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___type_18 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_1413 X1).
Qed.

Remark rem_2991 : forall X1 X2:term, auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___type_18 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_2992 : forall X1 X2:term, auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___type_18 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_1415 X2).
Qed.

Remark rem_2993 : forall X1 X2:term, auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___type_18 X2 -> (auto___def_78 X1 /\ auto___def_72 X2 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_78 X1). 2:apply (rem_2990 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_2991 X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_2992 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_2994 : forall X1 X2:term, auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_2993 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_3;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_2995 : forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_78 X1 -> auto___def_79 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2). tauto. exact (rem_2994 X1 X2).
Qed.

Remark rem_2996 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_18 X2 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_280 X1).
Qed.

Remark rem_2997 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_18 X2 -> auto___type_19 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_2998 : forall X2:term, auto___def_72 X2 -> auto___type_19 X2. (* Induct. *)
Proof.
  fix epsilon_m__def_72_p__type_19 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_532 epsilon_m__def_72_p__type_19 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_2999 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_18 X2 -> auto___type_19 X2 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___type_19 X2). tauto. exact (rem_2998 X2).
Qed.

Remark rem_3000 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_18 X2 -> auto___type_19 X2 -> (auto___def_89 X1 /\ auto___def_72 X2 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_89 X1). 2:apply (rem_2996 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_2997 X1 X2);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_2999 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3001 : forall X1 X2:term, auto___def_72 X2 -> auto___def_89 X1 -> auto___type_18 X2 -> auto___type_19 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_3000 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_7;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_3002 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_89 X1 -> auto___type_18 X2 -> auto___type_19 X2 -> auto___def_88 X1 X2). tauto. exact (rem_3001 X1 X2).
Qed.

Remark rem_3003 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_1931 X1).
Qed.

Remark rem_3004 : forall X2:term, auto___def_58 X2 -> auto___def_58 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3005 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_58 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_58 X2 -> auto___def_58 X2). tauto. exact (rem_3004 X2).
Qed.

Remark rem_3006 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_3007 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> (auto___def_57 X1 /\ auto___def_58 X2 /\ auto___def_72 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_57 X1). 2:apply (rem_3003 X1 X2);  assumption.
  cut (auto___def_58 X2). 2:apply (rem_3005 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_3006 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3008 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_3007 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_6;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_3009 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_1937 X1).
Qed.

Remark rem_3010 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_3011 : forall X2:term, auto___def_69 X2 -> auto___def_69 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3012 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_69 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_69 X2 -> auto___def_69 X2). tauto. exact (rem_3011 X2).
Qed.

Remark rem_3013 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> (auto___def_68 X1 /\ auto___def_72 X2 /\ auto___def_69 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_68 X1). 2:apply (rem_3009 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_3010 X1 X2);  assumption.
  cut (auto___def_69 X2). 2:apply (rem_3012 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3014 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_3013 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_2;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_3015 : forall X1 X2:term, auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_3016 : forall X1 X2:term, auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_3017 : forall X1 X2:term, auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_1899 X2).
Qed.

Remark rem_3018 : forall X1 X2:term, auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto___def_72 X2 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto_knows_current X1). 2:apply (rem_3015 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_3016 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_3017 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3019 : forall X1 X2:term, auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_3018 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_1;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_3020 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current X1 -> auto_knows_current X2 -> auto___def_88 X1 X2). tauto. exact (rem_3019 X1 X2).
Qed.

Remark rem_3021 : forall X1 X2:term, auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_3022 : forall X2:term, auto___def_72 X2 -> auto___type_18 X2. (* Induct. *)
Proof.
  fix epsilon_m__def_72_p__type_18 1.
  intro X. case X.
   intro H. elim (rem_103  H).
   intro H. elim (rem_106  H).
  intros X1 X2. intro H. elim (rem_111 X1 X2 H).
  intros X1 X2. intro H. elim (rem_117 X1 X2 H).
   intro H. elim (rem_109  H).
  intros X1 X2;  exact (rem_1150 epsilon_m__def_72_p__type_18 X1 X2).
   intro H. elim (rem_108  H).
  intros X1 X2. intro H. elim (rem_115 X1 X2 H).
  intros X1 X2. intro H. elim (rem_104 X1 X2 H).
  intros X1 X2. intro H. elim (rem_119 X1 X2 H).
  intros X1 X2. intro H. elim (rem_114 X1 X2 H).
   intro H. elim (rem_105  H).
   intro H. elim (rem_110  H).
  intros X1. intro H. elim (rem_107 X1 H).
   intro H. elim (rem_112  H).
  intros X1 X2 X3. intro H. elim (rem_116 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_118 X1 X2 X3 H).
   intro H. elim (rem_113  H).
Qed.

Remark rem_3023 : forall X1 X2:term, auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___type_18 X2). tauto. exact (rem_3022 X2).
Qed.

Remark rem_3024 : forall X1 X2:term, auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> (auto___def_87 X1 /\ auto___def_72 X2 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  cut (auto___def_87 X1). 2:apply (rem_286 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_3021 X1 X2);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_3023 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3025 : forall X1 X2:term, auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3.
  case (rem_3024 X1 X2 A1 A2 A3). clear  A1 A2 A3. intros. apply trans___def_88_8;  tauto.
 clear  A1 A2 A3. tauto.
Qed.

Remark rem_3026 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_87 X1 -> auto___type_18 X2 -> auto___def_88 X1 X2). tauto. exact (rem_3025 X1 X2).
Qed.

Remark rem_3027 : forall X1 X2:term, auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___type_18 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_638 X1).
Qed.

Remark rem_3028 : forall X1 X2:term, auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___type_18 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_640 X2).
Qed.

Remark rem_3029 : forall X1 X2:term, auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___type_18 X2 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_3030 : forall X1 X2:term, auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___type_18 X2 -> (auto___def_7 X1 /\ auto___def_8 X2 /\ auto___def_72 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  cut (auto___def_7 X1). 2:apply (rem_3027 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_3028 X1 X2);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_3029 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3031 : forall X1 X2:term, auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2 A3 A4.
  case (rem_3030 X1 X2 A1 A2 A3 A4). clear  A1 A2 A3 A4. intros. apply trans___def_88_5;  tauto.
 clear  A1 A2 A3 A4. tauto.
Qed.

Remark rem_3032 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_72 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_72 X2 -> auto___def_8 X2 -> auto___type_18 X2 -> auto___def_88 X1 X2). tauto. exact (rem_3031 X1 X2).
Qed.

Remark rem_3033 : forall X1 X2:term, auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2) -> auto___def_88 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intros H1 H2. intro H. intros.
  elim (rem_1604 X1 X2 H);  intros.
  apply (rem_2984 X1 X2);  tauto.
  apply (rem_2989 X1 X2);  tauto.
  apply (rem_2995 X1 X2);  tauto.
  apply (rem_3002 X1 X2);  tauto.
  apply (rem_3008 X1 X2);  tauto.
  apply (rem_3014 X1 X2);  tauto.
  apply (rem_3020 X1 X2);  tauto.
  apply (rem_3026 X1 X2);  tauto.
  apply (rem_3032 X1 X2);  tauto.
Qed.

Remark rem_3034 : forall X1 X2 X3:term, auto___def_72 X2 -> auto___type_17 X3 -> auto___type_18 X2 -> auto_agent X3 -> auto_knows_current (crypt X1 X2) -> auto___def_88 X1 X2. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2) -> auto___def_88 X1 X2). tauto.
  exact (rem_3033 X1 X2).
Qed.

Remark rem_3035 : forall X1 X2 X3:term, auto_agent X3 -> auto___type_17 X3 -> auto___def_72 X2 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2) -> auto___def_88 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X2 -> auto___type_17 X3 -> auto___type_18 X2 -> auto_agent X3 -> auto_knows_current (crypt X1 X2) -> auto___def_88 X1 X2). tauto. exact (rem_3034 X1 X2 X3).
Qed.

Remark rem_3036 : forall X1 X2:term, auto_alice_key_current X1 X2 -> or_1
    (auto_agent X1 /\ auto___type_17 X1 /\ auto___def_72 X2 /\ auto___type_18 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3037 : forall X1 X2 X3:term, auto_alice_key_current X3 X2 -> auto_knows_current (crypt X1 X2) -> auto___def_88 X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_3036 X3 X2 H);  intros.
  apply (rem_3035 X1 X2 X3);  tauto.
Qed.

Remark rem_3038 : forall X1 X2 X3:term, auto_knows_current (crypt X1 X2) -> auto_alice_key_current X3 X2 -> auto___def_88 X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_alice_key_current X3 X2 -> auto_knows_current (crypt X1 X2) -> auto___def_88 X1 X2). tauto. exact (rem_3037 X1 X2 X3).
Qed.

Remark rem_3039 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___type_7 X2 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_1359 X1 X2 H);  intros.
Qed.

Remark rem_3040 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___def_38 (cons server nil) -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___type_7 X2 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X1 -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___type_7 X2 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3039 X1 X2 X3).
Qed.

Remark rem_3041 : forall X1 X2 X3:term, auto___type_7 X2 -> auto___def_38 (cons server nil) -> auto___def_27 X1 -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X1 -> auto___def_38 (cons server nil) -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___type_7 X2 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3040 X1 X2 X3).
Qed.

Remark rem_3042 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1371 X2 (cons server nil) H);  intros.
  apply (rem_3041 X1 X2 X3);  tauto.
Qed.

Remark rem_3043 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___def_28 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X1 -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3042 X1 X2 X3).
Qed.

Remark rem_3044 : forall X1 X2 X3:term, auto___def_26 (cons X1 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1377 X1 nil H);  intros.
  apply (rem_3043 X1 X2 X3);  tauto.
Qed.

Remark rem_3045 : forall X1 X2 X3:term, auto___type_5 (nonceb_current X1 X2) -> auto___def_26 (cons X1 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_26 (cons X1 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3044 X1 X2 X3).
Qed.

Remark rem_3046 : forall X1 X2 X3:term, auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1380 (nonceb_current X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3045 X1 X2 X3);  tauto.
Qed.

Remark rem_3047 : forall X1 X2 X3:term, auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3046 X1 X2 X3).
Qed.

Remark rem_3048 : forall X1 X2 X3:term, auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3047 X1 X2 X3).
Qed.

Remark rem_3049 : forall X1 X2 X3:term, auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_204 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3048 X1 X2 X3);  tauto.
Qed.

Remark rem_3050 : forall X1 X2 X3:term, auto___type_4 X3 -> auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_4 X3 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3049 X1 X2 X3).
Qed.

Remark rem_3051 : forall X1 X2 X3:term, auto___def_23 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1386 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3050 X1 X2 X3);  tauto.
Qed.

Remark rem_3052 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___type_5 X2 -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_2326 X1 X2 H);  intros.
Qed.

Remark rem_3053 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___type_5 X2 -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3052 X1 X2 X3).
Qed.

Remark rem_3054 : forall X1 X2 X3:term, auto___type_5 X2 -> auto___def_38 (cons server nil) -> auto___def_27 X3 -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3053 X1 X2 X3).
Qed.

Remark rem_3055 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_291 X2 (cons server nil) H);  intros.
  apply (rem_3054 X1 X2 X3);  tauto.
Qed.

Remark rem_3056 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_32 nil -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3055 X1 X2 X3).
Qed.

Remark rem_3057 : forall X1 X2 X3:term, auto___type_7 X1 -> auto___def_32 nil -> auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_32 nil -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_current X1 X2) -> auto___type_7 X1 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3056 X1 X2 X3).
Qed.

Remark rem_3058 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_36 (cons X1 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_2424 X1 nil H);  intros.
  apply (rem_3057 X1 X2 X3);  tauto.
Qed.

Remark rem_3059 : forall X1 X2 X3:term, auto___type_6 (nonceb_current X1 X2) -> auto___def_36 (cons X1 nil) -> auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_36 (cons X1 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3058 X1 X2 X3).
Qed.

Remark rem_3060 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1658 (nonceb_current X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3059 X1 X2 X3);  tauto.
Qed.

Remark rem_3061 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_29 sym -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3060 X1 X2 X3).
Qed.

Remark rem_3062 : forall X1 X2 X3:term, auto___def_29 sym -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_27 X3 -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_29 sym -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3061 X1 X2 X3).
Qed.

Remark rem_3063 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_313 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3062 X1 X2 X3);  tauto.
Qed.

Remark rem_3064 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3063 X1 X2 X3).
Qed.

Remark rem_3065 : forall X1 X2 X3:term, auto___def_33 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1390 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3064 X1 X2 X3);  tauto.
Qed.

Remark rem_3066 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current.  tauto.
Defined.

Remark rem_3067 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current.  case (rem_3066 epsilon_m__type_17_pknows_current). clear  epsilon_m__type_17_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_17_pknows_current. tauto.
Defined.

Remark rem_3068 : auto___type_17 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3069 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto___type_17 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intro H. intros.
  elim (rem_3068 H);  intros.
  apply (rem_3067 epsilon_m__type_17_pknows_current);  tauto.
Defined.

Remark rem_3070 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.  case (rem_3066 epsilon_m__type_17_pknows_current). clear  epsilon_m__type_17_pknows_current. intros. apply trans_knows_current_noncea_old_1;  tauto.
 clear  epsilon_m__type_17_pknows_current. tauto.
Defined.

Remark rem_3071 : forall X1 X2:term, auto___type_17 (noncea_old X1 X2) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3072 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_17 (noncea_old X1 X2) -> auto_knows_current (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_3071 X1 X2 H);  intros.
  apply (rem_3070 epsilon_m__type_17_pknows_current X1 X2);  tauto.
Defined.

Remark rem_3073 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current.  case (rem_3066 epsilon_m__type_17_pknows_current). clear  epsilon_m__type_17_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_17_pknows_current. tauto.
Defined.

Remark rem_3074 : auto___type_17 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3075 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto___type_17 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intro H. intros.
  elim (rem_3074 H);  intros.
  apply (rem_3073 epsilon_m__type_17_pknows_current);  tauto.
Defined.

Remark rem_3076 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3077 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_3076 epsilon_m__type_17_pknows_current X1);  assumption.
  tauto.
Defined.

Remark rem_3078 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1. intros A1.
  case (rem_3077 epsilon_m__type_17_pknows_current X1 A1). clear  epsilon_m__type_17_pknows_current A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  epsilon_m__type_17_pknows_current A1. tauto.
Defined.

Remark rem_3079 : forall X1:term, auto___type_17 (s X1) -> or_1
    (auto_knows_current X1).
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3080 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___type_17 (s X1) -> auto_knows_current (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1. intro H. intros.
  elim (rem_3079 X1 H);  intros.
  apply (rem_3078 epsilon_m__type_17_pknows_current X1);  tauto.
Defined.

Remark rem_3081 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current.  case (rem_3066 epsilon_m__type_17_pknows_current). clear  epsilon_m__type_17_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__type_17_pknows_current. tauto.
Defined.

Remark rem_3082 : auto___type_17 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3083 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto___type_17 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intro H. intros.
  elim (rem_3082 H);  intros.
  apply (rem_3081 epsilon_m__type_17_pknows_current);  tauto.
Defined.

Remark rem_3084 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current.  case (rem_3066 epsilon_m__type_17_pknows_current). clear  epsilon_m__type_17_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_17_pknows_current. tauto.
Defined.

Remark rem_3085 : auto___type_17 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3086 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto___type_17 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intro H. intros.
  elim (rem_3085 H);  intros.
  apply (rem_3084 epsilon_m__type_17_pknows_current);  tauto.
Defined.

Remark rem_3087 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_3076 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3088 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto_knows_current X2 -> auto_knows_current X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3089 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_3088 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3090 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_3087 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_3089 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3091 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3090 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3092 : forall X1 X2:term, auto___type_17 (cons X1 X2) -> or_1
    (auto_knows_current X1 /\ auto_knows_current X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3093 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_17 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_3092 X1 X2 H);  intros.
  apply (rem_3091 epsilon_m__type_17_pknows_current X1 X2);  tauto.
Defined.

Remark rem_3094 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current.  case (rem_3066 epsilon_m__type_17_pknows_current). clear  epsilon_m__type_17_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_17_pknows_current. tauto.
Defined.

Remark rem_3095 : auto___type_17 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3096 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> auto___type_17 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intro H. intros.
  elim (rem_3095 H);  intros.
  apply (rem_3094 epsilon_m__type_17_pknows_current);  tauto.
Defined.

Remark rem_3097 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_49 X1 -> auto___def_49 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3098 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_49 X1 -> auto___def_49 X1). tauto. exact (rem_3097 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3099 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_50 X2 -> auto___def_50 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3100 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_50 X2). tauto. exact (rem_3099 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3101 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_3098 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_3100 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3102 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3101 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_key_1;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3103 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3104 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_3103 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3105 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3106 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_3105 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3107 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_3104 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_3106 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3108 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3107 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_key_2;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3109 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3110 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_3109 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3111 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3112 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_3111 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3113 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_3110 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_3112 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3114 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3113 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_key_3;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3115 : forall X1 X2:term, auto___type_17 (key X1 X2) -> or_3
    (auto___def_49 X1 /\ auto___def_50 X2)
    (auto___def_47 X1 /\ auto___def_48 X2)
    (auto___def_46 X1 /\ auto___type_10 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_3_intro_1; tauto.
  intros. apply or_3_intro_2; tauto.
  intros. apply or_3_intro_3; tauto.
Qed.

Remark rem_3116 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_17 (key X1 X2) -> auto_knows_current (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_3115 X1 X2 H);  intros.
  apply (rem_3102 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3108 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3114 epsilon_m__type_17_pknows_current X1 X2);  tauto.
Defined.

Remark rem_3117 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.  case (rem_3066 epsilon_m__type_17_pknows_current). clear  epsilon_m__type_17_pknows_current. intros. apply trans_knows_current_nonceb_old_1;  tauto.
 clear  epsilon_m__type_17_pknows_current. tauto.
Defined.

Remark rem_3118 : forall X1 X2:term, auto___type_17 (nonceb_old X1 X2) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3119 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_17 (nonceb_old X1 X2) -> auto_knows_current (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_3118 X1 X2 H);  intros.
  apply (rem_3117 epsilon_m__type_17_pknows_current X1 X2);  tauto.
Defined.

Remark rem_3120 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3121 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_3120 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3122 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3123 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_3122 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3124 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_3121 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_3123 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3125 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3124 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_noncea_current_1;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3126 : forall X1 X2:term, auto___type_17 (noncea_current X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3127 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_17 (noncea_current X1 X2) -> auto_knows_current (noncea_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_3126 X1 X2 H);  intros.
  apply (rem_3125 epsilon_m__type_17_pknows_current X1 X2);  tauto.
Defined.

Remark rem_3128 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3129 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_3128 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3130 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3131 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_3130 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3132 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_3129 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_3131 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3133 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3132 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_1;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3134 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3135 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_3134 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3136 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3137 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_3136 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3138 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_3135 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_3137 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3139 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3138 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_2;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3140 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_78 X1 -> auto___def_78 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3141 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_3140 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3142 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_79 X2 -> auto___def_79 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3143 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_3142 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3144 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> (auto___def_78 X1 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_78 X1). 2:apply (rem_3141 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_3143 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3145 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3144 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_3;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3146 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_89 X1 -> auto___def_89 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3147 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_3146 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3148 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___type_19 X2 -> auto___type_19 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3149 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___type_19 X2 -> auto___type_19 X2). tauto. exact (rem_3148 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3150 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> (auto___def_89 X1 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_89 X1). 2:apply (rem_3147 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_3149 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3151 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3150 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_4;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3152 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_57 X1 -> auto___def_57 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3153 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_3152 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3154 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_58 X2 -> auto___def_58 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3155 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_58 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_58 X2 -> auto___def_58 X2). tauto. exact (rem_3154 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3156 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> (auto___def_57 X1 /\ auto___def_58 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_57 X1). 2:apply (rem_3153 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_58 X2). 2:apply (rem_3155 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3157 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3156 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_5;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3158 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_68 X1 -> auto___def_68 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3159 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_3158 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3160 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_69 X2 -> auto___def_69 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3161 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_69 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_69 X2 -> auto___def_69 X2). tauto. exact (rem_3160 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3162 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> (auto___def_68 X1 /\ auto___def_69 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_68 X1). 2:apply (rem_3159 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_69 X2). 2:apply (rem_3161 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3163 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3162 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_6;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3164 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3090 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3165 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_87 X1 -> auto___def_87 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3166 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_3165 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3167 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___type_18 X2 -> auto___type_18 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3168 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___type_18 X2 -> auto___type_18 X2). tauto. exact (rem_3167 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3169 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> (auto___def_87 X1 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_87 X1). 2:apply (rem_3166 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_3168 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3170 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3169 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_8;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3171 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3172 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_3171 epsilon_m__type_17_pknows_current X1).
Defined.

Remark rem_3173 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3174 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_3173 epsilon_m__type_17_pknows_current X2).
Defined.

Remark rem_3175 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_3172 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_3174 epsilon_m__type_17_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3176 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3175 epsilon_m__type_17_pknows_current X1 X2 A1 A2). clear  epsilon_m__type_17_pknows_current A1 A2. intros. apply trans_knows_current_crypt_9;  tauto.
 clear  epsilon_m__type_17_pknows_current A1 A2. tauto.
Defined.

Remark rem_3177 : forall X1 X2:term, auto___type_17 (crypt X1 X2) -> or_9
    (auto___def_23 X1 /\ auto___def_24 X2)
    (auto___def_33 X1 /\ auto___def_34 X2)
    (auto___def_78 X1 /\ auto___def_79 X2)
    (auto___def_89 X1 /\ auto___type_19 X2)
    (auto___def_57 X1 /\ auto___def_58 X2)
    (auto___def_68 X1 /\ auto___def_69 X2)
    (auto_knows_current X1 /\ auto_knows_current X2)
    (auto___def_87 X1 /\ auto___type_18 X2)
    (auto___def_7 X1 /\ auto___def_8 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_9_intro_1; tauto.
  intros. apply or_9_intro_2; tauto.
  intros. apply or_9_intro_3; tauto.
  intros. apply or_9_intro_4; tauto.
  intros. apply or_9_intro_5; tauto.
  intros. apply or_9_intro_6; tauto.
  intros. apply or_9_intro_7; tauto.
  intros. apply or_9_intro_8; tauto.
  intros. apply or_9_intro_9; tauto.
Qed.

Remark rem_3178 : (forall X:term, auto___type_17 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_17 (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_17_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_3177 X1 X2 H);  intros.
  apply (rem_3133 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3139 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3145 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3151 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3157 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3163 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3164 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3170 epsilon_m__type_17_pknows_current X1 X2);  tauto.
  apply (rem_3176 epsilon_m__type_17_pknows_current X1 X2);  tauto.
Defined.

Remark rem_3179 : auto___type_17 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3180 : auto___type_17 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3181 : auto___type_17 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3182 : forall X1 X2 X3:term, auto___type_17 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3183 : forall X1 X2 X3:term, auto___type_17 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3184 : forall X1 X2:term, auto___type_17 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3185 : forall X1:term, auto___type_17 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_17_pknows_current 1.
  intro X. case X.
  exact (rem_3069 epsilon_m__type_17_pknows_current ).
  exact (rem_3075 epsilon_m__type_17_pknows_current ).
  intros X1 X2;  exact (rem_3093 epsilon_m__type_17_pknows_current X1 X2).
  intros X1 X2;  exact (rem_3178 epsilon_m__type_17_pknows_current X1 X2).
  exact (rem_3086 epsilon_m__type_17_pknows_current ).
  intros X1 X2;  exact (rem_3116 epsilon_m__type_17_pknows_current X1 X2).
  exact (rem_3083 epsilon_m__type_17_pknows_current ).
  intros X1 X2;  exact (rem_3127 epsilon_m__type_17_pknows_current X1 X2).
  intros X1 X2;  exact (rem_3072 epsilon_m__type_17_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_3184 X1 X2 H).
  intros X1 X2;  exact (rem_3119 epsilon_m__type_17_pknows_current X1 X2).
   intro H. elim (rem_3179  H).
   intro H. elim (rem_3180  H).
  intros X1;  exact (rem_3080 epsilon_m__type_17_pknows_current X1).
  exact (rem_3096 epsilon_m__type_17_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_3182 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_3183 X1 X2 X3 H).
   intro H. elim (rem_3181  H).
Qed.

Remark rem_3186 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_83 (cons server nil) -> auto___type_15 X2 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_17 X1 -> auto_knows_current X1). tauto. exact (rem_3185 X1).
Qed.

Remark rem_3187 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_83 (cons server nil) -> auto___type_15 X2 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___type_15 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X2 -> auto___type_15 X2). tauto. exact (rem_448 X2).
Qed.

Remark rem_3188 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_83 (cons server nil) -> auto___type_15 X2 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X2 -> auto_agent X2). tauto. exact (rem_477 X2).
Qed.

Remark rem_3189 : forall X3:term, auto___def_72 X3 -> auto___def_72 X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3190 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_83 (cons server nil) -> auto___type_15 X2 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_72 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_72 X3). tauto. exact (rem_3189 X3).
Qed.

Remark rem_3191 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_83 (cons server nil) -> auto___type_15 X2 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> (auto_knows_current X1 /\ auto___type_15 X2 /\ auto_agent X2 /\ auto___def_72 X3) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4 A5.
  cut (auto_knows_current X1). 2:apply (rem_3186 X1 X2 X3);  assumption.
  cut (auto___type_15 X2). 2:apply (rem_3187 X1 X2 X3);  assumption.
  cut (auto_agent X2). 2:apply (rem_3188 X1 X2 X3);  assumption.
  cut (auto___def_72 X3). 2:apply (rem_3190 X1 X2 X3);  assumption.
  tauto.
Qed.

Remark rem_3192 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_83 (cons server nil) -> auto___type_15 X2 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_86 X1 X2 X3. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4 A5.
  case (rem_3191 X1 X2 X3 A1 A2 A3 A4 A5). clear  A1 A2 A3 A4 A5. intros. apply trans___def_86_1;  tauto.
 clear  A1 A2 A3 A4 A5. tauto.
Qed.

Remark rem_3193 : forall X1 X2 X3:term, auto___type_15 X2 -> auto___def_83 (cons server nil) -> auto___def_72 X3 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_83 (cons server nil) -> auto___type_15 X2 -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3192 X1 X2 X3).
Qed.

Remark rem_3194 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_82 (cons X2 (cons server nil)) -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_154 X2 (cons server nil) H);  intros.
  apply (rem_3193 X1 X2 X3);  tauto.
Qed.

Remark rem_3195 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_77 nil -> auto___def_82 (cons X2 (cons server nil)) -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_82 (cons X2 (cons server nil)) -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3194 X1 X2 X3).
Qed.

Remark rem_3196 : forall X1 X2 X3:term, auto___type_17 X1 -> auto___def_77 nil -> auto___def_72 X3 -> auto___def_82 (cons X2 (cons server nil)) -> auto___type_16 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_77 nil -> auto___def_82 (cons X2 (cons server nil)) -> auto___type_16 (nonceb_current X1 X2) -> auto___type_17 X1 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3195 X1 X2 X3).
Qed.

Remark rem_3197 : forall X1 X2:term, auto___def_81 (cons X1 X2) -> or_1
    (auto___type_17 X1 /\ auto___def_77 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3198 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_81 (cons X1 nil) -> auto___def_82 (cons X2 (cons server nil)) -> auto___type_16 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_3197 X1 nil H);  intros.
  apply (rem_3196 X1 X2 X3);  tauto.
Qed.

Remark rem_3199 : forall X1 X2 X3:term, auto___type_16 (nonceb_current X1 X2) -> auto___def_81 (cons X1 nil) -> auto___def_72 X3 -> auto___def_82 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_81 (cons X1 nil) -> auto___def_82 (cons X2 (cons server nil)) -> auto___type_16 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3198 X1 X2 X3).
Qed.

Remark rem_3200 : forall X1 X2:term, auto___def_80 (cons X1 X2) -> or_1
    (auto___type_16 X1 /\ auto___def_81 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3201 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_82 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_3200 (nonceb_current X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3199 X1 X2 X3);  tauto.
Qed.

Remark rem_3202 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_74 sym -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_82 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_82 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3201 X1 X2 X3).
Qed.

Remark rem_3203 : forall X1 X2 X3:term, auto___def_74 sym -> auto___def_82 (cons X2 (cons server nil)) -> auto___def_72 X3 -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_74 sym -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_82 (cons X2 (cons server nil)) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3202 X1 X2 X3).
Qed.

Remark rem_3204 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_176 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3203 X1 X2 X3);  tauto.
Qed.

Remark rem_3205 : forall X1 X2 X3:term, auto___def_72 X3 -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X3 -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto___def_80 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3204 X1 X2 X3).
Qed.

Remark rem_3206 : forall X1 X2 X3:term, auto___def_78 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___def_79 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1667 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3205 X1 X2 X3);  tauto.
Qed.

Remark rem_3207 : forall X1 X2 X3:term, auto___def_89 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___type_19 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1669 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
Qed.

Remark rem_3208 : forall X1 X2:term, auto___def_61 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3209 : forall X1 X2 X3:term, auto___def_61 (cons X1 nil) -> auto___type_11 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_3208 X1 nil H);  intros.
Qed.

Remark rem_3210 : forall X1 X2 X3:term, auto_knows_current X1 -> auto_agent X2 -> auto___def_61 (cons X1 nil) -> auto___type_11 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_61 (cons X1 nil) -> auto___type_11 X3 -> auto_agent X2 -> auto_knows_current X1 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3209 X1 X2 X3).
Qed.

Remark rem_3211 : forall X1 X2 X3:term, auto___def_60 (nonceb_current X1 X2) -> auto___def_61 (cons X1 nil) -> auto___type_11 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1471 X1 X2 H);  intros.
  apply (rem_3210 X1 X2 X3);  tauto.
Qed.

Remark rem_3212 : forall X1 X2 X3:term, auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1800 (nonceb_current X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3211 X1 X2 X3);  tauto.
Qed.

Remark rem_3213 : forall X1 X2 X3:term, auto___def_14 (cons server nil) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3212 X1 X2 X3).
Qed.

Remark rem_3214 : forall X1 X2 X3:term, auto_agent X2 -> auto___def_14 (cons server nil) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_14 (cons server nil) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3213 X1 X2 X3).
Qed.

Remark rem_3215 : forall X1 X2 X3:term, auto___def_13 (cons X2 (cons server nil)) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_211 X2 (cons server nil) H);  intros.
  apply (rem_3214 X1 X2 X3);  tauto.
Qed.

Remark rem_3216 : forall X1 X2 X3:term, auto___def_12 sym -> auto___def_13 (cons X2 (cons server nil)) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_13 (cons X2 (cons server nil)) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3215 X1 X2 X3).
Qed.

Remark rem_3217 : forall X1 X2 X3:term, auto___def_58 (key sym (cons X2 (cons server nil))) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_259 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3216 X1 X2 X3);  tauto.
Qed.

Remark rem_3218 : forall X1 X2 X3:term, auto___type_11 X3 -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_58 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_58 (key sym (cons X2 (cons server nil))) -> auto___def_59 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_11 X3 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3217 X1 X2 X3).
Qed.

Remark rem_3219 : forall X1 X2 X3:term, auto___def_57 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___def_58 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1808 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3218 X1 X2 X3);  tauto.
Qed.

Remark rem_3220 : forall X1 X2 X3:term, auto___def_72 X1 -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___type_17 X2 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_476 X1 X2 H);  intros.
Qed.

Remark rem_3221 : forall X1 X2 X3:term, auto___def_72 X1 -> auto___def_83 (cons server nil) -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___type_17 X2 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X1 -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___type_17 X2 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3220 X1 X2 X3).
Qed.

Remark rem_3222 : forall X1 X2 X3:term, auto___type_17 X2 -> auto___def_83 (cons server nil) -> auto___def_72 X1 -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X1 -> auto___def_83 (cons server nil) -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___type_17 X2 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3221 X1 X2 X3).
Qed.

Remark rem_3223 : forall X1 X2 X3:term, auto___def_72 X1 -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_125 X2 (cons server nil) H);  intros.
  apply (rem_3222 X1 X2 X3);  tauto.
Qed.

Remark rem_3224 : forall X1 X2 X3:term, auto___def_72 X1 -> auto___def_73 nil -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X1 -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3223 X1 X2 X3).
Qed.

Remark rem_3225 : forall X1 X2:term, auto___def_71 (cons X1 X2) -> or_1
    (auto___def_72 X1 /\ auto___def_73 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3226 : forall X1 X2 X3:term, auto___def_71 (cons X1 nil) -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_3225 X1 nil H);  intros.
  apply (rem_3224 X1 X2 X3);  tauto.
Qed.

Remark rem_3227 : forall X1 X2 X3:term, auto___type_15 (nonceb_current X1 X2) -> auto___def_71 (cons X1 nil) -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_71 (cons X1 nil) -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___type_15 (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3226 X1 X2 X3).
Qed.

Remark rem_3228 : forall X1 X2 X3:term, auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1814 (nonceb_current X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3227 X1 X2 X3);  tauto.
Qed.

Remark rem_3229 : forall X1 X2 X3:term, auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_74 sym -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3228 X1 X2 X3).
Qed.

Remark rem_3230 : forall X1 X2 X3:term, auto___def_74 sym -> auto___def_84 (cons X2 (cons server nil)) -> auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_74 sym -> auto___def_84 (cons X2 (cons server nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3229 X1 X2 X3).
Qed.

Remark rem_3231 : forall X1 X2 X3:term, auto___def_69 (key sym (cons X2 (cons server nil))) -> auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_147 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3230 X1 X2 X3);  tauto.
Qed.

Remark rem_3232 : forall X1 X2 X3:term, auto___type_14 X3 -> auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_69 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_69 (key sym (cons X2 (cons server nil))) -> auto___def_70 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_14 X3 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3231 X1 X2 X3).
Qed.

Remark rem_3233 : forall X1 X2 X3:term, auto___def_68 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___def_69 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1820 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3232 X1 X2 X3);  tauto.
Qed.

Remark rem_3234 : forall X1 X2 X3:term, auto___def_50 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_39 X2 (cons server nil) H);  intros.
Qed.

Remark rem_3235 : forall X1 X2 X3:term, auto___def_49 sym -> auto___def_50 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_50 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3234 X1 X2 X3).
Qed.

Remark rem_3236 : forall X1 X2 X3:term, auto___def_48 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1217 X2 (cons server nil) H);  intros.
Qed.

Remark rem_3237 : forall X1 X2 X3:term, auto___def_47 sym -> auto___def_48 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_48 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3236 X1 X2 X3).
Qed.

Remark rem_3238 : forall X1 X2 X3:term, auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_1611 X1 X2 H);  intros.
Qed.

Remark rem_3239 : forall X1 X2 X3:term, auto___def_46 sym -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3238 X1 X2 X3).
Qed.

Remark rem_3240 : forall X1 X2 X3:term, auto___def_46 sym -> auto___type_10 (cons X2 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2 X3. intros. apply (rem_3239 X1 X2 X3);  assumption.
Qed.

Remark rem_3241 : forall X1 X2 X3:term, auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_99 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3235 X1 X2 X3);  tauto.
  apply (rem_3237 X1 X2 X3);  tauto.
  apply (rem_3240 X1 X2 X3);  tauto.
Qed.

Remark rem_3242 : forall X1 X2 X3:term, auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current nil -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3241 X1 X2 X3).
Qed.

Remark rem_3243 : forall X1 X2 X3:term, auto_knows_current X1 -> auto_knows_current nil -> auto_knows_current X3 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_knows_current X3 -> auto_knows_current X1 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current nil -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3242 X1 X2 X3).
Qed.

Remark rem_3244 : forall X1 X2 X3:term, auto_knows_current X3 -> auto_knows_current (cons X1 nil) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1520 X1 nil H);  intros.
  apply (rem_3243 X1 X2 X3);  tauto.
Qed.

Remark rem_3245 : forall X1 X2 X3:term, auto_knows_current (nonceb_current X1 X2) -> auto_knows_current (cons X1 nil) -> auto_knows_current X3 -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_knows_current X3 -> auto_knows_current (cons X1 nil) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto_knows_current (nonceb_current X1 X2) -> auto___def_86 X1 X2 X3). tauto. exact (rem_3244 X1 X2 X3).
Qed.

Remark rem_3246 : forall X1 X2 X3:term, auto_knows_current X3 -> auto_knows_current (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1520 (nonceb_current X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3245 X1 X2 X3);  tauto.
Qed.

Remark rem_3247 : forall X1 X2 X3:term, auto_knows_current (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto_knows_current (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1520 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3246 X1 X2 X3);  tauto.
Qed.

Remark rem_3248 : forall X1 X2 X3:term, auto___def_87 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___type_18 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1835 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
Qed.

Remark rem_3249 : forall X1 X2 X3:term, auto___def_10 (nonceb_current X1 X2) -> auto___def_11 (cons X1 nil) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1461 X1 X2 H);  intros.
Qed.

Remark rem_3250 : forall X1 X2 X3:term, auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1396 (nonceb_current X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3249 X1 X2 X3);  tauto.
Qed.

Remark rem_3251 : forall X1 X2 X3:term, auto___def_14 (cons server nil) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3250 X1 X2 X3).
Qed.

Remark rem_3252 : forall X1 X2 X3:term, auto_agent X2 -> auto___def_14 (cons server nil) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_14 (cons server nil) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3251 X1 X2 X3).
Qed.

Remark rem_3253 : forall X1 X2 X3:term, auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_211 X2 (cons server nil) H);  intros.
  apply (rem_3252 X1 X2 X3);  tauto.
Qed.

Remark rem_3254 : forall X1 X2 X3:term, auto___def_12 sym -> auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_86 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_86 X1 X2 X3). tauto.
  exact (rem_3253 X1 X2 X3).
Qed.

Remark rem_3255 : forall X1 X2 X3:term, auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_234 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3254 X1 X2 X3);  tauto.
Qed.

Remark rem_3256 : forall X1 X2 X3:term, auto___type_1 X3 -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons (nonceb_current X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_86 X1 X2 X3). tauto. exact (rem_3255 X1 X2 X3).
Qed.

Remark rem_3257 : forall X1 X2 X3:term, auto___def_7 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1404 X3 (cons (nonceb_current X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3256 X1 X2 X3);  tauto.
Qed.

Remark rem_3258 : forall X1 X2 X3:term, auto_knows_current (crypt (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) (key sym (cons X2 (cons server nil)))) -> auto___def_86 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1604 (cons X3 (cons (nonceb_current X1 X2) (cons X1 nil))) (key sym (cons X2 (cons server nil))) H);  intros.
  apply (rem_3051 X1 X2 X3);  tauto.
  apply (rem_3065 X1 X2 X3);  tauto.
  apply (rem_3206 X1 X2 X3);  tauto.
  apply (rem_3207 X1 X2 X3);  tauto.
  apply (rem_3219 X1 X2 X3);  tauto.
  apply (rem_3233 X1 X2 X3);  tauto.
  apply (rem_3247 X1 X2 X3);  tauto.
  apply (rem_3248 X1 X2 X3);  tauto.
  apply (rem_3257 X1 X2 X3);  tauto.
Qed.

Remark rem_3259 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4.  tauto.
Defined.

Remark rem_3260 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto___type_4 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4.  case (rem_3259 epsilon_mknows_old_p__type_4). clear  epsilon_mknows_old_p__type_4. intros. apply trans___type_4_alice_1;  tauto.
 clear  epsilon_mknows_old_p__type_4. tauto.
Defined.

Remark rem_3261 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto_knows_old alice -> auto___type_4 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intro H. intros.
  elim (rem_354 H);  intros.
  apply (rem_3260 epsilon_mknows_old_p__type_4);  tauto.
Defined.

Remark rem_3262 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3263 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_3262 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3264 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3265 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_3264 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3266 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_3263 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_3265 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3267 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_4 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3266 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_noncea_old_1;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3268 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old (noncea_old X1 X2) -> auto___type_4 (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intro H. intros.
  elim (rem_362 X1 X2 H);  intros.
  apply (rem_3267 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
Defined.

Remark rem_3269 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto___type_4 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4.  case (rem_3259 epsilon_mknows_old_p__type_4). clear  epsilon_mknows_old_p__type_4. intros. apply trans___type_4_bob_1;  tauto.
 clear  epsilon_mknows_old_p__type_4. tauto.
Defined.

Remark rem_3270 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto_knows_old bob -> auto___type_4 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intro H. intros.
  elim (rem_365 H);  intros.
  apply (rem_3269 epsilon_mknows_old_p__type_4);  tauto.
Defined.

Remark rem_3271 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3272 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1. intros A1.
  cut (auto_knows_old X1). 2:apply (rem_3271 epsilon_mknows_old_p__type_4 X1);  assumption.
  tauto.
Defined.

Remark rem_3273 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto_knows_old X1 -> auto___type_4 (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1. intros A1.
  case (rem_3272 epsilon_mknows_old_p__type_4 X1 A1). clear  epsilon_mknows_old_p__type_4 A1. intros. apply trans___type_4_s_1;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1. tauto.
Defined.

Remark rem_3274 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto_knows_old (s X1) -> auto___type_4 (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1. intro H. intros.
  elim (rem_370 X1 H);  intros.
  apply (rem_3273 epsilon_mknows_old_p__type_4 X1);  tauto.
Defined.

Remark rem_3275 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto___type_4 nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4.  case (rem_3259 epsilon_mknows_old_p__type_4). clear  epsilon_mknows_old_p__type_4. intros. apply trans___type_4_nil_1;  tauto.
 clear  epsilon_mknows_old_p__type_4. tauto.
Defined.

Remark rem_3276 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto_knows_old nil -> auto___type_4 nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intro H. intros.
  elim (rem_373 H);  intros.
  apply (rem_3275 epsilon_mknows_old_p__type_4);  tauto.
Defined.

Remark rem_3277 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto___type_4 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4.  case (rem_3259 epsilon_mknows_old_p__type_4). clear  epsilon_mknows_old_p__type_4. intros. apply trans___type_4_i_1;  tauto.
 clear  epsilon_mknows_old_p__type_4. tauto.
Defined.

Remark rem_3278 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto_knows_old i -> auto___type_4 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intro H. intros.
  elim (rem_376 H);  intros.
  apply (rem_3277 epsilon_mknows_old_p__type_4);  tauto.
Defined.

Remark rem_3279 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_3271 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3280 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_old X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3281 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_3280 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3282 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_3279 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_3281 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3283 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_4 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3282 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_cons_1;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3284 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old (cons X1 X2) -> auto___type_4 (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intro H. intros.
  elim (rem_383 X1 X2 H);  intros.
  apply (rem_3283 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
Defined.

Remark rem_3285 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto___type_4 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4.  case (rem_3259 epsilon_mknows_old_p__type_4). clear  epsilon_mknows_old_p__type_4. intros. apply trans___type_4_server_1;  tauto.
 clear  epsilon_mknows_old_p__type_4. tauto.
Defined.

Remark rem_3286 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> auto_knows_old server -> auto___type_4 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intro H. intros.
  elim (rem_386 H);  intros.
  apply (rem_3285 epsilon_mknows_old_p__type_4);  tauto.
Defined.

Remark rem_3287 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3288 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_3287 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3289 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3290 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_3289 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3291 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_3288 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_3290 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3292 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_4 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3291 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_key_1;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3293 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3294 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_3293 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3295 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3296 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_3295 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3297 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_3294 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_3296 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3298 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_4 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3297 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_key_2;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3299 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old (key X1 X2) -> auto___type_4 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intro H. intros.
  elim (rem_330 X1 X2 H);  intros.
  apply (rem_3292 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
  apply (rem_3298 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
Defined.

Remark rem_3300 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_4 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3282 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_crypt_1;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3301 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3302 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_3301 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3303 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3304 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_3303 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3305 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_3302 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_3304 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3306 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_4 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3305 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_crypt_2;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3307 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3308 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_3307 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3309 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3310 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_3309 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3311 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_3308 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_3310 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3312 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_4 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3311 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_crypt_3;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3313 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto___def_44 X1 -> auto___def_44 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3314 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_3313 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3315 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto___type_9 X2 -> auto___type_9 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3316 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___type_9 X2 -> auto___type_9 X2). tauto. exact (rem_3315 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3317 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto___def_44 X1 /\ auto___type_9 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto___def_44 X1). 2:apply (rem_3314 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_3316 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3318 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_4 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3317 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_crypt_4;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3319 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto___def_42 X1 -> auto___def_42 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3320 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_3319 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3321 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto___type_8 X2 -> auto___type_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3322 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___type_8 X2 -> auto___type_8 X2). tauto. exact (rem_3321 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3323 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto___def_42 X1 /\ auto___type_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto___def_42 X1). 2:apply (rem_3320 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto___type_8 X2). 2:apply (rem_3322 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3324 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_4 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3323 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_crypt_5;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3325 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3326 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_3325 epsilon_mknows_old_p__type_4 X1).
Defined.

Remark rem_3327 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3328 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_3327 epsilon_mknows_old_p__type_4 X2).
Defined.

Remark rem_3329 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_3326 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_3328 epsilon_mknows_old_p__type_4 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3330 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_4 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intros A1 A2.
  case (rem_3329 epsilon_mknows_old_p__type_4 X1 X2 A1 A2). clear  epsilon_mknows_old_p__type_4 A1 A2. intros. apply trans___type_4_crypt_6;  tauto.
 clear  epsilon_mknows_old_p__type_4 A1 A2. tauto.
Defined.

Remark rem_3331 : (forall X:term, auto_knows_old X -> auto___type_4 X)
    -> forall X1 X2:term, auto_knows_old (crypt X1 X2) -> auto___type_4 (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_old_p__type_4. intros X1 X2. intro H. intros.
  elim (rem_350 X1 X2 H);  intros.
  apply (rem_3300 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
  apply (rem_3306 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
  apply (rem_3312 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
  apply (rem_3318 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
  apply (rem_3324 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
  apply (rem_3330 epsilon_mknows_old_p__type_4 X1 X2);  tauto.
Defined.

Remark rem_3332 : forall X1:term, auto_knows_old X1 -> auto___type_4 X1. (* Induct. *)
Proof.
  fix epsilon_mknows_old_p__type_4 1.
  intro X. case X.
  exact (rem_3261 epsilon_mknows_old_p__type_4 ).
  exact (rem_3270 epsilon_mknows_old_p__type_4 ).
  intros X1 X2;  exact (rem_3284 epsilon_mknows_old_p__type_4 X1 X2).
  intros X1 X2;  exact (rem_3331 epsilon_mknows_old_p__type_4 X1 X2).
  exact (rem_3278 epsilon_mknows_old_p__type_4 ).
  intros X1 X2;  exact (rem_3299 epsilon_mknows_old_p__type_4 X1 X2).
  exact (rem_3276 epsilon_mknows_old_p__type_4 ).
  intros X1 X2. intro H. elim (rem_437 X1 X2 H).
  intros X1 X2;  exact (rem_3268 epsilon_mknows_old_p__type_4 X1 X2).
  intros X1 X2. intro H. elim (rem_440 X1 X2 H).
  intros X1 X2. intro H. elim (rem_436 X1 X2 H).
   intro H. elim (rem_433  H).
   intro H. elim (rem_434  H).
  intros X1;  exact (rem_3274 epsilon_mknows_old_p__type_4 X1).
  exact (rem_3286 epsilon_mknows_old_p__type_4 ).
  intros X1 X2 X3. intro H. elim (rem_438 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_439 X1 X2 X3 H).
   intro H. elim (rem_435  H).
Qed.

Remark rem_3333 : forall X1 X2 X3 X4:term, auto___def_10 X2 -> auto_agent X3 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X4 -> auto___type_4 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_old X1 -> auto___type_4 X1). tauto. exact (rem_3332 X1).
Qed.

Remark rem_3334 : forall X1 X2 X3 X4:term, auto_knows_old X2 -> auto_agent X3 -> auto_knows_old X3 -> auto___def_10 X4 -> auto_knows_old X1 -> auto___type_4 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X3 X2.
  cut (auto___def_10 X2 -> auto_agent X3 -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old X4 -> auto___type_4 X1). tauto. exact (rem_3333 X1 X2 X3 X4).
Qed.

Remark rem_3335 : forall X1 X2 X3 X4:term, auto___def_22 X2 X3 X4 X1 -> auto___type_4 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_444 X2 X3 X4 X1 H);  intros.
  apply (rem_3334 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3336 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_2130 X1 X3 H);  intros.
Qed.

Remark rem_3337 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___def_38 (cons server nil) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3336 X1 X2 X3 X4).
Qed.

Remark rem_3338 : forall X1 X2 X3 X4:term, auto___type_7 X1 -> auto___def_38 (cons server nil) -> auto___def_27 X4 -> auto___def_31 X2 -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___def_38 (cons server nil) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___type_7 X1 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3337 X1 X2 X3 X4).
Qed.

Remark rem_3339 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_1371 X1 (cons server nil) H);  intros.
  apply (rem_3338 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3340 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_31 X2 -> auto___def_32 nil -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3339 X1 X2 X3 X4).
Qed.

Remark rem_3341 : forall X1 X2 X3 X4:term, auto___def_31 X2 -> auto___def_32 nil -> auto___def_27 X4 -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 X4 -> auto___def_31 X2 -> auto___def_32 nil -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3340 X1 X2 X3 X4).
Qed.

Remark rem_3342 : forall X1 X2 X3 X4:term, auto___def_27 X4 -> auto___def_28 (cons X2 nil) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_1375 X2 nil H);  intros.
  apply (rem_3341 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3343 : forall X1 X2 X3 X4:term, auto___def_26 (cons X4 (cons X2 nil)) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1377 X4 (cons X2 nil) H);  intros.
  apply (rem_3342 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3344 : forall X1 X2 X3 X4:term, auto___type_5 X3 -> auto___def_26 (cons X4 (cons X2 nil)) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_26 (cons X4 (cons X2 nil)) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___type_5 X3 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3343 X1 X2 X3 X4).
Qed.

Remark rem_3345 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1380 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_3344 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3346 : forall X1 X2 X3 X4:term, auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_29 sym -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3345 X1 X2 X3 X4).
Qed.

Remark rem_3347 : forall X1 X2 X3 X4:term, auto___def_29 sym -> auto___def_39 (cons X1 (cons server nil)) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_29 sym -> auto___def_39 (cons X1 (cons server nil)) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3346 X1 X2 X3 X4).
Qed.

Remark rem_3348 : forall X1 X2 X3 X4:term, auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_204 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_3347 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3349 : forall X1 X2 X3 X4:term, auto___type_4 (noncea_current X1 X3) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_25 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_4 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3348 X1 X2 X3 X4).
Qed.

Remark rem_3350 : forall X1 X2 X3 X4:term, auto___def_23 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_24 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1386 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_3349 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3351 : forall X1 X2 X3 X4:term, auto___def_27 (noncea_current X1 X3) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_35 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_612 X1 X3 H);  intros.
Qed.

Remark rem_3352 : forall X1 X2 X3 X4:term, auto___def_27 (noncea_current X1 X3) -> auto___def_35 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_27 (noncea_current X1 X3) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_35 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3351 X1 X2 X3 X4).
Qed.

Remark rem_3353 : forall X1 X2 X3 X4:term, auto___def_33 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_34 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1390 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_3352 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3354 : forall X1 X2 X3 X4:term, auto___def_72 (noncea_current X1 X3) -> auto___def_79 (key sym (cons X1 (cons server nil))) -> auto___def_80 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_115 X1 X3 H);  intros.
Qed.

Remark rem_3355 : forall X1 X2 X3 X4:term, auto___def_72 (noncea_current X1 X3) -> auto___def_80 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_79 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_72 (noncea_current X1 X3) -> auto___def_79 (key sym (cons X1 (cons server nil))) -> auto___def_80 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3354 X1 X2 X3 X4).
Qed.

Remark rem_3356 : forall X1 X2 X3 X4:term, auto___def_78 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_79 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1667 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_3355 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3357 : forall X1 X2 X3 X4:term, auto___def_89 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___type_19 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1669 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
Qed.

Remark rem_3358 : forall X1 X2 X3 X4:term, auto___def_60 X3 -> auto___def_61 (cons X4 (cons X2 nil)) -> auto___type_11 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_3208 X4 (cons X2 nil) H);  intros.
Qed.

Remark rem_3359 : forall X1 X2 X3 X4:term, auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1800 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_3358 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3360 : forall X1 X2 X3 X4:term, auto___def_14 (cons server nil) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3359 X1 X2 X3 X4).
Qed.

Remark rem_3361 : forall X1 X2 X3 X4:term, auto_agent X1 -> auto___def_14 (cons server nil) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_14 (cons server nil) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3360 X1 X2 X3 X4).
Qed.

Remark rem_3362 : forall X1 X2 X3 X4:term, auto___def_13 (cons X1 (cons server nil)) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_211 X1 (cons server nil) H);  intros.
  apply (rem_3361 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3363 : forall X1 X2 X3 X4:term, auto___def_12 sym -> auto___def_13 (cons X1 (cons server nil)) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_13 (cons X1 (cons server nil)) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3362 X1 X2 X3 X4).
Qed.

Remark rem_3364 : forall X1 X2 X3 X4:term, auto___def_58 (key sym (cons X1 (cons server nil))) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_259 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_3363 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3365 : forall X1 X2 X3 X4:term, auto___type_11 (noncea_current X1 X3) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_58 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_58 (key sym (cons X1 (cons server nil))) -> auto___def_59 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_11 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3364 X1 X2 X3 X4).
Qed.

Remark rem_3366 : forall X1 X2 X3 X4:term, auto___def_57 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_58 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1808 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_3365 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3367 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_658 X1).
Qed.

Remark rem_3368 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto___type_17 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_17 X1 -> auto___type_17 X1). tauto. exact (rem_2645 X1).
Qed.

Remark rem_3369 : forall X2:term, auto___def_76 X2 -> auto___def_76 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3370 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_76 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_76 X2 -> auto___def_76 X2). tauto. exact (rem_3369 X2).
Qed.

Remark rem_3371 : forall X3:term, auto___type_15 X3 -> auto___type_15 X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3372 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto___type_15 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_15 X3 -> auto___type_15 X3). tauto. exact (rem_3371 X3).
Qed.

Remark rem_3373 : forall X3:term, auto___type_15 X3 -> auto_agent X3. (* Induct. *)
Proof.
  fix epsilon_m__type_15_pagent 1.
  intro X. case X.
  exact (rem_453 epsilon_m__type_15_pagent ).
  exact (rem_456 epsilon_m__type_15_pagent ).
  intros X1 X2. intro H. elim (rem_468 X1 X2 H).
  intros X1 X2. intro H. elim (rem_474 X1 X2 H).
  exact (rem_459 epsilon_m__type_15_pagent ).
  intros X1 X2. intro H. elim (rem_470 X1 X2 H).
   intro H. elim (rem_466  H).
  intros X1 X2. intro H. elim (rem_472 X1 X2 H).
  intros X1 X2. intro H. elim (rem_463 X1 X2 H).
  intros X1 X2. intro H. elim (rem_476 X1 X2 H).
  intros X1 X2. intro H. elim (rem_471 X1 X2 H).
   intro H. elim (rem_464  H).
   intro H. elim (rem_467  H).
  intros X1. intro H. elim (rem_465 X1 H).
  exact (rem_462 epsilon_m__type_15_pagent ).
  intros X1 X2 X3. intro H. elim (rem_473 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_475 X1 X2 X3 H).
   intro H. elim (rem_469  H).
Qed.

Remark rem_3374 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto_agent X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_15 X3 -> auto_agent X3). tauto. exact (rem_3373 X3).
Qed.

Remark rem_3375 : forall X4:term, auto___def_72 X4 -> auto___def_72 X4. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3376 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_72 X4. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_72 X4 -> auto___def_72 X4). tauto. exact (rem_3375 X4).
Qed.

Remark rem_3377 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> (auto_agent X1 /\ auto___type_17 X1 /\ auto___def_76 X2 /\ auto___type_15 X3 /\ auto_agent X3 /\ auto___def_72 X4) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6.
  cut (auto_agent X1). 2:apply (rem_3367 X1 X2 X3 X4);  assumption.
  cut (auto___type_17 X1). 2:apply (rem_3368 X1 X2 X3 X4);  assumption.
  cut (auto___def_76 X2). 2:apply (rem_3370 X1 X2 X3 X4);  assumption.
  cut (auto___type_15 X3). 2:apply (rem_3372 X1 X2 X3 X4);  assumption.
  cut (auto_agent X3). 2:apply (rem_3374 X1 X2 X3 X4);  assumption.
  cut (auto___def_72 X4). 2:apply (rem_3376 X1 X2 X3 X4);  assumption.
  tauto.
Qed.

Remark rem_3378 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4. intros A1 A2 A3 A4 A5 A6.
  case (rem_3377 X1 X2 X3 X4 A1 A2 A3 A4 A5 A6). clear  A1 A2 A3 A4 A5 A6. intros. apply trans___def_85_1;  tauto.
 clear  A1 A2 A3 A4 A5 A6. tauto.
Qed.

Remark rem_3379 : forall X1 X2 X3 X4:term, auto_agent X1 -> auto_agent X3 -> auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_72 X4 -> auto___def_76 X2 -> auto___type_15 X3 -> auto___type_17 X1 -> auto_agent X3 -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3378 X1 X2 X3 X4).
Qed.

Remark rem_3380 : forall X1 X2:term, auto___type_14 (noncea_current X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3381 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___type_17 X1 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_3380 X1 X3 H);  intros.
  apply (rem_3379 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3382 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___def_83 (cons server nil) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___type_17 X1 -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_72 X4 -> auto___def_76 X2 -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___type_17 X1 -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3381 X1 X2 X3 X4).
Qed.

Remark rem_3383 : forall X1 X2 X3 X4:term, auto___type_17 X1 -> auto___def_83 (cons server nil) -> auto___def_72 X4 -> auto___def_76 X2 -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_72 X4 -> auto___def_76 X2 -> auto___def_83 (cons server nil) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___type_17 X1 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3382 X1 X2 X3 X4).
Qed.

Remark rem_3384 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_125 X1 (cons server nil) H);  intros.
  apply (rem_3383 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3385 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_76 X2 -> auto___def_77 nil -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_72 X4 -> auto___def_76 X2 -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3384 X1 X2 X3 X4).
Qed.

Remark rem_3386 : forall X1 X2 X3 X4:term, auto___def_76 X2 -> auto___def_77 nil -> auto___def_72 X4 -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_72 X4 -> auto___def_76 X2 -> auto___def_77 nil -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3385 X1 X2 X3 X4).
Qed.

Remark rem_3387 : forall X1 X2:term, auto___def_73 (cons X1 X2) -> or_1
    (auto___def_76 X1 /\ auto___def_77 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3388 : forall X1 X2 X3 X4:term, auto___def_72 X4 -> auto___def_73 (cons X2 nil) -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_3387 X2 nil H);  intros.
  apply (rem_3386 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3389 : forall X1 X2 X3 X4:term, auto___def_71 (cons X4 (cons X2 nil)) -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_3225 X4 (cons X2 nil) H);  intros.
  apply (rem_3388 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3390 : forall X1 X2 X3 X4:term, auto___type_15 X3 -> auto___def_71 (cons X4 (cons X2 nil)) -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_71 (cons X4 (cons X2 nil)) -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___type_15 X3 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3389 X1 X2 X3 X4).
Qed.

Remark rem_3391 : forall X1 X2 X3 X4:term, auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1814 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_3390 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3392 : forall X1 X2 X3 X4:term, auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_74 sym -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3391 X1 X2 X3 X4).
Qed.

Remark rem_3393 : forall X1 X2 X3 X4:term, auto___def_74 sym -> auto___def_84 (cons X1 (cons server nil)) -> auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_74 sym -> auto___def_84 (cons X1 (cons server nil)) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3392 X1 X2 X3 X4).
Qed.

Remark rem_3394 : forall X1 X2 X3 X4:term, auto___def_69 (key sym (cons X1 (cons server nil))) -> auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_147 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_3393 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3395 : forall X1 X2 X3 X4:term, auto___type_14 (noncea_current X1 X3) -> auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_69 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_69 (key sym (cons X1 (cons server nil))) -> auto___def_70 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_14 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3394 X1 X2 X3 X4).
Qed.

Remark rem_3396 : forall X1 X2 X3 X4:term, auto___def_68 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_69 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1820 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_3395 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3397 : forall X1 X2 X3 X4:term, auto___def_50 (cons X1 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_39 X1 (cons server nil) H);  intros.
Qed.

Remark rem_3398 : forall X1 X2 X3 X4:term, auto___def_49 sym -> auto___def_50 (cons X1 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_50 (cons X1 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3397 X1 X2 X3 X4).
Qed.

Remark rem_3399 : forall X1 X2 X3 X4:term, auto___def_48 (cons X1 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1217 X1 (cons server nil) H);  intros.
Qed.

Remark rem_3400 : forall X1 X2 X3 X4:term, auto___def_47 sym -> auto___def_48 (cons X1 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_48 (cons X1 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3399 X1 X2 X3 X4).
Qed.

Remark rem_3401 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_46 sym -> False). tauto.
  exact (rem_1157).
Qed.

Remark rem_3402 : forall X1 X2 X3 X4:term, auto___def_46 sym -> auto___type_10 (cons X1 (cons server nil)) -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2 X3 X4. intros. apply (rem_3401 X1 X2 X3 X4);  assumption.
Qed.

Remark rem_3403 : forall X1 X2 X3 X4:term, auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2 H3. intro H. intros.
  elim (rem_99 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_3398 X1 X2 X3 X4);  tauto.
  apply (rem_3400 X1 X2 X3 X4);  tauto.
  apply (rem_3402 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3404 : forall X1 X2 X3 X4:term, auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current nil -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3403 X1 X2 X3 X4).
Qed.

Remark rem_3405 : forall X1 X2 X3 X4:term, auto_knows_current X2 -> auto_knows_current nil -> auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current X2 -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current nil -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3404 X1 X2 X3 X4).
Qed.

Remark rem_3406 : forall X1 X2 X3 X4:term, auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current (cons X2 nil) -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1 H2. intro H. intros.
  elim (rem_1520 X2 nil H);  intros.
  apply (rem_3405 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3407 : forall X1 X2 X3 X4:term, auto_knows_current X4 -> auto_knows_current (cons X2 nil) -> auto_knows_current X3 -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current X3 -> auto_knows_current X4 -> auto_knows_current (cons X2 nil) -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3406 X1 X2 X3 X4).
Qed.

Remark rem_3408 : forall X1 X2 X3 X4:term, auto_knows_current X3 -> auto_knows_current (cons X4 (cons X2 nil)) -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_1520 X4 (cons X2 nil) H);  intros.
  apply (rem_3407 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3409 : forall X1 X2 X3 X4:term, auto_knows_current (cons X3 (cons X4 (cons X2 nil))) -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1520 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_3408 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3410 : forall X1 X2 X3 X4:term, auto_knows_current (noncea_current X1 X3) -> auto_knows_current (cons X3 (cons X4 (cons X2 nil))) -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto_knows_current (cons X3 (cons X4 (cons X2 nil))) -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto_knows_current (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3409 X1 X2 X3 X4).
Qed.

Remark rem_3411 : forall X1 X2 X3 X4:term, auto_knows_current (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto_knows_current (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1520 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_3410 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3412 : forall X1 X2 X3 X4:term, auto___def_87 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___type_18 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1835 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
Qed.

Remark rem_3413 : forall X1 X2 X3 X4:term, auto___def_10 X3 -> auto___def_11 (cons X4 (cons X2 nil)) -> auto___type_1 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intros H1. intro H. intros.
  elim (rem_1394 X4 (cons X2 nil) H);  intros.
Qed.

Remark rem_3414 : forall X1 X2 X3 X4:term, auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1396 X3 (cons X4 (cons X2 nil)) H);  intros.
  apply (rem_3413 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3415 : forall X1 X2 X3 X4:term, auto___def_14 (cons server nil) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3414 X1 X2 X3 X4).
Qed.

Remark rem_3416 : forall X1 X2 X3 X4:term, auto_agent X1 -> auto___def_14 (cons server nil) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_14 (cons server nil) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto_agent X1 -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3415 X1 X2 X3 X4).
Qed.

Remark rem_3417 : forall X1 X2 X3 X4:term, auto___def_13 (cons X1 (cons server nil)) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_211 X1 (cons server nil) H);  intros.
  apply (rem_3416 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3418 : forall X1 X2 X3 X4:term, auto___def_12 sym -> auto___def_13 (cons X1 (cons server nil)) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Split. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_13 (cons X1 (cons server nil)) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto.
  exact (rem_3417 X1 X2 X3 X4).
Qed.

Remark rem_3419 : forall X1 X2 X3 X4:term, auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_234 sym (cons X1 (cons server nil)) H);  intros.
  apply (rem_3418 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3420 : forall X1 X2 X3 X4:term, auto___type_1 (noncea_current X1 X3) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4.
  cut (auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_9 (cons X3 (cons X4 (cons X2 nil))) -> auto___type_1 (noncea_current X1 X3) -> auto___def_85 X1 X2 X3 X4). tauto. exact (rem_3419 X1 X2 X3 X4).
Qed.

Remark rem_3421 : forall X1 X2 X3 X4:term, auto___def_7 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) -> auto___def_8 (key sym (cons X1 (cons server nil))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1404 (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil))) H);  intros.
  apply (rem_3420 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3422 : forall X1 X2 X3 X4:term, auto_knows_current (crypt (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) (key sym (cons X1 (cons server nil)))) -> auto___def_85 X1 X2 X3 X4. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1604 (cons (noncea_current X1 X3) (cons X3 (cons X4 (cons X2 nil)))) (key sym (cons X1 (cons server nil))) H);  intros.
  apply (rem_3350 X1 X2 X3 X4);  tauto.
  apply (rem_3353 X1 X2 X3 X4);  tauto.
  apply (rem_3356 X1 X2 X3 X4);  tauto.
  apply (rem_3357 X1 X2 X3 X4);  tauto.
  apply (rem_3366 X1 X2 X3 X4);  tauto.
  apply (rem_3396 X1 X2 X3 X4);  tauto.
  apply (rem_3411 X1 X2 X3 X4);  tauto.
  apply (rem_3412 X1 X2 X3 X4);  tauto.
  apply (rem_3421 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3423 : forall X1:term, auto___def_64 X1 -> auto___def_64 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3424 : forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> auto___def_64 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_64 X1 -> auto___def_64 X1). tauto. exact (rem_3423 X1).
Qed.

Remark rem_3425 : forall X2:term, auto___def_65 X2 -> auto___def_65 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3426 : forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> auto___def_65 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_65 X2 -> auto___def_65 X2). tauto. exact (rem_3425 X2).
Qed.

Remark rem_3427 : forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> (auto___def_64 X1 /\ auto___def_65 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_64 X1). 2:apply (rem_3424 X1 X2);  assumption.
  cut (auto___def_65 X2). 2:apply (rem_3426 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3428 : forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> auto___def_63 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_3427 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_63_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_3429 : forall X1 X2:term, auto___def_65 X2 -> auto___def_64 X1 -> auto___def_63 (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_64 X1 -> auto___def_65 X2 -> auto___def_63 (cons X1 X2)). tauto. exact (rem_3428 X1 X2).
Qed.

Remark rem_3430 : forall X1 X2 X3:term, auto___def_48 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1217 X2 (cons server nil) H);  intros.
Qed.

Remark rem_3431 : forall X1 X2 X3:term, auto___def_47 sym -> auto___def_48 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_48 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3430 X1 X2 X3).
Qed.

Remark rem_3432 : forall X1 X2 X3:term, auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_436 X1 X2 H);  intros.
Qed.

Remark rem_3433 : forall X1 X2 X3:term, auto___def_46 sym -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3432 X1 X2 X3).
Qed.

Remark rem_3434 : forall X1 X2 X3:term, auto___def_46 sym -> auto___type_10 (cons X2 (cons server nil)) -> auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2 X3. intros. apply (rem_3433 X1 X2 X3);  assumption.
Qed.

Remark rem_3435 : forall X1 X2 X3:term, auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_330 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3431 X1 X2 X3);  tauto.
  apply (rem_3434 X1 X2 X3);  tauto.
Qed.

Remark rem_3436 : forall X1 X2 X3:term, auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old nil -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3435 X1 X2 X3).
Qed.

Remark rem_3437 : forall X1 X2 X3:term, auto_knows_old X1 -> auto_knows_old nil -> auto_knows_old X3 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_knows_old X3 -> auto_knows_old X1 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old nil -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto. exact (rem_3436 X1 X2 X3).
Qed.

Remark rem_3438 : forall X1 X2 X3:term, auto_knows_old X3 -> auto_knows_old (cons X1 nil) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_383 X1 nil H);  intros.
  apply (rem_3437 X1 X2 X3);  tauto.
Qed.

Remark rem_3439 : forall X1 X2 X3:term, auto_knows_old (nonceb_old X1 X2) -> auto_knows_old (cons X1 nil) -> auto_knows_old X3 -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto_knows_old X3 -> auto_knows_old (cons X1 nil) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto_knows_old (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto. exact (rem_3438 X1 X2 X3).
Qed.

Remark rem_3440 : forall X1 X2 X3:term, auto_knows_old X3 -> auto_knows_old (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_383 (nonceb_old X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3439 X1 X2 X3);  tauto.
Qed.

Remark rem_3441 : forall X1 X2 X3:term, auto_knows_old (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) -> auto_knows_old (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_383 X3 (cons (nonceb_old X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3440 X1 X2 X3);  tauto.
Qed.

Remark rem_3442 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___type_7 X2 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1 H2. intro H. intros.
  elim (rem_1354 X1 X2 H);  intros.
Qed.

Remark rem_3443 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___def_38 (cons server nil) -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___type_7 X2 -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X1 -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___type_7 X2 -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3442 X1 X2 X3).
Qed.

Remark rem_3444 : forall X1 X2 X3:term, auto___type_7 X2 -> auto___def_38 (cons server nil) -> auto___def_27 X1 -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X1 -> auto___def_38 (cons server nil) -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___type_7 X2 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3443 X1 X2 X3).
Qed.

Remark rem_3445 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1371 X2 (cons server nil) H);  intros.
  apply (rem_3444 X1 X2 X3);  tauto.
Qed.

Remark rem_3446 : forall X1 X2 X3:term, auto___def_27 X1 -> auto___def_28 nil -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X1 -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3445 X1 X2 X3).
Qed.

Remark rem_3447 : forall X1 X2 X3:term, auto___def_26 (cons X1 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1377 X1 nil H);  intros.
  apply (rem_3446 X1 X2 X3);  tauto.
Qed.

Remark rem_3448 : forall X1 X2 X3:term, auto___type_5 (nonceb_old X1 X2) -> auto___def_26 (cons X1 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_26 (cons X1 nil) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___type_5 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto. exact (rem_3447 X1 X2 X3).
Qed.

Remark rem_3449 : forall X1 X2 X3:term, auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1380 (nonceb_old X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3448 X1 X2 X3);  tauto.
Qed.

Remark rem_3450 : forall X1 X2 X3:term, auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3449 X1 X2 X3).
Qed.

Remark rem_3451 : forall X1 X2 X3:term, auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_29 sym -> auto___def_39 (cons X2 (cons server nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3450 X1 X2 X3).
Qed.

Remark rem_3452 : forall X1 X2 X3:term, auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_204 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3451 X1 X2 X3);  tauto.
Qed.

Remark rem_3453 : forall X1 X2 X3:term, auto___type_4 X3 -> auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_25 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_4 X3 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3452 X1 X2 X3).
Qed.

Remark rem_3454 : forall X1 X2 X3:term, auto___def_23 (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) -> auto___def_24 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1386 X3 (cons (nonceb_old X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3453 X1 X2 X3);  tauto.
Qed.

Remark rem_3455 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old.  tauto.
Defined.

Remark rem_3456 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto_knows_old alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old.  case (rem_3455 epsilon_m__type_7_pknows_old). clear  epsilon_m__type_7_pknows_old. intros. apply trans_knows_old_alice_1;  tauto.
 clear  epsilon_m__type_7_pknows_old. tauto.
Defined.

Remark rem_3457 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto___type_7 alice -> auto_knows_old alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intro H. intros.
  elim (rem_2332 H);  intros.
  apply (rem_3456 epsilon_m__type_7_pknows_old);  tauto.
Defined.

Remark rem_3458 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3459 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_3458 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3460 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3461 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_3460 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3462 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_3459 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_3461 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3463 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_old (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3462 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_noncea_old_1;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3464 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_7 (noncea_old X1 X2) -> auto_knows_old (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_2336 X1 X2 H);  intros.
  apply (rem_3463 epsilon_m__type_7_pknows_old X1 X2);  tauto.
Defined.

Remark rem_3465 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto_knows_old bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old.  case (rem_3455 epsilon_m__type_7_pknows_old). clear  epsilon_m__type_7_pknows_old. intros. apply trans_knows_old_bob_1;  tauto.
 clear  epsilon_m__type_7_pknows_old. tauto.
Defined.

Remark rem_3466 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto___type_7 bob -> auto_knows_old bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intro H. intros.
  elim (rem_2339 H);  intros.
  apply (rem_3465 epsilon_m__type_7_pknows_old);  tauto.
Defined.

Remark rem_3467 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3468 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1. intros A1.
  cut (auto_knows_old X1). 2:apply (rem_3467 epsilon_m__type_7_pknows_old X1);  assumption.
  tauto.
Defined.

Remark rem_3469 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1. intros A1.
  case (rem_3468 epsilon_m__type_7_pknows_old X1 A1). clear  epsilon_m__type_7_pknows_old A1. intros. apply trans_knows_old_s_1;  tauto.
 clear  epsilon_m__type_7_pknows_old A1. tauto.
Defined.

Remark rem_3470 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___type_7 (s X1) -> auto_knows_old (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1. intro H. intros.
  elim (rem_2344 X1 H);  intros.
  apply (rem_3469 epsilon_m__type_7_pknows_old X1);  tauto.
Defined.

Remark rem_3471 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto_knows_old nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old.  case (rem_3455 epsilon_m__type_7_pknows_old). clear  epsilon_m__type_7_pknows_old. intros. apply trans_knows_old_nil_1;  tauto.
 clear  epsilon_m__type_7_pknows_old. tauto.
Defined.

Remark rem_3472 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto___type_7 nil -> auto_knows_old nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intro H. intros.
  elim (rem_2347 H);  intros.
  apply (rem_3471 epsilon_m__type_7_pknows_old);  tauto.
Defined.

Remark rem_3473 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto_knows_old i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old.  case (rem_3455 epsilon_m__type_7_pknows_old). clear  epsilon_m__type_7_pknows_old. intros. apply trans_knows_old_i_1;  tauto.
 clear  epsilon_m__type_7_pknows_old. tauto.
Defined.

Remark rem_3474 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto___type_7 i -> auto_knows_old i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intro H. intros.
  elim (rem_2350 H);  intros.
  apply (rem_3473 epsilon_m__type_7_pknows_old);  tauto.
Defined.

Remark rem_3475 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_3467 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3476 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_old X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3477 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_3476 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3478 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_3475 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_3477 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3479 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3478 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_cons_1;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3480 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_7 (cons X1 X2) -> auto_knows_old (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_2357 X1 X2 H);  intros.
  apply (rem_3479 epsilon_m__type_7_pknows_old X1 X2);  tauto.
Defined.

Remark rem_3481 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto_knows_old server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old.  case (rem_3455 epsilon_m__type_7_pknows_old). clear  epsilon_m__type_7_pknows_old. intros. apply trans_knows_old_server_1;  tauto.
 clear  epsilon_m__type_7_pknows_old. tauto.
Defined.

Remark rem_3482 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> auto___type_7 server -> auto_knows_old server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intro H. intros.
  elim (rem_2360 H);  intros.
  apply (rem_3481 epsilon_m__type_7_pknows_old);  tauto.
Defined.

Remark rem_3483 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3484 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_3483 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3485 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3486 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_3485 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3487 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_3484 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_3486 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3488 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_old (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3487 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_key_1;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3489 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3490 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_3489 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3491 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3492 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_3491 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3493 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_3490 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_3492 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3494 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_old (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3493 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_key_2;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3495 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_7 (key X1 X2) -> auto_knows_old (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_2374 X1 X2 H);  intros.
  apply (rem_3488 epsilon_m__type_7_pknows_old X1 X2);  tauto.
  apply (rem_3494 epsilon_m__type_7_pknows_old X1 X2);  tauto.
Defined.

Remark rem_3496 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3478 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_crypt_1;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3497 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3498 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_3497 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3499 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3500 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_3499 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3501 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_3498 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_3500 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3502 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3501 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_crypt_2;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3503 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3504 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_3503 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3505 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3506 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_3505 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3507 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_3504 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_3506 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3508 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3507 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_crypt_3;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3509 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___def_44 X1 -> auto___def_44 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3510 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_3509 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3511 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto___type_9 X2 -> auto___type_9 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3512 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___type_9 X2 -> auto___type_9 X2). tauto. exact (rem_3511 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3513 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto___def_44 X1 /\ auto___type_9 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_44 X1). 2:apply (rem_3510 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_3512 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3514 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3513 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_crypt_4;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3515 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___def_42 X1 -> auto___def_42 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3516 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_3515 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3517 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto___type_8 X2 -> auto___type_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3518 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___type_8 X2 -> auto___type_8 X2). tauto. exact (rem_3517 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3519 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto___def_42 X1 /\ auto___type_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_42 X1). 2:apply (rem_3516 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto___type_8 X2). 2:apply (rem_3518 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3520 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3519 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_crypt_5;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3521 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3522 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_3521 epsilon_m__type_7_pknows_old X1).
Defined.

Remark rem_3523 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3524 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_3523 epsilon_m__type_7_pknows_old X2).
Defined.

Remark rem_3525 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_3522 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_3524 epsilon_m__type_7_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3526 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3525 epsilon_m__type_7_pknows_old X1 X2 A1 A2). clear  epsilon_m__type_7_pknows_old A1 A2. intros. apply trans_knows_old_crypt_6;  tauto.
 clear  epsilon_m__type_7_pknows_old A1 A2. tauto.
Defined.

Remark rem_3527 : (forall X:term, auto___type_7 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_7 (crypt X1 X2) -> auto_knows_old (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_7_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_2407 X1 X2 H);  intros.
  apply (rem_3496 epsilon_m__type_7_pknows_old X1 X2);  tauto.
  apply (rem_3502 epsilon_m__type_7_pknows_old X1 X2);  tauto.
  apply (rem_3508 epsilon_m__type_7_pknows_old X1 X2);  tauto.
  apply (rem_3514 epsilon_m__type_7_pknows_old X1 X2);  tauto.
  apply (rem_3520 epsilon_m__type_7_pknows_old X1 X2);  tauto.
  apply (rem_3526 epsilon_m__type_7_pknows_old X1 X2);  tauto.
Defined.

Remark rem_3528 : forall X1:term, auto___type_7 X1 -> auto_knows_old X1. (* Induct. *)
Proof.
  fix epsilon_m__type_7_pknows_old 1.
  intro X. case X.
  exact (rem_3457 epsilon_m__type_7_pknows_old ).
  exact (rem_3466 epsilon_m__type_7_pknows_old ).
  intros X1 X2;  exact (rem_3480 epsilon_m__type_7_pknows_old X1 X2).
  intros X1 X2;  exact (rem_3527 epsilon_m__type_7_pknows_old X1 X2).
  exact (rem_3474 epsilon_m__type_7_pknows_old ).
  intros X1 X2;  exact (rem_3495 epsilon_m__type_7_pknows_old X1 X2).
  exact (rem_3472 epsilon_m__type_7_pknows_old ).
  intros X1 X2. intro H. elim (rem_2413 X1 X2 H).
  intros X1 X2;  exact (rem_3464 epsilon_m__type_7_pknows_old X1 X2).
  intros X1 X2. intro H. elim (rem_2416 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2412 X1 X2 H).
   intro H. elim (rem_2409  H).
   intro H. elim (rem_2410  H).
  intros X1;  exact (rem_3470 epsilon_m__type_7_pknows_old X1).
  exact (rem_3482 epsilon_m__type_7_pknows_old ).
  intros X1 X2 X3. intro H. elim (rem_2414 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2415 X1 X2 X3 H).
   intro H. elim (rem_2411  H).
Qed.

Remark rem_3529 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_7 X1 -> auto_knows_old X1). tauto. exact (rem_3528 X1).
Qed.

Remark rem_3530 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___type_5 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_5 X2 -> auto___type_5 X2). tauto. exact (rem_2016 X2).
Qed.

Remark rem_3531 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_5 X2 -> auto_agent X2). tauto. exact (rem_2018 X2).
Qed.

Remark rem_3532 : forall X3:term, auto___def_27 X3 -> auto___def_27 X3. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3533 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_27 X3. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_27 X3). tauto. exact (rem_3532 X3).
Qed.

Remark rem_3534 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> (auto_knows_old X1 /\ auto___type_5 X2 /\ auto_agent X2 /\ auto___def_27 X3) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4 A5.
  cut (auto_knows_old X1). 2:apply (rem_3529 X1 X2 X3);  assumption.
  cut (auto___type_5 X2). 2:apply (rem_3530 X1 X2 X3);  assumption.
  cut (auto_agent X2). 2:apply (rem_3531 X1 X2 X3);  assumption.
  cut (auto___def_27 X3). 2:apply (rem_3533 X1 X2 X3);  assumption.
  tauto.
Qed.

Remark rem_3535 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_41 X1 X2 X3. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4 A5.
  case (rem_3534 X1 X2 X3 A1 A2 A3 A4 A5). clear  A1 A2 A3 A4 A5. intros. apply trans___def_41_1;  tauto.
 clear  A1 A2 A3 A4 A5. tauto.
Qed.

Remark rem_3536 : forall X1 X2 X3:term, auto___type_5 X2 -> auto___def_38 (cons server nil) -> auto___def_27 X3 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_38 (cons server nil) -> auto___type_5 X2 -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3535 X1 X2 X3).
Qed.

Remark rem_3537 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_291 X2 (cons server nil) H);  intros.
  apply (rem_3536 X1 X2 X3);  tauto.
Qed.

Remark rem_3538 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_32 nil -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3537 X1 X2 X3).
Qed.

Remark rem_3539 : forall X1 X2 X3:term, auto___type_7 X1 -> auto___def_32 nil -> auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_32 nil -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_old X1 X2) -> auto___type_7 X1 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3538 X1 X2 X3).
Qed.

Remark rem_3540 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_36 (cons X1 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_2424 X1 nil H);  intros.
  apply (rem_3539 X1 X2 X3);  tauto.
Qed.

Remark rem_3541 : forall X1 X2 X3:term, auto___type_6 (nonceb_old X1 X2) -> auto___def_36 (cons X1 nil) -> auto___def_27 X3 -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_36 (cons X1 nil) -> auto___def_37 (cons X2 (cons server nil)) -> auto___type_6 (nonceb_old X1 X2) -> auto___def_41 X1 X2 X3). tauto. exact (rem_3540 X1 X2 X3).
Qed.

Remark rem_3542 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_1658 (nonceb_old X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3541 X1 X2 X3);  tauto.
Qed.

Remark rem_3543 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_29 sym -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3542 X1 X2 X3).
Qed.

Remark rem_3544 : forall X1 X2 X3:term, auto___def_29 sym -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_27 X3 -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_29 sym -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_37 (cons X2 (cons server nil)) -> auto___def_41 X1 X2 X3). tauto. exact (rem_3543 X1 X2 X3).
Qed.

Remark rem_3545 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intros H1. intro H. intros.
  elim (rem_313 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3544 X1 X2 X3);  tauto.
Qed.

Remark rem_3546 : forall X1 X2 X3:term, auto___def_27 X3 -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_27 X3 -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_35 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_41 X1 X2 X3). tauto. exact (rem_3545 X1 X2 X3).
Qed.

Remark rem_3547 : forall X1 X2 X3:term, auto___def_33 (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) -> auto___def_34 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1390 X3 (cons (nonceb_old X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3546 X1 X2 X3);  tauto.
Qed.

Remark rem_3548 : forall X1 X2 X3:term, auto___def_44 (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) -> auto___type_9 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_803 X3 (cons (nonceb_old X1 X2) (cons X1 nil)) H);  intros.
Qed.

Remark rem_3549 : forall X1 X2 X3:term, auto___def_42 (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) -> auto___type_8 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_778 X3 (cons (nonceb_old X1 X2) (cons X1 nil)) H);  intros.
Qed.

Remark rem_3550 : forall X1 X2 X3:term, auto___def_11 (cons X1 nil) -> auto___type_1 X3 -> auto_agent X2 -> auto_knows_old X1 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1394 X1 nil H);  intros.
Qed.

Remark rem_3551 : forall X1 X2 X3:term, auto_knows_old X1 -> auto_agent X2 -> auto___def_11 (cons X1 nil) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_11 (cons X1 nil) -> auto___type_1 X3 -> auto_agent X2 -> auto_knows_old X1 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3550 X1 X2 X3).
Qed.

Remark rem_3552 : forall X1 X2 X3:term, auto___def_10 (nonceb_old X1 X2) -> auto___def_11 (cons X1 nil) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1443 X1 X2 H);  intros.
  apply (rem_3551 X1 X2 X3);  tauto.
Qed.

Remark rem_3553 : forall X1 X2 X3:term, auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1396 (nonceb_old X1 X2) (cons X1 nil) H);  intros.
  apply (rem_3552 X1 X2 X3);  tauto.
Qed.

Remark rem_3554 : forall X1 X2 X3:term, auto___def_14 (cons server nil) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3553 X1 X2 X3).
Qed.

Remark rem_3555 : forall X1 X2 X3:term, auto_agent X2 -> auto___def_14 (cons server nil) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_14 (cons server nil) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto_agent X2 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3554 X1 X2 X3).
Qed.

Remark rem_3556 : forall X1 X2 X3:term, auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_211 X2 (cons server nil) H);  intros.
  apply (rem_3555 X1 X2 X3);  tauto.
Qed.

Remark rem_3557 : forall X1 X2 X3:term, auto___def_12 sym -> auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_41 X1 X2 X3. (* Split. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_13 (cons X2 (cons server nil)) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_41 X1 X2 X3). tauto.
  exact (rem_3556 X1 X2 X3).
Qed.

Remark rem_3558 : forall X1 X2 X3:term, auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_234 sym (cons X2 (cons server nil)) H);  intros.
  apply (rem_3557 X1 X2 X3);  tauto.
Qed.

Remark rem_3559 : forall X1 X2 X3:term, auto___type_1 X3 -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_9 (cons (nonceb_old X1 X2) (cons X1 nil)) -> auto___type_1 X3 -> auto___def_41 X1 X2 X3). tauto. exact (rem_3558 X1 X2 X3).
Qed.

Remark rem_3560 : forall X1 X2 X3:term, auto___def_7 (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) -> auto___def_8 (key sym (cons X2 (cons server nil))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_1404 X3 (cons (nonceb_old X1 X2) (cons X1 nil)) H);  intros.
  apply (rem_3559 X1 X2 X3);  tauto.
Qed.

Remark rem_3561 : forall X1 X2 X3:term, auto_knows_old (crypt (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) (key sym (cons X2 (cons server nil)))) -> auto___def_41 X1 X2 X3. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_350 (cons X3 (cons (nonceb_old X1 X2) (cons X1 nil))) (key sym (cons X2 (cons server nil))) H);  intros.
  apply (rem_3441 X1 X2 X3);  tauto.
  apply (rem_3454 X1 X2 X3);  tauto.
  apply (rem_3547 X1 X2 X3);  tauto.
  apply (rem_3548 X1 X2 X3);  tauto.
  apply (rem_3549 X1 X2 X3);  tauto.
  apply (rem_3560 X1 X2 X3);  tauto.
Qed.

Remark rem_3562 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17.  tauto.
Defined.

Remark rem_3563 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_17 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17.  case (rem_3562 epsilon_m__type_1_p__type_17). clear  epsilon_m__type_1_p__type_17. intros. apply trans___type_17_alice_1;  tauto.
 clear  epsilon_m__type_1_p__type_17. tauto.
Defined.

Remark rem_3564 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_1 alice -> auto___type_17 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intro H. intros.
  elim (rem_707 H);  intros.
  apply (rem_3563 epsilon_m__type_1_p__type_17);  tauto.
Defined.

Remark rem_3565 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  tauto.
Defined.

Remark rem_3566 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_17 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3565 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_noncea_old_1;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3567 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___type_1 (noncea_old X1 X2) -> auto___type_17 (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_711 X1 X2 H);  intros.
  apply (rem_3566 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3568 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_17 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17.  case (rem_3562 epsilon_m__type_1_p__type_17). clear  epsilon_m__type_1_p__type_17. intros. apply trans___type_17_bob_1;  tauto.
 clear  epsilon_m__type_1_p__type_17. tauto.
Defined.

Remark rem_3569 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_1 bob -> auto___type_17 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intro H. intros.
  elim (rem_714 H);  intros.
  apply (rem_3568 epsilon_m__type_1_p__type_17);  tauto.
Defined.

Remark rem_3570 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_1_p__type_17. exact (rem_926).
Defined.

Remark rem_3571 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_3570 epsilon_m__type_1_p__type_17 X1);  assumption.
  tauto.
Defined.

Remark rem_3572 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto_knows_old X1 -> auto___type_17 (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1. intros A1.
  case (rem_3571 epsilon_m__type_1_p__type_17 X1 A1). clear  epsilon_m__type_1_p__type_17 A1. intros. apply trans___type_17_s_1;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1. tauto.
Defined.

Remark rem_3573 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___type_1 (s X1) -> auto___type_17 (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1. intro H. intros.
  elim (rem_930 X1 H);  intros.
  apply (rem_3572 epsilon_m__type_1_p__type_17 X1);  tauto.
Defined.

Remark rem_3574 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_17 nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17.  case (rem_3562 epsilon_m__type_1_p__type_17). clear  epsilon_m__type_1_p__type_17. intros. apply trans___type_17_nil_1;  tauto.
 clear  epsilon_m__type_1_p__type_17. tauto.
Defined.

Remark rem_3575 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_1 nil -> auto___type_17 nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intro H. intros.
  elim (rem_933 H);  intros.
  apply (rem_3574 epsilon_m__type_1_p__type_17);  tauto.
Defined.

Remark rem_3576 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_17 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17.  case (rem_3562 epsilon_m__type_1_p__type_17). clear  epsilon_m__type_1_p__type_17. intros. apply trans___type_17_i_1;  tauto.
 clear  epsilon_m__type_1_p__type_17. tauto.
Defined.

Remark rem_3577 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_1 i -> auto___type_17 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intro H. intros.
  elim (rem_936 H);  intros.
  apply (rem_3576 epsilon_m__type_1_p__type_17);  tauto.
Defined.

Remark rem_3578 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_current X1). tauto. exact (rem_3570 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3579 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto_knows_old X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_1_p__type_17. exact (rem_939).
Defined.

Remark rem_3580 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_current X2). tauto. exact (rem_3579 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3581 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_3578 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_3580 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3582 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_17 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3581 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_cons_1;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3583 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___type_1 (cons X1 X2) -> auto___type_17 (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_944 X1 X2 H);  intros.
  apply (rem_3582 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3584 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_17 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17.  case (rem_3562 epsilon_m__type_1_p__type_17). clear  epsilon_m__type_1_p__type_17. intros. apply trans___type_17_server_1;  tauto.
 clear  epsilon_m__type_1_p__type_17. tauto.
Defined.

Remark rem_3585 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> auto___type_1 server -> auto___type_17 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intro H. intros.
  elim (rem_947 H);  intros.
  apply (rem_3584 epsilon_m__type_1_p__type_17);  tauto.
Defined.

Remark rem_3586 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3587 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_3586 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3588 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3589 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_3588 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3590 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_3587 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_3589 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3591 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_17 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3590 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_key_2;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3592 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3593 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_3592 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3594 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3595 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_3594 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3596 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_3593 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_3595 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3597 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_17 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3596 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_key_3;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3598 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___type_1 (key X1 X2) -> auto___type_17 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_961 X1 X2 H);  intros.
  apply (rem_3591 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
  apply (rem_3597 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3599 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3581 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_crypt_7;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3600 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3601 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_3600 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3602 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3603 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_3602 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3604 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_3601 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_3603 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3605 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3604 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_crypt_1;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3606 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3607 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_3606 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3608 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3609 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_3608 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3610 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_3607 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_3609 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3611 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3610 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_crypt_2;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3612 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___def_44 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_1_p__type_17. exact (rem_813).
Defined.

Remark rem_3613 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_44 X1 -> auto_knows_current X1). tauto. exact (rem_3612 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3614 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto___type_9 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_1_p__type_17. exact (rem_883).
Defined.

Remark rem_3615 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___type_9 X2 -> auto_knows_current X2). tauto. exact (rem_3614 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3616 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_3613 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_3615 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3617 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3616 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_crypt_7;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3618 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___def_42 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__type_1_p__type_17. exact (rem_787).
Defined.

Remark rem_3619 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_42 X1 -> auto_knows_current X1). tauto. exact (rem_3618 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3620 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto___type_8 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__type_1_p__type_17. exact (rem_914).
Defined.

Remark rem_3621 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___type_8 X2 -> auto_knows_current X2). tauto. exact (rem_3620 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3622 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_3619 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_3621 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3623 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3622 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_crypt_7;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3624 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3625 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_3624 epsilon_m__type_1_p__type_17 X1).
Defined.

Remark rem_3626 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3627 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_3626 epsilon_m__type_1_p__type_17 X2).
Defined.

Remark rem_3628 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_3625 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_3627 epsilon_m__type_1_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3629 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3628 epsilon_m__type_1_p__type_17 X1 X2 A1 A2). clear  epsilon_m__type_1_p__type_17 A1 A2. intros. apply trans___type_17_crypt_9;  tauto.
 clear  epsilon_m__type_1_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3630 : (forall X:term, auto___type_1 X -> auto___type_17 X)
    -> forall X1 X2:term, auto___type_1 (crypt X1 X2) -> auto___type_17 (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_1_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_994 X1 X2 H);  intros.
  apply (rem_3599 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
  apply (rem_3605 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
  apply (rem_3611 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
  apply (rem_3617 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
  apply (rem_3623 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
  apply (rem_3629 epsilon_m__type_1_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3631 : forall X1:term, auto___type_1 X1 -> auto___type_17 X1. (* Induct. *)
Proof.
  fix epsilon_m__type_1_p__type_17 1.
  intro X. case X.
  exact (rem_3564 epsilon_m__type_1_p__type_17 ).
  exact (rem_3569 epsilon_m__type_1_p__type_17 ).
  intros X1 X2;  exact (rem_3583 epsilon_m__type_1_p__type_17 X1 X2).
  intros X1 X2;  exact (rem_3630 epsilon_m__type_1_p__type_17 X1 X2).
  exact (rem_3577 epsilon_m__type_1_p__type_17 ).
  intros X1 X2;  exact (rem_3598 epsilon_m__type_1_p__type_17 X1 X2).
  exact (rem_3575 epsilon_m__type_1_p__type_17 ).
  intros X1 X2. intro H. elim (rem_1000 X1 X2 H).
  intros X1 X2;  exact (rem_3567 epsilon_m__type_1_p__type_17 X1 X2).
  intros X1 X2. intro H. elim (rem_1003 X1 X2 H).
  intros X1 X2. intro H. elim (rem_999 X1 X2 H).
   intro H. elim (rem_996  H).
   intro H. elim (rem_997  H).
  intros X1;  exact (rem_3573 epsilon_m__type_1_p__type_17 X1).
  exact (rem_3585 epsilon_m__type_1_p__type_17 ).
  intros X1 X2 X3. intro H. elim (rem_1001 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1002 X1 X2 X3 H).
   intro H. elim (rem_998  H).
Qed.

Remark rem_3632 : forall X1 X2 X3 X4:term, auto___def_10 X2 -> auto___type_1 X1 -> auto_agent X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_17 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___type_1 X1 -> auto___type_17 X1). tauto. exact (rem_3631 X1).
Qed.

Remark rem_3633 : forall X1 X2 X3 X4:term, auto___type_1 X1 -> auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto___def_10 X3 -> auto_knows_current X4 -> auto___type_17 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X3 X2 X4.
  cut (auto___def_10 X2 -> auto___type_1 X1 -> auto_agent X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_17 X1). tauto. exact (rem_3632 X1 X2 X3 X4).
Qed.

Remark rem_3634 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17.  tauto.
Defined.

Remark rem_3635 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto___type_17 alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17.  case (rem_3634 epsilon_mknows_current_p__type_17). clear  epsilon_mknows_current_p__type_17. intros. apply trans___type_17_alice_1;  tauto.
 clear  epsilon_mknows_current_p__type_17. tauto.
Defined.

Remark rem_3636 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto_knows_current alice -> auto___type_17 alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intro H. intros.
  elim (rem_1496 H);  intros.
  apply (rem_3635 epsilon_mknows_current_p__type_17);  tauto.
Defined.

Remark rem_3637 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___type_17 (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.  case (rem_3634 epsilon_mknows_current_p__type_17). clear  epsilon_mknows_current_p__type_17. intros. apply trans___type_17_noncea_old_1;  tauto.
 clear  epsilon_mknows_current_p__type_17. tauto.
Defined.

Remark rem_3638 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current (noncea_old X1 X2) -> auto___type_17 (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_1499 X1 X2 H);  intros.
  apply (rem_3637 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3639 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto___type_17 bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17.  case (rem_3634 epsilon_mknows_current_p__type_17). clear  epsilon_mknows_current_p__type_17. intros. apply trans___type_17_bob_1;  tauto.
 clear  epsilon_mknows_current_p__type_17. tauto.
Defined.

Remark rem_3640 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto_knows_current bob -> auto___type_17 bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intro H. intros.
  elim (rem_1502 H);  intros.
  apply (rem_3639 epsilon_mknows_current_p__type_17);  tauto.
Defined.

Remark rem_3641 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3642 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_3641 epsilon_mknows_current_p__type_17 X1);  assumption.
  tauto.
Defined.

Remark rem_3643 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto_knows_current X1 -> auto___type_17 (s X1). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1. intros A1.
  case (rem_3642 epsilon_mknows_current_p__type_17 X1 A1). clear  epsilon_mknows_current_p__type_17 A1. intros. apply trans___type_17_s_1;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1. tauto.
Defined.

Remark rem_3644 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto_knows_current (s X1) -> auto___type_17 (s X1). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1. intro H. intros.
  elim (rem_1507 X1 H);  intros.
  apply (rem_3643 epsilon_mknows_current_p__type_17 X1);  tauto.
Defined.

Remark rem_3645 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto___type_17 nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17.  case (rem_3634 epsilon_mknows_current_p__type_17). clear  epsilon_mknows_current_p__type_17. intros. apply trans___type_17_nil_1;  tauto.
 clear  epsilon_mknows_current_p__type_17. tauto.
Defined.

Remark rem_3646 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto_knows_current nil -> auto___type_17 nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intro H. intros.
  elim (rem_1510 H);  intros.
  apply (rem_3645 epsilon_mknows_current_p__type_17);  tauto.
Defined.

Remark rem_3647 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto___type_17 i. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17.  case (rem_3634 epsilon_mknows_current_p__type_17). clear  epsilon_mknows_current_p__type_17. intros. apply trans___type_17_i_1;  tauto.
 clear  epsilon_mknows_current_p__type_17. tauto.
Defined.

Remark rem_3648 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto_knows_current i -> auto___type_17 i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intro H. intros.
  elim (rem_1513 H);  intros.
  apply (rem_3647 epsilon_mknows_current_p__type_17);  tauto.
Defined.

Remark rem_3649 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_3641 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3650 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto_knows_current X2 -> auto_knows_current X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3651 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_3650 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3652 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_3649 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_3651 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3653 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_17 (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3652 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_cons_1;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3654 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current (cons X1 X2) -> auto___type_17 (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_1520 X1 X2 H);  intros.
  apply (rem_3653 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3655 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto___type_17 server. (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17.  case (rem_3634 epsilon_mknows_current_p__type_17). clear  epsilon_mknows_current_p__type_17. intros. apply trans___type_17_server_1;  tauto.
 clear  epsilon_mknows_current_p__type_17. tauto.
Defined.

Remark rem_3656 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> auto_knows_current server -> auto___type_17 server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intro H. intros.
  elim (rem_1523 H);  intros.
  apply (rem_3655 epsilon_mknows_current_p__type_17);  tauto.
Defined.

Remark rem_3657 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_49 X1 -> auto___def_49 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3658 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_49 X1 -> auto___def_49 X1). tauto. exact (rem_3657 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3659 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_50 X2 -> auto___def_50 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3660 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_50 X2). tauto. exact (rem_3659 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3661 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_3658 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_3660 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3662 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___type_17 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3661 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_key_1;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3663 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3664 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_3663 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3665 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3666 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_3665 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3667 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_3664 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_3666 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3668 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___type_17 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3667 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_key_2;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3669 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3670 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_3669 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3671 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___type_10 X2 -> auto___type_10 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3672 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___type_10 X2 -> auto___type_10 X2). tauto. exact (rem_3671 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3673 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_3670 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_3672 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3674 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_17 (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3673 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_key_3;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3675 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current (key X1 X2) -> auto___type_17 (key X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_99 X1 X2 H);  intros.
  apply (rem_3662 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3668 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3674 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3676 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___type_17 (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.  case (rem_3634 epsilon_mknows_current_p__type_17). clear  epsilon_mknows_current_p__type_17. intros. apply trans___type_17_nonceb_old_1;  tauto.
 clear  epsilon_mknows_current_p__type_17. tauto.
Defined.

Remark rem_3677 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current (nonceb_old X1 X2) -> auto___type_17 (nonceb_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_1545 X1 X2 H);  intros.
  apply (rem_3676 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3678 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3679 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_3678 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3680 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3681 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_3680 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3682 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_3679 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_3681 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3683 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto___type_17 (noncea_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3682 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_noncea_current_1;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3684 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current (noncea_current X1 X2) -> auto___type_17 (noncea_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_1553 X1 X2 H);  intros.
  apply (rem_3683 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3685 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_23 X1 -> auto___def_23 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3686 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_3685 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3687 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_24 X2 -> auto___def_24 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3688 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_3687 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3689 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_3686 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_3688 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3690 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3689 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_1;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3691 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3692 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_3691 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3693 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3694 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_3693 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3695 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_3692 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_3694 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3696 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3695 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_2;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3697 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_78 X1 -> auto___def_78 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3698 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_3697 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3699 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_79 X2 -> auto___def_79 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3700 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_3699 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3701 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> (auto___def_78 X1 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_78 X1). 2:apply (rem_3698 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_3700 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3702 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3701 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_3;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3703 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_89 X1 -> auto___def_89 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3704 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_3703 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3705 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___type_19 X2 -> auto___type_19 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3706 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___type_19 X2 -> auto___type_19 X2). tauto. exact (rem_3705 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3707 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> (auto___def_89 X1 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_89 X1). 2:apply (rem_3704 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_3706 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3708 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3707 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_4;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3709 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_57 X1 -> auto___def_57 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3710 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_3709 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3711 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_58 X2 -> auto___def_58 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3712 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_58 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_58 X2 -> auto___def_58 X2). tauto. exact (rem_3711 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3713 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> (auto___def_57 X1 /\ auto___def_58 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_57 X1). 2:apply (rem_3710 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_58 X2). 2:apply (rem_3712 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3714 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3713 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_5;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3715 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_68 X1 -> auto___def_68 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3716 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_3715 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3717 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_69 X2 -> auto___def_69 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3718 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_69 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_69 X2 -> auto___def_69 X2). tauto. exact (rem_3717 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3719 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> (auto___def_68 X1 /\ auto___def_69 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_68 X1). 2:apply (rem_3716 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_69 X2). 2:apply (rem_3718 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3720 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3719 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_6;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3721 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3652 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_7;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3722 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_87 X1 -> auto___def_87 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3723 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_3722 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3724 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___type_18 X2 -> auto___type_18 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3725 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___type_18 X2 -> auto___type_18 X2). tauto. exact (rem_3724 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3726 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> (auto___def_87 X1 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_87 X1). 2:apply (rem_3723 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_3725 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3727 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3726 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_8;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3728 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1:term, auto___def_7 X1 -> auto___def_7 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3729 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_3728 epsilon_mknows_current_p__type_17 X1).
Defined.

Remark rem_3730 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X2:term, auto___def_8 X2 -> auto___def_8 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3731 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_3730 epsilon_mknows_current_p__type_17 X2).
Defined.

Remark rem_3732 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_3729 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_3731 epsilon_mknows_current_p__type_17 X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3733 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___type_17 (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intros A1 A2.
  case (rem_3732 epsilon_mknows_current_p__type_17 X1 X2 A1 A2). clear  epsilon_mknows_current_p__type_17 A1 A2. intros. apply trans___type_17_crypt_9;  tauto.
 clear  epsilon_mknows_current_p__type_17 A1 A2. tauto.
Defined.

Remark rem_3734 : (forall X:term, auto_knows_current X -> auto___type_17 X)
    -> forall X1 X2:term, auto_knows_current (crypt X1 X2) -> auto___type_17 (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_mknows_current_p__type_17. intros X1 X2. intro H. intros.
  elim (rem_1604 X1 X2 H);  intros.
  apply (rem_3690 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3696 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3702 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3708 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3714 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3720 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3721 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3727 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
  apply (rem_3733 epsilon_mknows_current_p__type_17 X1 X2);  tauto.
Defined.

Remark rem_3735 : forall X1:term, auto_knows_current X1 -> auto___type_17 X1. (* Induct. *)
Proof.
  fix epsilon_mknows_current_p__type_17 1.
  intro X. case X.
  exact (rem_3636 epsilon_mknows_current_p__type_17 ).
  exact (rem_3640 epsilon_mknows_current_p__type_17 ).
  intros X1 X2;  exact (rem_3654 epsilon_mknows_current_p__type_17 X1 X2).
  intros X1 X2;  exact (rem_3734 epsilon_mknows_current_p__type_17 X1 X2).
  exact (rem_3648 epsilon_mknows_current_p__type_17 ).
  intros X1 X2;  exact (rem_3675 epsilon_mknows_current_p__type_17 X1 X2).
  exact (rem_3646 epsilon_mknows_current_p__type_17 ).
  intros X1 X2;  exact (rem_3684 epsilon_mknows_current_p__type_17 X1 X2).
  intros X1 X2;  exact (rem_3638 epsilon_mknows_current_p__type_17 X1 X2).
  intros X1 X2. intro H. elim (rem_1611 X1 X2 H).
  intros X1 X2;  exact (rem_3677 epsilon_mknows_current_p__type_17 X1 X2).
   intro H. elim (rem_1606  H).
   intro H. elim (rem_1607  H).
  intros X1;  exact (rem_3644 epsilon_mknows_current_p__type_17 X1).
  exact (rem_3656 epsilon_mknows_current_p__type_17 ).
  intros X1 X2 X3. intro H. elim (rem_1609 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_1610 X1 X2 X3 H).
   intro H. elim (rem_1608  H).
Qed.

Remark rem_3736 : forall X1 X2 X3 X4:term, auto___def_60 X2 -> auto_agent X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_17 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto_knows_current X1 -> auto___type_17 X1). tauto. exact (rem_3735 X1).
Qed.

Remark rem_3737 : forall X1 X2 X3 X4:term, auto_knows_current X1 -> auto_agent X2 -> auto_knows_current X2 -> auto___def_60 X3 -> auto_knows_current X4 -> auto___type_17 X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X3 X2 X4.
  cut (auto___def_60 X2 -> auto_agent X3 -> auto_knows_current X4 -> auto_knows_current X1 -> auto_knows_current X3 -> auto___type_17 X1). tauto. exact (rem_3736 X1 X2 X3 X4).
Qed.

Remark rem_3738 : forall X1 X2 X3 X4:term, auto___def_67 X1 X2 X3 X4 -> auto___type_17 X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_1030 X1 X2 X3 X4 H);  intros.
  apply (rem_3633 X1 X2 X3 X4);  tauto.
  apply (rem_3737 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3739 : forall X1 X2:term, auto_agent X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_3740 : forall X1 X2:term, auto_agent X2 -> auto_knows_current X1 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_686 X2).
Qed.

Remark rem_3741 : forall X1 X2:term, auto_agent X2 -> auto_knows_current X1 -> (auto_knows_current X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_3739 X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_3740 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3742 : forall X1 X2:term, auto_agent X2 -> auto_knows_current X1 -> auto___def_60 (nonceb_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_3741 X1 X2 A1 A2). clear  A1 A2. intros. apply trans___def_60_nonceb_current_1;  tauto.
 clear  A1 A2. tauto.
Qed.

(* [appp] Proofs that all approximation clauses hold. *)


Remark rem_3743 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_3744 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X2 -> auto_knows_old X2). tauto. exact (rem_323 X2).
Qed.

Remark rem_3745 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_3743 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_3744 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3746 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_3745 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_crypt_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_3747 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old X1 -> auto_knows_old (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (crypt X1 X2)). tauto. exact (rem_3746 X1 X2).
Qed.

Remark rem_3748 : forall X1:term, auto_knows_current (s X1) -> auto_knows_current X1. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_1507 X1 H);  intros.
  apply (rem_446 X1);  tauto.
Qed.

Remark rem_3749 : forall X1:term, auto_knows_current X1 -> auto_knows_current X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1. intros A1.
  cut (auto_knows_current X1). 2:apply (rem_446 X1);  assumption.
  tauto.
Qed.

Remark rem_3750 : forall X1:term, auto_knows_current X1 -> auto_knows_current (s X1). (* Deduce positive atom. *)
Proof.
  intros X1. intros A1.
  case (rem_3749 X1 A1). clear  A1. intros. apply trans_knows_current_s_1;  tauto.
 clear  A1. tauto.
Qed.

Remark rem_3751 : forall X1:term, auto___def_49 X1 -> auto___def_49 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3752 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_49 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_49 X1 -> auto___def_49 X1). tauto. exact (rem_3751 X1).
Qed.

Remark rem_3753 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto___def_50 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_50 X2). tauto. exact (rem_1945 X2).
Qed.

Remark rem_3754 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> (auto___def_49 X1 /\ auto___def_50 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_49 X1). 2:apply (rem_3752 X1 X2);  assumption.
  cut (auto___def_50 X2). 2:apply (rem_3753 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3755 : forall X1 X2:term, auto___def_49 X1 -> auto___def_50 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_3754 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_3756 : forall X1 X2:term, auto___def_50 X2 -> auto___def_49 X1 -> auto_knows_current (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_49 X1 -> auto___def_50 X2 -> auto_knows_current (key X1 X2)). tauto. exact (rem_3755 X1 X2).
Qed.

Remark rem_3757 : (forall X:term, auto___def_76 X -> auto_knows_current X)
    -> forall X1:term, auto___def_78 X1 -> auto___def_78 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3758 : (forall X:term, auto___def_76 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_78 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_76_pknows_current. intros X1 X2.
  cut (auto___def_78 X1 -> auto___def_78 X1). tauto. exact (rem_3757 epsilon_m__def_76_pknows_current X1).
Defined.

Remark rem_3759 : (forall X:term, auto___def_76 X -> auto_knows_current X)
    -> forall X2:term, auto___def_79 X2 -> auto___def_79 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3760 : (forall X:term, auto___def_76 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto___def_79 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_76_pknows_current. intros X1 X2.
  cut (auto___def_79 X2 -> auto___def_79 X2). tauto. exact (rem_3759 epsilon_m__def_76_pknows_current X2).
Defined.

Remark rem_3761 : (forall X:term, auto___def_76 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> (auto___def_78 X1 /\ auto___def_79 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_76_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto___def_78 X1). 2:apply (rem_3758 epsilon_m__def_76_pknows_current X1 X2);  assumption.
  cut (auto___def_79 X2). 2:apply (rem_3760 epsilon_m__def_76_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3762 : (forall X:term, auto___def_76 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_78 X1 -> auto___def_79 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_76_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_3761 epsilon_m__def_76_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_76_pknows_current A1 A2. intros. apply trans_knows_current_crypt_3;  tauto.
 clear  epsilon_m__def_76_pknows_current A1 A2. tauto.
Defined.

Remark rem_3763 : forall X1 X2:term, auto___def_76 (crypt X1 X2) -> or_1
    (auto___def_78 X1 /\ auto___def_79 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3764 : (forall X:term, auto___def_76 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_76 (crypt X1 X2) -> auto_knows_current (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_76_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_3763 X1 X2 H);  intros.
  apply (rem_3762 epsilon_m__def_76_pknows_current X1 X2);  tauto.
Defined.

Remark rem_3765 : auto___def_76 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3766 : forall X1 X2:term, auto___def_76 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3767 : auto___def_76 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3768 : auto___def_76 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3769 : forall X1:term, auto___def_76 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3770 : auto___def_76 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3771 : auto___def_76 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3772 : auto___def_76 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3773 : forall X1 X2:term, auto___def_76 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3774 : auto___def_76 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3775 : auto___def_76 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3776 : forall X1 X2:term, auto___def_76 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3777 : forall X1 X2:term, auto___def_76 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3778 : forall X1 X2:term, auto___def_76 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3779 : forall X1 X2 X3:term, auto___def_76 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3780 : forall X1 X2 X3:term, auto___def_76 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3781 : forall X1 X2:term, auto___def_76 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3782 : forall X1:term, auto___def_76 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_76_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_3765  H).
   intro H. elim (rem_3768  H).
  intros X1 X2. intro H. elim (rem_3773 X1 X2 H).
  intros X1 X2;  exact (rem_3764 epsilon_m__def_76_pknows_current X1 X2).
   intro H. elim (rem_3771  H).
  intros X1 X2. intro H. elim (rem_3776 X1 X2 H).
   intro H. elim (rem_3770  H).
  intros X1 X2. intro H. elim (rem_3778 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3766 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3781 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3777 X1 X2 H).
   intro H. elim (rem_3767  H).
   intro H. elim (rem_3772  H).
  intros X1. intro H. elim (rem_3769 X1 H).
   intro H. elim (rem_3774  H).
  intros X1 X2 X3. intro H. elim (rem_3779 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_3780 X1 X2 X3 H).
   intro H. elim (rem_3775  H).
Qed.

Remark rem_3783 : forall X1 X2 X3 X4:term, auto___def_72 X2 -> auto___def_76 X1 -> auto___type_15 X3 -> auto___type_17 X4 -> auto_agent X3 -> auto_agent X4 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_76 X1 -> auto_knows_current X1). tauto. exact (rem_3782 X1).
Qed.

Remark rem_3784 : forall X1 X2 X3 X4:term, auto_agent X2 -> auto___type_17 X2 -> auto___def_76 X1 -> auto___type_15 X3 -> auto_agent X3 -> auto___def_72 X4 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X3 X2.
  cut (auto___def_72 X2 -> auto___def_76 X1 -> auto___type_15 X3 -> auto___type_17 X4 -> auto_agent X3 -> auto_agent X4 -> auto_knows_current X1). tauto. exact (rem_3783 X1 X2 X3 X4).
Qed.

Remark rem_3785 : forall X1 X2 X3 X4:term, auto___def_85 X1 X2 X3 X4 -> or_1
    (auto_agent X1 /\ auto___type_17 X1 /\ auto___def_76 X2 /\ auto___type_15 X3 /\ auto_agent X3 /\ auto___def_72 X4)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3786 : forall X1 X2 X3 X4:term, auto___def_85 X2 X1 X3 X4 -> auto_knows_current X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_3785 X2 X1 X3 X4 H);  intros.
  apply (rem_3784 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_3787 : forall X1:term, auto___def_46 X1 -> auto___def_46 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_3788 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___def_46 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_46 X1 -> auto___def_46 X1). tauto. exact (rem_3787 X1).
Qed.

Remark rem_3789 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto___type_10 X2. (* Subsumed by universal clause. *)
Proof. intros. apply trans___type_10_1. Qed.

Remark rem_3790 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> (auto___def_46 X1 /\ auto___type_10 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_46 X1). 2:apply (rem_3788 X1 X2);  assumption.
  cut (auto___type_10 X2). 2:apply (rem_3789 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_3791 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_old (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_3790 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_key_2;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_3792 : forall X1 X2:term, auto___type_10 X2 -> auto___def_46 X1 -> auto_knows_old (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_old (key X1 X2)). tauto. exact (rem_3791 X1 X2).
Qed.

Remark rem_3793 : forall X1:term, auto_knows_old X1 -> auto_knows_old X1 \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1. intros A1.
  cut (auto_knows_old X1). 2:apply (rem_567 X1);  assumption.
  tauto.
Qed.

Remark rem_3794 : forall X1:term, auto_knows_old X1 -> auto_knows_old (s X1). (* Deduce positive atom. *)
Proof.
  intros X1. intros A1.
  case (rem_3793 X1 A1). clear  A1. intros. apply trans_knows_old_s_1;  tauto.
 clear  A1. tauto.
Qed.

Remark rem_3795 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_3796 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X1). tauto. exact (rem_3795 X1 X2).
Qed.

Remark rem_3797 : forall X1 X2:term, auto_knows_current (cons X2 X1) -> auto_knows_current X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_1520 X2 X1 H);  intros.
  apply (rem_3796 X1 X2);  tauto.
Qed.

Remark rem_3798 : forall X1:term, auto___def_33 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_33_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2471  H).
   intro H. elim (rem_2474  H).
  intros X1 X2;  exact (rem_2470 epsilon_m__def_33_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2485 X1 X2 H).
   intro H. elim (rem_2477  H).
  intros X1 X2. intro H. elim (rem_2481 X1 X2 H).
   intro H. elim (rem_2476  H).
  intros X1 X2. intro H. elim (rem_2483 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2472 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2487 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2482 X1 X2 H).
   intro H. elim (rem_2473  H).
   intro H. elim (rem_2478  H).
  intros X1. intro H. elim (rem_2475 X1 H).
   intro H. elim (rem_2479  H).
  intros X1 X2 X3. intro H. elim (rem_2484 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2486 X1 X2 X3 H).
   intro H. elim (rem_2480  H).
Qed.

Remark rem_3799 : forall X1 X2:term, auto___def_33 X1 -> auto___def_37 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_33 X1 -> auto_knows_current X1). tauto. exact (rem_3798 X1).
Qed.

Remark rem_3800 : forall X1:term, auto___def_7 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_7_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2569  H).
   intro H. elim (rem_2572  H).
  intros X1 X2;  exact (rem_2568 epsilon_m__def_7_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2583 X1 X2 H).
   intro H. elim (rem_2575  H).
  intros X1 X2. intro H. elim (rem_2579 X1 X2 H).
   intro H. elim (rem_2574  H).
  intros X1 X2. intro H. elim (rem_2581 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2570 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2585 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2580 X1 X2 H).
   intro H. elim (rem_2571  H).
   intro H. elim (rem_2576  H).
  intros X1. intro H. elim (rem_2573 X1 H).
   intro H. elim (rem_2577  H).
  intros X1 X2 X3. intro H. elim (rem_2582 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2584 X1 X2 X3 H).
   intro H. elim (rem_2578  H).
Qed.

Remark rem_3801 : forall X1 X2:term, auto___def_13 X2 -> auto___def_56 X2 -> auto___def_7 X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_7 X1 -> auto_knows_current X1). tauto. exact (rem_3800 X1).
Qed.

Remark rem_3802 : forall X1 X2:term, auto___def_7 X1 -> auto___def_13 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_56 X2 -> auto___def_7 X1 -> auto_knows_current X1). tauto. exact (rem_3801 X1 X2).
Qed.

Remark rem_3803 : (forall X:term, auto___def_56 X -> auto___def_13 X -> False)
    -> forall X1 X2 X3:term, auto___def_13 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_56_m__def_13. intros X1 X2 X3. intro H. intros.
  elim (rem_228 X1 X2 X3 H);  intros.
Defined.

Remark rem_3804 : forall X1 X2 X3:term, auto___def_56 (session_old X1 X2 X3) -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3805 : (forall X:term, auto___def_56 X -> auto___def_13 X -> False)
    -> forall X1 X2 X3:term, auto___def_56 (session_old X1 X2 X3) -> auto___def_13 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_56_m__def_13. intros X1 X2 X3. intro H. intros.
  elim (rem_3804 X1 X2 X3 H);  intros.
  apply (rem_3803 epsilon_m__def_56_m__def_13 X1 X2 X3);  tauto.
Defined.

Remark rem_3806 : auto___def_56 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3807 : forall X1 X2:term, auto___def_56 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3808 : auto___def_56 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3809 : auto___def_56 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3810 : forall X1:term, auto___def_56 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3811 : auto___def_56 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3812 : auto___def_56 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3813 : auto___def_56 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3814 : forall X1 X2:term, auto___def_56 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3815 : auto___def_56 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3816 : auto___def_56 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3817 : forall X1 X2:term, auto___def_56 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3818 : forall X1 X2:term, auto___def_56 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3819 : forall X1 X2:term, auto___def_56 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3820 : forall X1 X2 X3:term, auto___def_56 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3821 : forall X1 X2:term, auto___def_56 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3822 : forall X1 X2:term, auto___def_56 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3823 : forall X1:term, auto___def_56 X1 -> auto___def_13 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_56_m__def_13 1.
  intro X. case X.
   intro H. elim (rem_3806  H).
   intro H. elim (rem_3809  H).
  intros X1 X2. intro H. elim (rem_3814 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3821 X1 X2 H).
   intro H. elim (rem_3812  H).
  intros X1 X2. intro H. elim (rem_3817 X1 X2 H).
   intro H. elim (rem_3811  H).
  intros X1 X2. intro H. elim (rem_3819 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3807 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3822 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3818 X1 X2 H).
   intro H. elim (rem_3808  H).
   intro H. elim (rem_3813  H).
  intros X1. intro H. elim (rem_3810 X1 H).
   intro H. elim (rem_3815  H).
  intros X1 X2 X3. intro H. elim (rem_3820 X1 X2 X3 H).
  intros X1 X2 X3;  exact (rem_3805 epsilon_m__def_56_m__def_13 X1 X2 X3).
   intro H. elim (rem_3816  H).
Qed.

Remark rem_3824 : forall X1 X2:term, auto___def_13 X2 -> auto___def_56 X2 -> auto___def_57 X1 -> auto_knows_current X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_3823 X2)). tauto.
Qed.

Remark rem_3825 : forall X1 X2:term, auto___def_57 X1 -> auto___def_13 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_56 X2 -> auto___def_57 X1 -> auto_knows_current X1). tauto. exact (rem_3824 X1 X2).
Qed.

Remark rem_3826 : (forall X:term, auto___def_56 X -> auto___def_75 X -> False)
    -> forall X1 X2 X3:term, auto___def_75 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_56_m__def_75. intros X1 X2 X3. intro H. intros.
  elim (rem_27 X1 X2 X3 H);  intros.
Defined.

Remark rem_3827 : (forall X:term, auto___def_56 X -> auto___def_75 X -> False)
    -> forall X1 X2 X3:term, auto___def_56 (session_old X1 X2 X3) -> auto___def_75 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_56_m__def_75. intros X1 X2 X3. intro H. intros.
  elim (rem_3804 X1 X2 X3 H);  intros.
  apply (rem_3826 epsilon_m__def_56_m__def_75 X1 X2 X3);  tauto.
Defined.

Remark rem_3828 : forall X1:term, auto___def_56 X1 -> auto___def_75 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_56_m__def_75 1.
  intro X. case X.
   intro H. elim (rem_3806  H).
   intro H. elim (rem_3809  H).
  intros X1 X2. intro H. elim (rem_3814 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3821 X1 X2 H).
   intro H. elim (rem_3812  H).
  intros X1 X2. intro H. elim (rem_3817 X1 X2 H).
   intro H. elim (rem_3811  H).
  intros X1 X2. intro H. elim (rem_3819 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3807 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3822 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3818 X1 X2 H).
   intro H. elim (rem_3808  H).
   intro H. elim (rem_3813  H).
  intros X1. intro H. elim (rem_3810 X1 H).
   intro H. elim (rem_3815  H).
  intros X1 X2 X3. intro H. elim (rem_3820 X1 X2 X3 H).
  intros X1 X2 X3;  exact (rem_3827 epsilon_m__def_56_m__def_75 X1 X2 X3).
   intro H. elim (rem_3816  H).
Qed.

Remark rem_3829 : forall X1 X2:term, auto___def_56 X2 -> auto___def_75 X2 -> auto___def_87 X1 -> auto_knows_current X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_3828 X2)). tauto.
Qed.

Remark rem_3830 : forall X1 X2:term, auto___def_87 X1 -> auto___def_75 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_56 X2 -> auto___def_75 X2 -> auto___def_87 X1 -> auto_knows_current X1). tauto. exact (rem_3829 X1 X2).
Qed.

Remark rem_3831 : (forall X:term, auto___def_56 X -> auto___def_82 X -> False)
    -> forall X1 X2 X3:term, auto___def_82 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_56_m__def_82. intros X1 X2 X3. intro H. intros.
  elim (rem_171 X1 X2 X3 H);  intros.
Defined.

Remark rem_3832 : (forall X:term, auto___def_56 X -> auto___def_82 X -> False)
    -> forall X1 X2 X3:term, auto___def_56 (session_old X1 X2 X3) -> auto___def_82 (session_old X1 X2 X3) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_56_m__def_82. intros X1 X2 X3. intro H. intros.
  elim (rem_3804 X1 X2 X3 H);  intros.
  apply (rem_3831 epsilon_m__def_56_m__def_82 X1 X2 X3);  tauto.
Defined.

Remark rem_3833 : forall X1:term, auto___def_56 X1 -> auto___def_82 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_56_m__def_82 1.
  intro X. case X.
   intro H. elim (rem_3806  H).
   intro H. elim (rem_3809  H).
  intros X1 X2. intro H. elim (rem_3814 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3821 X1 X2 H).
   intro H. elim (rem_3812  H).
  intros X1 X2. intro H. elim (rem_3817 X1 X2 H).
   intro H. elim (rem_3811  H).
  intros X1 X2. intro H. elim (rem_3819 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3807 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3822 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3818 X1 X2 H).
   intro H. elim (rem_3808  H).
   intro H. elim (rem_3813  H).
  intros X1. intro H. elim (rem_3810 X1 H).
   intro H. elim (rem_3815  H).
  intros X1 X2 X3. intro H. elim (rem_3820 X1 X2 X3 H).
  intros X1 X2 X3;  exact (rem_3832 epsilon_m__def_56_m__def_82 X1 X2 X3).
   intro H. elim (rem_3816  H).
Qed.

Remark rem_3834 : forall X1 X2:term, auto___def_56 X2 -> auto___def_78 X1 -> auto___def_82 X2 -> auto_knows_current X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_3833 X2)). tauto.
Qed.

Remark rem_3835 : forall X1 X2:term, auto___def_78 X1 -> auto___def_82 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_56 X2 -> auto___def_78 X1 -> auto___def_82 X2 -> auto_knows_current X1). tauto. exact (rem_3834 X1 X2).
Qed.

Remark rem_3836 : forall X1 X2:term, auto___def_56 X2 -> auto___def_75 X2 -> auto___def_89 X1 -> auto_knows_current X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_3828 X2)). tauto.
Qed.

Remark rem_3837 : forall X1 X2:term, auto___def_89 X1 -> auto___def_75 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_56 X2 -> auto___def_75 X2 -> auto___def_89 X1 -> auto_knows_current X1). tauto. exact (rem_3836 X1 X2).
Qed.

Remark rem_3838 : forall X1 X2:term, auto___def_50 X2 -> auto___def_56 X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_3839 : forall X1 X2:term, auto_knows_current X1 -> auto___def_50 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_50 X2 -> auto___def_56 X2 -> auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_3838 X1 X2).
Qed.

Remark rem_3840 : forall X1:term, auto___def_23 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_23_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_2282  H).
   intro H. elim (rem_2285  H).
  intros X1 X2;  exact (rem_2281 epsilon_m__def_23_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_2296 X1 X2 H).
   intro H. elim (rem_2288  H).
  intros X1 X2. intro H. elim (rem_2292 X1 X2 H).
   intro H. elim (rem_2287  H).
  intros X1 X2. intro H. elim (rem_2294 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2283 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2298 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2293 X1 X2 H).
   intro H. elim (rem_2284  H).
   intro H. elim (rem_2289  H).
  intros X1. intro H. elim (rem_2286 X1 H).
   intro H. elim (rem_2290  H).
  intros X1 X2 X3. intro H. elim (rem_2295 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2297 X1 X2 X3 H).
   intro H. elim (rem_2291  H).
Qed.

Remark rem_3841 : forall X1 X2:term, auto___def_23 X1 -> auto___def_39 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_23 X1 -> auto_knows_current X1). tauto. exact (rem_3840 X1).
Qed.

Remark rem_3842 : (forall X:term, auto___def_84 X -> auto___def_56 X -> False)
    -> forall X1 X2:term, auto___def_56 (cons X1 X2) -> auto___type_17 X1 -> auto___def_83 X2 -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_84_m__def_56. intros X1 X2. intro H. intros.
  elim (rem_3814 X1 X2 H);  intros.
Defined.

Remark rem_3843 : (forall X:term, auto___def_84 X -> auto___def_56 X -> False)
    -> forall X1 X2:term, auto___def_84 (cons X1 X2) -> auto___def_56 (cons X1 X2) -> False. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_84_m__def_56. intros X1 X2. intro H. intros.
  elim (rem_125 X1 X2 H);  intros.
  apply (rem_3842 epsilon_m__def_84_m__def_56 X1 X2);  tauto.
Defined.

Remark rem_3844 : forall X1:term, auto___def_84 X1 -> auto___def_56 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_84_m__def_56 1.
  intro X. case X.
   intro H. elim (rem_127  H).
   intro H. elim (rem_130  H).
  intros X1 X2;  exact (rem_3843 epsilon_m__def_84_m__def_56 X1 X2).
  intros X1 X2. intro H. elim (rem_141 X1 X2 H).
   intro H. elim (rem_133  H).
  intros X1 X2. intro H. elim (rem_137 X1 X2 H).
   intro H. elim (rem_132  H).
  intros X1 X2. intro H. elim (rem_139 X1 X2 H).
  intros X1 X2. intro H. elim (rem_128 X1 X2 H).
  intros X1 X2. intro H. elim (rem_143 X1 X2 H).
  intros X1 X2. intro H. elim (rem_138 X1 X2 H).
   intro H. elim (rem_129  H).
   intro H. elim (rem_134  H).
  intros X1. intro H. elim (rem_131 X1 H).
   intro H. elim (rem_135  H).
  intros X1 X2 X3. intro H. elim (rem_140 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_142 X1 X2 X3 H).
   intro H. elim (rem_136  H).
Qed.

Remark rem_3845 : forall X1 X2:term, auto___def_56 X2 -> auto___def_68 X1 -> auto___def_84 X2 -> auto_knows_current X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_3844 X2)). tauto.
Qed.

Remark rem_3846 : forall X1 X2:term, auto___def_68 X1 -> auto___def_84 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_56 X2 -> auto___def_68 X1 -> auto___def_84 X2 -> auto_knows_current X1). tauto. exact (rem_3845 X1 X2).
Qed.

Remark rem_3847 : forall X1 X2:term, auto___def_55 X1 X2 -> or_9
    (auto___def_33 X1 /\ auto___def_37 X2)
    (auto___def_7 X1 /\ auto___def_13 X2)
    (auto___def_57 X1 /\ auto___def_13 X2)
    (auto___def_87 X1 /\ auto___def_75 X2)
    (auto___def_78 X1 /\ auto___def_82 X2)
    (auto___def_89 X1 /\ auto___def_75 X2)
    (auto_knows_current X1 /\ auto___def_50 X2)
    (auto___def_23 X1 /\ auto___def_39 X2)
    (auto___def_68 X1 /\ auto___def_84 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_9_intro_1; tauto.
  intros. apply or_9_intro_2; tauto.
  intros. apply or_9_intro_3; tauto.
  intros. apply or_9_intro_4; tauto.
  intros. apply or_9_intro_5; tauto.
  intros. apply or_9_intro_6; tauto.
  intros. apply or_9_intro_7; tauto.
  intros. apply or_9_intro_8; tauto.
  intros. apply or_9_intro_9; tauto.
Qed.

Remark rem_3848 : forall X1 X2:term, auto___def_55 X1 X2 -> auto___def_56 X2 -> auto_knows_current X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_3847 X1 X2 H);  intros.
  apply (rem_3799 X1 X2);  tauto.
  apply (rem_3802 X1 X2);  tauto.
  apply (rem_3825 X1 X2);  tauto.
  apply (rem_3830 X1 X2);  tauto.
  apply (rem_3835 X1 X2);  tauto.
  apply (rem_3837 X1 X2);  tauto.
  apply (rem_3839 X1 X2);  tauto.
  apply (rem_3841 X1 X2);  tauto.
  apply (rem_3846 X1 X2);  tauto.
Qed.

Remark rem_3849 : forall X1:term, auto_agent X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_magent_pknows_current 1.
  intro X. case X.
  exact (rem_1009 epsilon_magent_pknows_current ).
  exact (rem_1011 epsilon_magent_pknows_current ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_1013 epsilon_magent_pknows_current ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_1015 epsilon_magent_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_3850 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old X1 -> auto_knows_old X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old X1). tauto. exact (rem_3743 X1 X2).
Qed.

Remark rem_3851 : forall X1 X2:term, auto_knows_old (cons X2 X1) -> auto_knows_old X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_383 X2 X1 H);  intros.
  apply (rem_3850 X1 X2);  tauto.
Qed.

Remark rem_3852 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_2_pknows_old.  tauto.
Defined.

Remark rem_3853 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto_knows_old alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old.  case (rem_3852 epsilon_m__type_2_pknows_old). clear  epsilon_m__type_2_pknows_old. intros. apply trans_knows_old_alice_1;  tauto.
 clear  epsilon_m__type_2_pknows_old. tauto.
Defined.

Remark rem_3854 : auto___type_2 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3855 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto___type_2 alice -> auto_knows_old alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old. intro H. intros.
  elim (rem_3854 H);  intros.
  apply (rem_3853 epsilon_m__type_2_pknows_old);  tauto.
Defined.

Remark rem_3856 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto_knows_old bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old.  case (rem_3852 epsilon_m__type_2_pknows_old). clear  epsilon_m__type_2_pknows_old. intros. apply trans_knows_old_bob_1;  tauto.
 clear  epsilon_m__type_2_pknows_old. tauto.
Defined.

Remark rem_3857 : auto___type_2 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3858 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto___type_2 bob -> auto_knows_old bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old. intro H. intros.
  elim (rem_3857 H);  intros.
  apply (rem_3856 epsilon_m__type_2_pknows_old);  tauto.
Defined.

Remark rem_3859 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto_knows_old i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old.  case (rem_3852 epsilon_m__type_2_pknows_old). clear  epsilon_m__type_2_pknows_old. intros. apply trans_knows_old_i_1;  tauto.
 clear  epsilon_m__type_2_pknows_old. tauto.
Defined.

Remark rem_3860 : auto___type_2 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3861 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto___type_2 i -> auto_knows_old i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old. intro H. intros.
  elim (rem_3860 H);  intros.
  apply (rem_3859 epsilon_m__type_2_pknows_old);  tauto.
Defined.

Remark rem_3862 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto_knows_old server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old.  case (rem_3852 epsilon_m__type_2_pknows_old). clear  epsilon_m__type_2_pknows_old. intros. apply trans_knows_old_server_1;  tauto.
 clear  epsilon_m__type_2_pknows_old. tauto.
Defined.

Remark rem_3863 : auto___type_2 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3864 : (forall X:term, auto___type_2 X -> auto_knows_old X)
    -> auto___type_2 server -> auto_knows_old server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_2_pknows_old. intro H. intros.
  elim (rem_3863 H);  intros.
  apply (rem_3862 epsilon_m__type_2_pknows_old);  tauto.
Defined.

Remark rem_3865 : forall X1 X2:term, auto___type_2 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3866 : auto___type_2 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3867 : forall X1:term, auto___type_2 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3868 : auto___type_2 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3869 : auto___type_2 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3870 : forall X1 X2:term, auto___type_2 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3871 : auto___type_2 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3872 : forall X1 X2:term, auto___type_2 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3873 : forall X1 X2:term, auto___type_2 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3874 : forall X1 X2:term, auto___type_2 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3875 : forall X1 X2 X3:term, auto___type_2 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3876 : forall X1 X2:term, auto___type_2 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3877 : forall X1 X2 X3:term, auto___type_2 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3878 : forall X1 X2:term, auto___type_2 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3879 : forall X1:term, auto___type_2 X1 -> auto_knows_old X1. (* Induct. *)
Proof.
  fix epsilon_m__type_2_pknows_old 1.
  intro X. case X.
  exact (rem_3855 epsilon_m__type_2_pknows_old ).
  exact (rem_3858 epsilon_m__type_2_pknows_old ).
  intros X1 X2. intro H. elim (rem_3870 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3876 X1 X2 H).
  exact (rem_3861 epsilon_m__type_2_pknows_old ).
  intros X1 X2. intro H. elim (rem_3872 X1 X2 H).
   intro H. elim (rem_3868  H).
  intros X1 X2. intro H. elim (rem_3874 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3865 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3878 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3873 X1 X2 H).
   intro H. elim (rem_3866  H).
   intro H. elim (rem_3869  H).
  intros X1. intro H. elim (rem_3867 X1 H).
  exact (rem_3864 epsilon_m__type_2_pknows_old ).
  intros X1 X2 X3. intro H. elim (rem_3875 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_3877 X1 X2 X3 H).
   intro H. elim (rem_3871  H).
Qed.

Remark rem_3880 : forall X1 X2:term, auto___def_17 X2 -> auto___type_2 X1 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_2 X1 -> auto_knows_old X1). tauto. exact (rem_3879 X1).
Qed.

Remark rem_3881 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_3_pknows_old.  tauto.
Defined.

Remark rem_3882 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto_knows_old alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old.  case (rem_3881 epsilon_m__type_3_pknows_old). clear  epsilon_m__type_3_pknows_old. intros. apply trans_knows_old_alice_1;  tauto.
 clear  epsilon_m__type_3_pknows_old. tauto.
Defined.

Remark rem_3883 : auto___type_3 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3884 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto___type_3 alice -> auto_knows_old alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old. intro H. intros.
  elim (rem_3883 H);  intros.
  apply (rem_3882 epsilon_m__type_3_pknows_old);  tauto.
Defined.

Remark rem_3885 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto_knows_old bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old.  case (rem_3881 epsilon_m__type_3_pknows_old). clear  epsilon_m__type_3_pknows_old. intros. apply trans_knows_old_bob_1;  tauto.
 clear  epsilon_m__type_3_pknows_old. tauto.
Defined.

Remark rem_3886 : auto___type_3 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3887 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto___type_3 bob -> auto_knows_old bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old. intro H. intros.
  elim (rem_3886 H);  intros.
  apply (rem_3885 epsilon_m__type_3_pknows_old);  tauto.
Defined.

Remark rem_3888 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto_knows_old i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old.  case (rem_3881 epsilon_m__type_3_pknows_old). clear  epsilon_m__type_3_pknows_old. intros. apply trans_knows_old_i_1;  tauto.
 clear  epsilon_m__type_3_pknows_old. tauto.
Defined.

Remark rem_3889 : auto___type_3 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3890 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto___type_3 i -> auto_knows_old i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old. intro H. intros.
  elim (rem_3889 H);  intros.
  apply (rem_3888 epsilon_m__type_3_pknows_old);  tauto.
Defined.

Remark rem_3891 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto_knows_old server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old.  case (rem_3881 epsilon_m__type_3_pknows_old). clear  epsilon_m__type_3_pknows_old. intros. apply trans_knows_old_server_1;  tauto.
 clear  epsilon_m__type_3_pknows_old. tauto.
Defined.

Remark rem_3892 : auto___type_3 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3893 : (forall X:term, auto___type_3 X -> auto_knows_old X)
    -> auto___type_3 server -> auto_knows_old server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_3_pknows_old. intro H. intros.
  elim (rem_3892 H);  intros.
  apply (rem_3891 epsilon_m__type_3_pknows_old);  tauto.
Defined.

Remark rem_3894 : forall X1 X2:term, auto___type_3 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3895 : auto___type_3 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3896 : forall X1:term, auto___type_3 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3897 : auto___type_3 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3898 : auto___type_3 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3899 : forall X1 X2:term, auto___type_3 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3900 : auto___type_3 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3901 : forall X1 X2:term, auto___type_3 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3902 : forall X1 X2:term, auto___type_3 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3903 : forall X1 X2:term, auto___type_3 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3904 : forall X1 X2 X3:term, auto___type_3 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3905 : forall X1 X2:term, auto___type_3 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3906 : forall X1 X2 X3:term, auto___type_3 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3907 : forall X1 X2:term, auto___type_3 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3908 : forall X1:term, auto___type_3 X1 -> auto_knows_old X1. (* Induct. *)
Proof.
  fix epsilon_m__type_3_pknows_old 1.
  intro X. case X.
  exact (rem_3884 epsilon_m__type_3_pknows_old ).
  exact (rem_3887 epsilon_m__type_3_pknows_old ).
  intros X1 X2. intro H. elim (rem_3899 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3905 X1 X2 H).
  exact (rem_3890 epsilon_m__type_3_pknows_old ).
  intros X1 X2. intro H. elim (rem_3901 X1 X2 H).
   intro H. elim (rem_3897  H).
  intros X1 X2. intro H. elim (rem_3903 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3894 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3907 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3902 X1 X2 H).
   intro H. elim (rem_3895  H).
   intro H. elim (rem_3898  H).
  intros X1. intro H. elim (rem_3896 X1 H).
  exact (rem_3893 epsilon_m__type_3_pknows_old ).
  intros X1 X2 X3. intro H. elim (rem_3904 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_3906 X1 X2 X3 H).
   intro H. elim (rem_3900  H).
Qed.

Remark rem_3909 : (forall X:term, auto___def_17 X -> auto_knows_old X)
    -> forall X1:term, auto___type_3 X1 -> auto_knows_old X1. (* Cut history. *)
Proof.  intros epsilon_m__def_17_pknows_old. exact (rem_3908).
Defined.

Remark rem_3910 : (forall X:term, auto___def_17 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_3 X1 -> auto___def_18 X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_17_pknows_old. intros X1 X2.
  cut (auto___type_3 X1 -> auto_knows_old X1). tauto. exact (rem_3909 epsilon_m__def_17_pknows_old X1).
Defined.

Remark rem_3911 : (forall X:term, auto___def_19 X -> auto_knows_old X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3912 : (forall X:term, auto___def_19 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_19_pknows_old. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_3911 epsilon_m__def_19_pknows_old X1).
Defined.

Remark rem_3913 : (forall X:term, auto___def_19 X -> auto_knows_old X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3914 : (forall X:term, auto___def_19 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_19_pknows_old. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_3913 epsilon_m__def_19_pknows_old X2).
Defined.

Remark rem_3915 : (forall X:term, auto___def_19 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_19_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_3912 epsilon_m__def_19_pknows_old X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_3914 epsilon_m__def_19_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3916 : (forall X:term, auto___def_19 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_old (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_19_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3915 epsilon_m__def_19_pknows_old X1 X2 A1 A2). clear  epsilon_m__def_19_pknows_old A1 A2. intros. apply trans_knows_old_noncea_old_1;  tauto.
 clear  epsilon_m__def_19_pknows_old A1 A2. tauto.
Defined.

Remark rem_3917 : forall X1 X2:term, auto___def_19 (noncea_old X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3918 : (forall X:term, auto___def_19 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_19 (noncea_old X1 X2) -> auto_knows_old (noncea_old X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_19_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_3917 X1 X2 H);  intros.
  apply (rem_3916 epsilon_m__def_19_pknows_old X1 X2);  tauto.
Defined.

Remark rem_3919 : auto___def_19 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3920 : auto___def_19 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3921 : auto___def_19 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3922 : forall X1:term, auto___def_19 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3923 : auto___def_19 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3924 : auto___def_19 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3925 : auto___def_19 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3926 : forall X1 X2:term, auto___def_19 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3927 : auto___def_19 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3928 : auto___def_19 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3929 : forall X1 X2:term, auto___def_19 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3930 : forall X1 X2:term, auto___def_19 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3931 : forall X1 X2:term, auto___def_19 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3932 : forall X1 X2 X3:term, auto___def_19 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3933 : forall X1 X2:term, auto___def_19 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3934 : forall X1 X2 X3:term, auto___def_19 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3935 : forall X1 X2:term, auto___def_19 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3936 : forall X1:term, auto___def_19 X1 -> auto_knows_old X1. (* Induct. *)
Proof.
  fix epsilon_m__def_19_pknows_old 1.
  intro X. case X.
   intro H. elim (rem_3919  H).
   intro H. elim (rem_3921  H).
  intros X1 X2. intro H. elim (rem_3926 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3933 X1 X2 H).
   intro H. elim (rem_3924  H).
  intros X1 X2. intro H. elim (rem_3929 X1 X2 H).
   intro H. elim (rem_3923  H).
  intros X1 X2. intro H. elim (rem_3931 X1 X2 H).
  intros X1 X2;  exact (rem_3918 epsilon_m__def_19_pknows_old X1 X2).
  intros X1 X2. intro H. elim (rem_3935 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3930 X1 X2 H).
   intro H. elim (rem_3920  H).
   intro H. elim (rem_3925  H).
  intros X1. intro H. elim (rem_3922 X1 H).
   intro H. elim (rem_3927  H).
  intros X1 X2 X3. intro H. elim (rem_3932 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_3934 X1 X2 X3 H).
   intro H. elim (rem_3928  H).
Qed.

Remark rem_3937 : (forall X:term, auto___def_18 X -> auto_knows_old X)
    -> forall X1:term, auto___def_19 X1 -> auto_knows_old X1. (* Cut history. *)
Proof.  intros epsilon_m__def_18_pknows_old. exact (rem_3936).
Defined.

Remark rem_3938 : (forall X:term, auto___def_18 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_18_pknows_old. intros X1 X2.
  cut (auto___def_19 X1 -> auto_knows_old X1). tauto. exact (rem_3937 epsilon_m__def_18_pknows_old X1).
Defined.

Remark rem_3939 : (forall X:term, auto___def_20 X -> auto_knows_old X)
    -> forall X1:term, auto_knows_old X1 -> auto_knows_old X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_3940 : (forall X:term, auto___def_20 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto___def_21 X2 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_20_pknows_old. intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_3939 epsilon_m__def_20_pknows_old X1).
Defined.

Remark rem_3941 : (forall X:term, auto___def_21 X -> auto_knows_old X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_21_pknows_old.  tauto.
Defined.

Remark rem_3942 : (forall X:term, auto___def_21 X -> auto_knows_old X)
    -> auto_knows_old nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_21_pknows_old.  case (rem_3941 epsilon_m__def_21_pknows_old). clear  epsilon_m__def_21_pknows_old. intros. apply trans_knows_old_nil_1;  tauto.
 clear  epsilon_m__def_21_pknows_old. tauto.
Defined.

Remark rem_3943 : auto___def_21 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3944 : (forall X:term, auto___def_21 X -> auto_knows_old X)
    -> auto___def_21 nil -> auto_knows_old nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_21_pknows_old. intro H. intros.
  elim (rem_3943 H);  intros.
  apply (rem_3942 epsilon_m__def_21_pknows_old);  tauto.
Defined.

Remark rem_3945 : auto___def_21 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3946 : forall X1 X2:term, auto___def_21 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3947 : auto___def_21 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3948 : auto___def_21 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3949 : forall X1:term, auto___def_21 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3950 : auto___def_21 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3951 : auto___def_21 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3952 : forall X1 X2:term, auto___def_21 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3953 : auto___def_21 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3954 : auto___def_21 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3955 : forall X1 X2:term, auto___def_21 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3956 : forall X1 X2:term, auto___def_21 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3957 : forall X1 X2:term, auto___def_21 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3958 : forall X1 X2 X3:term, auto___def_21 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3959 : forall X1 X2:term, auto___def_21 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3960 : forall X1 X2 X3:term, auto___def_21 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3961 : forall X1 X2:term, auto___def_21 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3962 : forall X2:term, auto___def_21 X2 -> auto_knows_old X2. (* Induct. *)
Proof.
  fix epsilon_m__def_21_pknows_old 1.
  intro X. case X.
   intro H. elim (rem_3945  H).
   intro H. elim (rem_3948  H).
  intros X1 X2. intro H. elim (rem_3952 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3959 X1 X2 H).
   intro H. elim (rem_3950  H).
  intros X1 X2. intro H. elim (rem_3955 X1 X2 H).
  exact (rem_3944 epsilon_m__def_21_pknows_old ).
  intros X1 X2. intro H. elim (rem_3957 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3946 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3961 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3956 X1 X2 H).
   intro H. elim (rem_3947  H).
   intro H. elim (rem_3951  H).
  intros X1. intro H. elim (rem_3949 X1 H).
   intro H. elim (rem_3953  H).
  intros X1 X2 X3. intro H. elim (rem_3958 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_3960 X1 X2 X3 H).
   intro H. elim (rem_3954  H).
Qed.

Remark rem_3963 : (forall X:term, auto___def_20 X -> auto_knows_old X)
    -> forall X2:term, auto___def_21 X2 -> auto_knows_old X2. (* Cut history. *)
Proof.  intros epsilon_m__def_20_pknows_old. exact (rem_3962).
Defined.

Remark rem_3964 : (forall X:term, auto___def_20 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto___def_21 X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_20_pknows_old. intros X1 X2.
  cut (auto___def_21 X2 -> auto_knows_old X2). tauto. exact (rem_3963 epsilon_m__def_20_pknows_old X2).
Defined.

Remark rem_3965 : (forall X:term, auto___def_20 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto___def_21 X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_20_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_3940 epsilon_m__def_20_pknows_old X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_3964 epsilon_m__def_20_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3966 : (forall X:term, auto___def_20 X -> auto_knows_old X)
    -> forall X1 X2:term, auto_knows_old X1 -> auto___def_21 X2 -> auto_knows_old (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_20_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3965 epsilon_m__def_20_pknows_old X1 X2 A1 A2). clear  epsilon_m__def_20_pknows_old A1 A2. intros. apply trans_knows_old_cons_1;  tauto.
 clear  epsilon_m__def_20_pknows_old A1 A2. tauto.
Defined.

Remark rem_3967 : forall X1 X2:term, auto___def_20 (cons X1 X2) -> or_1
    (auto_knows_old X1 /\ auto___def_21 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3968 : (forall X:term, auto___def_20 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_20 (cons X1 X2) -> auto_knows_old (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_20_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_3967 X1 X2 H);  intros.
  apply (rem_3966 epsilon_m__def_20_pknows_old X1 X2);  tauto.
Defined.

Remark rem_3969 : auto___def_20 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3970 : forall X1 X2:term, auto___def_20 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3971 : auto___def_20 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3972 : auto___def_20 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3973 : forall X1:term, auto___def_20 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3974 : auto___def_20 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3975 : auto___def_20 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3976 : auto___def_20 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3977 : auto___def_20 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3978 : auto___def_20 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3979 : forall X1 X2:term, auto___def_20 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3980 : forall X1 X2:term, auto___def_20 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3981 : forall X1 X2:term, auto___def_20 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3982 : forall X1 X2 X3:term, auto___def_20 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3983 : forall X1 X2:term, auto___def_20 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3984 : forall X1 X2 X3:term, auto___def_20 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3985 : forall X1 X2:term, auto___def_20 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3986 : forall X2:term, auto___def_20 X2 -> auto_knows_old X2. (* Induct. *)
Proof.
  fix epsilon_m__def_20_pknows_old 1.
  intro X. case X.
   intro H. elim (rem_3969  H).
   intro H. elim (rem_3972  H).
  intros X1 X2;  exact (rem_3968 epsilon_m__def_20_pknows_old X1 X2).
  intros X1 X2. intro H. elim (rem_3983 X1 X2 H).
   intro H. elim (rem_3975  H).
  intros X1 X2. intro H. elim (rem_3979 X1 X2 H).
   intro H. elim (rem_3974  H).
  intros X1 X2. intro H. elim (rem_3981 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3970 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3985 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3980 X1 X2 H).
   intro H. elim (rem_3971  H).
   intro H. elim (rem_3976  H).
  intros X1. intro H. elim (rem_3973 X1 H).
   intro H. elim (rem_3977  H).
  intros X1 X2 X3. intro H. elim (rem_3982 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_3984 X1 X2 X3 H).
   intro H. elim (rem_3978  H).
Qed.

Remark rem_3987 : (forall X:term, auto___def_18 X -> auto_knows_old X)
    -> forall X2:term, auto___def_20 X2 -> auto_knows_old X2. (* Cut history. *)
Proof.  intros epsilon_m__def_18_pknows_old. exact (rem_3986).
Defined.

Remark rem_3988 : (forall X:term, auto___def_18 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_18_pknows_old. intros X1 X2.
  cut (auto___def_20 X2 -> auto_knows_old X2). tauto. exact (rem_3987 epsilon_m__def_18_pknows_old X2).
Defined.

Remark rem_3989 : (forall X:term, auto___def_18 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_18_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_3938 epsilon_m__def_18_pknows_old X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_3988 epsilon_m__def_18_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_3990 : (forall X:term, auto___def_18 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_19 X1 -> auto___def_20 X2 -> auto_knows_old (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_18_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_3989 epsilon_m__def_18_pknows_old X1 X2 A1 A2). clear  epsilon_m__def_18_pknows_old A1 A2. intros. apply trans_knows_old_cons_1;  tauto.
 clear  epsilon_m__def_18_pknows_old A1 A2. tauto.
Defined.

Remark rem_3991 : forall X1 X2:term, auto___def_18 (cons X1 X2) -> or_1
    (auto___def_19 X1 /\ auto___def_20 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_3992 : (forall X:term, auto___def_18 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_18 (cons X1 X2) -> auto_knows_old (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_18_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_3991 X1 X2 H);  intros.
  apply (rem_3990 epsilon_m__def_18_pknows_old X1 X2);  tauto.
Defined.

Remark rem_3993 : auto___def_18 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3994 : forall X1 X2:term, auto___def_18 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3995 : auto___def_18 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3996 : auto___def_18 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3997 : forall X1:term, auto___def_18 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3998 : auto___def_18 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_3999 : auto___def_18 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4000 : auto___def_18 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4001 : auto___def_18 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4002 : auto___def_18 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4003 : forall X1 X2:term, auto___def_18 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4004 : forall X1 X2:term, auto___def_18 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4005 : forall X1 X2:term, auto___def_18 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4006 : forall X1 X2 X3:term, auto___def_18 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4007 : forall X1 X2:term, auto___def_18 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4008 : forall X1 X2 X3:term, auto___def_18 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4009 : forall X1 X2:term, auto___def_18 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4010 : forall X2:term, auto___def_18 X2 -> auto_knows_old X2. (* Induct. *)
Proof.
  fix epsilon_m__def_18_pknows_old 1.
  intro X. case X.
   intro H. elim (rem_3993  H).
   intro H. elim (rem_3996  H).
  intros X1 X2;  exact (rem_3992 epsilon_m__def_18_pknows_old X1 X2).
  intros X1 X2. intro H. elim (rem_4007 X1 X2 H).
   intro H. elim (rem_3999  H).
  intros X1 X2. intro H. elim (rem_4003 X1 X2 H).
   intro H. elim (rem_3998  H).
  intros X1 X2. intro H. elim (rem_4005 X1 X2 H).
  intros X1 X2. intro H. elim (rem_3994 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4009 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4004 X1 X2 H).
   intro H. elim (rem_3995  H).
   intro H. elim (rem_4000  H).
  intros X1. intro H. elim (rem_3997 X1 H).
   intro H. elim (rem_4001  H).
  intros X1 X2 X3. intro H. elim (rem_4006 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4008 X1 X2 X3 H).
   intro H. elim (rem_4002  H).
Qed.

Remark rem_4011 : (forall X:term, auto___def_17 X -> auto_knows_old X)
    -> forall X2:term, auto___def_18 X2 -> auto_knows_old X2. (* Cut history. *)
Proof.  intros epsilon_m__def_17_pknows_old. exact (rem_4010).
Defined.

Remark rem_4012 : (forall X:term, auto___def_17 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_3 X1 -> auto___def_18 X2 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_17_pknows_old. intros X1 X2.
  cut (auto___def_18 X2 -> auto_knows_old X2). tauto. exact (rem_4011 epsilon_m__def_17_pknows_old X2).
Defined.

Remark rem_4013 : (forall X:term, auto___def_17 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_3 X1 -> auto___def_18 X2 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_17_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_3910 epsilon_m__def_17_pknows_old X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_4012 epsilon_m__def_17_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_4014 : (forall X:term, auto___def_17 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___type_3 X1 -> auto___def_18 X2 -> auto_knows_old (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_17_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_4013 epsilon_m__def_17_pknows_old X1 X2 A1 A2). clear  epsilon_m__def_17_pknows_old A1 A2. intros. apply trans_knows_old_cons_1;  tauto.
 clear  epsilon_m__def_17_pknows_old A1 A2. tauto.
Defined.

Remark rem_4015 : forall X1 X2:term, auto___def_17 (cons X1 X2) -> or_1
    (auto___type_3 X1 /\ auto___def_18 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4016 : (forall X:term, auto___def_17 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_17 (cons X1 X2) -> auto_knows_old (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_17_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_4015 X1 X2 H);  intros.
  apply (rem_4014 epsilon_m__def_17_pknows_old X1 X2);  tauto.
Defined.

Remark rem_4017 : auto___def_17 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4018 : forall X1 X2:term, auto___def_17 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4019 : auto___def_17 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4020 : auto___def_17 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4021 : forall X1:term, auto___def_17 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4022 : auto___def_17 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4023 : auto___def_17 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4024 : auto___def_17 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4025 : auto___def_17 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4026 : auto___def_17 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4027 : forall X1 X2:term, auto___def_17 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4028 : forall X1 X2:term, auto___def_17 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4029 : forall X1 X2:term, auto___def_17 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4030 : forall X1 X2 X3:term, auto___def_17 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4031 : forall X1 X2:term, auto___def_17 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4032 : forall X1 X2 X3:term, auto___def_17 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4033 : forall X1 X2:term, auto___def_17 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4034 : forall X2:term, auto___def_17 X2 -> auto_knows_old X2. (* Induct. *)
Proof.
  fix epsilon_m__def_17_pknows_old 1.
  intro X. case X.
   intro H. elim (rem_4017  H).
   intro H. elim (rem_4020  H).
  intros X1 X2;  exact (rem_4016 epsilon_m__def_17_pknows_old X1 X2).
  intros X1 X2. intro H. elim (rem_4031 X1 X2 H).
   intro H. elim (rem_4023  H).
  intros X1 X2. intro H. elim (rem_4027 X1 X2 H).
   intro H. elim (rem_4022  H).
  intros X1 X2. intro H. elim (rem_4029 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4018 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4033 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4028 X1 X2 H).
   intro H. elim (rem_4019  H).
   intro H. elim (rem_4024  H).
  intros X1. intro H. elim (rem_4021 X1 H).
   intro H. elim (rem_4025  H).
  intros X1 X2 X3. intro H. elim (rem_4030 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4032 X1 X2 X3 H).
   intro H. elim (rem_4026  H).
Qed.

Remark rem_4035 : forall X1 X2:term, auto___def_17 X2 -> auto___type_2 X1 -> auto_knows_old X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_17 X2 -> auto_knows_old X2). tauto. exact (rem_4034 X2).
Qed.

Remark rem_4036 : forall X1 X2:term, auto___def_17 X2 -> auto___type_2 X1 -> (auto_knows_old X1 /\ auto_knows_old X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_old X1). 2:apply (rem_3880 X1 X2);  assumption.
  cut (auto_knows_old X2). 2:apply (rem_4035 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4037 : forall X1 X2:term, auto___def_17 X2 -> auto___type_2 X1 -> auto_knows_old (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4036 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4038 : auto_agent alice. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans_agent_alice_1;  tauto.
 tauto.
Qed.

Remark rem_4039 : forall X1 X2:term, auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_3790 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_key_3;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4040 : forall X1 X2:term, auto___type_10 X2 -> auto___def_46 X1 -> auto_knows_current (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_46 X1 -> auto___type_10 X2 -> auto_knows_current (key X1 X2)). tauto. exact (rem_4039 X1 X2).
Qed.

Remark rem_4041 : forall X1 X2:term, auto___def_2 X2 -> auto___type_10 X2 -> auto_knows_old X1 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_4042 : forall X1 X2:term, auto___type_10 X2 -> auto_knows_old X1 -> auto___def_2 X2 -> auto_knows_old X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_2 X2 -> auto___type_10 X2 -> auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_4041 X1 X2).
Qed.

Remark rem_4043 : forall X1 X2:term, auto___def_1 X1 X2 -> or_1
    (auto___type_10 X1 /\ auto_knows_old X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4044 : forall X1 X2:term, auto___def_1 X2 X1 -> auto___def_2 X2 -> auto_knows_old X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_4043 X2 X1 H);  intros.
  apply (rem_4042 X1 X2);  tauto.
Qed.

Remark rem_4045 : auto_agent server. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans_agent_server_1;  tauto.
 tauto.
Qed.

Remark rem_4046 : auto___def_6 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4047 : forall X1 X2:term, auto___def_6 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4048 : auto___def_6 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4049 : auto___def_6 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4050 : forall X1:term, auto___def_6 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4051 : auto___def_6 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4052 : auto___def_6 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4053 : auto___def_6 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4054 : forall X1 X2:term, auto___def_6 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4055 : auto___def_6 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4056 : auto___def_6 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4057 : forall X1 X2:term, auto___def_6 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4058 : forall X1 X2:term, auto___def_6 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4059 : forall X1 X2:term, auto___def_6 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4060 : forall X1 X2 X3:term, auto___def_6 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4061 : forall X1 X2:term, auto___def_6 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4062 : forall X1 X2 X3:term, auto___def_6 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4063 : forall X1 X2:term, auto___def_6 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4064 : forall X1:term, auto___def_6 X1 -> auto___def_30 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_6_m__def_30 1.
  intro X. case X.
   intro H. elim (rem_4046  H).
   intro H. elim (rem_4049  H).
  intros X1 X2. intro H. elim (rem_4054 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4061 X1 X2 H).
   intro H. elim (rem_4052  H).
  intros X1 X2. intro H. elim (rem_4057 X1 X2 H).
   intro H. elim (rem_4051  H).
  intros X1 X2. intro H. elim (rem_4059 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4047 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4063 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4058 X1 X2 H).
   intro H. elim (rem_4048  H).
   intro H. elim (rem_4053  H).
  intros X1. intro H. elim (rem_4050 X1 H).
   intro H. elim (rem_4055  H).
  intros X1 X2 X3. intro H. elim (rem_4060 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4062 X1 X2 X3 H).
   intro H. elim (rem_4056  H).
Qed.

Remark rem_4065 : forall X1 X2:term, auto___def_30 X2 -> auto___def_44 X1 -> auto___def_6 X2 -> auto_knows_old X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_4064 X2)). tauto.
Qed.

Remark rem_4066 : forall X1 X2:term, auto___def_44 X1 -> auto___def_30 X2 -> auto___def_6 X2 -> auto_knows_old X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_44 X1 -> auto___def_6 X2 -> auto_knows_old X1). tauto. exact (rem_4065 X1 X2).
Qed.

Remark rem_4067 : forall X1:term, auto___def_6 X1 -> auto___def_37 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_6_m__def_37 1.
  intro X. case X.
   intro H. elim (rem_4046  H).
   intro H. elim (rem_4049  H).
  intros X1 X2. intro H. elim (rem_4054 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4061 X1 X2 H).
   intro H. elim (rem_4052  H).
  intros X1 X2. intro H. elim (rem_4057 X1 X2 H).
   intro H. elim (rem_4051  H).
  intros X1 X2. intro H. elim (rem_4059 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4047 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4063 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4058 X1 X2 H).
   intro H. elim (rem_4048  H).
   intro H. elim (rem_4053  H).
  intros X1. intro H. elim (rem_4050 X1 H).
   intro H. elim (rem_4055  H).
  intros X1 X2 X3. intro H. elim (rem_4060 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4062 X1 X2 X3 H).
   intro H. elim (rem_4056  H).
Qed.

Remark rem_4068 : forall X1 X2:term, auto___def_33 X1 -> auto___def_37 X2 -> auto___def_6 X2 -> auto_knows_old X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_4067 X2)). tauto.
Qed.

Remark rem_4069 : forall X1:term, auto___def_6 X1 -> auto___def_13 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_6_m__def_13 1.
  intro X. case X.
   intro H. elim (rem_4046  H).
   intro H. elim (rem_4049  H).
  intros X1 X2. intro H. elim (rem_4054 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4061 X1 X2 H).
   intro H. elim (rem_4052  H).
  intros X1 X2. intro H. elim (rem_4057 X1 X2 H).
   intro H. elim (rem_4051  H).
  intros X1 X2. intro H. elim (rem_4059 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4047 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4063 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4058 X1 X2 H).
   intro H. elim (rem_4048  H).
   intro H. elim (rem_4053  H).
  intros X1. intro H. elim (rem_4050 X1 H).
   intro H. elim (rem_4055  H).
  intros X1 X2 X3. intro H. elim (rem_4060 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4062 X1 X2 X3 H).
   intro H. elim (rem_4056  H).
Qed.

Remark rem_4070 : forall X1 X2:term, auto___def_13 X2 -> auto___def_6 X2 -> auto___def_7 X1 -> auto_knows_old X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_4069 X2)). tauto.
Qed.

Remark rem_4071 : forall X1 X2:term, auto___def_7 X1 -> auto___def_13 X2 -> auto___def_6 X2 -> auto_knows_old X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_13 X2 -> auto___def_6 X2 -> auto___def_7 X1 -> auto_knows_old X1). tauto. exact (rem_4070 X1 X2).
Qed.

Remark rem_4072 : forall X1 X2:term, auto___def_30 X2 -> auto___def_42 X1 -> auto___def_6 X2 -> auto_knows_old X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_4064 X2)). tauto.
Qed.

Remark rem_4073 : forall X1 X2:term, auto___def_42 X1 -> auto___def_30 X2 -> auto___def_6 X2 -> auto_knows_old X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_30 X2 -> auto___def_42 X1 -> auto___def_6 X2 -> auto_knows_old X1). tauto. exact (rem_4072 X1 X2).
Qed.

Remark rem_4074 : forall X1:term, auto___def_6 X1 -> auto___def_39 X1 -> False. (* Induct. *)
Proof.
  fix epsilon_m__def_6_m__def_39 1.
  intro X. case X.
   intro H. elim (rem_4046  H).
   intro H. elim (rem_4049  H).
  intros X1 X2. intro H. elim (rem_4054 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4061 X1 X2 H).
   intro H. elim (rem_4052  H).
  intros X1 X2. intro H. elim (rem_4057 X1 X2 H).
   intro H. elim (rem_4051  H).
  intros X1 X2. intro H. elim (rem_4059 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4047 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4063 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4058 X1 X2 H).
   intro H. elim (rem_4048  H).
   intro H. elim (rem_4053  H).
  intros X1. intro H. elim (rem_4050 X1 H).
   intro H. elim (rem_4055  H).
  intros X1 X2 X3. intro H. elim (rem_4060 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4062 X1 X2 X3 H).
   intro H. elim (rem_4056  H).
Qed.

Remark rem_4075 : forall X1 X2:term, auto___def_23 X1 -> auto___def_39 X2 -> auto___def_6 X2 -> auto_knows_old X1. (* Subsumed by epsilon clause. *)
Proof.
  intros X1 X2. intros.
  assert (HH:=(rem_4074 X2)). tauto.
Qed.

Inductive or_5(H1 H2 H3 H4 H5:Prop) : Prop :=
    or_5_intro_1 : H1 -> (or_5 H1 H2 H3 H4 H5)
  | or_5_intro_2 : H2 -> (or_5 H1 H2 H3 H4 H5)
  | or_5_intro_3 : H3 -> (or_5 H1 H2 H3 H4 H5)
  | or_5_intro_4 : H4 -> (or_5 H1 H2 H3 H4 H5)
  | or_5_intro_5 : H5 -> (or_5 H1 H2 H3 H4 H5)
.

Remark rem_4076 : forall X1 X2:term, auto___def_5 X1 X2 -> or_5
    (auto___def_44 X1 /\ auto___def_30 X2)
    (auto___def_33 X1 /\ auto___def_37 X2)
    (auto___def_7 X1 /\ auto___def_13 X2)
    (auto___def_42 X1 /\ auto___def_30 X2)
    (auto___def_23 X1 /\ auto___def_39 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_5_intro_1; tauto.
  intros. apply or_5_intro_2; tauto.
  intros. apply or_5_intro_3; tauto.
  intros. apply or_5_intro_4; tauto.
  intros. apply or_5_intro_5; tauto.
Qed.

Remark rem_4077 : forall X1 X2:term, auto___def_5 X1 X2 -> auto___def_6 X2 -> auto_knows_old X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_4076 X1 X2 H);  intros.
  apply (rem_4066 X1 X2);  tauto.
  apply (rem_4068 X1 X2);  tauto.
  apply (rem_4071 X1 X2);  tauto.
  apply (rem_4073 X1 X2);  tauto.
  apply (rem_4075 X1 X2);  tauto.
Qed.

Remark rem_4078 : forall X1:term, auto___def_50 (session_current alice bob X1) -> False. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_45 alice bob X1 H);  intros.
Qed.

Remark rem_4079 : forall X1:term, auto___def_49 sym -> auto___def_50 (session_current alice bob X1) -> False. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_50 (session_current alice bob X1) -> False). tauto.
  exact (rem_4078 X1).
Qed.

Remark rem_4080 : forall X1:term, auto___def_47 sym -> auto___def_48 (session_current alice bob X1) -> False. (* Split. *)
Proof.
  intros X1.
  cut (auto___def_47 sym -> False). tauto.
  exact (rem_1155).
Qed.

Remark rem_4081 : forall X1:term, auto___def_46 sym -> auto___type_10 (session_current alice bob X1) -> False. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1. intros. apply rem_1157;  assumption.
Qed.

Remark rem_4082 : forall X1:term, auto_knows_current (key sym (session_current alice bob X1)) -> False. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_99 sym (session_current alice bob X1) H);  intros.
  apply (rem_4079 X1);  tauto.
  apply (rem_4080 X1);  tauto.
  apply (rem_4081 X1);  tauto.
Qed.

Remark rem_4083 : forall X1:term, auto_knows_current (key sym (session_current alice bob X1)) -> auto___query__intruder_knows_session_key_generated_by_server. (* Split. *)
Proof.
  intros X1.
  cut (auto_knows_current (key sym (session_current alice bob X1)) -> False). tauto.
  exact (rem_4082 X1).
Qed.

Remark rem_4084 : forall X1:term, auto___def_47 X1 -> auto___def_47 X1. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_4085 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_47 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_47 X1). tauto. exact (rem_4084 X1).
Qed.

Remark rem_4086 : forall X2:term, auto___def_48 X2 -> auto___def_48 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_4087 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto___def_48 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_48 X2 -> auto___def_48 X2). tauto. exact (rem_4086 X2).
Qed.

Remark rem_4088 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> (auto___def_47 X1 /\ auto___def_48 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_47 X1). 2:apply (rem_4085 X1 X2);  assumption.
  cut (auto___def_48 X2). 2:apply (rem_4087 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4089 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4088 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_key_2;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4090 : forall X1 X2:term, auto___def_48 X2 -> auto___def_47 X1 -> auto_knows_current (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_current (key X1 X2)). tauto. exact (rem_4089 X1 X2).
Qed.

Remark rem_4091 : forall X1 X2:term, auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_3745 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4092 : forall X1 X2:term, auto_knows_old X2 -> auto_knows_old X1 -> auto_knows_old (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X2 -> auto_knows_old (cons X1 X2)). tauto. exact (rem_4091 X1 X2).
Qed.

Remark rem_4093 : auto_agent bob. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans_agent_bob_1;  tauto.
 tauto.
Qed.

Remark rem_4094 : (forall X:term, auto___def_31 X -> auto_knows_old X)
    -> forall X1:term, auto___def_33 X1 -> auto___def_33 X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_4095 : (forall X:term, auto___def_31 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_33 X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_31_pknows_old. intros X1 X2.
  cut (auto___def_33 X1 -> auto___def_33 X1). tauto. exact (rem_4094 epsilon_m__def_31_pknows_old X1).
Defined.

Remark rem_4096 : (forall X:term, auto___def_31 X -> auto_knows_old X)
    -> forall X2:term, auto___def_34 X2 -> auto___def_34 X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_4097 : (forall X:term, auto___def_31 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto___def_34 X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_31_pknows_old. intros X1 X2.
  cut (auto___def_34 X2 -> auto___def_34 X2). tauto. exact (rem_4096 epsilon_m__def_31_pknows_old X2).
Defined.

Remark rem_4098 : (forall X:term, auto___def_31 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> (auto___def_33 X1 /\ auto___def_34 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_31_pknows_old. intros X1 X2. intros A1 A2.
  cut (auto___def_33 X1). 2:apply (rem_4095 epsilon_m__def_31_pknows_old X1 X2);  assumption.
  cut (auto___def_34 X2). 2:apply (rem_4097 epsilon_m__def_31_pknows_old X1 X2);  assumption.
  tauto.
Defined.

Remark rem_4099 : (forall X:term, auto___def_31 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_33 X1 -> auto___def_34 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_31_pknows_old. intros X1 X2. intros A1 A2.
  case (rem_4098 epsilon_m__def_31_pknows_old X1 X2 A1 A2). clear  epsilon_m__def_31_pknows_old A1 A2. intros. apply trans_knows_old_crypt_3;  tauto.
 clear  epsilon_m__def_31_pknows_old A1 A2. tauto.
Defined.

Remark rem_4100 : (forall X:term, auto___def_31 X -> auto_knows_old X)
    -> forall X1 X2:term, auto___def_31 (crypt X1 X2) -> auto_knows_old (crypt X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_31_pknows_old. intros X1 X2. intro H. intros.
  elim (rem_2165 X1 X2 H);  intros.
  apply (rem_4099 epsilon_m__def_31_pknows_old X1 X2);  tauto.
Defined.

Remark rem_4101 : forall X1:term, auto___def_31 X1 -> auto_knows_old X1. (* Induct. *)
Proof.
  fix epsilon_m__def_31_pknows_old 1.
  intro X. case X.
   intro H. elim (rem_2167  H).
   intro H. elim (rem_2170  H).
  intros X1 X2. intro H. elim (rem_2175 X1 X2 H).
  intros X1 X2;  exact (rem_4100 epsilon_m__def_31_pknows_old X1 X2).
   intro H. elim (rem_2173  H).
  intros X1 X2. intro H. elim (rem_2178 X1 X2 H).
   intro H. elim (rem_2172  H).
  intros X1 X2. intro H. elim (rem_2180 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2168 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2183 X1 X2 H).
  intros X1 X2. intro H. elim (rem_2179 X1 X2 H).
   intro H. elim (rem_2169  H).
   intro H. elim (rem_2174  H).
  intros X1. intro H. elim (rem_2171 X1 H).
   intro H. elim (rem_2176  H).
  intros X1 X2 X3. intro H. elim (rem_2181 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_2182 X1 X2 X3 H).
   intro H. elim (rem_2177  H).
Qed.

Remark rem_4102 : forall X1 X2 X3 X4:term, auto___def_27 X2 -> auto___def_31 X1 -> auto___type_5 X3 -> auto___type_7 X4 -> auto_agent X3 -> auto_agent X4 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4.
  cut (auto___def_31 X1 -> auto_knows_old X1). tauto. exact (rem_4101 X1).
Qed.

Remark rem_4103 : forall X1 X2 X3 X4:term, auto_agent X2 -> auto___type_7 X2 -> auto___def_31 X1 -> auto___type_5 X3 -> auto_agent X3 -> auto___def_27 X4 -> auto_knows_old X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X4 X3 X2.
  cut (auto___def_27 X2 -> auto___def_31 X1 -> auto___type_5 X3 -> auto___type_7 X4 -> auto_agent X3 -> auto_agent X4 -> auto_knows_old X1). tauto. exact (rem_4102 X1 X2 X3 X4).
Qed.

Remark rem_4104 : forall X1 X2 X3 X4:term, auto___def_40 X1 X2 X3 X4 -> or_1
    (auto_agent X1 /\ auto___type_7 X1 /\ auto___def_31 X2 /\ auto___type_5 X3 /\ auto_agent X3 /\ auto___def_27 X4)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4105 : forall X1 X2 X3 X4:term, auto___def_40 X2 X1 X3 X4 -> auto_knows_old X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4. intro H. intros.
  elim (rem_4104 X2 X1 X3 X4 H);  intros.
  apply (rem_4103 X1 X2 X3 X4);  tauto.
Qed.

Remark rem_4106 : forall X1 X2:term, auto___def_48 X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_4107 : forall X1 X2:term, auto___def_53 X1 X2 -> or_1
    (auto___def_48 X1 /\ auto_knows_current X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4108 : forall X1 X2:term, auto___def_53 X2 X1 -> auto_knows_current X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_4107 X2 X1 H);  intros.
  apply (rem_4106 X1 X2);  tauto.
Qed.

Remark rem_4109 : forall X1 X2:term, auto___def_53 X2 X1 -> auto___def_54 X2 -> auto_knows_current X1. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2. intros. apply (rem_4108 X1 X2);  assumption.
Qed.

Remark rem_4110 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_23 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_23 X1). tauto. exact (rem_575 X1).
Qed.

Remark rem_4111 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto___def_24 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_24 X2 -> auto___def_24 X2). tauto. exact (rem_577 X2).
Qed.

Remark rem_4112 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> (auto___def_23 X1 /\ auto___def_24 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_23 X1). 2:apply (rem_4110 X1 X2);  assumption.
  cut (auto___def_24 X2). 2:apply (rem_4111 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4113 : forall X1 X2:term, auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4112 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_crypt_2;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4114 : forall X1 X2:term, auto___def_24 X2 -> auto___def_23 X1 -> auto_knows_old (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_23 X1 -> auto___def_24 X2 -> auto_knows_old (crypt X1 X2)). tauto. exact (rem_4113 X1 X2).
Qed.

Remark rem_4115 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_68 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_68 X1). tauto. exact (rem_1937 X1).
Qed.

Remark rem_4116 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto___def_69 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_69 X2 -> auto___def_69 X2). tauto. exact (rem_3011 X2).
Qed.

Remark rem_4117 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> (auto___def_68 X1 /\ auto___def_69 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_68 X1). 2:apply (rem_4115 X1 X2);  assumption.
  cut (auto___def_69 X2). 2:apply (rem_4116 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4118 : forall X1 X2:term, auto___def_68 X1 -> auto___def_69 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4117 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_crypt_6;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4119 : forall X1 X2:term, auto___def_69 X2 -> auto___def_68 X1 -> auto_knows_current (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_68 X1 -> auto___def_69 X2 -> auto_knows_current (crypt X1 X2)). tauto. exact (rem_4118 X1 X2).
Qed.

Remark rem_4120 : forall X1:term, auto_agent X1 -> auto_knows_old X1. (* Induct. *)
Proof.
  fix epsilon_magent_pknows_old 1.
  intro X. case X.
  exact (rem_690 epsilon_magent_pknows_old ).
  exact (rem_692 epsilon_magent_pknows_old ).
  intros X1 X2. intro H. elim (rem_504 X1 X2 H).
  intros X1 X2. intro H. elim (rem_510 X1 X2 H).
  exact (rem_694 epsilon_magent_pknows_old ).
  intros X1 X2. intro H. elim (rem_506 X1 X2 H).
   intro H. elim (rem_502  H).
  intros X1 X2. intro H. elim (rem_508 X1 X2 H).
  intros X1 X2. intro H. elim (rem_499 X1 X2 H).
  intros X1 X2. intro H. elim (rem_512 X1 X2 H).
  intros X1 X2. intro H. elim (rem_507 X1 X2 H).
   intro H. elim (rem_500  H).
   intro H. elim (rem_503  H).
  intros X1. intro H. elim (rem_501 X1 H).
  exact (rem_696 epsilon_magent_pknows_old ).
  intros X1 X2 X3. intro H. elim (rem_509 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_511 X1 X2 X3 H).
   intro H. elim (rem_505  H).
Qed.

Remark rem_4121 : forall X1:term, auto___def_72 X1 -> auto___type_15 bob -> auto___type_19 X1 -> auto_agent bob -> auto_knows_current X1 -> False. (* Subsumed by epsilon clause. *)
Proof.
  intros X1. intros.
  assert (HH:=(rem_120 X1)). tauto.
Qed.

Remark rem_4122 : forall X1:term, auto___type_15 bob -> auto_agent bob -> auto___def_72 X1 -> auto___type_19 X1 -> auto_knows_current X1 -> False. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1.
  cut (auto___def_72 X1 -> auto___type_15 bob -> auto___type_19 X1 -> auto_agent bob -> auto_knows_current X1 -> False). tauto. exact (rem_4121 X1).
Qed.

Remark rem_4123 : forall X1 X2:term, auto_bob_key_current X1 X2 -> or_1
    (auto___type_15 X1 /\ auto_agent X1 /\ auto___def_72 X2 /\ auto___type_19 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4124 : forall X1:term, auto_bob_key_current bob X1 -> auto_knows_current X1 -> False. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_4123 bob X1 H);  intros.
  apply (rem_4122 X1);  tauto.
Qed.

Remark rem_4125 : forall X1:term, auto_bob_key_current bob X1 -> auto_knows_current X1 -> auto___query__intruder_knows_session_key_as_seen_by_B. (* Split. *)
Proof.
  intros X1.
  cut (auto_bob_key_current bob X1 -> auto_knows_current X1 -> False). tauto.
  exact (rem_4124 X1).
Qed.

Remark rem_4126 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___def_44 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_44 X1 -> auto___def_44 X1). tauto. exact (rem_590 X1).
Qed.

Remark rem_4127 : forall X2:term, auto___type_9 X2 -> auto___type_9 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_4128 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_9 X2 -> auto___type_9 X2). tauto. exact (rem_4127 X2).
Qed.

Remark rem_4129 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> (auto___def_44 X1 /\ auto___type_9 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_44 X1). 2:apply (rem_4126 X1 X2);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_4128 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4130 : forall X1 X2:term, auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4129 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_crypt_4;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4131 : forall X1 X2:term, auto___type_9 X2 -> auto___def_44 X1 -> auto_knows_old (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_44 X1 -> auto___type_9 X2 -> auto_knows_old (crypt X1 X2)). tauto. exact (rem_4130 X1 X2).
Qed.

Remark rem_4132 : auto_agent i. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans_agent_i_1;  tauto.
 tauto.
Qed.

Remark rem_4133 : forall X1 X2:term, auto_knows_old (cons X1 X2) -> auto_knows_old X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_383 X1 X2 H);  intros.
  apply (rem_3743 X1 X2);  tauto.
Qed.

Remark rem_4134 : forall X1 X2 X3 X4 X5:term, auto___def_27 X2 -> auto___def_31 X3 -> auto___type_5 X4 -> auto___type_7 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_old (crypt X5 X2) -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_658 X1).
Qed.

Remark rem_4135 : forall X1 X2 X3 X4 X5:term, auto___def_27 X2 -> auto___def_31 X3 -> auto___type_5 X4 -> auto___type_7 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_old (crypt X5 X2) -> auto___type_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto___type_7 X1 -> auto___type_7 X1). tauto. exact (rem_8 X1).
Qed.

Remark rem_4136 : forall X1 X2 X3 X4 X5:term, auto___def_27 X2 -> auto___def_31 X3 -> auto___type_5 X4 -> auto___type_7 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_old (crypt X5 X2) -> auto___type_9 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto___def_27 X2 -> auto___type_9 X2). tauto. exact (rem_617 X2).
Qed.

Remark rem_4137 : forall X1 X2 X3 X4 X5:term, auto___def_27 X2 -> auto___def_31 X3 -> auto___type_5 X4 -> auto___type_7 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_old (crypt X5 X2) -> auto___def_27 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto___def_27 X2 -> auto___def_27 X2). tauto. exact (rem_570 X2).
Qed.

Remark rem_4138 : forall X1 X2 X3 X4 X5:term, auto___def_27 X2 -> auto___def_31 X3 -> auto___type_5 X4 -> auto___type_7 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_old (crypt X5 X2) -> (auto_agent X1 /\ auto___type_7 X1 /\ auto___type_9 X2 /\ auto___def_27 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4 X5. intros A1 A2 A3 A4 A5 A6 A7.
  cut (auto_agent X1). 2:apply (rem_4134 X1 X2 X3 X4 X5);  assumption.
  cut (auto___type_7 X1). 2:apply (rem_4135 X1 X2 X3 X4 X5);  assumption.
  cut (auto___type_9 X2). 2:apply (rem_4136 X1 X2 X3 X4 X5);  assumption.
  cut (auto___def_27 X2). 2:apply (rem_4137 X1 X2 X3 X4 X5);  assumption.
  tauto.
Qed.

Remark rem_4139 : forall X1 X2 X3 X4 X5:term, auto___def_27 X2 -> auto___def_31 X3 -> auto___type_5 X4 -> auto___type_7 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_old (crypt X5 X2) -> auto_alice_key_old X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4 X5. intros A1 A2 A3 A4 A5 A6 A7.
  case (rem_4138 X1 X2 X3 X4 X5 A1 A2 A3 A4 A5 A6 A7). clear  A1 A2 A3 A4 A5 A6 A7. intros. apply trans_alice_key_old_1;  tauto.
 clear  A1 A2 A3 A4 A5 A6 A7. tauto.
Qed.

Remark rem_4140 : forall X1 X2 X3 X4 X5:term, auto_agent X1 -> auto___type_7 X1 -> auto___def_31 X3 -> auto___type_5 X4 -> auto_agent X4 -> auto___def_27 X2 -> auto_knows_old (crypt X5 X2) -> auto_alice_key_old X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4 X5.
  cut (auto___def_27 X2 -> auto___def_31 X3 -> auto___type_5 X4 -> auto___type_7 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_old (crypt X5 X2) -> auto_alice_key_old X1 X2). tauto. exact (rem_4139 X1 X2 X3 X4 X5).
Qed.

Remark rem_4141 : forall X1 X2 X3 X4 X5:term, auto___def_40 X1 X3 X4 X2 -> auto_knows_old (crypt X5 X2) -> auto_alice_key_old X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4 X5. intro H. intros.
  elim (rem_4104 X1 X3 X4 X2 H);  intros.
  apply (rem_4140 X1 X2 X3 X4 X5);  tauto.
Qed.

Remark rem_4142 : forall X1 X2 X3 X4 X5:term, auto_knows_old (crypt X5 X2) -> auto___def_40 X1 X3 X4 X2 -> auto_alice_key_old X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4 X5.
  cut (auto___def_40 X1 X3 X4 X2 -> auto_knows_old (crypt X5 X2) -> auto_alice_key_old X1 X2). tauto. exact (rem_4141 X1 X2 X3 X4 X5).
Qed.

Remark rem_4143 : forall X1:term, auto_knows_old (s X1) -> auto_knows_old X1. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_370 X1 H);  intros.
  apply (rem_567 X1);  tauto.
Qed.

Remark rem_4144 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X2 -> auto_knows_current X2). tauto. exact (rem_1899 X2).
Qed.

Remark rem_4145 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_3795 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_4144 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4146 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4145 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_crypt_7;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4147 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current X1 -> auto_knows_current (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (crypt X1 X2)). tauto. exact (rem_4146 X1 X2).
Qed.

Remark rem_4148 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_7 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_7 X1). tauto. exact (rem_638 X1).
Qed.

Remark rem_4149 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto___def_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_8 X2 -> auto___def_8 X2). tauto. exact (rem_640 X2).
Qed.

Remark rem_4150 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> (auto___def_7 X1 /\ auto___def_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_7 X1). 2:apply (rem_4148 X1 X2);  assumption.
  cut (auto___def_8 X2). 2:apply (rem_4149 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4151 : forall X1 X2:term, auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4150 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_crypt_6;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4152 : forall X1 X2:term, auto___def_8 X2 -> auto___def_7 X1 -> auto_knows_old (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_7 X1 -> auto___def_8 X2 -> auto_knows_old (crypt X1 X2)). tauto. exact (rem_4151 X1 X2).
Qed.

Remark rem_4153 : forall X1 X2 X3:term, auto___def_41 X3 X1 X2 -> auto___def_45 X3 X1 X2 -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1 A2.
  tauto.
Qed.

Remark rem_4154 : forall X1 X2 X3:term, auto___def_41 X3 X1 X2 -> auto___def_45 X3 X1 X2 -> auto_bob_key_old X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1 A2.
  case (rem_4153 X1 X2 X3 A1 A2). clear  A1 A2. intros. apply trans_bob_key_old_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4155 : forall X1 X2 X3:term, auto___def_45 X3 X1 X2 -> auto___def_41 X3 X1 X2 -> auto_bob_key_old X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_41 X3 X1 X2 -> auto___def_45 X3 X1 X2 -> auto_bob_key_old X1 X2). tauto. exact (rem_4154 X1 X2 X3).
Qed.

Remark rem_4156 : forall X1 X2:term, auto_knows_current (noncea_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2.  case (rem_524). intros. apply trans_knows_current_noncea_old_1;  tauto.
 tauto.
Qed.

Remark rem_4157 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___def_87 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_87 X1 -> auto___def_87 X1). tauto. exact (rem_285 X1).
Qed.

Remark rem_4158 : forall X2:term, auto___type_18 X2 -> auto___type_18 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_4159 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_18 X2 -> auto___type_18 X2). tauto. exact (rem_4158 X2).
Qed.

Remark rem_4160 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> (auto___def_87 X1 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_87 X1). 2:apply (rem_4157 X1 X2);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_4159 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4161 : forall X1 X2:term, auto___def_87 X1 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4160 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_crypt_8;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4162 : forall X1 X2:term, auto___type_18 X2 -> auto___def_87 X1 -> auto_knows_current (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_87 X1 -> auto___type_18 X2 -> auto_knows_current (crypt X1 X2)). tauto. exact (rem_4161 X1 X2).
Qed.

Remark rem_4163 : forall X1 X2:term, auto___def_52 X2 -> auto___type_10 X2 -> auto_knows_current X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_446 X1).
Qed.

Remark rem_4164 : forall X1 X2:term, auto___type_10 X2 -> auto_knows_current X1 -> auto___def_52 X2 -> auto_knows_current X1. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_52 X2 -> auto___type_10 X2 -> auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_4163 X1 X2).
Qed.

Remark rem_4165 : forall X1 X2:term, auto___def_51 X1 X2 -> or_1
    (auto___type_10 X1 /\ auto_knows_current X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4166 : forall X1 X2:term, auto___def_51 X2 X1 -> auto___def_52 X2 -> auto_knows_current X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_4165 X2 X1 H);  intros.
  apply (rem_4164 X1 X2);  tauto.
Qed.

Remark rem_4167 : forall X1 X2:term, auto_knows_current (nonceb_old X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2.  case (rem_524). intros. apply trans_knows_current_nonceb_old_1;  tauto.
 tauto.
Qed.

Remark rem_4168 : forall X1:term, auto___def_72 X1 -> auto___type_17 alice -> auto___type_18 X1 -> auto_agent alice -> auto_knows_current X1 -> False. (* Subsumed by epsilon clause. *)
Proof.
  intros X1. intros.
  assert (HH:=(rem_120 X1)). tauto.
Qed.

Remark rem_4169 : forall X1:term, auto_agent alice -> auto___type_17 alice -> auto___def_72 X1 -> auto___type_18 X1 -> auto_knows_current X1 -> False. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1.
  cut (auto___def_72 X1 -> auto___type_17 alice -> auto___type_18 X1 -> auto_agent alice -> auto_knows_current X1 -> False). tauto. exact (rem_4168 X1).
Qed.

Remark rem_4170 : forall X1:term, auto_alice_key_current alice X1 -> auto_knows_current X1 -> False. (* Eliminate negative atom. *)
Proof.
  intros X1. intro H. intros.
  elim (rem_3036 alice X1 H);  intros.
  apply (rem_4169 X1);  tauto.
Qed.

Remark rem_4171 : forall X1:term, auto_alice_key_current alice X1 -> auto_knows_current X1 -> auto___query__intruder_knows_session_key_as_seen_by_alice. (* Split. *)
Proof.
  intros X1.
  cut (auto_alice_key_current alice X1 -> auto_knows_current X1 -> False). tauto.
  exact (rem_4170 X1).
Qed.

Remark rem_4172 : forall X1 X2 X3 X4 X5:term, auto___def_72 X2 -> auto___def_76 X3 -> auto___type_15 X4 -> auto___type_17 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_current (crypt X5 X2) -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_658 X1).
Qed.

Remark rem_4173 : forall X1 X2 X3 X4 X5:term, auto___def_72 X2 -> auto___def_76 X3 -> auto___type_15 X4 -> auto___type_17 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_current (crypt X5 X2) -> auto___type_17 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto___type_17 X1 -> auto___type_17 X1). tauto. exact (rem_2645 X1).
Qed.

Remark rem_4174 : forall X1 X2 X3 X4 X5:term, auto___def_72 X2 -> auto___def_76 X3 -> auto___type_15 X4 -> auto___type_17 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_current (crypt X5 X2) -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_4175 : forall X1 X2 X3 X4 X5:term, auto___def_72 X2 -> auto___def_76 X3 -> auto___type_15 X4 -> auto___type_17 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_current (crypt X5 X2) -> auto___type_18 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3 X4 X5.
  cut (auto___def_72 X2 -> auto___type_18 X2). tauto. exact (rem_3022 X2).
Qed.

Remark rem_4176 : forall X1 X2 X3 X4 X5:term, auto___def_72 X2 -> auto___def_76 X3 -> auto___type_15 X4 -> auto___type_17 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_current (crypt X5 X2) -> (auto_agent X1 /\ auto___type_17 X1 /\ auto___def_72 X2 /\ auto___type_18 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3 X4 X5. intros A1 A2 A3 A4 A5 A6 A7.
  cut (auto_agent X1). 2:apply (rem_4172 X1 X2 X3 X4 X5);  assumption.
  cut (auto___type_17 X1). 2:apply (rem_4173 X1 X2 X3 X4 X5);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_4174 X1 X2 X3 X4 X5);  assumption.
  cut (auto___type_18 X2). 2:apply (rem_4175 X1 X2 X3 X4 X5);  assumption.
  tauto.
Qed.

Remark rem_4177 : forall X1 X2 X3 X4 X5:term, auto___def_72 X2 -> auto___def_76 X3 -> auto___type_15 X4 -> auto___type_17 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_current (crypt X5 X2) -> auto_alice_key_current X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3 X4 X5. intros A1 A2 A3 A4 A5 A6 A7.
  case (rem_4176 X1 X2 X3 X4 X5 A1 A2 A3 A4 A5 A6 A7). clear  A1 A2 A3 A4 A5 A6 A7. intros. apply trans_alice_key_current_1;  tauto.
 clear  A1 A2 A3 A4 A5 A6 A7. tauto.
Qed.

Remark rem_4178 : forall X1 X2 X3 X4 X5:term, auto_agent X1 -> auto___type_17 X1 -> auto___def_76 X3 -> auto___type_15 X4 -> auto_agent X4 -> auto___def_72 X2 -> auto_knows_current (crypt X5 X2) -> auto_alice_key_current X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4 X5.
  cut (auto___def_72 X2 -> auto___def_76 X3 -> auto___type_15 X4 -> auto___type_17 X1 -> auto_agent X4 -> auto_agent X1 -> auto_knows_current (crypt X5 X2) -> auto_alice_key_current X1 X2). tauto. exact (rem_4177 X1 X2 X3 X4 X5).
Qed.

Remark rem_4179 : forall X1 X2 X3 X4 X5:term, auto___def_85 X1 X3 X4 X2 -> auto_knows_current (crypt X5 X2) -> auto_alice_key_current X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3 X4 X5. intro H. intros.
  elim (rem_3785 X1 X3 X4 X2 H);  intros.
  apply (rem_4178 X1 X2 X3 X4 X5);  tauto.
Qed.

Remark rem_4180 : forall X1 X2 X3 X4 X5:term, auto_knows_current (crypt X5 X2) -> auto___def_85 X1 X3 X4 X2 -> auto_alice_key_current X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3 X4 X5.
  cut (auto___def_85 X1 X3 X4 X2 -> auto_knows_current (crypt X5 X2) -> auto_alice_key_current X1 X2). tauto. exact (rem_4179 X1 X2 X3 X4 X5).
Qed.

Remark rem_4181 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_57 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_57 X1). tauto. exact (rem_1931 X1).
Qed.

Remark rem_4182 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto___def_58 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_58 X2 -> auto___def_58 X2). tauto. exact (rem_3004 X2).
Qed.

Remark rem_4183 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> (auto___def_57 X1 /\ auto___def_58 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_57 X1). 2:apply (rem_4181 X1 X2);  assumption.
  cut (auto___def_58 X2). 2:apply (rem_4182 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4184 : forall X1 X2:term, auto___def_57 X1 -> auto___def_58 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4183 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_crypt_5;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4185 : forall X1 X2:term, auto___def_58 X2 -> auto___def_57 X1 -> auto_knows_current (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_57 X1 -> auto___def_58 X2 -> auto_knows_current (crypt X1 X2)). tauto. exact (rem_4184 X1 X2).
Qed.

Remark rem_4186 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_12_pknows_current.  tauto.
Defined.

Remark rem_4187 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current.  case (rem_4186 epsilon_m__type_12_pknows_current). clear  epsilon_m__type_12_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_12_pknows_current. tauto.
Defined.

Remark rem_4188 : auto___type_12 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4189 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto___type_12 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current. intro H. intros.
  elim (rem_4188 H);  intros.
  apply (rem_4187 epsilon_m__type_12_pknows_current);  tauto.
Defined.

Remark rem_4190 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current.  case (rem_4186 epsilon_m__type_12_pknows_current). clear  epsilon_m__type_12_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_12_pknows_current. tauto.
Defined.

Remark rem_4191 : auto___type_12 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4192 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto___type_12 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current. intro H. intros.
  elim (rem_4191 H);  intros.
  apply (rem_4190 epsilon_m__type_12_pknows_current);  tauto.
Defined.

Remark rem_4193 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current.  case (rem_4186 epsilon_m__type_12_pknows_current). clear  epsilon_m__type_12_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_12_pknows_current. tauto.
Defined.

Remark rem_4194 : auto___type_12 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4195 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto___type_12 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current. intro H. intros.
  elim (rem_4194 H);  intros.
  apply (rem_4193 epsilon_m__type_12_pknows_current);  tauto.
Defined.

Remark rem_4196 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current.  case (rem_4186 epsilon_m__type_12_pknows_current). clear  epsilon_m__type_12_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_12_pknows_current. tauto.
Defined.

Remark rem_4197 : auto___type_12 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4198 : (forall X:term, auto___type_12 X -> auto_knows_current X)
    -> auto___type_12 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_12_pknows_current. intro H. intros.
  elim (rem_4197 H);  intros.
  apply (rem_4196 epsilon_m__type_12_pknows_current);  tauto.
Defined.

Remark rem_4199 : forall X1 X2:term, auto___type_12 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4200 : auto___type_12 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4201 : forall X1:term, auto___type_12 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4202 : auto___type_12 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4203 : auto___type_12 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4204 : forall X1 X2:term, auto___type_12 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4205 : auto___type_12 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4206 : forall X1 X2:term, auto___type_12 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4207 : forall X1 X2:term, auto___type_12 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4208 : forall X1 X2:term, auto___type_12 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4209 : forall X1 X2 X3:term, auto___type_12 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4210 : forall X1 X2:term, auto___type_12 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4211 : forall X1 X2 X3:term, auto___type_12 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4212 : forall X1 X2:term, auto___type_12 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4213 : forall X1:term, auto___type_12 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_12_pknows_current 1.
  intro X. case X.
  exact (rem_4189 epsilon_m__type_12_pknows_current ).
  exact (rem_4192 epsilon_m__type_12_pknows_current ).
  intros X1 X2. intro H. elim (rem_4204 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4210 X1 X2 H).
  exact (rem_4195 epsilon_m__type_12_pknows_current ).
  intros X1 X2. intro H. elim (rem_4206 X1 X2 H).
   intro H. elim (rem_4202  H).
  intros X1 X2. intro H. elim (rem_4208 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4199 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4212 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4207 X1 X2 H).
   intro H. elim (rem_4200  H).
   intro H. elim (rem_4203  H).
  intros X1. intro H. elim (rem_4201 X1 H).
  exact (rem_4198 epsilon_m__type_12_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_4209 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4211 X1 X2 X3 H).
   intro H. elim (rem_4205  H).
Qed.

Remark rem_4214 : forall X1 X2:term, auto___def_62 X2 -> auto___type_12 X1 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_12 X1 -> auto_knows_current X1). tauto. exact (rem_4213 X1).
Qed.

Remark rem_4215 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__type_13_pknows_current.  tauto.
Defined.

Remark rem_4216 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto_knows_current alice. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current.  case (rem_4215 epsilon_m__type_13_pknows_current). clear  epsilon_m__type_13_pknows_current. intros. apply trans_knows_current_alice_1;  tauto.
 clear  epsilon_m__type_13_pknows_current. tauto.
Defined.

Remark rem_4217 : auto___type_13 alice -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4218 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto___type_13 alice -> auto_knows_current alice. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current. intro H. intros.
  elim (rem_4217 H);  intros.
  apply (rem_4216 epsilon_m__type_13_pknows_current);  tauto.
Defined.

Remark rem_4219 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto_knows_current bob. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current.  case (rem_4215 epsilon_m__type_13_pknows_current). clear  epsilon_m__type_13_pknows_current. intros. apply trans_knows_current_bob_1;  tauto.
 clear  epsilon_m__type_13_pknows_current. tauto.
Defined.

Remark rem_4220 : auto___type_13 bob -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4221 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto___type_13 bob -> auto_knows_current bob. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current. intro H. intros.
  elim (rem_4220 H);  intros.
  apply (rem_4219 epsilon_m__type_13_pknows_current);  tauto.
Defined.

Remark rem_4222 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto_knows_current i. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current.  case (rem_4215 epsilon_m__type_13_pknows_current). clear  epsilon_m__type_13_pknows_current. intros. apply trans_knows_current_i_1;  tauto.
 clear  epsilon_m__type_13_pknows_current. tauto.
Defined.

Remark rem_4223 : auto___type_13 i -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4224 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto___type_13 i -> auto_knows_current i. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current. intro H. intros.
  elim (rem_4223 H);  intros.
  apply (rem_4222 epsilon_m__type_13_pknows_current);  tauto.
Defined.

Remark rem_4225 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto_knows_current server. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current.  case (rem_4215 epsilon_m__type_13_pknows_current). clear  epsilon_m__type_13_pknows_current. intros. apply trans_knows_current_server_1;  tauto.
 clear  epsilon_m__type_13_pknows_current. tauto.
Defined.

Remark rem_4226 : auto___type_13 server -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4227 : (forall X:term, auto___type_13 X -> auto_knows_current X)
    -> auto___type_13 server -> auto_knows_current server. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__type_13_pknows_current. intro H. intros.
  elim (rem_4226 H);  intros.
  apply (rem_4225 epsilon_m__type_13_pknows_current);  tauto.
Defined.

Remark rem_4228 : forall X1 X2:term, auto___type_13 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4229 : auto___type_13 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4230 : forall X1:term, auto___type_13 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4231 : auto___type_13 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4232 : auto___type_13 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4233 : forall X1 X2:term, auto___type_13 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4234 : auto___type_13 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4235 : forall X1 X2:term, auto___type_13 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4236 : forall X1 X2:term, auto___type_13 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4237 : forall X1 X2:term, auto___type_13 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4238 : forall X1 X2 X3:term, auto___type_13 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4239 : forall X1 X2:term, auto___type_13 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4240 : forall X1 X2 X3:term, auto___type_13 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4241 : forall X1 X2:term, auto___type_13 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4242 : forall X1:term, auto___type_13 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__type_13_pknows_current 1.
  intro X. case X.
  exact (rem_4218 epsilon_m__type_13_pknows_current ).
  exact (rem_4221 epsilon_m__type_13_pknows_current ).
  intros X1 X2. intro H. elim (rem_4233 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4239 X1 X2 H).
  exact (rem_4224 epsilon_m__type_13_pknows_current ).
  intros X1 X2. intro H. elim (rem_4235 X1 X2 H).
   intro H. elim (rem_4231  H).
  intros X1 X2. intro H. elim (rem_4237 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4228 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4241 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4236 X1 X2 H).
   intro H. elim (rem_4229  H).
   intro H. elim (rem_4232  H).
  intros X1. intro H. elim (rem_4230 X1 H).
  exact (rem_4227 epsilon_m__type_13_pknows_current ).
  intros X1 X2 X3. intro H. elim (rem_4238 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4240 X1 X2 X3 H).
   intro H. elim (rem_4234  H).
Qed.

Remark rem_4243 : (forall X:term, auto___def_62 X -> auto_knows_current X)
    -> forall X1:term, auto___type_13 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_62_pknows_current. exact (rem_4242).
Defined.

Remark rem_4244 : (forall X:term, auto___def_62 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_13 X1 -> auto___def_63 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_62_pknows_current. intros X1 X2.
  cut (auto___type_13 X1 -> auto_knows_current X1). tauto. exact (rem_4243 epsilon_m__def_62_pknows_current X1).
Defined.

Remark rem_4245 : (forall X:term, auto___def_64 X -> auto_knows_current X)
    -> forall X1:term, auto_agent X1 -> auto_agent X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_4246 : (forall X:term, auto___def_64 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_64_pknows_current. intros X1 X2.
  cut (auto_agent X1 -> auto_agent X1). tauto. exact (rem_4245 epsilon_m__def_64_pknows_current X1).
Defined.

Remark rem_4247 : (forall X:term, auto___def_64 X -> auto_knows_current X)
    -> forall X2:term, auto_agent X2 -> auto_agent X2. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_4248 : (forall X:term, auto___def_64 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_agent X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_64_pknows_current. intros X1 X2.
  cut (auto_agent X2 -> auto_agent X2). tauto. exact (rem_4247 epsilon_m__def_64_pknows_current X2).
Defined.

Remark rem_4249 : (forall X:term, auto___def_64 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> (auto_agent X1 /\ auto_agent X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_64_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_agent X1). 2:apply (rem_4246 epsilon_m__def_64_pknows_current X1 X2);  assumption.
  cut (auto_agent X2). 2:apply (rem_4248 epsilon_m__def_64_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_4250 : (forall X:term, auto___def_64 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_agent X1 -> auto_agent X2 -> auto_knows_current (noncea_current X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_64_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_4249 epsilon_m__def_64_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_64_pknows_current A1 A2. intros. apply trans_knows_current_noncea_current_1;  tauto.
 clear  epsilon_m__def_64_pknows_current A1 A2. tauto.
Defined.

Remark rem_4251 : forall X1 X2:term, auto___def_64 (noncea_current X1 X2) -> or_1
    (auto_agent X1 /\ auto_agent X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4252 : (forall X:term, auto___def_64 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_64 (noncea_current X1 X2) -> auto_knows_current (noncea_current X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_64_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_4251 X1 X2 H);  intros.
  apply (rem_4250 epsilon_m__def_64_pknows_current X1 X2);  tauto.
Defined.

Remark rem_4253 : auto___def_64 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4254 : forall X1 X2:term, auto___def_64 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4255 : auto___def_64 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4256 : auto___def_64 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4257 : forall X1:term, auto___def_64 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4258 : auto___def_64 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4259 : auto___def_64 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4260 : auto___def_64 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4261 : forall X1 X2:term, auto___def_64 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4262 : auto___def_64 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4263 : auto___def_64 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4264 : forall X1 X2:term, auto___def_64 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4265 : forall X1 X2:term, auto___def_64 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4266 : forall X1 X2 X3:term, auto___def_64 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4267 : forall X1 X2:term, auto___def_64 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4268 : forall X1 X2 X3:term, auto___def_64 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4269 : forall X1 X2:term, auto___def_64 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4270 : forall X1:term, auto___def_64 X1 -> auto_knows_current X1. (* Induct. *)
Proof.
  fix epsilon_m__def_64_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_4253  H).
   intro H. elim (rem_4256  H).
  intros X1 X2. intro H. elim (rem_4261 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4267 X1 X2 H).
   intro H. elim (rem_4259  H).
  intros X1 X2. intro H. elim (rem_4264 X1 X2 H).
   intro H. elim (rem_4258  H).
  intros X1 X2;  exact (rem_4252 epsilon_m__def_64_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_4254 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4269 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4265 X1 X2 H).
   intro H. elim (rem_4255  H).
   intro H. elim (rem_4260  H).
  intros X1. intro H. elim (rem_4257 X1 H).
   intro H. elim (rem_4262  H).
  intros X1 X2 X3. intro H. elim (rem_4266 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4268 X1 X2 X3 H).
   intro H. elim (rem_4263  H).
Qed.

Remark rem_4271 : (forall X:term, auto___def_63 X -> auto_knows_current X)
    -> forall X1:term, auto___def_64 X1 -> auto_knows_current X1. (* Cut history. *)
Proof.  intros epsilon_m__def_63_pknows_current. exact (rem_4270).
Defined.

Remark rem_4272 : (forall X:term, auto___def_63 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_63_pknows_current. intros X1 X2.
  cut (auto___def_64 X1 -> auto_knows_current X1). tauto. exact (rem_4271 epsilon_m__def_63_pknows_current X1).
Defined.

Remark rem_4273 : (forall X:term, auto___def_65 X -> auto_knows_current X)
    -> forall X1:term, auto_knows_current X1 -> auto_knows_current X1. (* Tautology. *)
Proof. intro H. clear H. tauto. Defined.

Remark rem_4274 : (forall X:term, auto___def_65 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto___def_66 X2 -> auto_knows_current X1. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_65_pknows_current. intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X1). tauto. exact (rem_4273 epsilon_m__def_65_pknows_current X1).
Defined.

Remark rem_4275 : (forall X:term, auto___def_66 X -> auto_knows_current X)
    -> True \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_66_pknows_current.  tauto.
Defined.

Remark rem_4276 : (forall X:term, auto___def_66 X -> auto_knows_current X)
    -> auto_knows_current nil. (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_66_pknows_current.  case (rem_4275 epsilon_m__def_66_pknows_current). clear  epsilon_m__def_66_pknows_current. intros. apply trans_knows_current_nil_1;  tauto.
 clear  epsilon_m__def_66_pknows_current. tauto.
Defined.

Remark rem_4277 : auto___def_66 nil -> or_1
    True.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4278 : (forall X:term, auto___def_66 X -> auto_knows_current X)
    -> auto___def_66 nil -> auto_knows_current nil. (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_66_pknows_current. intro H. intros.
  elim (rem_4277 H);  intros.
  apply (rem_4276 epsilon_m__def_66_pknows_current);  tauto.
Defined.

Remark rem_4279 : auto___def_66 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4280 : forall X1 X2:term, auto___def_66 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4281 : auto___def_66 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4282 : auto___def_66 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4283 : forall X1:term, auto___def_66 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4284 : auto___def_66 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4285 : auto___def_66 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4286 : forall X1 X2:term, auto___def_66 (cons X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4287 : auto___def_66 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4288 : auto___def_66 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4289 : forall X1 X2:term, auto___def_66 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4290 : forall X1 X2:term, auto___def_66 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4291 : forall X1 X2:term, auto___def_66 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4292 : forall X1 X2 X3:term, auto___def_66 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4293 : forall X1 X2:term, auto___def_66 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4294 : forall X1 X2 X3:term, auto___def_66 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4295 : forall X1 X2:term, auto___def_66 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4296 : forall X2:term, auto___def_66 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_66_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_4279  H).
   intro H. elim (rem_4282  H).
  intros X1 X2. intro H. elim (rem_4286 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4293 X1 X2 H).
   intro H. elim (rem_4284  H).
  intros X1 X2. intro H. elim (rem_4289 X1 X2 H).
  exact (rem_4278 epsilon_m__def_66_pknows_current ).
  intros X1 X2. intro H. elim (rem_4291 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4280 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4295 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4290 X1 X2 H).
   intro H. elim (rem_4281  H).
   intro H. elim (rem_4285  H).
  intros X1. intro H. elim (rem_4283 X1 H).
   intro H. elim (rem_4287  H).
  intros X1 X2 X3. intro H. elim (rem_4292 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4294 X1 X2 X3 H).
   intro H. elim (rem_4288  H).
Qed.

Remark rem_4297 : (forall X:term, auto___def_65 X -> auto_knows_current X)
    -> forall X2:term, auto___def_66 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_65_pknows_current. exact (rem_4296).
Defined.

Remark rem_4298 : (forall X:term, auto___def_65 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto___def_66 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_65_pknows_current. intros X1 X2.
  cut (auto___def_66 X2 -> auto_knows_current X2). tauto. exact (rem_4297 epsilon_m__def_65_pknows_current X2).
Defined.

Remark rem_4299 : (forall X:term, auto___def_65 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto___def_66 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_65_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_4274 epsilon_m__def_65_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_4298 epsilon_m__def_65_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_4300 : (forall X:term, auto___def_65 X -> auto_knows_current X)
    -> forall X1 X2:term, auto_knows_current X1 -> auto___def_66 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_65_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_4299 epsilon_m__def_65_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_65_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_65_pknows_current A1 A2. tauto.
Defined.

Remark rem_4301 : forall X1 X2:term, auto___def_65 (cons X1 X2) -> or_1
    (auto_knows_current X1 /\ auto___def_66 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4302 : (forall X:term, auto___def_65 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_65 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_65_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_4301 X1 X2 H);  intros.
  apply (rem_4300 epsilon_m__def_65_pknows_current X1 X2);  tauto.
Defined.

Remark rem_4303 : auto___def_65 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4304 : forall X1 X2:term, auto___def_65 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4305 : auto___def_65 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4306 : auto___def_65 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4307 : forall X1:term, auto___def_65 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4308 : auto___def_65 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4309 : auto___def_65 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4310 : auto___def_65 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4311 : auto___def_65 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4312 : auto___def_65 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4313 : forall X1 X2:term, auto___def_65 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4314 : forall X1 X2:term, auto___def_65 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4315 : forall X1 X2:term, auto___def_65 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4316 : forall X1 X2 X3:term, auto___def_65 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4317 : forall X1 X2:term, auto___def_65 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4318 : forall X1 X2 X3:term, auto___def_65 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4319 : forall X1 X2:term, auto___def_65 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4320 : forall X2:term, auto___def_65 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_65_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_4303  H).
   intro H. elim (rem_4306  H).
  intros X1 X2;  exact (rem_4302 epsilon_m__def_65_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_4317 X1 X2 H).
   intro H. elim (rem_4309  H).
  intros X1 X2. intro H. elim (rem_4313 X1 X2 H).
   intro H. elim (rem_4308  H).
  intros X1 X2. intro H. elim (rem_4315 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4304 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4319 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4314 X1 X2 H).
   intro H. elim (rem_4305  H).
   intro H. elim (rem_4310  H).
  intros X1. intro H. elim (rem_4307 X1 H).
   intro H. elim (rem_4311  H).
  intros X1 X2 X3. intro H. elim (rem_4316 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4318 X1 X2 X3 H).
   intro H. elim (rem_4312  H).
Qed.

Remark rem_4321 : (forall X:term, auto___def_63 X -> auto_knows_current X)
    -> forall X2:term, auto___def_65 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_63_pknows_current. exact (rem_4320).
Defined.

Remark rem_4322 : (forall X:term, auto___def_63 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_63_pknows_current. intros X1 X2.
  cut (auto___def_65 X2 -> auto_knows_current X2). tauto. exact (rem_4321 epsilon_m__def_63_pknows_current X2).
Defined.

Remark rem_4323 : (forall X:term, auto___def_63 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_63_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_4272 epsilon_m__def_63_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_4322 epsilon_m__def_63_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_4324 : (forall X:term, auto___def_63 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_64 X1 -> auto___def_65 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_63_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_4323 epsilon_m__def_63_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_63_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_63_pknows_current A1 A2. tauto.
Defined.

Remark rem_4325 : forall X1 X2:term, auto___def_63 (cons X1 X2) -> or_1
    (auto___def_64 X1 /\ auto___def_65 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4326 : (forall X:term, auto___def_63 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_63 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_63_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_4325 X1 X2 H);  intros.
  apply (rem_4324 epsilon_m__def_63_pknows_current X1 X2);  tauto.
Defined.

Remark rem_4327 : auto___def_63 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4328 : forall X1 X2:term, auto___def_63 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4329 : auto___def_63 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4330 : auto___def_63 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4331 : forall X1:term, auto___def_63 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4332 : auto___def_63 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4333 : auto___def_63 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4334 : auto___def_63 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4335 : auto___def_63 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4336 : auto___def_63 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4337 : forall X1 X2:term, auto___def_63 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4338 : forall X1 X2:term, auto___def_63 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4339 : forall X1 X2:term, auto___def_63 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4340 : forall X1 X2 X3:term, auto___def_63 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4341 : forall X1 X2:term, auto___def_63 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4342 : forall X1 X2 X3:term, auto___def_63 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4343 : forall X1 X2:term, auto___def_63 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4344 : forall X2:term, auto___def_63 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_63_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_4327  H).
   intro H. elim (rem_4330  H).
  intros X1 X2;  exact (rem_4326 epsilon_m__def_63_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_4341 X1 X2 H).
   intro H. elim (rem_4333  H).
  intros X1 X2. intro H. elim (rem_4337 X1 X2 H).
   intro H. elim (rem_4332  H).
  intros X1 X2. intro H. elim (rem_4339 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4328 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4343 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4338 X1 X2 H).
   intro H. elim (rem_4329  H).
   intro H. elim (rem_4334  H).
  intros X1. intro H. elim (rem_4331 X1 H).
   intro H. elim (rem_4335  H).
  intros X1 X2 X3. intro H. elim (rem_4340 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4342 X1 X2 X3 H).
   intro H. elim (rem_4336  H).
Qed.

Remark rem_4345 : (forall X:term, auto___def_62 X -> auto_knows_current X)
    -> forall X2:term, auto___def_63 X2 -> auto_knows_current X2. (* Cut history. *)
Proof.  intros epsilon_m__def_62_pknows_current. exact (rem_4344).
Defined.

Remark rem_4346 : (forall X:term, auto___def_62 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_13 X1 -> auto___def_63 X2 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros epsilon_m__def_62_pknows_current. intros X1 X2.
  cut (auto___def_63 X2 -> auto_knows_current X2). tauto. exact (rem_4345 epsilon_m__def_62_pknows_current X2).
Defined.

Remark rem_4347 : (forall X:term, auto___def_62 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_13 X1 -> auto___def_63 X2 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros epsilon_m__def_62_pknows_current. intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_4244 epsilon_m__def_62_pknows_current X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_4346 epsilon_m__def_62_pknows_current X1 X2);  assumption.
  tauto.
Defined.

Remark rem_4348 : (forall X:term, auto___def_62 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___type_13 X1 -> auto___def_63 X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros epsilon_m__def_62_pknows_current. intros X1 X2. intros A1 A2.
  case (rem_4347 epsilon_m__def_62_pknows_current X1 X2 A1 A2). clear  epsilon_m__def_62_pknows_current A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  epsilon_m__def_62_pknows_current A1 A2. tauto.
Defined.

Remark rem_4349 : forall X1 X2:term, auto___def_62 (cons X1 X2) -> or_1
    (auto___type_13 X1 /\ auto___def_63 X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4350 : (forall X:term, auto___def_62 X -> auto_knows_current X)
    -> forall X1 X2:term, auto___def_62 (cons X1 X2) -> auto_knows_current (cons X1 X2). (* Eliminate negative atom. *)
Proof.
  intros epsilon_m__def_62_pknows_current. intros X1 X2. intro H. intros.
  elim (rem_4349 X1 X2 H);  intros.
  apply (rem_4348 epsilon_m__def_62_pknows_current X1 X2);  tauto.
Defined.

Remark rem_4351 : auto___def_62 alice -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4352 : forall X1 X2:term, auto___def_62 (noncea_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4353 : auto___def_62 prv -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4354 : auto___def_62 bob -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4355 : forall X1:term, auto___def_62 (s X1) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4356 : auto___def_62 nil -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4357 : auto___def_62 i -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4358 : auto___def_62 pub -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4359 : auto___def_62 server -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4360 : auto___def_62 sym -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4361 : forall X1 X2:term, auto___def_62 (key X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4362 : forall X1 X2:term, auto___def_62 (nonceb_old X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4363 : forall X1 X2:term, auto___def_62 (noncea_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4364 : forall X1 X2 X3:term, auto___def_62 (session_current X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4365 : forall X1 X2:term, auto___def_62 (crypt X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4366 : forall X1 X2 X3:term, auto___def_62 (session_old X1 X2 X3) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4367 : forall X1 X2:term, auto___def_62 (nonceb_current X1 X2) -> or_0.
Proof.
  intros. inversion H.
Qed.

Remark rem_4368 : forall X2:term, auto___def_62 X2 -> auto_knows_current X2. (* Induct. *)
Proof.
  fix epsilon_m__def_62_pknows_current 1.
  intro X. case X.
   intro H. elim (rem_4351  H).
   intro H. elim (rem_4354  H).
  intros X1 X2;  exact (rem_4350 epsilon_m__def_62_pknows_current X1 X2).
  intros X1 X2. intro H. elim (rem_4365 X1 X2 H).
   intro H. elim (rem_4357  H).
  intros X1 X2. intro H. elim (rem_4361 X1 X2 H).
   intro H. elim (rem_4356  H).
  intros X1 X2. intro H. elim (rem_4363 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4352 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4367 X1 X2 H).
  intros X1 X2. intro H. elim (rem_4362 X1 X2 H).
   intro H. elim (rem_4353  H).
   intro H. elim (rem_4358  H).
  intros X1. intro H. elim (rem_4355 X1 H).
   intro H. elim (rem_4359  H).
  intros X1 X2 X3. intro H. elim (rem_4364 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_4366 X1 X2 X3 H).
   intro H. elim (rem_4360  H).
Qed.

Remark rem_4369 : forall X1 X2:term, auto___def_62 X2 -> auto___type_12 X1 -> auto_knows_current X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_62 X2 -> auto_knows_current X2). tauto. exact (rem_4368 X2).
Qed.

Remark rem_4370 : forall X1 X2:term, auto___def_62 X2 -> auto___type_12 X1 -> (auto_knows_current X1 /\ auto_knows_current X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto_knows_current X1). 2:apply (rem_4214 X1 X2);  assumption.
  cut (auto_knows_current X2). 2:apply (rem_4369 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4371 : forall X1 X2:term, auto___def_62 X2 -> auto___type_12 X1 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4370 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4372 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___def_42 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_42 X1 -> auto___def_42 X1). tauto. exact (rem_623 X1).
Qed.

Remark rem_4373 : forall X2:term, auto___type_8 X2 -> auto___type_8 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_4374 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto___type_8 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_8 X2 -> auto___type_8 X2). tauto. exact (rem_4373 X2).
Qed.

Remark rem_4375 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> (auto___def_42 X1 /\ auto___type_8 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_42 X1). 2:apply (rem_4372 X1 X2);  assumption.
  cut (auto___type_8 X2). 2:apply (rem_4374 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4376 : forall X1 X2:term, auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_old (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4375 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_crypt_5;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4377 : forall X1 X2:term, auto___type_8 X2 -> auto___def_42 X1 -> auto_knows_old (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_42 X1 -> auto___type_8 X2 -> auto_knows_old (crypt X1 X2)). tauto. exact (rem_4376 X1 X2).
Qed.

Remark rem_4378 : auto_knows_old nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans_knows_old_nil_1;  tauto.
 tauto.
Qed.

Remark rem_4379 : forall X1 X2:term, auto___def_48 X2 -> auto_knows_old X1 -> auto_knows_old X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto_knows_old X1 -> auto_knows_old X1). tauto. exact (rem_567 X1).
Qed.

Remark rem_4380 : forall X1 X2:term, auto___def_3 X1 X2 -> or_1
    (auto___def_48 X1 /\ auto_knows_old X2)
.
Proof.
  intros. inversion H.
  intros. apply or_1_intro_1; tauto.
Qed.

Remark rem_4381 : forall X1 X2:term, auto___def_3 X2 X1 -> auto_knows_old X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_4380 X2 X1 H);  intros.
  apply (rem_4379 X1 X2);  tauto.
Qed.

Remark rem_4382 : forall X1 X2:term, auto___def_3 X2 X1 -> auto___def_4 X2 -> auto_knows_old X1. (* Eliminate negative atom by universal clause. *)
Proof.
  intros X1 X2. intros. apply (rem_4381 X1 X2);  assumption.
Qed.

Remark rem_4383 : forall X1 X2 X3:term, auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto___type_15 X1 -> auto_agent X1 -> auto_knows_current X3 -> auto___type_15 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X1 -> auto___type_15 X1). tauto. exact (rem_2039 X1).
Qed.

Remark rem_4384 : forall X1:term, auto___type_15 X1 -> auto_agent X1. (* Induct. *)
Proof.
  fix epsilon_m__type_15_pagent 1.
  intro X. case X.
  exact (rem_453 epsilon_m__type_15_pagent ).
  exact (rem_456 epsilon_m__type_15_pagent ).
  intros X1 X2. intro H. elim (rem_468 X1 X2 H).
  intros X1 X2. intro H. elim (rem_474 X1 X2 H).
  exact (rem_459 epsilon_m__type_15_pagent ).
  intros X1 X2. intro H. elim (rem_470 X1 X2 H).
   intro H. elim (rem_466  H).
  intros X1 X2. intro H. elim (rem_472 X1 X2 H).
  intros X1 X2. intro H. elim (rem_463 X1 X2 H).
  intros X1 X2. intro H. elim (rem_476 X1 X2 H).
  intros X1 X2. intro H. elim (rem_471 X1 X2 H).
   intro H. elim (rem_464  H).
   intro H. elim (rem_467  H).
  intros X1. intro H. elim (rem_465 X1 H).
  exact (rem_462 epsilon_m__type_15_pagent ).
  intros X1 X2 X3. intro H. elim (rem_473 X1 X2 X3 H).
  intros X1 X2 X3. intro H. elim (rem_475 X1 X2 X3 H).
   intro H. elim (rem_469  H).
Qed.

Remark rem_4385 : forall X1 X2 X3:term, auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto___type_15 X1 -> auto_agent X1 -> auto_knows_current X3 -> auto_agent X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___type_15 X1 -> auto_agent X1). tauto. exact (rem_4384 X1).
Qed.

Remark rem_4386 : forall X1 X2 X3:term, auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto___type_15 X1 -> auto_agent X1 -> auto_knows_current X3 -> auto___def_72 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X2 -> auto___def_72 X2). tauto. exact (rem_2980 X2).
Qed.

Remark rem_4387 : forall X1 X2 X3:term, auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto___type_15 X1 -> auto_agent X1 -> auto_knows_current X3 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2 X3.
  cut (auto___def_72 X2 -> auto___type_19 X2). tauto. exact (rem_2998 X2).
Qed.

Remark rem_4388 : forall X1 X2 X3:term, auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto___type_15 X1 -> auto_agent X1 -> auto_knows_current X3 -> (auto___type_15 X1 /\ auto_agent X1 /\ auto___def_72 X2 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4 A5.
  cut (auto___type_15 X1). 2:apply (rem_4383 X1 X2 X3);  assumption.
  cut (auto_agent X1). 2:apply (rem_4385 X1 X2 X3);  assumption.
  cut (auto___def_72 X2). 2:apply (rem_4386 X1 X2 X3);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_4387 X1 X2 X3);  assumption.
  tauto.
Qed.

Remark rem_4389 : forall X1 X2 X3:term, auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto___type_15 X1 -> auto_agent X1 -> auto_knows_current X3 -> auto_bob_key_current X1 X2. (* Deduce positive atom. *)
Proof.
  intros X1 X2 X3. intros A1 A2 A3 A4 A5.
  case (rem_4388 X1 X2 X3 A1 A2 A3 A4 A5). clear  A1 A2 A3 A4 A5. intros. apply trans_bob_key_current_1;  tauto.
 clear  A1 A2 A3 A4 A5. tauto.
Qed.

Remark rem_4390 : forall X1 X2 X3:term, auto_knows_current X3 -> auto___type_15 X1 -> auto_agent X1 -> auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto_bob_key_current X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_72 X2 -> auto___def_90 X3 X1 X2 -> auto___type_15 X1 -> auto_agent X1 -> auto_knows_current X3 -> auto_bob_key_current X1 X2). tauto. exact (rem_4389 X1 X2 X3).
Qed.

Remark rem_4391 : forall X1 X2 X3:term, auto___def_86 X3 X1 X2 -> auto___def_90 X3 X1 X2 -> auto_bob_key_current X1 X2. (* Eliminate negative atom. *)
Proof.
  intros X1 X2 X3. intro H. intros.
  elim (rem_482 X3 X1 X2 H);  intros.
  apply (rem_4390 X1 X2 X3);  tauto.
Qed.

Remark rem_4392 : forall X1 X2 X3:term, auto___def_90 X3 X1 X2 -> auto___def_86 X3 X1 X2 -> auto_bob_key_current X1 X2. (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2 X3.
  cut (auto___def_86 X3 X1 X2 -> auto___def_90 X3 X1 X2 -> auto_bob_key_current X1 X2). tauto. exact (rem_4391 X1 X2 X3).
Qed.

Remark rem_4393 : forall X1 X2:term, auto_knows_current (cons X1 X2) -> auto_knows_current X1. (* Eliminate negative atom. *)
Proof.
  intros X1 X2. intro H. intros.
  elim (rem_1520 X1 X2 H);  intros.
  apply (rem_3795 X1 X2);  tauto.
Qed.

Remark rem_4394 : forall X1 X2:term, auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_old (key X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4088 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_old_key_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4395 : forall X1 X2:term, auto___def_48 X2 -> auto___def_47 X1 -> auto_knows_old (key X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_47 X1 -> auto___def_48 X2 -> auto_knows_old (key X1 X2)). tauto. exact (rem_4394 X1 X2).
Qed.

Remark rem_4396 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___def_89 X1. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___def_89 X1 -> auto___def_89 X1). tauto. exact (rem_280 X1).
Qed.

Remark rem_4397 : forall X2:term, auto___type_19 X2 -> auto___type_19 X2. (* Tautology. *)
Proof. tauto. Qed.

Remark rem_4398 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto___type_19 X2. (* Subsumption by simpler clause. *)
Proof.
  intros X1 X2.
  cut (auto___type_19 X2 -> auto___type_19 X2). tauto. exact (rem_4397 X2).
Qed.

Remark rem_4399 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> (auto___def_89 X1 /\ auto___type_19 X2) \/ False. (* Distribute disjunctions over conjunctions. *)
Proof.
  intros X1 X2. intros A1 A2.
  cut (auto___def_89 X1). 2:apply (rem_4396 X1 X2);  assumption.
  cut (auto___type_19 X2). 2:apply (rem_4398 X1 X2);  assumption.
  tauto.
Qed.

Remark rem_4400 : forall X1 X2:term, auto___def_89 X1 -> auto___type_19 X2 -> auto_knows_current (crypt X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4399 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_crypt_4;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4401 : forall X1 X2:term, auto___type_19 X2 -> auto___def_89 X1 -> auto_knows_current (crypt X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto___def_89 X1 -> auto___type_19 X2 -> auto_knows_current (crypt X1 X2)). tauto. exact (rem_4400 X1 X2).
Qed.

Remark rem_4402 : forall X1 X2:term, auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X1 X2). (* Deduce positive atom. *)
Proof.
  intros X1 X2. intros A1 A2.
  case (rem_4145 X1 X2 A1 A2). clear  A1 A2. intros. apply trans_knows_current_cons_1;  tauto.
 clear  A1 A2. tauto.
Qed.

Remark rem_4403 : forall X1 X2:term, auto_knows_current X2 -> auto_knows_current X1 -> auto_knows_current (cons X1 X2). (* Prove equivalent, normalized clause. *)
Proof.
   intros X1 X2.
  cut (auto_knows_current X1 -> auto_knows_current X2 -> auto_knows_current (cons X1 X2)). tauto. exact (rem_4402 X1 X2).
Qed.

Remark rem_4404 : auto_knows_current nil. (* Deduce positive atom. *)
Proof.
   case rem_524. intros. apply trans_knows_current_nil_1;  tauto.
 tauto.
Qed.

(* [trnp] Proofs of translated source clauses. *)


Lemma lem_intruder_knows_session_key_as_seen_by_B : forall _big_kab:term, auto_bob_key_current bob _big_kab -> auto_knows_current _big_kab -> auto___query__intruder_knows_session_key_as_seen_by_B.
Proof.
   intros _big_kab. intros H1 H2.
  exact (rem_4125 _big_kab
          H1
          H2).
Qed.

Lemma lem_intruder_knows_session_key_as_seen_by_alice : forall _big_kab:term, auto_alice_key_current alice _big_kab -> auto_knows_current _big_kab -> auto___query__intruder_knows_session_key_as_seen_by_alice.
Proof.
   intros _big_kab. intros H1 H2.
  exact (rem_4171 _big_kab
          H1
          H2).
Qed.

Lemma lem_intruder_knows_session_key_generated_by_server : forall _big_na:term, auto_knows_current (key sym (session_current alice bob _big_na)) -> auto___query__intruder_knows_session_key_generated_by_server.
Proof.
   intros _big_na. intros H1.
  exact (rem_4083 _big_na
          H1).
Qed.

Lemma lem_intruder_knows_own_private_key_current : auto_knows_current (key prv i).
Proof.
  
  exact (rem_4090 prv i
          rem_1979
          rem_2627).
Qed.

Lemma lem_intruder_knows_every_public_key_current : forall X:term, auto_knows_current (key pub X).
Proof.
   intros X.
  exact (rem_4040 pub X
          (rem_2686 X)
          rem_2024).
Qed.

Lemma lem_intruder_knows_all_agents_current : forall X:term, auto_agent X -> auto_knows_current X.
Proof.
   intros X. intros H1.
  exact (rem_3849 X
          H1).
Qed.

Lemma lem_define_bob_key_current : forall _big_a _big_b _big_kab:term, auto_knows_current (crypt (s (nonceb_current _big_a _big_b)) _big_kab) -> auto_knows_current (crypt (cons _big_kab (cons (nonceb_current _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> auto_bob_key_current _big_b _big_kab.
Proof.
   intros _big_a _big_b _big_kab. intros H1 H2.
  exact (rem_4392 _big_b _big_kab _big_a
          (rem_2620 _big_a _big_b _big_kab
            H1)
          (rem_3258 _big_a _big_b _big_kab
            H2)).
Qed.

Lemma lem_message7_current : forall _big_a _big_kab _big_nb:term, auto_alice_key_current _big_a _big_kab -> auto_knows_current (crypt _big_nb _big_kab) -> auto_knows_current (crypt (s _big_nb) _big_kab).
Proof.
   intros _big_a _big_kab _big_nb. intros H1 H2.
  exact (rem_4401 (s _big_nb) _big_kab
          (rem_551 _big_kab _big_nb
            (rem_3038 _big_nb _big_kab _big_a
              H2
              H1))
          (rem_320 _big_nb _big_kab
            (rem_3038 _big_nb _big_kab _big_a
              H2
              H1))).
Qed.

Lemma lem_define_alice_key_current : forall _big_a _big_b _big_kab _big_m _big_nb:term, auto_knows_current (crypt _big_nb _big_kab) -> auto_knows_current (crypt (cons (noncea_current _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> auto_alice_key_current _big_a _big_kab.
Proof.
   intros _big_a _big_b _big_kab _big_m _big_nb. intros H1 H2.
  exact (rem_4180 _big_a _big_kab _big_m _big_b _big_nb
          H1
          (rem_3422 _big_a _big_m _big_b _big_kab
            H2)).
Qed.

Lemma lem_message6_current : forall _big_a _big_b _big_kab:term, auto_knows_current (crypt (cons _big_kab (cons (nonceb_current _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> auto_knows_current (crypt (nonceb_current _big_a _big_b) _big_kab).
Proof.
   intros _big_a _big_b _big_kab. intros H1.
  exact (rem_4162 (nonceb_current _big_a _big_b) _big_kab
          (rem_1154 _big_kab _big_a _big_b
            (rem_3258 _big_a _big_b _big_kab
              H1))
          (rem_483 _big_a _big_b _big_kab
            (rem_3258 _big_a _big_b _big_kab
              H1))).
Qed.

Lemma lem_message5_current : forall _big_a _big_b _big_kab _big_m:term, auto_knows_current (crypt (cons (noncea_current _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> auto_knows_current _big_m.
Proof.
   intros _big_a _big_b _big_kab _big_m. intros H1.
  exact (rem_3786 _big_m _big_a _big_b _big_kab
          (rem_3422 _big_a _big_m _big_b _big_kab
            H1)).
Qed.

Lemma lem_message4_current : forall _big_a _big_b _big_na _big_nb:term, auto_knows_current (cons _big_a (cons _big_b (cons _big_na (cons (crypt (cons _big_a (cons _big_nb nil)) (key sym (cons _big_b (cons server nil)))) nil)))) -> auto_knows_current (crypt (cons _big_na (cons _big_b (cons (key sym (session_current _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))) (key sym (cons _big_a (cons server nil)))).
Proof.
   intros _big_a _big_b _big_na _big_nb. intros H1.
  exact (rem_4119 (cons _big_na (cons _big_b (cons (key sym (session_current _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))) (key sym (cons _big_a (cons server nil)))
          (rem_1636 sym (cons _big_a (cons server nil))
            (rem_2650 _big_a (cons server nil)
              (rem_2978 server nil
                rem_1143
                rem_525)
              (rem_3738 _big_a _big_b _big_nb _big_na
                (rem_1863 _big_a _big_b _big_nb _big_na
                  H1)))
            rem_2944)
          (rem_19 _big_na (cons _big_b (cons (key sym (session_current _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))
            (rem_2044 _big_b (cons (key sym (session_current _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil))
              (rem_1985 (key sym (session_current _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)
                (rem_1978 (crypt (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil
                  rem_1912
                  (rem_1419 (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))
                    (rem_1624 sym (cons _big_b (cons server nil))
                      (rem_2690 _big_b (cons server nil)
                        (rem_2978 server nil
                          rem_1143
                          rem_525)
                        (rem_2009 _big_b _big_a _big_nb _big_na
                          (rem_1863 _big_a _big_b _big_nb _big_na
                            H1)))
                      rem_2944)
                    (rem_566 (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))
                      (rem_1436 _big_nb (cons _big_a nil)
                        (rem_2959 _big_a nil
                          rem_1912
                          (rem_3738 _big_a _big_b _big_nb _big_na
                            (rem_1863 _big_a _big_b _big_nb _big_na
                              H1)))
                        (rem_1493 _big_nb _big_a _big_b _big_na
                          (rem_1863 _big_a _big_b _big_nb _big_na
                            H1)))
                      (rem_2976 sym (session_current _big_a _big_b _big_na)
                        (rem_1031 _big_a _big_b _big_na _big_nb
                          (rem_1863 _big_a _big_b _big_nb _big_na
                            H1))
                        rem_2944))))
                (rem_2976 sym (session_current _big_a _big_b _big_na)
                  (rem_1031 _big_a _big_b _big_na _big_nb
                    (rem_1863 _big_a _big_b _big_nb _big_na
                      H1))
                  rem_2944))
              (rem_2009 _big_b _big_a _big_nb _big_na
                (rem_1863 _big_a _big_b _big_nb _big_na
                  H1)))
            (rem_1617 _big_na _big_a _big_b _big_nb
              (rem_1863 _big_a _big_b _big_nb _big_na
                H1)))).
Qed.

Lemma lem_message3_current : forall _big_a _big_b _big_m:term, auto_agent _big_b -> auto_agent _big_a -> auto_knows_current _big_m -> auto_knows_current (cons _big_a (cons _big_b (cons (noncea_current _big_a _big_b) (cons _big_m nil)))).
Proof.
   intros _big_a _big_b _big_m. intros H1 H2 H3.
  exact (rem_4371 _big_a (cons _big_b (cons (noncea_current _big_a _big_b) (cons _big_m nil)))
          (rem_2841 _big_b (cons (noncea_current _big_a _big_b) (cons _big_m nil))
            (rem_3429 (noncea_current _big_a _big_b) (cons _big_m nil)
              (rem_2699 _big_m nil
                rem_2678
                H3)
              (rem_2046 _big_a _big_b
                H1
                H2))
            (rem_2637 _big_b
              H1))
          (rem_2034 _big_a
            H2)).
Qed.

Lemma lem_message2_current : forall _big_a _big_b:term, auto_agent _big_b -> auto_knows_current _big_a -> auto_knows_current (crypt (cons _big_a (cons (nonceb_current _big_a _big_b) nil)) (key sym (cons _big_b (cons server nil)))).
Proof.
   intros _big_a _big_b. intros H1 H2.
  exact (rem_4185 (cons _big_a (cons (nonceb_current _big_a _big_b) nil)) (key sym (cons _big_b (cons server nil)))
          (rem_485 sym (cons _big_b (cons server nil))
            (rem_663 _big_b (cons server nil)
              (rem_523 server nil
                rem_1143
                rem_525)
              H1)
            rem_2823)
          (rem_1630 _big_a (cons (nonceb_current _big_a _big_b) nil)
            (rem_2685 (nonceb_current _big_a _big_b) nil
              rem_2965
              (rem_3742 _big_a _big_b
                H1
                H2))
            (rem_2943 _big_a
              H2))).
Qed.

Lemma lem_message1_current : forall _big_a:term, auto_agent _big_a -> auto_knows_current _big_a.
Proof.
   intros _big_a. intros H1.
  exact (rem_3849 _big_a
          H1).
Qed.

Lemma lem_intruder_can_compute_predecessors_current : forall _big_m:term, auto_knows_current (s _big_m) -> auto_knows_current _big_m.
Proof.
   intros _big_m. intros H1.
  exact (rem_3748 _big_m
          H1).
Qed.

Lemma lem_intruder_can_compute_successors_current : forall _big_m:term, auto_knows_current _big_m -> auto_knows_current (s _big_m).
Proof.
   intros _big_m. intros H1.
  exact (rem_3750 _big_m
          H1).
Qed.

Lemma lem_intruder_can_decrypt_if_has_symmetric_key_current : forall _big_m X:term, auto_knows_current (crypt _big_m (key sym X)) -> auto_knows_current (key sym X) -> auto_knows_current _big_m.
Proof.
   intros _big_m X. intros H1 H2.
  exact (rem_3848 _big_m X
          (rem_1960 _big_m X
            H1)
          (rem_1877 X
            H2)).
Qed.

Lemma lem_intruder_can_decrypt_if_has_public_key_current : forall _big_k _big_m:term, auto_knows_current (crypt _big_m (key prv _big_k)) -> auto_knows_current (key pub _big_k) -> auto_knows_current _big_m.
Proof.
   intros _big_k _big_m. intros H1 H2.
  exact (rem_4109 _big_m _big_k
          (rem_1911 _big_k _big_m
            H1)
          (rem_559 _big_k
            H2)).
Qed.

Lemma lem_intruder_can_decrypt_if_has_private_key_current : forall _big_k _big_m:term, auto_knows_current (crypt _big_m (key pub _big_k)) -> auto_knows_current (key prv _big_k) -> auto_knows_current _big_m.
Proof.
   intros _big_k _big_m. intros H1 H2.
  exact (rem_4166 _big_m _big_k
          (rem_2590 _big_k _big_m
            H1)
          (rem_1231 _big_k
            H2)).
Qed.

Lemma lem_intruder_can_encrypt_current : forall _big_k _big_m:term, auto_knows_current _big_m -> auto_knows_current _big_k -> auto_knows_current (crypt _big_m _big_k).
Proof.
   intros _big_k _big_m. intros H1 H2.
  exact (rem_4147 _big_m _big_k
          H2
          H1).
Qed.

Lemma lem_intruder_can_build_pairs_current : forall _big_m1 _big_m2:term, auto_knows_current _big_m1 -> auto_knows_current _big_m2 -> auto_knows_current (cons _big_m1 _big_m2).
Proof.
   intros _big_m1 _big_m2. intros H1 H2.
  exact (rem_4403 _big_m1 _big_m2
          H2
          H1).
Qed.

Lemma lem_intruder_can_take_second_components_current : forall _big_m1 _big_m2:term, auto_knows_current (cons _big_m1 _big_m2) -> auto_knows_current _big_m2.
Proof.
   intros _big_m1 _big_m2. intros H1.
  exact (rem_3797 _big_m2 _big_m1
          H1).
Qed.

Lemma lem_intruder_can_take_first_components_current : forall _big_m1 _big_m2:term, auto_knows_current (cons _big_m1 _big_m2) -> auto_knows_current _big_m1.
Proof.
   intros _big_m1 _big_m2. intros H1.
  exact (rem_4393 _big_m1 _big_m2
          H1).
Qed.

Lemma lem_intruder_knows_nil_current : auto_knows_current nil.
Proof.
  
  exact rem_4404.
Qed.

Lemma lem_intruder_knows_all_previous_nonceb : forall _big_a _big_b:term, auto_knows_current (nonceb_old _big_a _big_b).
Proof.
   intros _big_a _big_b.
  exact (rem_4167 _big_a _big_b).
Qed.

Lemma lem_intruder_knows_all_previous_noncea : forall _big_a _big_b:term, auto_knows_current (noncea_old _big_a _big_b).
Proof.
   intros _big_a _big_b.
  exact (rem_4156 _big_a _big_b).
Qed.

Lemma lem_intruder_knows_all_previous_session_keys : forall _big_a _big_b _big_na:term, auto_knows_current (key sym (session_old _big_a _big_b _big_na)).
Proof.
   intros _big_a _big_b _big_na.
  exact (rem_3756 sym (session_old _big_a _big_b _big_na)
          (rem_2014 _big_a _big_b _big_na)
          rem_2835).
Qed.

Lemma lem_intruder_remembers : forall _big_m:term, auto_knows_old _big_m -> auto_knows_current _big_m.
Proof.
   intros _big_m. intros H1.
  exact (rem_926 _big_m
          H1).
Qed.

Lemma lem_intruder_knows_own_private_key_old : auto_knows_old (key prv i).
Proof.
  
  exact (rem_4395 prv i
          rem_1979
          rem_2627).
Qed.

Lemma lem_intruder_knows_every_public_key_old : forall X:term, auto_knows_old (key pub X).
Proof.
   intros X.
  exact (rem_3792 pub X
          (rem_2686 X)
          rem_2024).
Qed.

Lemma lem_intruder_knows_all_agents_old : forall X:term, auto_agent X -> auto_knows_old X.
Proof.
   intros X. intros H1.
  exact (rem_4120 X
          H1).
Qed.

Lemma lem_define_bob_key_old : forall _big_a _big_b _big_kab:term, auto_knows_old (crypt (s (nonceb_old _big_a _big_b)) _big_kab) -> auto_knows_old (crypt (cons _big_kab (cons (nonceb_old _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> auto_bob_key_old _big_b _big_kab.
Proof.
   intros _big_a _big_b _big_kab. intros H1 H2.
  exact (rem_4155 _big_b _big_kab _big_a
          (rem_2676 _big_a _big_b _big_kab
            H1)
          (rem_3561 _big_a _big_b _big_kab
            H2)).
Qed.

Lemma lem_message7_old : forall _big_a _big_kab _big_nb:term, auto_alice_key_old _big_a _big_kab -> auto_knows_old (crypt _big_nb _big_kab) -> auto_knows_old (crypt (s _big_nb) _big_kab).
Proof.
   intros _big_a _big_kab _big_nb. intros H1 H2.
  exact (rem_4131 (s _big_nb) _big_kab
          (rem_684 _big_kab _big_nb
            (rem_651 _big_nb _big_kab _big_a
              H2
              H1))
          (rem_1142 _big_nb _big_kab
            (rem_651 _big_nb _big_kab _big_a
              H2
              H1))).
Qed.

Lemma lem_define_alice_key_old : forall _big_a _big_b _big_kab _big_m _big_nb:term, auto_knows_old (crypt _big_nb _big_kab) -> auto_knows_old (crypt (cons (noncea_old _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> auto_alice_key_old _big_a _big_kab.
Proof.
   intros _big_a _big_b _big_kab _big_m _big_nb. intros H1 H2.
  exact (rem_4142 _big_a _big_kab _big_m _big_b _big_nb
          H1
          (rem_1406 _big_a _big_m _big_b _big_kab
            H2)).
Qed.

Lemma lem_message6_old : forall _big_a _big_b _big_kab:term, auto_knows_old (crypt (cons _big_kab (cons (nonceb_old _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> auto_knows_old (crypt (nonceb_old _big_a _big_b) _big_kab).
Proof.
   intros _big_a _big_b _big_kab. intros H1.
  exact (rem_4377 (nonceb_old _big_a _big_b) _big_kab
          (rem_1868 _big_kab _big_a _big_b
            (rem_3561 _big_a _big_b _big_kab
              H1))
          (rem_2023 _big_a _big_b _big_kab
            (rem_3561 _big_a _big_b _big_kab
              H1))).
Qed.

Lemma lem_message5_old : forall _big_a _big_b _big_kab _big_m:term, auto_knows_old (crypt (cons (noncea_old _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> auto_knows_old _big_m.
Proof.
   intros _big_a _big_b _big_kab _big_m. intros H1.
  exact (rem_4105 _big_m _big_a _big_b _big_kab
          (rem_1406 _big_a _big_m _big_b _big_kab
            H1)).
Qed.

Lemma lem_message4_old : forall _big_a _big_b _big_na _big_nb:term, auto_knows_old (cons _big_a (cons _big_b (cons _big_na (cons (crypt (cons _big_a (cons _big_nb nil)) (key sym (cons _big_b (cons server nil)))) nil)))) -> auto_knows_old (crypt (cons _big_na (cons _big_b (cons (key sym (session_old _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))) (key sym (cons _big_a (cons server nil)))).
Proof.
   intros _big_a _big_b _big_na _big_nb. intros H1.
  exact (rem_4114 (cons _big_na (cons _big_b (cons (key sym (session_old _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))) (key sym (cons _big_a (cons server nil)))
          (rem_2949 sym (cons _big_a (cons server nil))
            (rem_13 _big_a (cons server nil)
              (rem_2639 server nil
                rem_1143
                rem_525)
              (rem_445 _big_a _big_b _big_nb _big_na
                (rem_2822 _big_a _big_b _big_nb _big_na
                  H1)))
            rem_1420)
          (rem_2955 _big_na (cons _big_b (cons (key sym (session_old _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))
            (rem_657 _big_b (cons (key sym (session_old _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil))
              (rem_1197 (key sym (session_old _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)
                (rem_558 (crypt (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil
                  rem_1971
                  (rem_2964 (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))
                    (rem_1994 sym (cons _big_b (cons server nil))
                      (rem_1989 _big_b (cons server nil)
                        (rem_2639 server nil
                          rem_1143
                          rem_525)
                        (rem_516 _big_b _big_a _big_nb _big_na
                          (rem_2822 _big_a _big_b _big_nb _big_na
                            H1)))
                      rem_1420)
                    (rem_2971 (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))
                      (rem_2626 _big_nb (cons _big_a nil)
                        (rem_2038 _big_a nil
                          rem_1971
                          (rem_445 _big_a _big_b _big_nb _big_na
                            (rem_2822 _big_a _big_b _big_nb _big_na
                              H1)))
                        (rem_2834 _big_nb _big_a _big_b _big_na
                          (rem_2822 _big_a _big_b _big_nb _big_na
                            H1)))
                      (rem_670 sym (session_old _big_a _big_b _big_na)
                        (rem_704 _big_a _big_b _big_na _big_nb
                          (rem_2822 _big_a _big_b _big_nb _big_na
                            H1))
                        rem_1420))))
                (rem_670 sym (session_old _big_a _big_b _big_na)
                  (rem_704 _big_a _big_b _big_na _big_nb
                    (rem_2822 _big_a _big_b _big_nb _big_na
                      H1))
                  rem_1420))
              (rem_516 _big_b _big_a _big_nb _big_na
                (rem_2822 _big_a _big_b _big_nb _big_na
                  H1)))
            (rem_3335 _big_na _big_a _big_b _big_nb
              (rem_2822 _big_a _big_b _big_nb _big_na
                H1)))).
Qed.

Lemma lem_message3_old : forall _big_a _big_b _big_m:term, auto_agent _big_b -> auto_agent _big_a -> auto_knows_old _big_m -> auto_knows_old (cons _big_a (cons _big_b (cons (noncea_old _big_a _big_b) (cons _big_m nil)))).
Proof.
   intros _big_a _big_b _big_m. intros H1 H2 H3.
  exact (rem_4037 _big_a (cons _big_b (cons (noncea_old _big_a _big_b) (cons _big_m nil)))
          (rem_1412 _big_b (cons (noncea_old _big_a _big_b) (cons _big_m nil))
            (rem_7 (noncea_old _big_a _big_b) (cons _big_m nil)
              (rem_2656 _big_m nil
                rem_2677
                H3)
              (rem_1202 _big_a _big_b
                H1
                H2))
            (rem_1970 _big_b
              H1))
          (rem_1430 _big_a
            H2)).
Qed.

Lemma lem_message2_old : forall _big_a _big_b:term, auto_agent _big_b -> auto_knows_old _big_a -> auto_knows_old (crypt (cons _big_a (cons (nonceb_old _big_a _big_b) nil)) (key sym (cons _big_b (cons server nil)))).
Proof.
   intros _big_a _big_b. intros H1 H2.
  exact (rem_4152 (cons _big_a (cons (nonceb_old _big_a _big_b) nil)) (key sym (cons _big_b (cons server nil)))
          (rem_26 sym (cons _big_b (cons server nil))
            (rem_663 _big_b (cons server nil)
              (rem_523 server nil
                rem_1143
                rem_525)
              H1)
            rem_2823)
          (rem_2644 _big_a (cons (nonceb_old _big_a _big_b) nil)
            (rem_1643 (nonceb_old _big_a _big_b) nil
              rem_2651
              (rem_2694 _big_a _big_b
                H1
                H2))
            (rem_1313 _big_a
              H2))).
Qed.

Lemma lem_message1_old : forall _big_a:term, auto_agent _big_a -> auto_knows_old _big_a.
Proof.
   intros _big_a. intros H1.
  exact (rem_4120 _big_a
          H1).
Qed.

Lemma lem_intruder_can_compute_predecessors_old : forall _big_m:term, auto_knows_old (s _big_m) -> auto_knows_old _big_m.
Proof.
   intros _big_m. intros H1.
  exact (rem_4143 _big_m
          H1).
Qed.

Lemma lem_intruder_can_compute_successors_old : forall _big_m:term, auto_knows_old _big_m -> auto_knows_old (s _big_m).
Proof.
   intros _big_m. intros H1.
  exact (rem_3794 _big_m
          H1).
Qed.

Lemma lem_intruder_can_decrypt_if_has_symmetric_key_old : forall _big_m X:term, auto_knows_old (crypt _big_m (key sym X)) -> auto_knows_old (key sym X) -> auto_knows_old _big_m.
Proof.
   intros _big_m X. intros H1 H2.
  exact (rem_4077 _big_m X
          (rem_1190 _big_m X
            H1)
          (rem_2013 X
            H2)).
Qed.

Lemma lem_intruder_can_decrypt_if_has_public_key_old : forall _big_k _big_m:term, auto_knows_old (crypt _big_m (key prv _big_k)) -> auto_knows_old (key pub _big_k) -> auto_knows_old _big_m.
Proof.
   intros _big_k _big_m. intros H1 H2.
  exact (rem_4382 _big_m _big_k
          (rem_351 _big_k _big_m
            H1)
          (rem_1878 _big_k
            H2)).
Qed.

Lemma lem_intruder_can_decrypt_if_has_private_key_old : forall _big_k _big_m:term, auto_knows_old (crypt _big_m (key pub _big_k)) -> auto_knows_old (key prv _big_k) -> auto_knows_old _big_m.
Proof.
   intros _big_k _big_m. intros H1 H2.
  exact (rem_4044 _big_m _big_k
          (rem_2674 _big_k _big_m
            H1)
          (rem_1239 _big_k
            H2)).
Qed.

Lemma lem_intruder_can_encrypt_old : forall _big_k _big_m:term, auto_knows_old _big_m -> auto_knows_old _big_k -> auto_knows_old (crypt _big_m _big_k).
Proof.
   intros _big_k _big_m. intros H1 H2.
  exact (rem_3747 _big_m _big_k
          H2
          H1).
Qed.

Lemma lem_intruder_can_build_pairs_old : forall _big_m1 _big_m2:term, auto_knows_old _big_m1 -> auto_knows_old _big_m2 -> auto_knows_old (cons _big_m1 _big_m2).
Proof.
   intros _big_m1 _big_m2. intros H1 H2.
  exact (rem_4092 _big_m1 _big_m2
          H2
          H1).
Qed.

Lemma lem_intruder_can_take_second_components_old : forall _big_m1 _big_m2:term, auto_knows_old (cons _big_m1 _big_m2) -> auto_knows_old _big_m2.
Proof.
   intros _big_m1 _big_m2. intros H1.
  exact (rem_3851 _big_m2 _big_m1
          H1).
Qed.

Lemma lem_intruder_can_take_first_components_old : forall _big_m1 _big_m2:term, auto_knows_old (cons _big_m1 _big_m2) -> auto_knows_old _big_m1.
Proof.
   intros _big_m1 _big_m2. intros H1.
  exact (rem_4133 _big_m1 _big_m2
          H1).
Qed.

Lemma lem_intruder_knows_nil_old : auto_knows_old nil.
Proof.
  
  exact rem_4378.
Qed.

Lemma lem_intruder_agent : auto_agent i.
Proof.
  
  exact rem_4132.
Qed.

Lemma lem_server_agent : auto_agent server.
Proof.
  
  exact rem_4045.
Qed.

Lemma lem_bob_agent : auto_agent bob.
Proof.
  
  exact rem_4093.
Qed.

Lemma lem_alice_agent : auto_agent alice.
Proof.
  
  exact rem_4038.
Qed.


(* [srcc] Source clauses. *)

Inductive __query__intruder_knows_session_key_as_seen_by_B : Prop :=
    intruder_knows_session_key_as_seen_by_B : forall _big_kab:term, bob_key_current bob _big_kab -> knows_current _big_kab -> __query__intruder_knows_session_key_as_seen_by_B

with __query__intruder_knows_session_key_as_seen_by_alice : Prop :=
    intruder_knows_session_key_as_seen_by_alice : forall _big_kab:term, alice_key_current alice _big_kab -> knows_current _big_kab -> __query__intruder_knows_session_key_as_seen_by_alice

with __query__intruder_knows_session_key_generated_by_server : Prop :=
    intruder_knows_session_key_generated_by_server : forall _big_na:term, knows_current (key sym (session_current alice bob _big_na)) -> __query__intruder_knows_session_key_generated_by_server

with agent : term -> Prop :=
    alice_agent : agent alice
  | bob_agent : agent bob
  | intruder_agent : agent i
  | server_agent : agent server

with alice_key_current : term -> term -> Prop :=
    define_alice_key_current : forall _big_a _big_b _big_kab _big_m _big_nb:term, knows_current (crypt _big_nb _big_kab) -> knows_current (crypt (cons (noncea_current _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> alice_key_current _big_a _big_kab

with alice_key_old : term -> term -> Prop :=
    define_alice_key_old : forall _big_a _big_b _big_kab _big_m _big_nb:term, knows_old (crypt _big_nb _big_kab) -> knows_old (crypt (cons (noncea_old _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> alice_key_old _big_a _big_kab

with bob_key_current : term -> term -> Prop :=
    define_bob_key_current : forall _big_a _big_b _big_kab:term, knows_current (crypt (s (nonceb_current _big_a _big_b)) _big_kab) -> knows_current (crypt (cons _big_kab (cons (nonceb_current _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> bob_key_current _big_b _big_kab

with bob_key_old : term -> term -> Prop :=
    define_bob_key_old : forall _big_a _big_b _big_kab:term, knows_old (crypt (s (nonceb_old _big_a _big_b)) _big_kab) -> knows_old (crypt (cons _big_kab (cons (nonceb_old _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> bob_key_old _big_b _big_kab

with knows_current : term -> Prop :=
    intruder_can_build_pairs_current : forall _big_m1 _big_m2:term, knows_current _big_m1 -> knows_current _big_m2 -> knows_current (cons _big_m1 _big_m2)
  | intruder_can_compute_predecessors_current : forall _big_m:term, knows_current (s _big_m) -> knows_current _big_m
  | intruder_can_compute_successors_current : forall _big_m:term, knows_current _big_m -> knows_current (s _big_m)
  | intruder_can_decrypt_if_has_private_key_current : forall _big_k _big_m:term, knows_current (crypt _big_m (key pub _big_k)) -> knows_current (key prv _big_k) -> knows_current _big_m
  | intruder_can_decrypt_if_has_public_key_current : forall _big_k _big_m:term, knows_current (crypt _big_m (key prv _big_k)) -> knows_current (key pub _big_k) -> knows_current _big_m
  | intruder_can_decrypt_if_has_symmetric_key_current : forall _big_m X:term, knows_current (crypt _big_m (key sym X)) -> knows_current (key sym X) -> knows_current _big_m
  | intruder_can_encrypt_current : forall _big_k _big_m:term, knows_current _big_m -> knows_current _big_k -> knows_current (crypt _big_m _big_k)
  | intruder_can_take_first_components_current : forall _big_m1 _big_m2:term, knows_current (cons _big_m1 _big_m2) -> knows_current _big_m1
  | intruder_can_take_second_components_current : forall _big_m1 _big_m2:term, knows_current (cons _big_m1 _big_m2) -> knows_current _big_m2
  | intruder_knows_all_agents_current : forall X:term, agent X -> knows_current X
  | intruder_knows_all_previous_noncea : forall _big_a _big_b:term, knows_current (noncea_old _big_a _big_b)
  | intruder_knows_all_previous_nonceb : forall _big_a _big_b:term, knows_current (nonceb_old _big_a _big_b)
  | intruder_knows_all_previous_session_keys : forall _big_a _big_b _big_na:term, knows_current (key sym (session_old _big_a _big_b _big_na))
  | intruder_knows_every_public_key_current : forall X:term, knows_current (key pub X)
  | intruder_knows_nil_current : knows_current nil
  | intruder_knows_own_private_key_current : knows_current (key prv i)
  | intruder_remembers : forall _big_m:term, knows_old _big_m -> knows_current _big_m
  | message1_current : forall _big_a:term, agent _big_a -> knows_current _big_a
  | message2_current : forall _big_a _big_b:term, agent _big_b -> knows_current _big_a -> knows_current (crypt (cons _big_a (cons (nonceb_current _big_a _big_b) nil)) (key sym (cons _big_b (cons server nil))))
  | message3_current : forall _big_a _big_b _big_m:term, agent _big_b -> agent _big_a -> knows_current _big_m -> knows_current (cons _big_a (cons _big_b (cons (noncea_current _big_a _big_b) (cons _big_m nil))))
  | message4_current : forall _big_a _big_b _big_na _big_nb:term, knows_current (cons _big_a (cons _big_b (cons _big_na (cons (crypt (cons _big_a (cons _big_nb nil)) (key sym (cons _big_b (cons server nil)))) nil)))) -> knows_current (crypt (cons _big_na (cons _big_b (cons (key sym (session_current _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_current _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))) (key sym (cons _big_a (cons server nil))))
  | message5_current : forall _big_a _big_b _big_kab _big_m:term, knows_current (crypt (cons (noncea_current _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> knows_current _big_m
  | message6_current : forall _big_a _big_b _big_kab:term, knows_current (crypt (cons _big_kab (cons (nonceb_current _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> knows_current (crypt (nonceb_current _big_a _big_b) _big_kab)
  | message7_current : forall _big_a _big_kab _big_nb:term, alice_key_current _big_a _big_kab -> knows_current (crypt _big_nb _big_kab) -> knows_current (crypt (s _big_nb) _big_kab)

with knows_old : term -> Prop :=
    intruder_can_build_pairs_old : forall _big_m1 _big_m2:term, knows_old _big_m1 -> knows_old _big_m2 -> knows_old (cons _big_m1 _big_m2)
  | intruder_can_compute_predecessors_old : forall _big_m:term, knows_old (s _big_m) -> knows_old _big_m
  | intruder_can_compute_successors_old : forall _big_m:term, knows_old _big_m -> knows_old (s _big_m)
  | intruder_can_decrypt_if_has_private_key_old : forall _big_k _big_m:term, knows_old (crypt _big_m (key pub _big_k)) -> knows_old (key prv _big_k) -> knows_old _big_m
  | intruder_can_decrypt_if_has_public_key_old : forall _big_k _big_m:term, knows_old (crypt _big_m (key prv _big_k)) -> knows_old (key pub _big_k) -> knows_old _big_m
  | intruder_can_decrypt_if_has_symmetric_key_old : forall _big_m X:term, knows_old (crypt _big_m (key sym X)) -> knows_old (key sym X) -> knows_old _big_m
  | intruder_can_encrypt_old : forall _big_k _big_m:term, knows_old _big_m -> knows_old _big_k -> knows_old (crypt _big_m _big_k)
  | intruder_can_take_first_components_old : forall _big_m1 _big_m2:term, knows_old (cons _big_m1 _big_m2) -> knows_old _big_m1
  | intruder_can_take_second_components_old : forall _big_m1 _big_m2:term, knows_old (cons _big_m1 _big_m2) -> knows_old _big_m2
  | intruder_knows_all_agents_old : forall X:term, agent X -> knows_old X
  | intruder_knows_every_public_key_old : forall X:term, knows_old (key pub X)
  | intruder_knows_nil_old : knows_old nil
  | intruder_knows_own_private_key_old : knows_old (key prv i)
  | message1_old : forall _big_a:term, agent _big_a -> knows_old _big_a
  | message2_old : forall _big_a _big_b:term, agent _big_b -> knows_old _big_a -> knows_old (crypt (cons _big_a (cons (nonceb_old _big_a _big_b) nil)) (key sym (cons _big_b (cons server nil))))
  | message3_old : forall _big_a _big_b _big_m:term, agent _big_b -> agent _big_a -> knows_old _big_m -> knows_old (cons _big_a (cons _big_b (cons (noncea_old _big_a _big_b) (cons _big_m nil))))
  | message4_old : forall _big_a _big_b _big_na _big_nb:term, knows_old (cons _big_a (cons _big_b (cons _big_na (cons (crypt (cons _big_a (cons _big_nb nil)) (key sym (cons _big_b (cons server nil)))) nil)))) -> knows_old (crypt (cons _big_na (cons _big_b (cons (key sym (session_old _big_a _big_b _big_na)) (cons (crypt (cons (key sym (session_old _big_a _big_b _big_na)) (cons _big_nb (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) nil)))) (key sym (cons _big_a (cons server nil))))
  | message5_old : forall _big_a _big_b _big_kab _big_m:term, knows_old (crypt (cons (noncea_old _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) -> knows_old _big_m
  | message6_old : forall _big_a _big_b _big_kab:term, knows_old (crypt (cons _big_kab (cons (nonceb_old _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) -> knows_old (crypt (nonceb_old _big_a _big_b) _big_kab)
  | message7_old : forall _big_a _big_kab _big_nb:term, alice_key_old _big_a _big_kab -> knows_old (crypt _big_nb _big_kab) -> knows_old (crypt (s _big_nb) _big_kab)
.

(* [srct] Translation from source clauses. *)

Definition translate_auto_agent_from_agent (x1 : term) (pi : agent x1) : auto_agent x1 :=
  match pi as pi in agent x1 return auto_agent x1 with
    (alice_agent) => 
      (lem_alice_agent)
  | (bob_agent) => 
      (lem_bob_agent)
  | (intruder_agent) => 
      (lem_intruder_agent)
  | (server_agent) => 
      (lem_server_agent)
  end
.
Fixpoint translate_auto_alice_key_old_from_alice_key_old (x1 : term) (x2 : term) (pi : alice_key_old x1 x2) {struct pi} : auto_alice_key_old x1 x2 :=
  match pi as pi in alice_key_old x1 x2 return auto_alice_key_old x1 x2 with
    (define_alice_key_old _big_a _big_b _big_kab _big_m _big_nb H1 H2) => 
      (lem_define_alice_key_old _big_a _big_b _big_kab _big_m _big_nb
        (translate_auto_knows_old_from_knows_old (crypt _big_nb _big_kab) H1)
        (translate_auto_knows_old_from_knows_old (crypt (cons (noncea_old _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) H2))
  end

with translate_auto_knows_old_from_knows_old (x1 : term) (pi : knows_old x1) {struct pi} : auto_knows_old x1 :=
  match pi as pi in knows_old x1 return auto_knows_old x1 with
    (intruder_can_build_pairs_old _big_m1 _big_m2 H1 H2) => 
      (lem_intruder_can_build_pairs_old _big_m1 _big_m2
        (translate_auto_knows_old_from_knows_old _big_m1 H1)
        (translate_auto_knows_old_from_knows_old _big_m2 H2))
  | (intruder_can_compute_predecessors_old _big_m H1) => 
      (lem_intruder_can_compute_predecessors_old _big_m
        (translate_auto_knows_old_from_knows_old (s _big_m) H1))
  | (intruder_can_compute_successors_old _big_m H1) => 
      (lem_intruder_can_compute_successors_old _big_m
        (translate_auto_knows_old_from_knows_old _big_m H1))
  | (intruder_can_decrypt_if_has_private_key_old _big_k _big_m H1 H2) => 
      (lem_intruder_can_decrypt_if_has_private_key_old _big_k _big_m
        (translate_auto_knows_old_from_knows_old (crypt _big_m (key pub _big_k)) H1)
        (translate_auto_knows_old_from_knows_old (key prv _big_k) H2))
  | (intruder_can_decrypt_if_has_public_key_old _big_k _big_m H1 H2) => 
      (lem_intruder_can_decrypt_if_has_public_key_old _big_k _big_m
        (translate_auto_knows_old_from_knows_old (crypt _big_m (key prv _big_k)) H1)
        (translate_auto_knows_old_from_knows_old (key pub _big_k) H2))
  | (intruder_can_decrypt_if_has_symmetric_key_old _big_m X H1 H2) => 
      (lem_intruder_can_decrypt_if_has_symmetric_key_old _big_m X
        (translate_auto_knows_old_from_knows_old (crypt _big_m (key sym X)) H1)
        (translate_auto_knows_old_from_knows_old (key sym X) H2))
  | (intruder_can_encrypt_old _big_k _big_m H1 H2) => 
      (lem_intruder_can_encrypt_old _big_k _big_m
        (translate_auto_knows_old_from_knows_old _big_m H1)
        (translate_auto_knows_old_from_knows_old _big_k H2))
  | (intruder_can_take_first_components_old _big_m1 _big_m2 H1) => 
      (lem_intruder_can_take_first_components_old _big_m1 _big_m2
        (translate_auto_knows_old_from_knows_old (cons _big_m1 _big_m2) H1))
  | (intruder_can_take_second_components_old _big_m1 _big_m2 H1) => 
      (lem_intruder_can_take_second_components_old _big_m1 _big_m2
        (translate_auto_knows_old_from_knows_old (cons _big_m1 _big_m2) H1))
  | (intruder_knows_all_agents_old X H1) => 
      (lem_intruder_knows_all_agents_old X
        (translate_auto_agent_from_agent X H1))
  | (intruder_knows_every_public_key_old X) => 
      (lem_intruder_knows_every_public_key_old X)
  | (intruder_knows_nil_old) => 
      (lem_intruder_knows_nil_old)
  | (intruder_knows_own_private_key_old) => 
      (lem_intruder_knows_own_private_key_old)
  | (message1_old _big_a H1) => 
      (lem_message1_old _big_a
        (translate_auto_agent_from_agent _big_a H1))
  | (message2_old _big_a _big_b H1 H2) => 
      (lem_message2_old _big_a _big_b
        (translate_auto_agent_from_agent _big_b H1)
        (translate_auto_knows_old_from_knows_old _big_a H2))
  | (message3_old _big_a _big_b _big_m H1 H2 H3) => 
      (lem_message3_old _big_a _big_b _big_m
        (translate_auto_agent_from_agent _big_b H1)
        (translate_auto_agent_from_agent _big_a H2)
        (translate_auto_knows_old_from_knows_old _big_m H3))
  | (message4_old _big_a _big_b _big_na _big_nb H1) => 
      (lem_message4_old _big_a _big_b _big_na _big_nb
        (translate_auto_knows_old_from_knows_old (cons _big_a (cons _big_b (cons _big_na (cons (crypt (cons _big_a (cons _big_nb nil)) (key sym (cons _big_b (cons server nil)))) nil)))) H1))
  | (message5_old _big_a _big_b _big_kab _big_m H1) => 
      (lem_message5_old _big_a _big_b _big_kab _big_m
        (translate_auto_knows_old_from_knows_old (crypt (cons (noncea_old _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) H1))
  | (message6_old _big_a _big_b _big_kab H1) => 
      (lem_message6_old _big_a _big_b _big_kab
        (translate_auto_knows_old_from_knows_old (crypt (cons _big_kab (cons (nonceb_old _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) H1))
  | (message7_old _big_a _big_kab _big_nb H1 H2) => 
      (lem_message7_old _big_a _big_kab _big_nb
        (translate_auto_alice_key_old_from_alice_key_old _big_a _big_kab H1)
        (translate_auto_knows_old_from_knows_old (crypt _big_nb _big_kab) H2))
  end
.
Definition translate_auto_bob_key_old_from_bob_key_old (x1 : term) (x2 : term) (pi : bob_key_old x1 x2) : auto_bob_key_old x1 x2 :=
  match pi as pi in bob_key_old x1 x2 return auto_bob_key_old x1 x2 with
    (define_bob_key_old _big_a _big_b _big_kab H1 H2) => 
      (lem_define_bob_key_old _big_a _big_b _big_kab
        (translate_auto_knows_old_from_knows_old (crypt (s (nonceb_old _big_a _big_b)) _big_kab) H1)
        (translate_auto_knows_old_from_knows_old (crypt (cons _big_kab (cons (nonceb_old _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) H2))
  end
.
Fixpoint translate_auto_alice_key_current_from_alice_key_current (x1 : term) (x2 : term) (pi : alice_key_current x1 x2) {struct pi} : auto_alice_key_current x1 x2 :=
  match pi as pi in alice_key_current x1 x2 return auto_alice_key_current x1 x2 with
    (define_alice_key_current _big_a _big_b _big_kab _big_m _big_nb H1 H2) => 
      (lem_define_alice_key_current _big_a _big_b _big_kab _big_m _big_nb
        (translate_auto_knows_current_from_knows_current (crypt _big_nb _big_kab) H1)
        (translate_auto_knows_current_from_knows_current (crypt (cons (noncea_current _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) H2))
  end

with translate_auto_knows_current_from_knows_current (x1 : term) (pi : knows_current x1) {struct pi} : auto_knows_current x1 :=
  match pi as pi in knows_current x1 return auto_knows_current x1 with
    (intruder_can_build_pairs_current _big_m1 _big_m2 H1 H2) => 
      (lem_intruder_can_build_pairs_current _big_m1 _big_m2
        (translate_auto_knows_current_from_knows_current _big_m1 H1)
        (translate_auto_knows_current_from_knows_current _big_m2 H2))
  | (intruder_can_compute_predecessors_current _big_m H1) => 
      (lem_intruder_can_compute_predecessors_current _big_m
        (translate_auto_knows_current_from_knows_current (s _big_m) H1))
  | (intruder_can_compute_successors_current _big_m H1) => 
      (lem_intruder_can_compute_successors_current _big_m
        (translate_auto_knows_current_from_knows_current _big_m H1))
  | (intruder_can_decrypt_if_has_private_key_current _big_k _big_m H1 H2) => 
      (lem_intruder_can_decrypt_if_has_private_key_current _big_k _big_m
        (translate_auto_knows_current_from_knows_current (crypt _big_m (key pub _big_k)) H1)
        (translate_auto_knows_current_from_knows_current (key prv _big_k) H2))
  | (intruder_can_decrypt_if_has_public_key_current _big_k _big_m H1 H2) => 
      (lem_intruder_can_decrypt_if_has_public_key_current _big_k _big_m
        (translate_auto_knows_current_from_knows_current (crypt _big_m (key prv _big_k)) H1)
        (translate_auto_knows_current_from_knows_current (key pub _big_k) H2))
  | (intruder_can_decrypt_if_has_symmetric_key_current _big_m X H1 H2) => 
      (lem_intruder_can_decrypt_if_has_symmetric_key_current _big_m X
        (translate_auto_knows_current_from_knows_current (crypt _big_m (key sym X)) H1)
        (translate_auto_knows_current_from_knows_current (key sym X) H2))
  | (intruder_can_encrypt_current _big_k _big_m H1 H2) => 
      (lem_intruder_can_encrypt_current _big_k _big_m
        (translate_auto_knows_current_from_knows_current _big_m H1)
        (translate_auto_knows_current_from_knows_current _big_k H2))
  | (intruder_can_take_first_components_current _big_m1 _big_m2 H1) => 
      (lem_intruder_can_take_first_components_current _big_m1 _big_m2
        (translate_auto_knows_current_from_knows_current (cons _big_m1 _big_m2) H1))
  | (intruder_can_take_second_components_current _big_m1 _big_m2 H1) => 
      (lem_intruder_can_take_second_components_current _big_m1 _big_m2
        (translate_auto_knows_current_from_knows_current (cons _big_m1 _big_m2) H1))
  | (intruder_knows_all_agents_current X H1) => 
      (lem_intruder_knows_all_agents_current X
        (translate_auto_agent_from_agent X H1))
  | (intruder_knows_all_previous_noncea _big_a _big_b) => 
      (lem_intruder_knows_all_previous_noncea _big_a _big_b)
  | (intruder_knows_all_previous_nonceb _big_a _big_b) => 
      (lem_intruder_knows_all_previous_nonceb _big_a _big_b)
  | (intruder_knows_all_previous_session_keys _big_a _big_b _big_na) => 
      (lem_intruder_knows_all_previous_session_keys _big_a _big_b _big_na)
  | (intruder_knows_every_public_key_current X) => 
      (lem_intruder_knows_every_public_key_current X)
  | (intruder_knows_nil_current) => 
      (lem_intruder_knows_nil_current)
  | (intruder_knows_own_private_key_current) => 
      (lem_intruder_knows_own_private_key_current)
  | (intruder_remembers _big_m H1) => 
      (lem_intruder_remembers _big_m
        (translate_auto_knows_old_from_knows_old _big_m H1))
  | (message1_current _big_a H1) => 
      (lem_message1_current _big_a
        (translate_auto_agent_from_agent _big_a H1))
  | (message2_current _big_a _big_b H1 H2) => 
      (lem_message2_current _big_a _big_b
        (translate_auto_agent_from_agent _big_b H1)
        (translate_auto_knows_current_from_knows_current _big_a H2))
  | (message3_current _big_a _big_b _big_m H1 H2 H3) => 
      (lem_message3_current _big_a _big_b _big_m
        (translate_auto_agent_from_agent _big_b H1)
        (translate_auto_agent_from_agent _big_a H2)
        (translate_auto_knows_current_from_knows_current _big_m H3))
  | (message4_current _big_a _big_b _big_na _big_nb H1) => 
      (lem_message4_current _big_a _big_b _big_na _big_nb
        (translate_auto_knows_current_from_knows_current (cons _big_a (cons _big_b (cons _big_na (cons (crypt (cons _big_a (cons _big_nb nil)) (key sym (cons _big_b (cons server nil)))) nil)))) H1))
  | (message5_current _big_a _big_b _big_kab _big_m H1) => 
      (lem_message5_current _big_a _big_b _big_kab _big_m
        (translate_auto_knows_current_from_knows_current (crypt (cons (noncea_current _big_a _big_b) (cons _big_b (cons _big_kab (cons _big_m nil)))) (key sym (cons _big_a (cons server nil)))) H1))
  | (message6_current _big_a _big_b _big_kab H1) => 
      (lem_message6_current _big_a _big_b _big_kab
        (translate_auto_knows_current_from_knows_current (crypt (cons _big_kab (cons (nonceb_current _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) H1))
  | (message7_current _big_a _big_kab _big_nb H1 H2) => 
      (lem_message7_current _big_a _big_kab _big_nb
        (translate_auto_alice_key_current_from_alice_key_current _big_a _big_kab H1)
        (translate_auto_knows_current_from_knows_current (crypt _big_nb _big_kab) H2))
  end
.
Definition translate_auto___query__intruder_knows_session_key_generated_by_server_from___query__intruder_knows_session_key_generated_by_server (pi : __query__intruder_knows_session_key_generated_by_server) : auto___query__intruder_knows_session_key_generated_by_server :=
  match pi  with
    (intruder_knows_session_key_generated_by_server _big_na H1) => 
      (lem_intruder_knows_session_key_generated_by_server _big_na
        (translate_auto_knows_current_from_knows_current (key sym (session_current alice bob _big_na)) H1))
  end
.
Definition translate_auto_bob_key_current_from_bob_key_current (x1 : term) (x2 : term) (pi : bob_key_current x1 x2) : auto_bob_key_current x1 x2 :=
  match pi as pi in bob_key_current x1 x2 return auto_bob_key_current x1 x2 with
    (define_bob_key_current _big_a _big_b _big_kab H1 H2) => 
      (lem_define_bob_key_current _big_a _big_b _big_kab
        (translate_auto_knows_current_from_knows_current (crypt (s (nonceb_current _big_a _big_b)) _big_kab) H1)
        (translate_auto_knows_current_from_knows_current (crypt (cons _big_kab (cons (nonceb_current _big_a _big_b) (cons _big_a nil))) (key sym (cons _big_b (cons server nil)))) H2))
  end
.
Definition translate_auto___query__intruder_knows_session_key_as_seen_by_alice_from___query__intruder_knows_session_key_as_seen_by_alice (pi : __query__intruder_knows_session_key_as_seen_by_alice) : auto___query__intruder_knows_session_key_as_seen_by_alice :=
  match pi  with
    (intruder_knows_session_key_as_seen_by_alice _big_kab H1 H2) => 
      (lem_intruder_knows_session_key_as_seen_by_alice _big_kab
        (translate_auto_alice_key_current_from_alice_key_current alice _big_kab H1)
        (translate_auto_knows_current_from_knows_current _big_kab H2))
  end
.
Definition translate_auto___query__intruder_knows_session_key_as_seen_by_B_from___query__intruder_knows_session_key_as_seen_by_B (pi : __query__intruder_knows_session_key_as_seen_by_B) : auto___query__intruder_knows_session_key_as_seen_by_B :=
  match pi  with
    (intruder_knows_session_key_as_seen_by_B _big_kab H1 H2) => 
      (lem_intruder_knows_session_key_as_seen_by_B _big_kab
        (translate_auto_bob_key_current_from_bob_key_current bob _big_kab H1)
        (translate_auto_knows_current_from_knows_current _big_kab H2))
  end
.


(* [conp] Consistency proofs. *)

Theorem thm_intruder_knows_session_key_as_seen_by_B : ~__query__intruder_knows_session_key_as_seen_by_B.
Proof.
  unfold not. intro H.
  elim (translate_auto___query__intruder_knows_session_key_as_seen_by_B_from___query__intruder_knows_session_key_as_seen_by_B H).
Qed.

Theorem thm_intruder_knows_session_key_as_seen_by_alice : ~__query__intruder_knows_session_key_as_seen_by_alice.
Proof.
  unfold not. intro H.
  elim (translate_auto___query__intruder_knows_session_key_as_seen_by_alice_from___query__intruder_knows_session_key_as_seen_by_alice H).
Qed.

Theorem thm_intruder_knows_session_key_generated_by_server : ~__query__intruder_knows_session_key_generated_by_server.
Proof.
  unfold not. intro H.
  elim (translate_auto___query__intruder_knows_session_key_generated_by_server_from___query__intruder_knows_session_key_generated_by_server H).
Qed.

